class
	P_MISC1

inherit
	VIM_DATA
		redefine
			default_create
		end
	S_LIBIO
	S_STDIO
	S_CTYPE
	S_SYS_STAT
	S_STDLIB
	S_STRING
	S_LIBINTL
	S_WCTYPE
	S_UNISTD
	S_TIME
	S_FCNTL
	S_MATH
	S_SYS_TIME
	S_LOCALE
	S_BITS_ERRNO
	S_ICONV
	S_UTIME
	S_GLIB_OBJECT
	S_GTK_GTK
	S_SYS_SELECT
	S_X11_XLIB
	S_SIGNAL
	S_DIRENT
	S_PWD
	S_GLIB
	S_PANGO_PANGO
	S_GDK_GDK
	S_LANGINFO
	S_X11_XUTIL
	S_X11_INTRINSIC
	S_SYS_IOCTL
	S_SYS_RESOURCE
	S_SYS_WAIT
	S_SYS_UTSNAME
	S_TERMIOS
	S_DLFCN
	S_X11_ICE_ICELIB
	S_X11_SM_SMLIB
	S_X11_SHELL
	S_X11_STRINGDEFS
	S_SYS_SYSINFO
	S_TERMCAP
	S_TERM
	S_GDK_PIXBUF_GDK_PIXBUF
	S_SYS_SOCKET
	S_NETINET_IN
	S_NETDB

feature {NONE} -- Initialization

	default_create
		do
			create w_readonly.make
			create homedir.make
			create name.make (<<100>>)
			create pos___0.make
			create pos_copy___0.make
			create pos_copy___1.make
		end

feature {ANY} -- attributes

	w_readonly: CE_POINTER [INTEGER_8]

	homedir: CE_POINTER [NATURAL_8]

	name: CE_ARRAY [NATURAL_8]

	ind_hash_comment: INTEGER_32 assign set_ind_hash_comment

	set_ind_hash_comment (a_ind_hash_comment: INTEGER_32)
		do
			ind_hash_comment := a_ind_hash_comment
		end

	pos___0: PD_POS_T

	pos_copy___0: PD_POS_T

	pos_copy___1: PD_POS_T

	breakcheck_count: INTEGER_32 assign set_breakcheck_count

	set_breakcheck_count (a_breakcheck_count: INTEGER_32)
		do
			breakcheck_count := a_breakcheck_count
		end

	stardepth: INTEGER_32 assign set_stardepth

	set_stardepth (a_stardepth: INTEGER_32)
		do
			stardepth := a_stardepth
		end

	recursive___2: INTEGER_32 assign set_recursive___2

	set_recursive___2 (a_recursive___2: INTEGER_32)
		do
			recursive___2 := a_recursive___2
		end

feature {ANY} -- routines

	get_indent: INTEGER_32
		do
			Result := (get_indent_str ((memline_inst.ml_get_curline), (globals_inst.curbuf.item.b_p_ts).to_integer_32))
		end

	get_indent_lnum (a_lnum: INTEGER_32): INTEGER_32
		do
			Result := (get_indent_str ((memline_inst.ml_get (a_lnum)), (globals_inst.curbuf.item.b_p_ts).to_integer_32))
		end

	get_indent_buf (a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_lnum: INTEGER_32): INTEGER_32
		do
			Result := (get_indent_str ((memline_inst.ml_get_buf (a_buf___6, a_lnum, 0)), (a_buf___6.item.b_p_ts).to_integer_32))
		end

	get_indent_str (a_ptr: CE_POINTER [NATURAL_8]; a_ts: INTEGER_32): INTEGER_32
		local
			l_ptr: CE_POINTER [NATURAL_8]
			l_count___2: INTEGER_32
			js: JUMP_STATE
		do
			create l_ptr.make

			l_ptr.ce_gets (a_ptr)
			l_count___2 := 0
			from
			until
				not (not js.loop_left and then ((l_ptr.item).to_boolean))
			loop
				js.reset
				if (l_ptr.item).to_integer_32 = 9 then
					l_count___2 := l_count___2 + (a_ts - l_count___2 \\ a_ts)
				elseif (l_ptr.item).to_integer_32 = 32 then
					l_count___2 := l_count___2 + 1
				else
					js.break
				end
				if not js.loop_jumped then
					l_ptr.ce_gets (l_ptr + 1)
				end
			end
			js.reset
			Result := l_count___2
		end

	set_indent (a_size: INTEGER_32; a_flags___0: INTEGER_32): INTEGER_32
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_newline: CE_POINTER [NATURAL_8]
			l_oldline: CE_POINTER [NATURAL_8]
			l_s: CE_POINTER [NATURAL_8]
			l_todo: INTEGER_32
			l_ind_len: INTEGER_32
			l_line_len: INTEGER_32
			l_doit: INTEGER_32
			l_ind_done: INTEGER_32
			l_tab_pad: INTEGER_32
			l_retval: INTEGER_32
			l_orig_char_len: INTEGER_32
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_tmp___4: CE_POINTER [NATURAL_8]
			l_tmp___5: CE_POINTER [NATURAL_8]
			l_tmp___6: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p___0.make
			create l_newline.make
			create l_oldline.make
			create l_s.make
			create l_tmp___0.make
			create l_tmp___1.make
			create l_tmp___2.make
			create l_tmp___3.make
			create l_tmp___4.make
			create l_tmp___5.make
			create l_tmp___6.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_doit := 0
					l_ind_done := 0
					l_retval := 0
					l_orig_char_len := -1
					l_todo := a_size
					l_ind_len := 0
					l_oldline.ce_gets (memline_inst.ml_get_curline)
					l_p___0.ce_gets (l_oldline)
					if (globals_inst.curbuf.item.b_p_et).to_boolean then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 3 then -- else:
						if ((a_flags___0).bit_and (2)).to_boolean then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if not ((globals_inst.curbuf.item.b_p_pi).to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						if not ((a_flags___0).bit_and (2)).to_boolean then
							if (globals_inst.curbuf.item.b_p_pi).to_boolean then
								l_ind_done := 0
								from
								until
									js.loop_left
								loop
									js.reset
									if l_todo > 0 then
										if (l_p___0.item).to_integer_32 /= 32 then
											if (l_p___0.item).to_integer_32 /= 9 then
												js.break
											end
										end
									else
										js.break
									end
									if not js.loop_jumped then
										if (l_p___0.item).to_integer_32 = 9 then
											l_tab_pad := (globals_inst.curbuf.item.b_p_ts).to_integer_32 - l_ind_done \\ (globals_inst.curbuf.item.b_p_ts).to_integer_32
											if l_todo < l_tab_pad then
												js.break
											end
											if not js.loop_jumped then
												l_todo := l_todo - l_tab_pad
												l_ind_len := l_ind_len + 1
												l_ind_done := l_ind_done + l_tab_pad
											end
										else
											l_todo := l_todo - 1
											l_ind_len := l_ind_len + 1
											l_ind_done := l_ind_done + 1
										end
									end
									if not js.loop_jumped then
										l_p___0.ce_gets (l_p___0 + 1)
									end
								end
								js.reset
								if (globals_inst.curbuf.item.b_p_et).to_boolean then
									l_orig_char_len := l_ind_len
								end
								l_tab_pad := (globals_inst.curbuf.item.b_p_ts).to_integer_32 - l_ind_done \\ (globals_inst.curbuf.item.b_p_ts).to_integer_32
								if l_todo >= l_tab_pad then
									if l_orig_char_len = -1 then
										l_doit := 1
										l_todo := l_todo - l_tab_pad
										l_ind_len := l_ind_len + 1
									end
								end
							end
						end
						from
						until
							not (l_todo >= (globals_inst.curbuf.item.b_p_ts).to_integer_32)
						loop
							if (l_p___0.item).to_integer_32 /= 9 then
								l_doit := 1
							else
								l_p___0.ce_gets (l_p___0 + 1)
							end
							l_todo := l_todo - (globals_inst.curbuf.item.b_p_ts).to_integer_32
							l_ind_len := l_ind_len + 1
						end
				when 6 then -- if done | if done
						from
						until
							not (l_todo > 0)
						loop
							if (l_p___0.item).to_integer_32 /= 32 then
								l_doit := 1
							else
								l_p___0.ce_gets (l_p___0 + 1)
							end
							l_todo := l_todo - 1
							l_ind_len := l_ind_len + 1
						end
						if not l_doit.to_boolean then
							if (l_p___0.item).to_integer_32 /= 32 then
								if (l_p___0.item).to_integer_32 /= 9 then
									if not ((a_flags___0).bit_and (2)).to_boolean then
										Result := 0
										js.return
									end
								end
							end
						end
						if not js.return_called then
							if ((a_flags___0).bit_and (2)).to_boolean then
								l_p___0.ce_gets (l_oldline)
							else
								l_p___0.ce_gets (charset_inst.skipwhite (l_p___0))
							end
							l_line_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0))).to_integer_32 + 1
							if l_orig_char_len /= -1 then
								l_newline.ce_gets (misc2_inst.alloc ((((l_orig_char_len + a_size) - l_ind_done) + l_line_len).to_natural_32))
								if (l_newline.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
									Result := 0
									js.return
								end
								if not js.return_called then
									l_todo := a_size - l_ind_done
									l_ind_len := l_orig_char_len + l_todo
									l_p___0.ce_gets (l_oldline)
									l_s.ce_gets (l_newline)
									from
									until
										not (l_orig_char_len > 0)
									loop
										l_tmp___0.ce_gets (l_s)
										l_s.ce_gets (l_s + 1)
										l_tmp___1.ce_gets (l_p___0)
										l_p___0.ce_gets (l_p___0 + 1)
										l_tmp___0.item := l_tmp___1.item
										l_orig_char_len := l_orig_char_len - 1
									end
									from
									until
										js.loop_left
									loop
										js.reset
										if (l_p___0.item).to_integer_32 /= 32 then
											if (l_p___0.item).to_integer_32 /= 9 then
												js.break
											end
										end
										if not js.loop_jumped then
											l_p___0.ce_gets (l_p___0 + 1)
										end
									end
									js.reset
								end
							else
								l_todo := a_size
								l_newline.ce_gets (misc2_inst.alloc ((l_ind_len + l_line_len).to_natural_32))
								if (l_newline.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
									Result := 0
									js.return
								end
								if not js.return_called then
									l_s.ce_gets (l_newline)
								end
							end
						end
						if js.return_called then
							l_pos := -1 + 15 -- skip if block
						end
				when 7 then -- if:
							if not (globals_inst.curbuf.item.b_p_et).to_boolean then
								if not ((a_flags___0).bit_and (2)).to_boolean then
									if (globals_inst.curbuf.item.b_p_pi).to_boolean then
										l_p___0.ce_gets (l_oldline)
										l_ind_done := 0
										from
										until
											js.loop_left
										loop
											js.reset
											if l_todo > 0 then
												if (l_p___0.item).to_integer_32 /= 32 then
													if (l_p___0.item).to_integer_32 /= 9 then
														js.break
													end
												end
											else
												js.break
											end
											if not js.loop_jumped then
												if (l_p___0.item).to_integer_32 = 9 then
													l_tab_pad := (globals_inst.curbuf.item.b_p_ts).to_integer_32 - l_ind_done \\ (globals_inst.curbuf.item.b_p_ts).to_integer_32
													if l_todo < l_tab_pad then
														js.break
													end
													if not js.loop_jumped then
														l_todo := l_todo - l_tab_pad
														l_ind_done := l_ind_done + l_tab_pad
													end
												else
													l_todo := l_todo - 1
													l_ind_done := l_ind_done + 1
												end
											end
											if not js.loop_jumped then
												l_tmp___2.ce_gets (l_s)
												l_s.ce_gets (l_s + 1)
												l_tmp___3.ce_gets (l_p___0)
												l_p___0.ce_gets (l_p___0 + 1)
												l_tmp___2.item := l_tmp___3.item
											end
										end
										js.reset
										l_tab_pad := (globals_inst.curbuf.item.b_p_ts).to_integer_32 - l_ind_done \\ (globals_inst.curbuf.item.b_p_ts).to_integer_32
										if l_todo >= l_tab_pad then
											l_tmp___4.ce_gets (l_s)
											l_s.ce_gets (l_s + 1)
											l_tmp___4.item := (('%T').code).to_natural_8
											l_todo := l_todo - l_tab_pad
										end
										l_p___0.ce_gets (charset_inst.skipwhite (l_p___0))
									end
								end
								from
								until
									not (l_todo >= (globals_inst.curbuf.item.b_p_ts).to_integer_32)
								loop
									l_tmp___5.ce_gets (l_s)
									l_s.ce_gets (l_s + 1)
									l_tmp___5.item := (('%T').code).to_natural_8
									l_todo := l_todo - (globals_inst.curbuf.item.b_p_ts).to_integer_32
								end
							end
							from
							until
								not (l_todo > 0)
							loop
								l_tmp___6.ce_gets (l_s)
								l_s.ce_gets (l_s + 1)
								l_tmp___6.item := ((' ').code).to_natural_8
								l_todo := l_todo - 1
							end
							memmove (create {CE_POINTER [ANY]}.make_cast (l_s), create {CE_POINTER [ANY]}.make_cast (l_p___0), l_line_len.to_natural_32).do_nothing
							if ((a_flags___0).bit_and (4)).to_boolean then
								l_pos := -1 + 10 -- skip if block
							end
				when 8 then -- if:
							l_pos := -1 + 11 -- goto _L___0
				when 9 then -- if block done, skip else block:
							l_pos := -1 + 14
				when 10 then -- else:
							if (undo_inst.u_savesub (globals_inst.curwin.item.w_cursor.lnum)) /= 1 then
								l_pos := -1 + 13 -- skip if block
							end
				when 11 then -- if: | _L___0:
							memline_inst.ml_replace (globals_inst.curwin.item.w_cursor.lnum, l_newline, 0).do_nothing
							if ((a_flags___0).bit_and (1)).to_boolean then
								changed_bytes (globals_inst.curwin.item.w_cursor.lnum, 0)
							end
							if globals_inst.saved_cursor.lnum = globals_inst.curwin.item.w_cursor.lnum then
								if globals_inst.saved_cursor.col >= l_p___0.distance (l_oldline) then
									globals_inst.saved_cursor.col := globals_inst.saved_cursor.col + (l_ind_len - (l_p___0.distance (l_oldline)))
								end
							end
							l_retval := 1
				when 12 then -- if block done, skip else block:
							l_pos := -1 + 14
				when 13 then -- else:
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_newline))
				when 14 then -- if done
							globals_inst.curwin.item.w_cursor.col := l_ind_len
							Result := l_retval
				when 15 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	copy_indent (a_size: INTEGER_32; a_src: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_line: CE_POINTER [NATURAL_8]
			l_s: CE_POINTER [NATURAL_8]
			l_todo: INTEGER_32
			l_ind_len: INTEGER_32
			l_line_len: INTEGER_32
			l_tab_pad: INTEGER_32
			l_ind_done: INTEGER_32
			l_round: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___2: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_p___0.make
			create l_line.make
			create l_s.make
			create l_tmp.make
			create l_tmp___0.make
			create l_tmp___1.make
			create l_tmp___2.make

			l_p___0.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
			l_line.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
			l_line_len := 0
			l_round := 1
			from
			until
				not (not js.loop_left and then (l_round <= 2))
			loop
				l_todo := a_size
				l_ind_len := 0
				l_ind_done := 0
				l_s.ce_gets (a_src)
				from
				until
					js.loop_left
				loop
					js.reset
					if l_todo > 0 then
						if (l_s.item).to_integer_32 /= 32 then
							if (l_s.item).to_integer_32 /= 9 then
								js.break
							end
						end
					else
						js.break
					end
					if not js.loop_jumped then
						if (l_s.item).to_integer_32 = 9 then
							l_tab_pad := (globals_inst.curbuf.item.b_p_ts).to_integer_32 - l_ind_done \\ (globals_inst.curbuf.item.b_p_ts).to_integer_32
							if l_todo < l_tab_pad then
								js.break
							end
							if not js.loop_jumped then
								l_todo := l_todo - l_tab_pad
								l_ind_done := l_ind_done + l_tab_pad
							end
						else
							l_todo := l_todo - 1
							l_ind_done := l_ind_done + 1
						end
					end
					if not js.loop_jumped then
						l_ind_len := l_ind_len + 1
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_tmp.ce_gets (l_p___0)
							l_p___0.ce_gets (l_p___0 + 1)
							l_tmp.item := l_s.item
						end
						l_s.ce_gets (l_s + 1)
					end
				end
				js.reset
				l_tab_pad := (globals_inst.curbuf.item.b_p_ts).to_integer_32 - l_ind_done \\ (globals_inst.curbuf.item.b_p_ts).to_integer_32
				if l_todo >= l_tab_pad then
					l_todo := l_todo - l_tab_pad
					l_ind_len := l_ind_len + 1
					if (l_p___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						l_tmp___0.ce_gets (l_p___0)
						l_p___0.ce_gets (l_p___0 + 1)
						l_tmp___0.item := (('%T').code).to_natural_8
					end
				end
				from
				until
					not (l_todo >= (globals_inst.curbuf.item.b_p_ts).to_integer_32)
				loop
					l_todo := l_todo - (globals_inst.curbuf.item.b_p_ts).to_integer_32
					l_ind_len := l_ind_len + 1
					if (l_p___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						l_tmp___1.ce_gets (l_p___0)
						l_p___0.ce_gets (l_p___0 + 1)
						l_tmp___1.item := (('%T').code).to_natural_8
					end
				end
				from
				until
					not (l_todo > 0)
				loop
					l_todo := l_todo - 1
					l_ind_len := l_ind_len + 1
					if (l_p___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						l_tmp___2.ce_gets (l_p___0)
						l_p___0.ce_gets (l_p___0 + 1)
						l_tmp___2.item := ((' ').code).to_natural_8
					end
				end
				if (l_p___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					l_line_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((memline_inst.ml_get_curline)))).to_integer_32 + 1
					l_line.ce_gets (misc2_inst.alloc ((l_ind_len + l_line_len).to_natural_32))
					if (l_line.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_p___0.ce_gets (l_line)
					end
				end
				if not js.return_called then
					l_round := l_round + 1
				end
			end
			if not js.return_called then
				memmove (create {CE_POINTER [ANY]}.make_cast (l_p___0), create {CE_POINTER [ANY]}.make_cast ((memline_inst.ml_get_curline)), l_line_len.to_natural_32).do_nothing
				memline_inst.ml_replace (globals_inst.curwin.item.w_cursor.lnum, l_line, 0).do_nothing
				globals_inst.curwin.item.w_cursor.col := l_ind_len
				Result := 1
			end
		end

	get_number_indent (a_lnum: INTEGER_32): INTEGER_32
		local
			l_col: INTEGER_32
			l_pos___3: PD_POS_T
			l_regmatch___0: PD_REGMMATCH_T
			js: JUMP_STATE
		do
			create l_pos___3.make
			create l_regmatch___0.make

			if a_lnum > globals_inst.curbuf.item.b_ml.ml_line_count then
				Result := (-1)
				js.return
			end
			if not js.return_called then
				l_pos___3.lnum := (0).to_integer_32
				l_regmatch___0.regprog := regexp_inst.vim_regcomp (globals_inst.curbuf.item.b_p_flp, 1)
				if ((l_regmatch___0.regprog).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					l_regmatch___0.rmm_ic := 0
					l_regmatch___0.rmm_maxcol := 0
					if (regexp_inst.vim_regexec_multi (l_regmatch___0.address, globals_inst.curwin, globals_inst.curbuf, a_lnum, 0, create {CE_POINTER [SD_TIMEVAL]}.make_shared (default_pointer))).to_boolean then
						l_pos___3.lnum := l_regmatch___0.endpos[0].lnum + a_lnum
						l_pos___3.col := l_regmatch___0.endpos[0].col
						l_pos___3.coladd := 0
					end
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_regmatch___0.regprog))
				end
				if l_pos___3.lnum = 0 then
					Result := (-1)
					js.return
				elseif ((memline_inst.ml_get_pos (l_pos___3.address)).item).to_integer_32 = 0 then
					Result := (-1)
					js.return
				end
			end
			if not js.return_called then
				charset_inst.getvcol (globals_inst.curwin, l_pos___3.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_col), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
				Result := l_col
			end
		end

	cin_is_cinword (a_line: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_line: CE_POINTER [NATURAL_8]
			l_cinw: CE_POINTER [NATURAL_8]
			l_cinw_buf: CE_POINTER [NATURAL_8]
			l_cinw_len: INTEGER_32
			l_retval: INTEGER_32
			l_len: INTEGER_32
			js: JUMP_STATE
		do
			create l_line.make
			create l_cinw.make
			create l_cinw_buf.make

			l_line.ce_gets (a_line)
			l_retval := 0
			l_cinw_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.curbuf.item.b_p_cinw))).to_integer_32 + 1
			l_cinw_buf.ce_gets (misc2_inst.alloc (l_cinw_len.to_natural_32))
			if (l_cinw_buf.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				l_line.ce_gets (charset_inst.skipwhite (l_line))
				l_cinw.ce_gets (globals_inst.curbuf.item.b_p_cinw)
				from
				until
					not (not js.loop_left and then ((l_cinw.item).to_boolean))
				loop
					js.reset
					l_len := misc2_inst.copy_option_part (l_cinw.address, l_cinw_buf, l_cinw_len, ce_string (","))
					if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_line), create {CE_POINTER [INTEGER_8]}.make_cast (l_cinw_buf), l_len.to_natural_32)) = 0 then
						if (charset_inst.vim_iswordc ((l_line[l_len]).to_integer_32)).to_boolean then
							if not (charset_inst.vim_iswordc ((l_line[(l_len - 1)]).to_integer_32)).to_boolean then
								l_retval := 1
								js.break
							end
						else
							l_retval := 1
							js.break
						end
					end
				end
				js.reset
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_cinw_buf))
			end
			Result := l_retval
		end

	open_line (a_dir___0: INTEGER_32; a_flags___0: INTEGER_32; a_old_indent___0: INTEGER_32): INTEGER_32
		local
			l_saved_line: CE_POINTER [NATURAL_8]
			l_next_line: CE_POINTER [NATURAL_8]
			l_p_extra: CE_POINTER [NATURAL_8]
			l_less_cols: INTEGER_32
			l_less_cols_off: INTEGER_32
			l_old_cursor: PD_POS_T
			l_newcol: INTEGER_32
			l_newindent: INTEGER_32
			l_n: INTEGER_32
			l_trunc_line: INTEGER_32
			l_retval: INTEGER_32
			l_extra_len: INTEGER_32
			l_lead_len: INTEGER_32
			l_lead_flags: CE_POINTER [NATURAL_8]
			l_leader: CE_POINTER [NATURAL_8]
			l_allocated: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_saved_char: INTEGER_32
			l_pos___3: CE_POINTER [PD_POS_T]
			l_do_si: INTEGER_32
			l_tmp: INTEGER_32
			l_no_si: INTEGER_32
			l_first_char: INTEGER_32
			l_vreplace_mode: INTEGER_32
			l_did_append: INTEGER_32
			l_saved_pi: INTEGER_32
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_ptr: CE_POINTER [NATURAL_8]
			l_last_char: NATURAL_8
			l_was_backslashed: INTEGER_32
			l_lead_repl: CE_POINTER [NATURAL_8]
			l_lead_repl_len: INTEGER_32
			l_lead_middle: CE_ARRAY [NATURAL_8]
			l_lead_end: CE_ARRAY [NATURAL_8]
			l_comment_end: CE_POINTER [NATURAL_8]
			l_extra_space: INTEGER_32
			l_current_flag: INTEGER_32
			l_require_blank: INTEGER_32
			l_p2: CE_POINTER [NATURAL_8]
			l_c: INTEGER_32
			l_off___0: INTEGER_32
			l_tmp___10: CE_POINTER [NATURAL_8]
			l_tmp___11: INTEGER_32
			l_repl_size: INTEGER_32
			l_old_size: INTEGER_32
			l_endp: CE_POINTER [NATURAL_8]
			l_l: INTEGER_32
			l_tmp___14: INTEGER_32
			l_l___0: INTEGER_32
			l_repl_size___0: INTEGER_32
			l_i___0: INTEGER_32
			l_l___1: INTEGER_32
			l_l___2: INTEGER_32
			l_tmp___21: CE_POINTER [NATURAL_8]
			l_tmp___25: INTEGER_32
			l_tmp___29: INTEGER_32
			l_tmp___32: INTEGER_32
			l_tmp___33: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_saved_line.make
			create l_next_line.make
			create l_p_extra.make
			create l_old_cursor.make
			create l_lead_flags.make
			create l_leader.make
			create l_allocated.make
			create l_p___0.make
			create l_pos___3.make
			create l_tmp___3.make
			create l_ptr.make
			create l_lead_repl.make
			create l_lead_middle.make (<<50>>)
			create l_lead_end.make (<<50>>)
			create l_comment_end.make
			create l_p2.make
			create l_tmp___10.make
			create l_endp.make
			create l_tmp___21.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_next_line.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_p_extra.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_less_cols := 0
					l_less_cols_off := 0
					l_newcol := 0
					l_newindent := 0
					l_trunc_line := 0
					l_retval := 0
					l_extra_len := 0
					l_leader.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_allocated.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_saved_char := ('%/0/').code
					if not option_inst.p_paste.to_boolean then
						if (globals_inst.curbuf.item.b_p_si).to_boolean then
							if not (globals_inst.curbuf.item.b_p_cin).to_boolean then
								l_tmp := 1
							else
								l_tmp := 0
							end
						else
							l_tmp := 0
						end
					else
						l_tmp := 0
					end
					l_do_si := l_tmp
					l_no_si := 0
					l_first_char := ('%/0/').code
					l_saved_pi := globals_inst.curbuf.item.b_p_pi
					l_saved_line.ce_gets (misc2_inst.vim_strsave ((memline_inst.ml_get_curline)))
					if (l_saved_line.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						Result := 0
						js.return
					end
					if js.return_called then
						l_pos := -1 + 158 -- skip if block
					end
				when 1 then -- if:
						if not (((globals_inst.State).bit_and (128)).to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if globals_inst.curwin.item.w_cursor.lnum < globals_inst.orig_line_count.to_integer_32 then
							l_next_line.ce_gets (misc2_inst.vim_strsave ((memline_inst.ml_get (globals_inst.curwin.item.w_cursor.lnum + 1))))
						else
							l_next_line.ce_gets (misc2_inst.vim_strsave (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))))
						end
						if (l_next_line.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 157 -- goto theend
						end
				when 3 then
						edit_inst.replace_push (('%/0/').code)
						edit_inst.replace_push (('%/0/').code)
						l_p___0.ce_gets (l_saved_line + globals_inst.curwin.item.w_cursor.col)
						from
						until
							(l_p___0.item).to_integer_32 = 0
						loop
							if globals_inst.has_mbyte.to_boolean then
								l_p___0.ce_gets (l_p___0 + (edit_inst.replace_push_mb (l_p___0)))
							else
								l_tmp___3.ce_gets (l_p___0)
								l_p___0.ce_gets (l_p___0 + 1)
								edit_inst.replace_push ((l_tmp___3.item).to_integer_32)
							end
						end
						l_saved_line[globals_inst.curwin.item.w_cursor.col] := (('%/0/').code).to_natural_8
				when 4 then -- if done
						if ((globals_inst.State).bit_and (16)).to_boolean then
							if not ((globals_inst.State).bit_and (128)).to_boolean then
								l_p_extra.ce_gets (l_saved_line + globals_inst.curwin.item.w_cursor.col)
								if l_do_si.to_boolean then
									l_p___0.ce_gets (charset_inst.skipwhite (l_p_extra))
									l_first_char := (l_p___0.item).to_integer_32
								end
								l_extra_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_p_extra))).to_integer_32
								l_saved_char := (l_p_extra.item).to_integer_32
								l_p_extra.item := (('%/0/').code).to_natural_8
							end
						end
						undo_inst.u_clearline
						globals_inst.did_si := 0
						globals_inst.ai_col := 0
						if a_dir___0 = 1 then
							if globals_inst.did_ai.to_boolean then
								l_trunc_line := 1
							end
						end
						if not ((globals_inst.curbuf.item.b_p_ai).to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L___2
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 42
				when 7 then -- else:
						if not (l_do_si.to_boolean) then
							l_pos := -1 + 42 -- skip if block
						end
				when 8 then -- if: | _L___2:
						l_newindent := get_indent_str (l_saved_line, (globals_inst.curbuf.item.b_p_ts).to_integer_32)
						if l_newindent = 0 then
							l_newindent := a_old_indent___0
						end
						if l_trunc_line.to_boolean then
							l_pos := -1 + 41 -- skip if block
						end
				when 9 then -- if:
						if not (l_do_si.to_boolean) then
							l_pos := -1 + 41 -- skip if block
						end
				when 10 then -- if:
						if (l_saved_line.item).to_integer_32 = 0 then
							l_pos := -1 + 41 -- skip if block
						end
				when 11 then -- if:
						if (l_p_extra.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:
						l_pos := -1 + 15 -- goto _L___1
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 41
				when 14 then -- else:
						if l_first_char = 123 then
							l_pos := -1 + 41 -- skip if block
						end
				when 15 then -- if: | _L___1:
						l_old_cursor.ce_gets (globals_inst.curwin.item.w_cursor)
						l_ptr.ce_gets (l_saved_line)
						if ((a_flags___0).bit_and (2)).to_boolean then
							l_lead_len := get_leader_len (l_ptr, create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), 0)
						else
							l_lead_len := 0
						end
						if a_dir___0 /= 1 then
							l_pos := -1 + 26 -- skip if block
						end
				when 16 then -- if:
						if l_lead_len = 0 then
							if (l_ptr[0]).to_integer_32 = 35 then
								from
								until
									js.loop_left
								loop
									js.reset
									if (l_ptr[0]).to_integer_32 = 35 then
										if not (globals_inst.curwin.item.w_cursor.lnum > 1) then
											js.break
										end
									else
										js.break
									end
									if not js.loop_jumped then
										globals_inst.curwin.item.w_cursor.lnum := (globals_inst.curwin.item.w_cursor.lnum) - 1
										l_ptr.ce_gets (memline_inst.ml_get (globals_inst.curwin.item.w_cursor.lnum))
									end
								end
								js.reset
								l_newindent := get_indent
							end
						end
						if ((a_flags___0).bit_and (2)).to_boolean then
							l_lead_len := get_leader_len (l_ptr, create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), 0)
						else
							l_lead_len := 0
						end
						if not (l_lead_len > 0) then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						l_p___0.ce_gets (charset_inst.skipwhite (l_ptr))
						if (l_p___0[0]).to_integer_32 = 47 then
							if (l_p___0[1]).to_integer_32 = 42 then
								l_p___0.ce_gets (l_p___0 + 1)
							end
						end
						if (l_p___0[0]).to_integer_32 = 42 then
							l_p___0.ce_gets (l_p___0 + 1)
							from
							until
								not ((l_p___0.item).to_boolean)
							loop
								if (l_p___0[0]).to_integer_32 = 47 then
									if (l_p___0[-1]).to_integer_32 = 42 then
										globals_inst.curwin.item.w_cursor.col := l_p___0.distance (l_ptr)
										l_pos___3.ce_gets (search_inst.findmatch (create {CE_POINTER [PD_OPARG_S]}.make_shared (default_pointer), ('%/0/').code))
										if (l_pos___3.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
											globals_inst.curwin.item.w_cursor.lnum := l_pos___3.item.lnum
											l_newindent := get_indent
										end
									end
								end
								l_p___0.ce_gets (l_p___0 + 1)
							end
						end
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 19 then -- else:
						l_p___0.ce_gets ((l_ptr + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_ptr))).to_integer_32) - 1)
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_p___0.c_pointer.to_integer_32).to_natural_32 > (l_ptr.c_pointer.to_integer_32).to_natural_32 then
								if (l_p___0.item).to_integer_32 /= 32 then
									if (l_p___0.item).to_integer_32 /= 9 then
										js.break
									end
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_p___0.ce_gets (l_p___0 - 1)
							end
						end
						js.reset
						l_last_char := l_p___0.item
						if l_last_char.to_integer_32 /= 123 then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						l_pos := -1 + 23 -- goto _L
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 22 then -- else:
						if l_last_char.to_integer_32 /= 59 then
							l_pos := -1 + 24 -- skip if block
						end
				when 23 then -- if: | _L:
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 > (l_ptr.c_pointer.to_integer_32).to_natural_32 then
							l_p___0.ce_gets (l_p___0 - 1)
						end
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_p___0.c_pointer.to_integer_32).to_natural_32 > (l_ptr.c_pointer.to_integer_32).to_natural_32 then
								if (l_p___0.item).to_integer_32 /= 32 then
									if (l_p___0.item).to_integer_32 /= 9 then
										js.break
									end
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_p___0.ce_gets (l_p___0 - 1)
							end
						end
						js.reset
				when 24 then -- if done
						if (l_p___0.item).to_integer_32 = 41 then
							globals_inst.curwin.item.w_cursor.col := l_p___0.distance (l_ptr)
							l_pos___3.ce_gets (search_inst.findmatch (create {CE_POINTER [PD_OPARG_S]}.make_shared (default_pointer), ('(').code))
							if (l_pos___3.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								globals_inst.curwin.item.w_cursor.lnum := l_pos___3.item.lnum
								l_newindent := get_indent
								l_ptr.ce_gets (memline_inst.ml_get_curline)
							end
						end
						if l_last_char.to_integer_32 = 123 then
							globals_inst.did_si := 1
							l_no_si := 1
						elseif l_last_char.to_integer_32 /= 59 then
							if l_last_char.to_integer_32 /= 125 then
								if (cin_is_cinword (l_ptr)).to_boolean then
									globals_inst.did_si := 1
								end
							end
						end
				when 25 then -- if done | if block done, skip else block:
						l_pos := -1 + 40
				when 26 then -- else:
						if l_lead_len /= 0 then
							l_pos := -1 + 39 -- skip if block
						end
				when 27 then -- if:
						if (l_ptr[0]).to_integer_32 /= 35 then
							l_pos := -1 + 39 -- skip if block
						end
				when 28 then -- if:
						l_was_backslashed := 0
				when 29 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 38 -- skip loop
						end
				when 30 then -- loop body:
						js.reset
						if (l_ptr[0]).to_integer_32 /= 35 then
							l_pos := -1 + 33 -- skip if block
						end
				when 31 then -- if:
						l_pos := -1 + 34 -- goto _L___0
				when 32 then -- if block done, skip else block:
						l_pos := -1 + 37
				when 33 then -- else:
						if not (l_was_backslashed.to_boolean) then
							l_pos := -1 + 36 -- skip if block
						end
				when 34 then -- if: | _L___0:
						if not (globals_inst.curwin.item.w_cursor.lnum < globals_inst.curbuf.item.b_ml.ml_line_count) then
							js.break
						end
				when 35 then -- if block done, skip else block:
						l_pos := -1 + 37
				when 36 then -- else:
						js.break
				when 37 then -- if done
						if not js.loop_jumped then
							if (l_ptr.item).to_boolean then
								if (l_ptr[((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_ptr))) - {NATURAL_32} 1).to_integer_32]).to_integer_32 = 92 then
									l_was_backslashed := 1
								else
									l_was_backslashed := 0
								end
							else
								l_was_backslashed := 0
							end
							globals_inst.curwin.item.w_cursor.lnum := (globals_inst.curwin.item.w_cursor.lnum) + 1
							l_ptr.ce_gets (memline_inst.ml_get (globals_inst.curwin.item.w_cursor.lnum))
						end
						l_pos := -1 + 29 -- back to loop condition
				when 38 then -- loop done
						js.reset
						if l_was_backslashed.to_boolean then
							l_newindent := 0
						else
							l_newindent := get_indent
						end
				when 39 then -- if done | if done
						l_p___0.ce_gets (charset_inst.skipwhite (l_ptr))
						if (l_p___0.item).to_integer_32 = 125 then
							globals_inst.did_si := 1
						else
							globals_inst.can_si_back := 1
						end
				when 40 then -- if done
						globals_inst.curwin.item.w_cursor := l_old_cursor
				when 41 then -- if done | if done | if done | if done
						if l_do_si.to_boolean then
							globals_inst.can_si := 1
						end
						globals_inst.did_ai := 1
				when 42 then -- if done
						globals_inst.end_comment_pending := ('%/0/').code
						if ((a_flags___0).bit_and (2)).to_boolean then
							l_lead_len := get_leader_len (l_saved_line, l_lead_flags.address, (a_dir___0 = -1).to_integer)
						else
							l_lead_len := 0
						end
						if not (l_lead_len > 0) then
							l_pos := -1 + 111 -- skip if block
						end
				when 43 then -- if:
						l_lead_repl.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						l_lead_repl_len := 0
						l_comment_end.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						l_extra_space := 0
						l_require_blank := 0
						l_p___0.ce_gets (l_lead_flags)
				when 44 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 63 -- skip loop
						end
				when 45 then -- loop body:
						js.reset
						if (l_p___0.item).to_boolean then
							if (l_p___0.item).to_integer_32 = 58 then
								js.break
							end
						else
							js.break
						end
						if not js.loop_jumped and then ((l_p___0.item).to_integer_32 = 98) then
							l_require_blank := 1
							js.continue
						end
						if js.loop_jumped then
							l_pos := -1 + 62 -- skip if block
						end
				when 46 then -- if:
						if (l_p___0.item).to_integer_32 /= 115 then
							l_pos := -1 + 49 -- skip if block
						end
				when 47 then -- if:
						l_pos := -1 + 50 -- goto _L___5
				when 48 then -- if block done, skip else block:
						l_pos := -1 + 62
				when 49 then -- else:
						if (l_p___0.item).to_integer_32 /= 109 then
							l_pos := -1 + 62 -- skip if block
						end
				when 50 then -- if: | _L___5:
						l_current_flag := (l_p___0.item).to_integer_32
						if (l_p___0.item).to_integer_32 = 115 then
							if a_dir___0 = -1 then
								l_lead_len := 0
								js.break
							end
							if not js.loop_jumped then
								misc2_inst.copy_option_part (l_p___0.address, l_lead_middle, 50, ce_string (",")).do_nothing
								l_require_blank := 0
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 62 -- skip if block
						end
				when 51 then -- if:
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_p___0.item).to_boolean then
								if (l_p___0[-1]).to_integer_32 = 58 then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								if (l_p___0.item).to_integer_32 = 98 then
									l_require_blank := 1
								end
								l_p___0.ce_gets (l_p___0 + 1)
							end
						end
						js.reset
						misc2_inst.copy_option_part (l_p___0.address, l_lead_middle, 50, ce_string (",")).do_nothing
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_p___0.item).to_boolean then
								if (l_p___0[-1]).to_integer_32 = 58 then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								if (l_p___0.item).to_integer_32 = 120 then
									globals_inst.end_comment_pending := -1
								end
								l_p___0.ce_gets (l_p___0 + 1)
							end
						end
						js.reset
						l_n := misc2_inst.copy_option_part (l_p___0.address, l_lead_end, 50, ce_string (","))
						if globals_inst.end_comment_pending = -1 then
							globals_inst.end_comment_pending := (l_lead_end[l_n - 1]).to_integer_32
						end
						if a_dir___0 = 1 then
							l_p___0.ce_gets (l_saved_line + l_lead_len)
							from
							until
								not (not js.loop_left and then ((l_p___0.item).to_boolean))
							loop
								js.reset
								if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), create {CE_POINTER [INTEGER_8]}.make_cast (l_lead_end), l_n.to_natural_32)) = 0 then
									l_comment_end.ce_gets (l_p___0)
									l_lead_len := 0
									js.break
								end
								if not js.loop_jumped then
									l_p___0.ce_gets (l_p___0 + 1)
								end
							end
							js.reset
						end
						if not (l_lead_len > 0) then
							l_pos := -1 + 61 -- skip if block
						end
				when 52 then -- if:
						if l_current_flag = 115 then
							l_lead_repl.ce_gets (l_lead_middle)
							l_lead_repl_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_lead_middle))).to_integer_32
						end
						if ((l_saved_line[(l_lead_len - 1)]).to_integer_32 = 32) then
							l_pos := -1 + 61 -- skip if block
						end
				when 53 then -- if:
						if ((l_saved_line[(l_lead_len - 1)]).to_integer_32 = 9) then
							l_pos := -1 + 61 -- skip if block
						end
				when 54 then -- if:
						if (l_p_extra.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 57 -- skip if block
						end
				when 55 then -- if:
						if globals_inst.curwin.item.w_cursor.col = l_lead_len then
							l_extra_space := 1
						else
							l_pos := -1 + 57 -- goto _L___4
						end
				when 56 then -- if block done, skip else block:
						l_pos := -1 + 61
				when 57 then -- else: | _L___4:
						if (l_p_extra.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_pos := -1 + 60 -- skip if block
						end
				when 58 then -- if:
						if (l_saved_line[l_lead_len]).to_integer_32 = 0 then
							l_extra_space := 1
						else
							l_pos := -1 + 60 -- goto _L___3
						end
				when 59 then -- if block done, skip else block:
						l_pos := -1 + 61
				when 60 then -- else: | _L___3:
						if l_require_blank.to_boolean then
							l_extra_space := 1
						end
				when 61 then -- if done | if done | if done | if done
						js.break
				when 62 then -- if done | if done | if done
						if not js.loop_jumped and then ((l_p___0.item).to_integer_32 = 101) then
							if a_dir___0 = 1 then
								l_comment_end.ce_gets (charset_inst.skipwhite (l_saved_line))
								l_lead_len := 0
								js.break
							end
							if not js.loop_jumped then
								from
								until
									js.loop_left
								loop
									js.reset
									if (l_p___0.c_pointer.to_integer_32).to_natural_32 > ((globals_inst.curbuf.item.b_p_com).c_pointer.to_integer_32).to_natural_32 then
										if (l_p___0.item).to_integer_32 = 44 then
											js.break
										end
									else
										js.break
									end
									if not js.loop_jumped then
										l_p___0.ce_gets (l_p___0 - 1)
									end
								end
								js.reset
								l_lead_repl.ce_gets (l_p___0)
								from
								until
									js.loop_left
								loop
									js.reset
									if (l_lead_repl.c_pointer.to_integer_32).to_natural_32 > ((globals_inst.curbuf.item.b_p_com).c_pointer.to_integer_32).to_natural_32 then
										if (l_lead_repl[-1]).to_integer_32 = 58 then
											js.break
										end
									else
										js.break
									end
									if not js.loop_jumped then
										l_lead_repl.ce_gets (l_lead_repl - 1)
									end
								end
								js.reset
								l_lead_repl_len := l_p___0.distance (l_lead_repl)
								l_extra_space := 1
								l_p2.ce_gets (l_p___0)
								from
								until
									js.loop_left
								loop
									js.reset
									if (l_p2.item).to_boolean then
										if (l_p2.item).to_integer_32 = 58 then
											js.break
										end
									else
										js.break
									end
									if not js.loop_jumped then
										if (l_p2.item).to_integer_32 = 120 then
											globals_inst.end_comment_pending := -1
										end
										l_p2.ce_gets (l_p2 + 1)
									end
								end
								js.reset
								if globals_inst.end_comment_pending = -1 then
									from
									until
										js.loop_left
									loop
										js.reset
										if (l_p2.item).to_boolean then
											if (l_p2.item).to_integer_32 = 44 then
												js.break
											end
										else
											js.break
										end
										if not js.loop_jumped then
											l_p2.ce_gets (l_p2 + 1)
										end
									end
									js.reset
									globals_inst.end_comment_pending := (l_p2[-1]).to_integer_32
								end
								js.break
							end
						end
						if not js.loop_jumped and then ((l_p___0.item).to_integer_32 = 102) then
							if a_dir___0 = -1 then
								l_lead_len := 0
							else
								l_lead_repl.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")))
								l_lead_repl_len := 0
							end
							js.break
						end
						if not js.loop_left then
							l_p___0.ce_gets (l_p___0 + 1)
						end
						l_pos := -1 + 44 -- back to loop condition
				when 63 then -- loop done
						js.reset
						if not (l_lead_len.to_boolean) then
							l_pos := -1 + 103 -- skip if block
						end
				when 64 then -- if:
						l_leader.ce_gets (misc2_inst.alloc (((((l_lead_len + l_lead_repl_len) + l_extra_space) + l_extra_len) + 1).to_natural_32))
						l_allocated.ce_gets (l_leader)
						if (l_leader.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_pos := -1 + 67 -- skip if block
						end
				when 65 then -- if:
						l_lead_len := 0
				when 66 then -- if block done, skip else block:
						l_pos := -1 + 101
				when 67 then -- else:
						misc2_inst.vim_strncpy (l_leader, l_saved_line, l_lead_len.to_natural_32)
						if (l_lead_repl.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 96 -- skip if block
						end
				when 68 then -- if:
						l_c := 0
						l_off___0 := 0
						l_p___0.ce_gets (l_lead_flags)
				when 69 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 82 -- skip loop
						end
				when 70 then -- loop body:
						js.reset
						if (l_p___0.item).to_integer_32 /= 0 then
							if (l_p___0.item).to_integer_32 = 58 then
								js.break
							end
						else
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 81 -- skip if block
						end
				when 71 then -- if:
						if (l_p___0.item).to_integer_32 /= 114 then
							l_pos := -1 + 74 -- skip if block
						end
				when 72 then -- if:
						l_tmp___10.ce_gets (l_p___0)
						l_p___0.ce_gets (l_p___0 + 1)
						l_c := (l_tmp___10.item).to_integer_32
				when 73 then -- if block done, skip else block:
						l_pos := -1 + 81
				when 74 then -- else:
						if (l_p___0.item).to_integer_32 /= 108 then
							l_pos := -1 + 77 -- skip if block
						end
				when 75 then -- if:
						l_tmp___10.ce_gets (l_p___0)
						l_p___0.ce_gets (l_p___0 + 1)
						l_c := (l_tmp___10.item).to_integer_32
				when 76 then -- if block done, skip else block:
						l_pos := -1 + 81
				when 77 then -- else:
						if not ((l_p___0.item).to_integer_32 >= 48) then
							l_pos := -1 + 80 -- skip if block
						end
				when 78 then -- if:
						if (l_p___0.item).to_integer_32 <= 57 then
							l_tmp___11 := charset_inst.getdigits (l_p___0.address)
							l_off___0 := l_tmp___11.to_integer_32
						else
							l_pos := -1 + 80 -- goto _L___6
						end
				when 79 then -- if block done, skip else block:
						l_pos := -1 + 81
				when 80 then -- else: | _L___6:
						if (l_p___0.item).to_integer_32 = 45 then
							l_tmp___11 := charset_inst.getdigits (l_p___0.address)
							l_off___0 := l_tmp___11.to_integer_32
						else
							l_p___0.ce_gets (l_p___0 + 1)
						end
				when 81 then -- if done | if done | if done
						l_pos := -1 + 69 -- back to loop condition
				when 82 then -- loop done
						js.reset
						if l_c /= 114 then
							l_pos := -1 + 85 -- skip if block
						end
				when 83 then -- if:
						l_p___0.ce_gets ((l_leader + l_lead_len) - 1)
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_p___0.c_pointer.to_integer_32).to_natural_32 > (l_leader.c_pointer.to_integer_32).to_natural_32 then
								if (l_p___0.item).to_integer_32 /= 32 then
									if (l_p___0.item).to_integer_32 /= 9 then
										js.break
									end
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_p___0.ce_gets (l_p___0 - 1)
							end
						end
						js.reset
						l_p___0.ce_gets (l_p___0 + 1)
						l_repl_size := (charset_inst.vim_strnsize (l_lead_repl, l_lead_repl_len))
						l_old_size := 0
						l_endp.ce_gets (l_p___0)
						from
						until
							js.loop_left
						loop
							js.reset
							if l_old_size < l_repl_size then
								if not ((l_p___0.c_pointer.to_integer_32).to_natural_32 > (l_leader.c_pointer.to_integer_32).to_natural_32) then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								if globals_inst.has_mbyte.to_boolean then
									l_tmp___14 := (globals_inst.mb_head_off.integer_32_item ([l_leader, l_p___0 - 1])) + 1
								else
									l_tmp___14 := 1
								end
								l_p___0.ce_gets (l_p___0 - l_tmp___14)
								l_old_size := l_old_size + (charset_inst.ptr2cells (l_p___0))
							end
						end
						js.reset
						l_l := l_lead_repl_len - (l_endp.distance (l_p___0))
						if l_l /= 0 then
							memmove (create {CE_POINTER [ANY]}.make_cast ((l_endp + l_l)), create {CE_POINTER [ANY]}.make_cast (l_endp), ((l_leader + l_lead_len).distance (l_endp)).to_natural_32).do_nothing
						end
						l_lead_len := l_lead_len + l_l
						memmove (create {CE_POINTER [ANY]}.make_cast (l_p___0), create {CE_POINTER [ANY]}.make_cast (l_lead_repl), l_lead_repl_len.to_natural_32).do_nothing
						if ((l_p___0 + l_lead_repl_len).c_pointer.to_integer_32).to_natural_32 > ((l_leader + l_lead_len).c_pointer.to_integer_32).to_natural_32 then
							l_p___0[l_lead_repl_len] := (('%/0/').code).to_natural_8
						end
						from
						until
							js.loop_left
						loop
							js.reset
							l_p___0.ce_gets (l_p___0 - 1)
							if not ((l_p___0.c_pointer.to_integer_32).to_natural_32 >= (l_leader.c_pointer.to_integer_32).to_natural_32) then
								js.break
							end
							if not js.loop_jumped then
								l_l___0 := (globals_inst.mb_head_off.integer_32_item ([l_leader, l_p___0]))
								if l_l___0 > 1 then
									l_p___0.ce_gets (l_p___0 - l_l___0)
									if (charset_inst.ptr2cells (l_p___0)) > 1 then
										l_p___0[1] := ((' ').code).to_natural_8
										l_l___0 := l_l___0 - 1
									end
									memmove (create {CE_POINTER [ANY]}.make_cast ((l_p___0 + 1)), create {CE_POINTER [ANY]}.make_cast (((l_p___0 + l_l___0) + 1)), ((l_leader + l_lead_len).distance (((l_p___0 + l_l___0) + 1))).to_natural_32).do_nothing
									l_lead_len := l_lead_len - l_l___0
									l_p___0.item := ((' ').code).to_natural_8
								elseif (l_p___0.item).to_integer_32 /= 32 then
									if (l_p___0.item).to_integer_32 /= 9 then
										l_p___0.item := ((' ').code).to_natural_8
									end
								end
							end
						end
						js.reset
				when 84 then -- if block done, skip else block:
						l_pos := -1 + 95
				when 85 then -- else:
						l_p___0.ce_gets (charset_inst.skipwhite (l_leader))
						l_repl_size___0 := (charset_inst.vim_strnsize (l_lead_repl, l_lead_repl_len))
						l_i___0 := 0
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_p___0[l_i___0]).to_integer_32 /= 0 then
								if not (l_i___0 < l_lead_len) then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_l___1 := globals_inst.mb_ptr2len.integer_32_item ([l_p___0 + l_i___0])
								if (charset_inst.vim_strnsize (l_p___0, l_i___0 + l_l___1)) > l_repl_size___0 then
									js.break
								end
							end
							if not js.loop_jumped then
								l_i___0 := l_i___0 + l_l___1
							end
						end
						js.reset
						if l_i___0 /= l_lead_repl_len then
							memmove (create {CE_POINTER [ANY]}.make_cast ((l_p___0 + l_lead_repl_len)), create {CE_POINTER [ANY]}.make_cast ((l_p___0 + l_i___0)), ((l_lead_len - l_i___0) - (l_p___0.distance (l_leader))).to_natural_32).do_nothing
							l_lead_len := l_lead_len + (l_lead_repl_len - l_i___0)
						end
						memmove (create {CE_POINTER [ANY]}.make_cast (l_p___0), create {CE_POINTER [ANY]}.make_cast (l_lead_repl), l_lead_repl_len.to_natural_32).do_nothing
						l_p___0.ce_gets (l_p___0 + l_lead_repl_len)
				when 86 then -- loop condition:
						if not ((l_p___0.c_pointer.to_integer_32).to_natural_32 < ((l_leader + l_lead_len).c_pointer.to_integer_32).to_natural_32) then
							l_pos := -1 + 94 -- skip loop
						end
				when 87 then -- loop body:
						if ((l_p___0.item).to_integer_32 = 32) then
							l_pos := -1 + 93 -- skip if block
						end
				when 88 then -- if:
						if ((l_p___0.item).to_integer_32 = 9) then
							l_pos := -1 + 93 -- skip if block
						end
				when 89 then -- if:
						if not (((l_p___0 + 1).c_pointer.to_integer_32).to_natural_32 < ((l_leader + l_lead_len).c_pointer.to_integer_32).to_natural_32) then
							l_pos := -1 + 92 -- skip if block
						end
				when 90 then -- if:
						if (l_p___0[1]).to_integer_32 = 9 then
							l_lead_len := l_lead_len - 1
							memmove (create {CE_POINTER [ANY]}.make_cast (l_p___0), create {CE_POINTER [ANY]}.make_cast ((l_p___0 + 1)), ((l_leader + l_lead_len).distance (l_p___0)).to_natural_32).do_nothing
						else
							l_pos := -1 + 92 -- goto _L___7
						end
				when 91 then -- if block done, skip else block:
						l_pos := -1 + 93
				when 92 then -- else: | _L___7:
						l_l___2 := (globals_inst.mb_ptr2len.integer_32_item ([l_p___0]))
						if l_l___2 > 1 then
							if (charset_inst.ptr2cells (l_p___0)) > 1 then
								l_l___2 := l_l___2 - 1
								l_tmp___21.ce_gets (l_p___0)
								l_p___0.ce_gets (l_p___0 + 1)
								l_tmp___21.item := ((' ').code).to_natural_8
							end
							memmove (create {CE_POINTER [ANY]}.make_cast ((l_p___0 + 1)), create {CE_POINTER [ANY]}.make_cast ((l_p___0 + l_l___2)), ((l_leader + l_lead_len).distance (l_p___0)).to_natural_32).do_nothing
							l_lead_len := l_lead_len - (l_l___2 - 1)
						end
						l_p___0.item := ((' ').code).to_natural_8
				when 93 then -- if done | if done
						l_p___0.ce_gets (l_p___0 + 1)
						l_pos := -1 + 86 -- back to loop condition
				when 94 then -- loop done
						l_p___0.item := (('%/0/').code).to_natural_8
				when 95 then -- if done
						if (globals_inst.curbuf.item.b_p_ai).to_boolean then
							l_newindent := get_indent_str (l_leader, (globals_inst.curbuf.item.b_p_ts).to_integer_32)
						elseif l_do_si.to_boolean then
							l_newindent := get_indent_str (l_leader, (globals_inst.curbuf.item.b_p_ts).to_integer_32)
						end
						if l_newindent + l_off___0 < 0 then
							l_off___0 := -l_newindent
							l_newindent := 0
						else
							l_newindent := l_newindent + l_off___0
						end
						from
						until
							js.loop_left
						loop
							js.reset
							if l_off___0 > 0 then
								if l_lead_len > 0 then
									if (l_leader[(l_lead_len - 1)]).to_integer_32 /= 32 then
										js.break
									end
								else
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								if ((misc2_inst.vim_strchr ((charset_inst.skipwhite (l_leader)), ('%T').code)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									js.break
								end
							end
							if not js.loop_jumped then
								l_lead_len := l_lead_len - 1
								l_off___0 := l_off___0 - 1
							end
						end
						js.reset
						if l_lead_len > 0 then
							if (l_leader[(l_lead_len - 1)]).to_integer_32 = 32 then
								l_extra_space := 0
							elseif (l_leader[(l_lead_len - 1)]).to_integer_32 = 9 then
								l_extra_space := 0
							end
						end
						l_leader[l_lead_len] := (('%/0/').code).to_natural_8
				when 96 then -- if done
						if l_extra_space.to_boolean then
							l_tmp___25 := l_lead_len
							l_lead_len := l_lead_len + 1
							l_leader[l_tmp___25] := ((' ').code).to_natural_8
							l_leader[l_lead_len] := (('%/0/').code).to_natural_8
						end
						l_newcol := l_lead_len
						if not (l_newindent.to_boolean) then
							l_pos := -1 + 99 -- skip if block
						end
				when 97 then -- if:
						l_pos := -1 + 100 -- goto _L___8
				when 98 then -- if block done, skip else block:
						l_pos := -1 + 101
				when 99 then -- else:
						if not (globals_inst.did_si.to_boolean) then
							l_pos := -1 + 101 -- skip if block
						end
				when 100 then -- if: | _L___8:
						from
						until
							js.loop_left
						loop
							js.reset
							if l_lead_len.to_boolean then
								if (l_leader.item).to_integer_32 /= 32 then
									if (l_leader.item).to_integer_32 /= 9 then
										js.break
									end
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_lead_len := l_lead_len - 1
								l_newcol := l_newcol - 1
								l_leader.ce_gets (l_leader + 1)
							end
						end
						js.reset
				when 101 then -- if done | if done
						globals_inst.can_si := 0
						globals_inst.did_si := globals_inst.can_si
				when 102 then -- if block done, skip else block:
						l_pos := -1 + 111
				when 103 then -- else:
						if (l_comment_end.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 111 -- skip if block
						end
				when 104 then -- if:
						if (l_comment_end[0]).to_integer_32 /= 42 then
							l_pos := -1 + 111 -- skip if block
						end
				when 105 then -- if:
						if (l_comment_end[1]).to_integer_32 /= 47 then
							l_pos := -1 + 111 -- skip if block
						end
				when 106 then -- if:
						if not ((globals_inst.curbuf.item.b_p_ai).to_boolean) then
							l_pos := -1 + 109 -- skip if block
						end
				when 107 then -- if:
						l_pos := -1 + 110 -- goto _L___9
				when 108 then -- if block done, skip else block:
						l_pos := -1 + 111
				when 109 then -- else:
						if not (l_do_si.to_boolean) then
							l_pos := -1 + 111 -- skip if block
						end
				when 110 then -- if: | _L___9:
						l_old_cursor.ce_gets (globals_inst.curwin.item.w_cursor)
						globals_inst.curwin.item.w_cursor.col := l_comment_end.distance (l_saved_line)
						l_pos___3.ce_gets (search_inst.findmatch (create {CE_POINTER [PD_OPARG_S]}.make_shared (default_pointer), ('%/0/').code))
						if (l_pos___3.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							globals_inst.curwin.item.w_cursor.lnum := l_pos___3.item.lnum
							l_newindent := get_indent
						end
						globals_inst.curwin.item.w_cursor := l_old_cursor
				when 111 then -- if done | if done | if done | if done | if done | if done
						if (l_p_extra.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 127 -- skip if block
						end
				when 112 then -- if:
						l_p_extra.item := l_saved_char.to_natural_8
						if ((globals_inst.State).bit_and (64)).to_boolean then
							if not ((globals_inst.State).bit_and (128)).to_boolean then
								edit_inst.replace_push (('%/0/').code)
							end
						end
						if not ((globals_inst.curbuf.item.b_p_ai).to_boolean) then
							l_pos := -1 + 115 -- skip if block
						end
				when 113 then -- if:
						l_pos := -1 + 116 -- goto _L___11
				when 114 then -- if block done, skip else block:
						l_pos := -1 + 126
				when 115 then -- else:
						if not (((a_flags___0).bit_and (1)).to_boolean) then
							l_pos := -1 + 126 -- skip if block
						end
				when 116 then -- if: | _L___11:
						if js.loop_left then
							l_pos := -1 + 125 -- skip loop
						end
				when 117 then -- loop body:
						js.reset
						if (l_p_extra.item).to_integer_32 /= 32 then
							l_pos := -1 + 120 -- skip if block
						end
				when 118 then -- if:
						l_pos := -1 + 121 -- goto _L___10
				when 119 then -- if block done, skip else block:
						l_pos := -1 + 124
				when 120 then -- else:
						if (l_p_extra.item).to_integer_32 /= 9 then
							l_pos := -1 + 123 -- skip if block
						end
				when 121 then -- if: | _L___10:
						if globals_inst.enc_utf8.to_boolean then
							if (mbyte_inst.utf_iscomposing ((mbyte_inst.utf_ptr2char (l_p_extra + 1)))).to_boolean then
								js.break
							end
						end
				when 122 then -- if block done, skip else block:
						l_pos := -1 + 124
				when 123 then -- else:
						js.break
				when 124 then -- if done
						if not js.loop_jumped then
							if ((globals_inst.State).bit_and (64)).to_boolean then
								if not ((globals_inst.State).bit_and (128)).to_boolean then
									edit_inst.replace_push ((l_p_extra.item).to_integer_32)
								end
							end
							l_p_extra.ce_gets (l_p_extra + 1)
							l_less_cols_off := l_less_cols_off + 1
						end
						l_pos := -1 + 116 -- back to loop condition
				when 125 then -- loop done
						js.reset
				when 126 then -- if done
						if (l_p_extra.item).to_integer_32 /= 0 then
							globals_inst.did_ai := 0
						end
						l_less_cols := l_p_extra.distance (l_saved_line)
				when 127 then -- if done
						if (l_p_extra.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_p_extra.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")))
						end
						if l_lead_len.to_boolean then
							strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_leader), create {CE_POINTER [INTEGER_8]}.make_cast (l_p_extra)).do_nothing
							l_p_extra.ce_gets (l_leader)
							globals_inst.did_ai := 1
							l_less_cols := l_less_cols - l_lead_len
						else
							globals_inst.end_comment_pending := ('%/0/').code
						end
						l_old_cursor.ce_gets (globals_inst.curwin.item.w_cursor)
						if a_dir___0 = -1 then
							globals_inst.curwin.item.w_cursor.lnum := (globals_inst.curwin.item.w_cursor.lnum) - 1
						end
						if ((globals_inst.State).bit_and (128)).to_boolean then
							l_pos := -1 + 130 -- skip if block
						end
				when 128 then -- if:
						l_pos := -1 + 131 -- goto _L___12
				when 129 then -- if block done, skip else block:
						l_pos := -1 + 135
				when 130 then -- else:
						if not (l_old_cursor.lnum >= globals_inst.orig_line_count.to_integer_32) then
							l_pos := -1 + 134 -- skip if block
						end
				when 131 then -- if: | _L___12:
						if (memline_inst.ml_append (globals_inst.curwin.item.w_cursor.lnum, l_p_extra, 0, 0)) = 0 then
							l_pos := -1 + 157 -- goto theend
						end
				when 132 then
						mark_inst.mark_adjust (globals_inst.curwin.item.w_cursor.lnum + 1, 2147483647, 1, 0)
						l_did_append := 1
				when 133 then -- if block done, skip else block:
						l_pos := -1 + 135
				when 134 then -- else:
						globals_inst.curwin.item.w_cursor.lnum := (globals_inst.curwin.item.w_cursor.lnum) + 1
						if globals_inst.curwin.item.w_cursor.lnum >= globals_inst.Insstart.lnum + globals_inst.vr_lines_changed.to_integer_32 then
							undo_inst.u_save_cursor.do_nothing
							globals_inst.vr_lines_changed := globals_inst.vr_lines_changed + 1
						end
						memline_inst.ml_replace (globals_inst.curwin.item.w_cursor.lnum, l_p_extra, 1).do_nothing
						changed_bytes (globals_inst.curwin.item.w_cursor.lnum, 0)
						globals_inst.curwin.item.w_cursor.lnum := (globals_inst.curwin.item.w_cursor.lnum) - 1
						l_did_append := 0
				when 135 then -- if done
						if not (l_newindent.to_boolean) then
							l_pos := -1 + 138 -- skip if block
						end
				when 136 then -- if:
						l_pos := -1 + 139 -- goto _L___13
				when 137 then -- if block done, skip else block:
						l_pos := -1 + 140
				when 138 then -- else:
						if not (globals_inst.did_si.to_boolean) then
							l_pos := -1 + 140 -- skip if block
						end
				when 139 then -- if: | _L___13:
						globals_inst.curwin.item.w_cursor.lnum := (globals_inst.curwin.item.w_cursor.lnum) + 1
						if globals_inst.did_si.to_boolean then
							if option_inst.p_sr.to_boolean then
								l_newindent := l_newindent - (l_newindent \\ (globals_inst.curbuf.item.b_p_sw).to_integer_32)
							end
							l_newindent := l_newindent + (globals_inst.curbuf.item.b_p_sw).to_integer_32
						end
						if (globals_inst.curbuf.item.b_p_ci).to_boolean then
							copy_indent (l_newindent, l_saved_line).do_nothing
							globals_inst.curbuf.item.b_p_pi := 1
						else
							set_indent (l_newindent, 2).do_nothing
						end
						l_less_cols := l_less_cols - (globals_inst.curwin.item.w_cursor.col)
						globals_inst.ai_col := globals_inst.curwin.item.w_cursor.col
						if ((globals_inst.State).bit_and (64)).to_boolean then
							if not ((globals_inst.State).bit_and (128)).to_boolean then
								l_n := 0
								from
								until
									not (l_n < globals_inst.curwin.item.w_cursor.col)
								loop
									edit_inst.replace_push (('%/0/').code)
									l_n := l_n + 1
								end
							end
						end
						l_newcol := l_newcol + (globals_inst.curwin.item.w_cursor.col)
						if l_no_si.to_boolean then
							globals_inst.did_si := 0
						end
				when 140 then -- if done
						if ((globals_inst.State).bit_and (64)).to_boolean then
							if not ((globals_inst.State).bit_and (128)).to_boolean then
								from
								until
									js.loop_left
								loop
									js.reset
									l_tmp___29 := l_lead_len
									l_lead_len := l_lead_len - 1
									if not (l_tmp___29 > 0) then
										js.break
									end
									if not js.loop_jumped then
										edit_inst.replace_push (('%/0/').code)
									end
								end
								js.reset
							end
						end
						globals_inst.curwin.item.w_cursor := l_old_cursor
						if a_dir___0 /= 1 then
							l_pos := -1 + 147 -- skip if block
						end
				when 141 then -- if:
						if not (l_trunc_line.to_boolean) then
							l_pos := -1 + 144 -- skip if block
						end
				when 142 then -- if:
						l_pos := -1 + 145 -- goto _L___14
				when 143 then -- if block done, skip else block:
						l_pos := -1 + 146
				when 144 then -- else:
						if not (((globals_inst.State).bit_and (16)).to_boolean) then
							l_pos := -1 + 146 -- skip if block
						end
				when 145 then -- if: | _L___14:
						l_saved_line[globals_inst.curwin.item.w_cursor.col] := (('%/0/').code).to_natural_8
						if l_trunc_line.to_boolean then
							if not ((a_flags___0).bit_and (4)).to_boolean then
								edit_inst.truncate_spaces (l_saved_line)
							end
						end
						memline_inst.ml_replace (globals_inst.curwin.item.w_cursor.lnum, l_saved_line, 0).do_nothing
						l_saved_line.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						if l_did_append.to_boolean then
							changed_lines (globals_inst.curwin.item.w_cursor.lnum, globals_inst.curwin.item.w_cursor.col, globals_inst.curwin.item.w_cursor.lnum + 1, 1)
							l_did_append := 0
							if ((a_flags___0).bit_and (8)).to_boolean then
								mark_inst.mark_col_adjust (globals_inst.curwin.item.w_cursor.lnum, globals_inst.curwin.item.w_cursor.col + l_less_cols_off, 1, (-l_less_cols).to_integer_32)
							end
						else
							changed_bytes (globals_inst.curwin.item.w_cursor.lnum, globals_inst.curwin.item.w_cursor.col)
						end
				when 146 then -- if done
						globals_inst.curwin.item.w_cursor.lnum := l_old_cursor.lnum + 1
				when 147 then -- if done
						if l_did_append.to_boolean then
							changed_lines (globals_inst.curwin.item.w_cursor.lnum, 0, globals_inst.curwin.item.w_cursor.lnum, 1)
						end
						globals_inst.curwin.item.w_cursor.col := l_newcol
						globals_inst.curwin.item.w_cursor.coladd := 0
						if ((globals_inst.State).bit_and (128)).to_boolean then
							l_vreplace_mode := globals_inst.State
							globals_inst.State := 16
						else
							l_vreplace_mode := 0
						end
						if not option_inst.p_paste.to_boolean then
							if (l_leader.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								if (globals_inst.curbuf.item.b_p_lisp).to_boolean then
									if (globals_inst.curbuf.item.b_p_ai).to_boolean then
										edit_inst.fixthisline (get_lisp_indent_address)
										l_p___0.ce_gets (memline_inst.ml_get_curline)
										globals_inst.ai_col := (charset_inst.skipwhite (l_p___0)).distance (l_p___0)
									end
								end
							end
						end
						if option_inst.p_paste.to_boolean then
							l_pos := -1 + 153 -- skip if block
						end
				when 148 then -- if:
						if not ((globals_inst.curbuf.item.b_p_cin).to_boolean) then
							l_pos := -1 + 151 -- skip if block
						end
				when 149 then -- if:
						l_pos := -1 + 152 -- goto _L___15
				when 150 then -- if block done, skip else block:
						l_pos := -1 + 153
				when 151 then -- else:
						if ((globals_inst.curbuf.item.b_p_inde).item).to_integer_32 = 0 then
							l_pos := -1 + 153 -- skip if block
						end
				when 152 then -- if: | _L___15:
						l_tmp___32 := search_inst.linewhite (globals_inst.curwin.item.w_cursor.lnum)
						if a_dir___0 = 1 then
							l_tmp___33 := 257
						else
							l_tmp___33 := 258
						end
						if (edit_inst.in_cinkeys (l_tmp___33, (' ').code, l_tmp___32)).to_boolean then
							do_c_expr_indent
							l_p___0.ce_gets (memline_inst.ml_get_curline)
							globals_inst.ai_col := (charset_inst.skipwhite (l_p___0)).distance (l_p___0)
						end
				when 153 then -- if done | if done
						if l_vreplace_mode /= 0 then
							globals_inst.State := l_vreplace_mode
						end
						if not (((globals_inst.State).bit_and (128)).to_boolean) then
							l_pos := -1 + 156 -- skip if block
						end
				when 154 then -- if:
						l_p_extra.ce_gets (misc2_inst.vim_strsave ((memline_inst.ml_get_curline)))
						if (l_p_extra.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 157 -- goto theend
						end
				when 155 then
						memline_inst.ml_replace (globals_inst.curwin.item.w_cursor.lnum, l_next_line, 0).do_nothing
						globals_inst.curwin.item.w_cursor.col := 0
						globals_inst.curwin.item.w_cursor.coladd := 0
						ins_bytes (l_p_extra)
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_p_extra))
						l_next_line.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				when 156 then -- if done
						l_retval := 1
				when 157 then -- theend:
						globals_inst.curbuf.item.b_p_pi := l_saved_pi
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_saved_line))
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_next_line))
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_allocated))
						Result := l_retval
				when 158 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_leader_len (a_line: CE_POINTER [NATURAL_8]; a_flags___0: CE_POINTER [CE_POINTER [NATURAL_8]]; a_backward: INTEGER_32): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_j: INTEGER_32
			l_got_com: INTEGER_32
			l_found_one: INTEGER_32
			l_part_buf: CE_ARRAY [NATURAL_8]
			l_string___0: CE_POINTER [NATURAL_8]
			l_list: CE_POINTER [NATURAL_8]
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___4: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_part_buf.make (<<50>>)
			create l_string___0.make
			create l_list.make
			create l_tmp.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_got_com := 0
					l_i___0 := 0
					from
					until
						js.loop_left
					loop
						js.reset
						if (a_line[l_i___0]).to_integer_32 /= 32 then
							if (a_line[l_i___0]).to_integer_32 /= 9 then
								js.break
							end
						end
						if not js.loop_jumped then
							l_i___0 := l_i___0 + 1
						end
					end
					js.reset
				when 1 then -- loop condition:
					if not (not js.loop_left and then ((a_line[l_i___0]).to_boolean)) then
						l_pos := -1 + 12 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						l_found_one := 0
						l_list.ce_gets (globals_inst.curbuf.item.b_p_com)
				when 3 then -- loop condition:
						if not (not js.loop_left and then ((l_list.item).to_boolean)) then
							l_pos := -1 + 11 -- skip loop
						end
				when 4 then -- loop body:
						js.reset
						if not l_got_com.to_boolean then
							if (a_flags___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								a_flags___0.item := l_list
							end
						end
						misc2_inst.copy_option_part (l_list.address, l_part_buf, 50, ce_string (",")).do_nothing
						l_string___0.ce_gets (misc2_inst.vim_strchr (l_part_buf, (':').code))
						if (l_string___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							js.continue
						end
						if not js.loop_jumped then
							l_tmp.ce_gets (l_string___0)
							l_string___0.ce_gets (l_string___0 + 1)
							l_tmp.item := (('%/0/').code).to_natural_8
							if l_got_com.to_boolean then
								if ((misc2_inst.vim_strchr (l_part_buf, ('n').code)).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
									js.continue
								end
							end
						end
						if not js.loop_jumped and then (a_backward.to_boolean) then
							if ((misc2_inst.vim_strchr (l_part_buf, ('O').code)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								js.continue
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 10 -- skip if block
						end
				when 5 then -- if:
						if (l_string___0[0]).to_integer_32 /= 32 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_pos := -1 + 9 -- goto _L
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 8 then -- else:
						if (l_string___0[0]).to_integer_32 /= 9 then
							l_pos := -1 + 10 -- skip if block
						end
				when 9 then -- if: | _L:
						if l_i___0 = 0 then
							js.continue
						elseif (a_line[(l_i___0 - 1)]).to_integer_32 /= 32 then
							if (a_line[(l_i___0 - 1)]).to_integer_32 /= 9 then
								js.continue
							end
						end
						if not js.loop_jumped then
							from
							until
								js.loop_left
							loop
								js.reset
								if (l_string___0[0]).to_integer_32 /= 32 then
									if (l_string___0[0]).to_integer_32 /= 9 then
										js.break
									end
								end
								if not js.loop_jumped then
									l_string___0.ce_gets (l_string___0 + 1)
								end
							end
							js.reset
						end
				when 10 then -- if done | if done
						if not js.loop_jumped then
							l_j := 0
							from
							until
								js.loop_left
							loop
								js.reset
								if (l_string___0[l_j]).to_integer_32 /= 0 then
									if (l_string___0[l_j]).to_integer_32 /= (a_line[(l_i___0 + l_j)]).to_integer_32 then
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped then
									l_j := l_j + 1
								end
							end
							js.reset
							if (l_string___0[l_j]).to_integer_32 /= 0 then
								js.continue
							end
						end
						if not js.loop_jumped then
							if ((misc2_inst.vim_strchr (l_part_buf, ('b').code)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								if (a_line[(l_i___0 + l_j)]).to_integer_32 /= 32 then
									if (a_line[(l_i___0 + l_j)]).to_integer_32 /= 9 then
										if (a_line[(l_i___0 + l_j)]).to_integer_32 /= 0 then
											js.continue
										end
									end
								end
							end
						end
						if not js.loop_jumped then
							l_i___0 := l_i___0 + l_j
							l_got_com := 1
							l_found_one := 1
							js.break
						end
						if not js.loop_left then
							
						end
						l_pos := -1 + 3 -- back to loop condition
				when 11 then -- loop done
						js.reset
						if not l_found_one.to_boolean then
							js.break
						end
						if not js.loop_jumped then
							from
							until
								js.loop_left
							loop
								js.reset
								if (a_line[l_i___0]).to_integer_32 /= 32 then
									if (a_line[l_i___0]).to_integer_32 /= 9 then
										js.break
									end
								end
								if not js.loop_jumped then
									l_i___0 := l_i___0 + 1
								end
							end
							js.reset
							if ((misc2_inst.vim_strchr (l_part_buf, ('n').code)).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								js.break
							end
						end
						l_pos := -1 + 1 -- back to loop condition
				when 12 then -- loop done
					js.reset
					if l_got_com.to_boolean then
						l_tmp___4 := l_i___0
					else
						l_tmp___4 := 0
					end
					Result := l_tmp___4
				when 13 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	plines (a_lnum: INTEGER_32): INTEGER_32
		do
			Result := (plines_win (globals_inst.curwin, a_lnum, 1))
		end

	plines_win (a_wp___0: CE_POINTER [PD_WINDOW_S]; a_lnum: INTEGER_32; a_winheight: INTEGER_32): INTEGER_32
		local
			l_tmp: INTEGER_32
		do
			l_tmp := plines_win_nofill (a_wp___0, a_lnum, a_winheight)
			Result := (l_tmp + (diff_inst.diff_check_fill (a_wp___0, a_lnum)))
		end

	plines_nofill (a_lnum: INTEGER_32): INTEGER_32
		do
			Result := (plines_win_nofill (globals_inst.curwin, a_lnum, 1))
		end

	plines_win_nofill (a_wp___0: CE_POINTER [PD_WINDOW_S]; a_lnum: INTEGER_32; a_winheight: INTEGER_32): INTEGER_32
		local
			l_lines___0: INTEGER_32
			js: JUMP_STATE
		do
			if not (a_wp___0.item.w_onebuf_opt.wo_wrap).to_boolean then
				Result := 1
				js.return
			end
			if not js.return_called and then (a_wp___0.item.w_width = 0) then
				Result := 1
				js.return
			end
			if not js.return_called then
				if (fold_inst.lineFolded (a_wp___0, a_lnum)) = 1 then
					Result := 1
					js.return
				end
			end
			if not js.return_called then
				l_lines___0 := plines_win_nofold (a_wp___0, a_lnum)
				if a_winheight > 0 then
					if l_lines___0 > a_wp___0.item.w_height then
						Result := (a_wp___0.item.w_height)
						js.return
					end
				end
			end
			if not js.return_called then
				Result := l_lines___0
			end
		end

	plines_win_nofold (a_wp___0: CE_POINTER [PD_WINDOW_S]; a_lnum: INTEGER_32): INTEGER_32
		local
			l_s: CE_POINTER [NATURAL_8]
			l_col: INTEGER_32
			l_width: INTEGER_32
			js: JUMP_STATE
		do
			create l_s.make

			l_s.ce_gets (memline_inst.ml_get_buf (a_wp___0.item.w_buffer, a_lnum, 0))
			if (l_s.item).to_integer_32 = 0 then
				Result := 1
				js.return
			end
			if not js.return_called then
				l_col := (charset_inst.win_linetabsize (a_wp___0, l_s, (2147483647).to_integer_32)).to_integer_32
				if (a_wp___0.item.w_onebuf_opt.wo_list).to_boolean then
					if globals_inst.lcs_eol /= 0 then
						l_col := l_col + 1
					end
				end
				l_width := a_wp___0.item.w_width - (move_inst.win_col_off (a_wp___0))
				if l_width <= 0 then
					Result := 32000
					js.return
				end
			end
			if not js.return_called and then (l_col <= l_width.to_integer_32) then
				Result := 1
				js.return
			end
			if not js.return_called then
				l_col := l_col - l_width.to_integer_32
				l_width := l_width + (move_inst.win_col_off2 (a_wp___0))
				Result := ((l_col + (l_width - 1).to_integer_32) // l_width.to_integer_32 + 1).to_integer_32
			end
		end

	plines_win_col (a_wp___0: CE_POINTER [PD_WINDOW_S]; a_lnum: INTEGER_32; a_column: INTEGER_32): INTEGER_32
		local
			l_column: INTEGER_32
			l_col: INTEGER_32
			l_s: CE_POINTER [NATURAL_8]
			l_lines___0: INTEGER_32
			l_width: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			js: JUMP_STATE
		do
			create l_s.make

			l_column := a_column
			l_lines___0 := 0
			l_lines___0 := diff_inst.diff_check_fill (a_wp___0, a_lnum)
			if not (a_wp___0.item.w_onebuf_opt.wo_wrap).to_boolean then
				Result := (l_lines___0 + 1)
				js.return
			end
			if not js.return_called and then (a_wp___0.item.w_width = 0) then
				Result := (l_lines___0 + 1)
				js.return
			end
			if not js.return_called then
				l_s.ce_gets (memline_inst.ml_get_buf (a_wp___0.item.w_buffer, a_lnum, 0))
				l_col := 0
				from
				until
					js.loop_left
				loop
					js.reset
					if (l_s.item).to_integer_32 /= 0 then
						l_column := l_column - 1
						if not (l_column >= 0) then
							js.break
						end
					else
						js.break
					end
					if not js.loop_jumped then
						l_col := l_col + (charset_inst.win_lbr_chartabsize (a_wp___0, l_s, l_col.to_integer_32, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))).to_integer_32
						if globals_inst.has_mbyte.to_boolean then
							l_tmp___1 := (globals_inst.mb_ptr2len.integer_32_item ([l_s]))
						else
							l_tmp___1 := 1
						end
						l_s.ce_gets (l_s + l_tmp___1)
					end
				end
				js.reset
				if (l_s.item).to_integer_32 = 9 then
					if ((globals_inst.State).bit_and (1)).to_boolean then
						if not (a_wp___0.item.w_onebuf_opt.wo_list).to_boolean then
							l_tmp___2 := charset_inst.win_lbr_chartabsize (a_wp___0, l_s, l_col.to_integer_32, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
							l_col := l_col + (l_tmp___2 - 1).to_integer_32
						elseif globals_inst.lcs_tab1.to_boolean then
							l_tmp___2 := charset_inst.win_lbr_chartabsize (a_wp___0, l_s, l_col.to_integer_32, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
							l_col := l_col + (l_tmp___2 - 1).to_integer_32
						end
					end
				end
				l_width := a_wp___0.item.w_width - (move_inst.win_col_off (a_wp___0))
				if l_width <= 0 then
					Result := 9999
					js.return
				end
			end
			if not js.return_called then
				l_lines___0 := l_lines___0 + 1
				if l_col > l_width.to_integer_32 then
					l_lines___0 := (l_lines___0.to_integer_32 + ((l_col - l_width.to_integer_32) // (l_width + (move_inst.win_col_off2 (a_wp___0))).to_integer_32 + 1)).to_integer_32
				end
				Result := l_lines___0
			end
		end

	plines_m_win (a_wp___0: CE_POINTER [PD_WINDOW_S]; a_first___0: INTEGER_32; a_last: INTEGER_32): INTEGER_32
		local
			l_first___0: INTEGER_32
			l_count___2: INTEGER_32
			l_x___0: INTEGER_32
		do
			l_first___0 := a_first___0
			l_count___2 := 0
			from
			until
				not (l_first___0 <= a_last)
			loop
				l_x___0 := (fold_inst.foldedCount (a_wp___0, l_first___0, create {CE_POINTER [PD_FOLDINFO]}.make_shared (default_pointer))).to_integer_32
				if l_x___0 > 0 then
					l_count___2 := l_count___2 + 1
					l_first___0 := l_first___0 + l_x___0.to_integer_32
				else
					if l_first___0 = a_wp___0.item.w_topline then
						l_count___2 := l_count___2 + ((plines_win_nofill (a_wp___0, l_first___0, 1)) + a_wp___0.item.w_topfill)
					else
						l_count___2 := l_count___2 + (plines_win (a_wp___0, l_first___0, 1))
					end
					l_first___0 := l_first___0 + 1
				end
			end
			Result := l_count___2
		end

	ins_bytes (a_p___0: CE_POINTER [NATURAL_8])
		do
			ins_bytes_len (a_p___0, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_p___0))).to_integer_32)
		end

	ins_bytes_len (a_p___0: CE_POINTER [NATURAL_8]; a_len: INTEGER_32)
		local
			l_i___0: INTEGER_32
			l_n: INTEGER_32
		do
			if globals_inst.has_mbyte.to_boolean then
				l_i___0 := 0
				from
				until
					not (l_i___0 < a_len)
				loop
					if globals_inst.enc_utf8.to_boolean then
						l_n := mbyte_inst.utfc_ptr2len_len (a_p___0 + l_i___0, a_len - l_i___0)
					else
						l_n := globals_inst.mb_ptr2len.integer_32_item ([a_p___0 + l_i___0])
					end
					ins_char_bytes (a_p___0 + l_i___0, l_n)
					l_i___0 := l_i___0 + l_n
				end
			else
				l_i___0 := 0
				from
				until
					not (l_i___0 < a_len)
				loop
					ins_char ((a_p___0[l_i___0]).to_integer_32)
					l_i___0 := l_i___0 + 1
				end
			end
		end

	ins_char (a_c: INTEGER_32)
		local
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_n: INTEGER_32
		do
			create l_buf___6.make (<<21>>)

			l_n := globals_inst.mb_char2bytes.integer_32_item ([a_c, l_buf___6])
			if (l_buf___6[0]).to_integer_32 = 0 then
				l_buf___6[0] := (('%N').code).to_natural_8
			end
			ins_char_bytes (l_buf___6, l_n)
		end

	ins_char_bytes (a_buf___6: CE_POINTER [NATURAL_8]; a_charlen: INTEGER_32)
		local
			l_c: INTEGER_32
			l_newlen: INTEGER_32
			l_oldlen: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_newp: CE_POINTER [NATURAL_8]
			l_oldp: CE_POINTER [NATURAL_8]
			l_linelen___0: INTEGER_32
			l_col: INTEGER_32
			l_lnum: INTEGER_32
			l_i___0: INTEGER_32
			l_new_vcol: INTEGER_32
			l_vcol: INTEGER_32
			l_old_list: INTEGER_32
			l_tmp___7: INTEGER_32
			js: JUMP_STATE
		do
			create l_p___0.make
			create l_newp.make
			create l_oldp.make

			l_c := (a_buf___6[0]).to_integer_32
			l_lnum := globals_inst.curwin.item.w_cursor.lnum
			if (misc2_inst.virtual_active).to_boolean then
				if globals_inst.curwin.item.w_cursor.coladd > 0 then
					misc2_inst.coladvance_force ((misc2_inst.getviscol)).do_nothing
				end
			end
			l_col := globals_inst.curwin.item.w_cursor.col
			l_oldp.ce_gets (memline_inst.ml_get (l_lnum))
			l_linelen___0 := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_oldp))).to_integer_32 + 1
			l_oldlen := 0
			l_newlen := a_charlen
			if ((globals_inst.State).bit_and (64)).to_boolean then
				if ((globals_inst.State).bit_and (128)).to_boolean then
					l_new_vcol := 0
					l_old_list := globals_inst.curwin.item.w_onebuf_opt.wo_list
					if l_old_list.to_boolean then
						if ((misc2_inst.vim_strchr (option_inst.p_cpo, ('L').code)).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							globals_inst.curwin.item.w_onebuf_opt.wo_list := 0
						end
					end
					charset_inst.getvcol (globals_inst.curwin, create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curwin.c_pointer + {PD_WINDOW_S}.w_cursor_offset), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared ($l_vcol), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
					l_new_vcol := l_vcol + (charset_inst.chartabsize (a_buf___6, l_vcol))
					from
					until
						js.loop_left
					loop
						js.reset
						if (l_oldp[(l_col + l_oldlen)]).to_integer_32 /= 0 then
							if not (l_vcol < l_new_vcol) then
								js.break
							end
						else
							js.break
						end
						if not js.loop_jumped then
							l_vcol := l_vcol + (charset_inst.chartabsize ((l_oldp + l_col) + l_oldlen, l_vcol))
							if l_vcol > l_new_vcol then
								if (l_oldp[(l_col + l_oldlen)]).to_integer_32 = 9 then
									js.break
								end
							end
						end
						if not js.loop_jumped then
							l_oldlen := l_oldlen + (globals_inst.mb_ptr2len.integer_32_item ([(l_oldp + l_col) + l_oldlen]))
							if l_vcol > l_new_vcol then
								l_newlen := l_newlen + (l_vcol - l_new_vcol)
							end
						end
					end
					js.reset
					globals_inst.curwin.item.w_onebuf_opt.wo_list := l_old_list
				elseif (l_oldp[l_col]).to_integer_32 /= 0 then
					l_oldlen := globals_inst.mb_ptr2len.integer_32_item ([l_oldp + l_col])
				end
				edit_inst.replace_push (('%/0/').code)
				l_i___0 := 0
				from
				until
					not (l_i___0 < l_oldlen)
				loop
					if globals_inst.has_mbyte.to_boolean then
						l_i___0 := l_i___0 + ((edit_inst.replace_push_mb ((l_oldp + l_col) + l_i___0)) - 1)
					else
						edit_inst.replace_push ((l_oldp[(l_col + l_i___0)]).to_integer_32)
					end
					l_i___0 := l_i___0 + 1
				end
			end
			l_newp.ce_gets (misc2_inst.alloc_check (((l_linelen___0 + l_newlen) - l_oldlen).to_natural_32))
			if (l_newp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				js.return
			end
			if not js.return_called then
				if l_col > 0 then
					memmove (create {CE_POINTER [ANY]}.make_cast (l_newp), create {CE_POINTER [ANY]}.make_cast (l_oldp), l_col.to_natural_32).do_nothing
				end
				l_p___0.ce_gets (l_newp + l_col)
				memmove (create {CE_POINTER [ANY]}.make_cast ((l_p___0 + l_newlen)), create {CE_POINTER [ANY]}.make_cast (((l_oldp + l_col) + l_oldlen)), ((l_linelen___0 - l_col) - l_oldlen).to_natural_32).do_nothing
				memmove (create {CE_POINTER [ANY]}.make_cast (l_p___0), create {CE_POINTER [ANY]}.make_cast (a_buf___6), a_charlen.to_natural_32).do_nothing
				l_i___0 := a_charlen
				from
				until
					not (l_i___0 < l_newlen)
				loop
					l_tmp___7 := l_i___0
					l_i___0 := l_i___0 + 1
					l_p___0[l_tmp___7] := ((' ').code).to_natural_8
				end
				memline_inst.ml_replace (l_lnum, l_newp, 0).do_nothing
				changed_bytes (l_lnum, l_col)
				if option_inst.p_sm.to_boolean then
					if ((globals_inst.State).bit_and (16)).to_boolean then
						if globals_inst.msg_silent = 0 then
							if a_charlen = 1 then
								if not (edit_inst.ins_compl_active).to_boolean then
									search_inst.showmatch (l_c)
								end
							end
						end
					end
				end
				globals_inst.curwin.item.w_cursor.col := globals_inst.curwin.item.w_cursor.col + a_charlen
			end
		end

	ins_str (a_s: CE_POINTER [NATURAL_8])
		local
			l_oldp: CE_POINTER [NATURAL_8]
			l_newp: CE_POINTER [NATURAL_8]
			l_newlen: INTEGER_32
			l_oldlen: INTEGER_32
			l_col: INTEGER_32
			l_lnum: INTEGER_32
			js: JUMP_STATE
		do
			create l_oldp.make
			create l_newp.make

			l_newlen := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_s))).to_integer_32
			l_lnum := globals_inst.curwin.item.w_cursor.lnum
			if (misc2_inst.virtual_active).to_boolean then
				if globals_inst.curwin.item.w_cursor.coladd > 0 then
					misc2_inst.coladvance_force ((misc2_inst.getviscol)).do_nothing
				end
			end
			l_col := globals_inst.curwin.item.w_cursor.col
			l_oldp.ce_gets (memline_inst.ml_get (l_lnum))
			l_oldlen := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_oldp))).to_integer_32
			l_newp.ce_gets (misc2_inst.alloc_check (((l_oldlen + l_newlen) + 1).to_natural_32))
			if (l_newp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				js.return
			end
			if not js.return_called then
				if l_col > 0 then
					memmove (create {CE_POINTER [ANY]}.make_cast (l_newp), create {CE_POINTER [ANY]}.make_cast (l_oldp), l_col.to_natural_32).do_nothing
				end
				memmove (create {CE_POINTER [ANY]}.make_cast ((l_newp + l_col)), create {CE_POINTER [ANY]}.make_cast (a_s), l_newlen.to_natural_32).do_nothing
				memmove (create {CE_POINTER [ANY]}.make_cast (((l_newp + l_col) + l_newlen)), create {CE_POINTER [ANY]}.make_cast ((l_oldp + l_col)), ((l_oldlen - l_col) + 1).to_natural_32).do_nothing
				memline_inst.ml_replace (l_lnum, l_newp, 0).do_nothing
				changed_bytes (l_lnum, l_col)
				globals_inst.curwin.item.w_cursor.col := globals_inst.curwin.item.w_cursor.col + l_newlen
			end
		end

	del_char (a_fixpos: INTEGER_32): INTEGER_32
		local
			js: JUMP_STATE
		do
			if globals_inst.has_mbyte.to_boolean then
				mbyte_inst.mb_adjust_cursor
				if ((memline_inst.ml_get_cursor).item).to_integer_32 = 0 then
					Result := 0
					js.return
				end
				if not js.return_called then
					Result := (del_chars (1, a_fixpos))
					js.return
				end
			end
			if not js.return_called then
				Result := (del_bytes (1, a_fixpos, 1))
			end
		end

	del_chars (a_count___2: INTEGER_32; a_fixpos: INTEGER_32): INTEGER_32
		local
			l_bytes___0: INTEGER_32
			l_i___0: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_l: INTEGER_32
			js: JUMP_STATE
		do
			create l_p___0.make

			l_bytes___0 := 0
			l_p___0.ce_gets (memline_inst.ml_get_cursor)
			l_i___0 := 0
			from
			until
				js.loop_left
			loop
				js.reset
				if l_i___0 < a_count___2 then
					if (l_p___0.item).to_integer_32 = 0 then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					l_l := globals_inst.mb_ptr2len.integer_32_item ([l_p___0])
					l_bytes___0 := l_bytes___0 + l_l.to_integer_32
					l_p___0.ce_gets (l_p___0 + l_l)
					l_i___0 := l_i___0 + 1
				end
			end
			js.reset
			Result := (del_bytes (l_bytes___0, a_fixpos, 1))
		end

	del_bytes (a_count___2: INTEGER_32; a_fixpos_arg: INTEGER_32; a_use_delcombine: INTEGER_32): INTEGER_32
		local
			l_count___2: INTEGER_32
			l_oldp: CE_POINTER [NATURAL_8]
			l_newp: CE_POINTER [NATURAL_8]
			l_oldlen: INTEGER_32
			l_lnum: INTEGER_32
			l_col: INTEGER_32
			l_was_alloced: INTEGER_32
			l_movelen: INTEGER_32
			l_fixpos: INTEGER_32
			l_cc___0: CE_ARRAY [INTEGER_32]
			l_n: INTEGER_32
			js: JUMP_STATE
		do
			create l_oldp.make
			create l_newp.make
			create l_cc___0.make (<<6>>)

			l_count___2 := a_count___2
			l_lnum := globals_inst.curwin.item.w_cursor.lnum
			l_col := globals_inst.curwin.item.w_cursor.col
			l_fixpos := a_fixpos_arg
			l_oldp.ce_gets (memline_inst.ml_get (l_lnum))
			l_oldlen := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_oldp))).to_integer_32
			if l_col >= l_oldlen then
				Result := 0
				js.return
			end
			if not js.return_called then
				if option_inst.p_deco.to_boolean then
					if a_use_delcombine.to_boolean then
						if globals_inst.enc_utf8.to_boolean then
							if (mbyte_inst.utfc_ptr2len (l_oldp + l_col)).to_integer_32 >= l_count___2 then
								mbyte_inst.utfc_ptr2char (l_oldp + l_col, l_cc___0).do_nothing
								if l_cc___0[0] /= 0 then
									l_n := l_col
									from
									until
										js.loop_left
									loop
										js.reset
										l_col := l_n
										l_count___2 := (mbyte_inst.utf_ptr2len (l_oldp + l_n)).to_integer_32
										l_n := (l_n.to_integer_32 + l_count___2).to_integer_32
										if not (mbyte_inst.utf_iscomposing ((mbyte_inst.utf_ptr2char (l_oldp + l_n)))).to_boolean then
											js.break
										end
									end
									js.reset
									l_fixpos := 0
								end
							end
						end
					end
				end
				l_movelen := ((l_oldlen.to_integer_32 - l_col.to_integer_32) - l_count___2) + 1
				if l_movelen <= 1 then
					if l_col > 0 then
						if l_fixpos.to_boolean then
							if globals_inst.restart_edit = 0 then
								if ((option_inst.ve_flags).bit_and ({NATURAL_32} 8)) = {NATURAL_32} 0 then
									globals_inst.curwin.item.w_cursor.col := (globals_inst.curwin.item.w_cursor.col) - 1
									globals_inst.curwin.item.w_cursor.coladd := 0
									if globals_inst.has_mbyte.to_boolean then
										globals_inst.curwin.item.w_cursor.col := globals_inst.curwin.item.w_cursor.col - (globals_inst.mb_head_off.integer_32_item ([l_oldp, l_oldp + globals_inst.curwin.item.w_cursor.col]))
									end
								end
							end
						end
					end
					l_count___2 := (l_oldlen - l_col).to_integer_32
					l_movelen := 1
				end
				if (netbeans_inst.netbeans_active).to_boolean then
					l_was_alloced := 0
				else
					l_was_alloced := memline_inst.ml_line_alloced
				end
				if l_was_alloced.to_boolean then
					l_newp.ce_gets (l_oldp)
				else
					l_newp.ce_gets (misc2_inst.alloc (((l_oldlen + 1).to_integer_32 - l_count___2).to_natural_32))
					if (l_newp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						Result := 0
						js.return
					end
					if not js.return_called then
						memmove (create {CE_POINTER [ANY]}.make_cast (l_newp), create {CE_POINTER [ANY]}.make_cast (l_oldp), l_col.to_natural_32).do_nothing
					end
				end
			end
			if not js.return_called then
				memmove (create {CE_POINTER [ANY]}.make_cast ((l_newp + l_col)), create {CE_POINTER [ANY]}.make_cast (((l_oldp + l_col) + l_count___2)), l_movelen.to_natural_32).do_nothing
				if not l_was_alloced.to_boolean then
					memline_inst.ml_replace (l_lnum, l_newp, 0).do_nothing
				end
				changed_bytes (l_lnum, globals_inst.curwin.item.w_cursor.col)
				Result := 1
			end
		end

	truncate_line (a_fixpos: INTEGER_32): INTEGER_32
		local
			l_newp: CE_POINTER [NATURAL_8]
			l_lnum: INTEGER_32
			l_col: INTEGER_32
			js: JUMP_STATE
		do
			create l_newp.make

			l_lnum := globals_inst.curwin.item.w_cursor.lnum
			l_col := globals_inst.curwin.item.w_cursor.col
			if l_col = 0 then
				l_newp.ce_gets (misc2_inst.vim_strsave (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))))
			else
				l_newp.ce_gets (misc2_inst.vim_strnsave ((memline_inst.ml_get (l_lnum)), l_col))
			end
			if (l_newp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				Result := 0
				js.return
			end
			if not js.return_called then
				memline_inst.ml_replace (l_lnum, l_newp, 0).do_nothing
				changed_bytes (l_lnum, globals_inst.curwin.item.w_cursor.col)
				if a_fixpos.to_boolean then
					if globals_inst.curwin.item.w_cursor.col > 0 then
						globals_inst.curwin.item.w_cursor.col := (globals_inst.curwin.item.w_cursor.col) - 1
					end
				end
				Result := 1
			end
		end

	del_lines (a_nlines: INTEGER_32; a_undo: INTEGER_32)
		local
			l_n: INTEGER_32
			l_first___0: INTEGER_32
			js: JUMP_STATE
		do
			l_first___0 := globals_inst.curwin.item.w_cursor.lnum
			if a_nlines <= 0 then
				js.return
			end
			if not js.return_called and then (a_undo.to_boolean) then
				if (undo_inst.u_savedel (l_first___0, a_nlines)) = 0 then
					js.return
				end
			end
			if not js.return_called then
				l_n := 0
				from
				until
					not (not js.loop_left and then (l_n < a_nlines))
				loop
					js.reset
					if ((globals_inst.curbuf.item.b_ml.ml_flags).bit_and (1)).to_boolean then
						js.break
					end
					if not js.loop_jumped then
						memline_inst.ml_delete (l_first___0, 1).do_nothing
						l_n := l_n + 1
						if l_first___0 > globals_inst.curbuf.item.b_ml.ml_line_count then
							js.break
						end
					end
				end
				js.reset
				globals_inst.curwin.item.w_cursor.col := 0
				misc2_inst.check_cursor_lnum
				deleted_lines_mark (l_first___0, l_n)
			end
		end

	gchar_pos (a_pos___3: CE_POINTER [PD_POS_T]): INTEGER_32
		local
			l_ptr: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_ptr.make

			l_ptr.ce_gets ((memline_inst.ml_get_pos (a_pos___3)))
			if globals_inst.has_mbyte.to_boolean then
				Result := (globals_inst.mb_ptr2char.integer_32_item ([l_ptr]))
				js.return
			end
			if not js.return_called then
				Result := (l_ptr.item).to_integer_32
			end
		end

	gchar_cursor: INTEGER_32
		local
			js: JUMP_STATE
		do
			if globals_inst.has_mbyte.to_boolean then
				Result := (globals_inst.mb_ptr2char.integer_32_item ([(memline_inst.ml_get_cursor)]))
				js.return
			end
			if not js.return_called then
				Result := ((memline_inst.ml_get_cursor).item).to_integer_32
			end
		end

	pchar_cursor (a_c: INTEGER_32)
		do
			(memline_inst.ml_get_buf (globals_inst.curbuf, globals_inst.curwin.item.w_cursor.lnum, 1))[globals_inst.curwin.item.w_cursor.col] := a_c.to_natural_8
		end

	inindent (a_extra: INTEGER_32): INTEGER_32
		local
			l_ptr: CE_POINTER [NATURAL_8]
			l_col: INTEGER_32
			js: JUMP_STATE
		do
			create l_ptr.make

			l_col := 0
			l_ptr.ce_gets (memline_inst.ml_get_curline)
			from
			until
				js.loop_left
			loop
				js.reset
				if (l_ptr.item).to_integer_32 /= 32 then
					if (l_ptr.item).to_integer_32 /= 9 then
						js.break
					end
				end
				if not js.loop_jumped then
					l_ptr.ce_gets (l_ptr + 1)
					l_col := l_col + 1
				end
			end
			js.reset
			if l_col >= globals_inst.curwin.item.w_cursor.col + a_extra then
				Result := 1
			else
				Result := 0
			end
		end

	skip_to_option_part (a_p___0: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_p___0: CE_POINTER [NATURAL_8]
		do
			create l_p___0.make

			l_p___0.ce_gets (a_p___0)
			if (l_p___0.item).to_integer_32 = 44 then
				l_p___0.ce_gets (l_p___0 + 1)
			end
			from
			until
				(l_p___0.item).to_integer_32 /= 32
			loop
				l_p___0.ce_gets (l_p___0 + 1)
			end
			Result := l_p___0
		end

	changed
		local
			l_save_msg_scroll: INTEGER_32
			js: JUMP_STATE
		do
			if (mbyte_inst.im_is_preediting).to_boolean then
				if not globals_inst.xim_changed_while_preediting.to_boolean then
					js.return
				end
			end
			if not js.return_called then
				globals_inst.xim_changed_while_preediting := 0
				if not (globals_inst.curbuf.item.b_changed).to_boolean then
					l_save_msg_scroll := globals_inst.msg_scroll
					change_warning (0)
					if (globals_inst.curbuf.item.b_may_swap).to_boolean then
						if not (quickfix_inst.bt_dontwrite (globals_inst.curbuf)).to_boolean then
							memline_inst.ml_open_file (globals_inst.curbuf)
							if globals_inst.need_wait_return.to_boolean then
								if globals_inst.emsg_silent = 0 then
									term_inst.out_flush
									ui_inst.ui_delay (2000, 1)
									message_inst.wait_return (1)
									globals_inst.msg_scroll := l_save_msg_scroll
								end
							end
						end
					end
					changed_int
				end
				globals_inst.curbuf.item.b_changedtick := (globals_inst.curbuf.item.b_changedtick) + 1
			end
		end

	changed_int
		do
			globals_inst.curbuf.item.b_changed := 1
			memline_inst.ml_setflags (globals_inst.curbuf)
			check_status (globals_inst.curbuf)
			globals_inst.redraw_tabline := 1
			globals_inst.need_maketitle := 1
		end

	changed_bytes (a_lnum: INTEGER_32; a_col: INTEGER_32)
		local
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_wlnum: INTEGER_32
		do
			create l_wp___0.make

			changedOneline (globals_inst.curbuf, a_lnum)
			changed_common (a_lnum, a_col, a_lnum + 1, 0)
			if (globals_inst.curwin.item.w_onebuf_opt.wo_diff).to_boolean then
				l_wp___0.ce_gets (globals_inst.firstwin)
				from
				until
					(l_wp___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32
				loop
					if (l_wp___0.item.w_onebuf_opt.wo_diff).to_boolean then
						if (l_wp___0.c_pointer.to_integer_32).to_natural_32 /= (globals_inst.curwin.c_pointer.to_integer_32).to_natural_32 then
							screen_inst.redraw_win_later (l_wp___0, 10)
							l_wlnum := diff_inst.diff_lnum_win (a_lnum, l_wp___0)
							if l_wlnum > 0 then
								changedOneline (l_wp___0.item.w_buffer, l_wlnum)
							end
						end
					end
					l_wp___0.ce_gets (l_wp___0.item.w_next)
				end
			end
		end

	changedOneline (a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_lnum: INTEGER_32)
		do
			if (a_buf___6.item.b_mod_set).to_boolean then
				if a_lnum < a_buf___6.item.b_mod_top then
					a_buf___6.item.b_mod_top := a_lnum
				elseif a_lnum >= a_buf___6.item.b_mod_bot then
					a_buf___6.item.b_mod_bot := a_lnum + 1
				end
			else
				a_buf___6.item.b_mod_set := 1
				a_buf___6.item.b_mod_top := a_lnum
				a_buf___6.item.b_mod_bot := a_lnum + 1
				a_buf___6.item.b_mod_xlines := 0
			end
		end

	appended_lines (a_lnum: INTEGER_32; a_count___2: INTEGER_32)
		do
			changed_lines (a_lnum + 1, 0, a_lnum + 1, a_count___2)
		end

	appended_lines_mark (a_lnum: INTEGER_32; a_count___2: INTEGER_32)
		do
			mark_inst.mark_adjust (a_lnum + 1, 2147483647, a_count___2, 0)
			changed_lines (a_lnum + 1, 0, a_lnum + 1, a_count___2)
		end

	deleted_lines (a_lnum: INTEGER_32; a_count___2: INTEGER_32)
		do
			changed_lines (a_lnum, 0, a_lnum + a_count___2, -a_count___2)
		end

	deleted_lines_mark (a_lnum: INTEGER_32; a_count___2: INTEGER_32)
		do
			mark_inst.mark_adjust (a_lnum, (a_lnum + a_count___2) - 1, 2147483647, -a_count___2)
			changed_lines (a_lnum, 0, a_lnum + a_count___2, -a_count___2)
		end

	changed_lines (a_lnum: INTEGER_32; a_col: INTEGER_32; a_lnume: INTEGER_32; a_xtra: INTEGER_32)
		local
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_wlnum: INTEGER_32
		do
			create l_wp___0.make

			changed_lines_buf (globals_inst.curbuf, a_lnum, a_lnume, a_xtra)
			if a_xtra = 0 then
				if (globals_inst.curwin.item.w_onebuf_opt.wo_diff).to_boolean then
					l_wp___0.ce_gets (globals_inst.firstwin)
					from
					until
						(l_wp___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32
					loop
						if (l_wp___0.item.w_onebuf_opt.wo_diff).to_boolean then
							if (l_wp___0.c_pointer.to_integer_32).to_natural_32 /= (globals_inst.curwin.c_pointer.to_integer_32).to_natural_32 then
								screen_inst.redraw_win_later (l_wp___0, 10)
								l_wlnum := diff_inst.diff_lnum_win (a_lnum, l_wp___0)
								if l_wlnum > 0 then
									changed_lines_buf (l_wp___0.item.w_buffer, l_wlnum, (a_lnume - a_lnum) + l_wlnum, 0)
								end
							end
						end
						l_wp___0.ce_gets (l_wp___0.item.w_next)
					end
				end
			end
			changed_common (a_lnum, a_col, a_lnume, a_xtra)
		end

	changed_lines_buf (a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_lnum: INTEGER_32; a_lnume: INTEGER_32; a_xtra: INTEGER_32)
		do
			if (a_buf___6.item.b_mod_set).to_boolean then
				if a_lnum < a_buf___6.item.b_mod_top then
					a_buf___6.item.b_mod_top := a_lnum
				end
				if a_lnum < a_buf___6.item.b_mod_bot then
					a_buf___6.item.b_mod_bot := a_buf___6.item.b_mod_bot + a_xtra
					if a_buf___6.item.b_mod_bot < a_lnum then
						a_buf___6.item.b_mod_bot := a_lnum
					end
				end
				if a_lnume + a_xtra > a_buf___6.item.b_mod_bot then
					a_buf___6.item.b_mod_bot := a_lnume + a_xtra
				end
				a_buf___6.item.b_mod_xlines := a_buf___6.item.b_mod_xlines + a_xtra
			else
				a_buf___6.item.b_mod_set := 1
				a_buf___6.item.b_mod_top := a_lnum
				a_buf___6.item.b_mod_bot := a_lnume + a_xtra
				a_buf___6.item.b_mod_xlines := a_xtra
			end
		end

	changed_common (a_lnum: INTEGER_32; a_col: INTEGER_32; a_lnume: INTEGER_32; a_xtra: INTEGER_32)
		local
			l_lnum: INTEGER_32
			l_lnume: INTEGER_32
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_tp: CE_POINTER [PD_TABPAGE_S]
			l_i___0: INTEGER_32
			l_cols: INTEGER_32
			l_p___0: CE_POINTER [PD_POS_T]
			l_add: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___1: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_wp___0.make
			create l_tp.make
			create l_p___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_lnum := a_lnum
					l_lnume := a_lnume
					changed
					if (globals_inst.cmdmod.keepjumps).to_boolean then
						l_pos := -1 + 7 -- skip if block
					end
				when 1 then -- if:
						globals_inst.curbuf.item.b_last_change.lnum := l_lnum
						globals_inst.curbuf.item.b_last_change.col := a_col
						if not ((globals_inst.curbuf.item.b_new_change).to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if globals_inst.curbuf.item.b_changelistlen /= 0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						if globals_inst.curbuf.item.b_changelistlen = 0 then
							l_add := 1
						else
							l_p___0.ce_gets (globals_inst.curbuf.item.b_changelist + globals_inst.curbuf.item.b_changelistlen - 1)
							if l_p___0.item.lnum /= l_lnum then
								l_add := 1
							else
								l_cols := edit_inst.comp_textwidth (0)
								if l_cols = 0 then
									l_cols := 79
								end
								if l_p___0.item.col + l_cols < a_col then
									l_tmp := 1
								elseif a_col + l_cols < l_p___0.item.col then
									l_tmp := 1
								else
									l_tmp := 0
								end
								l_add := l_tmp
							end
						end
						if l_add.to_boolean then
							globals_inst.curbuf.item.b_new_change := 0
							if globals_inst.curbuf.item.b_changelistlen = 100 then
								globals_inst.curbuf.item.b_changelistlen := 99
								memmove (create {CE_POINTER [ANY]}.make_cast ((globals_inst.curbuf.item.b_changelist)), create {CE_POINTER [ANY]}.make_cast ((globals_inst.curbuf.item.b_changelist + 1)), {PD_POS_T}.sizeof.to_natural_32 * {NATURAL_32} 99).do_nothing
								l_tp.ce_gets (globals_inst.first_tabpage)
								from
								until
									not (not js.loop_left and then ((l_tp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32))
								loop
									if (l_tp.c_pointer.to_integer_32).to_natural_32 = (globals_inst.curtab.c_pointer.to_integer_32).to_natural_32 then
										l_wp___0.ce_gets (globals_inst.firstwin)
									else
										l_wp___0.ce_gets (l_tp.item.tp_firstwin)
									end
									from
									until
										(l_wp___0).c_pointer = default_pointer
									loop
										if ((l_wp___0.item.w_buffer).c_pointer.to_integer_32).to_natural_32 = (globals_inst.curbuf.c_pointer.to_integer_32).to_natural_32 then
											if l_wp___0.item.w_changelistidx > 0 then
												l_wp___0.item.w_changelistidx := (l_wp___0.item.w_changelistidx) - 1
											end
										end
										l_wp___0.ce_gets (l_wp___0.item.w_next)
									end
									l_tp.ce_gets (l_tp.item.tp_next)
								end
							end
							l_tp.ce_gets (globals_inst.first_tabpage)
							from
							until
								not (not js.loop_left and then ((l_tp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32))
							loop
								if (l_tp.c_pointer.to_integer_32).to_natural_32 = (globals_inst.curtab.c_pointer.to_integer_32).to_natural_32 then
									l_wp___0.ce_gets (globals_inst.firstwin)
								else
									l_wp___0.ce_gets (l_tp.item.tp_firstwin)
								end
								from
								until
									(l_wp___0).c_pointer = default_pointer
								loop
									if ((l_wp___0.item.w_buffer).c_pointer.to_integer_32).to_natural_32 = (globals_inst.curbuf.c_pointer.to_integer_32).to_natural_32 then
										if l_wp___0.item.w_changelistidx = globals_inst.curbuf.item.b_changelistlen then
											l_wp___0.item.w_changelistidx := (l_wp___0.item.w_changelistidx) + 1
										end
									end
									l_wp___0.ce_gets (l_wp___0.item.w_next)
								end
								l_tp.ce_gets (l_tp.item.tp_next)
							end
							globals_inst.curbuf.item.b_changelistlen := (globals_inst.curbuf.item.b_changelistlen) + 1
						end
				when 6 then -- if done
						globals_inst.curbuf.item.b_changelist[globals_inst.curbuf.item.b_changelistlen - 1] := globals_inst.curbuf.item.b_last_change
						globals_inst.curwin.item.w_changelistidx := globals_inst.curbuf.item.b_changelistlen
				when 7 then -- if done
					l_tp.ce_gets (globals_inst.first_tabpage)
					from
					until
						not (not js.loop_left and then ((l_tp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32))
					loop
						if (l_tp.c_pointer.to_integer_32).to_natural_32 = (globals_inst.curtab.c_pointer.to_integer_32).to_natural_32 then
							l_wp___0.ce_gets (globals_inst.firstwin)
						else
							l_wp___0.ce_gets (l_tp.item.tp_firstwin)
						end
						from
						until
							not (not js.loop_left and then ((l_wp___0).c_pointer /= default_pointer))
						loop
							if ((l_wp___0.item.w_buffer).c_pointer.to_integer_32).to_natural_32 = (globals_inst.curbuf.c_pointer.to_integer_32).to_natural_32 then
								if l_wp___0.item.w_redr_type < 10 then
									l_wp___0.item.w_redr_type := 10
								end
								fold_inst.foldUpdate (l_wp___0, l_lnum, (l_lnume + a_xtra) - 1)
								l_i___0 := fold_inst.hasFoldingWin (l_wp___0, l_lnum, create {CE_POINTER [INTEGER_32]}.make_shared ($l_lnum), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), 0, create {CE_POINTER [PD_FOLDINFO]}.make_shared (default_pointer))
								if l_wp___0.item.w_cursor.lnum = l_lnum then
									l_wp___0.item.w_cline_folded := l_i___0
								end
								l_i___0 := fold_inst.hasFoldingWin (l_wp___0, l_lnume, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared ($l_lnume), 0, create {CE_POINTER [PD_FOLDINFO]}.make_shared (default_pointer))
								if l_wp___0.item.w_cursor.lnum = l_lnume then
									l_wp___0.item.w_cline_folded := l_i___0
								end
								if l_wp___0.item.w_cursor.lnum <= l_lnum then
									l_i___0 := fold_inst.find_wl_entry (l_wp___0, l_lnum)
									if l_i___0 >= 0 then
										if l_wp___0.item.w_cursor.lnum > (l_wp___0.item.w_lines + l_i___0).item.wl_lnum then
											move_inst.changed_line_abv_curs_win (l_wp___0)
										end
									end
								end
								if l_wp___0.item.w_cursor.lnum > l_lnum then
									move_inst.changed_line_abv_curs_win (l_wp___0)
								elseif l_wp___0.item.w_cursor.lnum = l_lnum then
									if l_wp___0.item.w_cursor.col >= a_col then
										move_inst.changed_cline_bef_curs_win (l_wp___0)
									end
								end
								if l_wp___0.item.w_botline >= l_lnum then
									move_inst.approximate_botline_win (l_wp___0)
								end
								l_i___0 := 0
								from
								until
									not (l_i___0 < l_wp___0.item.w_lines_valid)
								loop
									if ((l_wp___0.item.w_lines + l_i___0).item.wl_valid).to_boolean then
										if (l_wp___0.item.w_lines + l_i___0).item.wl_lnum >= l_lnum then
											if (l_wp___0.item.w_lines + l_i___0).item.wl_lnum < l_lnume then
												(l_wp___0.item.w_lines + l_i___0).item.wl_valid := (0).to_integer_8
											elseif a_xtra /= 0 then
												(l_wp___0.item.w_lines + l_i___0).item.wl_lnum := (l_wp___0.item.w_lines + l_i___0).item.wl_lnum + a_xtra;
												(l_wp___0.item.w_lines + l_i___0).item.wl_lastlnum := (l_wp___0.item.w_lines + l_i___0).item.wl_lastlnum + a_xtra
											end
										elseif (l_wp___0.item.w_lines + l_i___0).item.wl_lastlnum >= l_lnum then
											(l_wp___0.item.w_lines + l_i___0).item.wl_valid := (0).to_integer_8
										end
									end
									l_i___0 := l_i___0 + 1
								end
								if (fold_inst.hasAnyFolding (l_wp___0)).to_boolean then
									move_inst.set_topline (l_wp___0, l_wp___0.item.w_topline)
								end
							end
							l_wp___0.ce_gets (l_wp___0.item.w_next)
						end
						l_tp.ce_gets (l_tp.item.tp_next)
					end
					if globals_inst.must_redraw < 10 then
						globals_inst.must_redraw := 10
					end
					if l_lnum <= globals_inst.curwin.item.w_cursor.lnum then
						if a_xtra < 0 then
							l_tmp___1 := -a_xtra
						else
							l_tmp___1 := a_xtra
						end
						if l_lnume + l_tmp___1 > globals_inst.curwin.item.w_cursor.lnum then
							globals_inst.last_cursormoved.lnum := (0).to_integer_32
						end
					end
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	unchanged (a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_ff: INTEGER_32)
		local
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not ((a_buf___6.item.b_changed).to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 3 then -- else:
						if not (a_ff.to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if not ((option_inst.file_ff_differs (a_buf___6)).to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						a_buf___6.item.b_changed := 0
						memline_inst.ml_setflags (a_buf___6)
						if a_ff.to_boolean then
							option_inst.save_file_ff (a_buf___6)
						end
						check_status (a_buf___6)
						globals_inst.redraw_tabline := 1
						globals_inst.need_maketitle := 1
				when 6 then -- if done | if done
						a_buf___6.item.b_changedtick := (a_buf___6.item.b_changedtick) + 1
						netbeans_inst.netbeans_unmodified (a_buf___6)
				when 7 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	check_status (a_buf___6: CE_POINTER [PD_FILE_BUFFER])
		local
			l_wp___0: CE_POINTER [PD_WINDOW_S]
		do
			create l_wp___0.make

			l_wp___0.ce_gets (globals_inst.firstwin)
			from
			until
				(l_wp___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32
			loop
				if ((l_wp___0.item.w_buffer).c_pointer.to_integer_32).to_natural_32 = (a_buf___6.c_pointer.to_integer_32).to_natural_32 then
					if (l_wp___0.item.w_status_height).to_boolean then
						l_wp___0.item.w_redr_status := 1
						if globals_inst.must_redraw < 10 then
							globals_inst.must_redraw := 10
						end
					end
				end
				l_wp___0.ce_gets (l_wp___0.item.w_next)
			end
		end

	change_warning (a_col: INTEGER_32)
		local
			js: JUMP_STATE
		do
			if globals_inst.curbuf.item.b_did_warn = 0 then
				if (undo_inst.curbufIsChanged) = 0 then
					if not globals_inst.autocmd_busy.to_boolean then
						if (globals_inst.curbuf.item.b_p_ro).to_boolean then
							globals_inst.curbuf_lock := globals_inst.curbuf_lock + 1
							fileio_inst.apply_autocmds ({PC_AUTO_EVENT}.EVENT_FILECHANGEDRO, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 0, globals_inst.curbuf).do_nothing
							globals_inst.curbuf_lock := globals_inst.curbuf_lock - 1
							if not (globals_inst.curbuf.item.b_p_ro).to_boolean then
								js.return
							end
							if not js.return_called then
								message_inst.msg_start
								if globals_inst.msg_row.to_integer_32 = globals_inst.Rows - 1 then
									globals_inst.msg_col := a_col
								end
								message_inst.msg_source (globals_inst.highlight_attr[17])
								message_inst.msg_puts_attr (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (w_readonly))), (globals_inst.highlight_attr[17]).bit_or (4096))
								eval_inst.set_vim_var_string (4, create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (w_readonly))), -1)
								message_inst.msg_clr_eos
								message_inst.msg_end.do_nothing
								if globals_inst.msg_silent = 0 then
									if not globals_inst.silent_mode.to_boolean then
										term_inst.out_flush
										ui_inst.ui_delay (1000, 1)
									end
								end
								globals_inst.curbuf.item.b_did_warn := 1
								globals_inst.redraw_cmdline := 0
								if globals_inst.msg_row.to_integer_32 < globals_inst.Rows - 1 then
									screen_inst.showmode.do_nothing
								end
							end
						end
					end
				end
			end
			if not js.return_called then
			end
		end

	ask_yesno (a_str___1: CE_POINTER [NATURAL_8]; a_direct: INTEGER_32): INTEGER_32
		local
			l_r: INTEGER_32
			l_save_State: INTEGER_32
			js: JUMP_STATE
		do
			l_r := (' ').code
			l_save_State := globals_inst.State
			if globals_inst.exiting.to_boolean then
				term_inst.settmode (2)
			end
			globals_inst.no_wait_return := globals_inst.no_wait_return + 1
			globals_inst.dont_scroll := 1
			globals_inst.State := 2048
			term_inst.setmouse
			globals_inst.no_mapping := globals_inst.no_mapping + 1
			globals_inst.allow_keys := globals_inst.allow_keys + 1
			from
			until
				js.loop_left
			loop
				js.reset
				if l_r /= 121 then
					if l_r = 110 then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					message_inst.smsg_attr ([globals_inst.highlight_attr[10], create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%%s (y/n)?")), a_str___1]).do_nothing
					if a_direct.to_boolean then
						l_r := get_keystroke
					else
						l_r := getchar_inst.plain_vgetc
					end
					if l_r = 3 then
						l_r := ('n').code
					elseif l_r = 27 then
						l_r := ('n').code
					end
					message_inst.msg_putchar (l_r)
					term_inst.out_flush
				end
			end
			js.reset
			globals_inst.no_wait_return := globals_inst.no_wait_return - 1
			globals_inst.State := l_save_State
			term_inst.setmouse
			globals_inst.no_mapping := globals_inst.no_mapping - 1
			globals_inst.allow_keys := globals_inst.allow_keys - 1
			Result := l_r
		end

	get_keystroke: INTEGER_32
		local
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_len: INTEGER_32
			l_n: INTEGER_32
			l_save_mapped_ctrl_c: INTEGER_32
			l_waited: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_buf___6.make (<<151>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_len := 0
					l_save_mapped_ctrl_c := globals_inst.mapped_ctrl_c
					l_waited := 0
					globals_inst.mapped_ctrl_c := 0
				when 1 then -- loop condition:
					if js.loop_left then
						l_pos := -1 + 77 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						term_inst.cursor_on
						term_inst.out_flush
						if l_len = 0 then
							l_tmp := -1
						else
							l_tmp := 100
						end
						l_n := ui_inst.ui_inchar (l_buf___6 + l_len, (145 - l_len) // 3, l_tmp, 0)
						if l_n > 0 then
							l_n := getchar_inst.fix_input_buffer (l_buf___6 + l_len, l_n, 0)
							l_len := l_len + l_n
							l_waited := 0
						elseif l_len > 0 then
							l_waited := l_waited + 1
						end
						l_n := term_inst.check_termcode (1, l_buf___6, l_len)
						if l_n < 0 then
							if not option_inst.p_ttimeout.to_boolean then
								js.continue
							else
								if option_inst.p_ttm < 0 then
									l_tmp___0 := option_inst.p_tm
								else
									l_tmp___0 := option_inst.p_ttm
								end
								if l_waited.to_integer_32 * 100 < l_tmp___0 then
									js.continue
								end
							end
						end
						if not js.loop_jumped then
							if l_n > 0 then
								l_len := l_n
							end
							if l_len = 0 then
								js.continue
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 76 -- skip if block
						end
				when 3 then -- if:
						l_n := (l_buf___6[0]).to_integer_32
						if l_n /= 128 then
							l_pos := -1 + 76 -- skip if block
						end
				when 4 then -- if:
						if (l_buf___6[1]).to_integer_32 = 254 then
							l_n := 128
						else
							if (l_buf___6[1]).to_integer_32 = 255 then
								l_tmp___1 := -(255 + ((88).bit_shift_left (8)))
							else
								l_tmp___1 := -((l_buf___6[1]).to_integer_32 + (((l_buf___6[2]).to_integer_32).bit_shift_left (8)))
							end
							l_n := l_tmp___1
						end
						if (l_buf___6[1]).to_integer_32 /= 252 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 74 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 75
				when 7 then -- else:
						if l_n /= -(253 + ((53).bit_shift_left (8))) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 74 -- goto _L
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 75
				when 10 then -- else:
						if l_n /= -(253 + ((69).bit_shift_left (8))) then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_pos := -1 + 74 -- goto _L
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 75
				when 13 then -- else:
						if l_n /= -(253 + ((45).bit_shift_left (8))) then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_pos := -1 + 74 -- goto _L
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 75
				when 16 then -- else:
						if l_n /= -(253 + ((46).bit_shift_left (8))) then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						l_pos := -1 + 74 -- goto _L
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 75
				when 19 then -- else:
						if l_n /= -(253 + ((70).bit_shift_left (8))) then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						l_pos := -1 + 74 -- goto _L
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 75
				when 22 then -- else:
						if l_n /= -(253 + ((47).bit_shift_left (8))) then
							l_pos := -1 + 25 -- skip if block
						end
				when 23 then -- if:
						l_pos := -1 + 74 -- goto _L
				when 24 then -- if block done, skip else block:
						l_pos := -1 + 75
				when 25 then -- else:
						if l_n /= -(253 + ((48).bit_shift_left (8))) then
							l_pos := -1 + 28 -- skip if block
						end
				when 26 then -- if:
						l_pos := -1 + 74 -- goto _L
				when 27 then -- if block done, skip else block:
						l_pos := -1 + 75
				when 28 then -- else:
						if l_n /= -(253 + ((49).bit_shift_left (8))) then
							l_pos := -1 + 31 -- skip if block
						end
				when 29 then -- if:
						l_pos := -1 + 74 -- goto _L
				when 30 then -- if block done, skip else block:
						l_pos := -1 + 75
				when 31 then -- else:
						if l_n /= -(253 + ((50).bit_shift_left (8))) then
							l_pos := -1 + 34 -- skip if block
						end
				when 32 then -- if:
						l_pos := -1 + 74 -- goto _L
				when 33 then -- if block done, skip else block:
						l_pos := -1 + 75
				when 34 then -- else:
						if l_n /= -(253 + ((51).bit_shift_left (8))) then
							l_pos := -1 + 37 -- skip if block
						end
				when 35 then -- if:
						l_pos := -1 + 74 -- goto _L
				when 36 then -- if block done, skip else block:
						l_pos := -1 + 75
				when 37 then -- else:
						if l_n /= -(253 + ((52).bit_shift_left (8))) then
							l_pos := -1 + 40 -- skip if block
						end
				when 38 then -- if:
						l_pos := -1 + 74 -- goto _L
				when 39 then -- if block done, skip else block:
						l_pos := -1 + 75
				when 40 then -- else:
						if l_n /= -(253 + ((75).bit_shift_left (8))) then
							l_pos := -1 + 43 -- skip if block
						end
				when 41 then -- if:
						l_pos := -1 + 74 -- goto _L
				when 42 then -- if block done, skip else block:
						l_pos := -1 + 75
				when 43 then -- else:
						if l_n /= -(253 + ((76).bit_shift_left (8))) then
							l_pos := -1 + 46 -- skip if block
						end
				when 44 then -- if:
						l_pos := -1 + 74 -- goto _L
				when 45 then -- if block done, skip else block:
						l_pos := -1 + 75
				when 46 then -- else:
						if l_n /= -(253 + ((77).bit_shift_left (8))) then
							l_pos := -1 + 49 -- skip if block
						end
				when 47 then -- if:
						l_pos := -1 + 74 -- goto _L
				when 48 then -- if block done, skip else block:
						l_pos := -1 + 75
				when 49 then -- else:
						if l_n /= -(253 + ((78).bit_shift_left (8))) then
							l_pos := -1 + 52 -- skip if block
						end
				when 50 then -- if:
						l_pos := -1 + 74 -- goto _L
				when 51 then -- if block done, skip else block:
						l_pos := -1 + 75
				when 52 then -- else:
						if l_n /= -(253 + ((89).bit_shift_left (8))) then
							l_pos := -1 + 55 -- skip if block
						end
				when 53 then -- if:
						l_pos := -1 + 74 -- goto _L
				when 54 then -- if block done, skip else block:
						l_pos := -1 + 75
				when 55 then -- else:
						if l_n /= -(253 + ((90).bit_shift_left (8))) then
							l_pos := -1 + 58 -- skip if block
						end
				when 56 then -- if:
						l_pos := -1 + 74 -- goto _L
				when 57 then -- if block done, skip else block:
						l_pos := -1 + 75
				when 58 then -- else:
						if l_n /= -(253 + ((91).bit_shift_left (8))) then
							l_pos := -1 + 61 -- skip if block
						end
				when 59 then -- if:
						l_pos := -1 + 74 -- goto _L
				when 60 then -- if block done, skip else block:
						l_pos := -1 + 75
				when 61 then -- else:
						if l_n /= -(253 + ((92).bit_shift_left (8))) then
							l_pos := -1 + 64 -- skip if block
						end
				when 62 then -- if:
						l_pos := -1 + 74 -- goto _L
				when 63 then -- if block done, skip else block:
						l_pos := -1 + 75
				when 64 then -- else:
						if l_n /= -(253 + ((93).bit_shift_left (8))) then
							l_pos := -1 + 67 -- skip if block
						end
				when 65 then -- if:
						l_pos := -1 + 74 -- goto _L
				when 66 then -- if block done, skip else block:
						l_pos := -1 + 75
				when 67 then -- else:
						if l_n /= -(253 + ((94).bit_shift_left (8))) then
							l_pos := -1 + 70 -- skip if block
						end
				when 68 then -- if:
						l_pos := -1 + 74 -- goto _L
				when 69 then -- if block done, skip else block:
						l_pos := -1 + 75
				when 70 then -- else:
						if l_n /= -(249 + ((88).bit_shift_left (8))) then
							l_pos := -1 + 73 -- skip if block
						end
				when 71 then -- if:
						l_pos := -1 + 74 -- goto _L
				when 72 then -- if block done, skip else block:
						l_pos := -1 + 75
				when 73 then -- else:
						if l_n /= -(248 + ((88).bit_shift_left (8))) then
							l_pos := -1 + 75 -- skip if block
						end
				when 74 then -- if: | _L:
						if (l_buf___6[1]).to_integer_32 = 252 then
							globals_inst.mod_mask := (l_buf___6[2]).to_integer_32
						end
						l_len := l_len - (3)
						if l_len > 0 then
							memmove (create {CE_POINTER [ANY]}.make_cast (l_buf___6), create {CE_POINTER [ANY]}.make_cast ((l_buf___6 + 3)), l_len.to_natural_32).do_nothing
						end
						js.continue
				when 75 then -- if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done
						if not js.loop_jumped then
							js.break
						end
				when 76 then -- if done | if done
						if not js.loop_jumped and then (globals_inst.has_mbyte.to_boolean) then
							if (globals_inst.mb_bytelen_tab[l_n]).to_integer_32 > l_len then
								js.continue
							end
							if not js.loop_jumped then
								if l_len >= 151 then
									l_tmp___2 := 150
								else
									l_tmp___2 := l_len
								end
								l_buf___6[l_tmp___2] := (('%/0/').code).to_natural_8
								l_n := globals_inst.mb_ptr2char.integer_32_item ([l_buf___6])
							end
						end
						if not js.loop_jumped then
							if l_n = globals_inst.intr_char then
								l_n := ('%/27/').code
							end
							js.break
						end
						if not js.loop_left then
							
						end
						l_pos := -1 + 1 -- back to loop condition
				when 77 then -- loop done
					js.reset
					globals_inst.mapped_ctrl_c := l_save_mapped_ctrl_c
					Result := l_n
				when 78 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_number (a_colon: INTEGER_32; a_mouse_used: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_n: INTEGER_32
			l_c: INTEGER_32
			l_typed: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_n := 0
					l_typed := 0
					if (a_mouse_used.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						a_mouse_used.item := 0
					end
					if globals_inst.msg_silent /= 0 then
						Result := 0
						js.return
					end
					if js.return_called then
						l_pos := -1 + 27 -- skip if block
					end
				when 1 then -- if:
						globals_inst.dont_scroll := 1
						globals_inst.no_mapping := globals_inst.no_mapping + 1
						globals_inst.allow_keys := globals_inst.allow_keys + 1
				when 2 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 26 -- skip loop
						end
				when 3 then -- loop body:
						js.reset
						screen_inst.windgoto (globals_inst.msg_row, globals_inst.msg_col)
						l_c := getchar_inst.safe_vgetc
						if not (l_c >= 48) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if l_c <= 57 then
							l_n := (l_n * 10 + l_c) - 48
							message_inst.msg_putchar (l_c)
							l_typed := l_typed + 1
						else
							l_pos := -1 + 6 -- goto _L___3
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 6 then -- else: | _L___3:
						if l_c /= -(107 + ((68).bit_shift_left (8))) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 16 -- goto _L___2
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 9 then -- else:
						if l_c /= -(253 + ((80).bit_shift_left (8))) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_pos := -1 + 16 -- goto _L___2
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 12 then -- else:
						if l_c /= -(107 + ((98).bit_shift_left (8))) then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						l_pos := -1 + 16 -- goto _L___2
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 15 then -- else:
						if l_c /= 8 then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if: | _L___2:
						if l_typed > 0 then
							message_inst.msg_puts (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%B %B")))
							l_typed := l_typed - 1
						end
						l_n := l_n // (10)
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 18 then -- else:
						if (a_mouse_used.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						if l_c = -(253 + ((44).bit_shift_left (8))) then
							a_mouse_used.item := 1
							l_n := globals_inst.mouse_row + 1
							js.break
						else
							l_pos := -1 + 21 -- goto _L___1
						end
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 21 then -- else: | _L___1:
						if l_n /= 0 then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if:
						if l_c = 58 then
							if a_colon.to_boolean then
								getchar_inst.stuffcharReadbuff ((':').code)
								if not globals_inst.exmode_active.to_boolean then
									globals_inst.cmdline_row := globals_inst.msg_row
								end
								globals_inst.skip_redraw := 1
								globals_inst.do_redraw := 0
								js.break
							else
								l_pos := -1 + 24 -- goto _L___0
							end
						else
							l_pos := -1 + 24 -- goto _L___0
						end
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 24 then -- else: | _L___0:
						if l_c = 13 then
							js.break
						elseif l_c = 10 then
							js.break
						elseif l_c = 3 then
							js.break
						elseif l_c = 27 then
							js.break
						end
				when 25 then -- if done | if done | if done | if done | if done | if done
						l_pos := -1 + 2 -- back to loop condition
				when 26 then -- loop done
						js.reset
						globals_inst.no_mapping := globals_inst.no_mapping - 1
						globals_inst.allow_keys := globals_inst.allow_keys - 1
						Result := l_n
				when 27 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	prompt_for_number (a_mouse_used: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_save_cmdline_row: INTEGER_32
			l_save_State: INTEGER_32
		do
			if (a_mouse_used.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				message_inst.msg_puts (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Type number and <Enter> or click with mouse (empty cancels): ")))))
			else
				message_inst.msg_puts (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Type number and <Enter> (empty cancels): ")))))
			end
			l_save_cmdline_row := globals_inst.cmdline_row
			globals_inst.cmdline_row := 0
			l_save_State := globals_inst.State
			globals_inst.State := 8
			l_i___0 := get_number (1, a_mouse_used)
			if globals_inst.KeyTyped.to_boolean then
				globals_inst.cmdline_row := globals_inst.msg_row - 1
				globals_inst.need_wait_return := 0
				globals_inst.msg_didany := 0
				globals_inst.msg_didout := 0
			else
				globals_inst.cmdline_row := l_save_cmdline_row
			end
			globals_inst.State := l_save_State
			Result := l_i___0
		end

	msgmore (a_n: INTEGER_32)
		local
			l_pn: INTEGER_32
			js: JUMP_STATE
		do
			if globals_inst.global_busy.to_boolean then
				js.return
			elseif not (screen_inst.messaging).to_boolean then
				js.return
			end
			if not js.return_called and then ((globals_inst.keep_msg.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32) then
				if not globals_inst.keep_msg_more.to_boolean then
					js.return
				end
			end
			if not js.return_called then
				if a_n > 0 then
					l_pn := a_n
				else
					l_pn := -a_n
				end
				if l_pn > option_inst.p_report then
					if l_pn = 1 then
						if a_n > 0 then
							strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.msg_buf), (gettext (ce_string ("1 more line")))).do_nothing
						else
							strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.msg_buf), (gettext (ce_string ("1 line less")))).do_nothing
						end
					elseif a_n > 0 then
						sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.msg_buf), (gettext (ce_string ("%%ld more lines"))), l_pn]).do_nothing
					else
						sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.msg_buf), (gettext (ce_string ("%%ld fewer lines"))), l_pn]).do_nothing
					end
					if globals_inst.got_int.to_boolean then
						strcat (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.msg_buf), (gettext (ce_string (" (Interrupted)")))).do_nothing
					end
					if (message_inst.msg (globals_inst.msg_buf)).to_boolean then
						message_inst.set_keep_msg (globals_inst.msg_buf, 0)
						globals_inst.keep_msg_more := 1
					end
				end
			end
		end

	beep_flush
		do
			if globals_inst.emsg_silent = 0 then
				getchar_inst.flush_buffers (0)
				vim_beep
			end
		end

	vim_beep
		do
			if globals_inst.emsg_silent = 0 then
				if option_inst.p_vb.to_boolean then
					if (gui_inst.gui.in_use).to_boolean then
						if (gui_inst.gui.starting).to_boolean then
							term_inst.out_char ((('%/7/').code).to_natural_32)
						else
							term_inst.out_str (term_inst.term_strings[30])
						end
					else
						term_inst.out_str (term_inst.term_strings[30])
					end
				else
					term_inst.out_char ((('%/7/').code).to_natural_32)
				end
				if ((misc2_inst.vim_strchr (option_inst.p_debug, ('e').code)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					message_inst.msg_source (globals_inst.highlight_attr[17])
					message_inst.msg_attr (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Beep!")))), globals_inst.highlight_attr[17]).do_nothing
				end
			end
		end

	init_homedir
		local
			l_var: CE_POINTER [NATURAL_8]
		do
			create l_var.make

			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (homedir))
			homedir.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
			l_var.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((getenv (ce_string ("HOME")))))
			if (l_var.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				if (l_var.item).to_integer_32 = 0 then
					l_var.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				end
			end
			if (l_var.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				if (os_unix_inst.mch_dirname (globals_inst.NameBuff, 4096)) = 1 then
					if (os_unix_inst.mch_chdir (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.NameBuff))) = 0 then
						if not (os_unix_inst.mch_chdir (create {CE_POINTER [INTEGER_8]}.make_cast (l_var))).to_boolean then
							if (os_unix_inst.mch_dirname (globals_inst.IObuff, 1025)) = 1 then
								l_var.ce_gets (globals_inst.IObuff)
							end
						end
						if (os_unix_inst.mch_chdir (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.NameBuff))) /= 0 then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_prev_dir))))).do_nothing
						end
					end
				end
				homedir.ce_gets (misc2_inst.vim_strsave (l_var))
			end
		end

	expand_env_save (a_src: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		do
			Result := (expand_env_save_opt (a_src, 0))
		end

	expand_env_save_opt (a_src: CE_POINTER [NATURAL_8]; a_one: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_p___0: CE_POINTER [NATURAL_8]
		do
			create l_p___0.make

			l_p___0.ce_gets (misc2_inst.alloc ({NATURAL_32} 4096))
			if (l_p___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				expand_env_esc (a_src, l_p___0, 4096, 0, a_one, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
			end
			Result := l_p___0
		end

	expand_env (a_src: CE_POINTER [NATURAL_8]; a_dst: CE_POINTER [NATURAL_8]; a_dstlen: INTEGER_32)
		do
			expand_env_esc (a_src, a_dst, a_dstlen, 0, 0, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
		end

	expand_env_esc (a_srcp: CE_POINTER [NATURAL_8]; a_dst: CE_POINTER [NATURAL_8]; a_dstlen: INTEGER_32; a_esc: INTEGER_32; a_one: INTEGER_32; a_startstr: CE_POINTER [NATURAL_8])
		local
			l_dst: CE_POINTER [NATURAL_8]
			l_dstlen: INTEGER_32
			l_src: CE_POINTER [NATURAL_8]
			l_tail: CE_POINTER [NATURAL_8]
			l_c: INTEGER_32
			l_var: CE_POINTER [NATURAL_8]
			l_copy_char___0: INTEGER_32
			l_mustfree: INTEGER_32
			l_at_start___0: INTEGER_32
			l_startstr_len: INTEGER_32
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___2: INTEGER_32
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_tmp___4: CE_POINTER [NATURAL_8]
			l_tmp___5: INTEGER_32
			l_tmp___8: CE_POINTER [NATURAL_8]
			l_tmp___9: CE_POINTER [NATURAL_8]
			l_tmp___10: INTEGER_32
			l_pw: CE_POINTER [SD_PASSWD]
			l_xpc: PD_EXPAND
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp___21: NATURAL_32
			l_tmp___23: CE_POINTER [NATURAL_8]
			l_tmp___24: CE_POINTER [NATURAL_8]
			l_tmp___25: CE_POINTER [NATURAL_8]
			l_tmp___26: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_dst.make
			create l_src.make
			create l_tail.make
			create l_var.make
			create l_tmp___0.make
			create l_tmp___1.make
			create l_tmp___3.make
			create l_tmp___4.make
			create l_tmp___8.make
			create l_tmp___9.make
			create l_pw.make
			create l_xpc.make
			create l_p___0.make
			create l_tmp___23.make
			create l_tmp___24.make
			create l_tmp___25.make
			create l_tmp___26.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_dst.ce_gets (a_dst)
					l_dstlen := a_dstlen
					l_at_start___0 := 1
					l_startstr_len := 0
					if (a_startstr.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						l_startstr_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_startstr))).to_integer_32
					end
					l_src.ce_gets (charset_inst.skipwhite (a_srcp))
					l_dstlen := l_dstlen - 1
				when 1 then -- loop condition:
					if js.loop_left then
						l_pos := -1 + 31 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						if (l_src.item).to_boolean then
							if not (l_dstlen > 0) then
								js.break
							end
						else
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 30 -- skip if block
						end
				when 3 then -- if:
						l_copy_char___0 := 1
						if (l_src.item).to_integer_32 /= 36 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 8 -- goto _L___1
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 6 then -- else:
						if (l_src.item).to_integer_32 /= 126 then
							l_pos := -1 + 20 -- skip if block
						end
				when 7 then -- if:
						if not (l_at_start___0.to_boolean) then
							l_pos := -1 + 20 -- skip if block
						end
				when 8 then -- if: | _L___1:
						l_mustfree := 0
						if (l_src.item).to_integer_32 = 126 then
							l_pos := -1 + 18 -- skip if block
						end
				when 9 then -- if:
						l_tail.ce_gets (l_src + 1)
						l_var.ce_gets (l_dst)
						l_c := l_dstlen - 1
						if (l_tail.item).to_integer_32 /= 123 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						if (charset_inst.vim_isIDc (('{').code)).to_boolean then
							l_pos := -1 + 12 -- goto _L
						else
							l_tail.ce_gets (l_tail + 1)
							from
							until
								js.loop_left
							loop
								js.reset
								l_tmp___2 := l_c
								l_c := l_c - 1
								if l_tmp___2 > 0 then
									if (l_tail.item).to_boolean then
										if (l_tail.item).to_integer_32 = 125 then
											js.break
										end
									else
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped then
									l_tmp___0.ce_gets (l_var)
									l_var.ce_gets (l_var + 1)
									l_tmp___1.ce_gets (l_tail)
									l_tail.ce_gets (l_tail + 1)
									l_tmp___0.item := l_tmp___1.item
								end
							end
							js.reset
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							l_tmp___5 := l_c
							l_c := l_c - 1
							if l_tmp___5 > 0 then
								if (l_tail.item).to_integer_32 /= 0 then
									if not (charset_inst.vim_isIDc ((l_tail.item).to_integer_32)).to_boolean then
										js.break
									end
								else
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_tmp___3.ce_gets (l_var)
								l_var.ce_gets (l_var + 1)
								l_tmp___4.ce_gets (l_tail)
								l_tail.ce_gets (l_tail + 1)
								l_tmp___3.item := l_tmp___4.item
							end
						end
						js.reset
				when 13 then
						if (l_src[1]).to_integer_32 /= 123 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						if (l_tail.item).to_integer_32 /= 125 then
							l_var.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						else
							l_pos := -1 + 16 -- goto _L___0
						end
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 16 then -- else: | _L___0:
						if (l_src[1]).to_integer_32 = 123 then
							l_tail.ce_gets (l_tail + 1)
						end
						l_var.item := (('%/0/').code).to_natural_8
						l_var.ce_gets (vim_getenv (l_dst, create {CE_POINTER [INTEGER_32]}.make_shared ($l_mustfree)))
				when 17 then -- if done | if block done, skip else block:
						l_pos := -1 + 19
				when 18 then -- else:
						if (l_src[1]).to_integer_32 = 0 then
							l_var.ce_gets (homedir)
							l_tail.ce_gets (l_src + 1)
						elseif (vim_ispathsep ((l_src[1]).to_integer_32)).to_boolean then
							l_var.ce_gets (homedir)
							l_tail.ce_gets (l_src + 1)
						elseif ((misc2_inst.vim_strchr (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ,%T%N")), (l_src[1]).to_integer_32)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_var.ce_gets (homedir)
							l_tail.ce_gets (l_src + 1)
						else
							l_tail.ce_gets (l_src)
							l_var.ce_gets (l_dst)
							l_c := l_dstlen - 1
							from
							until
								js.loop_left
							loop
								js.reset
								l_tmp___10 := l_c
								l_c := l_c - 1
								if l_tmp___10 > 0 then
									if (l_tail.item).to_boolean then
										if (charset_inst.vim_isfilec ((l_tail.item).to_integer_32)).to_boolean then
											if (vim_ispathsep ((l_tail.item).to_integer_32)).to_boolean then
												js.break
											end
										else
											js.break
										end
									else
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped then
									l_tmp___8.ce_gets (l_var)
									l_var.ce_gets (l_var + 1)
									l_tmp___9.ce_gets (l_tail)
									l_tail.ce_gets (l_tail + 1)
									l_tmp___8.item := l_tmp___9.item
								end
							end
							js.reset
							l_var.item := (('%/0/').code).to_natural_8
							l_pw.ce_gets (getpwnam ((create {CE_POINTER [INTEGER_8]}.make_cast (l_dst) + 1)))
							if (l_pw.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								l_var.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (l_pw.item.pw_dir))
							else
								l_var.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							end
							if (l_var.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								ex_getln_inst.ExpandInit (l_xpc.address)
								l_xpc.xp_context := 2
								l_var.ce_gets (ex_getln_inst.ExpandOne (l_xpc.address, l_dst, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 80, 2))
								l_mustfree := 1
							end
						end
				when 19 then
						if a_esc.to_boolean then
							if (l_var.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								if ((strpbrk (create {CE_POINTER [INTEGER_8]}.make_cast (l_var), ce_string (" %T"))).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									l_p___0.ce_gets ((misc2_inst.vim_strsave_escaped (l_var, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" %T")))))
									if (l_p___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
										if l_mustfree.to_boolean then
											misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_var))
										end
										l_var.ce_gets (l_p___0)
										l_mustfree := 1
									end
								end
							end
						end
						if (l_var.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							if (l_var.item).to_integer_32 /= 0 then
								l_tmp___21 := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_var))
								if (l_tmp___21 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_tail)))) + {NATURAL_32} 1 < l_dstlen.to_natural_32 then
									strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_dst), create {CE_POINTER [INTEGER_8]}.make_cast (l_var)).do_nothing
									l_dstlen := l_dstlen - (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_var))).to_integer_32
									l_c := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_var))).to_integer_32
									if (l_var.item).to_integer_32 /= 0 then
										if (misc2_inst.after_pathsep (l_dst, l_dst + l_c)).to_boolean then
											if (vim_ispathsep ((l_tail.item).to_integer_32)).to_boolean then
												l_tail.ce_gets (l_tail + 1)
											end
										end
									end
									l_dst.ce_gets (l_dst + l_c)
									l_src.ce_gets (l_tail)
									l_copy_char___0 := 0
								end
							end
						end
						if l_mustfree.to_boolean then
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_var))
						end
				when 20 then -- if done | if done
						if not (l_copy_char___0.to_boolean) then
							l_pos := -1 + 30 -- skip if block
						end
				when 21 then -- if:
						l_at_start___0 := 0
						if (l_src[0]).to_integer_32 /= 92 then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if:
						if (l_src[1]).to_integer_32 /= 0 then
							l_tmp___23.ce_gets (l_dst)
							l_dst.ce_gets (l_dst + 1)
							l_tmp___24.ce_gets (l_src)
							l_src.ce_gets (l_src + 1)
							l_tmp___23.item := l_tmp___24.item
							l_dstlen := l_dstlen - 1
						else
							l_pos := -1 + 24 -- goto _L___3
						end
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 24 then -- else: | _L___3:
						if (l_src[0]).to_integer_32 /= 32 then
							l_pos := -1 + 27 -- skip if block
						end
				when 25 then -- if:
						l_pos := -1 + 28 -- goto _L___2
				when 26 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 27 then -- else:
						if (l_src[0]).to_integer_32 /= 44 then
							l_pos := -1 + 29 -- skip if block
						end
				when 28 then -- if: | _L___2:
						if not a_one.to_boolean then
							l_at_start___0 := 1
						end
				when 29 then -- if done | if done
						l_tmp___25.ce_gets (l_dst)
						l_dst.ce_gets (l_dst + 1)
						l_tmp___26.ce_gets (l_src)
						l_src.ce_gets (l_src + 1)
						l_tmp___25.item := l_tmp___26.item
						l_dstlen := l_dstlen - 1
						if (a_startstr.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							if ((l_src - l_startstr_len).c_pointer.to_integer_32).to_natural_32 >= (a_srcp.c_pointer.to_integer_32).to_natural_32 then
								if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast ((l_src - l_startstr_len)), create {CE_POINTER [INTEGER_8]}.make_cast (a_startstr), l_startstr_len.to_natural_32)) = 0 then
									l_at_start___0 := 1
								end
							end
						end
				when 30 then -- if done | if done
						l_pos := -1 + 1 -- back to loop condition
				when 31 then -- loop done
					js.reset
					l_dst.item := (('%/0/').code).to_natural_8
				when 32 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	vim_getenv (a_name___1: CE_POINTER [NATURAL_8]; a_mustfree: CE_POINTER [INTEGER_32]): CE_POINTER [NATURAL_8]
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_pend: CE_POINTER [NATURAL_8]
			l_vimruntime: INTEGER_32
			l_buf___6: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p___0.make
			create l_pend.make
			create l_buf___6.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p___0.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((getenv (create {CE_POINTER [INTEGER_8]}.make_cast (a_name___1)))))
					if (l_p___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						if (l_p___0.item).to_integer_32 = 0 then
							l_p___0.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						end
					end
					if (l_p___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						Result := l_p___0
						js.return
					end
					if not js.return_called then
						l_vimruntime := ((strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_name___1), ce_string ("VIMRUNTIME"))) = 0).to_integer
						if not l_vimruntime.to_boolean then
							if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_name___1), ce_string ("VIM"))) /= 0 then
								Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
								js.return
							end
						end
					end
					if js.return_called then
						l_pos := -1 + 7 -- skip if block
					end
				when 1 then -- if:
						if l_vimruntime.to_boolean then
							if (auto_pathdef_inst.default_vimruntime_dir.item).to_integer_32 = 0 then
								l_p___0.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((getenv (ce_string ("VIM")))))
								if (l_p___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									if (l_p___0.item).to_integer_32 = 0 then
										l_p___0.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
									end
								end
								if (l_p___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									l_p___0.ce_gets (vim_version_dir (l_p___0))
									if (l_p___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
										a_mustfree.item := 1
									else
										l_p___0.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((getenv (ce_string ("VIM")))))
									end
								end
							end
						end
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							if (option_inst.p_hf.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								if ((misc2_inst.vim_strchr (option_inst.p_hf, ('$').code)).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
									l_p___0.ce_gets (option_inst.p_hf)
								end
							end
							if (l_p___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								l_pend.ce_gets (gettail (l_p___0))
								if (l_p___0.c_pointer.to_integer_32).to_natural_32 = (option_inst.p_hf.c_pointer.to_integer_32).to_natural_32 then
									l_pend.ce_gets (remove_tail (l_p___0, l_pend, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("doc"))))
								end
								if not l_vimruntime.to_boolean then
									l_pend.ce_gets (remove_tail (l_p___0, l_pend, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("runtime"))))
									l_pend.ce_gets (remove_tail (l_p___0, l_pend, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("vim73"))))
								end
								if (l_pend.c_pointer.to_integer_32).to_natural_32 > (l_p___0.c_pointer.to_integer_32).to_natural_32 then
									if (misc2_inst.after_pathsep (l_p___0, l_pend)).to_boolean then
										l_pend.ce_gets (l_pend - 1)
									end
								end
								l_p___0.ce_gets (misc2_inst.vim_strnsave (l_p___0, l_pend.distance (l_p___0)))
								if (l_p___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									if (os_unix_inst.mch_isdir (l_p___0)).to_boolean then
										a_mustfree.item := 1
									else
										misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_p___0))
										l_p___0.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
									end
								else
									a_mustfree.item := 1
								end
							end
						end
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_pos := -1 + 6 -- skip if block
						end
				when 2 then -- if:
						if not (l_vimruntime.to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if (auto_pathdef_inst.default_vimruntime_dir.item).to_integer_32 /= 0 then
							l_p___0.ce_gets (auto_pathdef_inst.default_vimruntime_dir)
							a_mustfree.item := 0
						else
							l_pos := -1 + 5 -- goto _L
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 5 then -- else: | _L:
						if (auto_pathdef_inst.default_vim_dir.item).to_integer_32 /= 0 then
							if l_vimruntime.to_boolean then
								l_p___0.ce_gets (vim_version_dir (auto_pathdef_inst.default_vim_dir))
								if (l_p___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									a_mustfree.item := 1
								else
									l_p___0.ce_gets (auto_pathdef_inst.default_vim_dir)
									a_mustfree.item := 0
								end
							else
								l_p___0.ce_gets (auto_pathdef_inst.default_vim_dir)
								a_mustfree.item := 0
							end
						end
				when 6 then -- if done
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							if l_vimruntime.to_boolean then
								vim_setenv (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("VIMRUNTIME")), l_p___0)
								globals_inst.didset_vimruntime := 1
								l_buf___6.ce_gets ((concat_str (l_p___0, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("/lang")))))
								if (l_buf___6.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									bindtextdomain (ce_string ("vim"), create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6)).do_nothing
									misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_buf___6))
								end
							else
								vim_setenv (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("VIM")), l_p___0)
								globals_inst.didset_vim := 1
							end
						end
						Result := l_p___0
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	vim_version_dir (a_vimdir: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_p___0: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_p___0.make

			if (a_vimdir.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				js.return
			elseif (a_vimdir.item).to_integer_32 = 0 then
				Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				l_p___0.ce_gets (concat_fnames (a_vimdir, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("vim73")), 1))
				if (l_p___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					if (os_unix_inst.mch_isdir (l_p___0)).to_boolean then
						Result := l_p___0
						js.return
					end
				end
			end
			if not js.return_called then
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_p___0))
				l_p___0.ce_gets (concat_fnames (a_vimdir, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("runtime")), 1))
				if (l_p___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					if (os_unix_inst.mch_isdir (l_p___0)).to_boolean then
						Result := l_p___0
						js.return
					end
				end
			end
			if not js.return_called then
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_p___0))
				Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
			end
		end

	remove_tail (a_p___0: CE_POINTER [NATURAL_8]; a_pend: CE_POINTER [NATURAL_8]; a_name___1: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_len: INTEGER_32
			l_newend: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_newend.make

			l_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_name___1))).to_integer_32 + 1
			l_newend.ce_gets (a_pend - l_len)
			if (l_newend.c_pointer.to_integer_32).to_natural_32 >= (a_p___0.c_pointer.to_integer_32).to_natural_32 then
				if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_newend), create {CE_POINTER [INTEGER_8]}.make_cast (a_name___1), (l_len - 1).to_natural_32)) = 0 then
					if (l_newend.c_pointer.to_integer_32).to_natural_32 = (a_p___0.c_pointer.to_integer_32).to_natural_32 then
						Result := l_newend
						js.return
					elseif (misc2_inst.after_pathsep (a_p___0, l_newend)).to_boolean then
						Result := l_newend
						js.return
					end
				end
			end
			if not js.return_called then
				Result := a_pend
			end
		end

	vim_setenv (a_name___1: CE_POINTER [NATURAL_8]; a_val___0: CE_POINTER [NATURAL_8])
		do
			setenv (create {CE_POINTER [INTEGER_8]}.make_cast (a_name___1), create {CE_POINTER [INTEGER_8]}.make_cast (a_val___0), 1).do_nothing
		end

	get_env_name (a_xp: CE_POINTER [PD_EXPAND]; a_idx: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_str___1: CE_POINTER [NATURAL_8]
			l_n: INTEGER_32
			js: JUMP_STATE
		do
			create l_str___1.make

			l_str___1.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (environ[a_idx]))
			if (l_str___1.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				l_n := 0
				from
				until
					not (not js.loop_left and then (l_n < 99))
				loop
					js.reset
					if (l_str___1[l_n]).to_integer_32 = 61 then
						js.break
					elseif (l_str___1[l_n]).to_integer_32 = 0 then
						js.break
					end
					if not js.loop_jumped then
						name[l_n] := l_str___1[l_n]
						l_n := l_n + 1
					end
				end
				js.reset
				name[l_n] := (('%/0/').code).to_natural_8
				Result := name
			end
		end

	get_env_name_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent get_env_name)
		end

	home_replace (a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_src: CE_POINTER [NATURAL_8]; a_dst: CE_POINTER [NATURAL_8]; a_dstlen: INTEGER_32; a_one: INTEGER_32)
		local
			l_src: CE_POINTER [NATURAL_8]
			l_dst: CE_POINTER [NATURAL_8]
			l_dstlen: INTEGER_32
			l_dirlen: NATURAL_32
			l_envlen: NATURAL_32
			l_len: NATURAL_32
			l_homedir_env: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_tmp___6: CE_POINTER [NATURAL_8]
			l_tmp___7: CE_POINTER [NATURAL_8]
			l_tmp___8: CE_POINTER [NATURAL_8]
			l_tmp___9: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_src.make
			create l_dst.make
			create l_homedir_env.make
			create l_p___0.make
			create l_tmp___1.make
			create l_tmp___2.make
			create l_tmp___6.make
			create l_tmp___7.make
			create l_tmp___8.make
			create l_tmp___9.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_src.ce_gets (a_src)
					l_dst.ce_gets (a_dst)
					l_dstlen := a_dstlen
					l_dirlen := (0).to_natural_32
					l_envlen := (0).to_natural_32
					if (l_src.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						l_dst.item := (('%/0/').code).to_natural_8
						js.return
					end
					if not js.return_called and then ((a_buf___6.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32) then
						if (a_buf___6.item.b_help).to_boolean then
							strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_dst), create {CE_POINTER [INTEGER_8]}.make_cast ((gettail (l_src)))).do_nothing
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 46 -- skip if block
					end
				when 1 then -- if:
						if (homedir.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_dirlen := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (homedir))
						end
						l_homedir_env.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((getenv (ce_string ("HOME")))))
						if (l_homedir_env.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							if (l_homedir_env.item).to_integer_32 = 0 then
								l_homedir_env.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							end
						end
						if (l_homedir_env.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_envlen := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_homedir_env))
						end
						if not a_one.to_boolean then
							l_src.ce_gets (charset_inst.skipwhite (l_src))
						end
				when 2 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 45 -- skip loop
						end
				when 3 then -- loop body:
						js.reset
						if (l_src.item).to_boolean then
							if not (l_dstlen > 0) then
								js.break
							end
						else
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 44 -- skip if block
						end
				when 4 then -- if:
						l_p___0.ce_gets (homedir)
						l_len := l_dirlen
				when 5 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 17 -- skip loop
						end
				when 6 then -- loop body:
						js.reset
						if not (l_len.to_boolean) then
							l_pos := -1 + 16 -- skip if block
						end
				when 7 then -- if:
						if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_src), create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), l_len)) /= 0 then
							l_pos := -1 + 16 -- skip if block
						end
				when 8 then -- if:
						if not ((vim_ispathsep ((l_src[l_len.to_integer_32]).to_integer_32)).to_boolean) then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						l_pos := -1 + 15 -- goto _L
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 11 then -- else:
						if a_one.to_boolean then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:
						if (l_src[l_len.to_integer_32]).to_integer_32 = 44 then
							l_pos := -1 + 15 -- goto _L
						elseif (l_src[l_len.to_integer_32]).to_integer_32 = 32 then
							l_pos := -1 + 15 -- goto _L
						else
							l_pos := -1 + 14 -- goto _L___0
						end
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 14 then -- else: | _L___0:
						if (l_src[l_len.to_integer_32]).to_integer_32 /= 0 then
							l_pos := -1 + 16 -- skip if block
						end
				when 15 then -- if: | _L:
						l_src.ce_gets (l_src + l_len.to_integer_32)
						l_dstlen := l_dstlen - 1
						if l_dstlen > 0 then
							l_tmp___1.ce_gets (l_dst)
							l_dst.ce_gets (l_dst + 1)
							l_tmp___1.item := (('~').code).to_natural_8
						end
						if not (vim_ispathsep ((l_src[0]).to_integer_32)).to_boolean then
							l_dstlen := l_dstlen - 1
							if l_dstlen > 0 then
								l_tmp___2.ce_gets (l_dst)
								l_dst.ce_gets (l_dst + 1)
								l_tmp___2.item := (('/').code).to_natural_8
							end
						end
						js.break
				when 16 then -- if done | if done | if done | if done
						if not js.loop_jumped and then ((l_p___0.c_pointer.to_integer_32).to_natural_32 = (l_homedir_env.c_pointer.to_integer_32).to_natural_32) then
							js.break
						end
						if not js.loop_jumped then
							l_p___0.ce_gets (l_homedir_env)
							l_len := l_envlen
						end
						l_pos := -1 + 5 -- back to loop condition
				when 17 then -- loop done
						js.reset
				when 18 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 33 -- skip loop
						end
				when 19 then -- loop body:
						js.reset
						if not ((l_src.item).to_boolean) then
							l_pos := -1 + 31 -- skip if block
						end
				when 20 then -- if:
						if not (a_one.to_boolean) then
							l_pos := -1 + 23 -- skip if block
						end
				when 21 then -- if:
						l_pos := -1 + 25 -- goto _L___1
				when 22 then -- if block done, skip else block:
						l_pos := -1 + 30
				when 23 then -- else:
						if (l_src.item).to_integer_32 = 44 then
							l_pos := -1 + 29 -- skip if block
						end
				when 24 then -- if:
						if (l_src.item).to_integer_32 = 32 then
							l_pos := -1 + 27 -- skip if block
						end
				when 25 then -- if: | _L___1:
						l_dstlen := l_dstlen - 1
						if not (l_dstlen > 0) then
							js.break
						end
				when 26 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 27 then -- else:
						js.break
				when 28 then -- if done | if block done, skip else block:
						l_pos := -1 + 30
				when 29 then -- else:
						js.break
				when 30 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 32
				when 31 then -- else:
						js.break
				when 32 then
						if not js.loop_jumped then
							l_tmp___6.ce_gets (l_dst)
							l_dst.ce_gets (l_dst + 1)
							l_tmp___7.ce_gets (l_src)
							l_src.ce_gets (l_src + 1)
							l_tmp___6.item := l_tmp___7.item
						end
						l_pos := -1 + 18 -- back to loop condition
				when 33 then -- loop done
						js.reset
				when 34 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 43 -- skip loop
						end
				when 35 then -- loop body:
						js.reset
						if (l_src.item).to_integer_32 /= 32 then
							l_pos := -1 + 38 -- skip if block
						end
				when 36 then -- if:
						l_pos := -1 + 39 -- goto _L___2
				when 37 then -- if block done, skip else block:
						l_pos := -1 + 42
				when 38 then -- else:
						if (l_src.item).to_integer_32 /= 44 then
							l_pos := -1 + 41 -- skip if block
						end
				when 39 then -- if: | _L___2:
						l_dstlen := l_dstlen - 1
						if not (l_dstlen > 0) then
							js.break
						end
				when 40 then -- if block done, skip else block:
						l_pos := -1 + 42
				when 41 then -- else:
						js.break
				when 42 then -- if done
						if not js.loop_jumped then
							l_tmp___8.ce_gets (l_dst)
							l_dst.ce_gets (l_dst + 1)
							l_tmp___9.ce_gets (l_src)
							l_src.ce_gets (l_src + 1)
							l_tmp___8.item := l_tmp___9.item
						end
						l_pos := -1 + 34 -- back to loop condition
				when 43 then -- loop done
						js.reset
				when 44 then -- if done
						l_pos := -1 + 2 -- back to loop condition
				when 45 then -- loop done
						js.reset
						l_dst.item := (('%/0/').code).to_natural_8
				when 46 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	home_replace_save (a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_src: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_dst: CE_POINTER [NATURAL_8]
			l_len: NATURAL_32
		do
			create l_dst.make

			l_len := {NATURAL_32} 3
			if (a_src.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				l_len := l_len + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_src)))
			end
			l_dst.ce_gets (misc2_inst.alloc (l_len))
			if (l_dst.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				home_replace (a_buf___6, a_src, l_dst, l_len.to_integer_32, 1)
			end
			Result := l_dst
		end

	fullpathcmp (a_s1: CE_POINTER [NATURAL_8]; a_s2: CE_POINTER [NATURAL_8]; a_checkname: INTEGER_32): INTEGER_32
		local
			l_exp1: CE_ARRAY [NATURAL_8]
			l_full1: CE_ARRAY [NATURAL_8]
			l_full2: CE_ARRAY [NATURAL_8]
			l_st1: SD_STAT
			l_st2: SD_STAT
			l_r1: INTEGER_32
			l_r2: INTEGER_32
			js: JUMP_STATE
		do
			create l_exp1.make (<<4096>>)
			create l_full1.make (<<4096>>)
			create l_full2.make (<<4096>>)
			create l_st1.make
			create l_st2.make

			expand_env (a_s1, l_exp1, 4096)
			l_r1 := stat (create {CE_POINTER [INTEGER_8]}.make_cast (l_exp1), (l_st1.address))
			l_r2 := stat (create {CE_POINTER [INTEGER_8]}.make_cast (a_s2), (l_st2.address))
			if l_r1 /= 0 then
				if l_r2 /= 0 then
					if a_checkname.to_boolean then
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_exp1), create {CE_POINTER [INTEGER_8]}.make_cast (a_s2))) = 0 then
							Result := 7
							js.return
						end
						if not js.return_called then
							l_r1 := window_inst.vim_FullName (l_exp1, l_full1, 4096, 0)
							l_r2 := window_inst.vim_FullName (a_s2, l_full2, 4096, 0)
							if l_r1 = 1 then
								if l_r2 = 1 then
									if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_full1), create {CE_POINTER [INTEGER_8]}.make_cast (l_full2))) = 0 then
										Result := 7
										js.return
									end
								end
							end
						end
					end
					if not js.return_called then
						Result := 4
						js.return
					end
				end
			end
			if not js.return_called then
				if l_r1 /= 0 then
					Result := 6
					js.return
				elseif l_r2 /= 0 then
					Result := 6
					js.return
				end
			end
			if not js.return_called and then (l_st1.st_dev = l_st2.st_dev) then
				if l_st1.st_ino = l_st2.st_ino then
					Result := 1
					js.return
				end
			end
			if not js.return_called then
				Result := 2
			end
		end

	gettail (a_fname: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_p1: CE_POINTER [NATURAL_8]
			l_p2: CE_POINTER [NATURAL_8]
			l_tmp___1: INTEGER_32
			js: JUMP_STATE
		do
			create l_p1.make
			create l_p2.make

			if (a_fname.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				Result := (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")))
				js.return
			end
			if not js.return_called then
				l_p2.ce_gets (a_fname)
				l_p1.ce_gets (l_p2)
				from
				until
					not ((l_p2.item).to_boolean)
				loop
					if (vim_ispathsep ((l_p2.item).to_integer_32)).to_boolean then
						l_p1.ce_gets (l_p2 + 1)
					end
					if globals_inst.has_mbyte.to_boolean then
						l_tmp___1 := (globals_inst.mb_ptr2len.integer_32_item ([l_p2]))
					else
						l_tmp___1 := 1
					end
					l_p2.ce_gets (l_p2 + l_tmp___1)
				end
				Result := l_p1
			end
		end

	gettail_dir (a_fname: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_dir_end: CE_POINTER [NATURAL_8]
			l_next_dir_end: CE_POINTER [NATURAL_8]
			l_look_for_sep: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp___1: INTEGER_32
		do
			create l_dir_end.make
			create l_next_dir_end.make
			create l_p___0.make

			l_dir_end.ce_gets (a_fname)
			l_next_dir_end.ce_gets (a_fname)
			l_look_for_sep := 1
			l_p___0.ce_gets (a_fname)
			from
			until
				(l_p___0.item).to_integer_32 = 0
			loop
				if (vim_ispathsep ((l_p___0.item).to_integer_32)).to_boolean then
					if l_look_for_sep.to_boolean then
						l_next_dir_end.ce_gets (l_p___0)
						l_look_for_sep := 0
					end
				else
					if not l_look_for_sep.to_boolean then
						l_dir_end.ce_gets (l_next_dir_end)
					end
					l_look_for_sep := 1
				end
				if globals_inst.has_mbyte.to_boolean then
					l_tmp___1 := (globals_inst.mb_ptr2len.integer_32_item ([l_p___0]))
				else
					l_tmp___1 := 1
				end
				l_p___0.ce_gets (l_p___0 + l_tmp___1)
			end
			Result := l_dir_end
		end

	gettail_sep (a_fname: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_t: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_p___0.make
			create l_t.make

			l_p___0.ce_gets (get_past_head (a_fname))
			l_t.ce_gets (gettail (a_fname))
			from
			until
				js.loop_left
			loop
				js.reset
				if (l_t.c_pointer.to_integer_32).to_natural_32 > (l_p___0.c_pointer.to_integer_32).to_natural_32 then
					if not (misc2_inst.after_pathsep (a_fname, l_t)).to_boolean then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					l_t.ce_gets (l_t - 1)
				end
			end
			js.reset
			Result := l_t
		end

	getnextcomp (a_fname: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_fname: CE_POINTER [NATURAL_8]
			l_tmp___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_fname.make

			l_fname.ce_gets (a_fname)
			from
			until
				js.loop_left
			loop
				js.reset
				if (l_fname.item).to_boolean then
					if (vim_ispathsep ((l_fname.item).to_integer_32)).to_boolean then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					if globals_inst.has_mbyte.to_boolean then
						l_tmp___0 := (globals_inst.mb_ptr2len.integer_32_item ([l_fname]))
					else
						l_tmp___0 := 1
					end
					l_fname.ce_gets (l_fname + l_tmp___0)
				end
			end
			js.reset
			if (l_fname.item).to_boolean then
				l_fname.ce_gets (l_fname + 1)
			end
			Result := l_fname
		end

	get_past_head (a_path: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_retval: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_retval.make

			l_retval.ce_gets (a_path)
			from
			until
				js.loop_left
			loop
				js.reset
				if not (vim_ispathsep ((l_retval.item).to_integer_32)).to_boolean then
					js.break
				end
				if not js.loop_jumped then
					l_retval.ce_gets (l_retval + 1)
				end
			end
			js.reset
			Result := l_retval
		end

	vim_ispathsep (a_c: INTEGER_32): INTEGER_32
		do
			Result := (a_c = 47).to_integer
		end

	vim_ispathlistsep (a_c: INTEGER_32): INTEGER_32
		do
			Result := (a_c = 58).to_integer
		end

	shorten_dir (a_str___1: CE_POINTER [NATURAL_8])
		local
			l_tail: CE_POINTER [NATURAL_8]
			l_s: CE_POINTER [NATURAL_8]
			l_d: CE_POINTER [NATURAL_8]
			l_skip___0: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_l: INTEGER_32
			l_tmp___3: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_tail.make
			create l_s.make
			create l_d.make
			create l_tmp.make
			create l_tmp___0.make
			create l_tmp___1.make
			create l_tmp___3.make

			l_skip___0 := 0
			l_tail.ce_gets (gettail (a_str___1))
			l_d.ce_gets (a_str___1)
			l_s.ce_gets (a_str___1)
			from
			until
				js.loop_left
			loop
				js.reset
				if (l_s.c_pointer.to_integer_32).to_natural_32 >= (l_tail.c_pointer.to_integer_32).to_natural_32 then
					l_tmp.ce_gets (l_d)
					l_d.ce_gets (l_d + 1)
					l_tmp.item := l_s.item
					if (l_s.item).to_integer_32 = 0 then
						js.break
					end
				elseif (vim_ispathsep ((l_s.item).to_integer_32)).to_boolean then
					l_tmp___0.ce_gets (l_d)
					l_d.ce_gets (l_d + 1)
					l_tmp___0.item := l_s.item
					l_skip___0 := 0
				elseif not l_skip___0.to_boolean then
					l_tmp___1.ce_gets (l_d)
					l_d.ce_gets (l_d + 1)
					l_tmp___1.item := l_s.item
					if (l_s.item).to_integer_32 /= 126 then
						if (l_s.item).to_integer_32 /= 46 then
							l_skip___0 := 1
						end
					end
					if globals_inst.has_mbyte.to_boolean then
						l_l := (globals_inst.mb_ptr2len.integer_32_item ([l_s]))
						from
						until
							js.loop_left
						loop
							js.reset
							l_l := l_l - 1
							if not (l_l > 0) then
								js.break
							end
							if not js.loop_jumped then
								l_tmp___3.ce_gets (l_d)
								l_d.ce_gets (l_d + 1)
								l_s.ce_gets (l_s + 1)
								l_tmp___3.item := l_s.item
							end
						end
						js.reset
					end
				end
				if not js.loop_jumped then
					l_s.ce_gets (l_s + 1)
				end
			end
			js.reset
		end

	dir_of_file_exists (a_fname: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_c: INTEGER_32
			l_retval: INTEGER_32
			js: JUMP_STATE
		do
			create l_p___0.make

			l_p___0.ce_gets (gettail_sep (a_fname))
			if (l_p___0.c_pointer.to_integer_32).to_natural_32 = (a_fname.c_pointer.to_integer_32).to_natural_32 then
				Result := 1
				js.return
			end
			if not js.return_called then
				l_c := (l_p___0.item).to_integer_32
				l_p___0.item := (('%/0/').code).to_natural_8
				l_retval := os_unix_inst.mch_isdir (a_fname)
				l_p___0.item := l_c.to_natural_8
				Result := l_retval
			end
		end

	concat_fnames (a_fname1: CE_POINTER [NATURAL_8]; a_fname2: CE_POINTER [NATURAL_8]; a_sep: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_dest: CE_POINTER [NATURAL_8]
			l_tmp: NATURAL_32
		do
			create l_dest.make

			l_tmp := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_fname1))
			l_dest.ce_gets (misc2_inst.alloc ((l_tmp + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_fname2)))) + {NATURAL_32} 3))
			if (l_dest.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_dest), create {CE_POINTER [INTEGER_8]}.make_cast (a_fname1)).do_nothing
				if a_sep.to_boolean then
					add_pathsep (l_dest)
				end
				strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_dest), create {CE_POINTER [INTEGER_8]}.make_cast (a_fname2)).do_nothing
			end
			Result := l_dest
		end

	concat_str (a_str1: CE_POINTER [NATURAL_8]; a_str2: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_dest: CE_POINTER [NATURAL_8]
			l_l: NATURAL_32
		do
			create l_dest.make

			l_l := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_str1)))
			l_dest.ce_gets (misc2_inst.alloc (((l_l + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_str2)))).to_natural_32 + {NATURAL_32} 1).to_natural_32))
			if (l_dest.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_dest), create {CE_POINTER [INTEGER_8]}.make_cast (a_str1)).do_nothing
				strcpy (create {CE_POINTER [INTEGER_8]}.make_cast ((l_dest + l_l.to_integer_32)), create {CE_POINTER [INTEGER_8]}.make_cast (a_str2)).do_nothing
			end
			Result := l_dest
		end

	add_pathsep (a_p___0: CE_POINTER [NATURAL_8])
		do
			if (a_p___0.item).to_integer_32 /= 0 then
				if not (misc2_inst.after_pathsep (a_p___0, a_p___0 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_p___0))).to_integer_32)).to_boolean then
					strcat (create {CE_POINTER [INTEGER_8]}.make_cast (a_p___0), ce_string ("/")).do_nothing
				end
			end
		end

	FullName_save (a_fname: CE_POINTER [NATURAL_8]; a_force: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_buf___6: CE_POINTER [NATURAL_8]
			l_new_fname: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_buf___6.make
			create l_new_fname.make

			l_new_fname.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
			if (a_fname.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				l_buf___6.ce_gets (misc2_inst.alloc ({NATURAL_32} 4096))
				if (l_buf___6.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					if (window_inst.vim_FullName (a_fname, l_buf___6, 4096, a_force)) /= 0 then
						l_new_fname.ce_gets (misc2_inst.vim_strsave (l_buf___6))
					else
						l_new_fname.ce_gets (misc2_inst.vim_strsave (a_fname))
					end
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_buf___6))
				end
				Result := l_new_fname
			end
		end

	find_start_comment (a_ind_maxcomment: INTEGER_32): CE_POINTER [PD_POS_T]
		local
			l_pos___3: CE_POINTER [PD_POS_T]
			l_line: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_cur_maxcomment: INTEGER_32
			js: JUMP_STATE
		do
			create l_pos___3.make
			create l_line.make
			create l_p___0.make

			l_cur_maxcomment := a_ind_maxcomment
			from
			until
				js.loop_left
			loop
				js.reset
				l_pos___3.ce_gets (search_inst.findmatchlimit (create {CE_POINTER [PD_OPARG_S]}.make_shared (default_pointer), ('*').code, 1, l_cur_maxcomment))
				if (l_pos___3.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					js.break
				end
				if not js.loop_jumped then
					l_line.ce_gets (memline_inst.ml_get (l_pos___3.item.lnum))
					l_p___0.ce_gets (l_line)
					from
					until
						js.loop_left
					loop
						js.reset
						if (l_p___0.item).to_boolean then
							if not (l_p___0.distance (l_line) < l_pos___3.item.col) then
								js.break
							end
						else
							js.break
						end
						if not js.loop_jumped then
							l_p___0.ce_gets (skip_string (l_p___0))
							l_p___0.ce_gets (l_p___0 + 1)
						end
					end
					js.reset
					if l_p___0.distance (l_line) <= l_pos___3.item.col then
						js.break
					end
				end
				if not js.loop_jumped then
					l_cur_maxcomment := ((globals_inst.curwin.item.w_cursor.lnum - l_pos___3.item.lnum) - 1).to_integer_32
					if l_cur_maxcomment <= 0 then
						l_pos___3.ce_gets (create {CE_POINTER [PD_POS_T]}.make_shared (default_pointer))
						js.break
					end
				end
			end
			js.reset
			Result := l_pos___3
		end

	skip_string (a_p___0: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p___0.ce_gets (a_p___0)
				when 1 then -- loop condition:
					if js.loop_left then
						l_pos := -1 + 15 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						if (l_p___0[0]).to_integer_32 /= 39 then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if not (l_p___0[1]).to_boolean then
							js.break
						end
						if not js.loop_jumped then
							l_i___0 := 2
							if (l_p___0[1]).to_integer_32 = 92 then
								l_i___0 := l_i___0 + 1
								from
								until
									js.loop_left
								loop
									js.reset
									if not (charset_inst.vim_isdigit ((l_p___0[(l_i___0 - 1)]).to_integer_32)).to_boolean then
										js.break
									end
									if not js.loop_jumped then
										l_i___0 := l_i___0 + 1
									end
								end
								js.reset
							end
							if (l_p___0[l_i___0]).to_integer_32 = 39 then
								l_p___0.ce_gets (l_p___0 + l_i___0)
								js.continue
							end
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 5 then -- else:
						if (l_p___0[0]).to_integer_32 /= 34 then
							l_pos := -1 + 14 -- skip if block
						end
				when 6 then -- if:
						l_p___0.ce_gets (l_p___0 + 1)
				when 7 then -- loop condition:
						if not (not js.loop_left and then ((l_p___0[0]).to_boolean)) then
							l_pos := -1 + 13 -- skip loop
						end
				when 8 then -- loop body:
						js.reset
						if (l_p___0[0]).to_integer_32 /= 92 then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						if (l_p___0[1]).to_integer_32 /= 0 then
							l_p___0.ce_gets (l_p___0 + 1)
						else
							l_pos := -1 + 11 -- goto _L
						end
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 11 then -- else: | _L:
						if (l_p___0[0]).to_integer_32 = 34 then
							js.break
						end
				when 12 then
						if not js.loop_jumped then
							l_p___0.ce_gets (l_p___0 + 1)
						end
						l_pos := -1 + 7 -- back to loop condition
				when 13 then -- loop done
						js.reset
						if (l_p___0[0]).to_integer_32 = 34 then
							js.continue
						end
				when 14 then -- if done | if done
						if not js.loop_jumped then
							js.break
						end
						if not js.loop_left then
							l_p___0.ce_gets (l_p___0 + 1)
						end
						l_pos := -1 + 1 -- back to loop condition
				when 15 then -- loop done
					js.reset
					if not (l_p___0.item).to_boolean then
						l_p___0.ce_gets (l_p___0 - 1)
					end
					Result := l_p___0
				when 16 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	do_c_expr_indent
		do
			if ((globals_inst.curbuf.item.b_p_inde).item).to_integer_32 /= 0 then
				edit_inst.fixthisline (get_expr_indent_address)
			else
				edit_inst.fixthisline (get_c_indent_address)
			end
		end

	cin_skipcomment (a_s: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_s: CE_POINTER [NATURAL_8]
			l_prev_s: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_s.make
			create l_prev_s.make

			l_s.ce_gets (a_s)
			from
			until
				not (not js.loop_left and then ((l_s.item).to_boolean))
			loop
				js.reset
				l_prev_s.ce_gets (l_s)
				l_s.ce_gets (charset_inst.skipwhite (l_s))
				if ind_hash_comment /= 0 then
					if (l_s.c_pointer.to_integer_32).to_natural_32 /= (l_prev_s.c_pointer.to_integer_32).to_natural_32 then
						if (l_s.item).to_integer_32 = 35 then
							l_s.ce_gets (l_s + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_s))).to_integer_32)
							js.break
						end
					end
				end
				if not js.loop_jumped and then ((l_s.item).to_integer_32 /= 47) then
					js.break
				end
				if not js.loop_jumped then
					l_s.ce_gets (l_s + 1)
					if (l_s.item).to_integer_32 = 47 then
						l_s.ce_gets (l_s + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_s))).to_integer_32)
						js.break
					end
				end
				if not js.loop_jumped and then ((l_s.item).to_integer_32 /= 42) then
					js.break
				end
				if not js.loop_jumped then
					l_s.ce_gets (l_s + 1)
					from
					until
						not (not js.loop_left and then ((l_s.item).to_boolean))
					loop
						js.reset
						if (l_s[0]).to_integer_32 = 42 then
							if (l_s[1]).to_integer_32 = 47 then
								l_s.ce_gets (l_s + (2))
								js.break
							end
						end
						if not js.loop_jumped then
							l_s.ce_gets (l_s + 1)
						end
					end
					js.reset
				end
			end
			js.reset
			Result := l_s
		end

	cin_nocode (a_s: CE_POINTER [NATURAL_8]): INTEGER_32
		do
			Result := (((cin_skipcomment (a_s)).item).to_integer_32 = 0).to_integer
		end

	find_line_comment: CE_POINTER [PD_POS_T]
		local
			l_line: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_line.make
			create l_p___0.make

			pos___0.ce_gets (globals_inst.curwin.item.w_cursor)
			from
			until
				js.loop_left
			loop
				js.reset
				pos___0.lnum := (pos___0.lnum) - 1
				if not (pos___0.lnum > 0) then
					js.break
				end
				if not js.loop_jumped then
					l_line.ce_gets (memline_inst.ml_get (pos___0.lnum))
					l_p___0.ce_gets (charset_inst.skipwhite (l_line))
					if (cin_islinecomment (l_p___0)).to_boolean then
						pos___0.col := l_p___0.distance (l_line)
						Result := (pos___0.address)
						js.return
					end
					if not js.return_called and then ((l_p___0.item).to_integer_32 /= 0) then
						js.break
					end
				end
			end
			js.reset
			if not js.return_called then
				Result := (create {CE_POINTER [PD_POS_T]}.make_shared (default_pointer))
			end
		end

	cin_islabel_skip (a_s: CE_POINTER [CE_POINTER [NATURAL_8]]): INTEGER_32
		local
			l_tmp___1: INTEGER_32
			js: JUMP_STATE
		do
			if not (charset_inst.vim_isIDc (((a_s.item).item).to_integer_32)).to_boolean then
				Result := 0
				js.return
			end
			if not js.return_called then
				from
				until
					js.loop_left
				loop
					js.reset
					if not (charset_inst.vim_isIDc (((a_s.item).item).to_integer_32)).to_boolean then
						js.break
					end
					if not js.loop_jumped then
						a_s.item := (a_s.item) + 1
					end
				end
				js.reset
				a_s.item := cin_skipcomment (a_s.item)
				if ((a_s.item).item).to_integer_32 = 58 then
					a_s.item := (a_s.item) + 1
					if ((a_s.item).item).to_integer_32 /= 58 then
						l_tmp___1 := 1
					else
						l_tmp___1 := 0
					end
				else
					l_tmp___1 := 0
				end
				Result := l_tmp___1
			end
		end

	cin_islabel (a_ind_maxcomment: INTEGER_32): INTEGER_32
		local
			l_s: CE_POINTER [NATURAL_8]
			l_cursor_save: PD_POS_T
			l_trypos: CE_POINTER [PD_POS_T]
			l_line: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_s.make
			create l_cursor_save.make
			create l_trypos.make
			create l_line.make

			l_s.ce_gets (cin_skipcomment ((memline_inst.ml_get_curline)))
			if (cin_isdefault (l_s)).to_boolean then
				Result := 0
				js.return
			end
			if not js.return_called then
				if (cin_isscopedecl (l_s)).to_boolean then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				if (cin_islabel_skip (l_s.address)).to_boolean then
					l_cursor_save.ce_gets (globals_inst.curwin.item.w_cursor)
					from
					until
						not (not js.loop_left and then (globals_inst.curwin.item.w_cursor.lnum > 1))
					loop
						js.reset
						globals_inst.curwin.item.w_cursor.lnum := (globals_inst.curwin.item.w_cursor.lnum) - 1
						globals_inst.curwin.item.w_cursor.col := 0
						l_trypos.ce_gets (find_start_comment (a_ind_maxcomment))
						if (l_trypos.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							globals_inst.curwin.item.w_cursor := l_trypos.item
						end
						l_line.ce_gets (memline_inst.ml_get_curline)
						if (cin_ispreproc (l_line)).to_boolean then
							js.continue
						end
						if not js.loop_jumped then
							l_line.ce_gets (cin_skipcomment (l_line))
							if (l_line.item).to_integer_32 = 0 then
								js.continue
							end
						end
						if not js.loop_jumped then
							globals_inst.curwin.item.w_cursor := l_cursor_save
							if (cin_isterminated (l_line, 1, 0)).to_boolean then
								Result := 1
								js.return
							elseif (cin_isscopedecl (l_line)).to_boolean then
								Result := 1
								js.return
							elseif (cin_iscase (l_line, 1)).to_boolean then
								Result := 1
								js.return
							elseif (cin_islabel_skip (l_line.address)).to_boolean then
								if (cin_nocode (l_line)).to_boolean then
									Result := 1
									js.return
								end
							end
							if not js.return_called then
								Result := 0
								js.return
							end
						end
					end
					if not js.return_called then
						globals_inst.curwin.item.w_cursor := l_cursor_save
						Result := 1
						js.return
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	cin_isinit: INTEGER_32
		local
			l_s: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_s.make

			l_s.ce_gets (cin_skipcomment ((memline_inst.ml_get_curline)))
			if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_s), ce_string ("typedef"), (7).to_natural_32)) = 0 then
				if not (charset_inst.vim_isIDc ((l_s[7]).to_integer_32)).to_boolean then
					l_s.ce_gets (cin_skipcomment (l_s + 7))
				end
			end
			if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_s), ce_string ("enum"), (4).to_natural_32)) = 0 then
				if not (charset_inst.vim_isIDc ((l_s[4]).to_integer_32)).to_boolean then
					Result := 1
					js.return
				end
			end
			if not js.return_called then
				if (cin_ends_in (l_s, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("=")), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("{")))).to_boolean then
					Result := 1
					js.return
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	cin_iscase (a_s: CE_POINTER [NATURAL_8]; a_strict: INTEGER_32): INTEGER_32
		local
			l_s: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_s.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_s.ce_gets (a_s)
					l_s.ce_gets (cin_skipcomment (l_s))
					if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_s), ce_string ("case"), (4).to_natural_32)) /= 0 then
						l_pos := -1 + 14 -- skip if block
					end
				when 1 then -- if:
						if (charset_inst.vim_isIDc ((l_s[4]).to_integer_32)).to_boolean then
							l_pos := -1 + 14 -- skip if block
						end
				when 2 then -- if:
						l_s.ce_gets (l_s + (4))
				when 3 then -- loop condition:
						if not (not js.loop_left and then ((l_s.item).to_boolean)) then
							l_pos := -1 + 13 -- skip loop
						end
				when 4 then -- loop body:
						l_s.ce_gets (cin_skipcomment (l_s))
						if (l_s.item).to_integer_32 = 58 then
							if (l_s[1]).to_integer_32 = 58 then
								l_s.ce_gets (l_s + 1)
							else
								Result := 1
								js.return
							end
						end
						if js.return_called then
							l_pos := -1 + 12 -- skip if block
						end
				when 5 then -- if:
						if (l_s.item).to_integer_32 /= 39 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						if (l_s[1]).to_boolean then
							if (l_s[2]).to_integer_32 = 39 then
								l_s.ce_gets (l_s + (2))
							else
								l_pos := -1 + 8 -- goto _L___1
							end
						else
							l_pos := -1 + 8 -- goto _L___1
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 8 then -- else: | _L___1:
						if (l_s.item).to_integer_32 /= 47 then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						if (l_s[1]).to_integer_32 = 42 then
							Result := 0
							js.return
						elseif (l_s[1]).to_integer_32 = 47 then
							Result := 0
							js.return
						else
							l_pos := -1 + 11 -- goto _L
						end
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 11 then -- else: | _L:
						if (l_s.item).to_integer_32 = 34 then
							if a_strict.to_boolean then
								Result := 0
								js.return
							else
								Result := 1
								js.return
							end
						end
				when 12 then -- if done | if done
						if not js.return_called then
							l_s.ce_gets (l_s + 1)
						end
						l_pos := -1 + 3 -- back to loop condition
				when 13 then -- loop done
						if not js.return_called then
							Result := 0
							js.return
						end
				when 14 then -- if done | if done
						if not js.return_called then
							if (cin_isdefault (l_s)).to_boolean then
								Result := 1
								js.return
							end
						end
						if not js.return_called then
							Result := 0
						end
				when 15 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	cin_isdefault (a_s: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_s: CE_POINTER [NATURAL_8]
			l_tmp___0: INTEGER_32
		do
			create l_s.make

			l_s.ce_gets (a_s)
			if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_s), ce_string ("default"), (7).to_natural_32)) = 0 then
				l_s.ce_gets (cin_skipcomment (l_s + 7))
				if (l_s.item).to_integer_32 = 58 then
					if (l_s[1]).to_integer_32 /= 58 then
						l_tmp___0 := 1
					else
						l_tmp___0 := 0
					end
				else
					l_tmp___0 := 0
				end
			else
				l_tmp___0 := 0
			end
			Result := l_tmp___0
		end

	cin_isscopedecl (a_s: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_s: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			l_tmp___2: INTEGER_32
			js: JUMP_STATE
		do
			create l_s.make

			l_s.ce_gets (a_s)
			l_s.ce_gets (cin_skipcomment (l_s))
			if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_s), ce_string ("public"), (6).to_natural_32)) = 0 then
				l_i___0 := 6
			elseif (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_s), ce_string ("protected"), (9).to_natural_32)) = 0 then
				l_i___0 := 9
			elseif (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_s), ce_string ("private"), (7).to_natural_32)) = 0 then
				l_i___0 := 7
			else
				Result := 0
				js.return
			end
			if not js.return_called then
				l_s.ce_gets (cin_skipcomment (l_s + l_i___0))
				if (l_s.item).to_integer_32 = 58 then
					if (l_s[1]).to_integer_32 /= 58 then
						l_tmp___2 := 1
					else
						l_tmp___2 := 0
					end
				else
					l_tmp___2 := 0
				end
				Result := l_tmp___2
			end
		end

	after_label (a_l: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_l: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_l.make

			l_l.ce_gets (a_l)
			from
			until
				not (not js.loop_left and then ((l_l.item).to_boolean))
			loop
				js.reset
				if (l_l.item).to_integer_32 = 58 then
					if (l_l[1]).to_integer_32 = 58 then
						l_l.ce_gets (l_l + 1)
					elseif not (cin_iscase (l_l + 1, 0)).to_boolean then
						js.break
					end
				elseif (l_l.item).to_integer_32 = 39 then
					if (l_l[1]).to_boolean then
						if (l_l[2]).to_integer_32 = 39 then
							l_l.ce_gets (l_l + (2))
						end
					end
				end
				if not js.loop_jumped then
					l_l.ce_gets (l_l + 1)
				end
			end
			js.reset
			if (l_l.item).to_integer_32 = 0 then
				Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				l_l.ce_gets (cin_skipcomment (l_l + 1))
				if (l_l.item).to_integer_32 = 0 then
					Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					js.return
				end
			end
			if not js.return_called then
				Result := l_l
			end
		end

	get_indent_nolabel (a_lnum: INTEGER_32): INTEGER_32
		local
			l_l: CE_POINTER [NATURAL_8]
			l_fp: PD_POS_T
			l_col: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_l.make
			create l_fp.make
			create l_p___0.make

			l_l.ce_gets (memline_inst.ml_get (a_lnum))
			l_p___0.ce_gets (after_label (l_l))
			if (l_p___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				Result := 0
				js.return
			end
			if not js.return_called then
				l_fp.col := l_p___0.distance (l_l)
				l_fp.lnum := a_lnum
				charset_inst.getvcol (globals_inst.curwin, l_fp.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_col), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
				Result := l_col
			end
		end

	skip_label (a_lnum: INTEGER_32; a_pp: CE_POINTER [CE_POINTER [NATURAL_8]]; a_ind_maxcomment: INTEGER_32): INTEGER_32
		local
			l_l: CE_POINTER [NATURAL_8]
			l_amount: INTEGER_32
			l_cursor_save: PD_POS_T
			l_pos: INTEGER_32
		do
			create l_l.make
			create l_cursor_save.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_cursor_save.ce_gets (globals_inst.curwin.item.w_cursor)
					globals_inst.curwin.item.w_cursor.lnum := a_lnum
					l_l.ce_gets (memline_inst.ml_get_curline)
					if not ((cin_iscase (l_l, 0)).to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 3 then -- else:
						if not ((cin_isscopedecl (l_l)).to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 6 then -- else:
						if not ((cin_islabel (a_ind_maxcomment)).to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if: | _L:
						l_amount := get_indent_nolabel (a_lnum)
						l_l.ce_gets (after_label ((memline_inst.ml_get_curline)))
						if (l_l.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_l.ce_gets (memline_inst.ml_get_curline)
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else:
						l_amount := get_indent
						l_l.ce_gets (memline_inst.ml_get_curline)
				when 10 then -- if done | if done
						a_pp.item := l_l
						globals_inst.curwin.item.w_cursor := l_cursor_save
						Result := l_amount
				when 11 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	cin_first_id_amount: INTEGER_32
		local
			l_line: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_s: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_fp: PD_POS_T
			l_col: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_line.make
			create l_p___0.make
			create l_s.make
			create l_fp.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_line.ce_gets (memline_inst.ml_get_curline)
					l_p___0.ce_gets (charset_inst.skipwhite (l_line))
					l_len := (charset_inst.skiptowhite (l_p___0)).distance (l_p___0)
					if l_len = 6 then
						if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), ce_string ("static"), (6).to_natural_32)) = 0 then
							l_p___0.ce_gets (charset_inst.skipwhite (l_p___0 + 6))
							l_len := (charset_inst.skiptowhite (l_p___0)).distance (l_p___0)
						end
					end
					if l_len /= 6 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), ce_string ("struct"), (6).to_natural_32)) = 0 then
							l_p___0.ce_gets (charset_inst.skipwhite (l_p___0 + 6))
						else
							l_pos := -1 + 3 -- goto _L___5
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 3 then -- else: | _L___5:
						if l_len /= 4 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), ce_string ("enum"), (4).to_natural_32)) = 0 then
							l_p___0.ce_gets (charset_inst.skipwhite (l_p___0 + 4))
						else
							l_pos := -1 + 6 -- goto _L___4
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 6 then -- else: | _L___4:
						if l_len /= 8 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), ce_string ("unsigned"), (8).to_natural_32)) = 0 then
							l_pos := -1 + 11 -- goto _L___2
						else
							l_pos := -1 + 9 -- goto _L___3
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 9 then -- else: | _L___3:
						if l_len /= 6 then
							l_pos := -1 + 21 -- skip if block
						end
				when 10 then -- if:
						if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), ce_string ("signed"), (6).to_natural_32)) /= 0 then
							l_pos := -1 + 21 -- skip if block
						end
				when 11 then -- if: | _L___2:
						l_s.ce_gets (charset_inst.skipwhite (l_p___0 + l_len))
						if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_s), ce_string ("int"), (3).to_natural_32)) /= 0 then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:
						if (l_s[3]).to_integer_32 = 32 then
							l_p___0.ce_gets (l_s)
						elseif (l_s[3]).to_integer_32 = 9 then
							l_p___0.ce_gets (l_s)
						else
							l_pos := -1 + 14 -- goto _L___1
						end
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 14 then -- else: | _L___1:
						if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_s), ce_string ("long"), (4).to_natural_32)) /= 0 then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if:
						if (l_s[4]).to_integer_32 = 32 then
							l_p___0.ce_gets (l_s)
						elseif (l_s[4]).to_integer_32 = 9 then
							l_p___0.ce_gets (l_s)
						else
							l_pos := -1 + 17 -- goto _L___0
						end
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 17 then -- else: | _L___0:
						if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_s), ce_string ("short"), (5).to_natural_32)) /= 0 then
							l_pos := -1 + 20 -- skip if block
						end
				when 18 then -- if:
						if (l_s[5]).to_integer_32 = 32 then
							l_p___0.ce_gets (l_s)
						elseif (l_s[5]).to_integer_32 = 9 then
							l_p___0.ce_gets (l_s)
						else
							l_pos := -1 + 20 -- goto _L
						end
				when 19 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 20 then -- else: | _L:
						if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_s), ce_string ("char"), (4).to_natural_32)) = 0 then
							if (l_s[4]).to_integer_32 = 32 then
								l_p___0.ce_gets (l_s)
							elseif (l_s[4]).to_integer_32 = 9 then
								l_p___0.ce_gets (l_s)
							end
						end
				when 21 then -- if done | if done | if done | if done | if done | if done | if done
						l_len := 0
						from
						until
							js.loop_left
						loop
							js.reset
							if not (charset_inst.vim_isIDc ((l_p___0[l_len]).to_integer_32)).to_boolean then
								js.break
							end
							if not js.loop_jumped then
								l_len := l_len + 1
							end
						end
						js.reset
						if l_len /= 0 then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if:
							Result := 0
							js.return
				when 23 then -- if block done, skip else block:
							l_pos := -1 + 31
				when 24 then -- else:
							if (l_p___0[l_len]).to_integer_32 /= 32 then
								l_pos := -1 + 27 -- skip if block
							end
				when 25 then -- if:
							l_pos := -1 + 28 -- goto _L___6
				when 26 then -- if block done, skip else block:
							l_pos := -1 + 31
				when 27 then -- else:
							if (l_p___0[l_len]).to_integer_32 /= 9 then
								l_pos := -1 + 30 -- skip if block
							end
				when 28 then -- if: | _L___6:
							if (cin_nocode (l_p___0)).to_boolean then
								Result := 0
								js.return
							end
				when 29 then -- if block done, skip else block:
							l_pos := -1 + 31
				when 30 then -- else:
							Result := 0
							js.return
				when 31 then -- if done | if done
							if not js.return_called then
								l_p___0.ce_gets (charset_inst.skipwhite (l_p___0 + l_len))
								l_fp.lnum := globals_inst.curwin.item.w_cursor.lnum
								l_fp.col := l_p___0.distance (l_line)
								charset_inst.getvcol (globals_inst.curwin, l_fp.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_col), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
								Result := l_col
							end
				when 32 then
							l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
				end

	cin_get_equal_amount (a_lnum: INTEGER_32): INTEGER_32
		local
			l_line: CE_POINTER [NATURAL_8]
			l_s: CE_POINTER [NATURAL_8]
			l_col: INTEGER_32
			l_fp: PD_POS_T
			js: JUMP_STATE
		do
			create l_line.make
			create l_s.make
			create l_fp.make

			if a_lnum > 1 then
				l_line.ce_gets (memline_inst.ml_get (a_lnum - 1))
				if (l_line.item).to_integer_32 /= 0 then
					if (l_line[((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_line))) - {NATURAL_32} 1).to_integer_32]).to_integer_32 = 92 then
						Result := (-1)
						js.return
					end
				end
			end
			if not js.return_called then
				l_s.ce_gets (memline_inst.ml_get (a_lnum))
				l_line.ce_gets (l_s)
				from
				until
					js.loop_left
				loop
					js.reset
					if (l_s.item).to_integer_32 /= 0 then
						if ((misc2_inst.vim_strchr (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("=;{}%"%'")), (l_s.item).to_integer_32)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							js.break
						end
					else
						js.break
					end
					if not js.loop_jumped then
						if (cin_iscomment (l_s)).to_boolean then
							l_s.ce_gets (cin_skipcomment (l_s))
						else
							l_s.ce_gets (l_s + 1)
						end
					end
				end
				js.reset
				if (l_s.item).to_integer_32 /= 61 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				l_s.ce_gets (charset_inst.skipwhite (l_s + 1))
				if (cin_nocode (l_s)).to_boolean then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				if (l_s.item).to_integer_32 = 34 then
					l_s.ce_gets (l_s + 1)
				end
				l_fp.lnum := a_lnum
				l_fp.col := l_s.distance (l_line)
				charset_inst.getvcol (globals_inst.curwin, l_fp.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_col), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
				Result := l_col
			end
		end

	cin_ispreproc (a_s: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_s: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_s.make

			l_s.ce_gets (a_s)
			l_s.ce_gets (charset_inst.skipwhite (l_s))
			if (l_s.item).to_integer_32 = 35 then
				Result := 1
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	cin_ispreproc_cont (a_pp: CE_POINTER [CE_POINTER [NATURAL_8]]; a_lnump: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_line: CE_POINTER [NATURAL_8]
			l_lnum: INTEGER_32
			l_retval: INTEGER_32
			js: JUMP_STATE
		do
			create l_line.make

			l_line.ce_gets (a_pp.item)
			l_lnum := a_lnump.item
			l_retval := 0
			from
			until
				js.loop_left
			loop
				js.reset
				if (cin_ispreproc (l_line)).to_boolean then
					l_retval := 1
					a_lnump.item := l_lnum
					js.break
				end
				if not js.loop_jumped and then (l_lnum = 1) then
					js.break
				end
				if not js.loop_jumped then
					l_lnum := l_lnum - 1
					l_line.ce_gets (memline_inst.ml_get (l_lnum))
					if (l_line.item).to_integer_32 = 0 then
						js.break
					elseif (l_line[((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_line))) - {NATURAL_32} 1).to_integer_32]).to_integer_32 /= 92 then
						js.break
					end
				end
			end
			js.reset
			if l_lnum /= a_lnump.item then
				a_pp.item := memline_inst.ml_get (a_lnump.item)
			end
			Result := l_retval
		end

	cin_iscomment (a_p___0: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_tmp: INTEGER_32
		do
			if (a_p___0[0]).to_integer_32 = 47 then
				if (a_p___0[1]).to_integer_32 = 42 then
					l_tmp := 1
				elseif (a_p___0[1]).to_integer_32 = 47 then
					l_tmp := 1
				else
					l_tmp := 0
				end
			else
				l_tmp := 0
			end
			Result := l_tmp
		end

	cin_islinecomment (a_p___0: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_tmp: INTEGER_32
		do
			if (a_p___0[0]).to_integer_32 = 47 then
				if (a_p___0[1]).to_integer_32 = 47 then
					l_tmp := 1
				else
					l_tmp := 0
				end
			else
				l_tmp := 0
			end
			Result := l_tmp
		end

	cin_isterminated (a_s: CE_POINTER [NATURAL_8]; a_incl_open: INTEGER_32; a_incl_comma: INTEGER_32): INTEGER_32
		local
			l_s: CE_POINTER [NATURAL_8]
			l_found_start: NATURAL_8
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_s.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_s.ce_gets (a_s)
					l_found_start := (0).to_natural_8
					l_s.ce_gets (cin_skipcomment (l_s))
					if (l_s.item).to_integer_32 = 123 then
						l_found_start := l_s.item
					elseif (l_s.item).to_integer_32 = 125 then
						if not (cin_iselse (l_s)).to_boolean then
							l_found_start := l_s.item
						end
					end
				when 1 then -- loop condition:
					if not (not js.loop_left and then ((l_s.item).to_boolean)) then
						l_pos := -1 + 15 -- skip loop
					end
				when 2 then -- loop body:
						l_s.ce_gets (skip_string ((cin_skipcomment (l_s))))
						if (l_s.item).to_integer_32 /= 59 then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_pos := -1 + 13 -- goto _L
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 5 then -- else:
						if not (a_incl_open.to_boolean) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						if (l_s.item).to_integer_32 = 123 then
							l_pos := -1 + 13 -- goto _L
						else
							l_pos := -1 + 8 -- goto _L___0
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 8 then -- else: | _L___0:
						if (l_s.item).to_integer_32 /= 125 then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						l_pos := -1 + 13 -- goto _L
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 11 then -- else:
						if not (a_incl_comma.to_boolean) then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:
						if (l_s.item).to_integer_32 /= 44 then
							l_pos := -1 + 14 -- skip if block
						end
				when 13 then -- if: | _L:
						if (cin_nocode (l_s + 1)).to_boolean then
							Result := (l_s.item).to_integer_32
							js.return
						end
				when 14 then -- if done | if done | if done | if done
						if not js.return_called and then ((l_s.item).to_boolean) then
							l_s.ce_gets (l_s + 1)
						end
						l_pos := -1 + 1 -- back to loop condition
				when 15 then -- loop done
					if not js.return_called then
						Result := l_found_start.to_integer_32
					end
				when 16 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	cin_isfuncdecl (a_sp: CE_POINTER [CE_POINTER [NATURAL_8]]; a_first_lnum: INTEGER_32): INTEGER_32
		local
			l_s: CE_POINTER [NATURAL_8]
			l_lnum: INTEGER_32
			l_retval: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_s.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_lnum := a_first_lnum
					l_retval := 0
					if (a_sp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						l_s.ce_gets (memline_inst.ml_get (l_lnum))
					else
						l_s.ce_gets (a_sp.item)
					end
					from
					until
						js.loop_left
					loop
						js.reset
						if (l_s.item).to_boolean then
							if (l_s.item).to_integer_32 /= 40 then
								if (l_s.item).to_integer_32 /= 59 then
									if (l_s.item).to_integer_32 /= 39 then
										if (l_s.item).to_integer_32 = 34 then
											js.break
										end
									else
										js.break
									end
								else
									js.break
								end
							else
								js.break
							end
						else
							js.break
						end
						if not js.loop_jumped then
							if (cin_iscomment (l_s)).to_boolean then
								l_s.ce_gets (cin_skipcomment (l_s))
							else
								l_s.ce_gets (l_s + 1)
							end
						end
					end
					js.reset
					if (l_s.item).to_integer_32 /= 40 then
						Result := 0
						js.return
					end
					if js.return_called then
						l_pos := -1 + 11 -- skip if block
					end
				when 1 then -- if: | loop condition:
						if js.loop_left then
							l_pos := -1 + 9 -- skip loop
						end
				when 2 then -- loop body:
						js.reset
						if (l_s.item).to_boolean then
							if (l_s.item).to_integer_32 /= 59 then
								if (l_s.item).to_integer_32 /= 39 then
									if (l_s.item).to_integer_32 = 34 then
										js.break
									end
								else
									js.break
								end
							else
								js.break
							end
						else
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 8 -- skip if block
						end
				when 3 then -- if:
						if (l_s.item).to_integer_32 = 41 then
							if (cin_nocode (l_s + 1)).to_boolean then
								l_lnum := a_first_lnum - 1
								l_s.ce_gets (memline_inst.ml_get (l_lnum))
								if (l_s.item).to_integer_32 = 0 then
									l_retval := 1
								elseif (l_s[((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_s))) - {NATURAL_32} 1).to_integer_32]).to_integer_32 /= 92 then
									l_retval := 1
								end
								l_pos := -1 + 10 -- goto done
							end
						end
				when 4 then
						if (l_s.item).to_integer_32 /= 44 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if (cin_nocode (l_s + 1)).to_boolean then
							if l_lnum >= globals_inst.curbuf.item.b_ml.ml_line_count then
								js.break
							end
							if not js.loop_jumped then
								l_lnum := l_lnum + 1
								l_s.ce_gets (memline_inst.ml_get (l_lnum))
							end
						else
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						if (cin_iscomment (l_s)).to_boolean then
							l_s.ce_gets (cin_skipcomment (l_s))
						else
							l_s.ce_gets (l_s + 1)
						end
				when 8 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 9 then -- loop done
						js.reset
				when 10 then -- done:
						if l_lnum /= a_first_lnum then
							if (a_sp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								a_sp.item := memline_inst.ml_get (a_first_lnum)
							end
						end
						Result := l_retval
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	cin_isif (a_p___0: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_tmp___1: INTEGER_32
		do
			if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_p___0), ce_string ("if"), (2).to_natural_32)) = 0 then
				if (charset_inst.vim_isIDc ((a_p___0[2]).to_integer_32)).to_boolean then
					l_tmp___1 := 0
				else
					l_tmp___1 := 1
				end
			else
				l_tmp___1 := 0
			end
			Result := l_tmp___1
		end

	cin_iselse (a_p___0: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp___1: INTEGER_32
		do
			create l_p___0.make

			l_p___0.ce_gets (a_p___0)
			if (l_p___0.item).to_integer_32 = 125 then
				l_p___0.ce_gets (cin_skipcomment (l_p___0 + 1))
			end
			if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), ce_string ("else"), (4).to_natural_32)) = 0 then
				if (charset_inst.vim_isIDc ((l_p___0[4]).to_integer_32)).to_boolean then
					l_tmp___1 := 0
				else
					l_tmp___1 := 1
				end
			else
				l_tmp___1 := 0
			end
			Result := l_tmp___1
		end

	cin_isdo (a_p___0: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_tmp___1: INTEGER_32
		do
			if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_p___0), ce_string ("do"), (2).to_natural_32)) = 0 then
				if (charset_inst.vim_isIDc ((a_p___0[2]).to_integer_32)).to_boolean then
					l_tmp___1 := 0
				else
					l_tmp___1 := 1
				end
			else
				l_tmp___1 := 0
			end
			Result := l_tmp___1
		end

	cin_iswhileofdo (a_p___0: CE_POINTER [NATURAL_8]; a_lnum: INTEGER_32; a_ind_maxparen: INTEGER_32): INTEGER_32
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_cursor_save: PD_POS_T
			l_trypos: CE_POINTER [PD_POS_T]
			l_retval: INTEGER_32
			js: JUMP_STATE
		do
			create l_p___0.make
			create l_cursor_save.make
			create l_trypos.make

			l_p___0.ce_gets (a_p___0)
			l_retval := 0
			l_p___0.ce_gets (cin_skipcomment (l_p___0))
			if (l_p___0.item).to_integer_32 = 125 then
				l_p___0.ce_gets (cin_skipcomment (l_p___0 + 1))
			end
			if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), ce_string ("while"), (5).to_natural_32)) = 0 then
				if not (charset_inst.vim_isIDc ((l_p___0[5]).to_integer_32)).to_boolean then
					l_cursor_save.ce_gets (globals_inst.curwin.item.w_cursor)
					globals_inst.curwin.item.w_cursor.lnum := a_lnum
					globals_inst.curwin.item.w_cursor.col := 0
					l_p___0.ce_gets (memline_inst.ml_get_curline)
					from
					until
						js.loop_left
					loop
						js.reset
						if (l_p___0.item).to_boolean then
							if (l_p___0.item).to_integer_32 = 119 then
								js.break
							end
						else
							js.break
						end
						if not js.loop_jumped then
							l_p___0.ce_gets (l_p___0 + 1)
							globals_inst.curwin.item.w_cursor.col := (globals_inst.curwin.item.w_cursor.col) + 1
						end
					end
					js.reset
					l_trypos.ce_gets (search_inst.findmatchlimit (create {CE_POINTER [PD_OPARG_S]}.make_shared (default_pointer), 0, 0, a_ind_maxparen))
					if (l_trypos.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						if ((cin_skipcomment ((memline_inst.ml_get_pos (l_trypos)) + 1)).item).to_integer_32 = 59 then
							l_retval := 1
						end
					end
					globals_inst.curwin.item.w_cursor := l_cursor_save
				end
			end
			Result := l_retval
		end

	cin_iswhileofdo_end (a_terminated: INTEGER_32; a_ind_maxparen: INTEGER_32; a_ind_maxcomment: INTEGER_32): INTEGER_32
		local
			l_line: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_s: CE_POINTER [NATURAL_8]
			l_trypos: CE_POINTER [PD_POS_T]
			l_i___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_line.make
			create l_p___0.make
			create l_s.make
			create l_trypos.make

			if a_terminated /= 59 then
				Result := 0
				js.return
			end
			if not js.return_called then
				l_line.ce_gets (memline_inst.ml_get_curline)
				l_p___0.ce_gets (l_line)
				from
				until
					not (not js.loop_left and then ((l_p___0.item).to_integer_32 /= 0))
				loop
					l_p___0.ce_gets (cin_skipcomment (l_p___0))
					if (l_p___0.item).to_integer_32 = 41 then
						l_s.ce_gets (charset_inst.skipwhite (l_p___0 + 1))
						if (l_s.item).to_integer_32 = 59 then
							if (cin_nocode (l_s + 1)).to_boolean then
								l_i___0 := l_p___0.distance (l_line)
								globals_inst.curwin.item.w_cursor.col := l_i___0
								l_trypos.ce_gets (find_match_paren (a_ind_maxparen, a_ind_maxcomment))
								if (l_trypos.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									l_s.ce_gets (cin_skipcomment ((memline_inst.ml_get (l_trypos.item.lnum))))
									if (l_s.item).to_integer_32 = 125 then
										l_s.ce_gets (cin_skipcomment (l_s + 1))
									end
									if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_s), ce_string ("while"), (5).to_natural_32)) = 0 then
										if not (charset_inst.vim_isIDc ((l_s[5]).to_integer_32)).to_boolean then
											globals_inst.curwin.item.w_cursor.lnum := l_trypos.item.lnum
											Result := 1
											js.return
										end
									end
								end
								if not js.return_called then
									l_line.ce_gets (memline_inst.ml_get_curline)
									l_p___0.ce_gets (l_line + l_i___0)
								end
							end
						end
					end
					if not js.return_called and then ((l_p___0.item).to_integer_32 /= 0) then
						l_p___0.ce_gets (l_p___0 + 1)
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	cin_isbreak (a_p___0: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_tmp___1: INTEGER_32
		do
			if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_p___0), ce_string ("break"), (5).to_natural_32)) = 0 then
				if (charset_inst.vim_isIDc ((a_p___0[5]).to_integer_32)).to_boolean then
					l_tmp___1 := 0
				else
					l_tmp___1 := 1
				end
			else
				l_tmp___1 := 0
			end
			Result := l_tmp___1
		end

	cin_is_cpp_baseclass (a_col: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_s: CE_POINTER [NATURAL_8]
			l_class_or_struct: INTEGER_32
			l_lookfor_ctor_init: INTEGER_32
			l_cpp_base_class: INTEGER_32
			l_lnum: INTEGER_32
			l_line: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_s.make
			create l_line.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_lnum := globals_inst.curwin.item.w_cursor.lnum
					l_line.ce_gets ((memline_inst.ml_get_curline))
					a_col.item := 0
					l_s.ce_gets (charset_inst.skipwhite (l_line))
					if (l_s.item).to_integer_32 = 35 then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_s.ce_gets (cin_skipcomment (l_s))
						if (l_s.item).to_integer_32 = 0 then
							Result := 0
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 19 -- skip if block
					end
				when 1 then -- if:
						l_class_or_struct := 0
						l_lookfor_ctor_init := l_class_or_struct
						l_cpp_base_class := l_lookfor_ctor_init
						from
						until
							not (not js.loop_left and then (l_lnum > 1))
						loop
							js.reset
							l_line.ce_gets (memline_inst.ml_get (l_lnum - 1))
							l_s.ce_gets (charset_inst.skipwhite (l_line))
							if (l_s.item).to_integer_32 = 35 then
								js.break
							elseif (l_s.item).to_integer_32 = 0 then
								js.break
							end
							if not js.loop_jumped then
								from
								until
									not (not js.loop_left and then ((l_s.item).to_integer_32 /= 0))
								loop
									js.reset
									l_s.ce_gets (cin_skipcomment (l_s))
									if (l_s.item).to_integer_32 = 123 then
										js.break
									elseif (l_s.item).to_integer_32 = 125 then
										js.break
									elseif (l_s.item).to_integer_32 = 59 then
										if (cin_nocode (l_s + 1)).to_boolean then
											js.break
										end
									end
									if not js.loop_jumped and then ((l_s.item).to_integer_32 /= 0) then
										l_s.ce_gets (l_s + 1)
									end
								end
								js.reset
								if (l_s.item).to_integer_32 /= 0 then
									js.break
								end
							end
							if not js.loop_jumped then
								l_lnum := l_lnum - 1
							end
						end
						js.reset
						l_line.ce_gets (memline_inst.ml_get (l_lnum))
						l_s.ce_gets (cin_skipcomment (l_line))
				when 2 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 18 -- skip loop
						end
				when 3 then -- loop body:
						js.reset
						if (l_s.item).to_integer_32 = 0 then
							if l_lnum = globals_inst.curwin.item.w_cursor.lnum then
								js.break
							end
							if not js.loop_jumped then
								l_lnum := l_lnum + 1
								l_line.ce_gets (memline_inst.ml_get (l_lnum))
								l_s.ce_gets (cin_skipcomment (l_line))
								if (l_s.item).to_integer_32 = 0 then
									js.continue
								end
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 17 -- skip if block
						end
				when 4 then -- if:
						if (l_s[0]).to_integer_32 /= 58 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if (l_s[1]).to_integer_32 = 58 then
							l_lookfor_ctor_init := 0
							l_s.ce_gets (cin_skipcomment (l_s + 2))
						elseif l_lookfor_ctor_init.to_boolean then
							l_cpp_base_class := 1
							l_class_or_struct := 0
							l_lookfor_ctor_init := l_class_or_struct
							a_col.item := 0
							l_s.ce_gets (cin_skipcomment (l_s + 1))
						elseif l_class_or_struct.to_boolean then
							l_cpp_base_class := 1
							l_class_or_struct := 0
							l_lookfor_ctor_init := l_class_or_struct
							a_col.item := 0
							l_s.ce_gets (cin_skipcomment (l_s + 1))
						else
							l_s.ce_gets (cin_skipcomment (l_s + 1))
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 7 then -- else:
						if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_s), ce_string ("class"), (5).to_natural_32)) /= 0 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						if (charset_inst.vim_isIDc ((l_s[5]).to_integer_32)).to_boolean then
							l_pos := -1 + 10 -- goto _L___1
						else
							l_pos := -1 + 14 -- goto _L
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 10 then -- else: | _L___1:
						if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_s), ce_string ("struct"), (6).to_natural_32)) /= 0 then
							l_pos := -1 + 16 -- skip if block
						end
				when 11 then -- if:
						if not ((charset_inst.vim_isIDc ((l_s[6]).to_integer_32)).to_boolean) then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:
						l_pos := -1 + 16 -- goto _L___0
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 14 then -- else: | _L:
						l_class_or_struct := 1
						l_lookfor_ctor_init := 0
						if (l_s.item).to_integer_32 = 99 then
							l_s.ce_gets (cin_skipcomment (l_s + 5))
						else
							l_s.ce_gets (cin_skipcomment (l_s + 6))
						end
				when 15 then -- if done | if block done, skip else block:
						l_pos := -1 + 17
				when 16 then -- else: | _L___0:
						if (l_s[0]).to_integer_32 = 123 then
							l_class_or_struct := 0
							l_lookfor_ctor_init := l_class_or_struct
							l_cpp_base_class := l_lookfor_ctor_init
						elseif (l_s[0]).to_integer_32 = 125 then
							l_class_or_struct := 0
							l_lookfor_ctor_init := l_class_or_struct
							l_cpp_base_class := l_lookfor_ctor_init
						elseif (l_s[0]).to_integer_32 = 59 then
							l_class_or_struct := 0
							l_lookfor_ctor_init := l_class_or_struct
							l_cpp_base_class := l_lookfor_ctor_init
						elseif (l_s[0]).to_integer_32 = 41 then
							l_class_or_struct := 0
							l_lookfor_ctor_init := 1
						elseif (l_s[0]).to_integer_32 = 63 then
							Result := 0
							js.return
						elseif (charset_inst.vim_isIDc ((l_s[0]).to_integer_32)).to_boolean then
							if a_col.item = 0 then
								l_lookfor_ctor_init := 0
								if l_cpp_base_class.to_boolean then
									a_col.item := l_s.distance (l_line)
								end
							end
						else
							l_class_or_struct := 0
							l_lookfor_ctor_init := 0
						end
						if not js.return_called then
							if l_lnum = globals_inst.curwin.item.w_cursor.lnum then
								if (l_s.item).to_integer_32 = 44 then
									if (cin_nocode (l_s + 1)).to_boolean then
										a_col.item := 0
									end
								end
							end
							l_s.ce_gets (cin_skipcomment (l_s + 1))
						end
				when 17 then -- if done | if done | if done
						if not js.loop_left then
							
						end
						l_pos := -1 + 2 -- back to loop condition
				when 18 then -- loop done
						js.reset
				when 19 then -- if done
					if not js.return_called then
						Result := l_cpp_base_class
					end
				when 20 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_baseclass_amount (a_col: INTEGER_32; a_ind_maxparen: INTEGER_32; a_ind_maxcomment: INTEGER_32; a_ind_cpp_baseclass: INTEGER_32): INTEGER_32
		local
			l_amount: INTEGER_32
			l_vcol: INTEGER_32
			l_trypos: CE_POINTER [PD_POS_T]
		do
			create l_trypos.make

			if a_col = 0 then
				l_amount := get_indent
				if (find_last_paren ((memline_inst.ml_get_curline), ('(').code, (')').code)).to_boolean then
					l_trypos.ce_gets (find_match_paren (a_ind_maxparen, a_ind_maxcomment))
					if (l_trypos.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						l_amount := get_indent_lnum (l_trypos.item.lnum)
					end
				end
				if not (cin_ends_in ((memline_inst.ml_get_curline), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (",")), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))).to_boolean then
					l_amount := l_amount + a_ind_cpp_baseclass
				end
			else
				globals_inst.curwin.item.w_cursor.col := a_col
				charset_inst.getvcol (globals_inst.curwin, create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curwin.c_pointer + {PD_WINDOW_S}.w_cursor_offset), create {CE_POINTER [INTEGER_32]}.make_shared ($l_vcol), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
				l_amount := l_vcol
			end
			if l_amount < a_ind_cpp_baseclass then
				l_amount := a_ind_cpp_baseclass
			end
			Result := l_amount
		end

	cin_ends_in (a_s: CE_POINTER [NATURAL_8]; a_find: CE_POINTER [NATURAL_8]; a_ignore___0: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_r: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			js: JUMP_STATE
		do
			create l_p___0.make
			create l_r.make

			l_p___0.ce_gets (a_s)
			l_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_find))).to_integer_32
			from
			until
				not (not js.loop_left and then ((l_p___0.item).to_integer_32 /= 0))
			loop
				l_p___0.ce_gets (cin_skipcomment (l_p___0))
				if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), create {CE_POINTER [INTEGER_8]}.make_cast (a_find), l_len.to_natural_32)) = 0 then
					l_r.ce_gets (charset_inst.skipwhite (l_p___0 + l_len))
					if (a_ignore___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_r), create {CE_POINTER [INTEGER_8]}.make_cast (a_ignore___0), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_ignore___0))))) = 0 then
							l_r.ce_gets (charset_inst.skipwhite (l_r + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_ignore___0))).to_integer_32))
						end
					end
					if (cin_nocode (l_r)).to_boolean then
						Result := 1
						js.return
					end
				end
				if not js.return_called and then ((l_p___0.item).to_integer_32 /= 0) then
					l_p___0.ce_gets (l_p___0 + 1)
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	cin_skip2pos (a_trypos: CE_POINTER [PD_POS_T]): INTEGER_32
		local
			l_line: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_line.make
			create l_p___0.make

			l_line.ce_gets (memline_inst.ml_get (a_trypos.item.lnum))
			l_p___0.ce_gets (l_line)
			from
			until
				js.loop_left
			loop
				js.reset
				if (l_p___0.item).to_boolean then
					if not (l_p___0.distance (l_line) < a_trypos.item.col) then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					if (cin_iscomment (l_p___0)).to_boolean then
						l_p___0.ce_gets (cin_skipcomment (l_p___0))
					else
						l_p___0.ce_gets (skip_string (l_p___0))
						l_p___0.ce_gets (l_p___0 + 1)
					end
				end
			end
			js.reset
			Result := (l_p___0.distance (l_line))
		end

	find_start_brace (a_ind_maxcomment: INTEGER_32): CE_POINTER [PD_POS_T]
		local
			l_cursor_save: PD_POS_T
			l_trypos: CE_POINTER [PD_POS_T]
			l_pos___3: CE_POINTER [PD_POS_T]
			js: JUMP_STATE
		do
			create l_cursor_save.make
			create l_trypos.make
			create l_pos___3.make

			l_cursor_save.ce_gets (globals_inst.curwin.item.w_cursor)
			from
			until
				js.loop_left
			loop
				js.reset
				l_trypos.ce_gets (search_inst.findmatchlimit (create {CE_POINTER [PD_OPARG_S]}.make_shared (default_pointer), ('{').code, 4, 0))
				if (l_trypos.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					js.break
				end
				if not js.loop_jumped then
					pos_copy___0.ce_gets (l_trypos.item)
					l_trypos.ce_gets (pos_copy___0.address)
					globals_inst.curwin.item.w_cursor := l_trypos.item
					l_pos___3.ce_gets (create {CE_POINTER [PD_POS_T]}.make_shared (default_pointer))
					if (cin_skip2pos (l_trypos)) = l_trypos.item.col then
						l_pos___3.ce_gets (find_start_comment (a_ind_maxcomment))
						if (l_pos___3.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							js.break
						end
					end
				end
				if not js.loop_jumped and then ((l_pos___3.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32) then
					globals_inst.curwin.item.w_cursor.lnum := l_pos___3.item.lnum
				end
			end
			js.reset
			globals_inst.curwin.item.w_cursor := l_cursor_save
			Result := l_trypos
		end

	find_match_paren (a_ind_maxparen: INTEGER_32; a_ind_maxcomment: INTEGER_32): CE_POINTER [PD_POS_T]
		local
			l_cursor_save: PD_POS_T
			l_trypos: CE_POINTER [PD_POS_T]
		do
			create l_cursor_save.make
			create l_trypos.make

			l_cursor_save.ce_gets (globals_inst.curwin.item.w_cursor)
			l_trypos.ce_gets (search_inst.findmatchlimit (create {CE_POINTER [PD_OPARG_S]}.make_shared (default_pointer), ('(').code, 0, a_ind_maxparen))
			if (l_trypos.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				if (cin_skip2pos (l_trypos)) > l_trypos.item.col then
					l_trypos.ce_gets (create {CE_POINTER [PD_POS_T]}.make_shared (default_pointer))
				else
					pos_copy___1.ce_gets (l_trypos.item)
					l_trypos.ce_gets (pos_copy___1.address)
					globals_inst.curwin.item.w_cursor := l_trypos.item
					if ((find_start_comment (a_ind_maxcomment)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						l_trypos.ce_gets (create {CE_POINTER [PD_POS_T]}.make_shared (default_pointer))
					end
				end
			end
			globals_inst.curwin.item.w_cursor := l_cursor_save
			Result := l_trypos
		end

	corr_ind_maxparen (a_ind_maxparen: INTEGER_32; a_startpos: CE_POINTER [PD_POS_T]): INTEGER_32
		local
			l_n: INTEGER_32
			js: JUMP_STATE
		do
			l_n := a_startpos.item.lnum - globals_inst.curwin.item.w_cursor.lnum
			if l_n > 0 then
				if l_n < (a_ind_maxparen // 2).to_integer_32 then
					Result := (a_ind_maxparen - l_n.to_integer_32)
					js.return
				end
			end
			if not js.return_called then
				Result := a_ind_maxparen
			end
		end

	find_last_paren (a_l: CE_POINTER [NATURAL_8]; a_start___1: INTEGER_32; a_end: INTEGER_32): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_retval: INTEGER_32
			l_open_count: INTEGER_32
		do
			l_retval := 0
			l_open_count := 0
			globals_inst.curwin.item.w_cursor.col := 0
			l_i___0 := 0
			from
			until
				not ((a_l[l_i___0]).to_boolean)
			loop
				l_i___0 := (cin_skipcomment (a_l + l_i___0)).distance (a_l)
				l_i___0 := (skip_string (a_l + l_i___0)).distance (a_l)
				if (a_l[l_i___0]).to_integer_32 = a_start___1 then
					l_open_count := l_open_count + 1
				elseif (a_l[l_i___0]).to_integer_32 = a_end then
					if l_open_count > 0 then
						l_open_count := l_open_count - 1
					else
						globals_inst.curwin.item.w_cursor.col := l_i___0
						l_retval := 1
					end
				end
				l_i___0 := l_i___0 + 1
			end
			Result := l_retval
		end

	get_c_indent: INTEGER_32
		local
			l_ind_level: INTEGER_32
			l_ind_open_imag: INTEGER_32
			l_ind_no_brace: INTEGER_32
			l_ind_first_open: INTEGER_32
			l_ind_open_extra: INTEGER_32
			l_ind_close_extra: INTEGER_32
			l_ind_open_left_imag: INTEGER_32
			l_ind_jump_label: INTEGER_32
			l_ind_case: INTEGER_32
			l_ind_case_code: INTEGER_32
			l_ind_case_break: INTEGER_32
			l_ind_scopedecl: INTEGER_32
			l_ind_scopedecl_code: INTEGER_32
			l_ind_param: INTEGER_32
			l_ind_func_type: INTEGER_32
			l_ind_cpp_baseclass: INTEGER_32
			l_ind_continuation: INTEGER_32
			l_ind_unclosed: INTEGER_32
			l_ind_unclosed2: INTEGER_32
			l_ind_unclosed_noignore: INTEGER_32
			l_ind_unclosed_wrapped: INTEGER_32
			l_ind_unclosed_whiteok: INTEGER_32
			l_ind_matching_paren: INTEGER_32
			l_ind_paren_prev: INTEGER_32
			l_ind_comment: INTEGER_32
			l_ind_in_comment: INTEGER_32
			l_ind_in_comment2: INTEGER_32
			l_ind_maxparen: INTEGER_32
			l_ind_maxcomment: INTEGER_32
			l_ind_java: INTEGER_32
			l_ind_js: INTEGER_32
			l_ind_keep_case_label: INTEGER_32
			l_cur_curpos: PD_POS_T
			l_amount: INTEGER_32
			l_scope_amount: INTEGER_32
			l_cur_amount: INTEGER_32
			l_col: INTEGER_32
			l_theline: CE_POINTER [NATURAL_8]
			l_linecopy___0: CE_POINTER [NATURAL_8]
			l_trypos: CE_POINTER [PD_POS_T]
			l_tryposBrace: CE_POINTER [PD_POS_T]
			l_our_paren_pos: PD_POS_T
			l_start___1: CE_POINTER [NATURAL_8]
			l_start_brace: INTEGER_32
			l_ourscope: INTEGER_32
			l_l: CE_POINTER [NATURAL_8]
			l_look: CE_POINTER [NATURAL_8]
			l_terminated: NATURAL_8
			l_lookfor: INTEGER_32
			l_whilelevel: INTEGER_32
			l_lnum: INTEGER_32
			l_options___0: CE_POINTER [NATURAL_8]
			l_fraction: INTEGER_32
			l_divider: INTEGER_32
			l_n: INTEGER_32
			l_iscase: INTEGER_32
			l_lookfor_break: INTEGER_32
			l_cont_amount: INTEGER_32
			l_original_line_islabel: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
			l_lead_start_len: INTEGER_32
			l_lead_middle_len: INTEGER_32
			l_lead_start: CE_ARRAY [NATURAL_8]
			l_lead_middle: CE_ARRAY [NATURAL_8]
			l_lead_end: CE_ARRAY [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_start_align: INTEGER_32
			l_start_off: INTEGER_32
			l_done___2: INTEGER_32
			l_align: INTEGER_32
			l_off___0: INTEGER_32
			l_what: INTEGER_32
			l_tmp___4: CE_POINTER [NATURAL_8]
			l_tmp___5: CE_POINTER [NATURAL_8]
			l_tmp___6: INTEGER_32
			l_tmp___14: INTEGER_32
			l_tmp___19: INTEGER_32
			l_tmp___26: INTEGER_32
			l_ignore_paren_col: INTEGER_32
			l_save_lnum: INTEGER_32
			l_line: CE_POINTER [NATURAL_8]
			l_look_col: INTEGER_32
			l_tmp___54: INTEGER_32
			l_tmp___55: INTEGER_32
			l_tmp___88: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_cur_curpos.make
			create l_theline.make
			create l_linecopy___0.make
			create l_trypos.make
			create l_tryposBrace.make
			create l_our_paren_pos.make
			create l_start___1.make
			create l_l.make
			create l_look.make
			create l_options___0.make
			create l_tmp.make
			create l_lead_start.make (<<50>>)
			create l_lead_middle.make (<<50>>)
			create l_lead_end.make (<<50>>)
			create l_p___0.make
			create l_tmp___4.make
			create l_tmp___5.make
			create l_line.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ind_level := (globals_inst.curbuf.item.b_p_sw).to_integer_32
					l_ind_open_imag := 0
					l_ind_no_brace := 0
					l_ind_first_open := 0
					l_ind_open_extra := 0
					l_ind_close_extra := 0
					l_ind_open_left_imag := 0
					l_ind_jump_label := -1
					l_ind_case := (globals_inst.curbuf.item.b_p_sw).to_integer_32
					l_ind_case_code := (globals_inst.curbuf.item.b_p_sw).to_integer_32
					l_ind_case_break := 0
					l_ind_scopedecl := (globals_inst.curbuf.item.b_p_sw).to_integer_32
					l_ind_scopedecl_code := (globals_inst.curbuf.item.b_p_sw).to_integer_32
					l_ind_param := (globals_inst.curbuf.item.b_p_sw).to_integer_32
					l_ind_func_type := (globals_inst.curbuf.item.b_p_sw).to_integer_32
					l_ind_cpp_baseclass := (globals_inst.curbuf.item.b_p_sw).to_integer_32
					l_ind_continuation := (globals_inst.curbuf.item.b_p_sw).to_integer_32
					l_ind_unclosed := (globals_inst.curbuf.item.b_p_sw * 2).to_integer_32
					l_ind_unclosed2 := (globals_inst.curbuf.item.b_p_sw).to_integer_32
					l_ind_unclosed_noignore := 0
					l_ind_unclosed_wrapped := 0
					l_ind_unclosed_whiteok := 0
					l_ind_matching_paren := 0
					l_ind_paren_prev := 0
					l_ind_comment := 0
					l_ind_in_comment := 3
					l_ind_in_comment2 := 0
					l_ind_maxparen := 20
					l_ind_maxcomment := 70
					l_ind_java := 0
					l_ind_js := 0
					l_ind_keep_case_label := 0
					l_cur_amount := 2147483647
					l_tryposBrace.ce_gets (create {CE_POINTER [PD_POS_T]}.make_shared (default_pointer))
					l_fraction := 0
					l_cont_amount := 0
					l_options___0.ce_gets (globals_inst.curbuf.item.b_p_cino)
				when 1 then -- loop condition:
					if not (not js.loop_left and then ((l_options___0.item).to_boolean)) then
						l_pos := -1 + 43 -- skip loop
					end
				when 2 then -- loop body:
						l_tmp.ce_gets (l_options___0)
						l_options___0.ce_gets (l_options___0 + 1)
						l_l.ce_gets (l_tmp)
						if (l_options___0.item).to_integer_32 = 45 then
							l_options___0.ce_gets (l_options___0 + 1)
						end
						l_n := (charset_inst.getdigits (l_options___0.address)).to_integer_32
						l_divider := 0
						if (l_options___0.item).to_integer_32 = 46 then
							l_options___0.ce_gets (l_options___0 + 1)
							l_fraction := (atol (create {CE_POINTER [INTEGER_8]}.make_cast (l_options___0))).to_integer_32
							from
							until
								js.loop_left
							loop
								js.reset
								if (l_options___0.item).to_integer_32 >= 48 then
									if not ((l_options___0.item).to_integer_32 <= 57) then
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped then
									l_options___0.ce_gets (l_options___0 + 1)
									if l_divider.to_boolean then
										l_divider := l_divider * (10)
									else
										l_divider := 10
									end
								end
							end
							js.reset
						end
						if (l_options___0.item).to_integer_32 /= 115 then
							l_pos := -1 + 8 -- skip if block
						end
				when 3 then -- if:
						if l_n /= 0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if l_fraction = 0 then
							l_n := (globals_inst.curbuf.item.b_p_sw).to_integer_32
						else
							l_pos := -1 + 6 -- goto _L
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L:
						l_n := (l_n.to_integer_32 * globals_inst.curbuf.item.b_p_sw).to_integer_32
						if l_divider.to_boolean then
							l_n := (l_n.to_integer_32 + (globals_inst.curbuf.item.b_p_sw * l_fraction.to_integer_32 + (l_divider // 2).to_integer_32) // l_divider.to_integer_32).to_integer_32
						end
				when 7 then
						l_options___0.ce_gets (l_options___0 + 1)
				when 8 then -- if done
						if (l_l[1]).to_integer_32 = 45 then
							l_n := -l_n
						end
						inspect (l_l.item).to_integer_32 -- switch 1 head
						when 62 then l_pos := -1 + 9
						when 101 then l_pos := -1 + 10
						when 110 then l_pos := -1 + 11
						when 102 then l_pos := -1 + 12
						when 123 then l_pos := -1 + 13
						when 125 then l_pos := -1 + 14
						when 94 then l_pos := -1 + 15
						when 76 then l_pos := -1 + 16
						when 58 then l_pos := -1 + 17
						when 61 then l_pos := -1 + 18
						when 98 then l_pos := -1 + 19
						when 112 then l_pos := -1 + 20
						when 116 then l_pos := -1 + 21
						when 47 then l_pos := -1 + 22
						when 99 then l_pos := -1 + 23
						when 67 then l_pos := -1 + 24
						when 105 then l_pos := -1 + 25
						when 43 then l_pos := -1 + 26
						when 40 then l_pos := -1 + 27
						when 117 then l_pos := -1 + 28
						when 85 then l_pos := -1 + 29
						when 87 then l_pos := -1 + 30
						when 119 then l_pos := -1 + 31
						when 109 then l_pos := -1 + 32
						when 77 then l_pos := -1 + 33
						when 41 then l_pos := -1 + 34
						when 42 then l_pos := -1 + 35
						when 103 then l_pos := -1 + 36
						when 104 then l_pos := -1 + 37
						when 106 then l_pos := -1 + 38
						when 74 then l_pos := -1 + 39
						when 108 then l_pos := -1 + 40
						when 35 then l_pos := -1 + 41
						else l_pos := -1 + 42
						end
				when 9 then -- switch 1, case 62
						l_ind_level := l_n
						l_pos := -1 + 42 -- switch 1; break
				when 10 then -- switch 1, case 101
						l_ind_open_imag := l_n
						l_pos := -1 + 42 -- switch 1; break
				when 11 then -- switch 1, case 110
						l_ind_no_brace := l_n
						l_pos := -1 + 42 -- switch 1; break
				when 12 then -- switch 1, case 102
						l_ind_first_open := l_n
						l_pos := -1 + 42 -- switch 1; break
				when 13 then -- switch 1, case 123
						l_ind_open_extra := l_n
						l_pos := -1 + 42 -- switch 1; break
				when 14 then -- switch 1, case 125
						l_ind_close_extra := l_n
						l_pos := -1 + 42 -- switch 1; break
				when 15 then -- switch 1, case 94
						l_ind_open_left_imag := l_n
						l_pos := -1 + 42 -- switch 1; break
				when 16 then -- switch 1, case 76
						l_ind_jump_label := l_n
						l_pos := -1 + 42 -- switch 1; break
				when 17 then -- switch 1, case 58
						l_ind_case := l_n
						l_pos := -1 + 42 -- switch 1; break
				when 18 then -- switch 1, case 61
						l_ind_case_code := l_n
						l_pos := -1 + 42 -- switch 1; break
				when 19 then -- switch 1, case 98
						l_ind_case_break := l_n
						l_pos := -1 + 42 -- switch 1; break
				when 20 then -- switch 1, case 112
						l_ind_param := l_n
						l_pos := -1 + 42 -- switch 1; break
				when 21 then -- switch 1, case 116
						l_ind_func_type := l_n
						l_pos := -1 + 42 -- switch 1; break
				when 22 then -- switch 1, case 47
						l_ind_comment := l_n
						l_pos := -1 + 42 -- switch 1; break
				when 23 then -- switch 1, case 99
						l_ind_in_comment := l_n
						l_pos := -1 + 42 -- switch 1; break
				when 24 then -- switch 1, case 67
						l_ind_in_comment2 := l_n
						l_pos := -1 + 42 -- switch 1; break
				when 25 then -- switch 1, case 105
						l_ind_cpp_baseclass := l_n
						l_pos := -1 + 42 -- switch 1; break
				when 26 then -- switch 1, case 43
						l_ind_continuation := l_n
						l_pos := -1 + 42 -- switch 1; break
				when 27 then -- switch 1, case 40
						l_ind_unclosed := l_n
						l_pos := -1 + 42 -- switch 1; break
				when 28 then -- switch 1, case 117
						l_ind_unclosed2 := l_n
						l_pos := -1 + 42 -- switch 1; break
				when 29 then -- switch 1, case 85
						l_ind_unclosed_noignore := l_n
						l_pos := -1 + 42 -- switch 1; break
				when 30 then -- switch 1, case 87
						l_ind_unclosed_wrapped := l_n
						l_pos := -1 + 42 -- switch 1; break
				when 31 then -- switch 1, case 119
						l_ind_unclosed_whiteok := l_n
						l_pos := -1 + 42 -- switch 1; break
				when 32 then -- switch 1, case 109
						l_ind_matching_paren := l_n
						l_pos := -1 + 42 -- switch 1; break
				when 33 then -- switch 1, case 77
						l_ind_paren_prev := l_n
						l_pos := -1 + 42 -- switch 1; break
				when 34 then -- switch 1, case 41
						l_ind_maxparen := l_n
						l_pos := -1 + 42 -- switch 1; break
				when 35 then -- switch 1, case 42
						l_ind_maxcomment := l_n
						l_pos := -1 + 42 -- switch 1; break
				when 36 then -- switch 1, case 103
						l_ind_scopedecl := l_n
						l_pos := -1 + 42 -- switch 1; break
				when 37 then -- switch 1, case 104
						l_ind_scopedecl_code := l_n
						l_pos := -1 + 42 -- switch 1; break
				when 38 then -- switch 1, case 106
						l_ind_java := l_n
						l_pos := -1 + 42 -- switch 1; break
				when 39 then -- switch 1, case 74
						l_ind_js := l_n
						l_pos := -1 + 42 -- switch 1; break
				when 40 then -- switch 1, case 108
						l_ind_keep_case_label := l_n
						l_pos := -1 + 42 -- switch 1; break
				when 41 then -- switch 1, case 35
						ind_hash_comment := l_n
						l_pos := -1 + 42 -- switch 1; break
				when 42 then -- switch 1, done:
						if (l_options___0.item).to_integer_32 = 44 then
							l_options___0.ce_gets (l_options___0 + 1)
						end
						l_pos := -1 + 1 -- back to loop condition
				when 43 then -- loop done
					l_cur_curpos.ce_gets (globals_inst.curwin.item.w_cursor)
					if l_cur_curpos.lnum = 1 then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_linecopy___0.ce_gets (misc2_inst.vim_strsave ((memline_inst.ml_get (l_cur_curpos.lnum))))
						if (l_linecopy___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							Result := 0
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 271 -- skip if block
					end
				when 44 then -- if:
						if ((globals_inst.State).bit_and (16)).to_boolean then
							if globals_inst.curwin.item.w_cursor.col < (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_linecopy___0))).to_integer_32 then
								if (l_linecopy___0[globals_inst.curwin.item.w_cursor.col]).to_integer_32 = 41 then
									l_linecopy___0[globals_inst.curwin.item.w_cursor.col] := (('%/0/').code).to_natural_8
								end
							end
						end
						l_theline.ce_gets (charset_inst.skipwhite (l_linecopy___0))
						globals_inst.curwin.item.w_cursor.col := 0
						l_original_line_islabel := cin_islabel (l_ind_maxcomment)
						if (l_theline.item).to_integer_32 /= 35 then
							l_pos := -1 + 47 -- skip if block
						end
				when 45 then -- if:
						if (l_linecopy___0.item).to_integer_32 = 35 then
							l_amount := 0
						elseif (edit_inst.in_cinkeys (('#').code, (' ').code, 1)).to_boolean then
							l_amount := 0
						else
							l_pos := -1 + 47 -- goto _L___37
						end
				when 46 then -- if block done, skip else block:
						l_pos := -1 + 270
				when 47 then -- else: | _L___37:
						if not (l_original_line_islabel.to_boolean) then
							l_pos := -1 + 50 -- skip if block
						end
				when 48 then -- if:
						if not l_ind_js.to_boolean then
							if l_ind_jump_label < 0 then
								l_amount := 0
							else
								l_pos := -1 + 50 -- goto _L___36
							end
						else
							l_pos := -1 + 50 -- goto _L___36
						end
				when 49 then -- if block done, skip else block:
						l_pos := -1 + 270
				when 50 then -- else: | _L___36:
						if not ((cin_islinecomment (l_theline)).to_boolean) then
							l_pos := -1 + 53 -- skip if block
						end
				when 51 then -- if:
						l_trypos.ce_gets (find_line_comment)
						if (l_trypos.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							charset_inst.getvcol (globals_inst.curwin, l_trypos, create {CE_POINTER [INTEGER_32]}.make_shared ($l_col), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
							l_amount := l_col
						else
							l_pos := -1 + 53 -- goto _L___34
						end
				when 52 then -- if block done, skip else block:
						l_pos := -1 + 270
				when 53 then -- else: | _L___34:
						if not ((cin_iscomment (l_theline)).to_boolean) then
							l_pos := -1 + 240 -- skip if block
						end
				when 54 then -- if: | _L___33:
						l_trypos.ce_gets (find_match_paren (l_ind_maxparen, l_ind_maxcomment))
						if (l_trypos.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 57 -- skip if block
						end
				when 55 then -- if:
						if l_ind_java = 0 then
							l_pos := -1 + 61 -- goto _L___31
						else
							l_pos := -1 + 57 -- goto _L___32
						end
				when 56 then -- if block done, skip else block:
						l_pos := -1 + 239
				when 57 then -- else: | _L___32:
						l_tryposBrace.ce_gets (find_start_brace (l_ind_maxcomment))
						if (l_tryposBrace.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 60 -- skip if block
						end
				when 58 then -- if:
						l_pos := -1 + 61 -- goto _L___31
				when 59 then -- if block done, skip else block:
						l_pos := -1 + 239
				when 60 then -- else:
						if (l_trypos.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 222 -- skip if block
						end
				when 61 then -- if: | _L___31:
						if (l_trypos.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							if (l_tryposBrace.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								if l_trypos.item.lnum /= l_tryposBrace.item.lnum then
									l_tmp___26 := (l_trypos.item.lnum < l_tryposBrace.item.lnum).to_integer
								else
									l_tmp___26 := (l_trypos.item.col < l_tryposBrace.item.col).to_integer
								end
								if l_tmp___26.to_boolean then
									l_trypos.ce_gets (create {CE_POINTER [PD_POS_T]}.make_shared (default_pointer))
								else
									l_tryposBrace.ce_gets (create {CE_POINTER [PD_POS_T]}.make_shared (default_pointer))
								end
							end
						end
						if (l_trypos.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 115 -- skip if block
						end
				when 62 then -- if:
						if (l_theline[0]).to_integer_32 /= 41 then
							l_pos := -1 + 65 -- skip if block
						end
				when 63 then -- if:
						if l_ind_paren_prev.to_boolean then
							l_amount := get_indent_lnum (globals_inst.curwin.item.w_cursor.lnum - 1)
						else
							l_pos := -1 + 65 -- goto _L___1
						end
				when 64 then -- if block done, skip else block:
						l_pos := -1 + 66
				when 65 then -- else: | _L___1:
						l_amount := -1
						l_our_paren_pos.ce_gets (l_trypos.item)
						l_lnum := l_cur_curpos.lnum - 1
						from
						until
							not (not js.loop_left and then (l_lnum > l_our_paren_pos.lnum))
						loop
							js.reset
							l_l.ce_gets (charset_inst.skipwhite ((memline_inst.ml_get (l_lnum))))
							if (cin_nocode (l_l)).to_boolean then
								js.continue
							end
							if not js.loop_jumped then
								if (cin_ispreproc_cont (l_l.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_lnum))).to_boolean then
									js.continue
								end
							end
							if not js.loop_jumped then
								globals_inst.curwin.item.w_cursor.lnum := l_lnum
								l_trypos.ce_gets (find_start_comment (l_ind_maxcomment))
								if (l_trypos.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									l_lnum := l_trypos.item.lnum + 1
									js.continue
								end
							end
							if not js.loop_jumped then
								l_trypos.ce_gets (find_match_paren ((corr_ind_maxparen (l_ind_maxparen, l_cur_curpos.address)), l_ind_maxcomment))
								if (l_trypos.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									if l_trypos.item.lnum = l_our_paren_pos.lnum then
										if l_trypos.item.col = l_our_paren_pos.col then
											l_amount := get_indent_lnum (l_lnum)
											if (l_theline[0]).to_integer_32 = 41 then
												if l_our_paren_pos.lnum /= l_lnum then
													if l_cur_amount > l_amount then
														l_cur_amount := l_amount
													end
												end
												l_amount := -1
											end
											js.break
										end
									end
								end
							end
							if not js.loop_left then
								l_lnum := l_lnum - 1
							end
						end
						js.reset
				when 66 then
						if l_amount /= -1 then
							l_pos := -1 + 113 -- skip if block
						end
				when 67 then -- if:
						l_ignore_paren_col := 0
						l_amount := skip_label (l_our_paren_pos.lnum, l_look.address, l_ind_maxcomment)
						l_look.ce_gets (charset_inst.skipwhite (l_look))
						if (l_look.item).to_integer_32 = 40 then
							l_save_lnum := globals_inst.curwin.item.w_cursor.lnum
							globals_inst.curwin.item.w_cursor.lnum := l_our_paren_pos.lnum
							l_line.ce_gets (memline_inst.ml_get_curline)
							l_look_col := l_look.distance (l_line)
							globals_inst.curwin.item.w_cursor.col := l_look_col + 1
							l_trypos.ce_gets (search_inst.findmatchlimit (create {CE_POINTER [PD_OPARG_S]}.make_shared (default_pointer), (')').code, 0, l_ind_maxparen))
							if (l_trypos.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								if l_trypos.item.lnum = l_our_paren_pos.lnum then
									if l_trypos.item.col < l_our_paren_pos.col then
										l_ignore_paren_col := l_trypos.item.col + 1
									end
								end
							end
							globals_inst.curwin.item.w_cursor.lnum := l_save_lnum
							l_look.ce_gets ((memline_inst.ml_get (l_our_paren_pos.lnum)) + l_look_col)
						end
						if (l_theline[0]).to_integer_32 /= 41 then
							l_pos := -1 + 70 -- skip if block
						end
				when 68 then -- if:
						l_pos := -1 + 76 -- goto _L___3
				when 69 then -- if block done, skip else block:
						l_pos := -1 + 91
				when 70 then -- else:
						if l_ind_unclosed /= 0 then
							l_pos := -1 + 73 -- skip if block
						end
				when 71 then -- if:
						l_pos := -1 + 76 -- goto _L___3
				when 72 then -- if block done, skip else block:
						l_pos := -1 + 91
				when 73 then -- else:
						if l_ind_unclosed_noignore.to_boolean then
							l_pos := -1 + 91 -- skip if block
						end
				when 74 then -- if:
						if (l_look.item).to_integer_32 /= 40 then
							l_pos := -1 + 91 -- skip if block
						end
				when 75 then -- if:
						if l_ignore_paren_col /= 0 then
							l_pos := -1 + 91 -- skip if block
						end
				when 76 then -- if: | _L___3:
						if (l_theline[0]).to_integer_32 = 41 then
							l_pos := -1 + 90 -- skip if block
						end
				when 77 then -- if:
						l_cur_amount := 2147483647
						l_l.ce_gets (memline_inst.ml_get (l_our_paren_pos.lnum))
						if not (l_ind_unclosed_wrapped.to_boolean) then
							l_pos := -1 + 89 -- skip if block
						end
				when 78 then -- if:
						if not ((cin_ends_in (l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("(")), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))).to_boolean) then
							l_pos := -1 + 87 -- skip if block
						end
				when 79 then -- if:
						l_n := 1
						l_col := 0
				when 80 then -- loop condition:
						if not (l_col < l_our_paren_pos.col) then
							l_pos := -1 + 85 -- skip loop
						end
				when 81 then -- loop body:
						inspect (l_l[l_col]).to_integer_32 -- switch 2 head
						when 40 then l_pos := -1 + 82
						when 123 then l_pos := -1 + 82
						when 41 then l_pos := -1 + 83
						when 125 then l_pos := -1 + 83
						else l_pos := -1 + 84
						end
				when 82 then -- switch 2, case 40 | switch 2, case 123
						l_n := l_n + 1
						l_pos := -1 + 84 -- switch 2; break
				when 83 then -- switch 2, case 41 | switch 2, case 125
						if l_n > 1 then
							l_n := l_n - 1
						end
						l_pos := -1 + 84 -- switch 2; break
				when 84 then -- switch 2, done:
						l_col := l_col + 1
						l_pos := -1 + 80 -- back to loop condition
				when 85 then -- loop done
						l_our_paren_pos.col := 0
						l_amount := l_amount + (l_n * l_ind_unclosed_wrapped)
				when 86 then -- if block done, skip else block:
						l_pos := -1 + 88
				when 87 then -- else:
						l_pos := -1 + 89 -- goto _L___2
				when 88 then -- if done | if block done, skip else block:
						l_pos := -1 + 90
				when 89 then -- else: | _L___2:
						if l_ind_unclosed_whiteok.to_boolean then
							l_our_paren_pos.col := (l_our_paren_pos.col) + 1
						else
							l_col := l_our_paren_pos.col + 1
							from
							until
								js.loop_left
							loop
								js.reset
								if (l_l[l_col]).to_integer_32 /= 32 then
									if (l_l[l_col]).to_integer_32 /= 9 then
										js.break
									end
								end
								if not js.loop_jumped then
									l_col := l_col + 1
								end
							end
							js.reset
							if (l_l[l_col]).to_integer_32 /= 0 then
								l_our_paren_pos.col := l_col
							else
								l_our_paren_pos.col := (l_our_paren_pos.col) + 1
							end
						end
				when 90 then -- if done
						if l_our_paren_pos.col > 0 then
							charset_inst.getvcol (globals_inst.curwin, l_our_paren_pos.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_col), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
							if l_cur_amount > l_col then
								l_cur_amount := l_col
							end
						end
				when 91 then -- if done | if done | if done | if done
						if (l_theline[0]).to_integer_32 /= 41 then
							l_pos := -1 + 94 -- skip if block
						end
				when 92 then -- if:
						if not l_ind_matching_paren.to_boolean then
							l_pos := -1 + 94 -- goto _L___7
						end
				when 93 then -- if block done, skip else block:
						l_pos := -1 + 113
				when 94 then -- else: | _L___7:
						if l_ind_unclosed /= 0 then
							l_pos := -1 + 97 -- skip if block
						end
				when 95 then -- if:
						l_pos := -1 + 100 -- goto _L___4
				when 96 then -- if block done, skip else block:
						l_pos := -1 + 113
				when 97 then -- else:
						if l_ind_unclosed_noignore.to_boolean then
							l_pos := -1 + 106 -- skip if block
						end
				when 98 then -- if:
						if (l_look.item).to_integer_32 /= 40 then
							l_pos := -1 + 104 -- skip if block
						end
				when 99 then -- if:
						if l_ignore_paren_col /= 0 then
							l_pos := -1 + 102 -- skip if block
						end
				when 100 then -- if: | _L___4:
						if l_cur_amount.to_integer_32 /= 2147483647 then
							l_amount := l_cur_amount
						end
				when 101 then -- if block done, skip else block:
						l_pos := -1 + 103
				when 102 then -- else:
						l_pos := -1 + 106 -- goto _L___6
				when 103 then -- if done | if block done, skip else block:
						l_pos := -1 + 105
				when 104 then -- else:
						l_pos := -1 + 106 -- goto _L___6
				when 105 then -- if done | if block done, skip else block:
						l_pos := -1 + 113
				when 106 then -- else: | _L___6:
						l_col := l_our_paren_pos.col
				when 107 then -- loop condition:
						if not (l_our_paren_pos.col > l_ignore_paren_col) then
							l_pos := -1 + 112 -- skip loop
						end
				when 108 then -- loop body:
						l_our_paren_pos.col := (l_our_paren_pos.col) - 1
						inspect ((memline_inst.ml_get_pos (l_our_paren_pos.address)).item).to_integer_32 -- switch 3 head
						when 40 then l_pos := -1 + 109
						when 41 then l_pos := -1 + 110
						else l_pos := -1 + 111
						end
				when 109 then -- switch 3, case 40
						l_amount := l_amount + l_ind_unclosed2
						l_col := l_our_paren_pos.col
						l_pos := -1 + 111 -- switch 3; break
				when 110 then -- switch 3, case 41
						l_amount := l_amount - l_ind_unclosed2
						l_col := (2147483647).to_integer_32
						l_pos := -1 + 111 -- switch 3; break
				when 111 then -- switch 3, done:
						l_pos := -1 + 107 -- back to loop condition
				when 112 then -- loop done
						if l_col.to_integer_32 = 2147483647 then
							l_amount := l_amount + l_ind_unclosed
						else
							globals_inst.curwin.item.w_cursor.lnum := l_our_paren_pos.lnum
							globals_inst.curwin.item.w_cursor.col := l_col
							l_trypos.ce_gets (find_match_paren (l_ind_maxparen, l_ind_maxcomment))
							if (l_trypos.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								l_amount := l_amount + l_ind_unclosed2
							else
								l_amount := l_amount + l_ind_unclosed
							end
						end
						if l_cur_amount < l_amount then
							l_amount := l_cur_amount
						end
				when 113 then -- if done | if done | if done
						if (cin_iscomment (l_theline)).to_boolean then
							l_amount := l_amount + l_ind_comment
						end
				when 114 then -- if block done, skip else block:
						l_pos := -1 + 220
				when 115 then -- else:
						l_trypos.ce_gets (l_tryposBrace)
						l_ourscope := l_trypos.item.lnum
						l_start___1.ce_gets (memline_inst.ml_get (l_ourscope))
						l_look.ce_gets (charset_inst.skipwhite (l_start___1))
						if (l_look.item).to_integer_32 = 123 then
							charset_inst.getvcol (globals_inst.curwin, l_trypos, create {CE_POINTER [INTEGER_32]}.make_shared ($l_col), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
							l_amount := l_col
							if (l_start___1.item).to_integer_32 = 123 then
								l_start_brace := 1
							else
								l_start_brace := 2
							end
						else
							globals_inst.curwin.item.w_cursor.lnum := l_ourscope
							l_lnum := l_ourscope
							if (find_last_paren (l_start___1, ('(').code, (')').code)).to_boolean then
								l_trypos.ce_gets (find_match_paren (l_ind_maxparen, l_ind_maxcomment))
								if (l_trypos.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									l_lnum := l_trypos.item.lnum
								end
							end
							if l_ind_keep_case_label.to_boolean then
								if (cin_iscase ((charset_inst.skipwhite ((memline_inst.ml_get_curline))), 0)).to_boolean then
									l_amount := get_indent
								else
									l_amount := skip_label (l_lnum, l_l.address, l_ind_maxcomment)
								end
							else
								l_amount := skip_label (l_lnum, l_l.address, l_ind_maxcomment)
							end
							l_start_brace := 3
						end
						if (l_theline[0]).to_integer_32 /= 125 then
							l_pos := -1 + 118 -- skip if block
						end
				when 116 then -- if:
						l_amount := l_amount + l_ind_close_extra
				when 117 then -- if block done, skip else block:
						l_pos := -1 + 220
				when 118 then -- else:
						l_lookfor := 0
						if (cin_iselse (l_theline)).to_boolean then
							l_lookfor := 1
						elseif (cin_iswhileofdo (l_theline, l_cur_curpos.lnum, l_ind_maxparen)).to_boolean then
							l_lookfor := 2
						end
						if l_lookfor /= 0 then
							globals_inst.curwin.item.w_cursor.lnum := l_cur_curpos.lnum
							if (find_match (l_lookfor, l_ourscope, l_ind_maxparen, l_ind_maxcomment)) = 1 then
								l_amount := get_indent
								l_pos := -1 + 270 -- goto theend
							end
						end
				when 119 then
						if l_start_brace = 1 then
							l_amount := l_ind_open_left_imag
						elseif l_start_brace = 3 then
							l_amount := l_amount + l_ind_open_imag
						else
							l_amount := l_amount - l_ind_open_extra
							if l_amount < 0 then
								l_amount := 0
							end
						end
						l_lookfor_break := 0
						if (cin_iscase (l_theline, 0)).to_boolean then
							l_lookfor := 3
							l_amount := l_amount + l_ind_case
						elseif (cin_isscopedecl (l_theline)).to_boolean then
							l_lookfor := 7
							l_amount := l_amount + l_ind_scopedecl
						else
							if l_ind_case_break.to_boolean then
								if (cin_isbreak (l_theline)).to_boolean then
									l_lookfor_break := 1
								end
							end
							l_lookfor := 0
							l_amount := l_amount + l_ind_level
						end
						l_scope_amount := l_amount
						l_whilelevel := 0
						globals_inst.curwin.item.w_cursor := l_cur_curpos
				when 120 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 219 -- skip loop
						end
				when 121 then -- loop body:
						js.reset
						globals_inst.curwin.item.w_cursor.lnum := (globals_inst.curwin.item.w_cursor.lnum) - 1
						globals_inst.curwin.item.w_cursor.col := 0
						if not (globals_inst.curwin.item.w_cursor.lnum <= l_ourscope) then
							l_pos := -1 + 138 -- skip if block
						end
				when 122 then -- if:
						if l_lookfor /= 10 then
							l_pos := -1 + 136 -- skip if block
						end
				when 123 then -- if:
						if globals_inst.curwin.item.w_cursor.lnum /= 0 then
							l_pos := -1 + 126 -- skip if block
						end
				when 124 then -- if:
						l_pos := -1 + 127 -- goto _L___8
				when 125 then -- if block done, skip else block:
						l_pos := -1 + 128
				when 126 then -- else:
						if not (globals_inst.curwin.item.w_cursor.lnum < l_ourscope - l_ind_maxparen.to_integer_32) then
							l_pos := -1 + 128 -- skip if block
						end
				when 127 then -- if: | _L___8:
						if l_cont_amount > 0 then
							l_amount := l_cont_amount
						elseif not l_ind_js.to_boolean then
							l_amount := l_amount + l_ind_continuation
						end
						js.break
				when 128 then -- if done
						if not js.loop_jumped then
							l_l.ce_gets (memline_inst.ml_get_curline)
							l_trypos.ce_gets (find_start_comment (l_ind_maxcomment))
							if (l_trypos.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								globals_inst.curwin.item.w_cursor.lnum := l_trypos.item.lnum + 1
								globals_inst.curwin.item.w_cursor.col := 0
								js.continue
							end
						end
						if not js.loop_jumped then
							if (cin_ispreproc_cont (l_l.address, create {CE_POINTER [INTEGER_32]}.make_shared (globals_inst.curwin.c_pointer + {PD_WINDOW_S}.w_cursor_offset + {PD_POS_T}.lnum_offset))).to_boolean then
								js.continue
							end
						end
						if not js.loop_jumped then
							if (cin_nocode (l_l)).to_boolean then
								js.continue
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 134 -- skip if block
						end
				when 129 then -- if:
						l_terminated := (cin_isterminated (l_l, 0, 1)).to_natural_8
						if l_start_brace = 1 then
							l_pos := -1 + 132 -- skip if block
						end
				when 130 then -- if:
						l_pos := -1 + 133 -- goto _L___9
				when 131 then -- if block done, skip else block:
						l_pos := -1 + 134
				when 132 then -- else:
						if (cin_isfuncdecl (l_l.address, globals_inst.curwin.item.w_cursor.lnum)).to_boolean then
							l_pos := -1 + 134 -- skip if block
						end
				when 133 then -- if: | _L___9:
						if l_terminated.to_integer_32 = 44 then
							js.break
						end
						if not js.loop_jumped and then (l_terminated.to_integer_32 /= 59) then
							if (cin_isinit).to_boolean then
								js.break
							end
						end
						if not js.loop_jumped then
							if l_terminated.to_integer_32 = 0 then
								js.continue
							elseif l_terminated.to_integer_32 = 123 then
								js.continue
							end
						end
				when 134 then -- if done | if done
						if not js.loop_jumped and then (l_terminated.to_integer_32 /= 59) then
							l_trypos.ce_gets (create {CE_POINTER [PD_POS_T]}.make_shared (default_pointer))
							if (find_last_paren (l_l, ('(').code, (')').code)).to_boolean then
								l_trypos.ce_gets (find_match_paren (l_ind_maxparen, l_ind_maxcomment))
							end
							if (l_trypos.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								if (find_last_paren (l_l, ('{').code, ('}').code)).to_boolean then
									l_trypos.ce_gets (find_start_brace (l_ind_maxcomment))
								end
							end
							if (l_trypos.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								globals_inst.curwin.item.w_cursor.lnum := l_trypos.item.lnum + 1
								globals_inst.curwin.item.w_cursor.col := 0
								js.continue
							end
						end
						if not js.loop_jumped then
							if l_cont_amount > 0 then
								l_amount := l_cont_amount
							else
								l_amount := l_amount + l_ind_continuation
							end
						end
				when 135 then -- if block done, skip else block:
						l_pos := -1 + 137
				when 136 then -- else:
						if l_lookfor = 6 then
							if l_cont_amount > 0 then
								l_amount := l_cont_amount
							else
								l_amount := l_amount + l_ind_continuation
							end
						elseif l_lookfor /= 5 then
							if l_lookfor /= 9 then
								l_amount := l_scope_amount
								if (l_theline[0]).to_integer_32 = 123 then
									l_amount := l_amount + l_ind_open_extra
								end
							end
						end
				when 137 then -- if done
						if not js.loop_jumped then
							js.break
						end
				when 138 then -- if done
						if not js.loop_jumped then
							l_trypos.ce_gets (find_start_comment (l_ind_maxcomment))
							if (l_trypos.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								globals_inst.curwin.item.w_cursor.lnum := l_trypos.item.lnum + 1
								globals_inst.curwin.item.w_cursor.col := 0
								js.continue
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 160 -- skip if block
						end
				when 139 then -- if:
						l_l.ce_gets (memline_inst.ml_get_curline)
						l_iscase := cin_iscase (l_l, 0)
						if not (l_iscase.to_boolean) then
							l_pos := -1 + 142 -- skip if block
						end
				when 140 then -- if:
						l_pos := -1 + 143 -- goto _L___14
				when 141 then -- if block done, skip else block:
						l_pos := -1 + 160
				when 142 then -- else:
						if not ((cin_isscopedecl (l_l)).to_boolean) then
							l_pos := -1 + 160 -- skip if block
						end
				when 143 then -- if: | _L___14:
						if l_lookfor = 9 then
							js.break
						end
						if not js.loop_jumped and then (l_whilelevel > 0) then
							js.continue
						end
						if js.loop_jumped then
							l_pos := -1 + 149 -- skip if block
						end
				when 144 then -- if:
						if l_lookfor /= 6 then
							l_pos := -1 + 147 -- skip if block
						end
				when 145 then -- if:
						l_pos := -1 + 148 -- goto _L___10
				when 146 then -- if block done, skip else block:
						l_pos := -1 + 149
				when 147 then -- else:
						if l_lookfor /= 10 then
							l_pos := -1 + 149 -- skip if block
						end
				when 148 then -- if: | _L___10:
						if l_cont_amount > 0 then
							l_amount := l_cont_amount
						else
							l_amount := l_amount + l_ind_continuation
						end
						js.break
				when 149 then -- if done | if done
						if js.loop_jumped then
							l_pos := -1 + 159 -- skip if block
						end
				when 150 then -- if:
						if not (l_iscase.to_boolean) then
							l_pos := -1 + 153 -- skip if block
						end
				when 151 then -- if:
						if l_lookfor = 3 then
							l_pos := -1 + 158 -- goto _L___11
						else
							l_pos := -1 + 153 -- goto _L___13
						end
				when 152 then -- if block done, skip else block:
						l_pos := -1 + 159
				when 153 then -- else: | _L___13:
						if not (l_iscase.to_boolean) then
							l_pos := -1 + 156 -- skip if block
						end
				when 154 then -- if:
						if l_lookfor_break.to_boolean then
							l_pos := -1 + 158 -- goto _L___11
						else
							l_pos := -1 + 156 -- goto _L___12
						end
				when 155 then -- if block done, skip else block:
						l_pos := -1 + 159
				when 156 then -- else: | _L___12:
						if l_iscase.to_boolean then
							l_pos := -1 + 159 -- skip if block
						end
				when 157 then -- if:
						if l_lookfor /= 7 then
							l_pos := -1 + 159 -- skip if block
						end
				when 158 then -- if: | _L___11:
						l_trypos.ce_gets (find_start_brace (l_ind_maxcomment))
						if (l_trypos.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_amount := get_indent
							js.break
						elseif l_trypos.item.lnum = l_ourscope then
							l_amount := get_indent
							js.break
						end
						if not js.loop_jumped then
							js.continue
						end
				when 159 then -- if done | if done | if done | if done
						if not js.loop_jumped then
							l_n := get_indent_nolabel (globals_inst.curwin.item.w_cursor.lnum)
							if l_lookfor = 5 then
								if l_n.to_boolean then
									l_amount := l_n
								end
								if not l_lookfor_break.to_boolean then
									js.break
								end
							end
						end
						if not js.loop_jumped and then (l_n.to_boolean) then
							l_amount := l_n
							l_l.ce_gets (after_label ((memline_inst.ml_get_curline)))
							if (l_l.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								if (cin_is_cinword (l_l)).to_boolean then
									if (l_theline[0]).to_integer_32 = 123 then
										l_amount := l_amount + l_ind_open_extra
									else
										l_amount := l_amount + (l_ind_level + l_ind_no_brace)
									end
								end
							end
							js.break
						end
						if not js.loop_jumped then
							l_tmp___54 := get_indent
							if l_iscase.to_boolean then
								l_tmp___55 := l_ind_case_code
							else
								l_tmp___55 := l_ind_scopedecl_code
							end
							l_scope_amount := l_tmp___54 + l_tmp___55
							if l_ind_case_break.to_boolean then
								l_lookfor := 8
							else
								l_lookfor := 4
							end
							js.continue
						end
				when 160 then -- if done | if done
						if js.loop_jumped then
							l_pos := -1 + 166 -- skip if block
						end
				when 161 then -- if:
						if l_lookfor /= 3 then
							l_pos := -1 + 164 -- skip if block
						end
				when 162 then -- if:
						l_pos := -1 + 165 -- goto _L___15
				when 163 then -- if block done, skip else block:
						l_pos := -1 + 166
				when 164 then -- else:
						if l_lookfor /= 7 then
							l_pos := -1 + 166 -- skip if block
						end
				when 165 then -- if: | _L___15:
						if (find_last_paren (l_l, ('{').code, ('}').code)).to_boolean then
							l_trypos.ce_gets (find_start_brace (l_ind_maxcomment))
							if (l_trypos.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								globals_inst.curwin.item.w_cursor.lnum := l_trypos.item.lnum + 1
								globals_inst.curwin.item.w_cursor.col := 0
							end
						end
						js.continue
				when 166 then -- if done | if done
						if not js.loop_jumped and then (not l_ind_js.to_boolean) then
							if (cin_islabel (l_ind_maxcomment)).to_boolean then
								l_l.ce_gets (after_label ((memline_inst.ml_get_curline)))
								if (l_l.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
									js.continue
								elseif (cin_nocode (l_l)).to_boolean then
									js.continue
								end
							end
						end
						if not js.loop_jumped then
							l_l.ce_gets (memline_inst.ml_get_curline)
							if (cin_ispreproc_cont (l_l.address, create {CE_POINTER [INTEGER_32]}.make_shared (globals_inst.curwin.c_pointer + {PD_WINDOW_S}.w_cursor_offset + {PD_POS_T}.lnum_offset))).to_boolean then
								js.continue
							elseif (cin_nocode (l_l)).to_boolean then
								js.continue
							end
						end
						if not js.loop_jumped then
							l_n := 0
							if l_lookfor /= 5 then
								if l_ind_cpp_baseclass > 0 then
									l_n := cin_is_cpp_baseclass (create {CE_POINTER [INTEGER_32]}.make_shared ($l_col))
									l_l.ce_gets (memline_inst.ml_get_curline)
								end
							end
							if l_n.to_boolean then
								if l_lookfor = 6 then
									if l_cont_amount > 0 then
										l_amount := l_cont_amount
									else
										l_amount := l_amount + l_ind_continuation
									end
								elseif (l_theline[0]).to_integer_32 = 123 then
									l_lookfor := 6
									l_ind_continuation := 0
									js.continue
								else
									l_amount := get_baseclass_amount (l_col, l_ind_maxparen, l_ind_maxcomment, l_ind_cpp_baseclass)
								end
								if not js.loop_jumped then
									js.break
								end
							elseif l_lookfor = 9 then
								if (cin_isterminated (l_l, 1, 0)).to_boolean then
									js.break
								else
									js.continue
								end
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 218 -- skip if block
						end
				when 167 then -- if:
						l_terminated := (cin_isterminated (l_l, 0, 1)).to_natural_8
						if l_terminated.to_integer_32 /= 0 then
							l_pos := -1 + 170 -- skip if block
						end
				when 168 then -- if:
						l_pos := -1 + 172 -- goto _L___21
				when 169 then -- if block done, skip else block:
						l_pos := -1 + 218
				when 170 then -- else:
						if l_lookfor = 6 then
							l_pos := -1 + 195 -- skip if block
						end
				when 171 then -- if:
						if l_terminated.to_integer_32 /= 44 then
							l_pos := -1 + 193 -- skip if block
						end
				when 172 then -- if: | _L___21:
						find_last_paren (l_l, ('(').code, (')').code).do_nothing
						l_trypos.ce_gets (find_match_paren ((corr_ind_maxparen (l_ind_maxparen, l_cur_curpos.address)), l_ind_maxcomment))
						if (l_trypos.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							if l_terminated.to_integer_32 = 44 then
								if (find_last_paren (l_l, ('{').code, ('}').code)).to_boolean then
									l_trypos.ce_gets (find_start_brace (l_ind_maxcomment))
								end
							end
						end
						if (l_trypos.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							globals_inst.curwin.item.w_cursor := l_trypos.item
							l_l.ce_gets (memline_inst.ml_get_curline)
							if (cin_iscase (l_l, 0)).to_boolean then
								globals_inst.curwin.item.w_cursor.lnum := (globals_inst.curwin.item.w_cursor.lnum) + 1
								globals_inst.curwin.item.w_cursor.col := 0
								js.continue
							elseif (cin_isscopedecl (l_l)).to_boolean then
								globals_inst.curwin.item.w_cursor.lnum := (globals_inst.curwin.item.w_cursor.lnum) + 1
								globals_inst.curwin.item.w_cursor.col := 0
								js.continue
							end
						end
						if not js.loop_jumped then
							if l_terminated.to_integer_32 = 44 then
								from
								until
									not (not js.loop_left and then (globals_inst.curwin.item.w_cursor.lnum > 1))
								loop
									js.reset
									l_l.ce_gets (memline_inst.ml_get (globals_inst.curwin.item.w_cursor.lnum - 1))
									if (l_l.item).to_integer_32 = 0 then
										js.break
									elseif (l_l[((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_l))) - {NATURAL_32} 1).to_integer_32]).to_integer_32 /= 92 then
										js.break
									end
									if not js.loop_jumped then
										globals_inst.curwin.item.w_cursor.lnum := (globals_inst.curwin.item.w_cursor.lnum) - 1
										globals_inst.curwin.item.w_cursor.col := 0
									end
								end
								js.reset
							end
							if not l_ind_js.to_boolean then
								l_cur_amount := skip_label (globals_inst.curwin.item.w_cursor.lnum, l_l.address, l_ind_maxcomment)
							else
								l_cur_amount := get_indent
							end
							if l_terminated.to_integer_32 /= 44 then
								if l_lookfor /= 5 then
									if (l_theline[0]).to_integer_32 = 123 then
										l_amount := l_cur_amount
										if ((charset_inst.skipwhite (l_l)).item).to_integer_32 /= 123 then
											l_amount := l_amount + l_ind_open_extra
										end
										if l_ind_cpp_baseclass.to_boolean then
											l_lookfor := 9
											js.continue
										end
										if not js.loop_jumped then
											js.break
										end
									end
								end
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 192 -- skip if block
						end
				when 173 then -- if:
						if not ((cin_is_cinword (l_l)).to_boolean) then
							l_pos := -1 + 176 -- skip if block
						end
				when 174 then -- if:
						l_pos := -1 + 177 -- goto _L___18
				when 175 then -- if block done, skip else block:
						l_pos := -1 + 192
				when 176 then -- else:
						if not ((cin_iselse ((charset_inst.skipwhite (l_l)))).to_boolean) then
							l_pos := -1 + 184 -- skip if block
						end
				when 177 then -- if: | _L___18:
						if l_lookfor /= 6 then
							l_pos := -1 + 180 -- skip if block
						end
				when 178 then -- if:
						l_pos := -1 + 181 -- goto _L___16
				when 179 then -- if block done, skip else block:
						l_pos := -1 + 182
				when 180 then -- else:
						if l_lookfor /= 10 then
							l_pos := -1 + 182 -- skip if block
						end
				when 181 then -- if: | _L___16:
						if l_cont_amount > 0 then
							l_amount := l_cont_amount
						else
							l_amount := l_amount + l_ind_continuation
						end
						js.break
				when 182 then -- if done
						if not js.loop_jumped then
							l_amount := l_cur_amount
							if (l_theline[0]).to_integer_32 = 123 then
								l_amount := l_amount + l_ind_open_extra
							end
							if l_lookfor /= 5 then
								l_amount := l_amount + (l_ind_level + l_ind_no_brace)
								js.break
							end
						end
						if not js.loop_jumped then
							l_l.ce_gets (charset_inst.skipwhite ((memline_inst.ml_get_curline)))
							if (cin_isdo (l_l)).to_boolean then
								if l_whilelevel = 0 then
									js.break
								end
								if not js.loop_jumped then
									l_whilelevel := l_whilelevel - 1
								end
							end
						end
						if not js.loop_jumped then
							if (cin_iselse (l_l)).to_boolean then
								if l_whilelevel = 0 then
									l_trypos.ce_gets (find_start_brace (l_ind_maxcomment))
									if (l_trypos.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
										js.break
									elseif (find_match (1, l_trypos.item.lnum, l_ind_maxparen, l_ind_maxcomment)) = 0 then
										js.break
									end
								end
							end
						end
				when 183 then -- if block done, skip else block:
						l_pos := -1 + 192
				when 184 then -- else:
						if l_lookfor = 6 then
							if l_terminated.to_integer_32 = 44 then
								l_amount := l_amount + l_ind_continuation
							end
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 192 -- skip if block
						end
				when 185 then -- if:
						if l_lookfor /= 10 then
							l_pos := -1 + 188 -- skip if block
						end
				when 186 then -- if:
						if l_terminated.to_integer_32 = 44 then
							if l_ind_cpp_baseclass = 0 then
								js.break
							end
							if not js.loop_jumped then
								l_lookfor := 9
								js.continue
							end
						end
						if not js.loop_jumped and then (l_amount > l_cur_amount) then
							l_amount := l_cur_amount
						end
				when 187 then -- if block done, skip else block:
						l_pos := -1 + 192
				when 188 then -- else:
						l_amount := l_cur_amount
						if l_lookfor /= 0 then
							l_pos := -1 + 191 -- skip if block
						end
				when 189 then -- if:
						if l_terminated.to_integer_32 = 44 then
							l_lookfor := 10
							l_cont_amount := cin_first_id_amount
						else
							l_pos := -1 + 191 -- goto _L___17
						end
				when 190 then -- if block done, skip else block:
						l_pos := -1 + 192
				when 191 then -- else: | _L___17:
						if l_lookfor = 0 then
							if (l_l.item).to_integer_32 /= 0 then
								if (l_l[((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_l))) - {NATURAL_32} 1).to_integer_32]).to_integer_32 = 92 then
									l_cont_amount := cin_get_equal_amount (globals_inst.curwin.item.w_cursor.lnum)
								end
							end
						end
						if l_lookfor /= 5 then
							l_lookfor := 6
						end
				when 192 then -- if done | if done | if done | if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 194
				when 193 then -- else:
						l_pos := -1 + 195 -- goto _L___22
				when 194 then -- if done | if block done, skip else block:
						l_pos := -1 + 218
				when 195 then -- else: | _L___22:
						if not ((cin_iswhileofdo_end (l_terminated.to_integer_32, l_ind_maxparen, l_ind_maxcomment)).to_boolean) then
							l_pos := -1 + 203 -- skip if block
						end
				when 196 then -- if:
						if l_lookfor /= 6 then
							l_pos := -1 + 199 -- skip if block
						end
				when 197 then -- if:
						l_pos := -1 + 200 -- goto _L___19
				when 198 then -- if block done, skip else block:
						l_pos := -1 + 201
				when 199 then -- else:
						if l_lookfor /= 10 then
							l_pos := -1 + 201 -- skip if block
						end
				when 200 then -- if: | _L___19:
						if l_cont_amount > 0 then
							l_amount := l_cont_amount
						else
							l_amount := l_amount + l_ind_continuation
						end
						js.break
				when 201 then -- if done
						if not js.loop_jumped then
							if l_whilelevel = 0 then
								l_lookfor := 5
								l_amount := get_indent
								if (l_theline[0]).to_integer_32 = 123 then
									l_amount := l_amount + l_ind_open_extra
								end
							end
							l_whilelevel := l_whilelevel + 1
						end
				when 202 then -- if block done, skip else block:
						l_pos := -1 + 218
				when 203 then -- else:
						if l_lookfor = 8 then
							if (cin_isbreak ((charset_inst.skipwhite ((memline_inst.ml_get_curline))))).to_boolean then
								l_lookfor := 4
								js.continue
							end
						end
						if not js.loop_jumped and then (l_whilelevel > 0) then
							l_l.ce_gets (cin_skipcomment ((memline_inst.ml_get_curline)))
							if (cin_isdo (l_l)).to_boolean then
								l_amount := get_indent
								l_whilelevel := l_whilelevel - 1
								js.continue
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 209 -- skip if block
						end
				when 204 then -- if:
						if l_lookfor /= 6 then
							l_pos := -1 + 207 -- skip if block
						end
				when 205 then -- if:
						l_pos := -1 + 208 -- goto _L___20
				when 206 then -- if block done, skip else block:
						l_pos := -1 + 209
				when 207 then -- else:
						if l_lookfor /= 10 then
							l_pos := -1 + 209 -- skip if block
						end
				when 208 then -- if: | _L___20:
						if l_cont_amount > 0 then
							l_amount := l_cont_amount
						else
							l_amount := l_amount + l_ind_continuation
						end
						js.break
				when 209 then -- if done | if done
						if js.loop_jumped then
							l_pos := -1 + 218 -- skip if block
						end
				when 210 then -- if:
						if l_lookfor /= 5 then
							l_pos := -1 + 213 -- skip if block
						end
				when 211 then -- if:
						if not l_lookfor_break.to_boolean then
							if l_whilelevel = 0 then
								js.break
							end
						end
				when 212 then -- if block done, skip else block:
						l_pos := -1 + 218
				when 213 then -- else: | term_again:
						l_l.ce_gets (memline_inst.ml_get_curline)
						if (find_last_paren (l_l, ('(').code, (')').code)).to_boolean then
							l_trypos.ce_gets (find_match_paren (l_ind_maxparen, l_ind_maxcomment))
							if (l_trypos.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								globals_inst.curwin.item.w_cursor := l_trypos.item
								l_l.ce_gets (memline_inst.ml_get_curline)
								if (cin_iscase (l_l, 0)).to_boolean then
									globals_inst.curwin.item.w_cursor.lnum := (globals_inst.curwin.item.w_cursor.lnum) + 1
									globals_inst.curwin.item.w_cursor.col := 0
									js.continue
								elseif (cin_isscopedecl (l_l)).to_boolean then
									globals_inst.curwin.item.w_cursor.lnum := (globals_inst.curwin.item.w_cursor.lnum) + 1
									globals_inst.curwin.item.w_cursor.col := 0
									js.continue
								end
							end
						end
						if not js.loop_jumped then
							if l_ind_keep_case_label.to_boolean then
								if (cin_iscase (l_l, 0)).to_boolean then
									l_tmp___88 := 1
								else
									l_tmp___88 := 0
								end
							else
								l_tmp___88 := 0
							end
							l_iscase := l_tmp___88
							l_amount := skip_label (globals_inst.curwin.item.w_cursor.lnum, l_l.address, l_ind_maxcomment)
							if (l_theline[0]).to_integer_32 = 123 then
								l_amount := l_amount + l_ind_open_extra
							end
							l_l.ce_gets (charset_inst.skipwhite (l_l))
							if (l_l.item).to_integer_32 = 123 then
								l_amount := l_amount - l_ind_open_extra
							end
							if l_iscase.to_boolean then
								l_lookfor := 4
							else
								l_lookfor := 5
							end
							if l_lookfor = 5 then
								if (l_l.item).to_integer_32 /= 125 then
									if (cin_iselse (l_l)).to_boolean then
										if l_whilelevel = 0 then
											l_trypos.ce_gets (find_start_brace (l_ind_maxcomment))
											if (l_trypos.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
												js.break
											elseif (find_match (1, l_trypos.item.lnum, l_ind_maxparen, l_ind_maxcomment)) = 0 then
												js.break
											end
											if not js.loop_jumped then
												js.continue
											end
										end
									end
								end
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 218 -- skip if block
						end
				when 214 then -- if:
						globals_inst.curwin.item.w_cursor.col := 0
						if ((cin_skipcomment (l_l)).item).to_integer_32 /= 125 then
							l_pos := -1 + 218 -- skip if block
						end
				when 215 then -- if:
						l_trypos.ce_gets (find_start_brace (l_ind_maxcomment))
						if (l_trypos.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 218 -- skip if block
						end
				when 216 then -- if:
						globals_inst.curwin.item.w_cursor := l_trypos.item
						l_l.ce_gets (cin_skipcomment ((memline_inst.ml_get_curline)))
						if (l_l.item).to_integer_32 = 125 then
							l_pos := -1 + 213 -- goto term_again
						elseif not (cin_iselse (l_l)).to_boolean then
							l_pos := -1 + 213 -- goto term_again
						end
				when 217 then
						globals_inst.curwin.item.w_cursor.lnum := (globals_inst.curwin.item.w_cursor.lnum) + 1
						globals_inst.curwin.item.w_cursor.col := 0
				when 218 then -- if done | if done | if done | if done | if done | if done | if done | if done
						if not js.loop_left then
							
						end
						l_pos := -1 + 120 -- back to loop condition
				when 219 then -- loop done
						js.reset
				when 220 then -- if done | if done
						if (cin_iscomment (l_theline)).to_boolean then
							l_amount := l_amount + l_ind_comment
						end
						if l_ind_jump_label > 0 then
							if l_original_line_islabel.to_boolean then
								l_amount := l_amount - l_ind_jump_label
							end
						end
				when 221 then -- if block done, skip else block:
						l_pos := -1 + 239
				when 222 then -- else:
						if (l_theline[0]).to_integer_32 /= 123 then
							l_pos := -1 + 225 -- skip if block
						end
				when 223 then -- if:
						l_amount := l_ind_first_open
				when 224 then -- if block done, skip else block:
						l_pos := -1 + 239
				when 225 then -- else:
						if not (l_cur_curpos.lnum < globals_inst.curbuf.item.b_ml.ml_line_count) then
							l_pos := -1 + 228 -- skip if block
						end
				when 226 then -- if:
						if (cin_nocode (l_theline)).to_boolean then
							l_pos := -1 + 228 -- goto _L___30
						elseif ((misc2_inst.vim_strchr (l_theline, ('{').code)).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							if ((misc2_inst.vim_strchr (l_theline, ('}').code)).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								if (cin_ends_in (l_theline, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (":")), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))).to_boolean then
									l_pos := -1 + 228 -- goto _L___30
								elseif (cin_ends_in (l_theline, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (",")), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))).to_boolean then
									l_pos := -1 + 228 -- goto _L___30
								elseif (cin_isfuncdecl (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), l_cur_curpos.lnum + 1)).to_boolean then
									if (cin_isterminated (l_theline, 0, 1)).to_boolean then
										l_pos := -1 + 228 -- goto _L___30
									else
										l_amount := l_ind_func_type
									end
								else
									l_pos := -1 + 228 -- goto _L___30
								end
							else
								l_pos := -1 + 228 -- goto _L___30
							end
						else
							l_pos := -1 + 228 -- goto _L___30
						end
				when 227 then -- if block done, skip else block:
						l_pos := -1 + 239
				when 228 then -- else: | _L___30:
						l_amount := 0
						globals_inst.curwin.item.w_cursor := l_cur_curpos
				when 229 then -- loop condition:
						if not (not js.loop_left and then (globals_inst.curwin.item.w_cursor.lnum > 1)) then
							l_pos := -1 + 238 -- skip loop
						end
				when 230 then -- loop body:
						js.reset
						globals_inst.curwin.item.w_cursor.lnum := (globals_inst.curwin.item.w_cursor.lnum) - 1
						globals_inst.curwin.item.w_cursor.col := 0
						l_l.ce_gets (memline_inst.ml_get_curline)
						l_trypos.ce_gets (find_start_comment (l_ind_maxcomment))
						if (l_trypos.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							globals_inst.curwin.item.w_cursor.lnum := l_trypos.item.lnum + 1
							globals_inst.curwin.item.w_cursor.col := 0
							js.continue
						end
						if not js.loop_jumped then
							l_n := 0
							if l_ind_cpp_baseclass /= 0 then
								if (l_theline[0]).to_integer_32 /= 123 then
									l_n := cin_is_cpp_baseclass (create {CE_POINTER [INTEGER_32]}.make_shared ($l_col))
									l_l.ce_gets (memline_inst.ml_get_curline)
								end
							end
							if l_n.to_boolean then
								l_amount := get_baseclass_amount (l_col, l_ind_maxparen, l_ind_maxcomment, l_ind_cpp_baseclass)
								js.break
							end
						end
						if not js.loop_jumped then
							if (cin_ispreproc_cont (l_l.address, create {CE_POINTER [INTEGER_32]}.make_shared (globals_inst.curwin.c_pointer + {PD_WINDOW_S}.w_cursor_offset + {PD_POS_T}.lnum_offset))).to_boolean then
								js.continue
							end
						end
						if not js.loop_jumped then
							if (cin_nocode (l_l)).to_boolean then
								js.continue
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 237 -- skip if block
						end
				when 231 then -- if:
						l_n := 0
						if not ((cin_ends_in (l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (",")), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))).to_boolean) then
							l_pos := -1 + 234 -- skip if block
						end
				when 232 then -- if:
						l_pos := -1 + 236 -- goto _L___23
				when 233 then -- if block done, skip else block:
						l_pos := -1 + 237
				when 234 then -- else:
						if (l_l.item).to_integer_32 = 0 then
							l_pos := -1 + 237 -- skip if block
						end
				when 235 then -- if:
						l_n := (l_l[((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_l))) - {NATURAL_32} 1).to_integer_32]).to_integer_32
						if l_n /= 92 then
							l_pos := -1 + 237 -- skip if block
						end
				when 236 then -- if: | _L___23:
						if (find_last_paren (l_l, ('(').code, (')').code)).to_boolean then
							l_trypos.ce_gets (find_match_paren (l_ind_maxparen, l_ind_maxcomment))
							if (l_trypos.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								globals_inst.curwin.item.w_cursor := l_trypos.item
							end
						end
						from
						until
							js.loop_left
						loop
							js.reset
							if l_n = 0 then
								if not (globals_inst.curwin.item.w_cursor.lnum > 1) then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_l.ce_gets (memline_inst.ml_get (globals_inst.curwin.item.w_cursor.lnum - 1))
								if (l_l.item).to_integer_32 = 0 then
									js.break
								elseif (l_l[((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_l))) - {NATURAL_32} 1).to_integer_32]).to_integer_32 /= 92 then
									js.break
								end
							end
							if not js.loop_jumped then
								globals_inst.curwin.item.w_cursor.lnum := (globals_inst.curwin.item.w_cursor.lnum) - 1
								globals_inst.curwin.item.w_cursor.col := 0
							end
						end
						js.reset
						l_amount := get_indent
						if l_amount = 0 then
							l_amount := cin_first_id_amount
						end
						if l_amount = 0 then
							l_amount := l_ind_continuation
						end
						js.break
				when 237 then -- if done | if done | if done
						if not js.loop_jumped then
							if (cin_isfuncdecl (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), l_cur_curpos.lnum)).to_boolean then
								js.break
							end
						end
						if not js.loop_jumped then
							l_l.ce_gets (memline_inst.ml_get_curline)
							if ((charset_inst.skipwhite (l_l)).item).to_integer_32 = 125 then
								js.break
							end
						end
						if not js.loop_jumped then
							if (cin_ends_in (l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("};")), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))).to_boolean then
								js.break
							end
						end
						if not js.loop_jumped then
							if (cin_isfuncdecl (l_l.address, globals_inst.curwin.item.w_cursor.lnum)).to_boolean then
								l_amount := l_ind_param
								js.break
							end
						end
						if not js.loop_jumped then
							if (cin_ends_in (l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (";")), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))).to_boolean then
								l_l.ce_gets (memline_inst.ml_get (globals_inst.curwin.item.w_cursor.lnum - 1))
								if (cin_ends_in (l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (",")), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))).to_boolean then
									js.break
								elseif (l_l.item).to_integer_32 /= 0 then
									if (l_l[((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_l))) - {NATURAL_32} 1).to_integer_32]).to_integer_32 = 92 then
										js.break
									end
								end
								if not js.loop_jumped then
									l_l.ce_gets (memline_inst.ml_get_curline)
								end
							end
						end
						if not js.loop_jumped then
							find_last_paren (l_l, ('(').code, (')').code).do_nothing
							l_trypos.ce_gets (find_match_paren (l_ind_maxparen, l_ind_maxcomment))
							if (l_trypos.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								globals_inst.curwin.item.w_cursor := l_trypos.item
							end
							l_amount := get_indent
							js.break
						end
						l_pos := -1 + 229 -- back to loop condition
				when 238 then -- loop done
						js.reset
						if (cin_iscomment (l_theline)).to_boolean then
							l_amount := l_amount + l_ind_comment
						end
						if l_cur_curpos.lnum > 1 then
							l_l.ce_gets (memline_inst.ml_get (l_cur_curpos.lnum - 1))
							if (l_l.item).to_integer_32 /= 0 then
								if (l_l[((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_l))) - {NATURAL_32} 1).to_integer_32]).to_integer_32 = 92 then
									l_cur_amount := cin_get_equal_amount (l_cur_curpos.lnum - 1)
									if l_cur_amount > 0 then
										l_amount := l_cur_amount
									elseif l_cur_amount = 0 then
										l_amount := l_amount + l_ind_continuation
									end
								end
							end
						end
				when 239 then -- if done | if done | if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 270
				when 240 then -- else:
						l_trypos.ce_gets (find_start_comment (l_ind_maxcomment))
						if (l_trypos.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 269 -- skip if block
						end
				when 241 then -- if:
						l_lead_start_len := 2
						l_lead_middle_len := 1
						l_start_align := 0
						l_start_off := 0
						l_done___2 := 0
						charset_inst.getvcol (globals_inst.curwin, l_trypos, create {CE_POINTER [INTEGER_32]}.make_shared ($l_col), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
						l_amount := l_col
						l_p___0.ce_gets (globals_inst.curbuf.item.b_p_com)
				when 242 then -- loop condition:
						if not (not js.loop_left and then ((l_p___0.item).to_integer_32 /= 0)) then
							l_pos := -1 + 267 -- skip loop
						end
				when 243 then -- loop body:
						js.reset
						l_align := 0
						l_off___0 := 0
						l_what := 0
				when 244 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 266 -- skip loop
						end
				when 245 then -- loop body:
						js.reset
						if (l_p___0.item).to_integer_32 /= 0 then
							if (l_p___0.item).to_integer_32 = 58 then
								js.break
							end
						else
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 265 -- skip if block
						end
				when 246 then -- if:
						if (l_p___0.item).to_integer_32 /= 115 then
							l_pos := -1 + 249 -- skip if block
						end
				when 247 then -- if:
						l_tmp___4.ce_gets (l_p___0)
						l_p___0.ce_gets (l_p___0 + 1)
						l_what := (l_tmp___4.item).to_integer_32
				when 248 then -- if block done, skip else block:
						l_pos := -1 + 265
				when 249 then -- else:
						if (l_p___0.item).to_integer_32 /= 101 then
							l_pos := -1 + 252 -- skip if block
						end
				when 250 then -- if:
						l_tmp___4.ce_gets (l_p___0)
						l_p___0.ce_gets (l_p___0 + 1)
						l_what := (l_tmp___4.item).to_integer_32
				when 251 then -- if block done, skip else block:
						l_pos := -1 + 265
				when 252 then -- else:
						if (l_p___0.item).to_integer_32 /= 109 then
							l_pos := -1 + 255 -- skip if block
						end
				when 253 then -- if:
						l_tmp___4.ce_gets (l_p___0)
						l_p___0.ce_gets (l_p___0 + 1)
						l_what := (l_tmp___4.item).to_integer_32
				when 254 then -- if block done, skip else block:
						l_pos := -1 + 265
				when 255 then -- else:
						if (l_p___0.item).to_integer_32 /= 108 then
							l_pos := -1 + 258 -- skip if block
						end
				when 256 then -- if:
						l_tmp___5.ce_gets (l_p___0)
						l_p___0.ce_gets (l_p___0 + 1)
						l_align := (l_tmp___5.item).to_integer_32
				when 257 then -- if block done, skip else block:
						l_pos := -1 + 265
				when 258 then -- else:
						if (l_p___0.item).to_integer_32 /= 114 then
							l_pos := -1 + 261 -- skip if block
						end
				when 259 then -- if:
						l_tmp___5.ce_gets (l_p___0)
						l_p___0.ce_gets (l_p___0 + 1)
						l_align := (l_tmp___5.item).to_integer_32
				when 260 then -- if block done, skip else block:
						l_pos := -1 + 265
				when 261 then -- else:
						if not ((l_p___0.item).to_integer_32 >= 48) then
							l_pos := -1 + 264 -- skip if block
						end
				when 262 then -- if:
						if (l_p___0.item).to_integer_32 <= 57 then
							l_tmp___6 := charset_inst.getdigits (l_p___0.address)
							l_off___0 := l_tmp___6.to_integer_32
						else
							l_pos := -1 + 264 -- goto _L___0
						end
				when 263 then -- if block done, skip else block:
						l_pos := -1 + 265
				when 264 then -- else: | _L___0:
						if (l_p___0.item).to_integer_32 = 45 then
							l_tmp___6 := charset_inst.getdigits (l_p___0.address)
							l_off___0 := l_tmp___6.to_integer_32
						else
							l_p___0.ce_gets (l_p___0 + 1)
						end
				when 265 then -- if done | if done | if done | if done | if done | if done
						l_pos := -1 + 244 -- back to loop condition
				when 266 then -- loop done
						js.reset
						if (l_p___0.item).to_integer_32 = 58 then
							l_p___0.ce_gets (l_p___0 + 1)
						end
						misc2_inst.copy_option_part (l_p___0.address, l_lead_end, 50, ce_string (",")).do_nothing
						if l_what = 115 then
							strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_lead_start), create {CE_POINTER [INTEGER_8]}.make_cast (l_lead_end)).do_nothing
							l_lead_start_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_lead_start))).to_integer_32
							l_start_off := l_off___0
							l_start_align := l_align
						elseif l_what = 109 then
							strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_lead_middle), create {CE_POINTER [INTEGER_8]}.make_cast (l_lead_end)).do_nothing
							l_lead_middle_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_lead_middle))).to_integer_32
						elseif l_what = 101 then
							if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_theline), create {CE_POINTER [INTEGER_8]}.make_cast (l_lead_middle), l_lead_middle_len.to_natural_32)) = 0 then
								if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_theline), create {CE_POINTER [INTEGER_8]}.make_cast (l_lead_end), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_lead_end))))) /= 0 then
									l_done___2 := 1
									if globals_inst.curwin.item.w_cursor.lnum > 1 then
										l_look.ce_gets (charset_inst.skipwhite ((memline_inst.ml_get (globals_inst.curwin.item.w_cursor.lnum - 1))))
										if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_look), create {CE_POINTER [INTEGER_8]}.make_cast (l_lead_start), l_lead_start_len.to_natural_32)) = 0 then
											l_amount := get_indent_lnum (globals_inst.curwin.item.w_cursor.lnum - 1)
										elseif (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_look), create {CE_POINTER [INTEGER_8]}.make_cast (l_lead_middle), l_lead_middle_len.to_natural_32)) = 0 then
											l_amount := get_indent_lnum (globals_inst.curwin.item.w_cursor.lnum - 1)
											js.break
										elseif (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (((memline_inst.ml_get (l_trypos.item.lnum)) + l_trypos.item.col)), create {CE_POINTER [INTEGER_8]}.make_cast (l_lead_start), l_lead_start_len.to_natural_32)) /= 0 then
											js.continue
										end
									end
									if not js.loop_jumped then
										if l_start_off /= 0 then
											l_amount := l_amount + l_start_off
										elseif l_start_align = 114 then
											l_tmp___14 := charset_inst.vim_strsize (l_lead_start)
											l_amount := l_amount + (l_tmp___14 - (charset_inst.vim_strsize (l_lead_middle)))
										end
										js.break
									end
								end
							end
							if not js.loop_jumped then
								if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_theline), create {CE_POINTER [INTEGER_8]}.make_cast (l_lead_middle), l_lead_middle_len.to_natural_32)) /= 0 then
									if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_theline), create {CE_POINTER [INTEGER_8]}.make_cast (l_lead_end), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_lead_end))))) = 0 then
										l_amount := get_indent_lnum (globals_inst.curwin.item.w_cursor.lnum - 1)
										if l_off___0 /= 0 then
											l_amount := l_amount + l_off___0
										elseif l_align = 114 then
											l_tmp___19 := charset_inst.vim_strsize (l_lead_start)
											l_amount := l_amount + (l_tmp___19 - (charset_inst.vim_strsize (l_lead_middle)))
										end
										l_done___2 := 1
										js.break
									end
								end
							end
						end
						l_pos := -1 + 242 -- back to loop condition
				when 267 then -- loop done
						js.reset
						if not l_done___2.to_boolean then
							if (l_theline[0]).to_integer_32 = 42 then
								l_amount := l_amount + 1
							else
								l_amount := -1
								l_lnum := l_cur_curpos.lnum - 1
								from
								until
									not (not js.loop_left and then (l_lnum > l_trypos.item.lnum))
								loop
									js.reset
									if (search_inst.linewhite (l_lnum)).to_boolean then
										js.continue
									end
									if not js.loop_jumped then
										l_amount := get_indent_lnum (l_lnum)
										js.break
									end
									if not js.loop_left then
										l_lnum := l_lnum - 1
									end
								end
								js.reset
								if l_amount = -1 then
									if not l_ind_in_comment2.to_boolean then
										l_start___1.ce_gets (memline_inst.ml_get (l_trypos.item.lnum))
										l_look.ce_gets ((l_start___1 + l_trypos.item.col) + 2)
										if (l_look.item).to_integer_32 /= 0 then
											l_trypos.item.col := (charset_inst.skipwhite (l_look)).distance (l_start___1)
										end
									end
									charset_inst.getvcol (globals_inst.curwin, l_trypos, create {CE_POINTER [INTEGER_32]}.make_shared ($l_col), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
									l_amount := l_col
									if l_ind_in_comment2.to_boolean then
										l_amount := l_amount + l_ind_in_comment
									elseif (l_look.item).to_integer_32 = 0 then
										l_amount := l_amount + l_ind_in_comment
									end
								end
							end
						end
				when 268 then -- if block done, skip else block:
						l_pos := -1 + 270
				when 269 then -- else:
						l_pos := -1 + 54 -- goto _L___33
				when 270 then -- if done | if done | if done | if done | theend:
						globals_inst.curwin.item.w_cursor := l_cur_curpos
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_linecopy___0))
						if l_amount < 0 then
							Result := 0
							js.return
						end
				when 271 then -- if done
					if not js.return_called then
						Result := l_amount
					end
				when 272 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_c_indent_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent get_c_indent)
		end

	find_match (a_lookfor: INTEGER_32; a_ourscope: INTEGER_32; a_ind_maxparen: INTEGER_32; a_ind_maxcomment: INTEGER_32): INTEGER_32
		local
			l_look: CE_POINTER [NATURAL_8]
			l_theirscope: CE_POINTER [PD_POS_T]
			l_mightbeif: CE_POINTER [NATURAL_8]
			l_elselevel: INTEGER_32
			l_whilelevel: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_look.make
			create l_theirscope.make
			create l_mightbeif.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_lookfor = 1 then
						l_elselevel := 1
						l_whilelevel := 0
					else
						l_elselevel := 0
						l_whilelevel := 1
					end
					globals_inst.curwin.item.w_cursor.col := 0
				when 1 then -- loop condition:
					if not (not js.loop_left and then (globals_inst.curwin.item.w_cursor.lnum > a_ourscope + 1)) then
						l_pos := -1 + 14 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						globals_inst.curwin.item.w_cursor.lnum := (globals_inst.curwin.item.w_cursor.lnum) - 1
						globals_inst.curwin.item.w_cursor.col := 0
						l_look.ce_gets (cin_skipcomment ((memline_inst.ml_get_curline)))
						if not ((cin_iselse (l_look)).to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_pos := -1 + 12 -- goto _L
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 5 then -- else:
						if not ((cin_isif (l_look)).to_boolean) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_pos := -1 + 12 -- goto _L
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 8 then -- else:
						if not ((cin_isdo (l_look)).to_boolean) then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						l_pos := -1 + 12 -- goto _L
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 11 then -- else:
						if not ((cin_iswhileofdo (l_look, globals_inst.curwin.item.w_cursor.lnum, a_ind_maxparen)).to_boolean) then
							l_pos := -1 + 13 -- skip if block
						end
				when 12 then -- if: | _L:
						l_theirscope.ce_gets (find_start_brace (a_ind_maxcomment))
						if (l_theirscope.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							js.break
						end
						if not js.loop_jumped and then (l_theirscope.item.lnum < a_ourscope) then
							js.break
						end
						if not js.loop_jumped and then (l_theirscope.item.lnum > a_ourscope) then
							js.continue
						end
						if not js.loop_jumped then
							l_look.ce_gets (cin_skipcomment ((memline_inst.ml_get_curline)))
							if (cin_iselse (l_look)).to_boolean then
								l_mightbeif.ce_gets (cin_skipcomment (l_look + 4))
								if not (cin_isif (l_mightbeif)).to_boolean then
									l_elselevel := l_elselevel + 1
								end
								js.continue
							end
						end
						if not js.loop_jumped then
							if (cin_iswhileofdo (l_look, globals_inst.curwin.item.w_cursor.lnum, a_ind_maxparen)).to_boolean then
								l_whilelevel := l_whilelevel + 1
								js.continue
							end
						end
						if not js.loop_jumped then
							l_look.ce_gets (cin_skipcomment ((memline_inst.ml_get_curline)))
							if (cin_isif (l_look)).to_boolean then
								l_elselevel := l_elselevel - 1
								if l_elselevel = 0 then
									if a_lookfor = 1 then
										l_whilelevel := 0
									end
								end
							end
							if (cin_isdo (l_look)).to_boolean then
								l_whilelevel := l_whilelevel - 1
							end
							if l_elselevel <= 0 then
								if l_whilelevel <= 0 then
									Result := 1
									js.return
								end
							end
						end
				when 13 then -- if done | if done | if done
						l_pos := -1 + 1 -- back to loop condition
				when 14 then -- loop done
					js.reset
					if not js.return_called then
						Result := 0
					end
				when 15 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_expr_indent: INTEGER_32
		local
			l_indent: INTEGER_32
			l_pos___3: PD_POS_T
			l_save_State: INTEGER_32
			l_use_sandbox: INTEGER_32
		do
			create l_pos___3.make

			l_use_sandbox := (option_inst.was_set_insecurely (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("indentexpr")), 4))
			l_pos___3.ce_gets (globals_inst.curwin.item.w_cursor)
			eval_inst.set_vim_var_nr (9, globals_inst.curwin.item.w_cursor.lnum)
			if l_use_sandbox.to_boolean then
				globals_inst.sandbox := globals_inst.sandbox + 1
			end
			globals_inst.textlock := globals_inst.textlock + 1
			l_indent := eval_inst.eval_to_number (globals_inst.curbuf.item.b_p_inde)
			if l_use_sandbox.to_boolean then
				globals_inst.sandbox := globals_inst.sandbox - 1
			end
			globals_inst.textlock := globals_inst.textlock - 1
			l_save_State := globals_inst.State
			globals_inst.State := 16
			globals_inst.curwin.item.w_cursor := l_pos___3
			misc2_inst.check_cursor
			globals_inst.State := l_save_State
			if l_indent < 0 then
				l_indent := get_indent
			end
			Result := l_indent
		end

	get_expr_indent_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent get_expr_indent)
		end

	lisp_match (a_p___0: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_len: INTEGER_32
			l_word: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_buf___6.make (<<512>>)
			create l_word.make

			l_word.ce_gets (option_inst.p_lispwords)
			from
			until
				not (not js.loop_left and then ((l_word.item).to_integer_32 /= 0))
			loop
				misc2_inst.copy_option_part (l_word.address, l_buf___6, 512, ce_string (",")).do_nothing
				l_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6))).to_integer_32
				if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6), create {CE_POINTER [INTEGER_8]}.make_cast (a_p___0), l_len.to_natural_32)) = 0 then
					if (a_p___0[l_len]).to_integer_32 = 32 then
						Result := 1
						js.return
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	get_lisp_indent: INTEGER_32
		local
			l_pos___3: CE_POINTER [PD_POS_T]
			l_realpos: PD_POS_T
			l_paren: PD_POS_T
			l_amount: INTEGER_32
			l_that: CE_POINTER [NATURAL_8]
			l_col: INTEGER_32
			l_firsttry: INTEGER_32
			l_parencount: INTEGER_32
			l_quotecount: INTEGER_32
			l_vi_lisp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_pos___3.make
			create l_realpos.make
			create l_paren.make
			create l_that.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_vi_lisp := (((misc2_inst.vim_strchr (option_inst.p_cpo, ('p').code)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer
					l_realpos.ce_gets (globals_inst.curwin.item.w_cursor)
					globals_inst.curwin.item.w_cursor.col := 0
					l_pos___3.ce_gets (search_inst.findmatch (create {CE_POINTER [PD_OPARG_S]}.make_shared (default_pointer), ('(').code))
					if (l_pos___3.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						l_pos___3.ce_gets (search_inst.findmatch (create {CE_POINTER [PD_OPARG_S]}.make_shared (default_pointer), ('[').code))
					else
						l_paren.ce_gets (l_pos___3.item)
						l_pos___3.ce_gets (search_inst.findmatch (create {CE_POINTER [PD_OPARG_S]}.make_shared (default_pointer), ('[').code))
						if (l_pos___3.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos___3.ce_gets (l_paren.address)
						else
							if l_pos___3.item.lnum /= l_paren.lnum then
								l_tmp___1 := (l_pos___3.item.lnum < l_paren.lnum).to_integer
							else
								if l_pos___3.item.col /= l_paren.col then
									l_tmp___0 := (l_pos___3.item.col < l_paren.col).to_integer
								else
									l_tmp___0 := (l_pos___3.item.coladd < l_paren.coladd).to_integer
								end
								l_tmp___1 := l_tmp___0
							end
							if l_tmp___1.to_boolean then
								l_pos___3.ce_gets (l_paren.address)
							end
						end
					end
					if (l_pos___3.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						l_pos := -1 + 63 -- skip if block
					end
				when 1 then -- if:
						l_amount := -1
						l_parencount := 0
						from
						until
							js.loop_left
						loop
							js.reset
							globals_inst.curwin.item.w_cursor.lnum := (globals_inst.curwin.item.w_cursor.lnum) - 1
							if not (globals_inst.curwin.item.w_cursor.lnum >= l_pos___3.item.lnum) then
								js.break
							end
							if not js.loop_jumped then
								if (search_inst.linewhite (globals_inst.curwin.item.w_cursor.lnum)).to_boolean then
									js.continue
								end
							end
							if not js.loop_jumped then
								l_that.ce_gets (memline_inst.ml_get_curline)
								from
								until
									not (not js.loop_left and then ((l_that.item).to_integer_32 /= 0))
								loop
									js.reset
									if (l_that.item).to_integer_32 = 59 then
										from
										until
											(l_that[1]).to_integer_32 = 0
										loop
											l_that.ce_gets (l_that + 1)
										end
										js.continue
									end
									if not js.loop_jumped and then ((l_that.item).to_integer_32 = 92) then
										if (l_that[1]).to_integer_32 /= 0 then
											l_that.ce_gets (l_that + 1)
										end
										js.continue
									end
									if not js.loop_jumped then
										if (l_that.item).to_integer_32 = 34 then
											if (l_that[1]).to_integer_32 /= 0 then
												from
												until
													js.loop_left
												loop
													js.reset
													l_that.ce_gets (l_that + 1)
													if (l_that.item).to_boolean then
														if (l_that.item).to_integer_32 = 34 then
															js.break
														end
													else
														js.break
													end
													if not js.loop_jumped and then ((l_that.item).to_integer_32 = 92) then
														l_that.ce_gets (l_that + 1)
														if (l_that.item).to_integer_32 = 0 then
															js.break
														end
														if not js.loop_jumped and then ((l_that[1]).to_integer_32 = 0) then
															l_that.ce_gets (l_that + 1)
															js.break
														end
													end
												end
												js.reset
											end
										end
										if (l_that.item).to_integer_32 = 40 then
											l_parencount := l_parencount + 1
										elseif (l_that.item).to_integer_32 = 91 then
											l_parencount := l_parencount + 1
										elseif (l_that.item).to_integer_32 = 41 then
											l_parencount := l_parencount - 1
										elseif (l_that.item).to_integer_32 = 93 then
											l_parencount := l_parencount - 1
										end
									end
									if not js.loop_left then
										l_that.ce_gets (l_that + 1)
									end
								end
								if l_parencount = 0 then
									l_amount := get_indent
									js.break
								end
							end
						end
						js.reset
						if l_amount /= -1 then
							l_pos := -1 + 62 -- skip if block
						end
				when 2 then -- if:
						globals_inst.curwin.item.w_cursor.lnum := l_pos___3.item.lnum
						globals_inst.curwin.item.w_cursor.col := l_pos___3.item.col
						l_col := l_pos___3.item.col
						l_that.ce_gets (memline_inst.ml_get_curline)
						if not (l_vi_lisp.to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if (get_indent) = 0 then
							l_amount := 2
						else
							l_pos := -1 + 5 -- goto _L___9
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 62
				when 5 then -- else: | _L___9:
						l_amount := 0
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_that.item).to_boolean then
								if not l_col.to_boolean then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_amount := l_amount + (charset_inst.lbr_chartabsize_adv (l_that.address, l_amount))
								l_col := l_col - 1
							end
						end
						js.reset
						if l_vi_lisp.to_boolean then
							l_pos := -1 + 14 -- skip if block
						end
				when 6 then -- if:
						if (l_that.item).to_integer_32 /= 40 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L___8
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 9 then -- else:
						if (l_that.item).to_integer_32 /= 91 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if: | _L___8:
						if (lisp_match (l_that + 1)).to_boolean then
							l_amount := l_amount + (2)
						else
							l_pos := -1 + 14 -- goto _L___7
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else:
						l_pos := -1 + 14 -- goto _L___7
				when 13 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 62
				when 14 then -- else: | _L___7:
						l_that.ce_gets (l_that + 1)
						l_amount := l_amount + 1
						l_firsttry := l_amount
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_that.item).to_integer_32 /= 32 then
								if (l_that.item).to_integer_32 /= 9 then
									js.break
								end
							end
							if not js.loop_jumped then
								l_amount := l_amount + (charset_inst.lbr_chartabsize (l_that, l_amount))
								l_that.ce_gets (l_that + 1)
							end
						end
						js.reset
						if not ((l_that.item).to_boolean) then
							l_pos := -1 + 62 -- skip if block
						end
				when 15 then -- if:
						if (l_that.item).to_integer_32 = 59 then
							l_pos := -1 + 62 -- skip if block
						end
				when 16 then -- if:
						if not l_vi_lisp.to_boolean then
							if (l_that.item).to_integer_32 /= 40 then
								if (l_that.item).to_integer_32 /= 91 then
									l_firsttry := l_firsttry + 1
								end
							end
						end
						l_parencount := 0
						l_quotecount := 0
						if not (l_vi_lisp.to_boolean) then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						l_pos := -1 + 26 -- goto _L___5
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 61
				when 19 then -- else:
						if (l_that.item).to_integer_32 = 34 then
							l_pos := -1 + 61 -- skip if block
						end
				when 20 then -- if:
						if (l_that.item).to_integer_32 = 39 then
							l_pos := -1 + 61 -- skip if block
						end
				when 21 then -- if:
						if (l_that.item).to_integer_32 = 35 then
							l_pos := -1 + 61 -- skip if block
						end
				when 22 then -- if:
						if not ((l_that.item).to_integer_32 < 48) then
							l_pos := -1 + 25 -- skip if block
						end
				when 23 then -- if:
						l_pos := -1 + 26 -- goto _L___5
				when 24 then -- if block done, skip else block:
						l_pos := -1 + 61
				when 25 then -- else:
						if not ((l_that.item).to_integer_32 > 57) then
							l_pos := -1 + 61 -- skip if block
						end
				when 26 then -- if: | _L___5:
						if js.loop_left then
							l_pos := -1 + 60 -- skip loop
						end
				when 27 then -- loop body:
						js.reset
						if not ((l_that.item).to_boolean) then
							l_pos := -1 + 46 -- skip if block
						end
				when 28 then -- if:
						if (l_that.item).to_integer_32 /= 32 then
							l_pos := -1 + 31 -- skip if block
						end
				when 29 then -- if:
						l_pos := -1 + 32 -- goto _L___3
				when 30 then -- if block done, skip else block:
						l_pos := -1 + 45
				when 31 then -- else:
						if (l_that.item).to_integer_32 /= 9 then
							l_pos := -1 + 44 -- skip if block
						end
				when 32 then -- if: | _L___3:
						if not (l_quotecount.to_boolean) then
							l_pos := -1 + 35 -- skip if block
						end
				when 33 then -- if:
						l_pos := -1 + 36 -- goto _L___2
				when 34 then -- if block done, skip else block:
						l_pos := -1 + 43
				when 35 then -- else:
						if not (l_parencount.to_boolean) then
							l_pos := -1 + 42 -- skip if block
						end
				when 36 then -- if: | _L___2:
						if (l_that.item).to_integer_32 /= 40 then
							l_pos := -1 + 39 -- skip if block
						end
				when 37 then -- if:
						l_pos := -1 + 40 -- goto _L___1
				when 38 then -- if block done, skip else block:
						l_pos := -1 + 41
				when 39 then -- else:
						if (l_that.item).to_integer_32 /= 91 then
							l_pos := -1 + 41 -- skip if block
						end
				when 40 then -- if: | _L___1:
						if not l_quotecount.to_boolean then
							if not l_parencount.to_boolean then
								if l_vi_lisp.to_boolean then
									js.break
								end
							end
						end
				when 41 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 43
				when 42 then -- else:
						js.break
				when 43 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 45
				when 44 then -- else:
						l_pos := -1 + 36 -- goto _L___2
				when 45 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 47
				when 46 then -- else:
						js.break
				when 47 then
						if js.loop_jumped then
							l_pos := -1 + 59 -- skip if block
						end
				when 48 then -- if:
						if (l_that.item).to_integer_32 = 34 then
							l_quotecount := (not l_quotecount.to_boolean).to_integer
						end
						if (l_that.item).to_integer_32 /= 40 then
							l_pos := -1 + 51 -- skip if block
						end
				when 49 then -- if:
						l_pos := -1 + 52 -- goto _L
				when 50 then -- if block done, skip else block:
						l_pos := -1 + 53
				when 51 then -- else:
						if (l_that.item).to_integer_32 /= 91 then
							l_pos := -1 + 53 -- skip if block
						end
				when 52 then -- if: | _L:
						if not l_quotecount.to_boolean then
							l_parencount := l_parencount + 1
						end
				when 53 then -- if done
						if (l_that.item).to_integer_32 /= 41 then
							l_pos := -1 + 56 -- skip if block
						end
				when 54 then -- if:
						l_pos := -1 + 57 -- goto _L___0
				when 55 then -- if block done, skip else block:
						l_pos := -1 + 58
				when 56 then -- else:
						if (l_that.item).to_integer_32 /= 93 then
							l_pos := -1 + 58 -- skip if block
						end
				when 57 then -- if: | _L___0:
						if not l_quotecount.to_boolean then
							l_parencount := l_parencount - 1
						end
				when 58 then -- if done
						if (l_that.item).to_integer_32 = 92 then
							if (l_that[1]).to_integer_32 /= 0 then
								l_amount := l_amount + (charset_inst.lbr_chartabsize_adv (l_that.address, l_amount))
							end
						end
						l_amount := l_amount + (charset_inst.lbr_chartabsize_adv (l_that.address, l_amount))
				when 59 then -- if done
						l_pos := -1 + 26 -- back to loop condition
				when 60 then -- loop done
						js.reset
				when 61 then -- if done | if done | if done | if done | if done
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_that.item).to_integer_32 /= 32 then
								if (l_that.item).to_integer_32 /= 9 then
									js.break
								end
							end
							if not js.loop_jumped then
								l_amount := l_amount + (charset_inst.lbr_chartabsize (l_that, l_amount))
								l_that.ce_gets (l_that + 1)
							end
						end
						js.reset
						if not (l_that.item).to_boolean then
							l_amount := l_firsttry
						elseif (l_that.item).to_integer_32 = 59 then
							l_amount := l_firsttry
						end
				when 62 then -- if done | if done | if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 64
				when 63 then -- else:
						l_amount := 0
				when 64 then
					globals_inst.curwin.item.w_cursor := l_realpos
					Result := l_amount
				when 65 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_lisp_indent_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent get_lisp_indent)
		end

	prepare_to_exit
		do
			signal (1, create {CE_ROUTINE}.make_shared (default_pointer + 1)).do_nothing
			if (gui_inst.gui.in_use).to_boolean then
				gui_inst.gui.dying := 1
				term_inst.out_trash
			else
				screen_inst.windgoto (globals_inst.Rows.to_integer_32 - 1, 0)
				term_inst.settmode (0)
				term_inst.stoptermcap
				term_inst.out_flush
			end
		end

	preserve_exit
		local
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			js: JUMP_STATE
		do
			create l_buf___6.make

			prepare_to_exit
			globals_inst.really_exiting := 1
			term_inst.out_str (globals_inst.IObuff)
			screen_inst.screen_start
			term_inst.out_flush
			memline_inst.ml_close_notmod
			l_buf___6.ce_gets (globals_inst.firstbuf)
			from
			until
				not (not js.loop_left and then ((l_buf___6.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32))
			loop
				js.reset
				if ((l_buf___6.item.b_ml.ml_mfp).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					if (((l_buf___6.item.b_ml.ml_mfp).item.mf_fname).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						term_inst.out_str (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Vim: preserving files...%N")))))
						screen_inst.screen_start
						term_inst.out_flush
						memline_inst.ml_sync_all (0, 0)
						js.break
					end
				end
				if not js.loop_jumped then
					l_buf___6.ce_gets (l_buf___6.item.b_next)
				end
			end
			js.reset
			memline_inst.ml_close_all (0)
			term_inst.out_str (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Vim: Finished.%N")))))
			main_inst.getout (1)
		end

	vim_fexists (a_fname: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_st: SD_STAT
			js: JUMP_STATE
		do
			create l_st.make

			if (stat (create {CE_POINTER [INTEGER_8]}.make_cast (a_fname), (l_st.address))).to_boolean then
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 1
			end
		end

	line_breakcheck
		do
			breakcheck_count := breakcheck_count + 1
			if breakcheck_count >= 200 then
				breakcheck_count := 0
				ui_inst.ui_breakcheck
			end
		end

	fast_breakcheck
		do
			breakcheck_count := breakcheck_count + 1
			if breakcheck_count >= 2000 then
				breakcheck_count := 0
				ui_inst.ui_breakcheck
			end
		end

	expand_wildcards_eval (a_pat: CE_POINTER [CE_POINTER [NATURAL_8]]; a_num_file: CE_POINTER [INTEGER_32]; a_file: CE_POINTER [CE_POINTER [CE_POINTER [NATURAL_8]]]; a_flags___0: INTEGER_32): INTEGER_32
		local
			l_ret: INTEGER_32
			l_eval_pat: CE_POINTER [NATURAL_8]
			l_exp_pat: CE_POINTER [NATURAL_8]
			l_ignored_msg: CE_POINTER [NATURAL_8]
			l_usedlen: INTEGER_32
			l_pos: INTEGER_32
		do
			create l_eval_pat.make
			create l_exp_pat.make
			create l_ignored_msg.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ret := 0
					l_eval_pat.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_exp_pat.ce_gets (a_pat.item)
					if (l_exp_pat.item).to_integer_32 /= 37 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 3 then -- else:
						if (l_exp_pat.item).to_integer_32 /= 35 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 6 then -- else:
						if (l_exp_pat.item).to_integer_32 /= 60 then
							l_pos := -1 + 8 -- skip if block
						end
				when 7 then -- if: | _L:
						globals_inst.emsg_off := globals_inst.emsg_off + 1
						l_eval_pat.ce_gets (ex_docmd_inst.eval_vars (l_exp_pat, l_exp_pat, create {CE_POINTER [INTEGER_32]}.make_shared ($l_usedlen), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), l_ignored_msg.address, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)))
						globals_inst.emsg_off := globals_inst.emsg_off - 1
						if (l_eval_pat.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_exp_pat.ce_gets (concat_str (l_eval_pat, l_exp_pat + l_usedlen))
						end
				when 8 then -- if done | if done
						if (l_exp_pat.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_ret := expand_wildcards (1, l_exp_pat.address, a_num_file, a_file, a_flags___0)
						end
						if (l_eval_pat.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_exp_pat))
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_eval_pat))
						end
						Result := l_ret
				when 9 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	expand_wildcards (a_num_pat: INTEGER_32; a_pat: CE_POINTER [CE_POINTER [NATURAL_8]]; a_num_file: CE_POINTER [INTEGER_32]; a_file: CE_POINTER [CE_POINTER [CE_POINTER [NATURAL_8]]]; a_flags___0: INTEGER_32): INTEGER_32
		local
			l_retval: INTEGER_32
			l_i___0: INTEGER_32
			l_j: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_non_suf_match: INTEGER_32
			l_ffname: CE_POINTER [NATURAL_8]
			l_tmp___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_p___0.make
			create l_ffname.make

			l_retval := gen_expand_wildcards (a_num_pat, a_pat, a_num_file, a_file, a_flags___0)
			if ((a_flags___0).bit_and (16)).to_boolean then
				Result := l_retval
				js.return
			elseif l_retval = 0 then
				Result := l_retval
				js.return
			end
			if not js.return_called then
				if (option_inst.p_wig.item).to_boolean then
					l_i___0 := 0
					from
					until
						not (not js.loop_left and then (l_i___0 < a_num_file.item))
					loop
						js.reset
						l_ffname.ce_gets (FullName_save (a_file.item[l_i___0], 0))
						if (l_ffname.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							js.break
						end
						if not js.loop_jumped then
							if (fileio_inst.match_file_list (option_inst.p_wig, a_file.item[l_i___0], l_ffname)).to_boolean then
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_file.item[l_i___0]))
								l_j := l_i___0
								from
								until
									not (l_j + 1 < a_num_file.item)
								loop
									a_file.item[l_j] := a_file.item[(l_j + 1)]
									l_j := l_j + 1
								end
								a_num_file.item := (a_num_file.item) - 1
								l_i___0 := l_i___0 - 1
							end
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_ffname))
							l_i___0 := l_i___0 + 1
						end
					end
					js.reset
				end
				if a_num_file.item > 1 then
					l_non_suf_match := 0
					l_i___0 := 0
					from
					until
						not (not js.loop_left and then (l_i___0 < a_num_file.item))
					loop
						if not (match_suffix (a_file.item[l_i___0])).to_boolean then
							l_p___0.ce_gets (a_file.item[l_i___0])
							l_j := l_i___0
							from
							until
								not (l_j > l_non_suf_match)
							loop
								a_file.item[l_j] := a_file.item[(l_j - 1)]
								l_j := l_j - 1
							end
							l_tmp___0 := l_non_suf_match
							l_non_suf_match := l_non_suf_match + 1
							a_file.item[l_tmp___0] := l_p___0
						end
						l_i___0 := l_i___0 + 1
					end
				end
				Result := l_retval
			end
		end

	match_suffix (a_fname: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_fnamelen: INTEGER_32
			l_setsuflen: INTEGER_32
			l_setsuf: CE_POINTER [NATURAL_8]
			l_suf_buf: CE_ARRAY [NATURAL_8]
			l_tail: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_setsuf.make
			create l_suf_buf.make (<<30>>)
			create l_tail.make

			l_fnamelen := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_fname))).to_integer_32
			l_setsuflen := 0
			l_setsuf.ce_gets (option_inst.p_su)
			from
			until
				not (not js.loop_left and then ((l_setsuf.item).to_boolean))
			loop
				js.reset
				l_setsuflen := misc2_inst.copy_option_part (l_setsuf.address, l_suf_buf, 30, ce_string (".,"))
				if l_setsuflen = 0 then
					l_tail.ce_gets ((gettail (a_fname)))
					if ((misc2_inst.vim_strchr (l_tail, ('.').code)).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						l_setsuflen := 1
						js.break
					end
				else
					if l_fnamelen >= l_setsuflen then
						if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_suf_buf), create {CE_POINTER [INTEGER_8]}.make_cast (((a_fname + l_fnamelen) - l_setsuflen)), l_setsuflen.to_natural_32)) = 0 then
							js.break
						end
					end
					if not js.loop_jumped then
						l_setsuflen := 0
					end
				end
			end
			js.reset
			Result := (l_setsuflen /= 0).to_integer
		end

	pstrcmp (a_a: CE_POINTER [ANY]; a_b: CE_POINTER [ANY]): INTEGER_32
		do
			Result := (misc2_inst.pathcmp ((create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_cast (a_a)).item, (create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_cast (a_b)).item, -1))
		end

	pstrcmp_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent pstrcmp)
		end

	unix_expandpath (a_gap: CE_POINTER [PD_GROWARRAY]; a_path: CE_POINTER [NATURAL_8]; a_wildoff: INTEGER_32; a_flags___0: INTEGER_32; a_didstar: INTEGER_32): INTEGER_32
		local
			l_buf___6: CE_POINTER [NATURAL_8]
			l_path_end: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_s: CE_POINTER [NATURAL_8]
			l_e: CE_POINTER [NATURAL_8]
			l_start_len: INTEGER_32
			l_pat: CE_POINTER [NATURAL_8]
			l_regmatch___0: PD_REGMATCH_T
			l_starts_with_dot: INTEGER_32
			l_matches___0: INTEGER_32
			l_len: INTEGER_32
			l_starstar: INTEGER_32
			l_dirp: CE_POINTER [ANY]
			l_dp: CE_POINTER [SD_DIRENT]
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___4: CE_POINTER [NATURAL_8]
			l_tmp___5: CE_POINTER [NATURAL_8]
			l_tmp___8: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_buf___6.make
			create l_path_end.make
			create l_p___0.make
			create l_s.make
			create l_e.make
			create l_pat.make
			create l_regmatch___0.make
			create l_dirp.make
			create l_dp.make
			create l_tmp___0.make
			create l_tmp___1.make
			create l_tmp___4.make
			create l_tmp___5.make
			create l_tmp___8.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_start_len := a_gap.item.ga_len
					l_starstar := 0
					if stardepth > 0 then
						ui_inst.ui_breakcheck
						if globals_inst.got_int.to_boolean then
							Result := 0
							js.return
						end
					end
					if not js.return_called then
						l_buf___6.ce_gets (misc2_inst.alloc ((((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_path))).to_integer_32 + 250) + 5).to_natural_32))
						if (l_buf___6.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							Result := 0
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						l_p___0.ce_gets (l_buf___6)
						l_s.ce_gets (l_buf___6)
						l_e.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						l_path_end.ce_gets (a_path)
				when 2 then -- loop condition:
						if not (not js.loop_left and then ((l_path_end.item).to_integer_32 /= 0)) then
							l_pos := -1 + 8 -- skip loop
						end
				when 3 then -- loop body:
						js.reset
						if not ((l_path_end.c_pointer.to_integer_32).to_natural_32 >= ((a_path + a_wildoff).c_pointer.to_integer_32).to_natural_32) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if (charset_inst.rem_backslash (l_path_end)).to_boolean then
							l_tmp___0.ce_gets (l_p___0)
							l_p___0.ce_gets (l_p___0 + 1)
							l_tmp___1.ce_gets (l_path_end)
							l_path_end.ce_gets (l_path_end + 1)
							l_tmp___0.item := l_tmp___1.item
						else
							l_pos := -1 + 6 -- goto _L
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L:
						if (l_path_end.item).to_integer_32 = 47 then
							if (l_e.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								js.break
							end
							if not js.loop_jumped then
								l_s.ce_gets (l_p___0 + 1)
							end
						elseif (l_path_end.c_pointer.to_integer_32).to_natural_32 >= ((a_path + a_wildoff).c_pointer.to_integer_32).to_natural_32 then
							if ((misc2_inst.vim_strchr (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("*?[{~$")), (l_path_end.item).to_integer_32)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								l_e.ce_gets (l_p___0)
							end
						end
				when 7 then
						if not js.loop_jumped then
							if globals_inst.has_mbyte.to_boolean then
								l_len := globals_inst.mb_ptr2len.integer_32_item ([l_path_end])
								strncpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), create {CE_POINTER [INTEGER_8]}.make_cast (l_path_end), l_len.to_natural_32).do_nothing
								l_p___0.ce_gets (l_p___0 + l_len)
								l_path_end.ce_gets (l_path_end + l_len)
							else
								l_tmp___4.ce_gets (l_p___0)
								l_p___0.ce_gets (l_p___0 + 1)
								l_tmp___5.ce_gets (l_path_end)
								l_path_end.ce_gets (l_path_end + 1)
								l_tmp___4.item := l_tmp___5.item
							end
						end
						l_pos := -1 + 2 -- back to loop condition
				when 8 then -- loop done
						js.reset
						l_e.ce_gets (l_p___0)
						l_e.item := (('%/0/').code).to_natural_8
						l_p___0.ce_gets (l_buf___6 + a_wildoff)
						from
						until
							not ((l_p___0.c_pointer.to_integer_32).to_natural_32 < (l_s.c_pointer.to_integer_32).to_natural_32)
						loop
							if (charset_inst.rem_backslash (l_p___0)).to_boolean then
								memmove (create {CE_POINTER [ANY]}.make_cast (l_p___0), create {CE_POINTER [ANY]}.make_cast ((l_p___0 + 1)), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((l_p___0 + 1)))) + {NATURAL_32} 1).do_nothing
								l_e.ce_gets (l_e - 1)
								l_s.ce_gets (l_s - 1)
							end
							l_p___0.ce_gets (l_p___0 + 1)
						end
						l_p___0.ce_gets (l_s)
						from
						until
							not ((l_p___0.c_pointer.to_integer_32).to_natural_32 < (l_e.c_pointer.to_integer_32).to_natural_32)
						loop
							if (l_p___0[0]).to_integer_32 = 42 then
								if (l_p___0[1]).to_integer_32 = 42 then
									l_starstar := 1
								end
							end
							l_p___0.ce_gets (l_p___0 + 1)
						end
						l_starts_with_dot := ((l_s.item).to_integer_32 = 46).to_integer
						l_pat.ce_gets (fileio_inst.file_pat_to_reg_pat (l_s, l_e, create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), 0))
						if (l_pat.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_buf___6))
							Result := 0
							js.return
						end
				when 9 then -- if done
					if not js.return_called then
						l_regmatch___0.rm_ic := 0
						l_regmatch___0.regprog := regexp_inst.vim_regcomp (l_pat, 1)
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_pat))
						if ((l_regmatch___0.regprog).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_buf___6))
							Result := 0
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 21 -- skip if block
					end
				when 10 then -- if:
						if not a_didstar.to_boolean then
							if stardepth < 100 then
								if l_starstar.to_boolean then
									if l_e.distance (l_s) = 2 then
										if (l_path_end.item).to_integer_32 = 47 then
											strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_s), create {CE_POINTER [INTEGER_8]}.make_cast ((l_path_end + 1))).do_nothing
											stardepth := stardepth + 1
											unix_expandpath (a_gap, l_buf___6, l_s.distance (l_buf___6), a_flags___0, 1).do_nothing
											stardepth := stardepth - 1
										end
									end
								end
							end
						end
						l_s.item := (('%/0/').code).to_natural_8
						if (l_buf___6.item).to_integer_32 = 0 then
							l_tmp___8.ce_gets (ce_string ("."))
						else
							l_tmp___8.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6))
						end
						l_dirp.ce_gets (opendir (l_tmp___8))
						if (l_dirp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 20 -- skip if block
						end
				when 11 then -- if: | loop condition:
						if js.loop_left then
							l_pos := -1 + 19 -- skip loop
						end
				when 12 then -- loop body:
						js.reset
						l_dp.ce_gets (readdir (l_dirp))
						if (l_dp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 18 -- skip if block
						end
				when 13 then -- if:
						if (l_dp.item.d_name[0]).to_integer_32 = 46 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_pos := -1 + 17 -- goto _L___0
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 16 then -- else:
						if not (l_starts_with_dot.to_boolean) then
							l_pos := -1 + 18 -- skip if block
						end
				when 17 then -- if: | _L___0:
						if (regexp_inst.vim_regexec (l_regmatch___0.address, create {CE_POINTER [NATURAL_8]}.make_cast ((l_dp.item.d_name)), 0)).to_boolean then
							strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_s), (l_dp.item.d_name)).do_nothing
							l_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6))).to_integer_32
							if l_starstar.to_boolean then
								if stardepth < 100 then
									strcpy (create {CE_POINTER [INTEGER_8]}.make_cast ((l_buf___6 + l_len)), ce_string ("/**")).do_nothing
									strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (((l_buf___6 + l_len) + 3)), create {CE_POINTER [INTEGER_8]}.make_cast (l_path_end)).do_nothing
									stardepth := stardepth + 1
									unix_expandpath (a_gap, l_buf___6, l_len + 1, a_flags___0, 1).do_nothing
									stardepth := stardepth - 1
								end
							end
							strcpy (create {CE_POINTER [INTEGER_8]}.make_cast ((l_buf___6 + l_len)), create {CE_POINTER [INTEGER_8]}.make_cast (l_path_end)).do_nothing
							if (os_unix_inst.mch_has_exp_wildcard (l_path_end)).to_boolean then
								unix_expandpath (a_gap, l_buf___6, l_len + 1, a_flags___0, 0).do_nothing
							else
								if (l_path_end.item).to_integer_32 /= 0 then
									charset_inst.backslash_halve ((l_buf___6 + l_len) + 1)
								end
								if (os_unix_inst.mch_getperm (l_buf___6)) >= 0 then
									addfile (a_gap, l_buf___6, a_flags___0)
								end
							end
						end
				when 18 then -- if done | if done
						l_pos := -1 + 11 -- back to loop condition
				when 19 then -- loop done
						js.reset
						closedir (l_dirp).do_nothing
				when 20 then -- if done
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_buf___6))
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_regmatch___0.regprog))
						l_matches___0 := a_gap.item.ga_len - l_start_len
						if l_matches___0 > 0 then
							qsort (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast (a_gap.item.ga_data) + l_start_len)), l_matches___0.to_natural_32, Pointer_bytes.to_natural_32, pstrcmp_address)
						end
						Result := l_matches___0
				when 21 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	find_previous_pathsep (a_path: CE_POINTER [NATURAL_8]; a_psep: CE_POINTER [CE_POINTER [NATURAL_8]]): INTEGER_32
		local
			l_tmp___2: INTEGER_32
			js: JUMP_STATE
		do
			if ((a_psep.item).c_pointer.to_integer_32).to_natural_32 > (a_path.c_pointer.to_integer_32).to_natural_32 then
				if (vim_ispathsep (((a_psep.item).item).to_integer_32)).to_boolean then
					a_psep.item := (a_psep.item) - 1
				end
			end
			from
			until
				not (not js.loop_left and then (((a_psep.item).c_pointer.to_integer_32).to_natural_32 > (a_path.c_pointer.to_integer_32).to_natural_32))
			loop
				if (vim_ispathsep (((a_psep.item).item).to_integer_32)).to_boolean then
					Result := 1
					js.return
				end
				if not js.return_called then
					if globals_inst.has_mbyte.to_boolean then
						l_tmp___2 := (globals_inst.mb_head_off.integer_32_item ([a_path, a_psep.item - 1])) + 1
					else
						l_tmp___2 := 1
					end
					a_psep.item := a_psep.item - l_tmp___2
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	is_unique (a_maybe_unique: CE_POINTER [NATURAL_8]; a_gap: CE_POINTER [PD_GROWARRAY]; a_i___0: INTEGER_32): INTEGER_32
		local
			l_j: INTEGER_32
			l_candidate_len: INTEGER_32
			l_other_path_len: INTEGER_32
			l_other_paths: CE_POINTER [CE_POINTER [NATURAL_8]]
			l_rival: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_other_paths.make
			create l_rival.make

			l_other_paths.ce_gets (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast (a_gap.item.ga_data))
			l_j := 0
			from
			until
				not (not js.loop_left and then (l_j < a_gap.item.ga_len))
			loop
				js.reset
				if l_j = a_i___0 then
					js.continue
				end
				if not js.loop_jumped then
					l_candidate_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_maybe_unique))).to_integer_32
					l_other_path_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_other_paths[l_j]))).to_integer_32
					if l_other_path_len < l_candidate_len then
						js.continue
					end
				end
				if not js.loop_jumped then
					l_rival.ce_gets ((l_other_paths[l_j] + l_other_path_len) - l_candidate_len)
					if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_maybe_unique), create {CE_POINTER [INTEGER_8]}.make_cast (l_rival))) = 0 then
						Result := 0
						js.return
					end
				end
				if not js.loop_left then
					l_j := l_j + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	expand_path_option (a_curdir: CE_POINTER [NATURAL_8]; a_gap: CE_POINTER [PD_GROWARRAY])
		local
			l_path_option: CE_POINTER [NATURAL_8]
			l_tmp: CE_POINTER [NATURAL_8]
			l_buf___6: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_tmp___9: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_path_option.make
			create l_tmp.make
			create l_buf___6.make
			create l_p___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if ((globals_inst.curbuf.item.b_p_path).item).to_integer_32 = 0 then
						l_tmp.ce_gets (option_inst.p_path)
					else
						l_tmp.ce_gets (globals_inst.curbuf.item.b_p_path)
					end
					l_path_option.ce_gets (l_tmp)
					l_buf___6.ce_gets (misc2_inst.alloc ({NATURAL_32} 4096))
					if (l_buf___6.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						js.return
					end
					if js.return_called then
						l_pos := -1 + 14 -- skip if block
					end
				when 1 then -- if: | loop condition:
						if not (not js.loop_left and then ((l_path_option.item).to_integer_32 /= 0)) then
							l_pos := -1 + 13 -- skip loop
						end
				when 2 then -- loop body:
						js.reset
						misc2_inst.copy_option_part (l_path_option.address, l_buf___6, 4096, ce_string (" ,")).do_nothing
						if (l_buf___6[0]).to_integer_32 /= 46 then
							l_pos := -1 + 11 -- skip if block
						end
				when 3 then -- if:
						if (l_buf___6[1]).to_integer_32 /= 0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L___0
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 6 then -- else:
						if not ((vim_ispathsep ((l_buf___6[1]).to_integer_32)).to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if: | _L___0:
						if ((globals_inst.curbuf.item.b_ffname).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							js.continue
						end
						if not js.loop_jumped then
							l_p___0.ce_gets (gettail (globals_inst.curbuf.item.b_ffname))
							l_len := l_p___0.distance ((globals_inst.curbuf.item.b_ffname))
							if l_len + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6))).to_integer_32 >= 4096 then
								js.continue
							end
						end
						if not js.loop_jumped then
							if (l_buf___6[1]).to_integer_32 = 0 then
								l_buf___6[l_len] := (('%/0/').code).to_natural_8
							else
								memmove (create {CE_POINTER [ANY]}.make_cast ((l_buf___6 + l_len)), create {CE_POINTER [ANY]}.make_cast ((l_buf___6 + 2)), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((l_buf___6 + 2)))) + {NATURAL_32} 1).do_nothing
							end
							memmove (create {CE_POINTER [ANY]}.make_cast (l_buf___6), create {CE_POINTER [ANY]}.make_cast (globals_inst.curbuf.item.b_ffname), l_len.to_natural_32).do_nothing
							tag_inst.simplify_filename (l_buf___6)
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else:
						l_pos := -1 + 11 -- goto _L
				when 10 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 12
				when 11 then -- else: | _L:
						if (l_buf___6[0]).to_integer_32 = 0 then
							strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6), create {CE_POINTER [INTEGER_8]}.make_cast (a_curdir)).do_nothing
						elseif (window_inst.path_with_url (l_buf___6)).to_boolean then
							js.continue
						elseif not (os_unix_inst.mch_isFullName (l_buf___6)).to_boolean then
							l_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_curdir))).to_integer_32
							if (l_len + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6))).to_integer_32) + 3 > 4096 then
								js.continue
							end
							if not js.loop_jumped then
								memmove (create {CE_POINTER [ANY]}.make_cast (((l_buf___6 + l_len) + 1)), create {CE_POINTER [ANY]}.make_cast (l_buf___6), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6))) + {NATURAL_32} 1).do_nothing
								strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6), create {CE_POINTER [INTEGER_8]}.make_cast (a_curdir)).do_nothing
								l_buf___6[l_len] := (('/').code).to_natural_8
								tag_inst.simplify_filename (l_buf___6)
							end
						end
				when 12 then
						if not js.loop_jumped then
							if (misc2_inst.ga_grow (a_gap, 1)) = 0 then
								js.break
							end
						end
						if not js.loop_jumped then
							l_p___0.ce_gets (misc2_inst.vim_strsave (l_buf___6))
							if (l_p___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								js.break
							end
						end
						if not js.loop_jumped then
							l_tmp___9 := a_gap.item.ga_len
							a_gap.item.ga_len := (a_gap.item.ga_len) + 1
							create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast (a_gap.item.ga_data)[l_tmp___9] := l_p___0
						end
						l_pos := -1 + 1 -- back to loop condition
				when 13 then -- loop done
						js.reset
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_buf___6))
				when 14 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_path_cutoff (a_fname: CE_POINTER [NATURAL_8]; a_gap: CE_POINTER [PD_GROWARRAY]): CE_POINTER [NATURAL_8]
		local
			l_i___0: INTEGER_32
			l_maxlen: INTEGER_32
			l_path_part: CE_POINTER [CE_POINTER [NATURAL_8]]
			l_cutoff: CE_POINTER [NATURAL_8]
			l_j: INTEGER_32
			l_tmp___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_path_part.make
			create l_cutoff.make

			l_maxlen := 0
			l_path_part.ce_gets (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast (a_gap.item.ga_data))
			l_cutoff.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
			l_i___0 := 0
			from
			until
				not (not js.loop_left and then (l_i___0 < a_gap.item.ga_len))
			loop
				l_j := 0
				from
				until
					js.loop_left
				loop
					js.reset
					if (a_fname[l_j]).to_integer_32 = ((l_path_part[l_i___0])[l_j]).to_integer_32 then
						if (a_fname[l_j]).to_integer_32 /= 0 then
							if ((l_path_part[l_i___0])[l_j]).to_integer_32 = 0 then
								js.break
							end
						else
							js.break
						end
					else
						js.break
					end
					if not js.loop_jumped then
						l_j := l_j + 1
					end
				end
				js.reset
				if l_j > l_maxlen then
					l_maxlen := l_j
					l_cutoff.ce_gets (a_fname + l_j)
				end
				l_i___0 := l_i___0 + 1
			end
			if (l_cutoff.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				from
				until
					js.loop_left
				loop
					js.reset
					if not (vim_ispathsep ((l_cutoff.item).to_integer_32)).to_boolean then
						js.break
					end
					if not js.loop_jumped then
						if globals_inst.has_mbyte.to_boolean then
							l_tmp___0 := (globals_inst.mb_ptr2len.integer_32_item ([l_cutoff]))
						else
							l_tmp___0 := 1
						end
						l_cutoff.ce_gets (l_cutoff + l_tmp___0)
					end
				end
				js.reset
			end
			Result := l_cutoff
		end

	uniquefy_paths (a_gap: CE_POINTER [PD_GROWARRAY]; a_pattern: CE_POINTER [NATURAL_8])
		local
			l_i___0: INTEGER_32
			l_len: INTEGER_32
			l_fnames: CE_POINTER [CE_POINTER [NATURAL_8]]
			l_sort_again: INTEGER_32
			l_pat: CE_POINTER [NATURAL_8]
			l_file_pattern: CE_POINTER [NATURAL_8]
			l_curdir: CE_POINTER [NATURAL_8]
			l_regmatch___0: PD_REGMATCH_T
			l_path_ga: PD_GROWARRAY
			l_in_curdir: CE_POINTER [CE_POINTER [NATURAL_8]]
			l_short_name: CE_POINTER [NATURAL_8]
			l_path: CE_POINTER [NATURAL_8]
			l_is_in_curdir: INTEGER_32
			l_dir_end: CE_POINTER [NATURAL_8]
			l_pathsep_p: CE_POINTER [NATURAL_8]
			l_path_cutoff: CE_POINTER [NATURAL_8]
			l_tmp___4: INTEGER_32
			l_tmp___9: NATURAL_32
			l_rel_path: CE_POINTER [NATURAL_8]
			l_path___0: CE_POINTER [NATURAL_8]
			l_tmp___13: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_fnames.make
			create l_pat.make
			create l_file_pattern.make
			create l_curdir.make
			create l_regmatch___0.make
			create l_path_ga.make
			create l_in_curdir.make
			create l_short_name.make
			create l_path.make
			create l_dir_end.make
			create l_pathsep_p.make
			create l_path_cutoff.make
			create l_rel_path.make
			create l_path___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_fnames.ce_gets (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast (a_gap.item.ga_data))
					l_sort_again := 0
					l_in_curdir.ce_gets (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer))
					remove_duplicates (a_gap)
					misc2_inst.ga_init2 (l_path_ga.address, (Pointer_bytes.to_natural_32).to_integer_32, 1)
					l_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_pattern))).to_integer_32
					l_file_pattern.ce_gets (misc2_inst.alloc ((l_len + 2).to_natural_32))
					if (l_file_pattern.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						js.return
					end
					if not js.return_called then
						l_file_pattern[0] := (('*').code).to_natural_8
						l_file_pattern[1] := (('%/0/').code).to_natural_8
						strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_file_pattern), create {CE_POINTER [INTEGER_8]}.make_cast (a_pattern)).do_nothing
						l_pat.ce_gets (fileio_inst.file_pat_to_reg_pat (l_file_pattern, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), 1))
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_file_pattern))
						if (l_pat.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							js.return
						end
					end
					if not js.return_called then
						l_regmatch___0.rm_ic := 1
						l_regmatch___0.regprog := regexp_inst.vim_regcomp (l_pat, 3)
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_pat))
						if ((l_regmatch___0.regprog).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 11 -- skip if block
					end
				when 1 then -- if:
						l_curdir.ce_gets (misc2_inst.alloc ({NATURAL_32} 4096))
						if (l_curdir.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 10 -- goto theend
						end
				when 2 then
						os_unix_inst.mch_dirname (l_curdir, 4096).do_nothing
						expand_path_option (l_curdir, l_path_ga.address)
						l_in_curdir.ce_gets (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast ((misc2_inst.alloc_clear ((a_gap.item.ga_len).to_natural_32 * Pointer_bytes.to_natural_32))))
						if (l_in_curdir.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 10 -- goto theend
						end
				when 3 then
						l_i___0 := 0
						from
						until
							js.loop_left
						loop
							js.reset
							if l_i___0 < a_gap.item.ga_len then
								if globals_inst.got_int.to_boolean then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_path.ce_gets (l_fnames[l_i___0])
								l_dir_end.ce_gets ((gettail_dir (l_path)))
								l_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_path))).to_integer_32
								if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_curdir), create {CE_POINTER [INTEGER_8]}.make_cast (l_path), (l_dir_end.distance (l_path)).to_natural_32)) = 0 then
									if (l_curdir[(l_dir_end.distance (l_path))]).to_integer_32 = 0 then
										l_tmp___4 := 1
									else
										l_tmp___4 := 0
									end
								else
									l_tmp___4 := 0
								end
								l_is_in_curdir := l_tmp___4
								if l_is_in_curdir.to_boolean then
									l_in_curdir[l_i___0] := misc2_inst.vim_strsave (l_path)
								end
								l_path_cutoff.ce_gets (get_path_cutoff (l_path, l_path_ga.address))
								l_pathsep_p.ce_gets ((l_path + l_len) - 1)
								from
								until
									js.loop_left
								loop
									js.reset
									if not (find_previous_pathsep (l_path, l_pathsep_p.address)).to_boolean then
										js.break
									end
									if not js.loop_jumped then
										if (regexp_inst.vim_regexec (l_regmatch___0.address, l_pathsep_p + 1, 0)).to_boolean then
											if (is_unique (l_pathsep_p + 1, a_gap, l_i___0)).to_boolean then
												if (l_path_cutoff.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
													if ((l_pathsep_p + 1).c_pointer.to_integer_32).to_natural_32 >= (l_path_cutoff.c_pointer.to_integer_32).to_natural_32 then
														l_sort_again := 1
														memmove (create {CE_POINTER [ANY]}.make_cast (l_path), create {CE_POINTER [ANY]}.make_cast ((l_pathsep_p + 1)), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_pathsep_p)))).do_nothing
														js.break
													end
												end
											end
										end
									end
								end
								js.reset
								if (os_unix_inst.mch_isFullName (l_path)).to_boolean then
									l_short_name.ce_gets (fileio_inst.shorten_fname (l_path, l_curdir))
									if (l_short_name.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
										if (l_short_name.c_pointer.to_integer_32).to_natural_32 > ((l_path + 1).c_pointer.to_integer_32).to_natural_32 then
											strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_path), ce_string (".")).do_nothing
											add_pathsep (l_path)
											l_tmp___9 := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_short_name))
											memmove (create {CE_POINTER [ANY]}.make_cast ((l_path + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_path))).to_integer_32)), create {CE_POINTER [ANY]}.make_cast (l_short_name), l_tmp___9 + {NATURAL_32} 1).do_nothing
										end
									end
								end
								ui_inst.ui_breakcheck
								l_i___0 := l_i___0 + 1
							end
						end
						js.reset
						l_i___0 := 0
				when 4 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 9 -- skip loop
						end
				when 5 then -- loop body:
						js.reset
						if l_i___0 < a_gap.item.ga_len then
							if globals_inst.got_int.to_boolean then
								js.break
							end
						else
							js.break
						end
						if not js.loop_jumped then
							l_path___0.ce_gets (l_in_curdir[l_i___0])
							if (l_path___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								js.continue
							end
						end
						if not js.loop_jumped then
							l_short_name.ce_gets (fileio_inst.shorten_fname (l_path___0, l_curdir))
							if (l_short_name.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								l_short_name.ce_gets (l_path___0)
							end
							if (is_unique (l_short_name, a_gap, l_i___0)).to_boolean then
								strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_fnames[l_i___0]), create {CE_POINTER [INTEGER_8]}.make_cast (l_short_name)).do_nothing
								js.continue
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_tmp___13 := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_short_name))
						l_rel_path.ce_gets (misc2_inst.alloc (((l_tmp___13 + (strlen (ce_string ("/")))) + {NATURAL_32} 2)))
						if (l_rel_path.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 10 -- goto theend
						end
				when 7 then
						strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_rel_path), ce_string (".")).do_nothing
						add_pathsep (l_rel_path)
						strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_rel_path), create {CE_POINTER [INTEGER_8]}.make_cast (l_short_name)).do_nothing
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_fnames[l_i___0]))
						l_fnames[l_i___0] := l_rel_path
						l_sort_again := 1
						ui_inst.ui_breakcheck
				when 8 then -- if done
						if not js.loop_left then
							l_i___0 := l_i___0 + 1
						end
						l_pos := -1 + 4 -- back to loop condition
				when 9 then -- loop done
						js.reset
				when 10 then -- theend:
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_curdir))
						if (l_in_curdir.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_i___0 := 0
							from
							until
								not (l_i___0 < a_gap.item.ga_len)
							loop
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_in_curdir[l_i___0]))
								l_i___0 := l_i___0 + 1
							end
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_in_curdir))
						end
						misc2_inst.ga_clear_strings (l_path_ga.address)
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_regmatch___0.regprog))
						if l_sort_again.to_boolean then
							remove_duplicates (a_gap)
						end
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	expand_in_path (a_gap: CE_POINTER [PD_GROWARRAY]; a_pattern: CE_POINTER [NATURAL_8]; a_flags___0: INTEGER_32): INTEGER_32
		local
			l_curdir: CE_POINTER [NATURAL_8]
			l_path_ga: PD_GROWARRAY
			l_files: CE_POINTER [NATURAL_8]
			l_s: CE_POINTER [NATURAL_8]
			l_e: CE_POINTER [NATURAL_8]
			l_paths: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_curdir.make
			create l_path_ga.make
			create l_files.make
			create l_s.make
			create l_e.make
			create l_paths.make

			l_files.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
			l_paths.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
			l_curdir.ce_gets (misc2_inst.alloc ({NATURAL_32} 4096))
			if (l_curdir.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				Result := 0
				js.return
			end
			if not js.return_called then
				os_unix_inst.mch_dirname (l_curdir, 4096).do_nothing
				misc2_inst.ga_init2 (l_path_ga.address, (Pointer_bytes.to_natural_32).to_integer_32, 1)
				expand_path_option (l_curdir, l_path_ga.address)
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_curdir))
				if l_path_ga.ga_len = 0 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				l_paths.ce_gets (misc2_inst.ga_concat_strings (l_path_ga.address))
				misc2_inst.ga_clear_strings (l_path_ga.address)
				if (l_paths.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				l_files.ce_gets (ex_getln_inst.globpath (l_paths, a_pattern, 0))
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_paths))
				if (l_files.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				l_e.ce_gets (l_files)
				l_s.ce_gets (l_e)
				from
				until
					not (not js.loop_left and then ((l_s.item).to_integer_32 /= 0))
				loop
					js.reset
					from
					until
						js.loop_left
					loop
						js.reset
						if (l_e.item).to_integer_32 /= 10 then
							if (l_e.item).to_integer_32 = 0 then
								js.break
							end
						else
							js.break
						end
						if not js.loop_jumped then
							l_e.ce_gets (l_e + 1)
						end
					end
					js.reset
					if (l_e.item).to_integer_32 = 0 then
						addfile (a_gap, l_s, a_flags___0)
						js.break
					else
						l_e.item := (('%/0/').code).to_natural_8
						addfile (a_gap, l_s, a_flags___0)
						l_e.ce_gets (l_e + 1)
						l_s.ce_gets (l_e)
					end
				end
				js.reset
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_files))
				Result := (a_gap.item.ga_len)
			end
		end

	remove_duplicates (a_gap: CE_POINTER [PD_GROWARRAY])
		local
			l_i___0: INTEGER_32
			l_j: INTEGER_32
			l_fnames: CE_POINTER [CE_POINTER [NATURAL_8]]
			js: JUMP_STATE
		do
			create l_fnames.make

			l_fnames.ce_gets (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast (a_gap.item.ga_data))
			misc2_inst.sort_strings (l_fnames, a_gap.item.ga_len)
			l_i___0 := a_gap.item.ga_len - 1
			from
			until
				not (not js.loop_left and then (l_i___0 > 0))
			loop
				if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_fnames[(l_i___0 - 1)]), create {CE_POINTER [INTEGER_8]}.make_cast (l_fnames[l_i___0]))) = 0 then
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_fnames[l_i___0]))
					l_j := l_i___0 + 1
					from
					until
						not (l_j < a_gap.item.ga_len)
					loop
						l_fnames[(l_j - 1)] := l_fnames[l_j]
						l_j := l_j + 1
					end
					a_gap.item.ga_len := (a_gap.item.ga_len) - 1
				end
				l_i___0 := l_i___0 - 1
			end
		end

	gen_expand_wildcards (a_num_pat: INTEGER_32; a_pat: CE_POINTER [CE_POINTER [NATURAL_8]]; a_num_file: CE_POINTER [INTEGER_32]; a_file: CE_POINTER [CE_POINTER [CE_POINTER [NATURAL_8]]]; a_flags___0: INTEGER_32): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_ga: PD_GROWARRAY
			l_p___0: CE_POINTER [NATURAL_8]
			l_add_pat: INTEGER_32
			l_did_expand_in_path: INTEGER_32
			l_tmp___0: INTEGER_32
			l_t: CE_POINTER [NATURAL_8]
			l_tmp___12: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_ga.make
			create l_p___0.make
			create l_t.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_did_expand_in_path := 0
					if recursive___2.to_boolean then
						Result := (os_unix_inst.mch_expand_wildcards (a_num_pat, a_pat, a_num_file, a_file, a_flags___0))
						js.return
					end
					if not js.return_called then
						l_i___0 := 0
						from
						until
							not (not js.loop_left and then (l_i___0 < a_num_pat))
						loop
							if ((strpbrk (create {CE_POINTER [INTEGER_8]}.make_cast (a_pat[l_i___0]), ce_string ("`%'{"))).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								if (vim_backtick (a_pat[l_i___0])).to_boolean then
									if ((a_pat[l_i___0])[1]).to_integer_32 /= 61 then
										l_tmp___0 := os_unix_inst.mch_expand_wildcards (a_num_pat, a_pat, a_num_file, a_file, a_flags___0)
										Result := l_tmp___0
										js.return
									end
								else
									l_tmp___0 := os_unix_inst.mch_expand_wildcards (a_num_pat, a_pat, a_num_file, a_file, a_flags___0)
									Result := l_tmp___0
									js.return
								end
							end
							if not js.return_called then
								l_i___0 := l_i___0 + 1
							end
						end
					end
					if js.return_called then
						l_pos := -1 + 21 -- skip if block
					end
				when 1 then -- if:
						recursive___2 := 1
						misc2_inst.ga_init2 (l_ga.address, (Pointer_bytes.to_natural_32).to_integer_32, 30)
						l_i___0 := 0
				when 2 then -- loop condition:
						if not (not js.loop_left and then (l_i___0 < a_num_pat)) then
							l_pos := -1 + 21 -- skip loop
						end
				when 3 then -- loop body:
						l_add_pat := -1
						l_p___0.ce_gets (a_pat[l_i___0])
						if not ((vim_backtick (l_p___0)).to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_add_pat := expand_backtick (l_ga.address, l_p___0, a_flags___0)
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 6 then -- else:
						if ((misc2_inst.vim_strchr (l_p___0, ('$').code)).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 9 then -- else:
						if (l_p___0.item).to_integer_32 /= 126 then
							l_pos := -1 + 11 -- skip if block
						end
				when 10 then -- if: | _L:
						l_p___0.ce_gets (expand_env_save_opt (l_p___0, 1))
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_p___0.ce_gets (a_pat[l_i___0])
						elseif ((misc2_inst.vim_strchr (l_p___0, ('$').code)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_p___0))
							misc2_inst.ga_clear_strings (l_ga.address)
							l_i___0 := os_unix_inst.mch_expand_wildcards (a_num_pat, a_pat, a_num_file, a_file, a_flags___0)
							recursive___2 := 0
							Result := l_i___0
							js.return
						elseif (l_p___0.item).to_integer_32 = 126 then
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_p___0))
							misc2_inst.ga_clear_strings (l_ga.address)
							l_i___0 := os_unix_inst.mch_expand_wildcards (a_num_pat, a_pat, a_num_file, a_file, a_flags___0)
							recursive___2 := 0
							Result := l_i___0
							js.return
						end
				when 11 then -- if done
						if not js.return_called then
							if (os_unix_inst.mch_has_exp_wildcard (l_p___0)).to_boolean then
								if ((a_flags___0).bit_and (128)).to_boolean then
									if (os_unix_inst.mch_isFullName (l_p___0)).to_boolean then
										l_add_pat := os_unix_inst.mch_expandpath (l_ga.address, l_p___0, a_flags___0)
									elseif (l_p___0[0]).to_integer_32 = 46 then
										if (vim_ispathsep ((l_p___0[1]).to_integer_32)).to_boolean then
											l_add_pat := os_unix_inst.mch_expandpath (l_ga.address, l_p___0, a_flags___0)
										elseif (l_p___0[1]).to_integer_32 = 46 then
											if (vim_ispathsep ((l_p___0[2]).to_integer_32)).to_boolean then
												l_add_pat := os_unix_inst.mch_expandpath (l_ga.address, l_p___0, a_flags___0)
											else
												recursive___2 := 0
												l_add_pat := expand_in_path (l_ga.address, l_p___0, a_flags___0)
												recursive___2 := 1
												l_did_expand_in_path := 1
											end
										else
											recursive___2 := 0
											l_add_pat := expand_in_path (l_ga.address, l_p___0, a_flags___0)
											recursive___2 := 1
											l_did_expand_in_path := 1
										end
									else
										recursive___2 := 0
										l_add_pat := expand_in_path (l_ga.address, l_p___0, a_flags___0)
										recursive___2 := 1
										l_did_expand_in_path := 1
									end
								else
									l_add_pat := os_unix_inst.mch_expandpath (l_ga.address, l_p___0, a_flags___0)
								end
							end
						end
				when 12 then -- if done
						if js.return_called then
							l_pos := -1 + 20 -- skip if block
						end
				when 13 then -- if:
						if l_add_pat /= -1 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_pos := -1 + 18 -- goto _L___0
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 16 then -- else:
						if l_add_pat /= 0 then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						if not (((a_flags___0).bit_and (4)).to_boolean) then
							l_pos := -1 + 19 -- skip if block
						end
				when 18 then -- if: | _L___0:
						l_t.ce_gets ((charset_inst.backslash_halve_save (l_p___0)))
						if ((a_flags___0).bit_and (4)).to_boolean then
							addfile (l_ga.address, l_t, (((a_flags___0).bit_or (1))).bit_or (2))
						elseif (os_unix_inst.mch_getperm (l_t)) >= 0 then
							addfile (l_ga.address, l_t, a_flags___0)
						end
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_t))
				when 19 then -- if done | if done
						if l_did_expand_in_path.to_boolean then
							if l_ga.ga_len > 0 then
								if ((a_flags___0).bit_and (128)).to_boolean then
									uniquefy_paths (l_ga.address, l_p___0)
								end
							end
						end
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 /= ((a_pat[l_i___0]).c_pointer.to_integer_32).to_natural_32 then
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_p___0))
						end
						l_i___0 := l_i___0 + 1
				when 20 then -- if done
						l_pos := -1 + 2 -- back to loop condition
				when 21 then -- loop done | if done
						if not js.return_called then
							a_num_file.item := l_ga.ga_len
							if ((l_ga.ga_data).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								a_file.item := create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast (l_ga.ga_data)
							else
								a_file.item := create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast (ce_string (""))
							end
							recursive___2 := 0
							if ((l_ga.ga_data).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								l_tmp___12 := 1
							else
								l_tmp___12 := 0
							end
							Result := l_tmp___12
						end
				when 22 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	vim_backtick (a_p___0: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_tmp___0: INTEGER_32
		do
			if (a_p___0.item).to_integer_32 = 96 then
				if (a_p___0[1]).to_integer_32 /= 0 then
					if ((a_p___0 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_p___0))).to_integer_32)[-1]).to_integer_32 = 96 then
						l_tmp___0 := 1
					else
						l_tmp___0 := 0
					end
				else
					l_tmp___0 := 0
				end
			else
				l_tmp___0 := 0
			end
			Result := l_tmp___0
		end

	expand_backtick (a_gap: CE_POINTER [PD_GROWARRAY]; a_pat: CE_POINTER [NATURAL_8]; a_flags___0: INTEGER_32): INTEGER_32
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_cmd: CE_POINTER [NATURAL_8]
			l_buffer: CE_POINTER [NATURAL_8]
			l_cnt: INTEGER_32
			l_i___0: INTEGER_32
			l_tmp___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_p___0.make
			create l_cmd.make
			create l_buffer.make

			l_cnt := 0
			l_cmd.ce_gets (misc2_inst.vim_strnsave (a_pat + 1, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_pat))).to_integer_32 - 2))
			if (l_cmd.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				Result := 0
				js.return
			end
			if not js.return_called then
				if (l_cmd.item).to_integer_32 = 61 then
					l_buffer.ce_gets (eval_inst.eval_to_string (l_cmd + 1, l_p___0.address, 1))
				else
					if ((a_flags___0).bit_and (32)).to_boolean then
						l_tmp___0 := 16
					else
						l_tmp___0 := 0
					end
					l_buffer.ce_gets (get_cmd_output (l_cmd, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), l_tmp___0))
				end
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_cmd))
				if (l_buffer.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				l_cmd.ce_gets (l_buffer)
				from
				until
					not (not js.loop_left and then ((l_cmd.item).to_integer_32 /= 0))
				loop
					l_cmd.ce_gets (charset_inst.skipwhite (l_cmd))
					l_p___0.ce_gets (l_cmd)
					from
					until
						js.loop_left
					loop
						js.reset
						if (l_p___0.item).to_integer_32 /= 0 then
							if (l_p___0.item).to_integer_32 /= 13 then
								if (l_p___0.item).to_integer_32 = 10 then
									js.break
								end
							else
								js.break
							end
						else
							js.break
						end
						if not js.loop_jumped then
							l_p___0.ce_gets (l_p___0 + 1)
						end
					end
					js.reset
					if (l_p___0.c_pointer.to_integer_32).to_natural_32 > (l_cmd.c_pointer.to_integer_32).to_natural_32 then
						l_i___0 := (l_p___0.item).to_integer_32
						l_p___0.item := (('%/0/').code).to_natural_8
						addfile (a_gap, l_cmd, a_flags___0)
						l_p___0.item := l_i___0.to_natural_8
						l_cnt := l_cnt + 1
					end
					l_cmd.ce_gets (l_p___0)
					from
					until
						js.loop_left
					loop
						js.reset
						if (l_cmd.item).to_integer_32 /= 0 then
							if (l_cmd.item).to_integer_32 /= 13 then
								if (l_cmd.item).to_integer_32 /= 10 then
									js.break
								end
							end
						else
							js.break
						end
						if not js.loop_jumped then
							l_cmd.ce_gets (l_cmd + 1)
						end
					end
					js.reset
				end
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_buffer))
				Result := l_cnt
			end
		end

	addfile (a_gap: CE_POINTER [PD_GROWARRAY]; a_f: CE_POINTER [NATURAL_8]; a_flags___0: INTEGER_32)
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_isdir: INTEGER_32
			l_tmp___3: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not ((a_flags___0).bit_and (4)).to_boolean then
						if (os_unix_inst.mch_getperm (a_f)) < 0 then
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						l_isdir := os_unix_inst.mch_isdir (a_f)
						if not (l_isdir.to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if not ((a_flags___0).bit_and (1)).to_boolean then
							js.return
						else
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						if not l_isdir.to_boolean then
							if not ((a_flags___0).bit_and (2)).to_boolean then
								js.return
							end
						end
				when 5 then -- if done
						if not js.return_called and then (not l_isdir.to_boolean) then
							if ((a_flags___0).bit_and (64)).to_boolean then
								if not (os_unix_inst.mch_can_exe (a_f)).to_boolean then
									js.return
								end
							end
						end
						if not js.return_called then
							if (misc2_inst.ga_grow (a_gap, 1)) = 0 then
								js.return
							end
						end
						if not js.return_called then
							l_p___0.ce_gets (misc2_inst.alloc (((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_f))) + {NATURAL_32} 1) + l_isdir.to_natural_32))
							if (l_p___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								js.return
							end
						end
						if not js.return_called then
							strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), create {CE_POINTER [INTEGER_8]}.make_cast (a_f)).do_nothing
							if l_isdir.to_boolean then
								if ((a_flags___0).bit_and (8)).to_boolean then
									add_pathsep (l_p___0)
								end
							end
							l_tmp___3 := a_gap.item.ga_len
							a_gap.item.ga_len := (a_gap.item.ga_len) + 1
							create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast (a_gap.item.ga_data)[l_tmp___3] := l_p___0
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	get_cmd_output (a_cmd: CE_POINTER [NATURAL_8]; a_infile: CE_POINTER [NATURAL_8]; a_flags___0: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_tempname: CE_POINTER [NATURAL_8]
			l_command: CE_POINTER [NATURAL_8]
			l_buffer: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_i___0: INTEGER_32
			l_fd: CE_POINTER [SD_IO_FILE]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_tempname.make
			create l_command.make
			create l_buffer.make
			create l_fd.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_buffer.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_i___0 := 0
					if (ex_cmds_inst.check_restricted).to_boolean then
						Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						js.return
					elseif (ex_cmds_inst.check_secure).to_boolean then
						Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						js.return
					end
					if not js.return_called then
						l_tempname.ce_gets (fileio_inst.vim_tempname (('o').code))
						if (l_tempname.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_notmp))))).do_nothing
							Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						l_command.ce_gets (ex_cmds_inst.make_filter_cmd (a_cmd, a_infile, l_tempname))
						if (l_command.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 5 -- goto done
						end
				when 2 then
						globals_inst.no_check_timestamps := globals_inst.no_check_timestamps + 1
						misc2_inst.call_shell (l_command, (10).bit_or (a_flags___0)).do_nothing
						globals_inst.no_check_timestamps := globals_inst.no_check_timestamps - 1
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_command))
						l_fd.ce_gets (fopen (create {CE_POINTER [INTEGER_8]}.make_cast (l_tempname), ce_string ("r")))
						if (l_fd.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_notopen)))), l_tempname).do_nothing
							l_pos := -1 + 5 -- goto done
						end
				when 3 then
						fseek (l_fd, 0, 2).do_nothing
						l_len := (ftell (l_fd)).to_integer_32
						fseek (l_fd, 0, 0).do_nothing
						l_buffer.ce_gets (misc2_inst.alloc ((l_len + 1).to_natural_32))
						if (l_buffer.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_i___0 := (fread (create {CE_POINTER [ANY]}.make_cast (l_buffer), (1).to_natural_32, l_len.to_natural_32, l_fd)).to_integer_32
						end
						fclose (l_fd).do_nothing
						unlink (create {CE_POINTER [INTEGER_8]}.make_cast (l_tempname)).do_nothing
						if (l_buffer.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 5 -- goto done
						end
				when 4 then
						if l_i___0 /= l_len then
							message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_notread)))), l_tempname).do_nothing
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_buffer))
							l_buffer.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						else
							l_buffer[l_len] := (('%/0/').code).to_natural_8
						end
				when 5 then -- done:
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_tempname))
						Result := l_buffer
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	FreeWild (a_count___2: INTEGER_32; a_files: CE_POINTER [CE_POINTER [NATURAL_8]])
		local
			l_count___2: INTEGER_32
			l_tmp: INTEGER_32
			js: JUMP_STATE
		do
			l_count___2 := a_count___2
			if l_count___2 <= 0 then
				js.return
			elseif (a_files.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				js.return
			end
			if not js.return_called then
				from
				until
					js.loop_left
				loop
					js.reset
					l_tmp := l_count___2
					l_count___2 := l_count___2 - 1
					if not l_tmp.to_boolean then
						js.break
					end
					if not js.loop_jumped then
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_files[l_count___2]))
					end
				end
				js.reset
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_files))
			end
		end

	goto_im: INTEGER_32
		local
			l_tmp___1: INTEGER_32
		do
			if option_inst.p_im.to_boolean then
				if (getchar_inst.stuff_empty).to_boolean then
					if (getchar_inst.typebuf_typed).to_boolean then
						l_tmp___1 := 1
					else
						l_tmp___1 := 0
					end
				else
					l_tmp___1 := 0
				end
			else
				l_tmp___1 := 0
			end
			Result := l_tmp___1
		end

end
