class
	P_MISC2

inherit
	VIM_DATA
		redefine
			default_create
		end
	S_LIBIO
	S_STDIO
	S_CTYPE
	S_SYS_STAT
	S_STDLIB
	S_STRING
	S_LIBINTL
	S_WCTYPE
	S_UNISTD
	S_TIME
	S_FCNTL
	S_MATH
	S_SYS_TIME
	S_LOCALE
	S_BITS_ERRNO
	S_ICONV
	S_UTIME
	S_GLIB_OBJECT
	S_GTK_GTK
	S_SYS_SELECT
	S_X11_XLIB
	S_SIGNAL
	S_DIRENT
	S_PWD
	S_GLIB
	S_PANGO_PANGO
	S_GDK_GDK
	S_LANGINFO
	S_X11_XUTIL
	S_X11_INTRINSIC
	S_SYS_IOCTL
	S_SYS_RESOURCE
	S_SYS_WAIT
	S_SYS_UTSNAME
	S_TERMIOS
	S_DLFCN
	S_X11_ICE_ICELIB
	S_X11_SM_SMLIB
	S_X11_SHELL
	S_X11_STRINGDEFS
	S_SYS_SYSINFO
	S_TERMCAP
	S_TERM
	S_GDK_PIXBUF_GDK_PIXBUF
	S_SYS_SOCKET
	S_NETINET_IN
	S_NETDB

feature {NONE} -- Initialization

	default_create
		do
			create username.make
			create ff_expand_buffer.make
			create mod_mask_table.make (<<9>>)
			create modifier_keys_table.make (<<376>>)
			create key_names_table.make (<<136>>)
			create mouse_table.make (<<20>>)
			create string.make (<<26>>)
			create shape_table.make (<<17>>)
			create mshape_names.make (<<17>>)
			create crc_32_tab.make (<<256>>)
			create keys.make (<<3>>)
			create saved_keys.make (<<3>>)
			create ff_file_to_find.make
			create fdip_search_ctx.make
			create dir.make
		end

feature {ANY} -- attributes

	username: CE_POINTER [NATURAL_8]

	ff_expand_buffer: CE_POINTER [NATURAL_8]

	releasing: INTEGER_32 assign set_releasing

	set_releasing (a_releasing: INTEGER_32)
		do
			releasing := a_releasing
		end

	mod_mask_table: CE_ARRAY [PD_MODMASKTABLE]

	modifier_keys_table: CE_ARRAY [NATURAL_8]

	key_names_table: CE_ARRAY [PD_KEY_NAME_ENTRY]

	mouse_table: CE_ARRAY [PD_MOUSETABLE]

	string: CE_ARRAY [NATURAL_8]

	shape_table: CE_ARRAY [PD_CURSOR_ENTRY]

	mshape_names: CE_ARRAY [CE_POINTER [INTEGER_8]]

	old_mouse_shape: INTEGER_32 assign set_old_mouse_shape

	set_old_mouse_shape (a_old_mouse_shape: INTEGER_32)
		do
			old_mouse_shape := a_old_mouse_shape
		end

	crc_32_tab: CE_ARRAY [NATURAL_32]

	done___0: INTEGER_32 assign set_done___0

	set_done___0 (a_done___0: INTEGER_32)
		do
			done___0 := a_done___0
		end

	keys: CE_ARRAY [NATURAL_32]

	crypt_busy: INTEGER_32 assign set_crypt_busy

	set_crypt_busy (a_crypt_busy: INTEGER_32)
		do
			crypt_busy := a_crypt_busy
		end

	saved_keys: CE_ARRAY [NATURAL_32]

	saved_crypt_method: INTEGER_32 assign set_saved_crypt_method

	set_saved_crypt_method (a_saved_crypt_method: INTEGER_32)
		do
			saved_crypt_method := a_saved_crypt_method
		end

	ff_file_to_find: CE_POINTER [NATURAL_8]

	fdip_search_ctx: CE_POINTER [ANY]

	dir: CE_POINTER [NATURAL_8]

	did_findfile_init: INTEGER_32 assign set_did_findfile_init

	set_did_findfile_init (a_did_findfile_init: INTEGER_32)
		do
			did_findfile_init := a_did_findfile_init
		end

feature {ANY} -- routines

	virtual_active: INTEGER_32
		local
			l_tmp: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if globals_inst.virtual_op /= 2 then
						Result := globals_inst.virtual_op
						js.return
					end
					if js.return_called then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						if option_inst.ve_flags /= {NATURAL_32} 4 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_tmp := 1
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 4 then -- else:
						if not (((option_inst.ve_flags).bit_and ({NATURAL_32} 5)).to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if globals_inst.VIsual_active.to_boolean then
							if globals_inst.VIsual_mode = 22 then
								l_tmp := 1
							else
								l_pos := -1 + 7 -- goto _L___0
							end
						else
							l_pos := -1 + 7 -- goto _L___0
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L___0:
						if ((option_inst.ve_flags).bit_and ({NATURAL_32} 6)).to_boolean then
							if ((globals_inst.State).bit_and (16)).to_boolean then
								l_tmp := 1
							else
								l_tmp := 0
							end
						else
							l_tmp := 0
						end
				when 8 then -- if done
						Result := l_tmp
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	getviscol: INTEGER_32
		local
			l_x___0: INTEGER_32
		do
			charset_inst.getvvcol (globals_inst.curwin, create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curwin.c_pointer + {PD_WINDOW_S}.w_cursor_offset), create {CE_POINTER [INTEGER_32]}.make_shared ($l_x___0), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
			Result := l_x___0
		end

	getviscol2 (a_col: INTEGER_32; a_coladd: INTEGER_32): INTEGER_32
		local
			l_x___0: INTEGER_32
			l_pos___3: PD_POS_T
		do
			create l_pos___3.make

			l_pos___3.lnum := globals_inst.curwin.item.w_cursor.lnum
			l_pos___3.col := a_col
			l_pos___3.coladd := a_coladd
			charset_inst.getvvcol (globals_inst.curwin, l_pos___3.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_x___0), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
			Result := l_x___0
		end

	coladvance_force (a_wcol: INTEGER_32): INTEGER_32
		local
			l_rc: INTEGER_32
		do
			l_rc := (coladvance2 (create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curwin.c_pointer + {PD_WINDOW_S}.w_cursor_offset), 1, 0, a_wcol))
			if a_wcol.to_integer_32 = 2147483647 then
				globals_inst.curwin.item.w_valid := (globals_inst.curwin.item.w_valid).bit_and ((-5))
			else
				globals_inst.curwin.item.w_valid := (globals_inst.curwin.item.w_valid).bit_or ((4))
				globals_inst.curwin.item.w_virtcol := a_wcol
			end
			Result := l_rc
		end

	coladvance (a_wcol: INTEGER_32): INTEGER_32
		local
			l_rc: INTEGER_32
		do
			l_rc := (getvpos (create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curwin.c_pointer + {PD_WINDOW_S}.w_cursor_offset), a_wcol))
			if a_wcol.to_integer_32 = 2147483647 then
				globals_inst.curwin.item.w_valid := (globals_inst.curwin.item.w_valid).bit_and ((-5))
			elseif l_rc = 0 then
				globals_inst.curwin.item.w_valid := (globals_inst.curwin.item.w_valid).bit_and ((-5))
			elseif ((memline_inst.ml_get_cursor).item).to_integer_32 /= 9 then
				globals_inst.curwin.item.w_valid := (globals_inst.curwin.item.w_valid).bit_or ((4))
				globals_inst.curwin.item.w_virtcol := a_wcol
			end
			Result := l_rc
		end

	getvpos (a_pos___3: CE_POINTER [PD_POS_T]; a_wcol: INTEGER_32): INTEGER_32
		do
			Result := (coladvance2 (a_pos___3, 0, (virtual_active), a_wcol))
		end

	coladvance2 (a_pos___3: CE_POINTER [PD_POS_T]; a_addspaces: INTEGER_32; a_finetune: INTEGER_32; a_wcol: INTEGER_32): INTEGER_32
		local
			l_wcol: INTEGER_32
			l_idx: INTEGER_32
			l_ptr: CE_POINTER [NATURAL_8]
			l_line: CE_POINTER [NATURAL_8]
			l_col: INTEGER_32
			l_csize: INTEGER_32
			l_one_more: INTEGER_32
			l_head___0: INTEGER_32
			l_tmp: INTEGER_32
			l_width: INTEGER_32
			l_tmp___4: INTEGER_32
			l_correct: INTEGER_32
			l_newline: CE_POINTER [NATURAL_8]
			l_t: INTEGER_32
			l_linelen___0: INTEGER_32
			l_correct___0: INTEGER_32
			l_newline___0: CE_POINTER [NATURAL_8]
			l_t___0: INTEGER_32
			l_s: INTEGER_32
			l_v: INTEGER_32
			l_tmp___8: INTEGER_32
			l_tmp___9: INTEGER_32
			l_scol: INTEGER_32
			l_ecol: INTEGER_32
			l_b: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_ptr.make
			create l_line.make
			create l_newline.make
			create l_newline___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_wcol := a_wcol
					l_col := 0
					l_csize := 0
					l_head___0 := 0
					if not (((globals_inst.State).bit_and (16)).to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_tmp := 1
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 3 then -- else:
						if globals_inst.restart_edit = 0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_tmp := 1
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 6 then -- else:
						if not (globals_inst.VIsual_active.to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if (option_inst.p_sel.item).to_integer_32 /= 111 then
							l_tmp := 1
						else
							l_pos := -1 + 9 -- goto _L
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else: | _L:
						if ((option_inst.ve_flags).bit_and ({NATURAL_32} 8)).to_boolean then
							if l_wcol.to_integer_32 < 2147483647 then
								l_tmp := 1
							else
								l_tmp := 0
							end
						else
							l_tmp := 0
						end
				when 10 then -- if done | if done
						l_one_more := l_tmp
						l_line.ce_gets (memline_inst.ml_get_buf (globals_inst.curbuf, a_pos___3.item.lnum, 0))
						if not (l_wcol.to_integer_32 >= 2147483647) then
							l_pos := -1 + 17 -- skip if block
						end
				when 11 then -- if:
							l_idx := ((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_line))).to_integer_32 - 1) + l_one_more
							l_col := l_wcol
							if not (a_addspaces.to_boolean) then
								l_pos := -1 + 14 -- skip if block
							end
				when 12 then -- if:
							l_pos := -1 + 15 -- goto _L___0
				when 13 then -- if block done, skip else block:
							l_pos := -1 + 16
				when 14 then -- else:
							if not (a_finetune.to_boolean) then
								l_pos := -1 + 16 -- skip if block
							end
				when 15 then -- if: | _L___0:
							if not globals_inst.VIsual_active.to_boolean then
								globals_inst.curwin.item.w_curswant := (charset_inst.linetabsize (l_line)) + l_one_more
								if globals_inst.curwin.item.w_curswant > 0 then
									globals_inst.curwin.item.w_curswant := (globals_inst.curwin.item.w_curswant) - 1
								end
							end
				when 16 then -- if done | if done | if block done, skip else block:
							l_pos := -1 + 24
				when 17 then -- else:
							l_width := globals_inst.curwin.item.w_width - (move_inst.win_col_off (globals_inst.curwin))
							if a_finetune.to_boolean then
								if (globals_inst.curwin.item.w_onebuf_opt.wo_wrap).to_boolean then
									if globals_inst.curwin.item.w_width /= 0 then
										if l_wcol >= l_width then
											l_csize := charset_inst.linetabsize (l_line)
											if l_csize > 0 then
												l_csize := l_csize - 1
											end
											if l_wcol // l_width > l_csize // l_width then
												if ((globals_inst.State).bit_and (16)) = 0 then
													l_wcol := (l_csize // l_width + 1) * l_width - 1
												elseif l_wcol > l_csize + 1 then
													l_wcol := (l_csize // l_width + 1) * l_width - 1
												end
											end
										end
									end
								end
							end
							l_idx := -1
							l_ptr.ce_gets (l_line)
							from
							until
								js.loop_left
							loop
								js.reset
								if l_col <= l_wcol then
									if (l_ptr.item).to_integer_32 = 0 then
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped then
									l_csize := charset_inst.win_lbr_chartabsize (globals_inst.curwin, l_ptr, l_col, create {CE_POINTER [INTEGER_32]}.make_shared ($l_head___0))
									if globals_inst.has_mbyte.to_boolean then
										l_tmp___4 := (globals_inst.mb_ptr2len.integer_32_item ([l_ptr]))
									else
										l_tmp___4 := 1
									end
									l_ptr.ce_gets (l_ptr + l_tmp___4)
									l_col := l_col + l_csize
								end
							end
							js.reset
							l_idx := l_ptr.distance (l_line)
							if l_col > l_wcol then
								l_idx := l_idx - 1
								l_csize := l_csize - l_head___0
								l_col := l_col - l_csize
							elseif not (virtual_active).to_boolean then
								if l_one_more = 0 then
									l_idx := l_idx - 1
									l_csize := l_csize - l_head___0
									l_col := l_col - l_csize
								end
							end
							if not ((virtual_active).to_boolean) then
								l_pos := -1 + 24 -- skip if block
							end
				when 18 then -- if:
							if not (a_addspaces.to_boolean) then
								l_pos := -1 + 24 -- skip if block
							end
				when 19 then -- if:
							if l_col = l_wcol then
								l_pos := -1 + 22 -- skip if block
							end
				when 20 then -- if:
							if l_col /= l_wcol + 1 then
								l_pos := -1 + 23 -- goto _L___1
							else
								l_pos := -1 + 22 -- goto _L___2
							end
				when 21 then -- if block done, skip else block:
							l_pos := -1 + 24
				when 22 then -- else: | _L___2:
							if not (l_csize > 1) then
								l_pos := -1 + 24 -- skip if block
							end
				when 23 then -- if: | _L___1:
							if (l_line[l_idx]).to_integer_32 = 0 then
								l_correct := l_wcol - l_col
								l_newline.ce_gets ((alloc (((l_idx + l_correct) + 1).to_natural_32)))
								if (l_newline.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
									Result := 0
									js.return
								end
								if not js.return_called then
									l_t := 0
									from
									until
										not (l_t < l_idx)
									loop
										l_newline[l_t] := l_line[l_t]
										l_t := l_t + 1
									end
									l_t := 0
									from
									until
										not (l_t < l_correct)
									loop
										l_newline[(l_t + l_idx)] := ((' ').code).to_natural_8
										l_t := l_t + 1
									end
									l_newline[(l_idx + l_correct)] := (('%/0/').code).to_natural_8
									memline_inst.ml_replace (a_pos___3.item.lnum, l_newline, 0).do_nothing
									misc1_inst.changed_bytes (a_pos___3.item.lnum, l_idx)
									l_idx := l_idx + l_correct
									l_col := l_wcol
								end
							else
								l_linelen___0 := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_line))).to_integer_32
								l_correct___0 := ((l_wcol - l_col) - l_csize) + 1
								l_s := 0
								if -l_correct___0 > l_csize then
									Result := 0
									js.return
								end
								if not js.return_called then
									l_newline___0.ce_gets (alloc ((l_linelen___0 + l_csize).to_natural_32))
									if (l_newline___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
										Result := 0
										js.return
									end
								end
								if not js.return_called then
									l_t___0 := 0
									from
									until
										not (not js.loop_left and then (l_t___0 < l_linelen___0))
									loop
										if l_t___0 /= l_idx then
											l_tmp___8 := l_s
											l_s := l_s + 1
											l_newline___0[l_tmp___8] := l_line[l_t___0]
										else
											l_v := 0
											from
											until
												not (l_v < l_csize)
											loop
												l_tmp___9 := l_s
												l_s := l_s + 1
												l_newline___0[l_tmp___9] := ((' ').code).to_natural_8
												l_v := l_v + 1
											end
										end
										l_t___0 := l_t___0 + 1
									end
									l_newline___0[((l_linelen___0 + l_csize) - 1)] := (('%/0/').code).to_natural_8
									memline_inst.ml_replace (a_pos___3.item.lnum, l_newline___0, 0).do_nothing
									misc1_inst.changed_bytes (a_pos___3.item.lnum, l_idx)
									l_idx := l_idx + ((l_csize - 1) + l_correct___0)
									l_col := l_col + l_correct___0
								end
							end
				when 24 then -- if done | if done | if done | if done
							if not js.return_called then
								if l_idx < 0 then
									a_pos___3.item.col := 0
								else
									a_pos___3.item.col := l_idx
								end
								a_pos___3.item.coladd := 0
								if a_finetune.to_boolean then
									if l_wcol.to_integer_32 = 2147483647 then
										if not l_one_more.to_boolean then
											charset_inst.getvcol (globals_inst.curwin, a_pos___3, create {CE_POINTER [INTEGER_32]}.make_shared ($l_scol), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared ($l_ecol))
											a_pos___3.item.coladd := l_ecol - l_scol
										end
									else
										l_b := l_wcol - l_col
										if l_b > 0 then
											if l_b.to_integer_32 < 2147483647 - (2 * globals_inst.curwin.item.w_width).to_integer_32 then
												a_pos___3.item.coladd := l_b
											end
										end
										l_col := l_col + l_b
									end
								end
								if globals_inst.has_mbyte.to_boolean then
									mbyte_inst.mb_adjustpos (a_pos___3)
								end
								if l_col < l_wcol then
									Result := 0
									js.return
								end
							end
							if not js.return_called then
								Result := 1
							end
				when 25 then
							l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
				end

	inc_cursor: INTEGER_32
		do
			Result := (inc (create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curwin.c_pointer + {PD_WINDOW_S}.w_cursor_offset)))
		end

	inc (a_lp: CE_POINTER [PD_POS_T]): INTEGER_32
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_l: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			js: JUMP_STATE
		do
			create l_p___0.make

			l_p___0.ce_gets ((memline_inst.ml_get_pos (a_lp)))
			if (l_p___0.item).to_integer_32 /= 0 then
				if globals_inst.has_mbyte.to_boolean then
					l_l := (globals_inst.mb_ptr2len.integer_32_item ([l_p___0]))
					a_lp.item.col := a_lp.item.col + l_l
					if (l_p___0[l_l]).to_integer_32 /= 0 then
						l_tmp___1 := 0
					else
						l_tmp___1 := 2
					end
					Result := l_tmp___1
					js.return
				end
				if not js.return_called then
					a_lp.item.col := (a_lp.item.col) + 1
					a_lp.item.coladd := 0
					if (l_p___0[1]).to_integer_32 /= 0 then
						l_tmp___2 := 0
					else
						l_tmp___2 := 2
					end
					Result := l_tmp___2
					js.return
				end
			end
			if not js.return_called and then (a_lp.item.lnum /= globals_inst.curbuf.item.b_ml.ml_line_count) then
				a_lp.item.col := 0
				a_lp.item.lnum := (a_lp.item.lnum) + 1
				a_lp.item.coladd := 0
				Result := 1
				js.return
			end
			if not js.return_called then
				Result := (-1)
			end
		end

	incl (a_lp: CE_POINTER [PD_POS_T]): INTEGER_32
		local
			l_r: INTEGER_32
		do
			l_r := inc (a_lp)
			if l_r >= 1 then
				if (a_lp.item.col).to_boolean then
					l_r := inc (a_lp)
				end
			end
			Result := l_r
		end

	incl_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent incl)
		end

	dec_cursor: INTEGER_32
		do
			Result := (dec (create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curwin.c_pointer + {PD_WINDOW_S}.w_cursor_offset)))
		end

	dec (a_lp: CE_POINTER [PD_POS_T]): INTEGER_32
		local
			l_p___0: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_p___0.make

			a_lp.item.coladd := 0
			if a_lp.item.col > 0 then
				a_lp.item.col := (a_lp.item.col) - 1
				if globals_inst.has_mbyte.to_boolean then
					l_p___0.ce_gets (memline_inst.ml_get (a_lp.item.lnum))
					a_lp.item.col := a_lp.item.col - (globals_inst.mb_head_off.integer_32_item ([l_p___0, l_p___0 + a_lp.item.col]))
				end
				Result := 0
				js.return
			end
			if not js.return_called and then (a_lp.item.lnum > 1) then
				a_lp.item.lnum := (a_lp.item.lnum) - 1
				l_p___0.ce_gets (memline_inst.ml_get (a_lp.item.lnum))
				a_lp.item.col := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0))).to_integer_32
				if globals_inst.has_mbyte.to_boolean then
					a_lp.item.col := a_lp.item.col - (globals_inst.mb_head_off.integer_32_item ([l_p___0, l_p___0 + a_lp.item.col]))
				end
				Result := 1
				js.return
			end
			if not js.return_called then
				Result := (-1)
			end
		end

	decl (a_lp: CE_POINTER [PD_POS_T]): INTEGER_32
		local
			l_r: INTEGER_32
		do
			l_r := dec (a_lp)
			if l_r = 1 then
				if (a_lp.item.col).to_boolean then
					l_r := dec (a_lp)
				end
			end
			Result := l_r
		end

	decl_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent decl)
		end

	get_cursor_rel_lnum (a_wp___0: CE_POINTER [PD_WINDOW_S]; a_lnum: INTEGER_32): INTEGER_32
		local
			l_lnum: INTEGER_32
			l_cursor: INTEGER_32
			l_retval: INTEGER_32
		do
			l_lnum := a_lnum
			l_cursor := a_wp___0.item.w_cursor.lnum
			l_retval := (0).to_integer_32
			if (fold_inst.hasAnyFolding (a_wp___0)).to_boolean then
				if l_lnum > l_cursor then
					from
					until
						not (l_lnum > l_cursor)
					loop
						fold_inst.hasFolding (l_lnum, create {CE_POINTER [INTEGER_32]}.make_shared ($l_lnum), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)).do_nothing
						if l_lnum > l_cursor then
							l_retval := l_retval + 1
						end
						l_lnum := l_lnum - 1
					end
				elseif l_lnum < l_cursor then
					from
					until
						not (l_lnum < l_cursor)
					loop
						fold_inst.hasFolding (l_lnum, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared ($l_lnum)).do_nothing
						if l_lnum < l_cursor then
							l_retval := l_retval - 1
						end
						l_lnum := l_lnum + 1
					end
				end
			else
				l_retval := l_lnum - l_cursor
			end
			Result := l_retval
		end

	check_cursor_lnum
		do
			if globals_inst.curwin.item.w_cursor.lnum > globals_inst.curbuf.item.b_ml.ml_line_count then
				if not (fold_inst.hasFolding (globals_inst.curbuf.item.b_ml.ml_line_count, create {CE_POINTER [INTEGER_32]}.make_shared (globals_inst.curwin.c_pointer + {PD_WINDOW_S}.w_cursor_offset + {PD_POS_T}.lnum_offset), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))).to_boolean then
					globals_inst.curwin.item.w_cursor.lnum := globals_inst.curbuf.item.b_ml.ml_line_count
				end
			end
			if globals_inst.curwin.item.w_cursor.lnum <= 0 then
				globals_inst.curwin.item.w_cursor.lnum := (1).to_integer_32
			end
		end

	check_cursor_col
		local
			l_len: INTEGER_32
			l_oldcol: INTEGER_32
			l_oldcoladd: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_oldcol := globals_inst.curwin.item.w_cursor.col
					l_oldcoladd := globals_inst.curwin.item.w_cursor.col + globals_inst.curwin.item.w_cursor.coladd
					l_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((memline_inst.ml_get_curline)))).to_integer_32
					if l_len /= 0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						globals_inst.curwin.item.w_cursor.col := 0
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 3 then -- else:
						if not (globals_inst.curwin.item.w_cursor.col >= l_len) then
							l_pos := -1 + 15 -- skip if block
						end
				when 4 then -- if:
						if not (((globals_inst.State).bit_and (16)).to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						globals_inst.curwin.item.w_cursor.col := l_len
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 7 then -- else:
						if not (globals_inst.restart_edit.to_boolean) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						globals_inst.curwin.item.w_cursor.col := l_len
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 10 then -- else:
						if not (globals_inst.VIsual_active.to_boolean) then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						if (option_inst.p_sel.item).to_integer_32 /= 111 then
							globals_inst.curwin.item.w_cursor.col := l_len
						else
							l_pos := -1 + 13 -- goto _L
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 13 then -- else: | _L:
						if ((option_inst.ve_flags).bit_and ({NATURAL_32} 8)).to_boolean then
							globals_inst.curwin.item.w_cursor.col := l_len
						elseif (virtual_active).to_boolean then
							globals_inst.curwin.item.w_cursor.col := l_len
						else
							globals_inst.curwin.item.w_cursor.col := l_len - 1
							if globals_inst.has_mbyte.to_boolean then
								mbyte_inst.mb_adjust_cursor
							end
						end
				when 14 then -- if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 16
				when 15 then -- else:
						if globals_inst.curwin.item.w_cursor.col < 0 then
							globals_inst.curwin.item.w_cursor.col := 0
						end
				when 16 then -- if done
						if l_oldcol.to_integer_32 = 2147483647 then
							globals_inst.curwin.item.w_cursor.coladd := 0
						elseif option_inst.ve_flags = {NATURAL_32} 4 then
							if l_oldcoladd > globals_inst.curwin.item.w_cursor.col then
								globals_inst.curwin.item.w_cursor.coladd := l_oldcoladd - globals_inst.curwin.item.w_cursor.col
							else
								globals_inst.curwin.item.w_cursor.coladd := 0
							end
						end
				when 17 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	check_cursor
		do
			check_cursor_lnum
			check_cursor_col
		end

	adjust_cursor_col
		local
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (globals_inst.curwin.item.w_cursor.col > 0) then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if globals_inst.VIsual_active.to_boolean then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if (option_inst.p_sel.item).to_integer_32 /= 111 then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						if (misc1_inst.gchar_cursor) = 0 then
							globals_inst.curwin.item.w_cursor.col := (globals_inst.curwin.item.w_cursor.col) - 1
						end
				when 6 then -- if done | if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	leftcol_changed: INTEGER_32
		local
			l_lastcol: INTEGER_32
			l_s: INTEGER_32
			l_e: INTEGER_32
			l_retval: INTEGER_32
		do
			l_retval := 0
			move_inst.changed_cline_bef_curs
			l_lastcol := (((globals_inst.curwin.item.w_leftcol + globals_inst.curwin.item.w_width) - (move_inst.curwin_col_off)) - 1).to_integer_32
			move_inst.validate_virtcol
			if globals_inst.curwin.item.w_virtcol > (l_lastcol - option_inst.p_siso).to_integer_32 then
				l_retval := 1
				coladvance ((l_lastcol - option_inst.p_siso).to_integer_32).do_nothing
			elseif (globals_inst.curwin.item.w_virtcol).to_integer_32 < (globals_inst.curwin.item.w_leftcol).to_integer_32 + option_inst.p_siso then
				l_retval := 1
				coladvance (((globals_inst.curwin.item.w_leftcol).to_integer_32 + option_inst.p_siso).to_integer_32).do_nothing
			end
			charset_inst.getvvcol (globals_inst.curwin, create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curwin.c_pointer + {PD_WINDOW_S}.w_cursor_offset), create {CE_POINTER [INTEGER_32]}.make_shared ($l_s), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared ($l_e))
			if l_e > l_lastcol.to_integer_32 then
				l_retval := 1
				coladvance (l_s - 1).do_nothing
			elseif l_s < globals_inst.curwin.item.w_leftcol then
				l_retval := 1
				if (coladvance (l_e + 1)) = 0 then
					globals_inst.curwin.item.w_leftcol := l_s
					move_inst.changed_cline_bef_curs
				end
			end
			if l_retval.to_boolean then
				globals_inst.curwin.item.w_set_curswant := 1
			end
			screen_inst.redraw_later (40)
			Result := l_retval
		end

	alloc (a_size: NATURAL_32): CE_POINTER [NATURAL_8]
		do
			Result := (lalloc (a_size.to_natural_32, 1))
		end

	alloc_clear (a_size: NATURAL_32): CE_POINTER [NATURAL_8]
		local
			l_p___0: CE_POINTER [NATURAL_8]
		do
			create l_p___0.make

			l_p___0.ce_gets (lalloc (a_size.to_natural_32, 1))
			if (l_p___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				memset (create {CE_POINTER [ANY]}.make_cast (l_p___0), 0, a_size).do_nothing
			end
			Result := l_p___0
		end

	alloc_check (a_size: NATURAL_32): CE_POINTER [NATURAL_8]
		do
			Result := (lalloc (a_size.to_natural_32, 1))
		end

	lalloc_clear (a_size: NATURAL_32; a_message: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_p___0: CE_POINTER [NATURAL_8]
		do
			create l_p___0.make

			l_p___0.ce_gets (lalloc (a_size, a_message))
			if (l_p___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				memset (create {CE_POINTER [ANY]}.make_cast (l_p___0), 0, a_size.to_natural_32).do_nothing
			end
			Result := l_p___0
		end

	lalloc (a_size: NATURAL_32; a_message: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_try_again: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_size = {NATURAL_32} 0 then
						globals_inst.emsg_silent := 0
						emsgn (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E341: Internal error: lalloc(%%ld, )")))), a_size.to_integer_32).do_nothing
						Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						js.return
					end
					if js.return_called then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if: | loop condition:
						if js.loop_left then
							l_pos := -1 + 4 -- skip loop
						end
				when 2 then -- loop body:
						js.reset
						l_p___0.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((malloc (a_size.to_natural_32))))
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_pos := -1 + 5 -- goto theend
						end
				when 3 then
						if releasing.to_boolean then
							js.break
						end
						if not js.loop_jumped then
							releasing := 1
							message_inst.clear_sb_text
							l_try_again := memfile_inst.mf_release_all
							l_try_again := (l_try_again).bit_or ((eval_inst.garbage_collect))
							releasing := 0
							if not l_try_again.to_boolean then
								js.break
							end
						end
						l_pos := -1 + 1 -- back to loop condition
				when 4 then -- loop done
						js.reset
						if a_message.to_boolean then
							if (l_p___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								do_outofmem_msg (a_size)
							end
						end
				when 5 then -- theend:
						Result := l_p___0
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	do_outofmem_msg (a_size: NATURAL_32)
		do
			if not globals_inst.did_outofmem_msg.to_boolean then
				globals_inst.emsg_silent := 0
				emsgn (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E342: Out of memory!  (allocating %%lu bytes)")))), a_size.to_integer_32).do_nothing
				globals_inst.did_outofmem_msg := 1
			end
		end

	vim_strsave (a_string___0: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_len: NATURAL_32
		do
			create l_p___0.make

			l_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_string___0))) + {NATURAL_32} 1
			l_p___0.ce_gets (alloc (l_len))
			if (l_p___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				memmove (create {CE_POINTER [ANY]}.make_cast (l_p___0), create {CE_POINTER [ANY]}.make_cast (a_string___0), l_len).do_nothing
			end
			Result := l_p___0
		end

	vim_strnsave (a_string___0: CE_POINTER [NATURAL_8]; a_len: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_p___0: CE_POINTER [NATURAL_8]
		do
			create l_p___0.make

			l_p___0.ce_gets (alloc ((a_len + 1).to_natural_32))
			if (l_p___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				strncpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), create {CE_POINTER [INTEGER_8]}.make_cast (a_string___0), a_len.to_natural_32).do_nothing
				l_p___0[a_len] := (('%/0/').code).to_natural_8
			end
			Result := l_p___0
		end

	vim_strsave_escaped (a_string___0: CE_POINTER [NATURAL_8]; a_esc_chars: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		do
			Result := (vim_strsave_escaped_ext (a_string___0, a_esc_chars, ('\').code, 0))
		end

	vim_strsave_escaped_ext (a_string___0: CE_POINTER [NATURAL_8]; a_esc_chars: CE_POINTER [NATURAL_8]; a_cc___0: INTEGER_32; a_bsl: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_p2: CE_POINTER [NATURAL_8]
			l_escaped_string: CE_POINTER [NATURAL_8]
			l_length: NATURAL_32
			l_l: INTEGER_32
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___4: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_p___0.make
			create l_p2.make
			create l_escaped_string.make
			create l_tmp___1.make
			create l_tmp___4.make

			l_length := {NATURAL_32} 1
			l_p___0.ce_gets (a_string___0)
			from
			until
				not ((l_p___0.item).to_boolean)
			loop
				js.reset
				if globals_inst.has_mbyte.to_boolean then
					l_l := globals_inst.mb_ptr2len.integer_32_item ([l_p___0])
					if l_l > 1 then
						l_length := l_length + l_l.to_natural_32
						l_p___0.ce_gets (l_p___0 + (l_l - 1))
						js.continue
					end
				end
				if not js.loop_jumped then
					if ((vim_strchr (a_esc_chars, (l_p___0.item).to_integer_32)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						l_length := l_length + 1
					elseif a_bsl.to_boolean then
						if (charset_inst.rem_backslash (l_p___0)).to_boolean then
							l_length := l_length + 1
						end
					end
					l_length := l_length + 1
				end
				l_p___0.ce_gets (l_p___0 + 1)
			end
			l_escaped_string.ce_gets (alloc (l_length))
			if (l_escaped_string.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				l_p2.ce_gets (l_escaped_string)
				l_p___0.ce_gets (a_string___0)
				from
				until
					not ((l_p___0.item).to_boolean)
				loop
					js.reset
					if globals_inst.has_mbyte.to_boolean then
						l_l := globals_inst.mb_ptr2len.integer_32_item ([l_p___0])
						if l_l > 1 then
							memmove (create {CE_POINTER [ANY]}.make_cast (l_p2), create {CE_POINTER [ANY]}.make_cast (l_p___0), l_l.to_natural_32).do_nothing
							l_p2.ce_gets (l_p2 + l_l)
							l_p___0.ce_gets (l_p___0 + (l_l - 1))
							js.continue
						end
					end
					if not js.loop_jumped then
						if ((vim_strchr (a_esc_chars, (l_p___0.item).to_integer_32)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_tmp___1.ce_gets (l_p2)
							l_p2.ce_gets (l_p2 + 1)
							l_tmp___1.item := a_cc___0.to_natural_8
						elseif a_bsl.to_boolean then
							if (charset_inst.rem_backslash (l_p___0)).to_boolean then
								l_tmp___1.ce_gets (l_p2)
								l_p2.ce_gets (l_p2 + 1)
								l_tmp___1.item := a_cc___0.to_natural_8
							end
						end
						l_tmp___4.ce_gets (l_p2)
						l_p2.ce_gets (l_p2 + 1)
						l_tmp___4.item := l_p___0.item
					end
					l_p___0.ce_gets (l_p___0 + 1)
				end
				l_p2.item := (('%/0/').code).to_natural_8
			end
			Result := l_escaped_string
		end

	csh_like_shell: INTEGER_32
		do
			Result := (((strstr (create {CE_POINTER [INTEGER_8]}.make_cast ((misc1_inst.gettail (option_inst.p_sh))), ce_string ("csh"))).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer
		end

	vim_strsave_shellescape (a_string___0: CE_POINTER [NATURAL_8]; a_do_special: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_length: NATURAL_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_d: CE_POINTER [NATURAL_8]
			l_escaped_string: CE_POINTER [NATURAL_8]
			l_l: INTEGER_32
			l_csh_like: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_tmp___4: CE_POINTER [NATURAL_8]
			l_tmp___5: CE_POINTER [NATURAL_8]
			l_tmp___6: CE_POINTER [NATURAL_8]
			l_tmp___7: CE_POINTER [NATURAL_8]
			l_tmp___8: CE_POINTER [NATURAL_8]
			l_tmp___9: CE_POINTER [NATURAL_8]
			l_tmp___10: CE_POINTER [NATURAL_8]
			l_tmp___11: CE_POINTER [NATURAL_8]
			l_tmp___12: CE_POINTER [NATURAL_8]
			l_tmp___13: CE_POINTER [NATURAL_8]
			l_tmp___14: CE_POINTER [NATURAL_8]
			l_tmp___16: CE_POINTER [NATURAL_8]
			l_tmp___17: CE_POINTER [NATURAL_8]
			l_tmp___18: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p___0.make
			create l_d.make
			create l_escaped_string.make
			create l_tmp___3.make
			create l_tmp___4.make
			create l_tmp___5.make
			create l_tmp___6.make
			create l_tmp___7.make
			create l_tmp___8.make
			create l_tmp___9.make
			create l_tmp___10.make
			create l_tmp___11.make
			create l_tmp___12.make
			create l_tmp___13.make
			create l_tmp___14.make
			create l_tmp___16.make
			create l_tmp___17.make
			create l_tmp___18.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_csh_like := csh_like_shell
					l_length := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_string___0))) + {NATURAL_32} 3
					l_p___0.ce_gets (a_string___0)
				when 1 then -- loop condition:
					if (l_p___0.item).to_integer_32 = 0 then
						l_pos := -1 + 12 -- skip loop
					end
				when 2 then -- loop body:
						if (l_p___0.item).to_integer_32 = 39 then
							l_length := l_length + ({NATURAL_32} 3)
						end
						if (l_p___0.item).to_integer_32 /= 10 then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_pos := -1 + 10 -- goto _L___0
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 5 then -- else:
						if (l_p___0.item).to_integer_32 /= 33 then
							l_pos := -1 + 11 -- skip if block
						end
				when 6 then -- if:
						if not (l_csh_like.to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L___0
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 9 then -- else:
						if not (a_do_special.to_boolean) then
							l_pos := -1 + 11 -- skip if block
						end
				when 10 then -- if: | _L___0:
						l_length := l_length + 1
						if l_csh_like.to_boolean then
							if a_do_special.to_boolean then
								l_length := l_length + 1
							end
						end
				when 11 then -- if done | if done | if done
						if a_do_special.to_boolean then
							if (ex_docmd_inst.find_cmdline_var (l_p___0, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l))) >= 0 then
								l_length := l_length + 1
								l_p___0.ce_gets (l_p___0 + (l_l - 1))
							end
						end
						if globals_inst.has_mbyte.to_boolean then
							l_tmp___1 := (globals_inst.mb_ptr2len.integer_32_item ([l_p___0]))
						else
							l_tmp___1 := 1
						end
						l_p___0.ce_gets (l_p___0 + l_tmp___1)
						l_pos := -1 + 1 -- back to loop condition
				when 12 then -- loop done
					l_escaped_string.ce_gets (alloc (l_length))
					if (l_escaped_string.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						l_pos := -1 + 27 -- skip if block
					end
				when 13 then -- if:
						l_d.ce_gets (l_escaped_string)
						l_tmp___3.ce_gets (l_d)
						l_d.ce_gets (l_d + 1)
						l_tmp___3.item := (('%'').code).to_natural_8
						l_p___0.ce_gets (a_string___0)
				when 14 then -- loop condition:
						if not (not js.loop_left and then ((l_p___0.item).to_integer_32 /= 0)) then
							l_pos := -1 + 26 -- skip loop
						end
				when 15 then -- loop body:
						js.reset
						if (l_p___0.item).to_integer_32 = 39 then
							l_tmp___4.ce_gets (l_d)
							l_d.ce_gets (l_d + 1)
							l_tmp___4.item := (('%'').code).to_natural_8
							l_tmp___5.ce_gets (l_d)
							l_d.ce_gets (l_d + 1)
							l_tmp___5.item := (('\').code).to_natural_8
							l_tmp___6.ce_gets (l_d)
							l_d.ce_gets (l_d + 1)
							l_tmp___6.item := (('%'').code).to_natural_8
							l_tmp___7.ce_gets (l_d)
							l_d.ce_gets (l_d + 1)
							l_tmp___7.item := (('%'').code).to_natural_8
							l_p___0.ce_gets (l_p___0 + 1)
							js.continue
						end
						if js.loop_jumped then
							l_pos := -1 + 25 -- skip if block
						end
				when 16 then -- if:
						if (l_p___0.item).to_integer_32 /= 10 then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						l_pos := -1 + 24 -- goto _L___2
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 19 then -- else:
						if (l_p___0.item).to_integer_32 /= 33 then
							l_pos := -1 + 25 -- skip if block
						end
				when 20 then -- if:
						if not (l_csh_like.to_boolean) then
							l_pos := -1 + 23 -- skip if block
						end
				when 21 then -- if:
						l_pos := -1 + 24 -- goto _L___2
				when 22 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 23 then -- else:
						if not (a_do_special.to_boolean) then
							l_pos := -1 + 25 -- skip if block
						end
				when 24 then -- if: | _L___2:
						l_tmp___8.ce_gets (l_d)
						l_d.ce_gets (l_d + 1)
						l_tmp___8.item := (('\').code).to_natural_8
						if l_csh_like.to_boolean then
							if a_do_special.to_boolean then
								l_tmp___9.ce_gets (l_d)
								l_d.ce_gets (l_d + 1)
								l_tmp___9.item := (('\').code).to_natural_8
							end
						end
						l_tmp___10.ce_gets (l_d)
						l_d.ce_gets (l_d + 1)
						l_tmp___11.ce_gets (l_p___0)
						l_p___0.ce_gets (l_p___0 + 1)
						l_tmp___10.item := l_tmp___11.item
						js.continue
				when 25 then -- if done | if done | if done | if done
						if not js.loop_jumped and then (a_do_special.to_boolean) then
							if (ex_docmd_inst.find_cmdline_var (l_p___0, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l))) >= 0 then
								l_tmp___12.ce_gets (l_d)
								l_d.ce_gets (l_d + 1)
								l_tmp___12.item := (('\').code).to_natural_8
								from
								until
									js.loop_left
								loop
									js.reset
									l_l := l_l - 1
									if not (l_l >= 0) then
										js.break
									end
									if not js.loop_jumped then
										l_tmp___13.ce_gets (l_d)
										l_d.ce_gets (l_d + 1)
										l_tmp___14.ce_gets (l_p___0)
										l_p___0.ce_gets (l_p___0 + 1)
										l_tmp___13.item := l_tmp___14.item
									end
								end
								js.reset
								js.continue
							end
						end
						if not js.loop_jumped then
							if globals_inst.has_mbyte.to_boolean then
								mbyte_inst.mb_copy_char (l_p___0.address, l_d.address)
							else
								l_tmp___16.ce_gets (l_d)
								l_d.ce_gets (l_d + 1)
								l_tmp___17.ce_gets (l_p___0)
								l_p___0.ce_gets (l_p___0 + 1)
								l_tmp___16.item := l_tmp___17.item
							end
						end
						if not js.loop_left then
							
						end
						l_pos := -1 + 14 -- back to loop condition
				when 26 then -- loop done
						l_tmp___18.ce_gets (l_d)
						l_d.ce_gets (l_d + 1)
						l_tmp___18.item := (('%'').code).to_natural_8
						l_d.item := (('%/0/').code).to_natural_8
				when 27 then -- if done
					Result := l_escaped_string
				when 28 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	vim_strsave_up (a_string___0: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_p1: CE_POINTER [NATURAL_8]
		do
			create l_p1.make

			l_p1.ce_gets (vim_strsave (a_string___0))
			vim_strup (l_p1)
			Result := l_p1
		end

	vim_strnsave_up (a_string___0: CE_POINTER [NATURAL_8]; a_len: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_p1: CE_POINTER [NATURAL_8]
		do
			create l_p1.make

			l_p1.ce_gets (vim_strnsave (a_string___0, a_len))
			vim_strup (l_p1)
			Result := l_p1
		end

	vim_strup (a_p___0: CE_POINTER [NATURAL_8])
		local
			l_p2: CE_POINTER [NATURAL_8]
			l_c: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_p2.make
			create l_tmp.make

			if (a_p___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				l_p2.ce_gets (a_p___0)
				from
				until
					js.loop_left
				loop
					js.reset
					l_c := (l_p2.item).to_integer_32
					if l_c = 0 then
						js.break
					end
					if not js.loop_jumped then
						l_tmp.ce_gets (l_p2)
						l_p2.ce_gets (l_p2 + 1)
						if l_c < 97 then
							l_tmp.item := l_c.to_natural_8
						elseif l_c > 122 then
							l_tmp.item := l_c.to_natural_8
						else
							l_tmp.item := (l_c - 32).to_natural_8
						end
					end
				end
				js.reset
			end
		end

	strup_save (a_orig: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_res: CE_POINTER [NATURAL_8]
			l_l: INTEGER_32
			l_c: INTEGER_32
			l_uc: INTEGER_32
			l_nl: INTEGER_32
			l_s: CE_POINTER [NATURAL_8]
			l_tmp___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_p___0.make
			create l_res.make
			create l_s.make

			l_p___0.ce_gets (vim_strsave (a_orig))
			l_res.ce_gets (l_p___0)
			if (l_res.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				from
				until
					not (not js.loop_left and then ((l_p___0.item).to_integer_32 /= 0))
				loop
					js.reset
					if globals_inst.enc_utf8.to_boolean then
						l_c := mbyte_inst.utf_ptr2char (l_p___0)
						l_uc := mbyte_inst.utf_toupper (l_c)
						l_l := mbyte_inst.utf_ptr2len (l_p___0)
						l_nl := mbyte_inst.utf_char2len (l_uc)
						if l_nl /= l_l then
							l_s.ce_gets (alloc ((((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_res))) + {NATURAL_32} 1) + l_nl.to_natural_32) - l_l.to_natural_32))
							if (l_s.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								js.break
							end
							if not js.loop_jumped then
								memmove (create {CE_POINTER [ANY]}.make_cast (l_s), create {CE_POINTER [ANY]}.make_cast (l_res), (l_p___0.distance (l_res)).to_natural_32).do_nothing
								strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (((l_s + (l_p___0.distance (l_res))) + l_nl)), create {CE_POINTER [INTEGER_8]}.make_cast ((l_p___0 + l_l))).do_nothing
								l_p___0.ce_gets (l_s + (l_p___0.distance (l_res)))
								vim_free (create {CE_POINTER [ANY]}.make_cast (l_res))
								l_res.ce_gets (l_s)
							end
						end
						if not js.loop_jumped then
							mbyte_inst.utf_char2bytes (l_uc, l_p___0).do_nothing
							l_p___0.ce_gets (l_p___0 + l_nl)
						end
					elseif globals_inst.has_mbyte.to_boolean then
						l_l := globals_inst.mb_ptr2len.integer_32_item ([l_p___0])
						if l_l > 1 then
							l_p___0.ce_gets (l_p___0 + l_l)
						else
							l_tmp___0 := toupper ((l_p___0.item).to_integer_32)
							l_p___0.item := l_tmp___0.to_natural_8
							l_p___0.ce_gets (l_p___0 + 1)
						end
					else
						l_tmp___0 := toupper ((l_p___0.item).to_integer_32)
						l_p___0.item := l_tmp___0.to_natural_8
						l_p___0.ce_gets (l_p___0 + 1)
					end
				end
				js.reset
			end
			Result := l_res
		end

	copy_spaces (a_ptr: CE_POINTER [NATURAL_8]; a_count___2: NATURAL_32)
		local
			l_i___0: NATURAL_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: NATURAL_32
			js: JUMP_STATE
		do
			create l_p___0.make
			create l_tmp.make

			l_i___0 := a_count___2
			l_p___0.ce_gets (a_ptr)
			from
			until
				js.loop_left
			loop
				js.reset
				l_tmp___0 := l_i___0
				l_i___0 := l_i___0 - 1
				if not l_tmp___0.to_boolean then
					js.break
				end
				if not js.loop_jumped then
					l_tmp.ce_gets (l_p___0)
					l_p___0.ce_gets (l_p___0 + 1)
					l_tmp.item := ((' ').code).to_natural_8
				end
			end
			js.reset
		end

	copy_chars (a_ptr: CE_POINTER [NATURAL_8]; a_count___2: NATURAL_32; a_c: INTEGER_32)
		local
			l_i___0: NATURAL_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: NATURAL_32
			js: JUMP_STATE
		do
			create l_p___0.make
			create l_tmp.make

			l_i___0 := a_count___2
			l_p___0.ce_gets (a_ptr)
			from
			until
				js.loop_left
			loop
				js.reset
				l_tmp___0 := l_i___0
				l_i___0 := l_i___0 - 1
				if not l_tmp___0.to_boolean then
					js.break
				end
				if not js.loop_jumped then
					l_tmp.ce_gets (l_p___0)
					l_p___0.ce_gets (l_p___0 + 1)
					l_tmp.item := a_c.to_natural_8
				end
			end
			js.reset
		end

	del_trailing_spaces (a_ptr: CE_POINTER [NATURAL_8])
		local
			l_q: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_q.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_q.ce_gets (a_ptr + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_ptr))).to_integer_32)
				when 1 then -- loop condition:
					if js.loop_left then
						l_pos := -1 + 13 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						l_q.ce_gets (l_q - 1)
						if not ((l_q.c_pointer.to_integer_32).to_natural_32 > (a_ptr.c_pointer.to_integer_32).to_natural_32) then
							l_pos := -1 + 11 -- skip if block
						end
				when 3 then -- if:
						if (l_q[0]).to_integer_32 /= 32 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 6 then -- else:
						if (l_q[0]).to_integer_32 /= 9 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if: | _L:
						if (l_q[-1]).to_integer_32 /= 92 then
							if (l_q[-1]).to_integer_32 = 22 then
								js.break
							end
						else
							js.break
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else:
						js.break
				when 10 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 12
				when 11 then -- else:
						js.break
				when 12 then
						if not js.loop_jumped then
							l_q.item := (('%/0/').code).to_natural_8
						end
						l_pos := -1 + 1 -- back to loop condition
				when 13 then -- loop done
					js.reset
				when 14 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	vim_strncpy (a_to: CE_POINTER [NATURAL_8]; a_from: CE_POINTER [NATURAL_8]; a_len: NATURAL_32)
		do
			strncpy (create {CE_POINTER [INTEGER_8]}.make_cast (a_to), create {CE_POINTER [INTEGER_8]}.make_cast (a_from), a_len).do_nothing
			a_to[a_len.to_integer_32] := (('%/0/').code).to_natural_8
		end

	copy_option_part (a_option: CE_POINTER [CE_POINTER [NATURAL_8]]; a_buf___6: CE_POINTER [NATURAL_8]; a_maxlen: INTEGER_32; a_sep_chars: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_len: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp: INTEGER_32
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___2: INTEGER_32
			js: JUMP_STATE
		do
			create l_p___0.make
			create l_tmp___0.make

			l_len := 0
			l_p___0.ce_gets (a_option.item)
			if (l_p___0.item).to_integer_32 = 46 then
				l_tmp := l_len
				l_len := l_len + 1
				l_tmp___0.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				a_buf___6[l_tmp] := l_tmp___0.item
			end
			from
			until
				js.loop_left
			loop
				js.reset
				if (l_p___0.item).to_integer_32 /= 0 then
					if ((vim_strchr (create {CE_POINTER [NATURAL_8]}.make_cast (a_sep_chars), (l_p___0.item).to_integer_32)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					if (l_p___0[0]).to_integer_32 = 92 then
						if ((vim_strchr (create {CE_POINTER [NATURAL_8]}.make_cast (a_sep_chars), (l_p___0[1]).to_integer_32)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_p___0.ce_gets (l_p___0 + 1)
						end
					end
					if l_len < a_maxlen - 1 then
						l_tmp___2 := l_len
						l_len := l_len + 1
						a_buf___6[l_tmp___2] := l_p___0.item
					end
					l_p___0.ce_gets (l_p___0 + 1)
				end
			end
			js.reset
			a_buf___6[l_len] := (('%/0/').code).to_natural_8
			if (l_p___0.item).to_integer_32 /= 0 then
				if (l_p___0.item).to_integer_32 /= 44 then
					l_p___0.ce_gets (l_p___0 + 1)
				end
			end
			l_p___0.ce_gets (misc1_inst.skip_to_option_part (l_p___0))
			a_option.item := l_p___0
			Result := l_len
		end

	vim_free (a_x___0: CE_POINTER [ANY])
		do
			if (a_x___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				if not globals_inst.really_exiting.to_boolean then
					free (a_x___0)
				end
			end
		end

	vim_strchr (a_string___0: CE_POINTER [NATURAL_8]; a_c: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_c: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_b: INTEGER_32
			l_n2: INTEGER_32
			js: JUMP_STATE
		do
			create l_p___0.make

			l_c := a_c
			l_p___0.ce_gets (a_string___0)
			if globals_inst.enc_utf8.to_boolean then
				if l_c >= 128 then
					from
					until
						not (not js.loop_left and then ((l_p___0.item).to_integer_32 /= 0))
					loop
						if (mbyte_inst.utf_ptr2char (l_p___0)) = l_c then
							Result := l_p___0
							js.return
						end
						if not js.return_called then
							l_p___0.ce_gets (l_p___0 + (globals_inst.mb_ptr2len.integer_32_item ([l_p___0])))
						end
					end
					if not js.return_called then
						Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						js.return
					end
				end
			end
			if not js.return_called and then (globals_inst.enc_dbcs /= 0) then
				if l_c > 255 then
					l_n2 := (l_c).bit_and (255)
					l_c := ((((l_c.to_natural_32).bit_shift_right (8))).bit_and ({NATURAL_32} 255)).to_integer_32
					from
					until
						js.loop_left
					loop
						js.reset
						l_b := (l_p___0.item).to_integer_32
						if l_b = 0 then
							js.break
						end
						if not js.loop_jumped then
							if l_b = l_c then
								if (l_p___0[1]).to_integer_32 = l_n2 then
									Result := l_p___0
									js.return
								end
							end
							if not js.return_called then
								l_p___0.ce_gets (l_p___0 + (globals_inst.mb_ptr2len.integer_32_item ([l_p___0])))
							end
						end
					end
					js.reset
					if not js.return_called then
						Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						js.return
					end
				end
			end
			if not js.return_called and then (globals_inst.has_mbyte.to_boolean) then
				from
				until
					js.loop_left
				loop
					js.reset
					l_b := (l_p___0.item).to_integer_32
					if l_b = 0 then
						js.break
					end
					if not js.loop_jumped then
						if l_b = l_c then
							Result := l_p___0
							js.return
						end
						if not js.return_called then
							l_p___0.ce_gets (l_p___0 + (globals_inst.mb_ptr2len.integer_32_item ([l_p___0])))
						end
					end
				end
				js.reset
				if not js.return_called then
					Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					js.return
				end
			end
			if not js.return_called then
				from
				until
					js.loop_left
				loop
					js.reset
					l_b := (l_p___0.item).to_integer_32
					if l_b = 0 then
						js.break
					end
					if not js.loop_jumped then
						if l_b = l_c then
							Result := l_p___0
							js.return
						end
						if not js.return_called then
							l_p___0.ce_gets (l_p___0 + 1)
						end
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
			end
		end

	vim_strbyte (a_string___0: CE_POINTER [NATURAL_8]; a_c: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_p___0: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_p___0.make

			l_p___0.ce_gets (a_string___0)
			from
			until
				not (not js.loop_left and then ((l_p___0.item).to_integer_32 /= 0))
			loop
				if (l_p___0.item).to_integer_32 = a_c then
					Result := l_p___0
					js.return
				end
				if not js.return_called then
					l_p___0.ce_gets (l_p___0 + 1)
				end
			end
			if not js.return_called then
				Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
			end
		end

	vim_strrchr (a_string___0: CE_POINTER [NATURAL_8]; a_c: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_retval: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp___0: INTEGER_32
		do
			create l_retval.make
			create l_p___0.make

			l_retval.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
			l_p___0.ce_gets (a_string___0)
			from
			until
				not ((l_p___0.item).to_boolean)
			loop
				if (l_p___0.item).to_integer_32 = a_c then
					l_retval.ce_gets (l_p___0)
				end
				if globals_inst.has_mbyte.to_boolean then
					l_tmp___0 := (globals_inst.mb_ptr2len.integer_32_item ([l_p___0]))
				else
					l_tmp___0 := 1
				end
				l_p___0.ce_gets (l_p___0 + l_tmp___0)
			end
			Result := l_retval
		end

	vim_isspace (a_x___0: INTEGER_32): INTEGER_32
		local
			l_tmp: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_x___0 >= 9) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if a_x___0 <= 13 then
							l_tmp := 1
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						if a_x___0 = 32 then
							l_tmp := 1
						else
							l_tmp := 0
						end
				when 4 then
					Result := l_tmp
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ga_clear (a_gap: CE_POINTER [PD_GROWARRAY])
		do
			vim_free (a_gap.item.ga_data)
			ga_init (a_gap)
		end

	ga_clear_strings (a_gap: CE_POINTER [PD_GROWARRAY])
		local
			l_i___0: INTEGER_32
		do
			l_i___0 := 0
			from
			until
				not (l_i___0 < a_gap.item.ga_len)
			loop
				vim_free (create {CE_POINTER [ANY]}.make_cast (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast (a_gap.item.ga_data)[l_i___0]))
				l_i___0 := l_i___0 + 1
			end
			ga_clear (a_gap)
		end

	ga_init (a_gap: CE_POINTER [PD_GROWARRAY])
		do
			a_gap.item.ga_data := create {CE_POINTER [ANY]}.make_shared (default_pointer)
			a_gap.item.ga_maxlen := 0
			a_gap.item.ga_len := 0
		end

	ga_init2 (a_gap: CE_POINTER [PD_GROWARRAY]; a_itemsize: INTEGER_32; a_growsize: INTEGER_32)
		do
			ga_init (a_gap)
			a_gap.item.ga_itemsize := a_itemsize
			a_gap.item.ga_growsize := a_growsize
		end

	ga_grow (a_gap: CE_POINTER [PD_GROWARRAY]; a_n: INTEGER_32): INTEGER_32
		local
			l_n: INTEGER_32
			l_len: NATURAL_32
			l_pp: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_pp.make

			l_n := a_n
			if a_gap.item.ga_maxlen - a_gap.item.ga_len < l_n then
				if l_n < a_gap.item.ga_growsize then
					l_n := a_gap.item.ga_growsize
				end
				l_len := (a_gap.item.ga_itemsize * (a_gap.item.ga_len + l_n)).to_natural_32
				l_pp.ce_gets (alloc_clear (l_len))
				if (l_pp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					Result := 0
					js.return
				end
				if not js.return_called then
					a_gap.item.ga_maxlen := a_gap.item.ga_len + l_n
					if ((a_gap.item.ga_data).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						memmove (create {CE_POINTER [ANY]}.make_cast (l_pp), a_gap.item.ga_data, (a_gap.item.ga_itemsize * a_gap.item.ga_len).to_natural_32).do_nothing
						vim_free (a_gap.item.ga_data)
					end
					a_gap.item.ga_data := create {CE_POINTER [ANY]}.make_cast (l_pp)
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	ga_concat_strings (a_gap: CE_POINTER [PD_GROWARRAY]): CE_POINTER [NATURAL_8]
		local
			l_i___0: INTEGER_32
			l_len: INTEGER_32
			l_s: CE_POINTER [NATURAL_8]
		do
			create l_s.make

			l_len := 0
			l_i___0 := 0
			from
			until
				not (l_i___0 < a_gap.item.ga_len)
			loop
				l_len := l_len + ((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast (a_gap.item.ga_data)[l_i___0]))).to_integer_32 + 1)
				l_i___0 := l_i___0 + 1
			end
			l_s.ce_gets (alloc ((l_len + 1).to_natural_32))
			if (l_s.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				l_s.item := (('%/0/').code).to_natural_8
				l_i___0 := 0
				from
				until
					not (l_i___0 < a_gap.item.ga_len)
				loop
					if (l_s.item).to_integer_32 /= 0 then
						strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_s), ce_string (",")).do_nothing
					end
					strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_s), create {CE_POINTER [INTEGER_8]}.make_cast (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast (a_gap.item.ga_data)[l_i___0])).do_nothing
					l_i___0 := l_i___0 + 1
				end
			end
			Result := l_s
		end

	ga_concat (a_gap: CE_POINTER [PD_GROWARRAY]; a_s: CE_POINTER [NATURAL_8])
		local
			l_len: INTEGER_32
		do
			l_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_s))).to_integer_32
			if (ga_grow (a_gap, l_len)) = 1 then
				memmove (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [INTEGER_8]}.make_cast (a_gap.item.ga_data) + a_gap.item.ga_len)), create {CE_POINTER [ANY]}.make_cast (a_s), l_len.to_natural_32).do_nothing
				a_gap.item.ga_len := a_gap.item.ga_len + l_len
			end
		end

	ga_append (a_gap: CE_POINTER [PD_GROWARRAY]; a_c: INTEGER_32)
		do
			if (ga_grow (a_gap, 1)) = 1 then
				create {CE_POINTER [INTEGER_8]}.make_cast (a_gap.item.ga_data)[a_gap.item.ga_len] := a_c.to_integer_8
				a_gap.item.ga_len := (a_gap.item.ga_len) + 1
			end
		end

	name_to_mod_mask (a_c: INTEGER_32): INTEGER_32
		local
			l_c: INTEGER_32
			l_i___0: INTEGER_32
			js: JUMP_STATE
		do
			l_c := a_c
			if l_c < 97 then
				l_c := l_c
			elseif l_c > 122 then
				l_c := l_c
			else
				l_c := l_c - (32)
			end
			l_i___0 := 0
			from
			until
				not (not js.loop_left and then ((mod_mask_table[l_i___0].mod_mask).to_integer_32 /= 0))
			loop
				if l_c = (mod_mask_table[l_i___0].name).to_integer_32 then
					Result := (mod_mask_table[l_i___0].mod_flag).to_integer_32
					js.return
				end
				if not js.return_called then
					l_i___0 := l_i___0 + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	simplify_key (a_key: INTEGER_32; a_modifiers: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_key0: INTEGER_32
			l_key1: INTEGER_32
			js: JUMP_STATE
		do
			if ((a_modifiers.item).bit_and (14)).to_boolean then
				if a_key = 9 then
					if ((a_modifiers.item).bit_and (2)).to_boolean then
						a_modifiers.item := (a_modifiers.item).bit_and ((-3))
						Result := (-(107 + ((66).bit_shift_left (8))))
						js.return
					end
				end
				if not js.return_called then
					l_key0 := (-a_key).bit_and (255)
					l_key1 := (((((-a_key).to_natural_32).bit_shift_right (8))).bit_and ({NATURAL_32} 255)).to_integer_32
					l_i___0 := 0
					from
					until
						not (not js.loop_left and then ((modifier_keys_table[l_i___0]).to_integer_32 /= 0))
					loop
						if l_key0 = (modifier_keys_table[l_i___0 + 3]).to_integer_32 then
							if l_key1 = (modifier_keys_table[l_i___0 + 4]).to_integer_32 then
								if ((a_modifiers.item).bit_and ((modifier_keys_table[l_i___0]).to_integer_32)).to_boolean then
									a_modifiers.item := (a_modifiers.item).bit_and ((((modifier_keys_table[l_i___0]).to_integer_32).bit_not))
									Result := (-((modifier_keys_table[l_i___0 + 1]).to_integer_32 + (((modifier_keys_table[l_i___0 + 2]).to_integer_32).bit_shift_left (8))))
									js.return
								end
							end
						end
						if not js.return_called then
							l_i___0 := l_i___0 + (5)
						end
					end
				end
			end
			if not js.return_called then
				Result := a_key
			end
		end

	handle_x_keys (a_key: INTEGER_32): INTEGER_32
		local
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect a_key -- switch 1 head
					when -16893 then l_pos := -1 + 1
					when -17149 then l_pos := -1 + 2
					when -17405 then l_pos := -1 + 3
					when -17661 then l_pos := -1 + 4
					when -16381 then l_pos := -1 + 5
					when -16637 then l_pos := -1 + 6
					when -15869 then l_pos := -1 + 7
					when -16125 then l_pos := -1 + 8
					when -14845 then l_pos := -1 + 9
					when -15101 then l_pos := -1 + 10
					when -15357 then l_pos := -1 + 11
					when -15613 then l_pos := -1 + 12
					when -18429 then l_pos := -1 + 13
					when -18685 then l_pos := -1 + 14
					when -18941 then l_pos := -1 + 15
					when -19197 then l_pos := -1 + 16
					else l_pos := -1 + 17
					end
				when 1 then -- switch 1, case -(253 + (65 << 8))
					Result := (-(107 + ((117).bit_shift_left (8))))
					js.return
				when 2 then -- switch 1, case -(253 + (66 << 8))
					if not js.return_called then
						Result := (-(107 + ((100).bit_shift_left (8))))
						js.return
					end
				when 3 then -- switch 1, case -(253 + (67 << 8))
					if not js.return_called then
						Result := (-(107 + ((108).bit_shift_left (8))))
						js.return
					end
				when 4 then -- switch 1, case -(253 + (68 << 8))
					if not js.return_called then
						Result := (-(107 + ((114).bit_shift_left (8))))
						js.return
					end
				when 5 then -- switch 1, case -(253 + (63 << 8))
					if not js.return_called then
						Result := (-(107 + ((104).bit_shift_left (8))))
						js.return
					end
				when 6 then -- switch 1, case -(253 + (64 << 8))
					if not js.return_called then
						Result := (-(107 + ((104).bit_shift_left (8))))
						js.return
					end
				when 7 then -- switch 1, case -(253 + (61 << 8))
					if not js.return_called then
						Result := (-(64 + ((55).bit_shift_left (8))))
						js.return
					end
				when 8 then -- switch 1, case -(253 + (62 << 8))
					if not js.return_called then
						Result := (-(64 + ((55).bit_shift_left (8))))
						js.return
					end
				when 9 then -- switch 1, case -(253 + (57 << 8))
					if not js.return_called then
						Result := (-(107 + ((49).bit_shift_left (8))))
						js.return
					end
				when 10 then -- switch 1, case -(253 + (58 << 8))
					if not js.return_called then
						Result := (-(107 + ((50).bit_shift_left (8))))
						js.return
					end
				when 11 then -- switch 1, case -(253 + (59 << 8))
					if not js.return_called then
						Result := (-(107 + ((51).bit_shift_left (8))))
						js.return
					end
				when 12 then -- switch 1, case -(253 + (60 << 8))
					if not js.return_called then
						Result := (-(107 + ((52).bit_shift_left (8))))
						js.return
					end
				when 13 then -- switch 1, case -(253 + (71 << 8))
					if not js.return_called then
						Result := (-(253 + ((6).bit_shift_left (8))))
						js.return
					end
				when 14 then -- switch 1, case -(253 + (72 << 8))
					if not js.return_called then
						Result := (-(253 + ((7).bit_shift_left (8))))
						js.return
					end
				when 15 then -- switch 1, case -(253 + (73 << 8))
					if not js.return_called then
						Result := (-(253 + ((8).bit_shift_left (8))))
						js.return
					end
				when 16 then -- switch 1, case -(253 + (74 << 8))
					if not js.return_called then
						Result := (-(253 + ((9).bit_shift_left (8))))
						js.return
					end
				when 17 then -- switch 1, done:
					if not js.return_called then
						Result := a_key
					end
				when 18 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_special_key_name (a_c: INTEGER_32; a_modifiers: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_c: INTEGER_32
			l_modifiers: INTEGER_32
			l_i___0: INTEGER_32
			l_idx: INTEGER_32
			l_table_idx: INTEGER_32
			l_s: CE_POINTER [NATURAL_8]
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___9: INTEGER_32
			l_tmp___10: INTEGER_32
			l_tmp___11: CE_POINTER [NATURAL_8]
			l_tmp___15: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_s.make
			create l_tmp___11.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_c := a_c
					l_modifiers := a_modifiers
					string[0] := (('<').code).to_natural_8
					l_idx := 1
					if l_c < 0 then
						if ((-l_c).bit_and (255)) = 242 then
							l_c := (((((-l_c).to_natural_32).bit_shift_right (8))).bit_and ({NATURAL_32} 255)).to_integer_32
						end
					end
					if l_c < 0 then
						l_i___0 := 0
						from
						until
							not (not js.loop_left and then ((modifier_keys_table[l_i___0]).to_integer_32 /= 0))
						loop
							js.reset
							if ((-l_c).bit_and (255)) = (modifier_keys_table[l_i___0 + 1]).to_integer_32 then
								if (((((-l_c).to_natural_32).bit_shift_right (8))).bit_and ({NATURAL_32} 255)).to_integer_32 = (modifier_keys_table[l_i___0 + 2]).to_integer_32 then
									l_modifiers := (l_modifiers).bit_or ((modifier_keys_table[l_i___0]).to_integer_32)
									l_c := -((modifier_keys_table[l_i___0 + 3]).to_integer_32 + (((modifier_keys_table[l_i___0 + 4]).to_integer_32).bit_shift_left (8)))
									js.break
								end
							end
							if not js.loop_jumped then
								l_i___0 := l_i___0 + (5)
							end
						end
						js.reset
					end
					l_table_idx := find_special_key_in_table (l_c)
					if not (l_c > 0) then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						if (globals_inst.mb_char2len.integer_32_item ([l_c])) /= 1 then
							l_pos := -1 + 9 -- skip if block
						end
				when 2 then -- if:
						if not (l_table_idx < 0) then
							l_pos := -1 + 8 -- skip if block
						end
				when 3 then -- if:
						if not ((charset_inst.vim_isprintc (l_c)).to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 4 then -- if:
						if ((l_c).bit_and (127)) /= 32 then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						if ((l_c).bit_and (128)).to_boolean then
							l_c := (l_c).bit_and ((127))
							l_modifiers := (l_modifiers).bit_or ((8))
							l_table_idx := find_special_key_in_table (l_c)
						end
				when 6 then -- if done | if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else:
						l_pos := -1 + 5 -- goto _L
				when 8 then -- if done
						if l_table_idx < 0 then
							if not (charset_inst.vim_isprintc (l_c)).to_boolean then
								if l_c < 32 then
									l_c := l_c + (64)
									l_modifiers := (l_modifiers).bit_or ((4))
								end
							end
						end
				when 9 then -- if done | if done
						l_i___0 := 0
						from
						until
							(mod_mask_table[l_i___0].name).to_integer_32 = 65
						loop
							if ((l_modifiers).bit_and ((mod_mask_table[l_i___0].mod_mask).to_integer_32)) = (mod_mask_table[l_i___0].mod_flag).to_integer_32 then
								l_tmp___2 := l_idx
								l_idx := l_idx + 1
								string[l_tmp___2] := mod_mask_table[l_i___0].name
								l_tmp___3 := l_idx
								l_idx := l_idx + 1
								string[l_tmp___3] := (('-').code).to_natural_8
							end
							l_i___0 := l_i___0 + 1
						end
						if not (l_table_idx < 0) then
							l_pos := -1 + 18 -- skip if block
						end
				when 10 then -- if:
							if not (l_c < 0) then
								l_pos := -1 + 13 -- skip if block
							end
				when 11 then -- if:
							l_tmp___4 := l_idx
							l_idx := l_idx + 1
							string[l_tmp___4] := (('t').code).to_natural_8
							l_tmp___5 := l_idx
							l_idx := l_idx + 1
							string[l_tmp___5] := (('_').code).to_natural_8
							l_tmp___6 := l_idx
							l_idx := l_idx + 1
							string[l_tmp___6] := ((-l_c).bit_and (255)).to_natural_8
							l_tmp___7 := l_idx
							l_idx := l_idx + 1
							string[l_tmp___7] := (((((-l_c).to_natural_32).bit_shift_right (8))).bit_and ({NATURAL_32} 255)).to_natural_8
				when 12 then -- if block done, skip else block:
							l_pos := -1 + 17
				when 13 then -- else:
							if not (globals_inst.has_mbyte.to_boolean) then
								l_pos := -1 + 16 -- skip if block
							end
				when 14 then -- if:
							if (globals_inst.mb_char2len.integer_32_item ([l_c])) > 1 then
								l_idx := l_idx + (globals_inst.mb_char2bytes.integer_32_item ([l_c, string + l_idx]))
							else
								l_pos := -1 + 16 -- goto _L___0
							end
				when 15 then -- if block done, skip else block:
							l_pos := -1 + 17
				when 16 then -- else: | _L___0:
							if (charset_inst.vim_isprintc (l_c)).to_boolean then
								l_tmp___9 := l_idx
								l_idx := l_idx + 1
								string[l_tmp___9] := l_c.to_natural_8
							else
								l_s.ce_gets (charset_inst.transchar (l_c))
								from
								until
									not ((l_s.item).to_boolean)
								loop
									l_tmp___10 := l_idx
									l_idx := l_idx + 1
									l_tmp___11.ce_gets (l_s)
									l_s.ce_gets (l_s + 1)
									string[l_tmp___10] := l_tmp___11.item
								end
							end
				when 17 then -- if done | if done | if block done, skip else block:
							l_pos := -1 + 19
				when 18 then -- else:
							strcpy (create {CE_POINTER [INTEGER_8]}.make_cast ((string + l_idx)), create {CE_POINTER [INTEGER_8]}.make_cast (key_names_table[l_table_idx].name)).do_nothing
							l_idx := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (string))).to_integer_32
				when 19 then
						l_tmp___15 := l_idx
						l_idx := l_idx + 1
						string[l_tmp___15] := (('>').code).to_natural_8
						string[l_idx] := (('%/0/').code).to_natural_8
						Result := string
				when 20 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	trans_special (a_srcp: CE_POINTER [CE_POINTER [NATURAL_8]]; a_dst: CE_POINTER [NATURAL_8]; a_keycode: INTEGER_32): INTEGER_32
		local
			l_modifiers: INTEGER_32
			l_key: INTEGER_32
			l_dlen: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___7: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_modifiers := 0
					l_dlen := 0
					l_key := find_special_key (a_srcp, create {CE_POINTER [INTEGER_32]}.make_shared ($l_modifiers), a_keycode, 0)
					if l_key = 0 then
						Result := 0
						js.return
					end
					if js.return_called then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						if l_modifiers /= 0 then
							l_tmp := l_dlen
							l_dlen := l_dlen + 1
							a_dst[l_tmp] := (128).to_natural_8
							l_tmp___0 := l_dlen
							l_dlen := l_dlen + 1
							a_dst[l_tmp___0] := (252).to_natural_8
							l_tmp___1 := l_dlen
							l_dlen := l_dlen + 1
							a_dst[l_tmp___1] := l_modifiers.to_natural_8
						end
						if not (l_key < 0) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_tmp___2 := l_dlen
						l_dlen := l_dlen + 1
						a_dst[l_tmp___2] := (128).to_natural_8
						l_tmp___3 := l_dlen
						l_dlen := l_dlen + 1
						a_dst[l_tmp___3] := ((-l_key).bit_and (255)).to_natural_8
						l_tmp___4 := l_dlen
						l_dlen := l_dlen + 1
						a_dst[l_tmp___4] := (((((-l_key).to_natural_32).bit_shift_right (8))).bit_and ({NATURAL_32} 255)).to_natural_8
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 4 then -- else:
						if not (globals_inst.has_mbyte.to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if not a_keycode.to_boolean then
							l_dlen := l_dlen + (globals_inst.mb_char2bytes.integer_32_item ([l_key, a_dst + l_dlen]))
						else
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						if a_keycode.to_boolean then
							l_dlen := (edit_inst.add_char2buf (l_key, a_dst + l_dlen)).distance (a_dst)
						else
							l_tmp___7 := l_dlen
							l_dlen := l_dlen + 1
							a_dst[l_tmp___7] := l_key.to_natural_8
						end
				when 8 then -- if done
						Result := l_dlen
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	find_special_key (a_srcp: CE_POINTER [CE_POINTER [NATURAL_8]]; a_modp: CE_POINTER [INTEGER_32]; a_keycode: INTEGER_32; a_keep_x_key: INTEGER_32): INTEGER_32
		local
			l_last_dash: CE_POINTER [NATURAL_8]
			l_end_of_name: CE_POINTER [NATURAL_8]
			l_src: CE_POINTER [NATURAL_8]
			l_bp___0: CE_POINTER [NATURAL_8]
			l_modifiers: INTEGER_32
			l_bit: INTEGER_32
			l_key: INTEGER_32
			l_n: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_last_dash.make
			create l_end_of_name.make
			create l_src.make
			create l_bp___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_src.ce_gets (a_srcp.item)
					if (l_src[0]).to_integer_32 /= 60 then
						Result := 0
						js.return
					end
					if js.return_called then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						l_last_dash.ce_gets (l_src)
						l_bp___0.ce_gets (l_src + 1)
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_bp___0.item).to_integer_32 /= 45 then
								if not (charset_inst.vim_isIDc ((l_bp___0.item).to_integer_32)).to_boolean then
									js.break
								end
							end
							if not js.loop_jumped then
								if (l_bp___0.item).to_integer_32 = 45 then
									l_last_dash.ce_gets (l_bp___0)
									if (l_bp___0[1]).to_integer_32 /= 0 then
										if (l_bp___0[2]).to_integer_32 = 62 then
											l_bp___0.ce_gets (l_bp___0 + 1)
										end
									end
								end
								if (l_bp___0[0]).to_integer_32 = 116 then
									if (l_bp___0[1]).to_integer_32 = 95 then
										if (l_bp___0[2]).to_boolean then
											if (l_bp___0[3]).to_boolean then
												l_bp___0.ce_gets (l_bp___0 + (3))
											end
										end
									end
								end
								l_bp___0.ce_gets (l_bp___0 + 1)
							end
						end
						js.reset
						if (l_bp___0.item).to_integer_32 /= 62 then
							l_pos := -1 + 9 -- skip if block
						end
				when 2 then -- if:
						l_end_of_name.ce_gets (l_bp___0 + 1)
						if (strncasecmp (create {CE_POINTER [INTEGER_8]}.make_cast ((l_src + 1)), ce_string ("char-"), (5).to_natural_32)) = 0 then
							if (l_src[6]).to_integer_32 >= 48 then
								if (l_src[6]).to_integer_32 <= 57 then
									charset_inst.vim_str2nr (l_src + 6, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), 1, 1, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_32]}.make_shared ($l_n))
									a_modp.item := 0
									a_srcp.item := l_end_of_name
									Result := l_n.to_integer_32
									js.return
								end
							end
						end
						if js.return_called then
							l_pos := -1 + 9 -- skip if block
						end
				when 3 then -- if:
						l_modifiers := 0
						l_bp___0.ce_gets (l_src + 1)
						from
						until
							not (not js.loop_left and then ((l_bp___0.c_pointer.to_integer_32).to_natural_32 < (l_last_dash.c_pointer.to_integer_32).to_natural_32))
						loop
							js.reset
							if (l_bp___0.item).to_integer_32 /= 45 then
								l_bit := name_to_mod_mask ((l_bp___0.item).to_integer_32)
								if l_bit = 0 then
									js.break
								end
								if not js.loop_jumped then
									l_modifiers := (l_modifiers).bit_or (l_bit)
								end
							end
							if not js.loop_jumped then
								l_bp___0.ce_gets (l_bp___0 + 1)
							end
						end
						js.reset
						if not ((l_bp___0.c_pointer.to_integer_32).to_natural_32 >= (l_last_dash.c_pointer.to_integer_32).to_natural_32) then
							l_pos := -1 + 9 -- skip if block
						end
				when 4 then -- if:
						if l_modifiers = 0 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if (l_last_dash[2]).to_integer_32 = 62 then
							l_key := (l_last_dash[1]).to_integer_32
						else
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						l_key := get_special_key_code (l_last_dash + 1)
						if not a_keep_x_key.to_boolean then
							l_key := handle_x_keys (l_key)
						end
				when 8 then
						if l_key /= 0 then
							l_key := simplify_key (l_key, create {CE_POINTER [INTEGER_32]}.make_shared ($l_modifiers))
							if not a_keycode.to_boolean then
								if l_key = -(107 + ((98).bit_shift_left (8))) then
									l_key := ('%B').code
								elseif l_key = -(107 + ((68).bit_shift_left (8))) then
									l_key := 127
								elseif l_key = -(253 + ((80).bit_shift_left (8))) then
									l_key := 127
								end
							end
							if not (l_key < 0) then
								l_key := extract_modifiers (l_key, create {CE_POINTER [INTEGER_32]}.make_shared ($l_modifiers))
							end
							a_modp.item := l_modifiers
							a_srcp.item := l_end_of_name
							Result := l_key
							js.return
						end
				when 9 then -- if done | if done | if done | if done
						if not js.return_called then
							Result := 0
						end
				when 10 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	extract_modifiers (a_key: INTEGER_32; a_modp: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_key: INTEGER_32
			l_modifiers: INTEGER_32
			l_tmp___0: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_key := a_key
					l_modifiers := a_modp.item
					if ((l_modifiers).bit_and (2)).to_boolean then
						if l_key < 127 then
							if ((((ctype_b_loc).item[l_key]).to_integer_32).bit_and (1024)).to_boolean then
								if l_key < 97 then
									l_key := l_key
								elseif l_key > 122 then
									l_key := l_key
								else
									l_key := l_key - (32)
								end
								l_modifiers := (l_modifiers).bit_and ((-3))
							end
						end
					end
					if not (((l_modifiers).bit_and (4)).to_boolean) then
						l_pos := -1 + 7 -- skip if block
					end
				when 1 then -- if:
						if not (l_key >= 63) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_key <= 95 then
							l_pos := -1 + 6 -- goto _L
						else
							l_pos := -1 + 4 -- goto _L___0
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 4 then -- else: | _L___0:
						if not (l_key < 127) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if not (((((ctype_b_loc).item[l_key]).to_integer_32).bit_and (1024)).to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 6 then -- if: | _L:
						if l_key < 97 then
							l_tmp___0 := l_key
						elseif l_key > 122 then
							l_tmp___0 := l_key
						else
							l_tmp___0 := l_key - 32
						end
						l_key := (l_tmp___0).bit_xor (64)
						l_modifiers := (l_modifiers).bit_and ((-5))
						if l_key = 0 then
							l_key := -(255 + ((88).bit_shift_left (8)))
						end
				when 7 then -- if done | if done | if done
						if ((l_modifiers).bit_and (8)).to_boolean then
							if l_key < 128 then
								if not globals_inst.enc_dbcs.to_boolean then
									l_key := (l_key).bit_or ((128))
									l_modifiers := (l_modifiers).bit_and ((-9))
								end
							end
						end
						a_modp.item := l_modifiers
						Result := l_key
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	find_special_key_in_table (a_c: INTEGER_32): INTEGER_32
		local
			l_i___0: INTEGER_32
			js: JUMP_STATE
		do
			l_i___0 := 0
			from
			until
				not (not js.loop_left and then (((key_names_table[l_i___0].name).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32))
			loop
				js.reset
				if a_c = key_names_table[l_i___0].key then
					js.break
				end
				if not js.loop_jumped then
					l_i___0 := l_i___0 + 1
				end
			end
			js.reset
			if ((key_names_table[l_i___0].name).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				l_i___0 := -1
			end
			Result := l_i___0
		end

	get_special_key_code (a_name___1: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_table_name: CE_POINTER [NATURAL_8]
			l_string___0: CE_ARRAY [NATURAL_8]
			l_i___0: INTEGER_32
			l_j: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_table_name.make
			create l_string___0.make (<<3>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (a_name___1[0]).to_integer_32 /= 116 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if (a_name___1[1]).to_integer_32 = 95 then
							if (a_name___1[2]).to_integer_32 /= 0 then
								if (a_name___1[3]).to_integer_32 /= 0 then
									l_string___0[0] := a_name___1[2]
									l_string___0[1] := a_name___1[3]
									l_string___0[2] := (('%/0/').code).to_natural_8
									if (term_inst.add_termcap_entry (l_string___0, 0)) = 1 then
										Result := (-((a_name___1[2]).to_integer_32 + (((a_name___1[3]).to_integer_32).bit_shift_left (8))))
										js.return
									end
								else
									l_pos := -1 + 3 -- goto _L___1
								end
							else
								l_pos := -1 + 3 -- goto _L___1
							end
						else
							l_pos := -1 + 3 -- goto _L___1
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L___1:
						l_i___0 := 0
						from
						until
							not (not js.loop_left and then (((key_names_table[l_i___0].name).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32))
						loop
							l_table_name.ce_gets (key_names_table[l_i___0].name)
							l_j := 0
							from
							until
								js.loop_left
							loop
								js.reset
								if (charset_inst.vim_isIDc ((a_name___1[l_j]).to_integer_32)).to_boolean then
									if (l_table_name[l_j]).to_integer_32 = 0 then
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped then
									if (l_table_name[l_j]).to_integer_32 < 65 then
										l_tmp___0 := (l_table_name[l_j]).to_integer_32
									elseif (l_table_name[l_j]).to_integer_32 > 90 then
										l_tmp___0 := (l_table_name[l_j]).to_integer_32
									else
										l_tmp___0 := (l_table_name[l_j]).to_integer_32 + 32
									end
									if (a_name___1[l_j]).to_integer_32 < 65 then
										l_tmp___1 := (a_name___1[l_j]).to_integer_32
									elseif (a_name___1[l_j]).to_integer_32 > 90 then
										l_tmp___1 := (a_name___1[l_j]).to_integer_32
									else
										l_tmp___1 := (a_name___1[l_j]).to_integer_32 + 32
									end
									if l_tmp___0 /= l_tmp___1 then
										js.break
									end
								end
								if not js.loop_jumped then
									l_j := l_j + 1
								end
							end
							js.reset
							if not (charset_inst.vim_isIDc ((a_name___1[l_j]).to_integer_32)).to_boolean then
								if (l_table_name[l_j]).to_integer_32 = 0 then
									Result := (key_names_table[l_i___0].key)
									js.return
								end
							end
							if not js.return_called then
								l_i___0 := l_i___0 + 1
							end
						end
				when 4 then
					if not js.return_called then
						Result := 0
					end
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_key_name (a_i___0: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			js: JUMP_STATE
		do
			if a_i___0 >= (({PD_KEY_NAME_ENTRY}.sizeof.to_natural_32 * (136).to_natural_32) // {PD_KEY_NAME_ENTRY}.sizeof.to_natural_32).to_integer_32 then
				Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				Result := (key_names_table[a_i___0].name)
			end
		end

	get_mouse_button (a_code: INTEGER_32; a_is_click: CE_POINTER [INTEGER_32]; a_is_drag: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_i___0: INTEGER_32
			js: JUMP_STATE
		do
			l_i___0 := 0
			from
			until
				not (not js.loop_left and then ((mouse_table[l_i___0].pseudo_code).to_boolean))
			loop
				if a_code = mouse_table[l_i___0].pseudo_code then
					a_is_click.item := mouse_table[l_i___0].is_click
					a_is_drag.item := mouse_table[l_i___0].is_drag
					Result := (mouse_table[l_i___0].button)
					js.return
				end
				if not js.return_called then
					l_i___0 := l_i___0 + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	get_pseudo_mouse_code (a_button: INTEGER_32; a_is_click: INTEGER_32; a_is_drag: INTEGER_32): INTEGER_32
		local
			l_i___0: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_i___0 := 0
				when 1 then -- loop condition:
					if not (not js.loop_left and then ((mouse_table[l_i___0].pseudo_code).to_boolean)) then
						l_pos := -1 + 12 -- skip loop
					end
				when 2 then -- loop body:
						if a_button /= mouse_table[l_i___0].button then
							l_pos := -1 + 11 -- skip if block
						end
				when 3 then -- if:
						if a_is_click /= mouse_table[l_i___0].is_click then
							l_pos := -1 + 11 -- skip if block
						end
				when 4 then -- if:
						if a_is_drag /= mouse_table[l_i___0].is_drag then
							l_pos := -1 + 11 -- skip if block
						end
				when 5 then -- if:
						if not (globals_inst.mouse_col < 0) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_pos := -1 + 9 -- goto _L
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 8 then -- else:
						if not (globals_inst.mouse_col > 10000) then
							l_pos := -1 + 10 -- skip if block
						end
				when 9 then -- if: | _L:
						if globals_inst.mouse_col < 0 then
							globals_inst.mouse_col := 0
						else
							globals_inst.mouse_col := globals_inst.mouse_col - (10000)
						end
						if mouse_table[l_i___0].pseudo_code = 44 then
							Result := 69
							js.return
						end
						if not js.return_called and then (mouse_table[l_i___0].pseudo_code = 46) then
							Result := 70
							js.return
						end
				when 10 then -- if done
						if not js.return_called then
							Result := (mouse_table[l_i___0].pseudo_code)
							js.return
						end
				when 11 then -- if done | if done | if done
						if not js.return_called then
							l_i___0 := l_i___0 + 1
						end
						l_pos := -1 + 1 -- back to loop condition
				when 12 then -- loop done
					if not js.return_called then
						Result := 53
					end
				when 13 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_fileformat (a_buf___6: CE_POINTER [PD_FILE_BUFFER]): INTEGER_32
		local
			l_c: INTEGER_32
			js: JUMP_STATE
		do
			l_c := ((a_buf___6.item.b_p_ff).item).to_integer_32
			if (a_buf___6.item.b_p_bin).to_boolean then
				Result := 0
				js.return
			elseif l_c = 117 then
				Result := 0
				js.return
			end
			if not js.return_called and then (l_c = 109) then
				Result := 2
				js.return
			end
			if not js.return_called then
				Result := 1
			end
		end

	get_fileformat_force (a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_eap: CE_POINTER [PD_EXARG]): INTEGER_32
		local
			l_c: INTEGER_32
			l_tmp: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (a_eap.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if a_eap.item.force_ff /= 0 then
							l_c := (a_eap.item.cmd[a_eap.item.force_ff]).to_integer_32
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						if (a_eap.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							if a_eap.item.force_bin /= 0 then
								l_tmp := (a_eap.item.force_bin = 1).to_integer
							else
								l_tmp := a_buf___6.item.b_p_bin
							end
						else
							l_tmp := a_buf___6.item.b_p_bin
						end
						if l_tmp.to_boolean then
							Result := 0
							js.return
						end
						if not js.return_called then
							l_c := ((a_buf___6.item.b_p_ff).item).to_integer_32
						end
				when 4 then
					if not js.return_called and then (l_c = 117) then
						Result := 0
						js.return
					end
					if not js.return_called and then (l_c = 109) then
						Result := 2
						js.return
					end
					if not js.return_called then
						Result := 1
					end
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	set_fileformat (a_t: INTEGER_32; a_opt_flags: INTEGER_32)
		local
			l_p___0: CE_POINTER [INTEGER_8]
			l_pos: INTEGER_32
		do
			create l_p___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p___0.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
					inspect a_t -- switch 1 head
					when 1 then l_pos := -1 + 1
					when 0 then l_pos := -1 + 2
					when 2 then l_pos := -1 + 3
					else l_pos := -1 + 4
					end
				when 1 then -- switch 1, case 1
					l_p___0.ce_gets (ce_string ("dos"))
					globals_inst.curbuf.item.b_p_tx := 1
					l_pos := -1 + 4 -- switch 1; break
				when 2 then -- switch 1, case 0
					l_p___0.ce_gets (ce_string ("unix"))
					globals_inst.curbuf.item.b_p_tx := 0
					l_pos := -1 + 4 -- switch 1; break
				when 3 then -- switch 1, case 2
					l_p___0.ce_gets (ce_string ("mac"))
					globals_inst.curbuf.item.b_p_tx := 0
					l_pos := -1 + 4 -- switch 1; break
				when 4 then -- switch 1, done:
					if (l_p___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						option_inst.set_string_option_direct (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ff")), -1, create {CE_POINTER [NATURAL_8]}.make_cast (l_p___0), (1).bit_or (a_opt_flags), 0)
					end
					misc1_inst.check_status (globals_inst.curbuf)
					globals_inst.redraw_tabline := 1
					globals_inst.need_maketitle := 1
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	default_fileformat: INTEGER_32
		local
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect (option_inst.p_ffs.item).to_integer_32 -- switch 1 head
					when 109 then l_pos := -1 + 1
					when 100 then l_pos := -1 + 2
					else l_pos := -1 + 3
					end
				when 1 then -- switch 1, case 109
					Result := 2
					js.return
				when 2 then -- switch 1, case 100
					if not js.return_called then
						Result := 1
						js.return
					end
				when 3 then -- switch 1, done:
					if not js.return_called then
						Result := 0
					end
				when 4 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	call_shell (a_cmd: CE_POINTER [NATURAL_8]; a_opt: INTEGER_32): INTEGER_32
		local
			l_ncmd: CE_POINTER [NATURAL_8]
			l_retval: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___2: NATURAL_32
		do
			create l_ncmd.make
			create l_tmp.make

			if option_inst.p_verbose > 3 then
				message_inst.verbose_enter
				if (a_cmd.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					l_tmp.ce_gets (option_inst.p_sh)
				else
					l_tmp.ce_gets (a_cmd)
				end
				message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Calling shell to execute: %"%%s%"")))), l_tmp]).do_nothing
				term_inst.out_char ((('%N').code).to_natural_32)
				term_inst.cursor_on
				message_inst.verbose_leave
			end
			if (option_inst.p_sh.item).to_integer_32 = 0 then
				message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_shellempty))))).do_nothing
				l_retval := -1
			else
				globals_inst.hold_gui_events := globals_inst.hold_gui_events + (1)
				tag_inst.tag_freematch
				if (a_cmd.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					l_retval := os_unix_inst.mch_call_shell (a_cmd, a_opt)
				elseif (option_inst.p_sxq.item).to_integer_32 = 0 then
					l_retval := os_unix_inst.mch_call_shell (a_cmd, a_opt)
				else
					l_tmp___2 := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_cmd))
					l_ncmd.ce_gets (alloc ((l_tmp___2 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (option_inst.p_sxq))) * {NATURAL_32} 2) + {NATURAL_32} 1))
					if (l_ncmd.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_ncmd), create {CE_POINTER [INTEGER_8]}.make_cast (option_inst.p_sxq)).do_nothing
						strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_ncmd), create {CE_POINTER [INTEGER_8]}.make_cast (a_cmd)).do_nothing
						strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_ncmd), create {CE_POINTER [INTEGER_8]}.make_cast (option_inst.p_sxq)).do_nothing
						l_retval := os_unix_inst.mch_call_shell (l_ncmd, a_opt)
						vim_free (create {CE_POINTER [ANY]}.make_cast (l_ncmd))
					else
						l_retval := -1
					end
				end
				globals_inst.hold_gui_events := globals_inst.hold_gui_events - (1)
				term_inst.shell_resized_check
			end
			eval_inst.set_vim_var_nr (6, l_retval.to_integer_32)
			Result := l_retval
		end

	get_real_state: INTEGER_32
		local
			js: JUMP_STATE
		do
			if ((globals_inst.State).bit_and (1)).to_boolean then
				if globals_inst.VIsual_active.to_boolean then
					if globals_inst.VIsual_select.to_boolean then
						Result := 4096
						js.return
					end
					if not js.return_called then
						Result := 2
						js.return
					end
				elseif globals_inst.finish_op.to_boolean then
					Result := 4
					js.return
				end
			end
			if not js.return_called then
				Result := globals_inst.State
			end
		end

	after_pathsep (a_b: CE_POINTER [NATURAL_8]; a_p___0: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_tmp___1: INTEGER_32
		do
			if (misc1_inst.vim_ispathsep ((a_p___0[-1]).to_integer_32)).to_boolean then
				if not globals_inst.has_mbyte.to_boolean then
					l_tmp___1 := 1
				elseif (globals_inst.mb_head_off.integer_32_item ([a_b, a_p___0 - 1])) = 0 then
					l_tmp___1 := 1
				else
					l_tmp___1 := 0
				end
			else
				l_tmp___1 := 0
			end
			Result := l_tmp___1
		end

	same_directory (a_f1: CE_POINTER [NATURAL_8]; a_f2: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_ffname: CE_ARRAY [NATURAL_8]
			l_t1: CE_POINTER [NATURAL_8]
			l_t2: CE_POINTER [NATURAL_8]
			l_tmp___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_ffname.make (<<4096>>)
			create l_t1.make
			create l_t2.make

			if (a_f1.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				Result := 0
				js.return
			elseif (a_f2.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				Result := 0
				js.return
			end
			if not js.return_called then
				window_inst.vim_FullName (a_f1, l_ffname, 4096, 0).do_nothing
				l_t1.ce_gets (misc1_inst.gettail_sep (l_ffname))
				l_t2.ce_gets (misc1_inst.gettail_sep (a_f2))
				if l_t1.distance (l_ffname) = l_t2.distance (a_f2) then
					if (pathcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_ffname), create {CE_POINTER [INTEGER_8]}.make_cast (a_f2), l_t1.distance (l_ffname))) = 0 then
						l_tmp___0 := 1
					else
						l_tmp___0 := 0
					end
				else
					l_tmp___0 := 0
				end
				Result := l_tmp___0
			end
		end

	vim_chdirfile (a_fname: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_dir___0: CE_ARRAY [NATURAL_8]
			l_tmp___1: INTEGER_32
		do
			create l_dir___0.make (<<4096>>)

			vim_strncpy (l_dir___0, a_fname, (4095).to_natural_32);
			(misc1_inst.gettail_sep (l_dir___0)).item := (('%/0/').code).to_natural_8
			if (os_unix_inst.mch_chdir (create {CE_POINTER [INTEGER_8]}.make_cast (l_dir___0))) = 0 then
				l_tmp___1 := 1
			else
				l_tmp___1 := 0
			end
			Result := l_tmp___1
		end

	parse_shape_opt (a_what: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_modep: CE_POINTER [NATURAL_8]
			l_colonp: CE_POINTER [NATURAL_8]
			l_commap: CE_POINTER [NATURAL_8]
			l_slashp: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_endp: CE_POINTER [NATURAL_8]
			l_idx: INTEGER_32
			l_all_idx: INTEGER_32
			l_len: INTEGER_32
			l_i___0: INTEGER_32
			l_n: INTEGER_32
			l_found_ve: INTEGER_32
			l_round: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___10: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_modep.make
			create l_colonp.make
			create l_commap.make
			create l_slashp.make
			create l_p___0.make
			create l_endp.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_idx := 0
					l_found_ve := 0
					l_round := 1
				when 1 then -- loop condition:
					if not (not js.loop_left and then (l_round <= 2)) then
						l_pos := -1 + 19 -- skip loop
					end
				when 2 then -- loop body:
						if a_what = 1 then
							l_modep.ce_gets (option_inst.p_mouseshape)
						else
							l_modep.ce_gets (option_inst.p_guicursor)
						end
				when 3 then -- loop condition:
						if not (not js.loop_left and then ((l_modep.item).to_integer_32 /= 0)) then
							l_pos := -1 + 18 -- skip loop
						end
				when 4 then -- loop body:
						l_colonp.ce_gets (vim_strchr (l_modep, (':').code))
						if (l_colonp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							Result := (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E545: Missing colon")))
							js.return
						end
						if not js.return_called and then ((l_colonp.c_pointer.to_integer_32).to_natural_32 = (l_modep.c_pointer.to_integer_32).to_natural_32) then
							Result := (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E546: Illegal mode")))
							js.return
						end
						if js.return_called then
							l_pos := -1 + 17 -- skip if block
						end
				when 5 then -- if:
						l_commap.ce_gets (vim_strchr (l_modep, (',').code))
						l_all_idx := -1
				when 6 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 16 -- skip loop
						end
				when 7 then -- loop body:
						js.reset
						if not ((l_modep.c_pointer.to_integer_32).to_natural_32 < (l_colonp.c_pointer.to_integer_32).to_natural_32) then
							if not (l_all_idx >= 0) then
								js.break
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 15 -- skip if block
						end
				when 8 then -- if:
						if not (l_all_idx < 0) then
							l_pos := -1 + 14 -- skip if block
						end
				when 9 then -- if:
						if (l_modep[1]).to_integer_32 = 45 then
							l_len := 1
						elseif (l_modep[1]).to_integer_32 = 58 then
							l_len := 1
						else
							l_len := 2
						end
						if l_len /= 1 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						if (l_modep[0]).to_integer_32 < 65 then
							l_tmp___0 := (l_modep[0]).to_integer_32
						elseif (l_modep[0]).to_integer_32 > 90 then
							l_tmp___0 := (l_modep[0]).to_integer_32
						else
							l_tmp___0 := (l_modep[0]).to_integer_32 + 32
						end
						if l_tmp___0 = 97 then
							l_all_idx := 16
						else
							l_pos := -1 + 12 -- goto _L
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else: | _L:
						l_idx := 0
						from
						until
							not (not js.loop_left and then (l_idx < 17))
						loop
							js.reset
							if (strncasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_modep), shape_table[l_idx].name, l_len.to_natural_32)) = 0 then
								js.break
							end
							if not js.loop_jumped then
								l_idx := l_idx + 1
							end
						end
						js.reset
						if l_idx = 17 then
							Result := (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E546: Illegal mode")))
							js.return
						elseif (((shape_table[l_idx].used_for).to_integer_32).bit_and (a_what)) = 0 then
							Result := (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E546: Illegal mode")))
							js.return
						end
						if not js.return_called and then (l_len = 2) then
							if (l_modep[0]).to_integer_32 = 118 then
								if (l_modep[1]).to_integer_32 = 101 then
									l_found_ve := 1
								end
							end
						end
				when 13 then
						if not js.return_called then
							l_modep.ce_gets (l_modep + (l_len + 1))
						end
				when 14 then -- if done
						if not js.return_called then
							if l_all_idx >= 0 then
								l_tmp___1 := l_all_idx
								l_all_idx := l_all_idx - 1
								l_idx := l_tmp___1
							elseif l_round = 2 then
								if a_what = 1 then
									shape_table[l_idx].mshape := 0
								else
									shape_table[l_idx].shape := 0
									shape_table[l_idx].blinkwait := 700
									shape_table[l_idx].blinkon := 400
									shape_table[l_idx].blinkoff := 250
								end
							end
							l_p___0.ce_gets (l_colonp + 1)
							from
							until
								js.loop_left
							loop
								js.reset
								if (l_p___0.item).to_boolean then
									if (l_p___0.item).to_integer_32 = 44 then
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped then
									if a_what = 1 then
										l_i___0 := 0
										from
										until
											js.loop_left
										loop
											js.reset
											if ((mshape_names[l_i___0]).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
												if (l_p___0.item).to_integer_32 >= 48 then
													if not ((l_p___0.item).to_integer_32 <= 57) then
														Result := (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E547: Illegal mouseshape")))
														js.return
													end
												else
													Result := (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E547: Illegal mouseshape")))
													js.return
												end
												if not js.return_called then
													if l_round = 2 then
														shape_table[l_idx].mshape := ((charset_inst.getdigits (l_p___0.address)) + 1000).to_integer_32
													else
														charset_inst.getdigits (l_p___0.address).do_nothing
													end
													js.break
												end
											end
											if not js.loop_jumped then
												l_len := (strlen (mshape_names[l_i___0])).to_integer_32
												if (strncasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), mshape_names[l_i___0], l_len.to_natural_32)) = 0 then
													if l_round = 2 then
														shape_table[l_idx].mshape := l_i___0
													end
													l_p___0.ce_gets (l_p___0 + l_len)
													js.break
												end
											end
											if not js.loop_jumped then
												l_i___0 := l_i___0 + 1
											end
										end
										js.reset
									else
										l_i___0 := (l_p___0.item).to_integer_32
										l_len := 0
										if (strncasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), ce_string ("ver"), (3).to_natural_32)) = 0 then
											l_len := 3
										elseif (strncasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), ce_string ("hor"), (3).to_natural_32)) = 0 then
											l_len := 3
										elseif (strncasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), ce_string ("blinkwait"), (9).to_natural_32)) = 0 then
											l_len := 9
										elseif (strncasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), ce_string ("blinkon"), (7).to_natural_32)) = 0 then
											l_len := 7
										elseif (strncasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), ce_string ("blinkoff"), (8).to_natural_32)) = 0 then
											l_len := 8
										end
										if l_len /= 0 then
											l_p___0.ce_gets (l_p___0 + l_len)
											if (l_p___0.item).to_integer_32 >= 48 then
												if not ((l_p___0.item).to_integer_32 <= 57) then
													Result := (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E548: digit expected")))
													js.return
												end
											else
												Result := (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E548: digit expected")))
												js.return
											end
											if not js.return_called then
												l_n := charset_inst.getdigits (l_p___0.address)
												if l_len = 3 then
													if l_n = 0 then
														Result := (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E549: Illegal percentage")))
														js.return
													end
													if not js.return_called and then (l_round = 2) then
														if l_i___0 < 65 then
															l_tmp___10 := l_i___0
														elseif l_i___0 > 90 then
															l_tmp___10 := l_i___0
														else
															l_tmp___10 := l_i___0 + 32
														end
														if l_tmp___10 = 118 then
															shape_table[l_idx].shape := 2
														else
															shape_table[l_idx].shape := 1
														end
														shape_table[l_idx].percentage := l_n.to_integer_32
													end
												elseif l_round = 2 then
													if l_len = 9 then
														shape_table[l_idx].blinkwait := l_n
													elseif l_len = 7 then
														shape_table[l_idx].blinkon := l_n
													else
														shape_table[l_idx].blinkoff := l_n
													end
												end
											end
										elseif (strncasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), ce_string ("block"), (5).to_natural_32)) = 0 then
											if l_round = 2 then
												shape_table[l_idx].shape := 0
											end
											l_p___0.ce_gets (l_p___0 + (5))
										else
											l_endp.ce_gets (vim_strchr (l_p___0, ('-').code))
											if (l_commap.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
												if (l_endp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
													l_endp.ce_gets (l_p___0 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0))).to_integer_32)
												end
											elseif (l_endp.c_pointer.to_integer_32).to_natural_32 > (l_commap.c_pointer.to_integer_32).to_natural_32 then
												l_endp.ce_gets (l_commap)
											elseif (l_endp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
												l_endp.ce_gets (l_commap)
											end
											l_slashp.ce_gets (vim_strchr (l_p___0, ('/').code))
											if (l_slashp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
												if (l_slashp.c_pointer.to_integer_32).to_natural_32 < (l_endp.c_pointer.to_integer_32).to_natural_32 then
													l_i___0 := syntax_inst.syn_check_group (l_p___0, l_slashp.distance (l_p___0))
													l_p___0.ce_gets (l_slashp + 1)
												end
											end
											if l_round = 2 then
												shape_table[l_idx].id := syntax_inst.syn_check_group (l_p___0, l_endp.distance (l_p___0))
												shape_table[l_idx].id_lm := shape_table[l_idx].id
												if (l_slashp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
													if (l_slashp.c_pointer.to_integer_32).to_natural_32 < (l_endp.c_pointer.to_integer_32).to_natural_32 then
														shape_table[l_idx].id := l_i___0
													end
												end
											end
											l_p___0.ce_gets (l_endp)
										end
									end
									if not js.return_called and then ((l_p___0.item).to_integer_32 = 45) then
										l_p___0.ce_gets (l_p___0 + 1)
									end
								end
							end
							js.reset
						end
				when 15 then -- if done
						l_pos := -1 + 6 -- back to loop condition
				when 16 then -- loop done
						js.reset
				when 17 then -- if done
						if not js.return_called then
							l_modep.ce_gets (l_p___0)
							if (l_modep.item).to_integer_32 = 44 then
								l_modep.ce_gets (l_modep + 1)
							end
						end
						l_pos := -1 + 3 -- back to loop condition
				when 18 then -- loop done
						if not js.return_called then
							l_round := l_round + 1
						end
						l_pos := -1 + 1 -- back to loop condition
				when 19 then -- loop done
					if not js.return_called then
						if not l_found_ve.to_boolean then
							if a_what = 1 then
								shape_table[8].mshape := shape_table[1].mshape
							else
								shape_table[8].shape := shape_table[1].shape
								shape_table[8].percentage := shape_table[1].percentage
								shape_table[8].blinkwait := shape_table[1].blinkwait
								shape_table[8].blinkon := shape_table[1].blinkon
								shape_table[8].blinkoff := shape_table[1].blinkoff
								shape_table[8].id := shape_table[1].id
								shape_table[8].id_lm := shape_table[1].id_lm
							end
						end
						Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					end
				when 20 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_shape_idx (a_mouse: INTEGER_32): INTEGER_32
		local
			l_x___0: INTEGER_32
			l_y: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_mouse.to_boolean) then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if globals_inst.State /= 513 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if globals_inst.State /= 768 then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						gui_gtk_x11_inst.gui_mch_getmouse (create {CE_POINTER [INTEGER_32]}.make_shared ($l_x___0), create {CE_POINTER [INTEGER_32]}.make_shared ($l_y))
						if ((l_y - gui_inst.gui.border_offset) // gui_inst.gui.char_height).to_integer_32 = globals_inst.Rows - 1 then
							Result := 15
							js.return
						end
						if not js.return_called then
							Result := 14
							js.return
						end
				when 6 then -- if done | if done
						if not js.return_called and then (a_mouse.to_boolean) then
							if globals_inst.drag_status_line.to_boolean then
								Result := 11
								js.return
							end
						end
						if not js.return_called and then (a_mouse.to_boolean) then
							if globals_inst.drag_sep_line.to_boolean then
								Result := 13
								js.return
							end
						end
						if not js.return_called and then (not a_mouse.to_boolean) then
							if globals_inst.State = 1808 then
								Result := 16
								js.return
							end
						end
						if not js.return_called and then (((globals_inst.State).bit_and (128)).to_boolean) then
							Result := 3
							js.return
						end
						if not js.return_called and then (((globals_inst.State).bit_and (64)).to_boolean) then
							Result := 3
							js.return
						end
						if not js.return_called and then (((globals_inst.State).bit_and (16)).to_boolean) then
							Result := 2
							js.return
						end
						if not js.return_called and then (((globals_inst.State).bit_and (8)).to_boolean) then
							if (ex_getln_inst.cmdline_at_end).to_boolean then
								Result := 4
								js.return
							end
							if not js.return_called then
								if (ex_getln_inst.cmdline_overstrike).to_boolean then
									Result := 6
									js.return
								end
							end
							if not js.return_called then
								Result := 5
								js.return
							end
						end
						if not js.return_called and then (globals_inst.finish_op.to_boolean) then
							Result := 7
							js.return
						end
						if not js.return_called and then (globals_inst.VIsual_active.to_boolean) then
							if (option_inst.p_sel.item).to_integer_32 = 101 then
								Result := 8
								js.return
							else
								Result := 1
								js.return
							end
						end
						if not js.return_called then
							Result := 0
						end
				when 7 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	update_mouseshape (a_shape_idx: INTEGER_32)
		local
			l_shape_idx: INTEGER_32
			l_new_mouse_shape: INTEGER_32
			js: JUMP_STATE
		do
			l_shape_idx := a_shape_idx
			if not (gui_inst.gui.in_use).to_boolean then
				js.return
			elseif (gui_inst.gui.starting).to_boolean then
				js.return
			end
			if not js.return_called and then (l_shape_idx = -1) then
				if (getchar_inst.char_avail).to_boolean then
					globals_inst.postponed_mouseshape := 1
					js.return
				end
			end
			if not js.return_called then
				if (option_inst.p_mouse.item).to_integer_32 = 0 then
					if l_shape_idx = 9 then
						l_shape_idx := -2
					elseif l_shape_idx = 10 then
						l_shape_idx := -2
					elseif l_shape_idx = 12 then
						l_shape_idx := -2
					end
				end
				if l_shape_idx = -2 then
					if old_mouse_shape /= shape_table[9].mshape then
						if old_mouse_shape /= shape_table[10].mshape then
							if old_mouse_shape /= shape_table[12].mshape then
								js.return
							end
						end
					end
				end
			end
			if not js.return_called then
				if l_shape_idx < 0 then
					l_new_mouse_shape := shape_table[(get_shape_idx (1))].mshape
				else
					l_new_mouse_shape := shape_table[l_shape_idx].mshape
				end
				if l_new_mouse_shape /= old_mouse_shape then
					gui_gtk_x11_inst.mch_set_mouse_shape (l_new_mouse_shape)
					old_mouse_shape := l_new_mouse_shape
				end
				globals_inst.postponed_mouseshape := 0
			end
		end

	make_crc_tab
		local
			l_s: NATURAL_32
			l_t: NATURAL_32
			l_v: NATURAL_32
			js: JUMP_STATE
		do
			if done___0.to_boolean then
				js.return
			end
			if not js.return_called then
				l_t := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_t < {NATURAL_32} 256))
				loop
					l_v := l_t
					l_s := (0).to_natural_32
					from
					until
						not (l_s < {NATURAL_32} 8)
					loop
						l_v := (((l_v).bit_shift_right (1))).bit_xor (((l_v).bit_and ({NATURAL_32} 1)) * {NATURAL_32} 3988292384)
						l_s := l_s + 1
					end
					crc_32_tab[l_t.to_integer_32] := l_v
					l_t := l_t + 1
				end
				done___0 := 1
			end
		end

	crypt_method_from_string (a_s: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_tmp: INTEGER_32
		do
			if (a_s.item).to_integer_32 = 98 then
				l_tmp := 1
			else
				l_tmp := 0
			end
			Result := l_tmp
		end

	get_crypt_method (a_buf___6: CE_POINTER [PD_FILE_BUFFER]): INTEGER_32
		local
			l_tmp: CE_POINTER [NATURAL_8]
		do
			create l_tmp.make

			if ((a_buf___6.item.b_p_cm).item).to_integer_32 = 0 then
				l_tmp.ce_gets (option_inst.p_cm)
			else
				l_tmp.ce_gets (a_buf___6.item.b_p_cm)
			end
			Result := (crypt_method_from_string (l_tmp))
		end

	set_crypt_method (a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_method: INTEGER_32)
		local
			l_tmp: CE_POINTER [INTEGER_8]
		do
			create l_tmp.make

			option_inst.free_string_option (a_buf___6.item.b_p_cm)
			if a_method = 0 then
				l_tmp.ce_gets (ce_string ("zip"))
			else
				l_tmp.ce_gets (ce_string ("blowfish"))
			end
			a_buf___6.item.b_p_cm := vim_strsave (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp))
		end

	crypt_push_state
		do
			if crypt_busy = 1 then
				if globals_inst.use_crypt_method = 0 then
					saved_keys[0] := keys[0]
					saved_keys[1] := keys[1]
					saved_keys[2] := keys[2]
				else
					blowfish_inst.bf_crypt_save
				end
				saved_crypt_method := globals_inst.use_crypt_method
			elseif crypt_busy > 1 then
				message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_intern2)))), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("crypt_push_state()"))).do_nothing
			end
			crypt_busy := crypt_busy + 1
		end

	crypt_pop_state
		do
			crypt_busy := crypt_busy - 1
			if crypt_busy = 1 then
				globals_inst.use_crypt_method := saved_crypt_method
				if globals_inst.use_crypt_method = 0 then
					keys[0] := saved_keys[0]
					keys[1] := saved_keys[1]
					keys[2] := saved_keys[2]
				else
					blowfish_inst.bf_crypt_restore
				end
			end
		end

	crypt_encode (a_from: CE_POINTER [NATURAL_8]; a_len: NATURAL_32; a_to: CE_POINTER [NATURAL_8])
		local
			l_i___0: NATURAL_32
			l_ztemp: INTEGER_32
			l_t: INTEGER_32
			l_temp: NATURAL_16
		do
			if globals_inst.use_crypt_method = 0 then
				l_i___0 := (0).to_natural_32
				from
				until
					not (l_i___0 < a_len)
				loop
					l_ztemp := (a_from[l_i___0.to_integer_32]).to_integer_32
					l_temp := ((((keys[2]).to_natural_16).to_integer_32).bit_or (2)).to_natural_16
					l_t := (((((l_temp.to_integer_32 * ((l_temp.to_integer_32).bit_xor (1))).to_natural_32).bit_shift_right (8))).bit_and ({NATURAL_32} 255)).to_integer_32
					keys[0] := (crc_32_tab[((((keys[0]).to_integer_32).bit_xor (l_ztemp))).bit_and (255)]).bit_xor (((keys[0]).bit_shift_right (8)))
					keys[1] := keys[1] + ((keys[0]).bit_and ({NATURAL_32} 255))
					keys[1] := keys[1] * {NATURAL_32} 134775813 + {NATURAL_32} 1
					keys[2] := (crc_32_tab[((((keys[2]).to_integer_32).bit_xor (((keys[1]).bit_shift_right (24)).to_integer_32))).bit_and (255)]).bit_xor (((keys[2]).bit_shift_right (8)))
					a_to[l_i___0.to_integer_32] := ((l_t).bit_xor (l_ztemp)).to_natural_8
					l_i___0 := l_i___0 + 1
				end
			else
				blowfish_inst.bf_crypt_encode (a_from, a_len, a_to)
			end
		end

	crypt_decode (a_ptr: CE_POINTER [NATURAL_8]; a_len: INTEGER_32)
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_temp: NATURAL_16
			l_tmp: NATURAL_8
		do
			create l_p___0.make

			if globals_inst.use_crypt_method = 0 then
				l_p___0.ce_gets (a_ptr)
				from
				until
					not ((l_p___0.c_pointer.to_integer_32).to_natural_32 < ((a_ptr + a_len).c_pointer.to_integer_32).to_natural_32)
				loop
					l_temp := ((((keys[2]).to_natural_16).to_integer_32).bit_or (2)).to_natural_16
					l_temp := (((((l_temp.to_integer_32 * ((l_temp.to_integer_32).bit_xor (1))).to_natural_32).bit_shift_right (8))).bit_and ({NATURAL_32} 255)).to_natural_16
					l_tmp := (((l_p___0.item).to_integer_32).bit_xor (l_temp.to_integer_32)).to_natural_8
					l_p___0.item := l_tmp
					keys[0] := (crc_32_tab[((((keys[0]).to_integer_32).bit_xor (l_tmp.to_integer_32))).bit_and (255)]).bit_xor (((keys[0]).bit_shift_right (8)))
					keys[1] := keys[1] + ((keys[0]).bit_and ({NATURAL_32} 255))
					keys[1] := keys[1] * {NATURAL_32} 134775813 + {NATURAL_32} 1
					keys[2] := (crc_32_tab[((((keys[2]).to_integer_32).bit_xor (((keys[1]).bit_shift_right (24)).to_integer_32))).bit_and (255)]).bit_xor (((keys[2]).bit_shift_right (8)))
					l_p___0.ce_gets (l_p___0 + 1)
				end
			else
				blowfish_inst.bf_crypt_decode (a_ptr, a_len)
			end
		end

	crypt_init_keys (a_passwd: CE_POINTER [NATURAL_8])
		local
			l_p___0: CE_POINTER [NATURAL_8]
		do
			create l_p___0.make

			if (a_passwd.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				if (a_passwd.item).to_integer_32 /= 0 then
					if globals_inst.use_crypt_method = 0 then
						make_crc_tab
						keys[0] := (305419896).to_natural_32
						keys[1] := (591751049).to_natural_32
						keys[2] := (878082192).to_natural_32
						l_p___0.ce_gets (a_passwd)
						from
						until
							(l_p___0.item).to_integer_32 = 0
						loop
							keys[0] := (crc_32_tab[((((keys[0]).to_integer_32).bit_xor ((l_p___0.item).to_integer_32))).bit_and (255)]).bit_xor (((keys[0]).bit_shift_right (8)))
							keys[1] := keys[1] + ((keys[0]).bit_and ({NATURAL_32} 255))
							keys[1] := keys[1] * {NATURAL_32} 134775813 + {NATURAL_32} 1
							keys[2] := (crc_32_tab[((((keys[2]).to_integer_32).bit_xor (((keys[1]).bit_shift_right (24)).to_integer_32))).bit_and (255)]).bit_xor (((keys[2]).bit_shift_right (8)))
							l_p___0.ce_gets (l_p___0 + 1)
						end
					else
						blowfish_inst.bf_crypt_init_keys (a_passwd)
					end
				end
			end
		end

	free_crypt_key (a_key: CE_POINTER [NATURAL_8])
		local
			l_p___0: CE_POINTER [NATURAL_8]
		do
			create l_p___0.make

			if (a_key.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				l_p___0.ce_gets (a_key)
				from
				until
					(l_p___0.item).to_integer_32 = 0
				loop
					l_p___0.item := (0).to_natural_8
					l_p___0.ce_gets (l_p___0 + 1)
				end
				vim_free (create {CE_POINTER [ANY]}.make_cast (a_key))
			end
		end

	get_crypt_key (a_store: INTEGER_32; a_twice: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_p1: CE_POINTER [NATURAL_8]
			l_p2: CE_POINTER [NATURAL_8]
			l_round: INTEGER_32
			l_tmp___1: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_p1.make
			create l_p2.make
			create l_tmp___1.make

			l_p2.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
			l_round := 0
			from
			until
				js.loop_left
			loop
				js.reset
				globals_inst.cmdline_star := 1
				globals_inst.cmdline_row := globals_inst.msg_row
				if l_round = 0 then
					l_tmp___1.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Enter encryption key: ")))))
				else
					l_tmp___1.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Enter same key again: ")))))
				end
				l_p1.ce_gets (ex_getln_inst.getcmdline_prompt (('%/0/').code, l_tmp___1, 0, 0, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)))
				globals_inst.cmdline_star := 0
				if (l_p1.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					js.break
				end
				if not js.loop_jumped and then (l_round = a_twice) then
					if (l_p2.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_p1), create {CE_POINTER [INTEGER_8]}.make_cast (l_p2))) /= 0 then
							message_inst.msg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Keys don%'t match!"))))).do_nothing
							free_crypt_key (l_p1)
							free_crypt_key (l_p2)
							l_p2.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							l_round := -1
							js.continue
						end
					end
					if not js.loop_jumped then
						if a_store.to_boolean then
							option_inst.set_option_value (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("key")), 0, l_p1, 4)
							free_crypt_key (l_p1)
							l_p1.ce_gets (globals_inst.curbuf.item.b_p_key)
						end
						js.break
					end
				end
				if not js.loop_jumped then
					l_p2.ce_gets (l_p1)
				end
				if not js.loop_left then
					l_round := l_round + 1
				end
			end
			js.reset
			if globals_inst.msg_didout.to_boolean then
				message_inst.msg_putchar (('%N').code)
			end
			globals_inst.need_wait_return := 0
			globals_inst.msg_didout := 0
			free_crypt_key (l_p2)
			Result := l_p1
		end

	vim_findfile_init (a_path: CE_POINTER [NATURAL_8]; a_filename: CE_POINTER [NATURAL_8]; a_stopdirs: CE_POINTER [NATURAL_8]; a_level: INTEGER_32; a_free_visited: INTEGER_32; a_find_what: INTEGER_32; a_search_ctx_arg: CE_POINTER [ANY]; a_tagfile: INTEGER_32; a_rel_fname: CE_POINTER [NATURAL_8]): CE_POINTER [ANY]
		local
			l_path: CE_POINTER [NATURAL_8]
			l_wc_part: CE_POINTER [NATURAL_8]
			l_sptr: CE_POINTER [PD_FF_STACK]
			l_search_ctx: CE_POINTER [PD_FF_SEARCH_CTX_T]
			l_len: INTEGER_32
			l_walker: CE_POINTER [NATURAL_8]
			l_dircount: INTEGER_32
			l_helper: CE_POINTER [NATURAL_8]
			l_ptr: CE_POINTER [ANY]
			l_llevel: INTEGER_32
			l_len___0: INTEGER_32
			l_errpt: CE_POINTER [INTEGER_8]
			l_tmp___8: INTEGER_32
			l_tmp___9: CE_POINTER [NATURAL_8]
			l_tmp___10: INTEGER_32
			l_tmp___11: CE_POINTER [NATURAL_8]
			l_tmp___13: INTEGER_32
			l_tmp___14: INTEGER_32
			l_tmp___17: INTEGER_32
			l_tmp___18: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_path.make
			create l_wc_part.make
			create l_sptr.make
			create l_search_ctx.make
			create l_walker.make
			create l_helper.make
			create l_ptr.make
			create l_errpt.make
			create l_tmp___9.make
			create l_tmp___11.make
			create l_tmp___18.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_path.ce_gets (a_path)
					if (a_search_ctx_arg.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_search_ctx.ce_gets (create {CE_POINTER [PD_FF_SEARCH_CTX_T]}.make_cast (a_search_ctx_arg))
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						l_search_ctx.ce_gets (create {CE_POINTER [PD_FF_SEARCH_CTX_T]}.make_cast ((alloc ({PD_FF_SEARCH_CTX_T}.sizeof.to_natural_32))))
						if (l_search_ctx.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 57 -- goto error_return
						end
				when 4 then
						memset (create {CE_POINTER [ANY]}.make_cast (l_search_ctx), 0, {PD_FF_SEARCH_CTX_T}.sizeof.to_natural_32).do_nothing
				when 5 then -- if done
					l_search_ctx.item.ffsc_find_what := a_find_what
					l_search_ctx.item.ffsc_tagfile := a_tagfile
					ff_clear (l_search_ctx)
					if a_free_visited /= 1 then
						l_pos := -1 + 8 -- skip if block
					end
				when 6 then -- if:
						vim_findfile_free_visited (create {CE_POINTER [ANY]}.make_cast (l_search_ctx))
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 8 then -- else:
						l_search_ctx.item.ffsc_visited_list := ff_get_visited_list (a_filename, create {CE_POINTER [CE_POINTER [PD_FF_VISITED_LIST_HDR]]}.make_shared (l_search_ctx.c_pointer + {PD_FF_SEARCH_CTX_T}.ffsc_visited_lists_list_offset))
						if ((l_search_ctx.item.ffsc_visited_list).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 57 -- goto error_return
						end
				when 9 then
						l_search_ctx.item.ffsc_dir_visited_list := ff_get_visited_list (a_filename, create {CE_POINTER [CE_POINTER [PD_FF_VISITED_LIST_HDR]]}.make_shared (l_search_ctx.c_pointer + {PD_FF_SEARCH_CTX_T}.ffsc_dir_visited_lists_list_offset))
						if ((l_search_ctx.item.ffsc_dir_visited_list).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 57 -- goto error_return
						end
				when 10 then
					if (ff_expand_buffer.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						ff_expand_buffer.ce_gets ((alloc ({NATURAL_32} 4096)))
						if (ff_expand_buffer.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 57 -- goto error_return
						end
					end
				when 11 then
					if (l_path[0]).to_integer_32 /= 46 then
						l_pos := -1 + 30 -- skip if block
					end
				when 12 then -- if:
						if not ((misc1_inst.vim_ispathsep ((l_path[1]).to_integer_32)).to_boolean) then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						l_pos := -1 + 16 -- goto _L___4
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 15 then -- else:
						if (l_path[1]).to_integer_32 /= 0 then
							l_pos := -1 + 28 -- skip if block
						end
				when 16 then -- if: | _L___4:
						if a_tagfile.to_boolean then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						l_pos := -1 + 20 -- goto _L___2
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 19 then -- else:
						if ((vim_strchr (option_inst.p_cpo, ('d').code)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_pos := -1 + 26 -- skip if block
						end
				when 20 then -- if: | _L___2:
						if (a_rel_fname.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 24 -- skip if block
						end
				when 21 then -- if:
						l_len := (misc1_inst.gettail (a_rel_fname)).distance (a_rel_fname)
						if (window_inst.vim_isAbsName (a_rel_fname)).to_boolean then
							l_search_ctx.item.ffsc_start_dir := vim_strnsave (a_rel_fname, l_len)
						elseif l_len + 1 < 4096 then
							vim_strncpy (ff_expand_buffer, a_rel_fname, l_len.to_natural_32)
							l_search_ctx.item.ffsc_start_dir := misc1_inst.FullName_save (ff_expand_buffer, 0)
						else
							l_search_ctx.item.ffsc_start_dir := vim_strnsave (a_rel_fname, l_len)
						end
						if ((l_search_ctx.item.ffsc_start_dir).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 57 -- goto error_return
						end
				when 22 then
						l_path.ce_gets (l_path + 1)
						if (l_path.item).to_integer_32 /= 0 then
							l_path.ce_gets (l_path + 1)
						end
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 24 then -- else:
						l_pos := -1 + 30 -- goto _L___3
				when 25 then -- if done | if block done, skip else block:
						l_pos := -1 + 27
				when 26 then -- else:
						l_pos := -1 + 30 -- goto _L___3
				when 27 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 29
				when 28 then -- else:
						l_pos := -1 + 30 -- goto _L___3
				when 29 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 36
				when 30 then -- else: | _L___3:
						if (l_path.item).to_integer_32 /= 0 then
							l_pos := -1 + 33 -- skip if block
						end
				when 31 then -- if:
						l_pos := -1 + 34 -- goto _L
				when 32 then -- if block done, skip else block:
						l_pos := -1 + 36
				when 33 then -- else:
						if (window_inst.vim_isAbsName (l_path)).to_boolean then
							l_pos := -1 + 36 -- skip if block
						end
				when 34 then -- if: | _L:
						if (os_unix_inst.mch_dirname (ff_expand_buffer, 4096)) = 0 then
							l_pos := -1 + 57 -- goto error_return
						end
				when 35 then
						l_search_ctx.item.ffsc_start_dir := vim_strsave (ff_expand_buffer)
						if ((l_search_ctx.item.ffsc_start_dir).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 57 -- goto error_return
						end
				when 36 then -- if done | if done
						if (a_stopdirs.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_walker.ce_gets (a_stopdirs)
							from
							until
								(l_walker.item).to_integer_32 /= 59
							loop
								l_walker.ce_gets (l_walker + 1)
							end
							l_dircount := 1
							l_search_ctx.item.ffsc_stopdirs_v := create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast ((alloc (Pointer_bytes.to_natural_32)))
							if ((l_search_ctx.item.ffsc_stopdirs_v).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								from
								until
									js.loop_left
								loop
									js.reset
									l_helper.ce_gets (l_walker)
									l_ptr.ce_gets (realloc (create {CE_POINTER [ANY]}.make_cast (l_search_ctx.item.ffsc_stopdirs_v), (l_dircount + 1).to_natural_32 * Pointer_bytes.to_natural_32))
									if ((l_ptr).c_pointer /= default_pointer) then
										l_search_ctx.item.ffsc_stopdirs_v := create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast (l_ptr)
									else
										js.break
									end
									if not js.loop_jumped then
										l_walker.ce_gets (vim_strchr (l_walker, (';').code))
										if ((l_walker).c_pointer /= default_pointer) then
											l_search_ctx.item.ffsc_stopdirs_v[(l_dircount - 1)] := vim_strnsave (l_helper, l_walker.distance (l_helper))
											l_walker.ce_gets (l_walker + 1)
										else
											l_search_ctx.item.ffsc_stopdirs_v[(l_dircount - 1)] := vim_strsave (l_helper)
										end
										l_dircount := l_dircount + 1
										if (l_walker.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
											js.break
										end
									end
								end
								js.reset
								l_search_ctx.item.ffsc_stopdirs_v[(l_dircount - 1)] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
							end
						end
						l_search_ctx.item.ffsc_level := a_level
						l_wc_part.ce_gets (vim_strchr (l_path, ('*').code))
						if (l_wc_part.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 50 -- skip if block
						end
				when 37 then -- if:
							l_search_ctx.item.ffsc_fix_path := vim_strnsave (l_path, l_wc_part.distance (l_path))
							l_len___0 := 0
				when 38 then -- loop condition:
							if (l_wc_part.item).to_integer_32 = 0 then
								l_pos := -1 + 48 -- skip loop
							end
				when 39 then -- loop body:
							if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_wc_part), ce_string ("**"), (2).to_natural_32)) /= 0 then
								l_pos := -1 + 46 -- skip if block
							end
				when 40 then -- if:
							l_tmp___8 := l_len___0
							l_len___0 := l_len___0 + 1
							l_tmp___9.ce_gets (l_wc_part)
							l_wc_part.ce_gets (l_wc_part + 1)
							ff_expand_buffer[l_tmp___8] := l_tmp___9.item
							l_tmp___10 := l_len___0
							l_len___0 := l_len___0 + 1
							l_tmp___11.ce_gets (l_wc_part)
							l_wc_part.ce_gets (l_wc_part + 1)
							ff_expand_buffer[l_tmp___10] := l_tmp___11.item
							l_llevel := (strtol (create {CE_POINTER [INTEGER_8]}.make_cast (l_wc_part), (l_errpt.address), 10)).to_integer_32
							if (l_errpt.c_pointer.to_integer_32).to_natural_32 = (l_wc_part.c_pointer.to_integer_32).to_natural_32 then
								l_pos := -1 + 43 -- skip if block
							end
				when 41 then -- if:
							if l_llevel > 0 then
								if l_llevel < 255 then
									l_tmp___13 := l_len___0
									l_len___0 := l_len___0 + 1
									ff_expand_buffer[l_tmp___13] := l_llevel.to_natural_8
								else
									l_pos := -1 + 43 -- goto _L___6
								end
							else
								l_pos := -1 + 43 -- goto _L___6
							end
				when 42 then -- if block done, skip else block:
							l_pos := -1 + 44
				when 43 then -- else: | _L___6:
							if (l_errpt.c_pointer.to_integer_32).to_natural_32 /= (l_wc_part.c_pointer.to_integer_32).to_natural_32 then
								if l_llevel = 0 then
									l_len___0 := l_len___0 - (2)
								else
									l_tmp___14 := l_len___0
									l_len___0 := l_len___0 + 1
									ff_expand_buffer[l_tmp___14] := (30).to_natural_8
								end
							else
								l_tmp___14 := l_len___0
								l_len___0 := l_len___0 + 1
								ff_expand_buffer[l_tmp___14] := (30).to_natural_8
							end
				when 44 then
							l_wc_part.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (l_errpt))
							if (l_wc_part.item).to_integer_32 /= 0 then
								if not (misc1_inst.vim_ispathsep ((l_wc_part.item).to_integer_32)).to_boolean then
									message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E343: Invalid path: %'**[number]%' must be at the end of the path or be followed by %'%%s%'.")))), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("/"))).do_nothing
									l_pos := -1 + 57 -- goto error_return
								end
							end
				when 45 then -- if block done, skip else block:
							l_pos := -1 + 47
				when 46 then -- else:
							l_tmp___17 := l_len___0
							l_len___0 := l_len___0 + 1
							l_tmp___18.ce_gets (l_wc_part)
							l_wc_part.ce_gets (l_wc_part + 1)
							ff_expand_buffer[l_tmp___17] := l_tmp___18.item
				when 47 then
							l_pos := -1 + 38 -- back to loop condition
				when 48 then -- loop done
							ff_expand_buffer[l_len___0] := (('%/0/').code).to_natural_8
							l_search_ctx.item.ffsc_wc_path := vim_strsave (ff_expand_buffer)
							if ((l_search_ctx.item.ffsc_wc_path).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								l_pos := -1 + 57 -- goto error_return
							end
				when 49 then -- if block done, skip else block:
							l_pos := -1 + 51
				when 50 then -- else:
							l_search_ctx.item.ffsc_fix_path := vim_strsave (l_path)
				when 51 then
						if ((l_search_ctx.item.ffsc_start_dir).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_pos := -1 + 54 -- skip if block
						end
				when 52 then -- if:
							l_search_ctx.item.ffsc_start_dir := vim_strsave (l_search_ctx.item.ffsc_fix_path)
							if ((l_search_ctx.item.ffsc_start_dir).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								l_pos := -1 + 57 -- goto error_return
							end
				when 53 then
							l_search_ctx.item.ffsc_fix_path[0] := (('%/0/').code).to_natural_8
				when 54 then -- if done
						strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (ff_expand_buffer), create {CE_POINTER [INTEGER_8]}.make_cast (l_search_ctx.item.ffsc_start_dir)).do_nothing
						misc1_inst.add_pathsep (ff_expand_buffer)
						strcat (create {CE_POINTER [INTEGER_8]}.make_cast (ff_expand_buffer), create {CE_POINTER [INTEGER_8]}.make_cast (l_search_ctx.item.ffsc_fix_path)).do_nothing
						misc1_inst.add_pathsep (ff_expand_buffer)
						l_sptr.ce_gets (ff_create_stack_element (ff_expand_buffer, l_search_ctx.item.ffsc_wc_path, a_level, 0))
						if (l_sptr.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 57 -- goto error_return
						end
				when 55 then
						ff_push (l_search_ctx, l_sptr)
						l_search_ctx.item.ffsc_file_to_search := vim_strsave (a_filename)
						if ((l_search_ctx.item.ffsc_file_to_search).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 57 -- goto error_return
						end
				when 56 then
						Result := (create {CE_POINTER [ANY]}.make_cast (l_search_ctx))
						js.return
						if js.return_called then
							l_pos := -1 + 58 -- skip if block
						end
				when 57 then -- if: | error_return:
							vim_findfile_cleanup (create {CE_POINTER [ANY]}.make_cast (l_search_ctx))
							Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
				when 58 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	vim_findfile_stopdir (a_buf___6: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_r_ptr: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_r_ptr.make

			l_r_ptr.ce_gets (a_buf___6)
			from
			until
				js.loop_left
			loop
				js.reset
				if (l_r_ptr.item).to_integer_32 /= 0 then
					if (l_r_ptr.item).to_integer_32 = 59 then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					if (l_r_ptr[0]).to_integer_32 = 92 then
						if (l_r_ptr[1]).to_integer_32 = 59 then
							memmove (create {CE_POINTER [ANY]}.make_cast (l_r_ptr), create {CE_POINTER [ANY]}.make_cast ((l_r_ptr + 1)), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((l_r_ptr + 1)))) + {NATURAL_32} 1).do_nothing
							l_r_ptr.ce_gets (l_r_ptr + 1)
						end
					end
					l_r_ptr.ce_gets (l_r_ptr + 1)
				end
			end
			js.reset
			if (l_r_ptr.item).to_integer_32 = 59 then
				l_r_ptr.item := (0).to_natural_8
				l_r_ptr.ce_gets (l_r_ptr + 1)
			elseif (l_r_ptr.item).to_integer_32 = 0 then
				l_r_ptr.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
			end
			Result := l_r_ptr
		end

	vim_findfile_cleanup (a_ctx: CE_POINTER [ANY])
		local
			js: JUMP_STATE
		do
			if (a_ctx.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				js.return
			end
			if not js.return_called then
				vim_findfile_free_visited (a_ctx)
				ff_clear (create {CE_POINTER [PD_FF_SEARCH_CTX_T]}.make_cast (a_ctx))
				vim_free (a_ctx)
			end
		end

	vim_findfile (a_search_ctx_arg: CE_POINTER [ANY]): CE_POINTER [NATURAL_8]
		local
			l_file_path: CE_POINTER [NATURAL_8]
			l_rest_of_wildcards: CE_POINTER [NATURAL_8]
			l_path_end: CE_POINTER [NATURAL_8]
			l_stackp: CE_POINTER [PD_FF_STACK]
			l_len: INTEGER_32
			l_i___0: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_suf: CE_POINTER [NATURAL_8]
			l_search_ctx: CE_POINTER [PD_FF_SEARCH_CTX_T]
			l_dirptrs: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_tmp___3: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___7: CE_POINTER [NATURAL_8]
			l_tmp___11: CE_POINTER [NATURAL_8]
			l_tmp___12: INTEGER_32
			l_sptr: CE_POINTER [PD_FF_STACK]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_file_path.make
			create l_rest_of_wildcards.make
			create l_path_end.make
			create l_stackp.make
			create l_p___0.make
			create l_suf.make
			create l_search_ctx.make
			create l_dirptrs.make (<<2>>)
			create l_tmp___7.make
			create l_tmp___11.make
			create l_sptr.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_path_end.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					if (a_search_ctx_arg.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						js.return
					end
					if not js.return_called then
						l_search_ctx.ce_gets (create {CE_POINTER [PD_FF_SEARCH_CTX_T]}.make_cast (a_search_ctx_arg))
						l_file_path.ce_gets (alloc ({NATURAL_32} 4096))
						if (l_file_path.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 32 -- skip if block
					end
				when 1 then -- if:
						if ((l_search_ctx.item.ffsc_start_dir).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_path_end.ce_gets (l_search_ctx.item.ffsc_start_dir + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_search_ctx.item.ffsc_start_dir))).to_integer_32)
						end
				when 2 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 31 -- skip loop
						end
				when 3 then -- loop body:
						js.reset
				when 4 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 30 -- skip loop
						end
				when 5 then -- loop body:
						js.reset
						ui_inst.ui_breakcheck
						if globals_inst.got_int.to_boolean then
							js.break
						end
						if not js.loop_jumped then
							l_stackp.ce_gets (ff_pop (l_search_ctx))
							if (l_stackp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								js.break
							end
						end
						if not js.loop_jumped and then (((l_stackp.item.ffs_filearray).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32) then
							if (ff_check_visited (create {CE_POINTER [CE_POINTER [PD_FF_VISITED]]}.make_shared ((l_search_ctx.item.ffsc_dir_visited_list).c_pointer + {PD_FF_VISITED_LIST_HDR}.ffvl_visited_list_offset), l_stackp.item.ffs_fix_path, l_stackp.item.ffs_wc_path)) = 0 then
								ff_free_stack_element (l_stackp)
								js.continue
							end
						end
						if not js.loop_jumped and then (l_stackp.item.ffs_level <= 0) then
							ff_free_stack_element (l_stackp)
							js.continue
						end
						if js.loop_jumped then
							l_pos := -1 + 29 -- skip if block
						end
				when 6 then -- if:
						l_file_path[0] := (('%/0/').code).to_natural_8
						if ((l_stackp.item.ffs_filearray).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_dirptrs[0] := l_file_path
							l_dirptrs[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
							if not (window_inst.vim_isAbsName (l_stackp.item.ffs_fix_path)).to_boolean then
								if ((l_search_ctx.item.ffsc_start_dir).c_pointer /= default_pointer) then
									strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_file_path), create {CE_POINTER [INTEGER_8]}.make_cast (l_search_ctx.item.ffsc_start_dir)).do_nothing
									misc1_inst.add_pathsep (l_file_path)
								end
							end
							strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_file_path), create {CE_POINTER [INTEGER_8]}.make_cast (l_stackp.item.ffs_fix_path)).do_nothing
							misc1_inst.add_pathsep (l_file_path)
							l_rest_of_wildcards.ce_gets (l_stackp.item.ffs_wc_path)
							if (l_rest_of_wildcards.item).to_integer_32 /= 0 then
								l_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_file_path))).to_integer_32
								if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_rest_of_wildcards), ce_string ("**"), (2).to_natural_32)) = 0 then
									l_p___0.ce_gets (l_rest_of_wildcards + 2)
									if (l_p___0.item).to_integer_32 > 0 then
										l_p___0.item := ((l_p___0.item).to_integer_32 - 1).to_natural_8
										l_tmp___3 := l_len
										l_len := l_len + 1
										l_file_path[l_tmp___3] := (('*').code).to_natural_8
									end
									if (l_p___0.item).to_integer_32 = 0 then
										memmove (create {CE_POINTER [ANY]}.make_cast (l_rest_of_wildcards), create {CE_POINTER [ANY]}.make_cast ((l_rest_of_wildcards + 3)), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((l_rest_of_wildcards + 3)))) + {NATURAL_32} 1).do_nothing
									else
										l_rest_of_wildcards.ce_gets (l_rest_of_wildcards + (3))
									end
									if l_stackp.item.ffs_star_star_empty = 0 then
										l_stackp.item.ffs_star_star_empty := 1
										l_dirptrs[1] := l_stackp.item.ffs_fix_path
									end
								end
								from
								until
									js.loop_left
								loop
									js.reset
									if (l_rest_of_wildcards.item).to_boolean then
										if (misc1_inst.vim_ispathsep ((l_rest_of_wildcards.item).to_integer_32)).to_boolean then
											js.break
										end
									else
										js.break
									end
									if not js.loop_jumped then
										l_tmp___6 := l_len
										l_len := l_len + 1
										l_tmp___7.ce_gets (l_rest_of_wildcards)
										l_rest_of_wildcards.ce_gets (l_rest_of_wildcards + 1)
										l_file_path[l_tmp___6] := l_tmp___7.item
									end
								end
								js.reset
								l_file_path[l_len] := (('%/0/').code).to_natural_8
								if (misc1_inst.vim_ispathsep ((l_rest_of_wildcards.item).to_integer_32)).to_boolean then
									l_rest_of_wildcards.ce_gets (l_rest_of_wildcards + 1)
								end
							end
							if (window_inst.path_with_url (l_dirptrs[0])).to_boolean then
								l_stackp.item.ffs_filearray := create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast ((alloc (Pointer_bytes.to_natural_32)))
								if ((l_stackp.item.ffs_filearray).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									l_tmp___11.ce_gets (vim_strsave (l_dirptrs[0]))
									l_stackp.item.ffs_filearray[0] := l_tmp___11
									if (l_tmp___11.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
										l_stackp.item.ffs_filearray_size := 1
									else
										l_stackp.item.ffs_filearray_size := 0
									end
								else
									l_stackp.item.ffs_filearray_size := 0
								end
							else
								if ((l_dirptrs[1]).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
									l_tmp___12 := 1
								else
									l_tmp___12 := 2
								end
								misc1_inst.expand_wildcards (l_tmp___12, l_dirptrs, create {CE_POINTER [INTEGER_32]}.make_shared (l_stackp.c_pointer + {PD_FF_STACK}.ffs_filearray_size_offset), create {CE_POINTER [CE_POINTER [CE_POINTER [NATURAL_8]]]}.make_shared (l_stackp.c_pointer + {PD_FF_STACK}.ffs_filearray_offset), 41).do_nothing
							end
							l_stackp.item.ffs_filearray_cur := (0).to_natural_8
							l_stackp.item.ffs_stage := 0
						else
							l_rest_of_wildcards.ce_gets (l_stackp.item.ffs_wc_path + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_stackp.item.ffs_wc_path))).to_integer_32)
						end
						if l_stackp.item.ffs_stage /= 0 then
							l_pos := -1 + 28 -- skip if block
						end
				when 7 then -- if:
						if (l_rest_of_wildcards.item).to_integer_32 /= 0 then
							l_pos := -1 + 26 -- skip if block
						end
				when 8 then -- if:
						l_i___0 := (l_stackp.item.ffs_filearray_cur).to_integer_32
				when 9 then -- loop condition:
						if not (not js.loop_left and then (l_i___0 < l_stackp.item.ffs_filearray_size)) then
							l_pos := -1 + 25 -- skip loop
						end
				when 10 then -- loop body:
						js.reset
						if not (window_inst.path_with_url (l_stackp.item.ffs_filearray[l_i___0])).to_boolean then
							if not (os_unix_inst.mch_isdir (l_stackp.item.ffs_filearray[l_i___0])).to_boolean then
								js.continue
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 24 -- skip if block
						end
				when 11 then -- if:
						strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_file_path), create {CE_POINTER [INTEGER_8]}.make_cast (l_stackp.item.ffs_filearray[l_i___0])).do_nothing
						misc1_inst.add_pathsep (l_file_path)
						strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_file_path), create {CE_POINTER [INTEGER_8]}.make_cast (l_search_ctx.item.ffsc_file_to_search)).do_nothing
						l_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_file_path))).to_integer_32
						if (l_search_ctx.item.ffsc_tagfile).to_boolean then
							l_suf.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")))
						else
							l_suf.ce_gets (globals_inst.curbuf.item.b_p_sua)
						end
				when 12 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 23 -- skip loop
						end
				when 13 then -- loop body:
						js.reset
						if not ((window_inst.path_with_url (l_file_path)).to_boolean) then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_pos := -1 + 21 -- goto _L___0
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 16 then -- else:
						if not ((os_unix_inst.mch_getperm (l_file_path)) >= 0) then
							l_pos := -1 + 22 -- skip if block
						end
				when 17 then -- if:
						if l_search_ctx.item.ffsc_find_what /= 2 then
							l_pos := -1 + 20 -- skip if block
						end
				when 18 then -- if:
						l_pos := -1 + 21 -- goto _L___0
				when 19 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 20 then -- else:
						if (l_search_ctx.item.ffsc_find_what = 1) /= (os_unix_inst.mch_isdir (l_file_path)).to_boolean then
							l_pos := -1 + 22 -- skip if block
						end
				when 21 then -- if: | _L___0:
						if (ff_check_visited (create {CE_POINTER [CE_POINTER [PD_FF_VISITED]]}.make_shared ((l_search_ctx.item.ffsc_visited_list).c_pointer + {PD_FF_VISITED_LIST_HDR}.ffvl_visited_list_offset), l_file_path, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")))) = 1 then
							l_stackp.item.ffs_filearray_cur := (l_i___0 + 1).to_natural_8
							ff_push (l_search_ctx, l_stackp)
							if not (window_inst.path_with_url (l_file_path)).to_boolean then
								tag_inst.simplify_filename (l_file_path)
							end
							if (os_unix_inst.mch_dirname (ff_expand_buffer, 4096)) = 1 then
								l_p___0.ce_gets (fileio_inst.shorten_fname (l_file_path, ff_expand_buffer))
								if (l_p___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									memmove (create {CE_POINTER [ANY]}.make_cast (l_file_path), create {CE_POINTER [ANY]}.make_cast (l_p___0), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0))) + {NATURAL_32} 1).do_nothing
								end
							end
							Result := l_file_path
							js.return
						end
				when 22 then -- if done | if done | if done
						if not js.return_called then
							if (l_suf.item).to_integer_32 = 0 then
								js.break
							end
							if not js.loop_jumped then
								copy_option_part (l_suf.address, l_file_path + l_len, 4096 - l_len, ce_string (",")).do_nothing
							end
						end
						l_pos := -1 + 12 -- back to loop condition
				when 23 then -- loop done
						js.reset
				when 24 then -- if done
						if not js.loop_left then
							l_i___0 := l_i___0 + 1
						end
						l_pos := -1 + 9 -- back to loop condition
				when 25 then -- loop done | if block done, skip else block:
						l_pos := -1 + 27
				when 26 then -- else:
						l_i___0 := (l_stackp.item.ffs_filearray_cur).to_integer_32
						from
						until
							not (l_i___0 < l_stackp.item.ffs_filearray_size)
						loop
							js.reset
							if not (os_unix_inst.mch_isdir (l_stackp.item.ffs_filearray[l_i___0])).to_boolean then
								js.continue
							end
							if not js.loop_jumped then
								ff_push (l_search_ctx, (ff_create_stack_element (l_stackp.item.ffs_filearray[l_i___0], l_rest_of_wildcards, l_stackp.item.ffs_level - 1, 0)))
							end
							l_i___0 := l_i___0 + 1
						end
				when 27 then -- if done
						if not js.return_called then
							l_stackp.item.ffs_filearray_cur := (0).to_natural_8
							l_stackp.item.ffs_stage := 1
						end
				when 28 then -- if done
						if not js.return_called then
							if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_stackp.item.ffs_wc_path), ce_string ("**"), (2).to_natural_32)) = 0 then
								l_i___0 := (l_stackp.item.ffs_filearray_cur).to_integer_32
								from
								until
									not (l_i___0 < l_stackp.item.ffs_filearray_size)
								loop
									js.reset
									if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_stackp.item.ffs_filearray[l_i___0]), create {CE_POINTER [INTEGER_8]}.make_cast (l_stackp.item.ffs_fix_path))) = 0 then
										js.continue
									end
									if not js.loop_jumped then
										if not (os_unix_inst.mch_isdir (l_stackp.item.ffs_filearray[l_i___0])).to_boolean then
											js.continue
										end
									end
									if not js.loop_jumped then
										ff_push (l_search_ctx, (ff_create_stack_element (l_stackp.item.ffs_filearray[l_i___0], l_stackp.item.ffs_wc_path, l_stackp.item.ffs_level - 1, 1)))
									end
									l_i___0 := l_i___0 + 1
								end
							end
							ff_free_stack_element (l_stackp)
						end
				when 29 then -- if done
						if not js.loop_left then
							
						end
						l_pos := -1 + 4 -- back to loop condition
				when 30 then -- loop done
						js.reset
						if not js.return_called then
							if ((l_search_ctx.item.ffsc_start_dir).c_pointer /= default_pointer) then
								if ((l_search_ctx.item.ffsc_stopdirs_v).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									if not globals_inst.got_int.to_boolean then
										if (ff_path_in_stoplist (l_search_ctx.item.ffsc_start_dir, l_path_end.distance ((l_search_ctx.item.ffsc_start_dir)), l_search_ctx.item.ffsc_stopdirs_v)) = 1 then
											js.break
										end
										if not js.loop_jumped then
											from
											until
												js.loop_left
											loop
												js.reset
												if (l_path_end.c_pointer.to_integer_32).to_natural_32 > ((l_search_ctx.item.ffsc_start_dir).c_pointer.to_integer_32).to_natural_32 then
													if not (misc1_inst.vim_ispathsep ((l_path_end.item).to_integer_32)).to_boolean then
														js.break
													end
												else
													js.break
												end
												if not js.loop_jumped then
													l_path_end.ce_gets (l_path_end - 1)
												end
											end
											js.reset
											from
											until
												js.loop_left
											loop
												js.reset
												if (l_path_end.c_pointer.to_integer_32).to_natural_32 > ((l_search_ctx.item.ffsc_start_dir).c_pointer.to_integer_32).to_natural_32 then
													if (misc1_inst.vim_ispathsep ((l_path_end[-1]).to_integer_32)).to_boolean then
														js.break
													end
												else
													js.break
												end
												if not js.loop_jumped then
													l_path_end.ce_gets (l_path_end - 1)
												end
											end
											js.reset
											l_path_end.item := (0).to_natural_8
											l_path_end.ce_gets (l_path_end - 1)
											if ((l_search_ctx.item.ffsc_start_dir).item).to_integer_32 = 0 then
												js.break
											end
										end
										if not js.loop_jumped then
											strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_file_path), create {CE_POINTER [INTEGER_8]}.make_cast (l_search_ctx.item.ffsc_start_dir)).do_nothing
											misc1_inst.add_pathsep (l_file_path)
											strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_file_path), create {CE_POINTER [INTEGER_8]}.make_cast (l_search_ctx.item.ffsc_fix_path)).do_nothing
											l_sptr.ce_gets (ff_create_stack_element (l_file_path, l_search_ctx.item.ffsc_wc_path, l_search_ctx.item.ffsc_level, 0))
											if (l_sptr.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
												js.break
											end
										end
										if not js.loop_jumped then
											ff_push (l_search_ctx, l_sptr)
										end
									else
										js.break
									end
								else
									js.break
								end
							else
								js.break
							end
						end
						l_pos := -1 + 2 -- back to loop condition
				when 31 then -- loop done
						js.reset
				when 32 then -- if done
					if not js.return_called then
						vim_free (create {CE_POINTER [ANY]}.make_cast (l_file_path))
						Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					end
				when 33 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	vim_findfile_free_visited (a_search_ctx_arg: CE_POINTER [ANY])
		local
			l_search_ctx: CE_POINTER [PD_FF_SEARCH_CTX_T]
			js: JUMP_STATE
		do
			create l_search_ctx.make

			if (a_search_ctx_arg.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				js.return
			end
			if not js.return_called then
				l_search_ctx.ce_gets (create {CE_POINTER [PD_FF_SEARCH_CTX_T]}.make_cast (a_search_ctx_arg))
				vim_findfile_free_visited_list (create {CE_POINTER [CE_POINTER [PD_FF_VISITED_LIST_HDR]]}.make_shared (l_search_ctx.c_pointer + {PD_FF_SEARCH_CTX_T}.ffsc_visited_lists_list_offset))
				vim_findfile_free_visited_list (create {CE_POINTER [CE_POINTER [PD_FF_VISITED_LIST_HDR]]}.make_shared (l_search_ctx.c_pointer + {PD_FF_SEARCH_CTX_T}.ffsc_dir_visited_lists_list_offset))
			end
		end

	vim_findfile_free_visited_list (a_list_headp: CE_POINTER [CE_POINTER [PD_FF_VISITED_LIST_HDR]])
		local
			l_vp: CE_POINTER [PD_FF_VISITED_LIST_HDR]
		do
			create l_vp.make

			from
			until
				((a_list_headp.item).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32
			loop
				l_vp.ce_gets ((a_list_headp.item).item.ffvl_next)
				ff_free_visited_list ((a_list_headp.item).item.ffvl_visited_list)
				vim_free (create {CE_POINTER [ANY]}.make_cast ((a_list_headp.item).item.ffvl_filename))
				vim_free (create {CE_POINTER [ANY]}.make_cast (a_list_headp.item))
				a_list_headp.item := l_vp
			end
			a_list_headp.item := create {CE_POINTER [PD_FF_VISITED_LIST_HDR]}.make_shared (default_pointer)
		end

	ff_free_visited_list (a_vl: CE_POINTER [PD_FF_VISITED])
		local
			l_vl: CE_POINTER [PD_FF_VISITED]
			l_vp: CE_POINTER [PD_FF_VISITED]
		do
			create l_vl.make
			create l_vp.make

			l_vl.ce_gets (a_vl)
			from
			until
				(l_vl.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32
			loop
				l_vp.ce_gets (l_vl.item.ffv_next)
				vim_free (create {CE_POINTER [ANY]}.make_cast (l_vl.item.ffv_wc_path))
				vim_free (create {CE_POINTER [ANY]}.make_cast (l_vl))
				l_vl.ce_gets (l_vp)
			end
			l_vl.ce_gets (create {CE_POINTER [PD_FF_VISITED]}.make_shared (default_pointer))
		end

	ff_get_visited_list (a_filename: CE_POINTER [NATURAL_8]; a_list_headp: CE_POINTER [CE_POINTER [PD_FF_VISITED_LIST_HDR]]): CE_POINTER [PD_FF_VISITED_LIST_HDR]
		local
			l_retptr: CE_POINTER [PD_FF_VISITED_LIST_HDR]
			js: JUMP_STATE
		do
			create l_retptr.make

			l_retptr.ce_gets (create {CE_POINTER [PD_FF_VISITED_LIST_HDR]}.make_shared (default_pointer))
			if ((a_list_headp.item).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				l_retptr.ce_gets (a_list_headp.item)
				from
				until
					not (not js.loop_left and then ((l_retptr.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32))
				loop
					if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_filename), create {CE_POINTER [INTEGER_8]}.make_cast (l_retptr.item.ffvl_filename))) = 0 then
						Result := l_retptr
						js.return
					end
					if not js.return_called then
						l_retptr.ce_gets (l_retptr.item.ffvl_next)
					end
				end
			end
			if not js.return_called then
				l_retptr.ce_gets (create {CE_POINTER [PD_FF_VISITED_LIST_HDR]}.make_cast ((alloc ({PD_FF_VISITED_LIST_HDR}.sizeof.to_natural_32))))
				if (l_retptr.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					Result := (create {CE_POINTER [PD_FF_VISITED_LIST_HDR]}.make_shared (default_pointer))
					js.return
				end
			end
			if not js.return_called then
				l_retptr.item.ffvl_visited_list := create {CE_POINTER [PD_FF_VISITED]}.make_shared (default_pointer)
				l_retptr.item.ffvl_filename := vim_strsave (a_filename)
				if ((l_retptr.item.ffvl_filename).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					vim_free (create {CE_POINTER [ANY]}.make_cast (l_retptr))
					Result := (create {CE_POINTER [PD_FF_VISITED_LIST_HDR]}.make_shared (default_pointer))
					js.return
				end
			end
			if not js.return_called then
				l_retptr.item.ffvl_next := a_list_headp.item
				a_list_headp.item := l_retptr
				Result := l_retptr
			end
		end

	ff_wc_equal (a_s1: CE_POINTER [NATURAL_8]; a_s2: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_tmp: NATURAL_32
			js: JUMP_STATE
		do
			if (a_s1.c_pointer.to_integer_32).to_natural_32 = (a_s2.c_pointer.to_integer_32).to_natural_32 then
				Result := 1
				js.return
			end
			if not js.return_called then
				if (a_s1.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					Result := 0
					js.return
				elseif (a_s2.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				l_tmp := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_s1))
				if l_tmp /= (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_s2))) then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				l_i___0 := 0
				from
				until
					js.loop_left
				loop
					js.reset
					if (a_s1[l_i___0]).to_integer_32 /= 0 then
						if (a_s2[l_i___0]).to_integer_32 = 0 then
							js.break
						end
					else
						js.break
					end
					if not js.loop_jumped and then ((a_s1[l_i___0]).to_integer_32 /= (a_s2[l_i___0]).to_integer_32) then
						if l_i___0 >= 2 then
							if (a_s1[(l_i___0 - 1)]).to_integer_32 = 42 then
								if (a_s1[(l_i___0 - 2)]).to_integer_32 = 42 then
									js.continue
								else
									Result := 0
									js.return
								end
							else
								Result := 0
								js.return
							end
						else
							Result := 0
							js.return
						end
					end
					if not js.loop_left then
						l_i___0 := l_i___0 + 1
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := 1
			end
		end

	ff_check_visited (a_visited_list: CE_POINTER [CE_POINTER [PD_FF_VISITED]]; a_fname: CE_POINTER [NATURAL_8]; a_wc_path: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_vp: CE_POINTER [PD_FF_VISITED]
			l_st: SD_STAT
			l_url: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___4: INTEGER_32
			js: JUMP_STATE
		do
			create l_vp.make
			create l_st.make

			l_url := 0
			if (window_inst.path_with_url (a_fname)).to_boolean then
				vim_strncpy (ff_expand_buffer, a_fname, (4095).to_natural_32)
				l_url := 1
			else
				ff_expand_buffer[0] := (('%/0/').code).to_natural_8
				if (stat (create {CE_POINTER [INTEGER_8]}.make_cast (a_fname), (l_st.address))) < 0 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				l_vp.ce_gets (a_visited_list.item)
				from
				until
					not (not js.loop_left and then ((l_vp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32))
				loop
					if not l_url.to_boolean then
						if (l_vp.item.ffv_dev_valid).to_boolean then
							if l_vp.item.ffv_dev = l_st.st_dev then
								if l_vp.item.ffv_ino = l_st.st_ino then
									l_tmp___2 := 1
								else
									l_tmp___2 := 0
								end
							else
								l_tmp___2 := 0
							end
						else
							l_tmp___2 := 0
						end
						l_tmp___4 := l_tmp___2
					else
						l_tmp___4 := ((strcmp (create {CE_POINTER [INTEGER_8]}.make_cast ((l_vp.item.ffv_fname)), create {CE_POINTER [INTEGER_8]}.make_cast (ff_expand_buffer))) = 0).to_integer
					end
					if l_tmp___4.to_boolean then
						if (ff_wc_equal (l_vp.item.ffv_wc_path, a_wc_path)) = 1 then
							Result := 0
							js.return
						end
					end
					if not js.return_called then
						l_vp.ce_gets (l_vp.item.ffv_next)
					end
				end
			end
			if not js.return_called then
				l_vp.ce_gets (create {CE_POINTER [PD_FF_VISITED]}.make_cast ((alloc ({PD_FF_VISITED}.sizeof.to_natural_32 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (ff_expand_buffer)))))))
				if (l_vp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					if not l_url.to_boolean then
						l_vp.item.ffv_dev_valid := 1
						l_vp.item.ffv_ino := l_st.st_ino
						l_vp.item.ffv_dev := l_st.st_dev
						l_vp.item.ffv_fname[0] := (('%/0/').code).to_natural_8
					else
						l_vp.item.ffv_dev_valid := 0
						strcpy (create {CE_POINTER [INTEGER_8]}.make_cast ((l_vp.item.ffv_fname)), create {CE_POINTER [INTEGER_8]}.make_cast (ff_expand_buffer)).do_nothing
					end
					if (a_wc_path.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						l_vp.item.ffv_wc_path := vim_strsave (a_wc_path)
					else
						l_vp.item.ffv_wc_path := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					end
					l_vp.item.ffv_next := a_visited_list.item
					a_visited_list.item := l_vp
				end
				Result := 1
			end
		end

	ff_create_stack_element (a_fix_part: CE_POINTER [NATURAL_8]; a_wc_part: CE_POINTER [NATURAL_8]; a_level: INTEGER_32; a_star_star_empty: INTEGER_32): CE_POINTER [PD_FF_STACK]
		local
			l_fix_part: CE_POINTER [NATURAL_8]
			l_wc_part: CE_POINTER [NATURAL_8]
			l_new: CE_POINTER [PD_FF_STACK]
			js: JUMP_STATE
		do
			create l_fix_part.make
			create l_wc_part.make
			create l_new.make

			l_fix_part.ce_gets (a_fix_part)
			l_wc_part.ce_gets (a_wc_part)
			l_new.ce_gets (create {CE_POINTER [PD_FF_STACK]}.make_cast ((alloc ({PD_FF_STACK}.sizeof.to_natural_32))))
			if (l_new.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				Result := (create {CE_POINTER [PD_FF_STACK]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				l_new.item.ffs_prev := create {CE_POINTER [PD_FF_STACK]}.make_shared (default_pointer)
				l_new.item.ffs_filearray := create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer)
				l_new.item.ffs_filearray_size := 0
				l_new.item.ffs_filearray_cur := (0).to_natural_8
				l_new.item.ffs_stage := 0
				l_new.item.ffs_level := a_level
				l_new.item.ffs_star_star_empty := a_star_star_empty
				if (l_fix_part.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					l_fix_part.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")))
				end
				l_new.item.ffs_fix_path := vim_strsave (l_fix_part)
				if (l_wc_part.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					l_wc_part.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")))
				end
				l_new.item.ffs_wc_path := vim_strsave (l_wc_part)
				if ((l_new.item.ffs_fix_path).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					ff_free_stack_element (l_new)
					l_new.ce_gets (create {CE_POINTER [PD_FF_STACK]}.make_shared (default_pointer))
				elseif ((l_new.item.ffs_wc_path).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					ff_free_stack_element (l_new)
					l_new.ce_gets (create {CE_POINTER [PD_FF_STACK]}.make_shared (default_pointer))
				end
				Result := l_new
			end
		end

	ff_push (a_search_ctx: CE_POINTER [PD_FF_SEARCH_CTX_T]; a_stack_ptr: CE_POINTER [PD_FF_STACK])
		do
			if (a_stack_ptr.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				a_stack_ptr.item.ffs_prev := a_search_ctx.item.ffsc_stack_ptr
				a_search_ctx.item.ffsc_stack_ptr := a_stack_ptr
			end
		end

	ff_pop (a_search_ctx: CE_POINTER [PD_FF_SEARCH_CTX_T]): CE_POINTER [PD_FF_STACK]
		local
			l_sptr: CE_POINTER [PD_FF_STACK]
		do
			create l_sptr.make

			l_sptr.ce_gets (a_search_ctx.item.ffsc_stack_ptr)
			if ((a_search_ctx.item.ffsc_stack_ptr).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				a_search_ctx.item.ffsc_stack_ptr := (a_search_ctx.item.ffsc_stack_ptr).item.ffs_prev
			end
			Result := l_sptr
		end

	ff_free_stack_element (a_stack_ptr: CE_POINTER [PD_FF_STACK])
		do
			vim_free (create {CE_POINTER [ANY]}.make_cast (a_stack_ptr.item.ffs_fix_path))
			vim_free (create {CE_POINTER [ANY]}.make_cast (a_stack_ptr.item.ffs_wc_path))
			if ((a_stack_ptr.item.ffs_filearray).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				misc1_inst.FreeWild (a_stack_ptr.item.ffs_filearray_size, a_stack_ptr.item.ffs_filearray)
			end
			vim_free (create {CE_POINTER [ANY]}.make_cast (a_stack_ptr))
		end

	ff_clear (a_search_ctx: CE_POINTER [PD_FF_SEARCH_CTX_T])
		local
			l_sptr: CE_POINTER [PD_FF_STACK]
			l_i___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_sptr.make

			from
			until
				js.loop_left
			loop
				js.reset
				l_sptr.ce_gets (ff_pop (a_search_ctx))
				if (l_sptr.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					js.break
				end
				if not js.loop_jumped then
					ff_free_stack_element (l_sptr)
				end
			end
			js.reset
			vim_free (create {CE_POINTER [ANY]}.make_cast (a_search_ctx.item.ffsc_file_to_search))
			vim_free (create {CE_POINTER [ANY]}.make_cast (a_search_ctx.item.ffsc_start_dir))
			vim_free (create {CE_POINTER [ANY]}.make_cast (a_search_ctx.item.ffsc_fix_path))
			vim_free (create {CE_POINTER [ANY]}.make_cast (a_search_ctx.item.ffsc_wc_path))
			if ((a_search_ctx.item.ffsc_stopdirs_v).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				l_i___0 := 0
				from
				until
					((a_search_ctx.item.ffsc_stopdirs_v[l_i___0]).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32
				loop
					vim_free (create {CE_POINTER [ANY]}.make_cast (a_search_ctx.item.ffsc_stopdirs_v[l_i___0]))
					l_i___0 := l_i___0 + 1
				end
				vim_free (create {CE_POINTER [ANY]}.make_cast (a_search_ctx.item.ffsc_stopdirs_v))
			end
			a_search_ctx.item.ffsc_stopdirs_v := create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer)
			a_search_ctx.item.ffsc_file_to_search := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			a_search_ctx.item.ffsc_start_dir := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			a_search_ctx.item.ffsc_fix_path := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			a_search_ctx.item.ffsc_wc_path := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			a_search_ctx.item.ffsc_level := 0
		end

	ff_path_in_stoplist (a_path: CE_POINTER [NATURAL_8]; a_path_len: INTEGER_32; a_stopdirs_v: CE_POINTER [CE_POINTER [NATURAL_8]]): INTEGER_32
		local
			l_path_len: INTEGER_32
			l_i___0: INTEGER_32
			js: JUMP_STATE
		do
			l_path_len := a_path_len
			l_i___0 := 0
			from
			until
				js.loop_left
			loop
				js.reset
				if l_path_len > 1 then
					if not (misc1_inst.vim_ispathsep ((a_path[(l_path_len - 1)]).to_integer_32)).to_boolean then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					l_path_len := l_path_len - 1
				end
			end
			js.reset
			if l_path_len = 0 then
				Result := 1
				js.return
			end
			if not js.return_called then
				l_i___0 := 0
				from
				until
					not (not js.loop_left and then (((a_stopdirs_v[l_i___0]).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32))
				loop
					if (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_stopdirs_v[l_i___0]))).to_integer_32 > l_path_len then
						if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_stopdirs_v[l_i___0]), create {CE_POINTER [INTEGER_8]}.make_cast (a_path), l_path_len.to_natural_32)) = 0 then
							if (misc1_inst.vim_ispathsep (((a_stopdirs_v[l_i___0])[l_path_len]).to_integer_32)).to_boolean then
								Result := 1
								js.return
							end
						end
					elseif (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_stopdirs_v[l_i___0]), create {CE_POINTER [INTEGER_8]}.make_cast (a_path))) = 0 then
						Result := 1
						js.return
					end
					if not js.return_called then
						l_i___0 := l_i___0 + 1
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	find_file_in_path (a_ptr: CE_POINTER [NATURAL_8]; a_len: INTEGER_32; a_options___0: INTEGER_32; a_first___0: INTEGER_32; a_rel_fname: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_tmp: CE_POINTER [NATURAL_8]
		do
			create l_tmp.make

			if ((globals_inst.curbuf.item.b_p_path).item).to_integer_32 = 0 then
				l_tmp.ce_gets (option_inst.p_path)
			else
				l_tmp.ce_gets (globals_inst.curbuf.item.b_p_path)
			end
			Result := (find_file_in_path_option (a_ptr, a_len, a_options___0, a_first___0, l_tmp, 2, a_rel_fname, globals_inst.curbuf.item.b_p_sua))
		end

	find_directory_in_path (a_ptr: CE_POINTER [NATURAL_8]; a_len: INTEGER_32; a_options___0: INTEGER_32; a_rel_fname: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		do
			Result := (find_file_in_path_option (a_ptr, a_len, a_options___0, 1, option_inst.p_cdpath, 1, a_rel_fname, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))))
		end

	find_file_in_path_option (a_ptr: CE_POINTER [NATURAL_8]; a_len: INTEGER_32; a_options___0: INTEGER_32; a_first___0: INTEGER_32; a_path_option: CE_POINTER [NATURAL_8]; a_find_what: INTEGER_32; a_rel_fname: CE_POINTER [NATURAL_8]; a_suffixes___0: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_save_char: NATURAL_8
			l_file_name: CE_POINTER [NATURAL_8]
			l_buf___6: CE_POINTER [NATURAL_8]
			l_rel_to_curdir: INTEGER_32
			l_tmp___1: INTEGER_32
			l_l: INTEGER_32
			l_run: INTEGER_32
			l_r_ptr: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_file_name.make
			create l_buf___6.make
			create l_r_ptr.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_file_name.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_buf___6.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					if a_first___0 = 1 then
						l_save_char := a_ptr[a_len]
						a_ptr[a_len] := (('%/0/').code).to_natural_8
						misc1_inst.expand_env (a_ptr, globals_inst.NameBuff, 4096)
						a_ptr[a_len] := l_save_char
						vim_free (create {CE_POINTER [ANY]}.make_cast (ff_file_to_find))
						ff_file_to_find.ce_gets (vim_strsave (globals_inst.NameBuff))
						if (ff_file_to_find.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_file_name.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							l_pos := -1 + 17 -- goto theend
						end
					end
				when 1 then
					if (ff_file_to_find[0]).to_integer_32 = 46 then
						if (ff_file_to_find[1]).to_integer_32 = 0 then
							l_tmp___1 := 1
						elseif (misc1_inst.vim_ispathsep ((ff_file_to_find[1]).to_integer_32)).to_boolean then
							l_tmp___1 := 1
						elseif (ff_file_to_find[1]).to_integer_32 = 46 then
							if (ff_file_to_find[2]).to_integer_32 = 0 then
								l_tmp___1 := 1
							elseif (misc1_inst.vim_ispathsep ((ff_file_to_find[2]).to_integer_32)).to_boolean then
								l_tmp___1 := 1
							else
								l_tmp___1 := 0
							end
						else
							l_tmp___1 := 0
						end
					else
						l_tmp___1 := 0
					end
					l_rel_to_curdir := l_tmp___1
					if not ((window_inst.vim_isAbsName (ff_file_to_find)).to_boolean) then
						l_pos := -1 + 4 -- skip if block
					end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 4 then -- else:
						if not (l_rel_to_curdir.to_boolean) then
							l_pos := -1 + 15 -- skip if block
						end
				when 5 then -- if: | _L:
						if a_first___0 /= 1 then
							l_pos := -1 + 14 -- skip if block
						end
				when 6 then -- if:
						if (window_inst.path_with_url (ff_file_to_find)).to_boolean then
							l_file_name.ce_gets (vim_strsave (ff_file_to_find))
							l_pos := -1 + 17 -- goto theend
						end
				when 7 then
						l_run := 1
				when 8 then -- loop condition:
						if not (not js.loop_left and then (l_run <= 2)) then
							l_pos := -1 + 14 -- skip loop
						end
				when 9 then -- loop body:
						l_l := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (ff_file_to_find))).to_integer_32
						if l_run = 1 then
							if l_rel_to_curdir.to_boolean then
								if ((a_options___0).bit_and (16)).to_boolean then
									if (a_rel_fname.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
										if (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_rel_fname))) + l_l.to_natural_32 < {NATURAL_32} 4096 then
											strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.NameBuff), create {CE_POINTER [INTEGER_8]}.make_cast (a_rel_fname)).do_nothing
											strcpy (create {CE_POINTER [INTEGER_8]}.make_cast ((misc1_inst.gettail (globals_inst.NameBuff))), create {CE_POINTER [INTEGER_8]}.make_cast (ff_file_to_find)).do_nothing
											l_l := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.NameBuff))).to_integer_32
										else
											strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.NameBuff), create {CE_POINTER [INTEGER_8]}.make_cast (ff_file_to_find)).do_nothing
											l_run := 2
										end
									else
										strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.NameBuff), create {CE_POINTER [INTEGER_8]}.make_cast (ff_file_to_find)).do_nothing
										l_run := 2
									end
								else
									strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.NameBuff), create {CE_POINTER [INTEGER_8]}.make_cast (ff_file_to_find)).do_nothing
									l_run := 2
								end
							else
								strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.NameBuff), create {CE_POINTER [INTEGER_8]}.make_cast (ff_file_to_find)).do_nothing
								l_run := 2
							end
						else
							strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.NameBuff), create {CE_POINTER [INTEGER_8]}.make_cast (ff_file_to_find)).do_nothing
							l_run := 2
						end
						l_buf___6.ce_gets (a_suffixes___0)
				when 10 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 13 -- skip loop
						end
				when 11 then -- loop body:
						js.reset
						if (os_unix_inst.mch_getperm (globals_inst.NameBuff)) >= 0 then
							if a_find_what = 2 then
								l_file_name.ce_gets (vim_strsave (globals_inst.NameBuff))
								l_pos := -1 + 17 -- goto theend
							elseif (a_find_what = 1) = (os_unix_inst.mch_isdir (globals_inst.NameBuff)).to_boolean then
								l_file_name.ce_gets (vim_strsave (globals_inst.NameBuff))
								l_pos := -1 + 17 -- goto theend
							end
						end
				when 12 then
						if (l_buf___6.item).to_integer_32 = 0 then
							js.break
						end
						if not js.loop_jumped then
							copy_option_part (l_buf___6.address, globals_inst.NameBuff + l_l, 4096 - l_l, ce_string (",")).do_nothing
						end
						l_pos := -1 + 10 -- back to loop condition
				when 13 then -- loop done
						js.reset
						l_run := l_run + 1
						l_pos := -1 + 8 -- back to loop condition
				when 14 then -- loop done | if done | if block done, skip else block:
						l_pos := -1 + 16
				when 15 then -- else:
						if a_first___0 = 1 then
							vim_findfile_free_visited (fdip_search_ctx)
							dir.ce_gets (a_path_option)
							did_findfile_init := 0
						end
						from
						until
							js.loop_left
						loop
							js.reset
							if did_findfile_init.to_boolean then
								l_file_name.ce_gets (vim_findfile (fdip_search_ctx))
								if (l_file_name.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									js.break
								end
								if not js.loop_jumped then
									did_findfile_init := 0
								end
							else
								if (dir.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
									vim_findfile_cleanup (fdip_search_ctx)
									fdip_search_ctx.ce_gets (create {CE_POINTER [ANY]}.make_shared (default_pointer))
									js.break
								elseif (dir.item).to_integer_32 = 0 then
									vim_findfile_cleanup (fdip_search_ctx)
									fdip_search_ctx.ce_gets (create {CE_POINTER [ANY]}.make_shared (default_pointer))
									js.break
								end
								if not js.loop_jumped then
									l_buf___6.ce_gets (alloc ({NATURAL_32} 4096))
									if (l_buf___6.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
										js.break
									end
								end
								if not js.loop_jumped then
									l_buf___6[0] := (0).to_natural_8
									copy_option_part (dir.address, l_buf___6, 4096, ce_string (" ,")).do_nothing
									l_r_ptr.ce_gets (vim_findfile_stopdir (l_buf___6))
									fdip_search_ctx.ce_gets (vim_findfile_init (l_buf___6, ff_file_to_find, l_r_ptr, 100, 0, a_find_what, fdip_search_ctx, 0, a_rel_fname))
									if (fdip_search_ctx.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
										did_findfile_init := 1
									end
									vim_free (create {CE_POINTER [ANY]}.make_cast (l_buf___6))
								end
							end
						end
						js.reset
				when 16 then -- if done
						if (l_file_name.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							if ((a_options___0).bit_and (1)).to_boolean then
								if a_first___0 = 1 then
									if a_find_what = 1 then
										message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E344: Can%'t find directory %"%%s%" in cdpath")))), ff_file_to_find).do_nothing
									else
										message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E345: Can%'t find file %"%%s%" in path")))), ff_file_to_find).do_nothing
									end
								elseif a_find_what = 1 then
									message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E346: No more directory %"%%s%" found in cdpath")))), ff_file_to_find).do_nothing
								else
									message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E347: No more file %"%%s%" found in path")))), ff_file_to_find).do_nothing
								end
							end
						end
				when 17 then -- theend:
						Result := l_file_name
				when 18 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	vim_chdir (a_new_dir: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_dir_name: CE_POINTER [NATURAL_8]
			l_r: INTEGER_32
			js: JUMP_STATE
		do
			create l_dir_name.make

			l_dir_name.ce_gets (find_directory_in_path (a_new_dir, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_new_dir))).to_integer_32, 1, globals_inst.curbuf.item.b_ffname))
			if (l_dir_name.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				Result := (-1)
				js.return
			end
			if not js.return_called then
				l_r := os_unix_inst.mch_chdir (create {CE_POINTER [INTEGER_8]}.make_cast (l_dir_name))
				vim_free (create {CE_POINTER [ANY]}.make_cast (l_dir_name))
				Result := l_r
			end
		end

	get_user_name (a_buf___6: CE_POINTER [NATURAL_8]; a_len: INTEGER_32): INTEGER_32
		local
			js: JUMP_STATE
		do
			if (username.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				if (os_unix_inst.mch_get_user_name (a_buf___6, a_len)) = 0 then
					Result := 0
					js.return
				end
				if not js.return_called then
					username.ce_gets (vim_strsave (a_buf___6))
				end
			else
				vim_strncpy (a_buf___6, username, (a_len - 1).to_natural_32)
			end
			if not js.return_called then
				Result := 1
			end
		end

	sort_compare___0 (a_s1: CE_POINTER [ANY]; a_s2: CE_POINTER [ANY]): INTEGER_32
		do
			Result := (strcmp ((create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_cast (a_s1)).item, (create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_cast (a_s2)).item))
		end

	sort_compare___0_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent sort_compare___0)
		end

	sort_strings (a_files: CE_POINTER [CE_POINTER [NATURAL_8]]; a_count___2: INTEGER_32)
		do
			qsort (create {CE_POINTER [ANY]}.make_cast (a_files), a_count___2.to_natural_32, Pointer_bytes.to_natural_32, sort_compare___0_address)
		end

	pathcmp (a_p___0: CE_POINTER [INTEGER_8]; a_q: CE_POINTER [INTEGER_8]; a_maxlen: INTEGER_32): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_s: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_s.make

			l_s.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
			l_i___0 := 0
			from
			until
				js.loop_left
			loop
				js.reset
				if not (a_maxlen < 0) then
					if not (l_i___0 < a_maxlen) then
						js.break
					end
				end
				if not js.loop_jumped and then ((a_p___0[l_i___0]).to_integer_32 = 0) then
					if (a_q[l_i___0]).to_integer_32 = 0 then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_s.ce_gets (a_q)
						js.break
					end
				end
				if not js.loop_jumped and then ((a_q[l_i___0]).to_integer_32 = 0) then
					l_s.ce_gets (a_p___0)
					js.break
				end
				if not js.loop_jumped then
					if (a_p___0[l_i___0]).to_integer_32 /= (a_q[l_i___0]).to_integer_32 then
						if (misc1_inst.vim_ispathsep ((a_p___0[l_i___0]).to_integer_32)).to_boolean then
							Result := (-1)
							js.return
						end
						if not js.return_called then
							if (misc1_inst.vim_ispathsep ((a_q[l_i___0]).to_integer_32)).to_boolean then
								Result := 1
								js.return
							end
						end
						if not js.return_called then
							Result := ((create {CE_POINTER [NATURAL_8]}.make_cast (a_p___0)[l_i___0]).to_integer_32 - (create {CE_POINTER [NATURAL_8]}.make_cast (a_q)[l_i___0]).to_integer_32)
							js.return
						end
					end
					if not js.return_called then
						l_i___0 := l_i___0 + 1
					end
				end
			end
			js.reset
			if not js.return_called and then ((l_s.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32) then
				Result := 0
				js.return
			end
			if not js.return_called and then ((l_s[(l_i___0 + 1)]).to_integer_32 = 0) then
				if l_i___0 > 0 then
					if not (after_pathsep (create {CE_POINTER [NATURAL_8]}.make_cast (l_s), create {CE_POINTER [NATURAL_8]}.make_cast (l_s) + l_i___0)).to_boolean then
						if (l_s[l_i___0]).to_integer_32 = 47 then
							Result := 0
							js.return
						end
					end
				end
			end
			if not js.return_called and then ((l_s.c_pointer.to_integer_32).to_natural_32 = (a_q.c_pointer.to_integer_32).to_natural_32) then
				Result := (-1)
				js.return
			end
			if not js.return_called then
				Result := 1
			end
		end

	filewritable (a_fname: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_retval: INTEGER_32
			l_perm: INTEGER_32
		do
			l_retval := 0
			l_perm := 0
			l_perm := (os_unix_inst.mch_getperm (a_fname)).to_integer_32
			if ((l_perm).bit_and (146)).to_boolean then
				if (access (create {CE_POINTER [INTEGER_8]}.make_cast (a_fname), 2)) = 0 then
					l_retval := l_retval + 1
					if (os_unix_inst.mch_isdir (a_fname)).to_boolean then
						l_retval := l_retval + 1
					end
				end
			end
			Result := l_retval
		end

	emsg3 (a_s: CE_POINTER [NATURAL_8]; a_a1: CE_POINTER [NATURAL_8]; a_a2: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if (message_inst.emsg_not_now).to_boolean then
				Result := 1
				js.return
			end
			if not js.return_called then
				message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (1025).to_natural_32, create {CE_POINTER [INTEGER_8]}.make_cast (a_s), a_a1, a_a2]).do_nothing
				Result := (message_inst.emsg (globals_inst.IObuff))
			end
		end

	emsgn (a_s: CE_POINTER [NATURAL_8]; a_n: INTEGER_32): INTEGER_32
		local
			js: JUMP_STATE
		do
			if (message_inst.emsg_not_now).to_boolean then
				Result := 1
				js.return
			end
			if not js.return_called then
				message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (1025).to_natural_32, create {CE_POINTER [INTEGER_8]}.make_cast (a_s), a_n]).do_nothing
				Result := (message_inst.emsg (globals_inst.IObuff))
			end
		end

	get2c (a_fd: CE_POINTER [SD_IO_FILE]): INTEGER_32
		local
			l_n: INTEGER_32
		do
			l_n := IO_getc (a_fd)
			l_n := ((l_n).bit_shift_left (8)) + (IO_getc (a_fd))
			Result := l_n
		end

	get3c (a_fd: CE_POINTER [SD_IO_FILE]): INTEGER_32
		local
			l_n: INTEGER_32
		do
			l_n := IO_getc (a_fd)
			l_n := ((l_n).bit_shift_left (8)) + (IO_getc (a_fd))
			l_n := ((l_n).bit_shift_left (8)) + (IO_getc (a_fd))
			Result := l_n
		end

	get4c (a_fd: CE_POINTER [SD_IO_FILE]): INTEGER_32
		local
			l_n: INTEGER_32
		do
			l_n := IO_getc (a_fd)
			l_n := ((l_n).bit_shift_left (8)) + (IO_getc (a_fd))
			l_n := ((l_n).bit_shift_left (8)) + (IO_getc (a_fd))
			l_n := ((l_n).bit_shift_left (8)) + (IO_getc (a_fd))
			Result := l_n
		end

	get8ctime (a_fd: CE_POINTER [SD_IO_FILE]): INTEGER_32
		local
			l_n: INTEGER_32
			l_i___0: INTEGER_32
		do
			l_n := (0).to_integer_32
			l_i___0 := 0
			from
			until
				not (l_i___0 < 8)
			loop
				l_n := ((l_n).bit_shift_left (8)) + (IO_getc (a_fd)).to_integer_32
				l_i___0 := l_i___0 + 1
			end
			Result := l_n
		end

	read_string (a_fd: CE_POINTER [SD_IO_FILE]; a_cnt: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_str___1: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			l_c: INTEGER_32
			js: JUMP_STATE
		do
			create l_str___1.make

			l_str___1.ce_gets (alloc (a_cnt.to_natural_32 + {NATURAL_32} 1))
			if (l_str___1.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				l_i___0 := 0
				from
				until
					not (not js.loop_left and then (l_i___0 < a_cnt))
				loop
					l_c := IO_getc (a_fd)
					if l_c = -1 then
						vim_free (create {CE_POINTER [ANY]}.make_cast (l_str___1))
						Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						js.return
					end
					if not js.return_called then
						l_str___1[l_i___0] := l_c.to_natural_8
						l_i___0 := l_i___0 + 1
					end
				end
				if not js.return_called then
					l_str___1[l_i___0] := (('%/0/').code).to_natural_8
				end
			end
			if not js.return_called then
				Result := l_str___1
			end
		end

	put_bytes (a_fd: CE_POINTER [SD_IO_FILE]; a_nr: NATURAL_32; a_len: INTEGER_32): INTEGER_32
		local
			l_i___0: INTEGER_32
			js: JUMP_STATE
		do
			l_i___0 := a_len - 1
			from
			until
				not (not js.loop_left and then (l_i___0 >= 0))
			loop
				if (IO_putc (((a_nr).bit_shift_right (l_i___0 * 8)).to_integer_32, a_fd)) = -1 then
					Result := 0
					js.return
				end
				if not js.return_called then
					l_i___0 := l_i___0 - 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	put_time (a_fd: CE_POINTER [SD_IO_FILE]; a_the_time: INTEGER_32)
		local
			l_c: INTEGER_32
			l_i___0: INTEGER_32
			l_wtime: INTEGER_32
		do
			l_wtime := a_the_time
			l_i___0 := 7
			from
			until
				not (l_i___0 >= 0)
			loop
				if l_i___0 + 1 > (Integer_32_bytes.to_natural_32).to_integer_32 then
					IO_putc (0, a_fd).do_nothing
				else
					l_c := ((l_wtime.to_natural_32).bit_shift_right (l_i___0 * 8)).to_integer_32
					IO_putc (l_c, a_fd).do_nothing
				end
				l_i___0 := l_i___0 - 1
			end
		end

end
