class
	P_OPS

inherit
	VIM_DATA
		redefine
			default_create
		end
	S_LIBIO
	S_STDIO
	S_CTYPE
	S_SYS_STAT
	S_STDLIB
	S_STRING
	S_LIBINTL
	S_WCTYPE
	S_UNISTD
	S_TIME
	S_FCNTL
	S_MATH
	S_SYS_TIME
	S_LOCALE
	S_BITS_ERRNO
	S_ICONV
	S_UTIME
	S_GLIB_OBJECT
	S_GTK_GTK
	S_SYS_SELECT
	S_X11_XLIB
	S_SIGNAL
	S_DIRENT
	S_PWD
	S_GLIB
	S_PANGO_PANGO
	S_GDK_GDK
	S_LANGINFO
	S_X11_XUTIL
	S_X11_INTRINSIC
	S_SYS_IOCTL
	S_SYS_RESOURCE
	S_SYS_WAIT
	S_SYS_UTSNAME
	S_TERMIOS
	S_DLFCN
	S_X11_ICE_ICELIB
	S_X11_SM_SMLIB
	S_X11_SHELL
	S_X11_STRINGDEFS
	S_SYS_SYSINFO
	S_TERMCAP
	S_TERM
	S_GDK_PIXBUF_GDK_PIXBUF
	S_SYS_SOCKET
	S_NETINET_IN
	S_NETDB

feature {NONE} -- Initialization

	default_create
		do
			create y_regs.make (<<40>>)
			create y_current.make
			create y_previous.make
			create opchars.make (<<28, 3>>)
			create expr_line.make
		end

feature {ANY} -- attributes

	y_regs: CE_ARRAY [PD_YANKREG]

	y_current: CE_POINTER [PD_YANKREG]

	y_append: INTEGER_32 assign set_y_append

	set_y_append (a_y_append: INTEGER_32)
		do
			y_append := a_y_append
		end

	y_previous: CE_POINTER [PD_YANKREG]

	opchars: CE_ARRAY [CE_ARRAY [INTEGER_8]]

	expr_line: CE_POINTER [NATURAL_8]

	nested: INTEGER_32 assign set_nested

	set_nested (a_nested: INTEGER_32)
		do
			nested := a_nested
		end

	regname: INTEGER_32 assign set_regname

	set_regname (a_regname: INTEGER_32)
		do
			regname := a_regname
		end

	execreg_lastc: INTEGER_32 assign set_execreg_lastc

	set_execreg_lastc (a_execreg_lastc: INTEGER_32)
		do
			execreg_lastc := a_execreg_lastc
		end

	hexupper: INTEGER_32 assign set_hexupper

	set_hexupper (a_hexupper: INTEGER_32)
		do
			hexupper := a_hexupper
		end

feature {ANY} -- routines

	get_op_type (a_char1: INTEGER_32; a_char2: INTEGER_32): INTEGER_32
		local
			l_i___0: INTEGER_32
			js: JUMP_STATE
		do
			if a_char1 = 114 then
				Result := 16
				js.return
			end
			if not js.return_called and then (a_char1 = 126) then
				Result := 7
				js.return
			end
			if not js.return_called then
				l_i___0 := 0
				from
				until
					js.loop_left
				loop
					js.reset
					if ((opchars[l_i___0])[0]).to_integer_32 = a_char1 then
						if ((opchars[l_i___0])[1]).to_integer_32 = a_char2 then
							js.break
						end
					end
					if not js.loop_jumped then
						l_i___0 := l_i___0 + 1
					end
				end
				js.reset
				Result := l_i___0
			end
		end

	op_on_lines (a_op: INTEGER_32): INTEGER_32
		do
			Result := ((opchars[a_op])[2]).to_integer_32
		end

	get_op_char (a_optype: INTEGER_32): INTEGER_32
		do
			Result := ((opchars[a_optype])[0]).to_integer_32
		end

	get_extra_op_char (a_optype: INTEGER_32): INTEGER_32
		do
			Result := ((opchars[a_optype])[1]).to_integer_32
		end

	op_shift (a_oap: CE_POINTER [PD_OPARG_S]; a_curs_top: INTEGER_32; a_amount: INTEGER_32)
		local
			l_i___0: INTEGER_32
			l_first_char: INTEGER_32
			l_s: CE_POINTER [NATURAL_8]
			l_block_col: INTEGER_32
			js: JUMP_STATE
		do
			create l_s.make

			l_block_col := 0
			if (undo_inst.u_save (a_oap.item.start.lnum - 1, a_oap.item.end2.lnum + 1)) = 0 then
				js.return
			end
			if not js.return_called then
				if (a_oap.item.block_mode).to_boolean then
					l_block_col := globals_inst.curwin.item.w_cursor.col
				end
				l_i___0 := a_oap.item.line_count
				from
				until
					js.loop_left
				loop
					js.reset
					l_i___0 := l_i___0 - 1
					if not (l_i___0 >= 0) then
						js.break
					end
					if not js.loop_jumped then
						l_first_char := ((memline_inst.ml_get_curline).item).to_integer_32
						if l_first_char = 0 then
							globals_inst.curwin.item.w_cursor.col := 0
						elseif (a_oap.item.block_mode).to_boolean then
							shift_block (a_oap, a_amount)
						elseif l_first_char /= 35 then
							shift_line ((a_oap.item.op_type = 4).to_integer, option_inst.p_sr, a_amount, 0)
						elseif not (preprocs_left).to_boolean then
							shift_line ((a_oap.item.op_type = 4).to_integer, option_inst.p_sr, a_amount, 0)
						end
						globals_inst.curwin.item.w_cursor.lnum := (globals_inst.curwin.item.w_cursor.lnum) + 1
					end
				end
				js.reset
				misc1_inst.changed_lines (a_oap.item.start.lnum, 0, a_oap.item.end2.lnum + 1, 0)
				if (a_oap.item.block_mode).to_boolean then
					globals_inst.curwin.item.w_cursor.lnum := a_oap.item.start.lnum
					globals_inst.curwin.item.w_cursor.col := l_block_col
				elseif a_curs_top.to_boolean then
					globals_inst.curwin.item.w_cursor.lnum := a_oap.item.start.lnum
					edit_inst.beginline (6)
				else
					globals_inst.curwin.item.w_cursor.lnum := (globals_inst.curwin.item.w_cursor.lnum) - 1
				end
				if a_oap.item.line_count > option_inst.p_report then
					if a_oap.item.op_type = 5 then
						l_s.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (">")))
					else
						l_s.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("<")))
					end
					if a_oap.item.line_count = 1 then
						if a_amount = 1 then
							sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (gettext (ce_string ("1 line %%sed 1 time"))), l_s]).do_nothing
						else
							sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (gettext (ce_string ("1 line %%sed %%d times"))), l_s, a_amount]).do_nothing
						end
					elseif a_amount = 1 then
						sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (gettext (ce_string ("%%ld lines %%sed 1 time"))), a_oap.item.line_count, l_s]).do_nothing
					else
						sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (gettext (ce_string ("%%ld lines %%sed %%d times"))), a_oap.item.line_count, l_s, a_amount]).do_nothing
					end
					message_inst.msg (globals_inst.IObuff).do_nothing
				end
				globals_inst.curbuf.item.b_op_start := a_oap.item.start
				globals_inst.curbuf.item.b_op_end.lnum := a_oap.item.end2.lnum
				globals_inst.curbuf.item.b_op_end.col := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((memline_inst.ml_get (a_oap.item.end2.lnum))))).to_integer_32
				if globals_inst.curbuf.item.b_op_end.col > 0 then
					globals_inst.curbuf.item.b_op_end.col := (globals_inst.curbuf.item.b_op_end.col) - 1
				end
			end
		end

	shift_line (a_left: INTEGER_32; a_round: INTEGER_32; a_amount: INTEGER_32; a_call_changed_bytes: INTEGER_32)
		local
			l_amount: INTEGER_32
			l_count___2: INTEGER_32
			l_i___0: INTEGER_32
			l_j: INTEGER_32
			l_p_sw___0: INTEGER_32
			l_tmp: INTEGER_32
		do
			l_amount := a_amount
			l_p_sw___0 := (globals_inst.curbuf.item.b_p_sw).to_integer_32
			l_count___2 := misc1_inst.get_indent
			if a_round.to_boolean then
				l_i___0 := l_count___2 // l_p_sw___0
				l_j := l_count___2 \\ l_p_sw___0
				if l_j.to_boolean then
					if a_left.to_boolean then
						l_amount := l_amount - 1
					end
				end
				if a_left.to_boolean then
					l_i___0 := l_i___0 - l_amount
					if l_i___0 < 0 then
						l_i___0 := 0
					end
				else
					l_i___0 := l_i___0 + l_amount
				end
				l_count___2 := l_i___0 * l_p_sw___0
			elseif a_left.to_boolean then
				l_count___2 := l_count___2 - (l_p_sw___0 * l_amount)
				if l_count___2 < 0 then
					l_count___2 := 0
				end
			else
				l_count___2 := l_count___2 + (l_p_sw___0 * l_amount)
			end
			if ((globals_inst.State).bit_and (128)).to_boolean then
				edit_inst.change_indent (1, l_count___2, 0, ('%/0/').code, a_call_changed_bytes)
			else
				if a_call_changed_bytes.to_boolean then
					l_tmp := 1
				else
					l_tmp := 0
				end
				misc1_inst.set_indent (l_count___2, l_tmp).do_nothing
			end
		end

	shift_block (a_oap: CE_POINTER [PD_OPARG_S]; a_amount: INTEGER_32)
		local
			l_left: INTEGER_32
			l_oldstate: INTEGER_32
			l_total: INTEGER_32
			l_newp: CE_POINTER [NATURAL_8]
			l_oldp: CE_POINTER [NATURAL_8]
			l_oldcol: INTEGER_32
			l_p_sw___0: INTEGER_32
			l_p_ts___0: INTEGER_32
			l_bd: PD_BLOCK_DEF
			l_incr: INTEGER_32
			l_ws_vcol: INTEGER_32
			l_i___0: INTEGER_32
			l_j: INTEGER_32
			l_len: INTEGER_32
			l_destination_col: INTEGER_32
			l_verbatim_copy_end: CE_POINTER [NATURAL_8]
			l_verbatim_copy_width: INTEGER_32
			l_fill: NATURAL_32
			l_new_line_len: NATURAL_32
			l_block_space_width: NATURAL_32
			l_shift_amount: NATURAL_32
			l_non_white: CE_POINTER [NATURAL_8]
			l_non_white_col: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___4: INTEGER_32
			js: JUMP_STATE
		do
			create l_newp.make
			create l_oldp.make
			create l_bd.make
			create l_verbatim_copy_end.make
			create l_non_white.make

			l_left := (a_oap.item.op_type = 4).to_integer
			l_oldstate := globals_inst.State
			l_oldcol := globals_inst.curwin.item.w_cursor.col
			l_p_sw___0 := (globals_inst.curbuf.item.b_p_sw).to_integer_32
			l_p_ts___0 := (globals_inst.curbuf.item.b_p_ts).to_integer_32
			l_i___0 := 0
			l_j := 0
			globals_inst.State := 16
			block_prep (a_oap, l_bd.address, globals_inst.curwin.item.w_cursor.lnum, 1)
			if (l_bd.is_short).to_boolean then
				js.return
			end
			if not js.return_called then
				l_total := a_amount * l_p_sw___0
				l_oldp.ce_gets (memline_inst.ml_get_curline)
				if not l_left.to_boolean then
					l_total := l_total + (l_bd.pre_whitesp)
					l_ws_vcol := l_bd.start_vcol - l_bd.pre_whitesp
					if (l_bd.startspaces).to_boolean then
						if globals_inst.has_mbyte.to_boolean then
							l_bd.textstart := l_bd.textstart + (globals_inst.mb_ptr2len.integer_32_item ([l_bd.textstart]))
						else
							l_bd.textstart := (l_bd.textstart) + 1
						end
					end
					from
					until
						js.loop_left
					loop
						js.reset
						if ((l_bd.textstart).item).to_integer_32 /= 32 then
							if ((l_bd.textstart).item).to_integer_32 /= 9 then
								js.break
							end
						end
						if not js.loop_jumped then
							l_incr := charset_inst.lbr_chartabsize_adv (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (l_bd.c_pointer + {PD_BLOCK_DEF}.textstart_offset), l_bd.start_vcol)
							l_total := l_total + l_incr
							l_bd.start_vcol := l_bd.start_vcol + l_incr
						end
					end
					js.reset
					if not (globals_inst.curbuf.item.b_p_et).to_boolean then
						l_i___0 := (l_ws_vcol \\ l_p_ts___0 + l_total) // l_p_ts___0
					end
					if l_i___0.to_boolean then
						l_j := (l_ws_vcol \\ l_p_ts___0 + l_total) \\ l_p_ts___0
					else
						l_j := l_total
					end
					l_bd.textcol := l_bd.textcol - (l_bd.pre_whitesp_c - (l_bd.startspaces /= 0).to_integer)
					l_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_bd.textstart))).to_integer_32 + 1
					l_newp.ce_gets (misc2_inst.alloc_check ((((l_bd.textcol + l_i___0) + l_j) + l_len).to_natural_32))
					if (l_newp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						js.return
					end
					if not js.return_called then
						memset (create {CE_POINTER [ANY]}.make_cast (l_newp), ('%/0/').code, (((l_bd.textcol + l_i___0) + l_j) + l_len).to_natural_32).do_nothing
						memmove (create {CE_POINTER [ANY]}.make_cast (l_newp), create {CE_POINTER [ANY]}.make_cast (l_oldp), (l_bd.textcol).to_natural_32).do_nothing
						misc2_inst.copy_chars (l_newp + l_bd.textcol, l_i___0.to_natural_32, ('%T').code)
						misc2_inst.copy_spaces ((l_newp + l_bd.textcol) + l_i___0, l_j.to_natural_32)
						memmove (create {CE_POINTER [ANY]}.make_cast ((((l_newp + l_bd.textcol) + l_i___0) + l_j)), create {CE_POINTER [ANY]}.make_cast (l_bd.textstart), l_len.to_natural_32).do_nothing
					end
				else
					l_non_white.ce_gets (l_bd.textstart)
					if (l_bd.startspaces).to_boolean then
						if globals_inst.has_mbyte.to_boolean then
							l_tmp___2 := (globals_inst.mb_ptr2len.integer_32_item ([l_non_white]))
						else
							l_tmp___2 := 1
						end
						l_non_white.ce_gets (l_non_white + l_tmp___2)
					end
					l_non_white_col := l_bd.start_vcol
					from
					until
						js.loop_left
					loop
						js.reset
						if (l_non_white.item).to_integer_32 /= 32 then
							if (l_non_white.item).to_integer_32 /= 9 then
								js.break
							end
						end
						if not js.loop_jumped then
							l_incr := charset_inst.lbr_chartabsize_adv (l_non_white.address, l_non_white_col)
							l_non_white_col := l_non_white_col + l_incr
						end
					end
					js.reset
					l_block_space_width := (l_non_white_col - a_oap.item.start_vcol).to_natural_32
					if l_block_space_width < l_total.to_natural_32 then
						l_shift_amount := l_block_space_width
					else
						l_shift_amount := l_total.to_natural_32
					end
					l_destination_col := (l_non_white_col.to_natural_32 - l_shift_amount).to_integer_32
					l_verbatim_copy_end.ce_gets (l_bd.textstart)
					l_verbatim_copy_width := l_bd.start_vcol
					if (l_bd.startspaces).to_boolean then
						l_verbatim_copy_width := l_verbatim_copy_width - (l_bd.start_char_vcols)
					end
					from
					until
						not (not js.loop_left and then (l_verbatim_copy_width < l_destination_col))
					loop
						js.reset
						l_incr := charset_inst.lbr_chartabsize (l_verbatim_copy_end, l_verbatim_copy_width)
						if l_verbatim_copy_width + l_incr > l_destination_col then
							js.break
						end
						if not js.loop_jumped then
							l_verbatim_copy_width := l_verbatim_copy_width + l_incr
							if globals_inst.has_mbyte.to_boolean then
								l_tmp___4 := (globals_inst.mb_ptr2len.integer_32_item ([l_verbatim_copy_end]))
							else
								l_tmp___4 := 1
							end
							l_verbatim_copy_end.ce_gets (l_verbatim_copy_end + l_tmp___4)
						end
					end
					js.reset
					l_fill := (l_destination_col - l_verbatim_copy_width).to_natural_32
					l_new_line_len := (((l_verbatim_copy_end.distance (l_oldp)).to_natural_32 + l_fill) + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_non_white)))) + {NATURAL_32} 1
					l_newp.ce_gets (misc2_inst.alloc_check (l_new_line_len))
					if (l_newp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						js.return
					end
					if not js.return_called then
						memmove (create {CE_POINTER [ANY]}.make_cast (l_newp), create {CE_POINTER [ANY]}.make_cast (l_oldp), (l_verbatim_copy_end.distance (l_oldp)).to_natural_32).do_nothing
						misc2_inst.copy_spaces (l_newp + (l_verbatim_copy_end.distance (l_oldp)), l_fill)
						memmove (create {CE_POINTER [ANY]}.make_cast (((l_newp + (l_verbatim_copy_end.distance (l_oldp))) + l_fill.to_integer_32)), create {CE_POINTER [ANY]}.make_cast (l_non_white), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_non_white))) + {NATURAL_32} 1).do_nothing
					end
				end
			end
			if not js.return_called then
				memline_inst.ml_replace (globals_inst.curwin.item.w_cursor.lnum, l_newp, 0).do_nothing
				misc1_inst.changed_bytes (globals_inst.curwin.item.w_cursor.lnum, l_bd.textcol)
				globals_inst.State := l_oldstate
				globals_inst.curwin.item.w_cursor.col := l_oldcol
			end
		end

	block_insert (a_oap: CE_POINTER [PD_OPARG_S]; a_s: CE_POINTER [NATURAL_8]; a_b_insert: INTEGER_32; a_bdp: CE_POINTER [PD_BLOCK_DEF])
		local
			l_p_ts___0: INTEGER_32
			l_count___2: INTEGER_32
			l_spaces: INTEGER_32
			l_offset: INTEGER_32
			l_s_len: NATURAL_32
			l_newp: CE_POINTER [NATURAL_8]
			l_oldp: CE_POINTER [NATURAL_8]
			l_lnum: INTEGER_32
			l_oldstate: INTEGER_32
			js: JUMP_STATE
		do
			create l_newp.make
			create l_oldp.make

			l_count___2 := 0
			l_spaces := 0
			l_oldstate := globals_inst.State
			globals_inst.State := 16
			l_s_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_s)))
			l_lnum := a_oap.item.start.lnum + 1
			from
			until
				not (l_lnum <= a_oap.item.end2.lnum)
			loop
				js.reset
				block_prep (a_oap, a_bdp, l_lnum, 1)
				if (a_bdp.item.is_short).to_boolean then
					if a_b_insert.to_boolean then
						js.continue
					end
				end
				if not js.loop_jumped then
					l_oldp.ce_gets (memline_inst.ml_get (l_lnum))
					if a_b_insert.to_boolean then
						l_p_ts___0 := a_bdp.item.start_char_vcols
						l_spaces := a_bdp.item.startspaces
						if l_spaces /= 0 then
							l_count___2 := l_p_ts___0 - 1
						end
						l_offset := a_bdp.item.textcol
					else
						l_p_ts___0 := a_bdp.item.end_char_vcols
						if not (a_bdp.item.is_short).to_boolean then
							if (a_bdp.item.endspaces).to_boolean then
								l_spaces := l_p_ts___0 - a_bdp.item.endspaces
							else
								l_spaces := 0
							end
							if l_spaces /= 0 then
								l_count___2 := l_p_ts___0 - 1
							end
							l_offset := (a_bdp.item.textcol + a_bdp.item.textlen) - (l_spaces /= 0).to_integer
						else
							if not (a_bdp.item.is_MAX).to_boolean then
								l_spaces := (a_oap.item.end_vcol - a_bdp.item.end_vcol) + 1
							end
							l_count___2 := l_spaces
							l_offset := a_bdp.item.textcol + a_bdp.item.textlen
						end
					end
					l_newp.ce_gets (misc2_inst.alloc_check ((((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_oldp))) + l_s_len) + l_count___2.to_natural_32) + {NATURAL_32} 1))
					if (l_newp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						js.continue
					end
				end
				if not js.loop_jumped then
					memmove (create {CE_POINTER [ANY]}.make_cast (l_newp), create {CE_POINTER [ANY]}.make_cast (l_oldp), l_offset.to_natural_32).do_nothing
					l_oldp.ce_gets (l_oldp + l_offset)
					misc2_inst.copy_spaces (l_newp + l_offset, l_spaces.to_natural_32)
					memmove (create {CE_POINTER [ANY]}.make_cast (((l_newp + l_offset) + l_spaces)), create {CE_POINTER [ANY]}.make_cast (a_s), l_s_len).do_nothing
					l_offset := (l_offset.to_natural_32 + l_s_len).to_integer_32
					if l_spaces.to_boolean then
						if not (a_bdp.item.is_short).to_boolean then
							misc2_inst.copy_spaces ((l_newp + l_offset) + l_spaces, (l_p_ts___0 - l_spaces).to_natural_32)
							l_oldp.ce_gets (l_oldp + 1)
							l_count___2 := l_count___2 + 1
						end
					end
					if l_spaces > 0 then
						l_offset := l_offset + l_count___2
					end
					memmove (create {CE_POINTER [ANY]}.make_cast ((l_newp + l_offset)), create {CE_POINTER [ANY]}.make_cast (l_oldp), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_oldp))) + {NATURAL_32} 1).do_nothing
					memline_inst.ml_replace (l_lnum, l_newp, 0).do_nothing
					if l_lnum = a_oap.item.end2.lnum then
						globals_inst.curbuf.item.b_op_end.lnum := a_oap.item.end2.lnum
						globals_inst.curbuf.item.b_op_end.col := l_offset
					end
				end
				l_lnum := l_lnum + 1
			end
			misc1_inst.changed_lines (a_oap.item.start.lnum + 1, 0, a_oap.item.end2.lnum + 1, 0)
			globals_inst.State := l_oldstate
		end

	op_reindent (a_oap: CE_POINTER [PD_OPARG_S]; a_how: CE_ROUTINE)
		local
			l_i___0: INTEGER_32
			l_l: CE_POINTER [NATURAL_8]
			l_count___2: INTEGER_32
			l_first_changed: INTEGER_32
			l_last_changed: INTEGER_32
			l_start_lnum: INTEGER_32
			l_tmp___3: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_l.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_first_changed := (0).to_integer_32
					l_last_changed := (0).to_integer_32
					l_start_lnum := globals_inst.curwin.item.w_cursor.lnum
					if not (globals_inst.curbuf.item.b_p_ma).to_boolean then
						message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_modifiable))))).do_nothing
						js.return
					end
					if js.return_called then
						l_pos := -1 + 21 -- skip if block
					end
				when 1 then -- if:
						l_i___0 := a_oap.item.line_count
				when 2 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 20 -- skip loop
						end
				when 3 then -- loop body:
						js.reset
						l_i___0 := l_i___0 - 1
						if l_i___0 >= 0 then
							if globals_inst.got_int.to_boolean then
								js.break
							end
						else
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 19 -- skip if block
						end
				when 4 then -- if:
						if not (l_i___0 > 1) then
							l_pos := -1 + 10 -- skip if block
						end
				when 5 then -- if:
						if l_i___0 \\ 50 /= 0 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_pos := -1 + 9 -- goto _L
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 8 then -- else:
						if l_i___0 /= a_oap.item.line_count - 1 then
							l_pos := -1 + 10 -- skip if block
						end
				when 9 then -- if: | _L:
						if a_oap.item.line_count > option_inst.p_report then
							message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("%%ld lines to indent... ")))), l_i___0]).do_nothing
						end
				when 10 then -- if done | if done
						if l_i___0 = a_oap.item.line_count - 1 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_pos := -1 + 17 -- goto _L___0
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 13 then -- else:
						if a_oap.item.line_count /= 1 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_pos := -1 + 17 -- goto _L___0
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 16 then -- else:
						if (a_how.c_pointer.to_integer_32).to_natural_32 = ((misc1_inst.get_lisp_indent_address).c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 18 -- skip if block
						end
				when 17 then -- if: | _L___0:
						l_l.ce_gets (charset_inst.skipwhite ((memline_inst.ml_get_curline)))
						if (l_l.item).to_integer_32 = 0 then
							l_count___2 := 0
						else
							l_count___2 := a_how.integer_32_item ([])
						end
						if (misc1_inst.set_indent (l_count___2, 4)).to_boolean then
							if l_first_changed = 0 then
								l_first_changed := globals_inst.curwin.item.w_cursor.lnum
							end
							l_last_changed := globals_inst.curwin.item.w_cursor.lnum
						end
				when 18 then -- if done | if done
						globals_inst.curwin.item.w_cursor.lnum := (globals_inst.curwin.item.w_cursor.lnum) + 1
						globals_inst.curwin.item.w_cursor.col := 0
				when 19 then -- if done
						l_pos := -1 + 2 -- back to loop condition
				when 20 then -- loop done
						js.reset
						globals_inst.curwin.item.w_cursor.lnum := l_start_lnum
						edit_inst.beginline (6)
						if l_last_changed /= 0 then
							if (a_oap.item.is_VIsual).to_boolean then
								l_tmp___3 := l_start_lnum + a_oap.item.line_count
							else
								l_tmp___3 := l_last_changed + 1
							end
							misc1_inst.changed_lines (l_first_changed, 0, l_tmp___3, 0)
						elseif (a_oap.item.is_VIsual).to_boolean then
							screen_inst.redraw_curbuf_later (20)
						end
						if a_oap.item.line_count > option_inst.p_report then
							l_i___0 := a_oap.item.line_count - (l_i___0 + 1)
							if l_i___0 = 1 then
								message_inst.msg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("1 line indented "))))).do_nothing
							else
								message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("%%ld lines indented ")))), l_i___0]).do_nothing
							end
						end
						globals_inst.curbuf.item.b_op_start := a_oap.item.start
						globals_inst.curbuf.item.b_op_end := a_oap.item.end2
				when 21 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_expr_register: INTEGER_32
		local
			l_new_line: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_new_line.make

			l_new_line.ce_gets (ex_getln_inst.getcmdline (('=').code, 0, 0))
			if (l_new_line.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				Result := (('%/0/').code)
				js.return
			end
			if not js.return_called then
				if (l_new_line.item).to_integer_32 = 0 then
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_new_line))
				else
					set_expr_line (l_new_line)
				end
				Result := (('=').code)
			end
		end

	set_expr_line (a_new_line: CE_POINTER [NATURAL_8])
		do
			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (expr_line))
			expr_line.ce_gets (a_new_line)
		end

	get_expr_line: CE_POINTER [NATURAL_8]
		local
			l_expr_copy: CE_POINTER [NATURAL_8]
			l_rv: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_expr_copy.make
			create l_rv.make

			if (expr_line.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				l_expr_copy.ce_gets (misc2_inst.vim_strsave (expr_line))
				if (l_expr_copy.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					js.return
				end
			end
			if not js.return_called and then (nested >= 10) then
				Result := l_expr_copy
				js.return
			end
			if not js.return_called then
				nested := nested + 1
				l_rv.ce_gets (eval_inst.eval_to_string (l_expr_copy, create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), 1))
				nested := nested - 1
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_expr_copy))
				Result := l_rv
			end
		end

	get_expr_line_src: CE_POINTER [NATURAL_8]
		local
			js: JUMP_STATE
		do
			if (expr_line.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				Result := (misc2_inst.vim_strsave (expr_line))
			end
		end

	valid_yank_reg (a_regname___0: INTEGER_32; a_writing: INTEGER_32): INTEGER_32
		local
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_regname___0 > 0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if a_regname___0 < 127 then
							if ((((ctype_b_loc).item[a_regname___0]).to_integer_32).bit_and (8)).to_boolean then
								Result := 1
								js.return
							else
								l_pos := -1 + 3 -- goto _L___0
							end
						else
							l_pos := -1 + 3 -- goto _L___0
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else: | _L___0:
						if a_writing.to_boolean then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if ((misc2_inst.vim_strchr (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("/.%%#:=")), a_regname___0)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							Result := 1
							js.return
						else
							l_pos := -1 + 6 -- goto _L
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L:
						if a_regname___0 = 34 then
							Result := 1
							js.return
						elseif a_regname___0 = 45 then
							Result := 1
							js.return
						elseif a_regname___0 = 95 then
							Result := 1
							js.return
						elseif a_regname___0 = 42 then
							Result := 1
							js.return
						elseif a_regname___0 = 43 then
							Result := 1
							js.return
						elseif not a_writing.to_boolean then
							if a_regname___0 = 126 then
								Result := 1
								js.return
							end
						end
				when 7 then -- if done
						if not js.return_called then
							Result := 0
						end
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	get_yank_register (a_regname___0: INTEGER_32; a_writing: INTEGER_32)
		local
			l_i___0: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					y_append := 0
					if a_regname___0 /= 0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if a_regname___0 /= 34 then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						if not a_writing.to_boolean then
							if (y_previous.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								y_current.ce_gets (y_previous)
								js.return
							end
						end
				when 5 then -- if done
						if js.return_called then
							l_pos := -1 + 26 -- skip if block
						end
				when 6 then -- if:
							l_i___0 := a_regname___0
							if not (l_i___0 >= 48) then
								l_pos := -1 + 9 -- skip if block
							end
				when 7 then -- if:
							if l_i___0 <= 57 then
								l_i___0 := l_i___0 - (48)
							else
								l_pos := -1 + 9 -- goto _L___4
							end
				when 8 then -- if block done, skip else block:
							l_pos := -1 + 25
				when 9 then -- else: | _L___4:
							if not (l_i___0 < 127) then
								l_pos := -1 + 12 -- skip if block
							end
				when 10 then -- if:
							if ((((ctype_b_loc).item[l_i___0]).to_integer_32).bit_and (512)).to_boolean then
								l_i___0 := (l_i___0 - 97) + 10
							else
								l_pos := -1 + 12 -- goto _L___3
							end
				when 11 then -- if block done, skip else block:
							l_pos := -1 + 25
				when 12 then -- else: | _L___3:
							if not (l_i___0 < 127) then
								l_pos := -1 + 15 -- skip if block
							end
				when 13 then -- if:
							if ((((ctype_b_loc).item[l_i___0]).to_integer_32).bit_and (256)).to_boolean then
								l_i___0 := (l_i___0 - 65) + 10
								y_append := 1
							else
								l_pos := -1 + 15 -- goto _L___2
							end
				when 14 then -- if block done, skip else block:
							l_pos := -1 + 25
				when 15 then -- else: | _L___2:
							if a_regname___0 /= 45 then
								l_pos := -1 + 18 -- skip if block
							end
				when 16 then -- if:
							l_i___0 := 36
				when 17 then -- if block done, skip else block:
							l_pos := -1 + 25
				when 18 then -- else:
							if not ((globals_inst.clip_star.available).to_boolean) then
								l_pos := -1 + 21 -- skip if block
							end
				when 19 then -- if:
							if a_regname___0 = 42 then
								l_i___0 := 37
							else
								l_pos := -1 + 21 -- goto _L___1
							end
				when 20 then -- if block done, skip else block:
							l_pos := -1 + 25
				when 21 then -- else: | _L___1:
							if not ((globals_inst.clip_plus.available).to_boolean) then
								l_pos := -1 + 24 -- skip if block
							end
				when 22 then -- if:
							if a_regname___0 = 43 then
								l_i___0 := 38
							else
								l_pos := -1 + 24 -- goto _L___0
							end
				when 23 then -- if block done, skip else block:
							l_pos := -1 + 25
				when 24 then -- else: | _L___0:
							if not a_writing.to_boolean then
								if a_regname___0 = 126 then
									l_i___0 := 39
								else
									l_i___0 := 0
								end
							else
								l_i___0 := 0
							end
				when 25 then -- if done | if done | if done | if done | if done
							y_current.ce_gets (y_regs + l_i___0)
							if a_writing.to_boolean then
								y_previous.ce_gets (y_current)
							end
				when 26 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	may_get_selection (a_regname___0: INTEGER_32): INTEGER_32
		local
			l_regname___0: INTEGER_32
		do
			l_regname___0 := a_regname___0
			if l_regname___0 = 42 then
				if not (globals_inst.clip_star.available).to_boolean then
					l_regname___0 := 0
				else
					clip_get_selection (globals_inst.clip_star.address)
				end
			elseif l_regname___0 = 43 then
				if not (globals_inst.clip_plus.available).to_boolean then
					l_regname___0 := 0
				else
					clip_get_selection (globals_inst.clip_plus.address)
				end
			end
			Result := l_regname___0
		end

	get_register (a_name___1: INTEGER_32; a_copy: INTEGER_32): CE_POINTER [ANY]
		local
			l_reg___0: CE_POINTER [PD_YANKREG]
			l_i___0: INTEGER_32
		do
			create l_reg___0.make

			if a_name___1 = 42 then
				if (globals_inst.clip_star.available).to_boolean then
					if (ui_inst.clip_isautosel).to_boolean then
						ui_inst.clip_update_selection
					end
					may_get_selection (a_name___1).do_nothing
				end
			end
			get_yank_register (a_name___1, 0)
			l_reg___0.ce_gets (create {CE_POINTER [PD_YANKREG]}.make_cast ((misc2_inst.alloc ({PD_YANKREG}.sizeof.to_natural_32))))
			if (l_reg___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				l_reg___0.item := y_current.item
				if a_copy.to_boolean then
					if l_reg___0.item.y_size = 0 then
						l_reg___0.item.y_array := create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer)
					else
						l_reg___0.item.y_array := create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast ((misc2_inst.alloc (((Pointer_bytes.to_natural_32).to_natural_32 * (l_reg___0.item.y_size).to_natural_32).to_natural_32)))
					end
					if ((l_reg___0.item.y_array).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						l_i___0 := 0
						from
						until
							not (l_i___0.to_integer_32 < l_reg___0.item.y_size)
						loop
							l_reg___0.item.y_array[l_i___0] := misc2_inst.vim_strsave (y_current.item.y_array[l_i___0])
							l_i___0 := l_i___0 + 1
						end
					end
				else
					y_current.item.y_array := create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer)
				end
			end
			Result := (create {CE_POINTER [ANY]}.make_cast (l_reg___0))
		end

	put_register (a_name___1: INTEGER_32; a_reg___0: CE_POINTER [ANY])
		do
			get_yank_register (a_name___1, 0)
			free_yank_all
			y_current.item := (create {CE_POINTER [PD_YANKREG]}.make_cast (a_reg___0)).item
			misc2_inst.vim_free (a_reg___0)
			may_set_selection
		end

	yank_register_mline (a_regname___0: INTEGER_32): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_regname___0 /= 0 then
				if not (valid_yank_reg (a_regname___0, 0)).to_boolean then
					Result := 0
					js.return
				end
			end
			if not js.return_called and then (a_regname___0 = 95) then
				Result := 0
				js.return
			end
			if not js.return_called then
				get_yank_register (a_regname___0, 0)
				Result := ((y_current.item.y_type).to_integer_32 = 1).to_integer
			end
		end

	do_record (a_c: INTEGER_32): INTEGER_32
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_old_y_previous: CE_POINTER [PD_YANKREG]
			l_old_y_current: CE_POINTER [PD_YANKREG]
			l_retval: INTEGER_32
			l_pos: INTEGER_32
		do
			create l_p___0.make
			create l_old_y_previous.make
			create l_old_y_current.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if globals_inst.Recording /= 0 then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						if not (a_c < 0) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_retval := 0
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 4 then -- else:
						if not (a_c < 127) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if ((((ctype_b_loc).item[a_c]).to_integer_32).bit_and (8)).to_boolean then
							globals_inst.Recording := 1
							screen_inst.showmode.do_nothing
							regname := a_c
							l_retval := 1
						else
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						if a_c /= 34 then
							l_retval := 0
						else
							globals_inst.Recording := 1
							screen_inst.showmode.do_nothing
							regname := a_c
							l_retval := 1
						end
				when 8 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else:
						globals_inst.Recording := 0
						message_inst.msg (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))).do_nothing
						l_p___0.ce_gets (getchar_inst.get_recorded)
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_retval := 0
						else
							getchar_inst.vim_unescape_csi (l_p___0)
							l_old_y_previous.ce_gets (y_previous)
							l_old_y_current.ce_gets (y_current)
							l_retval := stuff_yank (regname, l_p___0)
							y_previous.ce_gets (l_old_y_previous)
							y_current.ce_gets (l_old_y_current)
						end
				when 10 then
					Result := l_retval
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	stuff_yank (a_regname___0: INTEGER_32; a_p___0: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_lp: CE_POINTER [NATURAL_8]
			l_pp: CE_POINTER [CE_POINTER [NATURAL_8]]
			l_tmp___0: NATURAL_32
			l_tmp___2: CE_POINTER [CE_POINTER [NATURAL_8]]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_lp.make
			create l_pp.make
			create l_tmp___2.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_regname___0 /= 0 then
						if not (valid_yank_reg (a_regname___0, 1)).to_boolean then
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_p___0))
							Result := 0
							js.return
						end
					end
					if not js.return_called and then (a_regname___0 = 95) then
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_p___0))
						Result := 1
						js.return
					end
					if js.return_called then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						get_yank_register (a_regname___0, 1)
						if not (y_append.to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if ((y_current.item.y_array).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_pp.ce_gets (y_current.item.y_array + (y_current.item.y_size - 1))
							l_tmp___0 := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_pp.item))
							l_lp.ce_gets (misc2_inst.lalloc (((l_tmp___0 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_p___0)))) + {NATURAL_32} 1).to_natural_32, 1))
							if (l_lp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_p___0))
								Result := 0
								js.return
							end
							if not js.return_called then
								strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_lp), create {CE_POINTER [INTEGER_8]}.make_cast (l_pp.item)).do_nothing
								strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_lp), create {CE_POINTER [INTEGER_8]}.make_cast (a_p___0)).do_nothing
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_p___0))
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_pp.item))
								l_pp.item := l_lp
							end
						else
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						free_yank_all
						l_tmp___2.ce_gets (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast ((misc2_inst.alloc (Pointer_bytes.to_natural_32))))
						y_current.item.y_array := l_tmp___2
						if (l_tmp___2.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_p___0))
							Result := 0
							js.return
						end
						if not js.return_called then
							y_current.item.y_array[0] := a_p___0
							y_current.item.y_size := (1).to_integer_32
							y_current.item.y_type := (0).to_natural_8
						end
				when 5 then -- if done
						if not js.return_called then
							Result := 1
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	do_execreg (a_regname___0: INTEGER_32; a_colon: INTEGER_32; a_addcr: INTEGER_32; a_silent: INTEGER_32): INTEGER_32
		local
			l_regname___0: INTEGER_32
			l_i___0: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_retval: INTEGER_32
			l_remap: INTEGER_32
			l_escaped: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p___0.make
			create l_escaped.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_regname___0 := a_regname___0
					l_retval := 1
					if l_regname___0 = 64 then
						if execreg_lastc = 0 then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E748: No previously used register"))))).do_nothing
							Result := 0
							js.return
						end
						if not js.return_called then
							l_regname___0 := execreg_lastc
						end
					end
					if not js.return_called then
						if l_regname___0 = 37 then
							message_inst.emsg_invreg (l_regname___0)
							Result := 0
							js.return
						elseif l_regname___0 = 35 then
							message_inst.emsg_invreg (l_regname___0)
							Result := 0
							js.return
						elseif not (valid_yank_reg (l_regname___0, 0)).to_boolean then
							message_inst.emsg_invreg (l_regname___0)
							Result := 0
							js.return
						end
					end
					if not js.return_called then
						execreg_lastc := l_regname___0
						l_regname___0 := may_get_selection (l_regname___0)
						if l_regname___0 = 95 then
							Result := 1
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 26 -- skip if block
					end
				when 1 then -- if:
						if l_regname___0 /= 58 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if (globals_inst.last_cmdline.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_nolastcmd))))).do_nothing
							Result := 0
							js.return
						end
						if not js.return_called then
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (globals_inst.new_last_cmdline))
							globals_inst.new_last_cmdline.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							l_p___0.ce_gets (misc2_inst.vim_strsave_escaped_ext (globals_inst.last_cmdline, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/1/%/2/%/3/%/4/%/5/%/6/%/7/%B%T%N%/11/%F%R%/14/%/15/%/16/%/17/%/18/%/19/%/20/%/21/%/22/%/23/%/24/%/25/%/26/%/27/%/28/%/29/%/30/%/31/")), 22, 0))
							if (l_p___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								if globals_inst.VIsual_active.to_boolean then
									if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), ce_string ("%'<,%'>"), (5).to_natural_32)) = 0 then
										l_retval := put_in_typebuf (l_p___0 + 5, 1, 1, a_silent)
									else
										l_retval := put_in_typebuf (l_p___0, 1, 1, a_silent)
									end
								else
									l_retval := put_in_typebuf (l_p___0, 1, 1, a_silent)
								end
							end
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_p___0))
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 26
				when 4 then -- else:
						if l_regname___0 /= 61 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_p___0.ce_gets (get_expr_line)
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							Result := 0
							js.return
						end
						if not js.return_called then
							l_retval := put_in_typebuf (l_p___0, 1, a_colon, a_silent)
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_p___0))
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 26
				when 7 then -- else:
						if l_regname___0 /= 46 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_p___0.ce_gets (edit_inst.get_last_insert_save)
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_noinstext))))).do_nothing
							Result := 0
							js.return
						end
						if not js.return_called then
							l_retval := put_in_typebuf (l_p___0, 0, a_colon, a_silent)
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_p___0))
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 26
				when 10 then -- else:
						get_yank_register (l_regname___0, 0)
						if ((y_current.item.y_array).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							Result := 0
							js.return
						end
						if js.return_called then
							l_pos := -1 + 25 -- skip if block
						end
				when 11 then -- if:
						if a_colon.to_boolean then
							l_remap := -1
						else
							l_remap := 0
						end
						put_reedit_in_typebuf (a_silent)
						l_i___0 := y_current.item.y_size
				when 12 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 24 -- skip loop
						end
				when 13 then -- loop body:
						js.reset
						l_i___0 := l_i___0 - 1
						if not (l_i___0 >= 0) then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 23 -- skip if block
						end
				when 14 then -- if:
						if (y_current.item.y_type).to_integer_32 /= 1 then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if:
						l_pos := -1 + 21 -- goto _L
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 17 then -- else:
						if not (l_i___0 < y_current.item.y_size - 1) then
							l_pos := -1 + 20 -- skip if block
						end
				when 18 then -- if:
						l_pos := -1 + 21 -- goto _L
				when 19 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 20 then -- else:
						if not (a_addcr.to_boolean) then
							l_pos := -1 + 22 -- skip if block
						end
				when 21 then -- if: | _L:
						if (getchar_inst.ins_typebuf (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%N")), l_remap, 0, 1, a_silent)) = 0 then
							Result := 0
							js.return
						end
				when 22 then -- if done | if done
						if not js.return_called then
							l_escaped.ce_gets (getchar_inst.vim_strsave_escape_csi (y_current.item.y_array[l_i___0]))
							if (l_escaped.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								Result := 0
								js.return
							end
						end
						if not js.return_called then
							l_retval := getchar_inst.ins_typebuf (l_escaped, l_remap, 0, 1, a_silent)
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_escaped))
							if l_retval = 0 then
								Result := 0
								js.return
							end
						end
						if not js.return_called and then (a_colon.to_boolean) then
							if (getchar_inst.ins_typebuf (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (":")), l_remap, 0, 1, a_silent)) = 0 then
								Result := 0
								js.return
							end
						end
				when 23 then -- if done
						l_pos := -1 + 12 -- back to loop condition
				when 24 then -- loop done
						js.reset
				when 25 then -- if done
						if not js.return_called then
							globals_inst.Exec_reg := 1
						end
				when 26 then -- if done | if done | if done | if done
						if not js.return_called then
							Result := l_retval
						end
				when 27 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	put_reedit_in_typebuf (a_silent: INTEGER_32)
		local
			l_buf___6: CE_ARRAY [NATURAL_8]
		do
			create l_buf___6.make (<<3>>)

			if globals_inst.restart_edit /= 0 then
				if globals_inst.restart_edit = 86 then
					l_buf___6[0] := (('g').code).to_natural_8
					l_buf___6[1] := (('R').code).to_natural_8
					l_buf___6[2] := (('%/0/').code).to_natural_8
				else
					if globals_inst.restart_edit = 73 then
						l_buf___6[0] := (('i').code).to_natural_8
					else
						l_buf___6[0] := globals_inst.restart_edit.to_natural_8
					end
					l_buf___6[1] := (('%/0/').code).to_natural_8
				end
				if (getchar_inst.ins_typebuf (l_buf___6, -1, 0, 1, a_silent)) = 1 then
					globals_inst.restart_edit := ('%/0/').code
				end
			end
		end

	put_in_typebuf (a_s: CE_POINTER [NATURAL_8]; a_esc: INTEGER_32; a_colon: INTEGER_32; a_silent: INTEGER_32): INTEGER_32
		local
			l_retval: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp: INTEGER_32
		do
			create l_p___0.make

			l_retval := 1
			put_reedit_in_typebuf (a_silent)
			if a_colon.to_boolean then
				l_retval := getchar_inst.ins_typebuf (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%N")), -1, 0, 1, a_silent)
			end
			if l_retval = 1 then
				if a_esc.to_boolean then
					l_p___0.ce_gets (getchar_inst.vim_strsave_escape_csi (a_s))
				else
					l_p___0.ce_gets (a_s)
				end
				if (l_p___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					l_retval := 0
				else
					if a_esc.to_boolean then
						l_tmp := -1
					else
						l_tmp := 0
					end
					l_retval := getchar_inst.ins_typebuf (l_p___0, l_tmp, 0, 1, a_silent)
				end
				if a_esc.to_boolean then
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_p___0))
				end
			end
			if a_colon.to_boolean then
				if l_retval = 1 then
					l_retval := getchar_inst.ins_typebuf (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (":")), -1, 0, 1, a_silent)
				end
			end
			Result := l_retval
		end

	insert_reg (a_regname___0: INTEGER_32; a_literally: INTEGER_32): INTEGER_32
		local
			l_regname___0: INTEGER_32
			l_i___0: INTEGER_32
			l_retval: INTEGER_32
			l_arg: CE_POINTER [NATURAL_8]
			l_allocated: INTEGER_32
			js: JUMP_STATE
		do
			create l_arg.make

			l_regname___0 := a_regname___0
			l_retval := 1
			ui_inst.ui_breakcheck
			if globals_inst.got_int.to_boolean then
				Result := 0
				js.return
			end
			if not js.return_called and then (l_regname___0 /= 0) then
				if not (valid_yank_reg (l_regname___0, 0)).to_boolean then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				l_regname___0 := may_get_selection (l_regname___0)
				if l_regname___0 = 46 then
					l_retval := edit_inst.stuff_inserted (('%/0/').code, 1, 1)
				elseif (get_spec_reg (l_regname___0, l_arg.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_allocated), 1)).to_boolean then
					if (l_arg.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						Result := 0
						js.return
					end
					if not js.return_called then
						stuffescaped (l_arg, a_literally)
						if l_allocated.to_boolean then
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_arg))
						end
					end
				else
					get_yank_register (l_regname___0, 0)
					if ((y_current.item.y_array).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						l_retval := 0
					else
						l_i___0 := 0
						from
						until
							not (l_i___0 < y_current.item.y_size)
						loop
							stuffescaped (y_current.item.y_array[l_i___0], a_literally)
							if (y_current.item.y_type).to_integer_32 = 1 then
								getchar_inst.stuffcharReadbuff (('%N').code)
							elseif l_i___0 < y_current.item.y_size - 1 then
								getchar_inst.stuffcharReadbuff (('%N').code)
							end
							l_i___0 := l_i___0 + 1
						end
					end
				end
			end
			if not js.return_called then
				Result := l_retval
			end
		end

	stuffescaped (a_arg: CE_POINTER [NATURAL_8]; a_literally: INTEGER_32)
		local
			l_arg: CE_POINTER [NATURAL_8]
			l_c: INTEGER_32
			l_start___1: CE_POINTER [NATURAL_8]
			l_tmp: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_arg.make
			create l_start___1.make
			create l_tmp.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_arg.ce_gets (a_arg)
				when 1 then -- loop condition:
					if not (not js.loop_left and then ((l_arg.item).to_integer_32 /= 0)) then
						l_pos := -1 + 17 -- skip loop
					end
				when 2 then -- loop body:
						l_start___1.ce_gets (l_arg)
				when 3 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 9 -- skip loop
						end
				when 4 then -- loop body:
						js.reset
						if not ((l_arg.item).to_integer_32 >= 32) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if not ((l_arg.item).to_integer_32 < 127) then
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						if (l_arg.item).to_integer_32 = 128 then
							if a_literally.to_boolean then
								js.break
							end
						else
							js.break
						end
				when 8 then
						if not js.loop_jumped then
							l_arg.ce_gets (l_arg + 1)
						end
						l_pos := -1 + 3 -- back to loop condition
				when 9 then -- loop done
						js.reset
						if (l_arg.c_pointer.to_integer_32).to_natural_32 > (l_start___1.c_pointer.to_integer_32).to_natural_32 then
							getchar_inst.stuffReadbuffLen (l_start___1, (l_arg.distance (l_start___1)).to_integer_32)
						end
						if (l_arg.item).to_integer_32 = 0 then
							l_pos := -1 + 16 -- skip if block
						end
				when 10 then -- if:
						if globals_inst.has_mbyte.to_boolean then
							l_c := mbyte_inst.mb_cptr2char_adv (l_arg.address)
						else
							l_tmp.ce_gets (l_arg)
							l_arg.ce_gets (l_arg + 1)
							l_c := (l_tmp.item).to_integer_32
						end
						if not (a_literally.to_boolean) then
							l_pos := -1 + 15 -- skip if block
						end
				when 11 then -- if:
						if not (l_c < 32) then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:
						if l_c /= 9 then
							getchar_inst.stuffcharReadbuff (22)
						else
							l_pos := -1 + 14 -- goto _L___0
						end
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 14 then -- else: | _L___0:
						if l_c = 127 then
							getchar_inst.stuffcharReadbuff (22)
						end
				when 15 then -- if done
						getchar_inst.stuffcharReadbuff (l_c)
				when 16 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 17 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_spec_reg (a_regname___0: INTEGER_32; a_argp: CE_POINTER [CE_POINTER [NATURAL_8]]; a_allocated: CE_POINTER [INTEGER_32]; a_errmsg: INTEGER_32): INTEGER_32
		local
			l_cnt: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					a_argp.item := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					a_allocated.item := 0
					inspect a_regname___0 -- switch 1 head
					when 37 then l_pos := -1 + 1
					when 35 then l_pos := -1 + 2
					when 61 then l_pos := -1 + 3
					when 58 then l_pos := -1 + 4
					when 47 then l_pos := -1 + 5
					when 46 then l_pos := -1 + 6
					when 6 then l_pos := -1 + 7
					when 16 then l_pos := -1 + 7
					when 23 then l_pos := -1 + 8
					when 1 then l_pos := -1 + 8
					when 95 then l_pos := -1 + 9
					else l_pos := -1 + 10
					end
				when 1 then -- switch 1, case 37
					if a_errmsg.to_boolean then
						ex_cmds2_inst.check_fname.do_nothing
					end
					a_argp.item := globals_inst.curbuf.item.b_fname
					Result := 1
					js.return
				when 2 then -- switch 1, case 35
					if not js.return_called then
						a_argp.item := buffer_inst.getaltfname (a_errmsg)
						Result := 1
						js.return
					end
				when 3 then -- switch 1, case 61
					if not js.return_called then
						a_argp.item := get_expr_line
						a_allocated.item := 1
						Result := 1
						js.return
					end
				when 4 then -- switch 1, case 58
					if not js.return_called then
						if (globals_inst.last_cmdline.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							if a_errmsg.to_boolean then
								message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_nolastcmd))))).do_nothing
							end
						end
						a_argp.item := globals_inst.last_cmdline
						Result := 1
						js.return
					end
				when 5 then -- switch 1, case 47
					if not js.return_called then
						if ((search_inst.last_search_pat).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							if a_errmsg.to_boolean then
								message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_noprevre))))).do_nothing
							end
						end
						a_argp.item := search_inst.last_search_pat
						Result := 1
						js.return
					end
				when 6 then -- switch 1, case 46
					if not js.return_called then
						a_argp.item := edit_inst.get_last_insert_save
						a_allocated.item := 1
						if ((a_argp.item).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							if a_errmsg.to_boolean then
								message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_noinstext))))).do_nothing
							end
						end
						Result := 1
						js.return
					end
				when 7 then -- switch 1, case 6 | switch 1, case 16
					if not js.return_called and then (not a_errmsg.to_boolean) then
						Result := 0
						js.return
					end
					if not js.return_called then
						if a_regname___0 = 16 then
							l_tmp___3 := 2
						else
							l_tmp___3 := 0
						end
						a_argp.item := window_inst.file_name_at_cursor ((5).bit_or (l_tmp___3), 1, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
						a_allocated.item := 1
						Result := 1
						js.return
					end
				when 8 then -- switch 1, case 23 | switch 1, case 1
					if not js.return_called and then (not a_errmsg.to_boolean) then
						Result := 0
						js.return
					end
					if not js.return_called then
						if a_regname___0 = 23 then
							l_tmp___4 := 3
						else
							l_tmp___4 := 2
						end
						l_cnt := normal_inst.find_ident_under_cursor (a_argp, l_tmp___4)
						if l_cnt.to_boolean then
							a_argp.item := (misc2_inst.vim_strnsave (a_argp.item, l_cnt))
						else
							a_argp.item := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
						end
						a_allocated.item := 1
						Result := 1
						js.return
					end
				when 9 then -- switch 1, case 95
					if not js.return_called then
						a_argp.item := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
						Result := 1
						js.return
					end
				when 10 then -- switch 1, done:
					if not js.return_called then
						Result := 0
					end
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	cmdline_paste_reg (a_regname___0: INTEGER_32; a_literally: INTEGER_32; a_remcr: INTEGER_32): INTEGER_32
		local
			l_i___0: INTEGER_32
			js: JUMP_STATE
		do
			get_yank_register (a_regname___0, 0)
			if ((y_current.item.y_array).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				Result := 0
				js.return
			end
			if not js.return_called then
				l_i___0 := 0
				from
				until
					not (not js.loop_left and then (l_i___0 < y_current.item.y_size))
				loop
					ex_getln_inst.cmdline_paste_str (y_current.item.y_array[l_i___0], a_literally)
					if (y_current.item.y_type).to_integer_32 = 1 then
						ex_getln_inst.cmdline_paste_str (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%R")), a_literally)
					elseif l_i___0 < y_current.item.y_size - 1 then
						if a_remcr.to_boolean then
							if l_i___0 = y_current.item.y_size - 2 then
								if ((y_current.item.y_array[(l_i___0 + 1)]).item).to_integer_32 /= 0 then
									ex_getln_inst.cmdline_paste_str (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%R")), a_literally)
								end
							else
								ex_getln_inst.cmdline_paste_str (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%R")), a_literally)
							end
						else
							ex_getln_inst.cmdline_paste_str (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%R")), a_literally)
						end
					end
					ui_inst.ui_breakcheck
					if globals_inst.got_int.to_boolean then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_i___0 := l_i___0 + 1
					end
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	adjust_clip_reg (a_rp: CE_POINTER [INTEGER_32])
		do
			if a_rp.item = 0 then
				if globals_inst.clip_unnamed.to_boolean then
					a_rp.item := ('*').code
				end
			end
			if not (globals_inst.clip_star.available).to_boolean then
				if a_rp.item = 42 then
					a_rp.item := 0
				end
			end
			if not (globals_inst.clip_plus.available).to_boolean then
				if a_rp.item = 43 then
					a_rp.item := 0
				end
			end
		end

	op_delete (a_oap: CE_POINTER [PD_OPARG_S]): INTEGER_32
		local
			l_n: INTEGER_32
			l_lnum: INTEGER_32
			l_ptr: CE_POINTER [NATURAL_8]
			l_newp: CE_POINTER [NATURAL_8]
			l_oldp: CE_POINTER [NATURAL_8]
			l_bd: PD_BLOCK_DEF
			l_old_lcount: INTEGER_32
			l_did_yank: INTEGER_32
			l_msg_silent_save: INTEGER_32
			l_endcol: INTEGER_32
			l_curline: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_tmp___26: INTEGER_32
			l_curpos: PD_POS_T
			l_tmp___28: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_ptr.make
			create l_newp.make
			create l_oldp.make
			create l_bd.make
			create l_curline.make
			create l_curpos.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_old_lcount := globals_inst.curbuf.item.b_ml.ml_line_count
					l_did_yank := 0
					if ((globals_inst.curbuf.item.b_ml.ml_flags).bit_and (1)).to_boolean then
						Result := 1
						js.return
					end
					if not js.return_called and then ((a_oap.item.empty).to_boolean) then
						Result := (undo_inst.u_save_cursor)
						js.return
					end
					if not js.return_called and then (not (globals_inst.curbuf.item.b_p_ma).to_boolean) then
						message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_modifiable))))).do_nothing
						Result := 0
						js.return
					end
					if js.return_called then
						l_pos := -1 + 7 -- skip if block
					end
				when 1 then -- if:
						adjust_clip_reg (create {CE_POINTER [INTEGER_32]}.make_shared (a_oap.c_pointer + {PD_OPARG_S}.regname_offset))
						if globals_inst.has_mbyte.to_boolean then
							mb_adjust_opend (a_oap)
						end
						if a_oap.item.motion_type = 0 then
							if not (a_oap.item.is_VIsual).to_boolean then
								if not (a_oap.item.block_mode).to_boolean then
									if a_oap.item.line_count > 1 then
										if a_oap.item.op_type = 1 then
											l_ptr.ce_gets (((memline_inst.ml_get (a_oap.item.end2.lnum)) + a_oap.item.end2.col) + a_oap.item.inclusive)
											l_ptr.ce_gets (charset_inst.skipwhite (l_ptr))
											if (l_ptr.item).to_integer_32 = 0 then
												if (misc1_inst.inindent (0)).to_boolean then
													a_oap.item.motion_type := 1
												end
											end
										end
									end
								end
							end
						end
						if a_oap.item.motion_type /= 0 then
							l_pos := -1 + 7 -- skip if block
						end
				when 2 then -- if:
						if a_oap.item.line_count /= 1 then
							l_pos := -1 + 7 -- skip if block
						end
				when 3 then -- if:
						if a_oap.item.op_type /= 1 then
							l_pos := -1 + 7 -- skip if block
						end
				when 4 then -- if:
						if ((memline_inst.ml_get (a_oap.item.start.lnum)).item).to_integer_32 /= 0 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if globals_inst.virtual_op.to_boolean then
							l_pos := -1 + 23 -- goto setmarks
						end
				when 6 then
						if ((misc2_inst.vim_strchr (option_inst.p_cpo, ('E').code)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							misc1_inst.beep_flush
						end
						Result := 1
						js.return
				when 7 then -- if done | if done | if done | if done | if done
						if not (not js.return_called and then (a_oap.item.regname /= 95)) then
							l_pos := -1 + 21 -- skip if block
						end
				when 8 then -- if:
							if a_oap.item.regname /= 0 then
								if not (valid_yank_reg (a_oap.item.regname, 1)).to_boolean then
									misc1_inst.beep_flush
									Result := 1
									js.return
								end
								if not js.return_called then
									get_yank_register (a_oap.item.regname, 1)
									if (op_yank (a_oap, 1, 0)) = 1 then
										l_did_yank := 1
									end
								end
							end
							if js.return_called then
								l_pos := -1 + 21 -- skip if block
							end
				when 9 then -- if:
							if a_oap.item.regname = 0 then
								l_pos := -1 + 12 -- skip if block
							end
				when 10 then -- if:
							l_pos := -1 + 19 -- goto _L
				when 11 then -- if block done, skip else block:
							l_pos := -1 + 20
				when 12 then -- else:
							if a_oap.item.motion_type /= 1 then
								l_pos := -1 + 15 -- skip if block
							end
				when 13 then -- if:
							l_pos := -1 + 19 -- goto _L
				when 14 then -- if block done, skip else block:
							l_pos := -1 + 20
				when 15 then -- else:
							if not (a_oap.item.line_count > 1) then
								l_pos := -1 + 18 -- skip if block
							end
				when 16 then -- if:
							l_pos := -1 + 19 -- goto _L
				when 17 then -- if block done, skip else block:
							l_pos := -1 + 20
				when 18 then -- else:
							if not ((a_oap.item.use_reg_one).to_boolean) then
								l_pos := -1 + 20 -- skip if block
							end
				when 19 then -- if: | _L:
							y_current.ce_gets (y_regs + 9)
							free_yank_all
							l_n := 9
							from
							until
								not (l_n > 1)
							loop
								y_regs[l_n] := y_regs[l_n - 1]
								l_n := l_n - 1
							end
							y_current.ce_gets (y_regs + 1)
							y_previous.ce_gets (y_current)
							y_regs[1].y_array := create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer)
							if (op_yank (a_oap, 1, 0)) = 1 then
								l_did_yank := 1
							end
				when 20 then -- if done | if done | if done
							if a_oap.item.regname = 0 then
								if a_oap.item.motion_type /= 1 then
									if a_oap.item.line_count = 1 then
										a_oap.item.regname := ('-').code
										get_yank_register (a_oap.item.regname, 1)
										if (op_yank (a_oap, 1, 0)) = 1 then
											l_did_yank := 1
										end
										a_oap.item.regname := 0
									end
								end
							end
							if not l_did_yank.to_boolean then
								l_msg_silent_save := globals_inst.msg_silent
								globals_inst.msg_silent := 0
								l_n := misc1_inst.ask_yesno (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("cannot yank; delete anyway")))), 1)
								globals_inst.msg_silent := l_msg_silent_save
								if l_n /= 121 then
									message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_abort))))).do_nothing
									Result := 0
									js.return
								end
							end
				when 21 then -- if done | if done
							if not js.return_called then
								if (a_oap.item.block_mode).to_boolean then
									if (undo_inst.u_save (a_oap.item.start.lnum - 1, a_oap.item.end2.lnum + 1)) = 0 then
										Result := 0
										js.return
									end
									if not js.return_called then
										l_lnum := globals_inst.curwin.item.w_cursor.lnum
										from
										until
											not (l_lnum <= a_oap.item.end2.lnum)
										loop
											js.reset
											block_prep (a_oap, l_bd.address, l_lnum, 1)
											if l_bd.textlen = 0 then
												js.continue
											end
											if not js.loop_jumped then
												if l_lnum = globals_inst.curwin.item.w_cursor.lnum then
													globals_inst.curwin.item.w_cursor.col := l_bd.textcol + l_bd.startspaces
													globals_inst.curwin.item.w_cursor.coladd := 0
												end
												l_n := (l_bd.textlen - l_bd.startspaces) - l_bd.endspaces
												l_oldp.ce_gets (memline_inst.ml_get (l_lnum))
												l_newp.ce_gets (misc2_inst.alloc_check (((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_oldp))) + {NATURAL_32} 1) - l_n.to_natural_32))
												if (l_newp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
													js.continue
												end
											end
											if not js.loop_jumped then
												memmove (create {CE_POINTER [ANY]}.make_cast (l_newp), create {CE_POINTER [ANY]}.make_cast (l_oldp), (l_bd.textcol).to_natural_32).do_nothing
												misc2_inst.copy_spaces (l_newp + l_bd.textcol, (l_bd.startspaces + l_bd.endspaces).to_natural_32)
												l_oldp.ce_gets (l_oldp + (l_bd.textcol + l_bd.textlen))
												memmove (create {CE_POINTER [ANY]}.make_cast ((((l_newp + l_bd.textcol) + l_bd.startspaces) + l_bd.endspaces)), create {CE_POINTER [ANY]}.make_cast (l_oldp), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_oldp))) + {NATURAL_32} 1).do_nothing
												memline_inst.ml_replace (l_lnum, l_newp, 0).do_nothing
											end
											l_lnum := l_lnum + 1
										end
										misc2_inst.check_cursor_col
										misc1_inst.changed_lines (globals_inst.curwin.item.w_cursor.lnum, globals_inst.curwin.item.w_cursor.col, a_oap.item.end2.lnum + 1, 0)
										a_oap.item.line_count := 0
									end
								elseif a_oap.item.motion_type = 1 then
									if a_oap.item.op_type = 3 then
										if a_oap.item.line_count > 1 then
											l_lnum := globals_inst.curwin.item.w_cursor.lnum
											globals_inst.curwin.item.w_cursor.lnum := (globals_inst.curwin.item.w_cursor.lnum) + 1
											misc1_inst.del_lines (a_oap.item.line_count - 1, 1)
											globals_inst.curwin.item.w_cursor.lnum := l_lnum
										end
										if (undo_inst.u_save_cursor) = 0 then
											Result := 0
											js.return
										end
										if not js.return_called then
											if (globals_inst.curbuf.item.b_p_ai).to_boolean then
												edit_inst.beginline (1)
												globals_inst.did_ai := 1
												globals_inst.ai_col := globals_inst.curwin.item.w_cursor.col
											else
												edit_inst.beginline (0)
											end
											misc1_inst.truncate_line (0).do_nothing
											if a_oap.item.line_count > 1 then
												undo_inst.u_clearline
											end
										end
									else
										misc1_inst.del_lines (a_oap.item.line_count, 1)
										edit_inst.beginline (5)
										undo_inst.u_clearline
									end
								else
									if globals_inst.virtual_op.to_boolean then
										l_endcol := 0
										if (misc1_inst.gchar_pos (create {CE_POINTER [PD_POS_T]}.make_shared (a_oap.c_pointer + {PD_OPARG_S}.start_offset))) = 9 then
											if (undo_inst.u_save_cursor) = 0 then
												Result := 0
												js.return
											end
											if not js.return_called then
												if a_oap.item.line_count = 1 then
													l_endcol := misc2_inst.getviscol2 (a_oap.item.end2.col, a_oap.item.end2.coladd)
												end
												misc2_inst.coladvance_force ((misc2_inst.getviscol2 (a_oap.item.start.col, a_oap.item.start.coladd))).do_nothing
												a_oap.item.start := globals_inst.curwin.item.w_cursor
												if a_oap.item.line_count = 1 then
													misc2_inst.coladvance (l_endcol).do_nothing
													a_oap.item.end2.col := globals_inst.curwin.item.w_cursor.col
													a_oap.item.end2.coladd := globals_inst.curwin.item.w_cursor.coladd
													globals_inst.curwin.item.w_cursor := a_oap.item.start
												end
											end
										end
										if not js.return_called then
											if (misc1_inst.gchar_pos (create {CE_POINTER [PD_POS_T]}.make_shared (a_oap.c_pointer + {PD_OPARG_S}.end2_offset))) = 9 then
												if a_oap.item.end2.coladd < a_oap.item.inclusive then
													if (undo_inst.u_save (a_oap.item.end2.lnum - 1, a_oap.item.end2.lnum + 1)) = 0 then
														Result := 0
														js.return
													end
													if not js.return_called then
														globals_inst.curwin.item.w_cursor := a_oap.item.end2
														misc2_inst.coladvance_force ((misc2_inst.getviscol2 (a_oap.item.end2.col, a_oap.item.end2.coladd))).do_nothing
														a_oap.item.end2 := globals_inst.curwin.item.w_cursor
														globals_inst.curwin.item.w_cursor := a_oap.item.start
													end
												end
											end
										end
									end
									if not js.return_called then
										if a_oap.item.line_count = 1 then
											if (undo_inst.u_save_cursor) = 0 then
												Result := 0
												js.return
											end
											if not js.return_called then
												if ((misc2_inst.vim_strchr (option_inst.p_cpo, ('$').code)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
													if a_oap.item.op_type = 3 then
														if a_oap.item.end2.lnum = globals_inst.curwin.item.w_cursor.lnum then
															if not (a_oap.item.is_VIsual).to_boolean then
																edit_inst.display_dollar (a_oap.item.end2.col - (not (a_oap.item.inclusive).to_boolean).to_integer)
															end
														end
													end
												end
												l_n := ((a_oap.item.end2.col - a_oap.item.start.col) + 1) - (not (a_oap.item.inclusive).to_boolean).to_integer
												if globals_inst.virtual_op.to_boolean then
													l_curline.ce_gets ((memline_inst.ml_get_curline))
													l_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_curline))).to_integer_32
													if a_oap.item.end2.coladd /= 0 then
														if a_oap.item.end2.col >= l_len - 1 then
															if (a_oap.item.start.coladd).to_boolean then
																if not (a_oap.item.end2.col >= l_len - 1) then
																	l_n := l_n + 1
																end
															else
																l_n := l_n + 1
															end
														end
													end
													if l_n = 0 then
														if a_oap.item.start.coladd /= a_oap.item.end2.coladd then
															l_n := 1
														end
													end
													if (misc1_inst.gchar_cursor) /= 0 then
														globals_inst.curwin.item.w_cursor.coladd := 0
													end
												end
												if a_oap.item.op_type = 1 then
													if not (a_oap.item.is_VIsual).to_boolean then
														l_tmp___26 := 1
													else
														l_tmp___26 := 0
													end
												else
													l_tmp___26 := 0
												end
												misc1_inst.del_bytes (l_n.to_integer_32, (not globals_inst.virtual_op.to_boolean).to_integer, l_tmp___26).do_nothing
											end
										else
											if (undo_inst.u_save (globals_inst.curwin.item.w_cursor.lnum - 1, globals_inst.curwin.item.w_cursor.lnum + a_oap.item.line_count)) = 0 then
												Result := 0
												js.return
											end
											if not js.return_called then
												misc1_inst.truncate_line (1).do_nothing
												l_curpos.ce_gets (globals_inst.curwin.item.w_cursor)
												globals_inst.curwin.item.w_cursor.lnum := (globals_inst.curwin.item.w_cursor.lnum) + 1
												misc1_inst.del_lines (a_oap.item.line_count - 2, 0)
												globals_inst.curwin.item.w_cursor.col := 0
												if a_oap.item.op_type = 1 then
													if not (a_oap.item.is_VIsual).to_boolean then
														l_tmp___28 := 1
													else
														l_tmp___28 := 0
													end
												else
													l_tmp___28 := 0
												end
												misc1_inst.del_bytes (((a_oap.item.end2.col + 1) - (not (a_oap.item.inclusive).to_boolean).to_integer).to_integer_32, (not globals_inst.virtual_op.to_boolean).to_integer, l_tmp___28).do_nothing
												globals_inst.curwin.item.w_cursor := l_curpos
												do_join (2, 0, 0).do_nothing
											end
										end
									end
								end
							end
							if js.return_called then
								l_pos := -1 + 24 -- skip if block
							end
				when 22 then -- if:
								misc1_inst.msgmore (globals_inst.curbuf.item.b_ml.ml_line_count - l_old_lcount)
				when 23 then -- setmarks:
								if (a_oap.item.block_mode).to_boolean then
									globals_inst.curbuf.item.b_op_end.lnum := a_oap.item.end2.lnum
									globals_inst.curbuf.item.b_op_end.col := a_oap.item.start.col
								else
									globals_inst.curbuf.item.b_op_end := a_oap.item.start
								end
								globals_inst.curbuf.item.b_op_start := a_oap.item.start
								Result := 1
				when 24 then
							l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
				end

	mb_adjust_opend (a_oap: CE_POINTER [PD_OPARG_S])
		local
			l_p___0: CE_POINTER [NATURAL_8]
		do
			create l_p___0.make

			if (a_oap.item.inclusive).to_boolean then
				l_p___0.ce_gets (memline_inst.ml_get (a_oap.item.end2.lnum))
				a_oap.item.end2.col := a_oap.item.end2.col + (mbyte_inst.mb_tail_off (l_p___0, l_p___0 + a_oap.item.end2.col))
			end
		end

	op_replace (a_oap: CE_POINTER [PD_OPARG_S]; a_c: INTEGER_32): INTEGER_32
		local
			l_n: INTEGER_32
			l_numc: INTEGER_32
			l_num_chars: INTEGER_32
			l_newp: CE_POINTER [NATURAL_8]
			l_oldp: CE_POINTER [NATURAL_8]
			l_oldlen: NATURAL_32
			l_bd: PD_BLOCK_DEF
			l_vpos: PD_POS_T
			l_tmp___0: INTEGER_32
			l_tmp___7: NATURAL_32
			l_tmp___11: INTEGER_32
			l_end_vcol: INTEGER_32
			l_virtcols: INTEGER_32
			l_tmp___21: INTEGER_32
			l_tmp___22: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_newp.make
			create l_oldp.make
			create l_bd.make
			create l_vpos.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if ((globals_inst.curbuf.item.b_ml.ml_flags).bit_and (1)).to_boolean then
						Result := 1
						js.return
					elseif (a_oap.item.empty).to_boolean then
						Result := 1
						js.return
					end
					if not js.return_called then
						if globals_inst.has_mbyte.to_boolean then
							mb_adjust_opend (a_oap)
						end
						if (undo_inst.u_save (a_oap.item.start.lnum - 1, a_oap.item.end2.lnum + 1)) = 0 then
							Result := 0
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 29 -- skip if block
					end
				when 1 then -- if:
						if not ((a_oap.item.block_mode).to_boolean) then
							l_pos := -1 + 12 -- skip if block
						end
				when 2 then -- if:
						l_bd.is_MAX := ((globals_inst.curwin.item.w_curswant).to_integer_32 = 2147483647).to_integer
				when 3 then -- loop condition:
						if not (not js.loop_left and then (globals_inst.curwin.item.w_cursor.lnum <= a_oap.item.end2.lnum)) then
							l_pos := -1 + 11 -- skip loop
						end
				when 4 then -- loop body:
						js.reset
						globals_inst.curwin.item.w_cursor.col := 0
						block_prep (a_oap, l_bd.address, globals_inst.curwin.item.w_cursor.lnum, 1)
						if l_bd.textlen = 0 then
							if not globals_inst.virtual_op.to_boolean then
								js.continue
							elseif (l_bd.is_MAX).to_boolean then
								js.continue
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 10 -- skip if block
						end
				when 5 then -- if:
						if not (globals_inst.virtual_op.to_boolean) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						if (l_bd.is_short).to_boolean then
							if ((l_bd.textstart).item).to_integer_32 = 0 then
								l_vpos.lnum := globals_inst.curwin.item.w_cursor.lnum
								misc2_inst.getvpos (l_vpos.address, a_oap.item.start_vcol).do_nothing
								l_bd.startspaces := l_bd.startspaces + (l_vpos.coladd)
								l_n := l_bd.startspaces
							else
								l_pos := -1 + 8 -- goto _L___0
							end
						else
							l_pos := -1 + 8 -- goto _L___0
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else: | _L___0:
						if (l_bd.startspaces).to_boolean then
							l_n := l_bd.start_char_vcols - 1
						else
							l_n := 0
						end
				when 9 then
						if (l_bd.endspaces).to_boolean then
							if not (l_bd.is_oneChar).to_boolean then
								if l_bd.end_char_vcols > 0 then
									l_tmp___0 := l_bd.end_char_vcols - 1
								else
									l_tmp___0 := 0
								end
							else
								l_tmp___0 := 0
							end
						else
							l_tmp___0 := 0
						end
						l_n := l_n + l_tmp___0
						l_numc := (a_oap.item.end_vcol - a_oap.item.start_vcol) + 1
						if (l_bd.is_short).to_boolean then
							if not globals_inst.virtual_op.to_boolean then
								l_numc := l_numc - ((a_oap.item.end_vcol - l_bd.end_vcol) + 1)
							elseif (l_bd.is_MAX).to_boolean then
								l_numc := l_numc - ((a_oap.item.end_vcol - l_bd.end_vcol) + 1)
							end
						end
						if (globals_inst.mb_char2cells.integer_32_item ([a_c])) > 1 then
							if ((l_numc).bit_and (1)).to_boolean then
								if not (l_bd.is_short).to_boolean then
									l_bd.endspaces := (l_bd.endspaces) + 1
									l_n := l_n + 1
								end
							end
							l_numc := l_numc // (2)
						end
						l_num_chars := l_numc
						l_numc := l_numc * (globals_inst.mb_char2len.integer_32_item ([a_c]))
						l_n := l_n + (l_numc - l_bd.textlen)
						l_oldp.ce_gets (memline_inst.ml_get_curline)
						l_oldlen := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_oldp))
						l_newp.ce_gets (misc2_inst.alloc_check ((l_oldlen + {NATURAL_32} 1) + l_n.to_natural_32))
						if (l_newp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							js.continue
						end
				when 10 then -- if done
						if not js.loop_jumped then
							memset (create {CE_POINTER [ANY]}.make_cast (l_newp), ('%/0/').code, (l_oldlen + {NATURAL_32} 1) + l_n.to_natural_32).do_nothing
							memmove (create {CE_POINTER [ANY]}.make_cast (l_newp), create {CE_POINTER [ANY]}.make_cast (l_oldp), (l_bd.textcol).to_natural_32).do_nothing
							l_oldp.ce_gets (l_oldp + (l_bd.textcol + l_bd.textlen))
							misc2_inst.copy_spaces (l_newp + l_bd.textcol, (l_bd.startspaces).to_natural_32)
							if globals_inst.has_mbyte.to_boolean then
								l_n := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_newp))).to_integer_32
								from
								until
									js.loop_left
								loop
									js.reset
									l_num_chars := l_num_chars - 1
									if not (l_num_chars >= 0) then
										js.break
									end
									if not js.loop_jumped then
										l_n := l_n + (globals_inst.mb_char2bytes.integer_32_item ([a_c, l_newp + l_n]))
									end
								end
								js.reset
							else
								misc2_inst.copy_chars (l_newp + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_newp))).to_integer_32, l_numc.to_natural_32, a_c)
							end
							if not (l_bd.is_short).to_boolean then
								misc2_inst.copy_spaces (l_newp + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_newp))).to_integer_32, (l_bd.endspaces).to_natural_32)
								l_tmp___7 := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_oldp))
								memmove (create {CE_POINTER [ANY]}.make_cast ((l_newp + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_newp))).to_integer_32)), create {CE_POINTER [ANY]}.make_cast (l_oldp), l_tmp___7 + {NATURAL_32} 1).do_nothing
							end
							memline_inst.ml_replace (globals_inst.curwin.item.w_cursor.lnum, l_newp, 0).do_nothing
						end
						if not js.loop_left then
							globals_inst.curwin.item.w_cursor.lnum := (globals_inst.curwin.item.w_cursor.lnum) + 1
						end
						l_pos := -1 + 3 -- back to loop condition
				when 11 then -- loop done | if block done, skip else block:
						l_pos := -1 + 28
				when 12 then -- else:
						if a_oap.item.motion_type = 1 then
							a_oap.item.start.col := 0
							globals_inst.curwin.item.w_cursor.col := 0
							a_oap.item.end2.col := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((memline_inst.ml_get (a_oap.item.end2.lnum))))).to_integer_32
							if (a_oap.item.end2.col).to_boolean then
								a_oap.item.end2.col := (a_oap.item.end2.col) - 1
							end
						elseif not (a_oap.item.inclusive).to_boolean then
							misc2_inst.dec (create {CE_POINTER [PD_POS_T]}.make_shared (a_oap.c_pointer + {PD_OPARG_S}.end2_offset)).do_nothing
						end
				when 13 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 27 -- skip loop
						end
				when 14 then -- loop body:
						js.reset
						if globals_inst.curwin.item.w_cursor.lnum /= a_oap.item.end2.lnum then
							l_tmp___22 := (globals_inst.curwin.item.w_cursor.lnum < a_oap.item.end2.lnum).to_integer
						else
							if globals_inst.curwin.item.w_cursor.col /= a_oap.item.end2.col then
								l_tmp___21 := (globals_inst.curwin.item.w_cursor.col < a_oap.item.end2.col).to_integer
							else
								l_tmp___21 := (globals_inst.curwin.item.w_cursor.coladd < a_oap.item.end2.coladd).to_integer
							end
							l_tmp___22 := l_tmp___21
						end
						if not l_tmp___22.to_boolean then
							if globals_inst.curwin.item.w_cursor.lnum = a_oap.item.end2.lnum then
								if globals_inst.curwin.item.w_cursor.col = a_oap.item.end2.col then
									if globals_inst.curwin.item.w_cursor.coladd /= a_oap.item.end2.coladd then
										js.break
									end
								else
									js.break
								end
							else
								js.break
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 26 -- skip if block
						end
				when 15 then -- if:
						l_n := misc1_inst.gchar_cursor
						if l_n = 0 then
							l_pos := -1 + 24 -- skip if block
						end
				when 16 then -- if:
						if not ((globals_inst.mb_char2len.integer_32_item ([a_c])) > 1) then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						l_pos := -1 + 20 -- goto _L___1
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 19 then -- else:
						if not ((globals_inst.mb_char2len.integer_32_item ([l_n])) > 1) then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if: | _L___1:
						l_tmp___11 := globals_inst.mb_char2len.integer_32_item ([a_c])
						a_oap.item.end2.col := a_oap.item.end2.col + (l_tmp___11 - (globals_inst.mb_char2len.integer_32_item ([l_n])))
						l_n := globals_inst.State
						globals_inst.State := 80
						misc1_inst.ins_char (a_c)
						globals_inst.State := l_n
						misc2_inst.dec_cursor.do_nothing
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 22 then -- else:
						if l_n = 9 then
							l_end_vcol := 0
							if globals_inst.curwin.item.w_cursor.lnum = a_oap.item.end2.lnum then
								l_end_vcol := misc2_inst.getviscol2 (a_oap.item.end2.col, a_oap.item.end2.coladd)
							end
							misc2_inst.coladvance_force ((misc2_inst.getviscol)).do_nothing
							if globals_inst.curwin.item.w_cursor.lnum = a_oap.item.end2.lnum then
								misc2_inst.getvpos (create {CE_POINTER [PD_POS_T]}.make_shared (a_oap.c_pointer + {PD_OPARG_S}.end2_offset), l_end_vcol).do_nothing
							end
						end
						(memline_inst.ml_get_buf (globals_inst.curbuf, globals_inst.curwin.item.w_cursor.lnum, 1))[globals_inst.curwin.item.w_cursor.col] := a_c.to_natural_8
				when 23 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 25
				when 24 then -- else:
						if globals_inst.virtual_op.to_boolean then
							if globals_inst.curwin.item.w_cursor.lnum = a_oap.item.end2.lnum then
								l_virtcols := a_oap.item.end2.coladd
								if globals_inst.curwin.item.w_cursor.lnum = a_oap.item.start.lnum then
									if a_oap.item.start.col = a_oap.item.end2.col then
										if (a_oap.item.start.coladd).to_boolean then
											l_virtcols := l_virtcols - (a_oap.item.start.coladd)
										end
									end
								end
								misc2_inst.coladvance_force ((misc2_inst.getviscol2 (a_oap.item.end2.col, a_oap.item.end2.coladd)) + 1).do_nothing
								globals_inst.curwin.item.w_cursor.col := globals_inst.curwin.item.w_cursor.col - (l_virtcols + 1)
								from
								until
									not (not js.loop_left and then (l_virtcols >= 0))
								loop
									js.reset;
									(memline_inst.ml_get_buf (globals_inst.curbuf, globals_inst.curwin.item.w_cursor.lnum, 1))[globals_inst.curwin.item.w_cursor.col] := a_c.to_natural_8
									if (misc2_inst.inc (create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curwin.c_pointer + {PD_WINDOW_S}.w_cursor_offset))) = -1 then
										js.break
									end
									if not js.loop_jumped then
										l_virtcols := l_virtcols - 1
									end
								end
								js.reset
							end
						end
				when 25 then
						if (misc2_inst.inc_cursor) = -1 then
							js.break
						end
				when 26 then -- if done
						l_pos := -1 + 13 -- back to loop condition
				when 27 then -- loop done
						js.reset
				when 28 then -- if done
						globals_inst.curwin.item.w_cursor := a_oap.item.start
						misc2_inst.check_cursor
						misc1_inst.changed_lines (a_oap.item.start.lnum, a_oap.item.start.col, a_oap.item.end2.lnum + 1, 0)
						globals_inst.curbuf.item.b_op_start := a_oap.item.start
						globals_inst.curbuf.item.b_op_end := a_oap.item.end2
						Result := 1
				when 29 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	op_tilde (a_oap: CE_POINTER [PD_OPARG_S])
		local
			l_pos___3: PD_POS_T
			l_bd: PD_BLOCK_DEF
			l_did_change: INTEGER_32
			l_one_change: INTEGER_32
			l_ptr: CE_POINTER [NATURAL_8]
			l_tmp___6: INTEGER_32
			l_tmp___8: INTEGER_32
			l_tmp___9: INTEGER_32
			l_ptr___0: CE_POINTER [NATURAL_8]
			l_count___2: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_pos___3.make
			create l_bd.make
			create l_ptr.make
			create l_ptr___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_did_change := 0
					if (undo_inst.u_save (a_oap.item.start.lnum - 1, a_oap.item.end2.lnum + 1)) = 0 then
						js.return
					end
					if js.return_called then
						l_pos := -1 + 19 -- skip if block
					end
				when 1 then -- if:
						l_pos___3.ce_gets (a_oap.item.start)
						if not ((a_oap.item.block_mode).to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						from
						until
							not (l_pos___3.lnum <= a_oap.item.end2.lnum)
						loop
							block_prep (a_oap, l_bd.address, l_pos___3.lnum, 0)
							l_pos___3.col := l_bd.textcol
							l_one_change := swapchars (a_oap.item.op_type, l_pos___3.address, l_bd.textlen)
							l_did_change := (l_did_change).bit_or (l_one_change)
							if (netbeans_inst.netbeans_active).to_boolean then
								if l_one_change.to_boolean then
									l_ptr.ce_gets ((memline_inst.ml_get_buf (globals_inst.curbuf, l_pos___3.lnum, 0)))
									netbeans_inst.netbeans_removed (globals_inst.curbuf, l_pos___3.lnum, l_bd.textcol, (l_bd.textlen).to_integer_32)
									netbeans_inst.netbeans_inserted (globals_inst.curbuf, l_pos___3.lnum, l_bd.textcol, l_ptr + l_bd.textcol, l_bd.textlen)
								end
							end
							l_pos___3.lnum := (l_pos___3.lnum) + 1
						end
						if l_did_change.to_boolean then
							misc1_inst.changed_lines (a_oap.item.start.lnum, 0, a_oap.item.end2.lnum + 1, 0)
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 4 then -- else:
						if a_oap.item.motion_type = 1 then
							a_oap.item.start.col := 0
							l_pos___3.col := 0
							a_oap.item.end2.col := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((memline_inst.ml_get (a_oap.item.end2.lnum))))).to_integer_32
							if (a_oap.item.end2.col).to_boolean then
								a_oap.item.end2.col := (a_oap.item.end2.col) - 1
							end
						elseif not (a_oap.item.inclusive).to_boolean then
							misc2_inst.dec (create {CE_POINTER [PD_POS_T]}.make_shared (a_oap.c_pointer + {PD_OPARG_S}.end2_offset)).do_nothing
						end
						if l_pos___3.lnum /= a_oap.item.end2.lnum then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_did_change := swapchars (a_oap.item.op_type, l_pos___3.address, (a_oap.item.end2.col - l_pos___3.col) + 1)
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 7 then -- else: | loop condition:
						if js.loop_left then
							l_pos := -1 + 16 -- skip loop
						end
				when 8 then -- loop body:
						js.reset
						if l_pos___3.lnum = a_oap.item.end2.lnum then
							l_tmp___6 := a_oap.item.end2.col + 1
						else
							l_tmp___6 := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((memline_inst.ml_get_pos (l_pos___3.address))))).to_integer_32
						end
						l_did_change := (l_did_change).bit_or ((swapchars (a_oap.item.op_type, l_pos___3.address, l_tmp___6)))
						if a_oap.item.end2.lnum /= l_pos___3.lnum then
							l_tmp___9 := (a_oap.item.end2.lnum < l_pos___3.lnum).to_integer
						else
							if a_oap.item.end2.col /= l_pos___3.col then
								l_tmp___8 := (a_oap.item.end2.col < l_pos___3.col).to_integer
							else
								l_tmp___8 := (a_oap.item.end2.coladd < l_pos___3.coladd).to_integer
							end
							l_tmp___9 := l_tmp___8
						end
						if not (l_tmp___9.to_boolean) then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						js.break
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 11 then -- else:
						if a_oap.item.end2.lnum /= l_pos___3.lnum then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:
						if a_oap.item.end2.col = l_pos___3.col then
							if a_oap.item.end2.coladd = l_pos___3.coladd then
								js.break
							else
								l_pos := -1 + 14 -- goto _L___0
							end
						else
							l_pos := -1 + 14 -- goto _L___0
						end
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 14 then -- else: | _L___0:
						if (misc2_inst.inc (l_pos___3.address)) = -1 then
							js.break
						end
				when 15 then -- if done
						l_pos := -1 + 7 -- back to loop condition
				when 16 then -- loop done
						js.reset
				when 17 then -- if done
						if l_did_change.to_boolean then
							misc1_inst.changed_lines (a_oap.item.start.lnum, a_oap.item.start.col, a_oap.item.end2.lnum + 1, 0)
							if (netbeans_inst.netbeans_active).to_boolean then
								if l_did_change.to_boolean then
									l_pos___3.ce_gets (a_oap.item.start)
									from
									until
										not (l_pos___3.lnum < a_oap.item.end2.lnum)
									loop
										l_ptr___0.ce_gets (memline_inst.ml_get_buf (globals_inst.curbuf, l_pos___3.lnum, 0))
										l_count___2 := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_ptr___0))).to_integer_32 - l_pos___3.col
										netbeans_inst.netbeans_removed (globals_inst.curbuf, l_pos___3.lnum, l_pos___3.col, l_count___2.to_integer_32)
										netbeans_inst.netbeans_inserted (globals_inst.curbuf, l_pos___3.lnum, l_pos___3.col, l_ptr___0 + l_pos___3.col, l_count___2)
										l_pos___3.col := 0
										l_pos___3.lnum := (l_pos___3.lnum) + 1
									end
									l_ptr___0.ce_gets (memline_inst.ml_get_buf (globals_inst.curbuf, l_pos___3.lnum, 0))
									l_count___2 := (a_oap.item.end2.col - l_pos___3.col) + 1
									netbeans_inst.netbeans_removed (globals_inst.curbuf, l_pos___3.lnum, l_pos___3.col, l_count___2.to_integer_32)
									netbeans_inst.netbeans_inserted (globals_inst.curbuf, l_pos___3.lnum, l_pos___3.col, l_ptr___0 + l_pos___3.col, l_count___2)
								end
							end
						end
				when 18 then -- if done
						if not l_did_change.to_boolean then
							if (a_oap.item.is_VIsual).to_boolean then
								screen_inst.redraw_curbuf_later (20)
							end
						end
						globals_inst.curbuf.item.b_op_start := a_oap.item.start
						globals_inst.curbuf.item.b_op_end := a_oap.item.end2
						if a_oap.item.line_count > option_inst.p_report then
							if a_oap.item.line_count = 1 then
								message_inst.msg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("1 line changed"))))).do_nothing
							else
								message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("%%ld lines changed")))), a_oap.item.line_count]).do_nothing
							end
						end
				when 19 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	swapchars (a_op_type: INTEGER_32; a_pos___3: CE_POINTER [PD_POS_T]; a_length: INTEGER_32): INTEGER_32
		local
			l_todo: INTEGER_32
			l_did_change: INTEGER_32
			js: JUMP_STATE
		do
			l_did_change := 0
			l_todo := a_length
			from
			until
				not (not js.loop_left and then (l_todo > 0))
			loop
				js.reset
				if globals_inst.has_mbyte.to_boolean then
					l_todo := l_todo - ((globals_inst.mb_ptr2len.integer_32_item ([(memline_inst.ml_get_pos (a_pos___3))])) - 1)
				end
				l_did_change := (l_did_change).bit_or ((swapchar (a_op_type, a_pos___3)))
				if (misc2_inst.inc (a_pos___3)) = -1 then
					js.break
				end
				if not js.loop_jumped then
					l_todo := l_todo - 1
				end
			end
			js.reset
			Result := l_did_change
		end

	swapchar (a_op_type: INTEGER_32; a_pos___3: CE_POINTER [PD_POS_T]): INTEGER_32
		local
			l_c: INTEGER_32
			l_nc: INTEGER_32
			l_sp: PD_POS_T
			l_sp___0: PD_POS_T
			l_tmp___4: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_sp.make
			create l_sp___0.make
			create l_tmp___4.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_c := misc1_inst.gchar_pos (a_pos___3)
					if l_c >= 128 then
						if a_op_type = 15 then
							Result := 0
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						if a_op_type /= 11 then
							l_pos := -1 + 8 -- skip if block
						end
				when 2 then -- if:
						if l_c /= 223 then
							l_pos := -1 + 8 -- skip if block
						end
				when 3 then -- if:
						if not (globals_inst.enc_latin1like.to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 6 then -- else:
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (option_inst.p_enc), ce_string ("iso-8859-2"))) /= 0 then
							l_pos := -1 + 8 -- skip if block
						end
				when 7 then -- if: | _L:
						l_sp.ce_gets (globals_inst.curwin.item.w_cursor)
						globals_inst.curwin.item.w_cursor := a_pos___3.item
						misc1_inst.del_char (0).do_nothing
						misc1_inst.ins_char (('S').code)
						misc1_inst.ins_char (('S').code)
						globals_inst.curwin.item.w_cursor := l_sp
						misc2_inst.inc (a_pos___3).do_nothing
				when 8 then -- if done | if done | if done
						if globals_inst.enc_dbcs /= 0 then
							if l_c >= 256 then
								Result := 0
								js.return
							end
						end
				when 9 then -- if done
					if js.return_called then
						l_pos := -1 + 22 -- skip if block
					end
				when 10 then -- if:
						l_nc := l_c
						if (charset_inst.vim_islower (l_c)).to_boolean then
							if a_op_type = 15 then
								l_nc := ((l_c - 97) + 13) \\ 26 + 97
							elseif a_op_type /= 12 then
								l_nc := charset_inst.vim_toupper (l_c)
							end
						elseif (charset_inst.vim_isupper (l_c)).to_boolean then
							if a_op_type = 15 then
								l_nc := ((l_c - 65) + 13) \\ 26 + 65
							elseif a_op_type /= 11 then
								l_nc := charset_inst.vim_tolower (l_c)
							end
						end
						if l_nc = l_c then
							l_pos := -1 + 22 -- skip if block
						end
				when 11 then -- if:
						if not (globals_inst.enc_utf8.to_boolean) then
							l_pos := -1 + 20 -- skip if block
						end
				when 12 then -- if:
						if not (l_c >= 128) then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						l_pos := -1 + 16 -- goto _L___0
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 15 then -- else:
						if not (l_nc >= 128) then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if: | _L___0:
						l_sp___0.ce_gets (globals_inst.curwin.item.w_cursor)
						globals_inst.curwin.item.w_cursor := a_pos___3.item
						misc1_inst.del_bytes ((mbyte_inst.utf_ptr2len ((memline_inst.ml_get_cursor))).to_integer_32, 0, 0).do_nothing
						misc1_inst.ins_char (l_nc)
						globals_inst.curwin.item.w_cursor := l_sp___0
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 18 then -- else:
						l_tmp___4.ce_gets (memline_inst.ml_get_buf (globals_inst.curbuf, a_pos___3.item.lnum, 1))
						l_tmp___4[a_pos___3.item.col] := l_nc.to_natural_8
				when 19 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 21
				when 20 then -- else:
						l_tmp___4.ce_gets (memline_inst.ml_get_buf (globals_inst.curbuf, a_pos___3.item.lnum, 1))
						l_tmp___4[a_pos___3.item.col] := l_nc.to_natural_8
				when 21 then
						Result := 1
						js.return
				when 22 then -- if done | if done
						if not js.return_called then
							Result := 0
						end
				when 23 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	op_insert (a_oap: CE_POINTER [PD_OPARG_S]; a_count1: INTEGER_32)
		local
			l_ins_len: INTEGER_32
			l_pre_textlen: INTEGER_32
			l_firstline: CE_POINTER [NATURAL_8]
			l_ins_text: CE_POINTER [NATURAL_8]
			l_bd: PD_BLOCK_DEF
			l_i___0: INTEGER_32
			l_old_ve_flags: INTEGER_32
			l_tmp___1: INTEGER_32
			l_bd2: PD_BLOCK_DEF
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_firstline.make
			create l_ins_text.make
			create l_bd.make
			create l_bd2.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_pre_textlen := 0
					l_bd.is_MAX := ((globals_inst.curwin.item.w_curswant).to_integer_32 = 2147483647).to_integer
					globals_inst.curwin.item.w_cursor.lnum := a_oap.item.start.lnum
					screen_inst.update_screen (20)
					if (a_oap.item.block_mode).to_boolean then
						if globals_inst.curwin.item.w_cursor.coladd > 0 then
							l_old_ve_flags := option_inst.ve_flags.to_integer_32
							option_inst.ve_flags := {NATURAL_32} 4
							if (undo_inst.u_save_cursor) = 0 then
								js.return
							end
							if not js.return_called then
								if a_oap.item.op_type = 18 then
									l_tmp___1 := a_oap.item.end_vcol + 1
								else
									l_tmp___1 := (misc2_inst.getviscol)
								end
								misc2_inst.coladvance_force (l_tmp___1).do_nothing
								if a_oap.item.op_type = 18 then
									globals_inst.curwin.item.w_cursor.col := (globals_inst.curwin.item.w_cursor.col) - 1
								end
								option_inst.ve_flags := l_old_ve_flags.to_natural_32
							end
						end
						if not js.return_called then
							block_prep (a_oap, l_bd.address, a_oap.item.start.lnum, 1)
							l_firstline.ce_gets ((memline_inst.ml_get (a_oap.item.start.lnum)) + l_bd.textcol)
							if a_oap.item.op_type = 18 then
								l_firstline.ce_gets (l_firstline + (l_bd.textlen))
							end
							l_pre_textlen := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_firstline))).to_integer_32
						end
					end
					if not (not js.return_called and then (a_oap.item.op_type = 18)) then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						if not ((a_oap.item.block_mode).to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if globals_inst.curwin.item.w_cursor.coladd = 0 then
							globals_inst.curwin.item.w_set_curswant := 1
							from
							until
								js.loop_left
							loop
								js.reset
								if ((memline_inst.ml_get_cursor).item).to_integer_32 /= 0 then
									if not (globals_inst.curwin.item.w_cursor.col < l_bd.textcol + l_bd.textlen) then
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped then
									globals_inst.curwin.item.w_cursor.col := (globals_inst.curwin.item.w_cursor.col) + 1
								end
							end
							js.reset
							if (l_bd.is_short).to_boolean then
								if not (l_bd.is_MAX).to_boolean then
									if (undo_inst.u_save_cursor) = 0 then
										js.return
									end
									if not js.return_called then
										l_i___0 := 0
										from
										until
											not (l_i___0 < l_bd.endspaces)
										loop
											misc1_inst.ins_char ((' ').code)
											l_i___0 := l_i___0 + 1
										end
										l_bd.textlen := l_bd.textlen + (l_bd.endspaces)
									end
								end
							end
						else
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						globals_inst.curwin.item.w_cursor := a_oap.item.end2
						misc2_inst.check_cursor_col
						if ((memline_inst.ml_get (globals_inst.curwin.item.w_cursor.lnum)).item).to_integer_32 /= 0 then
							if a_oap.item.start_vcol /= a_oap.item.end_vcol then
								misc2_inst.inc_cursor.do_nothing
							end
						end
				when 5 then -- if done
						if not js.return_called then
							edit_inst.edit (('%/0/').code, 0, a_count1).do_nothing
							if globals_inst.curwin.item.w_cursor.lnum /= a_oap.item.start.lnum then
								js.return
							elseif globals_inst.got_int.to_boolean then
								js.return
							end
						end
						if not (not js.return_called and then ((a_oap.item.block_mode).to_boolean)) then
							l_pos := -1 + 12 -- skip if block
						end
				when 6 then -- if:
							block_prep (a_oap, l_bd2.address, a_oap.item.start.lnum, 1)
							if (l_bd.is_MAX).to_boolean then
								l_pos := -1 + 9 -- skip if block
							end
				when 7 then -- if:
							l_pos := -1 + 10 -- goto _L___0
				when 8 then -- if block done, skip else block:
							l_pos := -1 + 11
				when 9 then -- else:
							if not (l_bd2.textlen < l_bd.textlen) then
								l_pos := -1 + 11 -- skip if block
							end
				when 10 then -- if: | _L___0:
							if a_oap.item.op_type = 18 then
								l_pre_textlen := l_pre_textlen + (l_bd2.textlen - l_bd.textlen).to_integer_32
								if (l_bd2.endspaces).to_boolean then
									l_bd2.textlen := (l_bd2.textlen) - 1
								end
							end
							l_bd.textcol := l_bd2.textcol
							l_bd.textlen := l_bd2.textlen
				when 11 then -- if done
							l_firstline.ce_gets ((memline_inst.ml_get (a_oap.item.start.lnum)) + l_bd.textcol)
							if a_oap.item.op_type = 18 then
								l_firstline.ce_gets (l_firstline + (l_bd.textlen))
							end
							l_ins_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_firstline))).to_integer_32 - l_pre_textlen
							if l_ins_len > 0 then
								l_ins_text.ce_gets (misc2_inst.vim_strnsave (l_firstline, l_ins_len.to_integer_32))
								if (l_ins_text.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									if (undo_inst.u_save (a_oap.item.start.lnum, a_oap.item.end2.lnum + 1)) = 1 then
										block_insert (a_oap, l_ins_text, (a_oap.item.op_type = 17).to_integer, l_bd.address)
									end
									globals_inst.curwin.item.w_cursor.col := a_oap.item.start.col
									misc2_inst.check_cursor
									misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_ins_text))
								end
							end
				when 12 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	op_change (a_oap: CE_POINTER [PD_OPARG_S]): INTEGER_32
		local
			l_l: INTEGER_32
			l_retval: INTEGER_32
			l_offset: INTEGER_32
			l_linenr: INTEGER_32
			l_ins_len: INTEGER_32
			l_pre_textlen: INTEGER_32
			l_pre_indent: INTEGER_32
			l_firstline: CE_POINTER [NATURAL_8]
			l_ins_text: CE_POINTER [NATURAL_8]
			l_newp: CE_POINTER [NATURAL_8]
			l_oldp: CE_POINTER [NATURAL_8]
			l_bd: PD_BLOCK_DEF
			l_tmp___2: INTEGER_32
			l_new_indent: INTEGER_32
			l_vpos: PD_POS_T
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_firstline.make
			create l_ins_text.make
			create l_newp.make
			create l_oldp.make
			create l_bd.make
			create l_vpos.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_pre_textlen := 0
					l_pre_indent := 0
					l_l := a_oap.item.start.col
					if a_oap.item.motion_type = 1 then
						l_l := 0
						if not option_inst.p_paste.to_boolean then
							if (globals_inst.curbuf.item.b_p_si).to_boolean then
								if not (globals_inst.curbuf.item.b_p_cin).to_boolean then
									globals_inst.can_si := 1
								end
							end
						end
					end
					if ((globals_inst.curbuf.item.b_ml.ml_flags).bit_and (1)).to_boolean then
						if (undo_inst.u_save_cursor) = 0 then
							Result := 0
							js.return
						end
					elseif (op_delete (a_oap)) = 0 then
						Result := 0
						js.return
					end
					if js.return_called then
						l_pos := -1 + 17 -- skip if block
					end
				when 1 then -- if:
						if l_l > globals_inst.curwin.item.w_cursor.col then
							if ((memline_inst.ml_get (globals_inst.curwin.item.w_cursor.lnum)).item).to_integer_32 /= 0 then
								if not globals_inst.virtual_op.to_boolean then
									misc2_inst.inc_cursor.do_nothing
								end
							end
						end
						if (a_oap.item.block_mode).to_boolean then
							if globals_inst.virtual_op.to_boolean then
								if globals_inst.curwin.item.w_cursor.coladd > 0 then
									l_tmp___2 := misc2_inst.getviscol
									misc2_inst.coladvance_force (l_tmp___2).do_nothing
								elseif (misc1_inst.gchar_cursor) = 0 then
									l_tmp___2 := misc2_inst.getviscol
									misc2_inst.coladvance_force (l_tmp___2).do_nothing
								end
							end
							l_firstline.ce_gets (memline_inst.ml_get (a_oap.item.start.lnum))
							l_pre_textlen := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_firstline))).to_integer_32
							l_pre_indent := ((charset_inst.skipwhite (l_firstline)).distance (l_firstline)).to_integer_32
							l_bd.textcol := globals_inst.curwin.item.w_cursor.col
						end
						if a_oap.item.motion_type = 1 then
							edit_inst.fix_indent
						end
						l_retval := edit_inst.edit (('%/0/').code, 0, (1).to_integer_32)
						if not ((a_oap.item.block_mode).to_boolean) then
							l_pos := -1 + 16 -- skip if block
						end
				when 2 then -- if:
						if a_oap.item.start.lnum = a_oap.item.end2.lnum then
							l_pos := -1 + 16 -- skip if block
						end
				when 3 then -- if:
						if globals_inst.got_int.to_boolean then
							l_pos := -1 + 16 -- skip if block
						end
				when 4 then -- if:
						l_firstline.ce_gets (memline_inst.ml_get (a_oap.item.start.lnum))
						if l_bd.textcol > l_pre_indent.to_integer_32 then
							l_new_indent := ((charset_inst.skipwhite (l_firstline)).distance (l_firstline)).to_integer_32
							l_pre_textlen := l_pre_textlen + (l_new_indent - l_pre_indent)
							l_bd.textcol := ((l_bd.textcol).to_integer_32 + (l_new_indent - l_pre_indent)).to_integer_32
						end
						l_ins_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_firstline))).to_integer_32 - l_pre_textlen
						if not (l_ins_len > 0) then
							l_pos := -1 + 16 -- skip if block
						end
				when 5 then -- if:
						l_ins_text.ce_gets (misc2_inst.alloc_check ((l_ins_len + 1).to_natural_32))
						if (l_ins_text.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 15 -- skip if block
						end
				when 6 then -- if:
						misc2_inst.vim_strncpy (l_ins_text, l_firstline + l_bd.textcol, l_ins_len.to_natural_32)
						l_linenr := a_oap.item.start.lnum + 1
				when 7 then -- loop condition:
						if not (l_linenr <= a_oap.item.end2.lnum) then
							l_pos := -1 + 14 -- skip loop
						end
				when 8 then -- loop body:
						js.reset
						block_prep (a_oap, l_bd.address, l_linenr, 1)
						if (l_bd.is_short).to_boolean then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						l_pos := -1 + 12 -- goto _L
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 11 then -- else:
						if not (globals_inst.virtual_op.to_boolean) then
							l_pos := -1 + 13 -- skip if block
						end
				when 12 then -- if: | _L:
						if (l_bd.is_short).to_boolean then
							l_vpos.lnum := l_linenr
							misc2_inst.getvpos (l_vpos.address, a_oap.item.start_vcol).do_nothing
						else
							l_vpos.coladd := 0
						end
						l_oldp.ce_gets (memline_inst.ml_get (l_linenr))
						l_newp.ce_gets (misc2_inst.alloc_check (((((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_oldp))) + (l_vpos.coladd).to_natural_32).to_natural_32 + l_ins_len.to_natural_32) + {NATURAL_32} 1).to_natural_32))
						if (l_newp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							js.continue
						end
						if not js.loop_jumped then
							memmove (create {CE_POINTER [ANY]}.make_cast (l_newp), create {CE_POINTER [ANY]}.make_cast (l_oldp), (l_bd.textcol).to_natural_32).do_nothing
							l_offset := (l_bd.textcol).to_integer_32
							misc2_inst.copy_spaces (l_newp + l_offset, (l_vpos.coladd).to_natural_32)
							l_offset := l_offset + (l_vpos.coladd).to_integer_32
							memmove (create {CE_POINTER [ANY]}.make_cast ((l_newp + l_offset)), create {CE_POINTER [ANY]}.make_cast (l_ins_text), l_ins_len.to_natural_32).do_nothing
							l_offset := l_offset + l_ins_len
							l_oldp.ce_gets (l_oldp + (l_bd.textcol))
							memmove (create {CE_POINTER [ANY]}.make_cast ((l_newp + l_offset)), create {CE_POINTER [ANY]}.make_cast (l_oldp), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_oldp))) + {NATURAL_32} 1).do_nothing
							memline_inst.ml_replace (l_linenr, l_newp, 0).do_nothing
						end
				when 13 then -- if done
						l_linenr := l_linenr + 1
						l_pos := -1 + 7 -- back to loop condition
				when 14 then -- loop done
						misc2_inst.check_cursor
						misc1_inst.changed_lines (a_oap.item.start.lnum + 1, 0, a_oap.item.end2.lnum + 1, 0)
				when 15 then -- if done
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_ins_text))
				when 16 then -- if done | if done | if done | if done
						Result := l_retval
				when 17 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	init_yank
		local
			l_i___0: INTEGER_32
		do
			l_i___0 := 0
			from
			until
				not (l_i___0 < 40)
			loop
				y_regs[l_i___0].y_array := create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer)
				l_i___0 := l_i___0 + 1
			end
		end

	free_yank (a_n: INTEGER_32)
		local
			l_i___0: INTEGER_32
			js: JUMP_STATE
		do
			if ((y_current.item.y_array).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				l_i___0 := a_n
				from
				until
					js.loop_left
				loop
					js.reset
					l_i___0 := l_i___0 - 1
					if not (l_i___0 >= 0) then
						js.break
					end
					if not js.loop_jumped then
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (y_current.item.y_array[l_i___0]))
					end
				end
				js.reset
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (y_current.item.y_array))
				y_current.item.y_array := create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer)
			end
		end

	free_yank_all
		do
			free_yank (y_current.item.y_size)
		end

	op_yank (a_oap: CE_POINTER [PD_OPARG_S]; a_deleting: INTEGER_32; a_mess: INTEGER_32): INTEGER_32
		local
			l_y_idx: INTEGER_32
			l_curr: CE_POINTER [PD_YANKREG]
			l_newreg: PD_YANKREG
			l_new_ptr: CE_POINTER [CE_POINTER [NATURAL_8]]
			l_lnum: INTEGER_32
			l_j: INTEGER_32
			l_yanktype: INTEGER_32
			l_yanklines: INTEGER_32
			l_yankendlnum: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_pnew: CE_POINTER [NATURAL_8]
			l_bd: PD_BLOCK_DEF
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_startcol: INTEGER_32
			l_endcol: INTEGER_32
			l_is_oneChar: INTEGER_32
			l_cs: INTEGER_32
			l_ce: INTEGER_32
			l_tmp___8: NATURAL_32
			l_tmp___10: INTEGER_32
			l_tmp___12: INTEGER_32
			l_tmp___13: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_curr.make
			create l_newreg.make
			create l_new_ptr.make
			create l_p___0.make
			create l_pnew.make
			create l_bd.make
			create l_tmp___2.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_yanktype := a_oap.item.motion_type
					l_yanklines := a_oap.item.line_count
					l_yankendlnum := a_oap.item.end2.lnum
					if a_oap.item.regname /= 0 then
						if not (valid_yank_reg (a_oap.item.regname, 1)).to_boolean then
							misc1_inst.beep_flush
							Result := 0
							js.return
						end
					end
					if not js.return_called and then (a_oap.item.regname = 95) then
						Result := 1
						js.return
					end
					if js.return_called then
						l_pos := -1 + 14 -- skip if block
					end
				when 1 then -- if:
						if (globals_inst.clip_star.available).to_boolean then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if a_oap.item.regname = 42 then
							a_oap.item.regname := 0
						else
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						if not (globals_inst.clip_plus.available).to_boolean then
							if a_oap.item.regname = 43 then
								a_oap.item.regname := 0
							end
						end
				when 5 then
						if not a_deleting.to_boolean then
							get_yank_register (a_oap.item.regname, 1)
						end
						l_curr.ce_gets (y_current)
						if y_append.to_boolean then
							if ((y_current.item.y_array).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								y_current.ce_gets (l_newreg.address)
							else
								free_yank_all
							end
						else
							free_yank_all
						end
						if a_oap.item.motion_type /= 0 then
							l_pos := -1 + 13 -- skip if block
						end
				when 6 then -- if:
						if a_oap.item.start.col /= 0 then
							l_pos := -1 + 13 -- skip if block
						end
				when 7 then -- if:
						if (a_oap.item.inclusive).to_boolean then
							l_pos := -1 + 13 -- skip if block
						end
				when 8 then -- if:
						if (a_oap.item.is_VIsual).to_boolean then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						l_pos := -1 + 12 -- goto _L___0
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 11 then -- else:
						if (option_inst.p_sel.item).to_integer_32 /= 111 then
							l_pos := -1 + 13 -- skip if block
						end
				when 12 then -- if: | _L___0:
						if not (a_oap.item.block_mode).to_boolean then
							if a_oap.item.end2.col = 0 then
								if l_yanklines > 1 then
									l_yanktype := 1
									l_yankendlnum := l_yankendlnum - 1
									l_yanklines := l_yanklines - 1
								end
							end
						end
				when 13 then -- if done | if done | if done | if done
						y_current.item.y_size := l_yanklines
						y_current.item.y_type := l_yanktype.to_natural_8
						y_current.item.y_width := 0
						y_current.item.y_array := create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast ((misc2_inst.lalloc_clear ((Pointer_bytes.to_natural_32).to_natural_32 * l_yanklines.to_natural_32, 1)))
						if ((y_current.item.y_array).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							y_current.ce_gets (l_curr)
							Result := 0
							js.return
						end
				when 14 then -- if done
					if js.return_called then
						l_pos := -1 + 61 -- skip if block
					end
				when 15 then -- if:
						l_y_idx := 0
						l_lnum := a_oap.item.start.lnum
						if (a_oap.item.block_mode).to_boolean then
							y_current.item.y_type := (2).to_natural_8
							y_current.item.y_width := a_oap.item.end_vcol - a_oap.item.start_vcol
							if (globals_inst.curwin.item.w_curswant).to_integer_32 = 2147483647 then
								if y_current.item.y_width > 0 then
									y_current.item.y_width := (y_current.item.y_width) - 1
								end
							end
						end
				when 16 then -- loop condition:
						if not (l_lnum <= l_yankendlnum) then
							l_pos := -1 + 33 -- skip loop
						end
				when 17 then -- loop body:
						inspect (y_current.item.y_type).to_integer_32 -- switch 1 head
						when 2 then l_pos := -1 + 18
						when 1 then l_pos := -1 + 20
						when 0 then l_pos := -1 + 22
						else l_pos := -1 + 32
						end
				when 18 then -- switch 1, case 2
						block_prep (a_oap, l_bd.address, l_lnum, 0)
						if (yank_copy_line (l_bd.address, l_y_idx)) = 0 then
							l_pos := -1 + 62 -- goto fail
						end
				when 19 then
						l_pos := -1 + 32 -- switch 1; break
				when 20 then -- switch 1, case 1
						l_tmp___2.ce_gets (misc2_inst.vim_strsave ((memline_inst.ml_get (l_lnum))))
						y_current.item.y_array[l_y_idx] := l_tmp___2
						if (l_tmp___2.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 62 -- goto fail
						end
				when 21 then
						l_pos := -1 + 32 -- switch 1; break
				when 22 then -- switch 1, case 0
						l_startcol := 0
						l_endcol := (2147483647).to_integer_32
						l_is_oneChar := 0
						l_p___0.ce_gets (memline_inst.ml_get (l_lnum))
						l_bd.startspaces := 0
						l_bd.endspaces := 0
						if l_lnum = a_oap.item.start.lnum then
							l_startcol := a_oap.item.start.col
							if globals_inst.virtual_op.to_boolean then
								charset_inst.getvcol (globals_inst.curwin, create {CE_POINTER [PD_POS_T]}.make_shared (a_oap.c_pointer + {PD_OPARG_S}.start_offset), create {CE_POINTER [INTEGER_32]}.make_shared ($l_cs), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared ($l_ce))
								if l_ce /= l_cs then
									if a_oap.item.start.coladd > 0 then
										l_bd.startspaces := ((l_ce - l_cs) + 1) - a_oap.item.start.coladd
										l_startcol := l_startcol + 1
									end
								end
							end
						end
						if l_lnum /= a_oap.item.end2.lnum then
							l_pos := -1 + 30 -- skip if block
						end
				when 23 then -- if:
						l_endcol := a_oap.item.end2.col
						if not (globals_inst.virtual_op.to_boolean) then
							l_pos := -1 + 30 -- skip if block
						end
				when 24 then -- if:
						charset_inst.getvcol (globals_inst.curwin, create {CE_POINTER [PD_POS_T]}.make_shared (a_oap.c_pointer + {PD_OPARG_S}.end2_offset), create {CE_POINTER [INTEGER_32]}.make_shared ($l_cs), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared ($l_ce))
						if (l_p___0[l_endcol]).to_integer_32 /= 0 then
							l_pos := -1 + 27 -- skip if block
						end
				when 25 then -- if:
						l_pos := -1 + 29 -- goto _L___1
				when 26 then -- if block done, skip else block:
						l_pos := -1 + 30
				when 27 then -- else:
						if not (l_cs + a_oap.item.end2.coladd < l_ce) then
							l_pos := -1 + 30 -- skip if block
						end
				when 28 then -- if:
						if (globals_inst.mb_head_off.integer_32_item ([l_p___0, l_p___0 + l_endcol])) /= 0 then
							l_pos := -1 + 30 -- skip if block
						end
				when 29 then -- if: | _L___1:
						if a_oap.item.start.lnum = a_oap.item.end2.lnum then
							if a_oap.item.start.col = a_oap.item.end2.col then
								l_is_oneChar := 1
								l_bd.startspaces := (a_oap.item.end2.coladd - a_oap.item.start.coladd) + a_oap.item.inclusive
								l_endcol := l_startcol
							else
								l_bd.endspaces := a_oap.item.end2.coladd + a_oap.item.inclusive
								l_endcol := l_endcol - (a_oap.item.inclusive)
							end
						else
							l_bd.endspaces := a_oap.item.end2.coladd + a_oap.item.inclusive
							l_endcol := l_endcol - (a_oap.item.inclusive)
						end
				when 30 then -- if done | if done | if done | if done
						if l_startcol > l_endcol then
							l_bd.textlen := 0
						elseif l_is_oneChar.to_boolean then
							l_bd.textlen := 0
						else
							if l_endcol.to_integer_32 = 2147483647 then
								l_endcol := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0))).to_integer_32
							end
							l_bd.textlen := (l_endcol - l_startcol) + a_oap.item.inclusive
						end
						l_bd.textstart := l_p___0 + l_startcol
						if (yank_copy_line (l_bd.address, l_y_idx)) = 0 then
							l_pos := -1 + 62 -- goto fail
						end
				when 31 then
						l_pos := -1 + 32 -- switch 1; break
				when 32 then -- switch 1, done:
						l_lnum := l_lnum + 1
						l_y_idx := l_y_idx + 1
						l_pos := -1 + 16 -- back to loop condition
				when 33 then -- loop done
						if (l_curr.c_pointer.to_integer_32).to_natural_32 = (y_current.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 44 -- skip if block
						end
				when 34 then -- if:
						l_new_ptr.ce_gets (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast ((misc2_inst.lalloc ((Pointer_bytes.to_natural_32).to_natural_32 * (l_curr.item.y_size + y_current.item.y_size).to_natural_32, 1))))
						if (l_new_ptr.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 62 -- goto fail
						end
				when 35 then
						l_j := 0
						from
						until
							not (l_j < l_curr.item.y_size)
						loop
							l_new_ptr[l_j] := l_curr.item.y_array[l_j]
							l_j := l_j + 1
						end
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_curr.item.y_array))
						l_curr.item.y_array := l_new_ptr
						if l_yanktype = 1 then
							l_curr.item.y_type := (1).to_natural_8
						end
						if (l_curr.item.y_type).to_integer_32 /= 0 then
							l_pos := -1 + 42 -- skip if block
						end
				when 36 then -- if:
						if ((misc2_inst.vim_strchr (option_inst.p_cpo, ('>').code)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_pos := -1 + 40 -- skip if block
						end
				when 37 then -- if:
						l_tmp___8 := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_curr.item.y_array[(l_curr.item.y_size - 1)]))
						l_pnew.ce_gets (misc2_inst.lalloc (((l_tmp___8 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (y_current.item.y_array[0])))) + {NATURAL_32} 1).to_natural_32, 1))
						if (l_pnew.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_y_idx := y_current.item.y_size - 1
							l_pos := -1 + 62 -- goto fail
						end
				when 38 then
						l_j := l_j - 1
						strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_pnew), create {CE_POINTER [INTEGER_8]}.make_cast (l_curr.item.y_array[l_j])).do_nothing
						strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_pnew), create {CE_POINTER [INTEGER_8]}.make_cast (y_current.item.y_array[0])).do_nothing
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_curr.item.y_array[l_j]))
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (y_current.item.y_array[0]))
						l_tmp___10 := l_j
						l_j := l_j + 1
						l_curr.item.y_array[l_tmp___10] := l_pnew
						l_y_idx := 1
				when 39 then -- if block done, skip else block:
						l_pos := -1 + 41
				when 40 then -- else:
						l_y_idx := 0
				when 41 then -- if done | if block done, skip else block:
						l_pos := -1 + 43
				when 42 then -- else:
						l_y_idx := 0
				when 43 then -- if done
						from
						until
							not (l_y_idx < y_current.item.y_size)
						loop
							l_tmp___12 := l_j
							l_j := l_j + 1
							l_tmp___13 := l_y_idx
							l_y_idx := l_y_idx + 1
							l_curr.item.y_array[l_tmp___12] := y_current.item.y_array[l_tmp___13]
						end
						l_curr.item.y_size := l_j
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (y_current.item.y_array))
						y_current.ce_gets (l_curr)
				when 44 then -- if done
						if a_mess.to_boolean then
							if l_yanktype = 0 then
								if not (a_oap.item.block_mode).to_boolean then
									if l_yanklines = 1 then
										l_yanklines := 0
									end
								end
							end
							if l_yanklines > option_inst.p_report then
								move_inst.update_topline_redraw
								if l_yanklines = 1 then
									if (a_oap.item.block_mode).to_boolean then
										message_inst.msg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("block of 1 line yanked"))))).do_nothing
									else
										message_inst.msg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("1 line yanked"))))).do_nothing
									end
								elseif (a_oap.item.block_mode).to_boolean then
									message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("block of %%ld lines yanked")))), l_yanklines]).do_nothing
								else
									message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("%%ld lines yanked")))), l_yanklines]).do_nothing
								end
							end
						end
						globals_inst.curbuf.item.b_op_start := a_oap.item.start
						globals_inst.curbuf.item.b_op_end := a_oap.item.end2
						if l_yanktype = 1 then
							if not (a_oap.item.block_mode).to_boolean then
								globals_inst.curbuf.item.b_op_start.col := 0
								globals_inst.curbuf.item.b_op_end.col := (2147483647).to_integer_32
							end
						end
						if not ((globals_inst.clip_star.available).to_boolean) then
							l_pos := -1 + 59 -- skip if block
						end
				when 45 then -- if:
						if (l_curr.c_pointer.to_integer_32).to_natural_32 /= ((y_regs + 37).c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 48 -- skip if block
						end
				when 46 then -- if:
						l_pos := -1 + 51 -- goto _L___3
				when 47 then -- if block done, skip else block:
						l_pos := -1 + 58
				when 48 then -- else:
						if a_deleting.to_boolean then
							l_pos := -1 + 57 -- skip if block
						end
				when 49 then -- if:
						if a_oap.item.regname /= 0 then
							l_pos := -1 + 55 -- skip if block
						end
				when 50 then -- if:
						if not (globals_inst.clip_unnamed.to_boolean) then
							l_pos := -1 + 53 -- skip if block
						end
				when 51 then -- if: | _L___3:
						if (l_curr.c_pointer.to_integer_32).to_natural_32 /= ((y_regs + 37).c_pointer.to_integer_32).to_natural_32 then
							copy_yank_reg (y_regs + 37)
						end
						ui_inst.clip_own_selection (globals_inst.clip_star.address)
						ui_inst.clip_gen_set_selection (globals_inst.clip_star.address)
				when 52 then -- if block done, skip else block:
						l_pos := -1 + 54
				when 53 then -- else:
						l_pos := -1 + 59 -- goto _L___2
				when 54 then -- if done | if block done, skip else block:
						l_pos := -1 + 56
				when 55 then -- else:
						l_pos := -1 + 59 -- goto _L___2
				when 56 then -- if done | if block done, skip else block:
						l_pos := -1 + 58
				when 57 then -- else:
						l_pos := -1 + 59 -- goto _L___2
				when 58 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 60
				when 59 then -- else: | _L___2:
						if (globals_inst.clip_plus.available).to_boolean then
							if (l_curr.c_pointer.to_integer_32).to_natural_32 = ((y_regs + 38).c_pointer.to_integer_32).to_natural_32 then
								ui_inst.clip_own_selection (globals_inst.clip_plus.address)
								ui_inst.clip_gen_set_selection (globals_inst.clip_plus.address)
								if not (ui_inst.clip_isautosel).to_boolean then
									copy_yank_reg (y_regs + 37)
									ui_inst.clip_own_selection (globals_inst.clip_star.address)
									ui_inst.clip_gen_set_selection (globals_inst.clip_star.address)
								end
							end
						end
				when 60 then
						Result := 1
						js.return
				when 61 then -- if done
					if js.return_called then
						l_pos := -1 + 63 -- skip if block
					end
				when 62 then -- if: | fail:
						free_yank (l_y_idx + 1)
						y_current.ce_gets (l_curr)
						Result := 0
				when 63 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	yank_copy_line (a_bd: CE_POINTER [PD_BLOCK_DEF]; a_y_idx: INTEGER_32): INTEGER_32
		local
			l_pnew: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_pnew.make

			l_pnew.ce_gets (misc2_inst.alloc ((((a_bd.item.startspaces + a_bd.item.endspaces) + a_bd.item.textlen) + 1).to_natural_32))
			if (l_pnew.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				Result := 0
				js.return
			end
			if not js.return_called then
				y_current.item.y_array[a_y_idx] := l_pnew
				misc2_inst.copy_spaces (l_pnew, (a_bd.item.startspaces).to_natural_32)
				l_pnew.ce_gets (l_pnew + (a_bd.item.startspaces))
				memmove (create {CE_POINTER [ANY]}.make_cast (l_pnew), create {CE_POINTER [ANY]}.make_cast (a_bd.item.textstart), (a_bd.item.textlen).to_natural_32).do_nothing
				l_pnew.ce_gets (l_pnew + (a_bd.item.textlen))
				misc2_inst.copy_spaces (l_pnew, (a_bd.item.endspaces).to_natural_32)
				l_pnew.ce_gets (l_pnew + (a_bd.item.endspaces))
				l_pnew.item := (('%/0/').code).to_natural_8
				Result := 1
			end
		end

	copy_yank_reg (a_reg___0: CE_POINTER [PD_YANKREG])
		local
			l_curr: CE_POINTER [PD_YANKREG]
			l_j: INTEGER_32
			l_tmp___0: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_curr.make
			create l_tmp___0.make

			l_curr.ce_gets (y_current)
			y_current.ce_gets (a_reg___0)
			free_yank_all
			y_current.item := l_curr.item
			y_current.item.y_array := create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast ((misc2_inst.lalloc_clear ((Pointer_bytes.to_natural_32).to_natural_32 * (y_current.item.y_size).to_natural_32, 1)))
			if ((y_current.item.y_array).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				y_current.item.y_size := (0).to_integer_32
			else
				l_j := 0
				from
				until
					not (not js.loop_left and then (l_j < y_current.item.y_size))
				loop
					js.reset
					l_tmp___0.ce_gets (misc2_inst.vim_strsave (l_curr.item.y_array[l_j]))
					y_current.item.y_array[l_j] := l_tmp___0
					if (l_tmp___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						free_yank (l_j)
						y_current.item.y_size := (0).to_integer_32
						js.break
					end
					if not js.loop_jumped then
						l_j := l_j + 1
					end
				end
				js.reset
			end
			y_current.ce_gets (l_curr)
		end

	do_put (a_regname___0: INTEGER_32; a_dir___0: INTEGER_32; a_count___2: INTEGER_32; a_flags___0: INTEGER_32)
		local
			l_regname___0: INTEGER_32
			l_dir___0: INTEGER_32
			l_ptr: CE_POINTER [NATURAL_8]
			l_newp: CE_POINTER [NATURAL_8]
			l_oldp: CE_POINTER [NATURAL_8]
			l_yanklen: INTEGER_32
			l_totlen: INTEGER_32
			l_lnum: INTEGER_32
			l_col: INTEGER_32
			l_i___0: INTEGER_32
			l_y_type: INTEGER_32
			l_y_size: INTEGER_32
			l_oldlen: INTEGER_32
			l_y_width: INTEGER_32
			l_vcol: INTEGER_32
			l_delcount: INTEGER_32
			l_incr: INTEGER_32
			l_j: INTEGER_32
			l_bd: PD_BLOCK_DEF
			l_y_array: CE_POINTER [CE_POINTER [NATURAL_8]]
			l_nr_lines: INTEGER_32
			l_new_cursor: PD_POS_T
			l_indent: INTEGER_32
			l_orig_indent: INTEGER_32
			l_indent_diff: INTEGER_32
			l_first_indent: INTEGER_32
			l_lendiff: INTEGER_32
			l_old_pos: PD_POS_T
			l_insert_string: CE_POINTER [NATURAL_8]
			l_allocated: INTEGER_32
			l_cnt: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___9: CE_POINTER [NATURAL_8]
			l_tmp___16: INTEGER_32
			l_tmp___17: INTEGER_32
			l_c: INTEGER_8
			l_endcol2: INTEGER_32
			l_spaces: INTEGER_32
			l_shortline: INTEGER_8
			l_tmp___25: INTEGER_32
			l_len: INTEGER_32
			l_bytelen___0: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_ptr.make
			create l_newp.make
			create l_oldp.make
			create l_bd.make
			create l_y_array.make
			create l_new_cursor.make
			create l_old_pos.make
			create l_insert_string.make
			create l_tmp___9.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_regname___0 := a_regname___0
					l_dir___0 := a_dir___0
					l_totlen := 0
					l_y_width := 0
					l_incr := 0
					l_y_array.ce_gets (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer))
					l_nr_lines := 0
					l_orig_indent := 0
					l_indent_diff := 0
					l_first_indent := 1
					l_lendiff := 0
					l_insert_string.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_allocated := 0
					adjust_clip_reg (create {CE_POINTER [INTEGER_32]}.make_shared ($l_regname___0))
					may_get_selection (l_regname___0).do_nothing
					if ((a_flags___0).bit_and (1)).to_boolean then
						l_orig_indent := misc1_inst.get_indent
					end
					globals_inst.curbuf.item.b_op_start := globals_inst.curwin.item.w_cursor
					globals_inst.curbuf.item.b_op_end := globals_inst.curwin.item.w_cursor
					if l_regname___0 = 46 then
						if l_dir___0 = 1 then
							if a_count___2 = -1 then
								l_tmp := ('o').code
							else
								l_tmp := ('a').code
							end
							l_tmp___1 := l_tmp
						else
							if a_count___2 = -1 then
								l_tmp___0 := ('O').code
							else
								l_tmp___0 := ('i').code
							end
							l_tmp___1 := l_tmp___0
						end
						edit_inst.stuff_inserted (l_tmp___1, a_count___2, 0).do_nothing
						if ((a_flags___0).bit_and (2)).to_boolean then
							if (misc1_inst.gchar_cursor) /= 0 then
								getchar_inst.stuffcharReadbuff (('l').code)
							end
						end
						js.return
					end
					if not js.return_called then
						if (get_spec_reg (l_regname___0, l_insert_string.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_allocated), 1)).to_boolean then
							if (l_insert_string.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								js.return
							end
						end
					end
					if js.return_called then
						l_pos := -1 + 85 -- skip if block
					end
				when 1 then -- if:
						if (l_insert_string.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 10 -- skip if block
						end
				when 2 then -- if:
						l_y_type := 0
						if l_regname___0 /= 61 then
							l_pos := -1 + 8 -- skip if block
						end
				when 3 then -- if: | loop condition:
						if js.loop_left then
							l_pos := -1 + 6 -- skip loop
						end
				when 4 then -- loop body:
						js.reset
						l_y_size := 0
						l_ptr.ce_gets (l_insert_string)
						from
						until
							not (not js.loop_left and then ((l_ptr.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32))
						loop
							js.reset
							if (l_y_array.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								l_y_array[l_y_size] := l_ptr
							end
							l_y_size := l_y_size + 1
							l_ptr.ce_gets (misc2_inst.vim_strchr (l_ptr, ('%N').code))
							if (l_ptr.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								if (l_y_array.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									l_ptr.item := (('%/0/').code).to_natural_8
								end
								l_ptr.ce_gets (l_ptr + 1)
								if (l_ptr.item).to_integer_32 = 0 then
									l_y_type := 1
									js.break
								end
							end
						end
						js.reset
						if (l_y_array.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							js.break
						end
						if not js.loop_jumped then
							l_y_array.ce_gets (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast ((misc2_inst.alloc ((l_y_size.to_natural_32 * (Pointer_bytes.to_natural_32).to_natural_32).to_natural_32))))
							if (l_y_array.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								l_pos := -1 + 84 -- goto end
							end
						end
				when 5 then
						l_pos := -1 + 3 -- back to loop condition
				when 6 then -- loop done
						js.reset
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else:
						l_y_size := 1
						l_y_array.ce_gets (l_insert_string.address)
				when 9 then -- if done | if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else:
						get_yank_register (l_regname___0, 0)
						l_y_type := (y_current.item.y_type).to_integer_32
						l_y_width := (y_current.item.y_width).to_integer_32
						l_y_size := y_current.item.y_size
						l_y_array.ce_gets (y_current.item.y_array)
				when 11 then -- if done
						if l_y_type /= 1 then
							l_pos := -1 + 18 -- skip if block
						end
				when 12 then -- if:
						if not (((a_flags___0).bit_and (16)).to_boolean) then
							l_pos := -1 + 17 -- skip if block
						end
				when 13 then -- if:
						if (undo_inst.u_save_cursor) = 0 then
							l_pos := -1 + 84 -- goto end
						end
				when 14 then
						l_ptr.ce_gets (misc2_inst.vim_strsave ((memline_inst.ml_get_cursor)))
						if (l_ptr.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 84 -- goto end
						end
				when 15 then
						memline_inst.ml_append (globals_inst.curwin.item.w_cursor.lnum, l_ptr, 0, 0).do_nothing
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_ptr))
						l_ptr.ce_gets (misc2_inst.vim_strnsave ((memline_inst.ml_get_curline), globals_inst.curwin.item.w_cursor.col))
						if (l_ptr.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 84 -- goto end
						end
				when 16 then
						memline_inst.ml_replace (globals_inst.curwin.item.w_cursor.lnum, l_ptr, 0).do_nothing
						l_nr_lines := l_nr_lines + 1
						l_dir___0 := 1
				when 17 then -- if done
						if ((a_flags___0).bit_and (32)).to_boolean then
							globals_inst.curwin.item.w_cursor := globals_inst.curbuf.item.b_visual.vi_end
							l_dir___0 := 1
						end
						globals_inst.curbuf.item.b_op_start := globals_inst.curwin.item.w_cursor
						globals_inst.curbuf.item.b_op_end := globals_inst.curwin.item.w_cursor
				when 18 then -- if done
						if ((a_flags___0).bit_and (8)).to_boolean then
							l_y_type := 1
						end
						if l_y_size /= 0 then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						l_pos := -1 + 22 -- goto _L
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 21 then -- else:
						if (l_y_array.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_pos := -1 + 23 -- skip if block
						end
				when 22 then -- if: | _L:
						if l_regname___0 = 0 then
							l_tmp___9.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%"")))
						else
							l_tmp___9.ce_gets ((charset_inst.transchar (l_regname___0)))
						end
						message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E353: Nothing in register %%s")))), l_tmp___9).do_nothing
						l_pos := -1 + 84 -- goto end
				when 23 then -- if done
						if l_y_type /= 2 then
							l_pos := -1 + 26 -- skip if block
						end
				when 24 then -- if:
						l_lnum := (globals_inst.curwin.item.w_cursor.lnum + l_y_size) + 1
						if l_lnum > globals_inst.curbuf.item.b_ml.ml_line_count then
							l_lnum := globals_inst.curbuf.item.b_ml.ml_line_count + 1
						end
						if (undo_inst.u_save (globals_inst.curwin.item.w_cursor.lnum - 1, l_lnum)) = 0 then
							l_pos := -1 + 84 -- goto end
						end
				when 25 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 26 then -- else:
						if l_y_type /= 1 then
							l_pos := -1 + 30 -- skip if block
						end
				when 27 then -- if:
						l_lnum := globals_inst.curwin.item.w_cursor.lnum
						if l_dir___0 = -1 then
							fold_inst.hasFolding (l_lnum, create {CE_POINTER [INTEGER_32]}.make_shared ($l_lnum), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)).do_nothing
						else
							fold_inst.hasFolding (l_lnum, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared ($l_lnum)).do_nothing
						end
						if l_dir___0 = 1 then
							l_lnum := l_lnum + 1
						end
						if (undo_inst.u_save (l_lnum - 1, l_lnum)) = 0 then
							l_pos := -1 + 84 -- goto end
						end
				when 28 then
						if l_dir___0 = 1 then
							globals_inst.curwin.item.w_cursor.lnum := l_lnum - 1
						else
							globals_inst.curwin.item.w_cursor.lnum := l_lnum
						end
						globals_inst.curbuf.item.b_op_start := globals_inst.curwin.item.w_cursor
				when 29 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 30 then -- else:
						if (undo_inst.u_save_cursor) = 0 then
							l_pos := -1 + 84 -- goto end
						end
				when 31 then -- if done
						l_yanklen := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_y_array[0]))).to_integer_32
						if option_inst.ve_flags = {NATURAL_32} 4 then
							if l_y_type = 0 then
								if (misc1_inst.gchar_cursor) = 9 then
									if l_dir___0 = 1 then
										l_tmp___16 := ((globals_inst.curwin.item.w_cursor.coladd).to_integer_32 < globals_inst.curbuf.item.b_p_ts - 1).to_integer
									else
										l_tmp___16 := (globals_inst.curwin.item.w_cursor.coladd > 0).to_integer
									end
									if l_tmp___16.to_boolean then
										misc2_inst.coladvance_force ((misc2_inst.getviscol)).do_nothing
									else
										globals_inst.curwin.item.w_cursor.coladd := 0
									end
								elseif globals_inst.curwin.item.w_cursor.coladd > 0 then
									l_tmp___17 := misc2_inst.getviscol
									misc2_inst.coladvance_force (l_tmp___17 + (l_dir___0 = 1).to_integer).do_nothing
								elseif (misc1_inst.gchar_cursor) = 0 then
									l_tmp___17 := misc2_inst.getviscol
									misc2_inst.coladvance_force (l_tmp___17 + (l_dir___0 = 1).to_integer).do_nothing
								end
							end
						end
						l_lnum := globals_inst.curwin.item.w_cursor.lnum
						l_col := globals_inst.curwin.item.w_cursor.col
						if l_y_type /= 2 then
							l_pos := -1 + 53 -- skip if block
						end
				when 32 then -- if:
						l_c := (misc1_inst.gchar_cursor).to_integer_8
						l_endcol2 := 0
						if l_dir___0 = 1 then
							if l_c.to_integer_32 /= 0 then
								if option_inst.ve_flags = {NATURAL_32} 4 then
									charset_inst.getvcol (globals_inst.curwin, create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curwin.c_pointer + {PD_WINDOW_S}.w_cursor_offset), create {CE_POINTER [INTEGER_32]}.make_shared ($l_col), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared ($l_endcol2))
								else
									charset_inst.getvcol (globals_inst.curwin, create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curwin.c_pointer + {PD_WINDOW_S}.w_cursor_offset), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared ($l_col))
								end
								if globals_inst.has_mbyte.to_boolean then
									globals_inst.curwin.item.w_cursor.col := globals_inst.curwin.item.w_cursor.col + (globals_inst.mb_ptr2len.integer_32_item ([(memline_inst.ml_get_cursor)]))
								elseif l_c.to_integer_32 /= 9 then
									globals_inst.curwin.item.w_cursor.col := (globals_inst.curwin.item.w_cursor.col) + 1
								elseif option_inst.ve_flags /= {NATURAL_32} 4 then
									globals_inst.curwin.item.w_cursor.col := (globals_inst.curwin.item.w_cursor.col) + 1
								end
								l_col := l_col + 1
							else
								charset_inst.getvcol (globals_inst.curwin, create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curwin.c_pointer + {PD_WINDOW_S}.w_cursor_offset), create {CE_POINTER [INTEGER_32]}.make_shared ($l_col), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared ($l_endcol2))
							end
						else
							charset_inst.getvcol (globals_inst.curwin, create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curwin.c_pointer + {PD_WINDOW_S}.w_cursor_offset), create {CE_POINTER [INTEGER_32]}.make_shared ($l_col), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared ($l_endcol2))
						end
						l_col := l_col + (globals_inst.curwin.item.w_cursor.coladd)
						if option_inst.ve_flags /= {NATURAL_32} 4 then
							l_pos := -1 + 38 -- skip if block
						end
				when 33 then -- if:
						if not (globals_inst.curwin.item.w_cursor.coladd > 0) then
							l_pos := -1 + 36 -- skip if block
						end
				when 34 then -- if:
						l_pos := -1 + 37 -- goto _L___0
				when 35 then -- if block done, skip else block:
						l_pos := -1 + 38
				when 36 then -- else:
						if l_endcol2 /= globals_inst.curwin.item.w_cursor.col then
							l_pos := -1 + 38 -- skip if block
						end
				when 37 then -- if: | _L___0:
						if l_dir___0 = 1 then
							if l_c.to_integer_32 = 0 then
								l_col := l_col + 1
							end
						end
						if l_dir___0 /= 1 then
							if l_c.to_integer_32 /= 0 then
								globals_inst.curwin.item.w_cursor.col := (globals_inst.curwin.item.w_cursor.col) + 1
							end
						end
						if l_c.to_integer_32 = 9 then
							if l_dir___0 = -1 then
								if (globals_inst.curwin.item.w_cursor.col).to_boolean then
									globals_inst.curwin.item.w_cursor.col := (globals_inst.curwin.item.w_cursor.col) - 1
								end
							end
							if l_dir___0 = 1 then
								if l_col - 1 = l_endcol2 then
									globals_inst.curwin.item.w_cursor.col := (globals_inst.curwin.item.w_cursor.col) + 1
								end
							end
						end
				when 38 then -- if done | if done
						globals_inst.curwin.item.w_cursor.coladd := 0
						l_bd.textcol := 0
						l_i___0 := 0
				when 39 then -- loop condition:
						if not (not js.loop_left and then (l_i___0 < l_y_size)) then
							l_pos := -1 + 51 -- skip loop
						end
				when 40 then -- loop body:
						js.reset
						l_bd.startspaces := 0
						l_bd.endspaces := 0
						l_vcol := 0
						l_delcount := 0
						if globals_inst.curwin.item.w_cursor.lnum > globals_inst.curbuf.item.b_ml.ml_line_count then
							if (memline_inst.ml_append (globals_inst.curbuf.item.b_ml.ml_line_count, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")), 1, 0)) = 0 then
								js.break
							end
							if not js.loop_jumped then
								l_nr_lines := l_nr_lines + 1
							end
						end
						if not js.loop_jumped then
							l_oldp.ce_gets (memline_inst.ml_get_curline)
							l_oldlen := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_oldp))).to_integer_32
							l_ptr.ce_gets (l_oldp)
							from
							until
								js.loop_left
							loop
								js.reset
								if l_vcol < l_col then
									if not (l_ptr.item).to_boolean then
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped then
									l_incr := charset_inst.lbr_chartabsize_adv (l_ptr.address, l_vcol)
									l_vcol := l_vcol + l_incr
								end
							end
							js.reset
							l_bd.textcol := l_ptr.distance (l_oldp)
							if l_vcol < l_col then
								l_tmp___25 := 1
							elseif l_vcol = l_col then
								if not (l_ptr.item).to_boolean then
									l_tmp___25 := 1
								else
									l_tmp___25 := 0
								end
							else
								l_tmp___25 := 0
							end
							l_shortline := l_tmp___25.to_integer_8
							if l_vcol < l_col then
								l_bd.startspaces := l_col - l_vcol
							elseif l_vcol > l_col then
								l_bd.endspaces := l_vcol - l_col
								l_bd.startspaces := l_incr - l_bd.endspaces
								l_bd.textcol := (l_bd.textcol) - 1
								l_delcount := 1
								if globals_inst.has_mbyte.to_boolean then
									l_bd.textcol := l_bd.textcol - (globals_inst.mb_head_off.integer_32_item ([l_oldp, l_oldp + l_bd.textcol]))
								end
								if (l_oldp[l_bd.textcol]).to_integer_32 /= 9 then
									l_delcount := 0
									l_bd.endspaces := 0
								end
							end
							l_yanklen := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_y_array[l_i___0]))).to_integer_32
							l_spaces := (l_y_width + 1).to_integer_32
							l_j := 0
							from
							until
								not (l_j < l_yanklen.to_integer_32)
							loop
								l_spaces := l_spaces - (charset_inst.lbr_chartabsize (l_y_array[l_i___0] + l_j, 0))
								l_j := l_j + 1
							end
							if l_spaces < 0 then
								l_spaces := 0
							end
							l_totlen := ((a_count___2 * (l_yanklen + l_spaces).to_integer_32 + (l_bd.startspaces).to_integer_32) + (l_bd.endspaces).to_integer_32).to_integer_32
							l_newp.ce_gets (misc2_inst.alloc_check ((l_totlen.to_natural_32 + l_oldlen.to_natural_32) + {NATURAL_32} 1))
							if (l_newp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								js.break
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 50 -- skip if block
						end
				when 41 then -- if:
						l_ptr.ce_gets (l_newp)
						memmove (create {CE_POINTER [ANY]}.make_cast (l_ptr), create {CE_POINTER [ANY]}.make_cast (l_oldp), (l_bd.textcol).to_natural_32).do_nothing
						l_ptr.ce_gets (l_ptr + (l_bd.textcol))
						misc2_inst.copy_spaces (l_ptr, (l_bd.startspaces).to_natural_32)
						l_ptr.ce_gets (l_ptr + (l_bd.startspaces))
						l_j := 0
				when 42 then -- loop condition:
						if not (l_j < a_count___2) then
							l_pos := -1 + 49 -- skip loop
						end
				when 43 then -- loop body:
						memmove (create {CE_POINTER [ANY]}.make_cast (l_ptr), create {CE_POINTER [ANY]}.make_cast (l_y_array[l_i___0]), l_yanklen.to_natural_32).do_nothing
						l_ptr.ce_gets (l_ptr + l_yanklen)
						if not (l_j < a_count___2 - 1) then
							l_pos := -1 + 46 -- skip if block
						end
				when 44 then -- if:
						l_pos := -1 + 47 -- goto _L___1
				when 45 then -- if block done, skip else block:
						l_pos := -1 + 48
				when 46 then -- else:
						if l_shortline.to_boolean then
							l_pos := -1 + 48 -- skip if block
						end
				when 47 then -- if: | _L___1:
						if l_spaces.to_boolean then
							misc2_inst.copy_spaces (l_ptr, l_spaces.to_natural_32)
							l_ptr.ce_gets (l_ptr + l_spaces)
						end
				when 48 then -- if done
						l_j := l_j + 1
						l_pos := -1 + 42 -- back to loop condition
				when 49 then -- loop done
						misc2_inst.copy_spaces (l_ptr, (l_bd.endspaces).to_natural_32)
						l_ptr.ce_gets (l_ptr + (l_bd.endspaces))
						memmove (create {CE_POINTER [ANY]}.make_cast (l_ptr), create {CE_POINTER [ANY]}.make_cast (((l_oldp + l_bd.textcol) + l_delcount)), (((l_oldlen - l_bd.textcol) - l_delcount) + 1).to_natural_32).do_nothing
						memline_inst.ml_replace (globals_inst.curwin.item.w_cursor.lnum, l_newp, 0).do_nothing
						globals_inst.curwin.item.w_cursor.lnum := (globals_inst.curwin.item.w_cursor.lnum) + 1
						if l_i___0 = 0 then
							globals_inst.curwin.item.w_cursor.col := globals_inst.curwin.item.w_cursor.col + (l_bd.startspaces)
						end
						l_i___0 := l_i___0 + 1
				when 50 then -- if done
						l_pos := -1 + 39 -- back to loop condition
				when 51 then -- loop done
						js.reset
						misc1_inst.changed_lines (l_lnum, 0, globals_inst.curwin.item.w_cursor.lnum, l_nr_lines)
						globals_inst.curbuf.item.b_op_start := globals_inst.curwin.item.w_cursor
						globals_inst.curbuf.item.b_op_start.lnum := l_lnum
						globals_inst.curbuf.item.b_op_end.lnum := globals_inst.curwin.item.w_cursor.lnum - 1
						globals_inst.curbuf.item.b_op_end.col := (l_bd.textcol + l_totlen) - 1
						globals_inst.curbuf.item.b_op_end.coladd := 0
						if ((a_flags___0).bit_and (2)).to_boolean then
							globals_inst.curwin.item.w_cursor := globals_inst.curbuf.item.b_op_end
							globals_inst.curwin.item.w_cursor.col := (globals_inst.curwin.item.w_cursor.col) + 1
							l_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((memline_inst.ml_get_curline)))).to_integer_32
							if globals_inst.curwin.item.w_cursor.col > l_len then
								globals_inst.curwin.item.w_cursor.col := l_len
							end
						else
							globals_inst.curwin.item.w_cursor.lnum := l_lnum
						end
				when 52 then -- if block done, skip else block:
						l_pos := -1 + 83
				when 53 then -- else:
						if l_y_type = 0 then
							if l_dir___0 = 1 then
								if (misc1_inst.gchar_cursor) /= 0 then
									if globals_inst.has_mbyte.to_boolean then
										l_bytelen___0 := (globals_inst.mb_ptr2len.integer_32_item ([(memline_inst.ml_get_cursor)]))
										l_col := l_col + l_bytelen___0
										if l_yanklen.to_boolean then
											globals_inst.curwin.item.w_cursor.col := globals_inst.curwin.item.w_cursor.col + l_bytelen___0
											globals_inst.curbuf.item.b_op_end.col := globals_inst.curbuf.item.b_op_end.col + l_bytelen___0
										end
									else
										l_col := l_col + 1
										if l_yanklen.to_boolean then
											globals_inst.curwin.item.w_cursor.col := (globals_inst.curwin.item.w_cursor.col) + 1
											globals_inst.curbuf.item.b_op_end.col := (globals_inst.curbuf.item.b_op_end.col) + 1
										end
									end
								end
							end
							globals_inst.curbuf.item.b_op_start := globals_inst.curwin.item.w_cursor
						elseif l_dir___0 = -1 then
							l_lnum := l_lnum - 1
						end
						l_new_cursor.ce_gets (globals_inst.curwin.item.w_cursor)
						if l_y_type /= 0 then
							l_pos := -1 + 62 -- skip if block
						end
				when 54 then -- if:
						if l_y_size /= 1 then
							l_pos := -1 + 60 -- skip if block
						end
				when 55 then -- if:
						l_totlen := (a_count___2 * l_yanklen.to_integer_32).to_integer_32
						if not (l_totlen.to_boolean) then
							l_pos := -1 + 58 -- skip if block
						end
				when 56 then -- if:
						l_oldp.ce_gets (memline_inst.ml_get (l_lnum))
						l_newp.ce_gets (misc2_inst.alloc_check (((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_oldp))) + l_totlen.to_natural_32) + {NATURAL_32} 1))
						if (l_newp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 84 -- goto end
						end
				when 57 then
						memmove (create {CE_POINTER [ANY]}.make_cast (l_newp), create {CE_POINTER [ANY]}.make_cast (l_oldp), l_col.to_natural_32).do_nothing
						l_ptr.ce_gets (l_newp + l_col)
						l_i___0 := 0
						from
						until
							not (l_i___0 < a_count___2)
						loop
							memmove (create {CE_POINTER [ANY]}.make_cast (l_ptr), create {CE_POINTER [ANY]}.make_cast (l_y_array[0]), l_yanklen.to_natural_32).do_nothing
							l_ptr.ce_gets (l_ptr + l_yanklen)
							l_i___0 := l_i___0 + 1
						end
						memmove (create {CE_POINTER [ANY]}.make_cast (l_ptr), create {CE_POINTER [ANY]}.make_cast ((l_oldp + l_col)), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((l_oldp + l_col)))) + {NATURAL_32} 1).do_nothing
						memline_inst.ml_replace (l_lnum, l_newp, 0).do_nothing
						globals_inst.curwin.item.w_cursor.col := globals_inst.curwin.item.w_cursor.col + (l_totlen - 1)
				when 58 then -- if done
						globals_inst.curbuf.item.b_op_end := globals_inst.curwin.item.w_cursor
						if l_totlen.to_boolean then
							if globals_inst.restart_edit /= 0 then
								globals_inst.curwin.item.w_cursor.col := (globals_inst.curwin.item.w_cursor.col) + 1
							elseif ((a_flags___0).bit_and (2)).to_boolean then
								globals_inst.curwin.item.w_cursor.col := (globals_inst.curwin.item.w_cursor.col) + 1
							end
						end
						misc1_inst.changed_bytes (l_lnum, l_col)
				when 59 then -- if block done, skip else block:
						l_pos := -1 + 61
				when 60 then -- else:
						l_pos := -1 + 62 -- goto _L___4
				when 61 then -- if done | if block done, skip else block:
						l_pos := -1 + 83
				when 62 then -- else: | _L___4:
						l_cnt := 1
				when 63 then -- loop condition:
						if not (not js.loop_left and then (l_cnt <= a_count___2)) then
							l_pos := -1 + 82 -- skip loop
						end
				when 64 then -- loop body:
						l_i___0 := 0
						if l_y_type /= 0 then
							l_pos := -1 + 68 -- skip if block
						end
				when 65 then -- if:
						l_lnum := l_new_cursor.lnum
						l_ptr.ce_gets ((memline_inst.ml_get (l_lnum)) + l_col)
						l_totlen := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_y_array[(l_y_size - 1)]))).to_integer_32
						l_newp.ce_gets (misc2_inst.alloc_check (((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_ptr))) + l_totlen.to_natural_32) + {NATURAL_32} 1))
						if (l_newp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 82 -- goto error
						end
				when 66 then
						strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_newp), create {CE_POINTER [INTEGER_8]}.make_cast (l_y_array[(l_y_size - 1)])).do_nothing
						strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_newp), create {CE_POINTER [INTEGER_8]}.make_cast (l_ptr)).do_nothing
						memline_inst.ml_append (l_lnum, l_newp, 0, 0).do_nothing
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_newp))
						l_oldp.ce_gets (memline_inst.ml_get (l_lnum))
						l_newp.ce_gets (misc2_inst.alloc_check (((l_col + l_yanklen) + 1).to_natural_32))
						if (l_newp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 82 -- goto error
						end
				when 67 then
						memmove (create {CE_POINTER [ANY]}.make_cast (l_newp), create {CE_POINTER [ANY]}.make_cast (l_oldp), l_col.to_natural_32).do_nothing
						memmove (create {CE_POINTER [ANY]}.make_cast ((l_newp + l_col)), create {CE_POINTER [ANY]}.make_cast (l_y_array[0]), (l_yanklen + 1).to_natural_32).do_nothing
						memline_inst.ml_replace (l_lnum, l_newp, 0).do_nothing
						globals_inst.curwin.item.w_cursor.lnum := l_lnum
						l_i___0 := 1
				when 68 then -- if done
						if not (l_i___0 < l_y_size) then
							l_pos := -1 + 81 -- skip loop
						end
				when 69 then -- loop body:
						if l_y_type = 0 then
							l_pos := -1 + 72 -- skip if block
						end
				when 70 then -- if:
						l_pos := -1 + 73 -- goto _L___2
				when 71 then -- if block done, skip else block:
						l_pos := -1 + 74
				when 72 then -- else:
						if not (l_i___0 < l_y_size - 1) then
							l_pos := -1 + 74 -- skip if block
						end
				when 73 then -- if: | _L___2:
						if (memline_inst.ml_append (l_lnum, l_y_array[l_i___0], 0, 0)) = 0 then
							l_pos := -1 + 82 -- goto error
						end
				when 74 then -- if done
						l_lnum := l_lnum + 1
						l_nr_lines := l_nr_lines + 1
						if not (((a_flags___0).bit_and (1)).to_boolean) then
							l_pos := -1 + 80 -- skip if block
						end
				when 75 then -- if:
						l_old_pos.ce_gets (globals_inst.curwin.item.w_cursor)
						globals_inst.curwin.item.w_cursor.lnum := l_lnum
						l_ptr.ce_gets (memline_inst.ml_get (l_lnum))
						if l_cnt = a_count___2 then
							if l_i___0 = l_y_size - 1 then
								l_lendiff := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_ptr))).to_integer_32
							end
						end
						if (l_ptr.item).to_integer_32 /= 35 then
							l_pos := -1 + 78 -- skip if block
						end
				when 76 then -- if:
						if (preprocs_left).to_boolean then
							l_indent := 0
						else
							l_pos := -1 + 78 -- goto _L___3
						end
				when 77 then -- if block done, skip else block:
						l_pos := -1 + 79
				when 78 then -- else: | _L___3:
						if (l_ptr.item).to_integer_32 = 0 then
							l_indent := 0
						elseif l_first_indent.to_boolean then
							l_indent_diff := l_orig_indent - (misc1_inst.get_indent)
							l_indent := l_orig_indent
							l_first_indent := 0
						else
							l_indent := (misc1_inst.get_indent) + l_indent_diff
							if l_indent < 0 then
								l_indent := 0
							end
						end
				when 79 then
						misc1_inst.set_indent (l_indent, 0).do_nothing
						globals_inst.curwin.item.w_cursor := l_old_pos
						if l_cnt = a_count___2 then
							if l_i___0 = l_y_size - 1 then
								l_lendiff := l_lendiff - (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((memline_inst.ml_get (l_lnum))))).to_integer_32
							end
						end
				when 80 then -- if done
						l_i___0 := l_i___0 + 1
						l_pos := -1 + 68 -- back to loop condition
				when 81 then -- loop done
						l_cnt := l_cnt + 1
						l_pos := -1 + 63 -- back to loop condition
				when 82 then -- error:
						if l_y_type = 1 then
							globals_inst.curbuf.item.b_op_start.col := 0
							if l_dir___0 = 1 then
								globals_inst.curbuf.item.b_op_start.lnum := (globals_inst.curbuf.item.b_op_start.lnum) + 1
							end
						end
						mark_inst.mark_adjust (globals_inst.curbuf.item.b_op_start.lnum + (l_y_type = 0).to_integer, 2147483647, l_nr_lines, 0)
						if l_y_type = 0 then
							misc1_inst.changed_lines (globals_inst.curwin.item.w_cursor.lnum, l_col, globals_inst.curwin.item.w_cursor.lnum + 1, l_nr_lines)
						else
							misc1_inst.changed_lines (globals_inst.curbuf.item.b_op_start.lnum, 0, globals_inst.curbuf.item.b_op_start.lnum, l_nr_lines)
						end
						globals_inst.curbuf.item.b_op_end.lnum := l_lnum
						l_col := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_y_array[(l_y_size - 1)]))).to_integer_32 - l_lendiff
						if l_col > 1 then
							globals_inst.curbuf.item.b_op_end.col := l_col - 1
						else
							globals_inst.curbuf.item.b_op_end.col := 0
						end
						if ((a_flags___0).bit_and (4)).to_boolean then
							globals_inst.curwin.item.w_cursor.lnum := l_lnum
							edit_inst.beginline (5)
						elseif ((a_flags___0).bit_and (2)).to_boolean then
							if l_y_type = 1 then
								if l_lnum >= globals_inst.curbuf.item.b_ml.ml_line_count then
									globals_inst.curwin.item.w_cursor.lnum := globals_inst.curbuf.item.b_ml.ml_line_count
								else
									globals_inst.curwin.item.w_cursor.lnum := l_lnum + 1
								end
								globals_inst.curwin.item.w_cursor.col := 0
							else
								globals_inst.curwin.item.w_cursor.lnum := l_lnum
								globals_inst.curwin.item.w_cursor.col := l_col
							end
						elseif l_y_type = 1 then
							globals_inst.curwin.item.w_cursor.col := 0
							if l_dir___0 = 1 then
								globals_inst.curwin.item.w_cursor.lnum := (globals_inst.curwin.item.w_cursor.lnum) + 1
							end
							edit_inst.beginline (5)
						else
							globals_inst.curwin.item.w_cursor := l_new_cursor
						end
				when 83 then -- if done
						misc1_inst.msgmore (l_nr_lines)
						globals_inst.curwin.item.w_set_curswant := 1
				when 84 then -- end:
						if l_allocated.to_boolean then
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_insert_string))
						end
						if l_regname___0 = 61 then
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_y_array))
						end
						adjust_cursor_eol
				when 85 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	adjust_cursor_eol
		local
			l_scol: INTEGER_32
			l_ecol: INTEGER_32
		do
			if globals_inst.curwin.item.w_cursor.col > 0 then
				if (misc1_inst.gchar_cursor) = 0 then
					if ((option_inst.ve_flags).bit_and ({NATURAL_32} 8)) = {NATURAL_32} 0 then
						if not globals_inst.restart_edit.to_boolean then
							if not ((globals_inst.State).bit_and (16)).to_boolean then
								misc2_inst.dec_cursor.do_nothing
								if option_inst.ve_flags = {NATURAL_32} 4 then
									charset_inst.getvcol (globals_inst.curwin, create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curwin.c_pointer + {PD_WINDOW_S}.w_cursor_offset), create {CE_POINTER [INTEGER_32]}.make_shared ($l_scol), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared ($l_ecol))
									globals_inst.curwin.item.w_cursor.coladd := (l_ecol - l_scol) + 1
								end
							end
						end
					end
				end
			end
		end

	preprocs_left: INTEGER_32
		local
			l_tmp___0: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not ((globals_inst.curbuf.item.b_p_si).to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if not (globals_inst.curbuf.item.b_p_cin).to_boolean then
							l_tmp___0 := 1
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						if (globals_inst.curbuf.item.b_p_cin).to_boolean then
							if (edit_inst.in_cinkeys (('#').code, (' ').code, 1)).to_boolean then
								l_tmp___0 := 1
							else
								l_tmp___0 := 0
							end
						else
							l_tmp___0 := 0
						end
				when 4 then
					Result := l_tmp___0
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_register_name (a_num: INTEGER_32): INTEGER_32
		do
			if a_num = -1 then
				Result := (('%"').code)
			elseif a_num < 10 then
				Result := (a_num + 48)
			elseif a_num = 36 then
				Result := (('-').code)
			elseif a_num = 37 then
				Result := (('*').code)
			elseif a_num = 38 then
				Result := (('+').code)
			else
				Result := ((a_num + 97) - 10)
			end
		end

	ex_display (a_eap: CE_POINTER [PD_EXARG])
		local
			l_i___0: INTEGER_32
			l_n: INTEGER_32
			l_j: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_yb: CE_POINTER [PD_YANKREG]
			l_name___1: INTEGER_32
			l_attr: INTEGER_32
			l_arg: CE_POINTER [NATURAL_8]
			l_clen: INTEGER_32
			l_fname: CE_POINTER [NATURAL_8]
			l_dummy___0: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p___0.make
			create l_yb.make
			create l_arg.make
			create l_fname.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_arg.ce_gets (a_eap.item.arg)
					if (l_arg.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						if (l_arg.item).to_integer_32 = 0 then
							l_arg.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						end
					end
					l_attr := globals_inst.highlight_attr[0]
					message_inst.msg_puts_title (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("%N--- Registers ---")))))
					l_i___0 := -1
					from
					until
						js.loop_left
					loop
						js.reset
						if l_i___0 < 40 then
							if globals_inst.got_int.to_boolean then
								js.break
							end
						else
							js.break
						end
						if not js.loop_jumped then
							l_name___1 := get_register_name (l_i___0)
							if (l_arg.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								if ((misc2_inst.vim_strchr (l_arg, l_name___1)).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
									js.continue
								end
							end
						end
						if not js.loop_jumped then
							adjust_clip_reg (create {CE_POINTER [INTEGER_32]}.make_shared ($l_name___1))
							may_get_selection (l_name___1).do_nothing
							if l_i___0 = -1 then
								if (y_previous.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									l_yb.ce_gets (y_previous)
								else
									l_yb.ce_gets (y_regs + 0)
								end
							else
								l_yb.ce_gets (y_regs + l_i___0)
							end
							if l_name___1 = (charset_inst.vim_tolower (globals_inst.redir_reg)) then
								js.continue
							elseif globals_inst.redir_reg = 34 then
								if (l_yb.c_pointer.to_integer_32).to_natural_32 = (y_previous.c_pointer.to_integer_32).to_natural_32 then
									js.continue
								end
							end
						end
						if not js.loop_jumped then
							if ((l_yb.item.y_array).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								message_inst.msg_putchar (('%N').code)
								message_inst.msg_putchar (('%"').code)
								message_inst.msg_putchar (l_name___1)
								message_inst.msg_puts (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("   ")))
								l_n := globals_inst.Columns.to_integer_32 - 6
								l_j := 0
								from
								until
									js.loop_left
								loop
									js.reset
									if l_j < l_yb.item.y_size then
										if not (l_n > 1) then
											js.break
										end
									else
										js.break
									end
									if not js.loop_jumped then
										if l_j.to_boolean then
											message_inst.msg_puts_attr (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("^J")), l_attr)
											l_n := l_n - (2)
										end
										l_p___0.ce_gets (l_yb.item.y_array[l_j])
										from
										until
											js.loop_left
										loop
											js.reset
											if (l_p___0.item).to_boolean then
												l_n := l_n - (charset_inst.ptr2cells (l_p___0))
												if not (l_n >= 0) then
													js.break
												end
											else
												js.break
											end
											if not js.loop_jumped then
												l_clen := globals_inst.mb_ptr2len.integer_32_item ([l_p___0])
												message_inst.msg_outtrans_len (l_p___0, l_clen).do_nothing
												l_p___0.ce_gets (l_p___0 + (l_clen - 1))
												l_p___0.ce_gets (l_p___0 + 1)
											end
										end
										js.reset
										l_j := l_j + 1
									end
								end
								js.reset
								if l_n > 1 then
									if (l_yb.item.y_type).to_integer_32 = 1 then
										message_inst.msg_puts_attr (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("^J")), l_attr)
									end
								end
								term_inst.out_flush
							end
							ui_inst.ui_breakcheck
						end
						if not js.loop_left then
							l_i___0 := l_i___0 + 1
						end
					end
					js.reset
					l_p___0.ce_gets (edit_inst.get_last_insert)
					if (l_p___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if (l_arg.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if ((misc2_inst.vim_strchr (l_arg, ('.').code)).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						if not globals_inst.got_int.to_boolean then
							message_inst.msg_puts (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%N%".   ")))
							dis_msg (l_p___0, 1)
						end
				when 6 then -- if done | if done
						if (globals_inst.last_cmdline.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 12 -- skip if block
						end
				when 7 then -- if:
							if (l_arg.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								l_pos := -1 + 10 -- skip if block
							end
				when 8 then -- if:
							l_pos := -1 + 11 -- goto _L___0
				when 9 then -- if block done, skip else block:
							l_pos := -1 + 12
				when 10 then -- else:
							if ((misc2_inst.vim_strchr (l_arg, (':').code)).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								l_pos := -1 + 12 -- skip if block
							end
				when 11 then -- if: | _L___0:
							if not globals_inst.got_int.to_boolean then
								message_inst.msg_puts (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%N%":   ")))
								dis_msg (globals_inst.last_cmdline, 0)
							end
				when 12 then -- if done | if done
							if ((globals_inst.curbuf.item.b_fname).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								l_pos := -1 + 18 -- skip if block
							end
				when 13 then -- if:
								if (l_arg.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									l_pos := -1 + 16 -- skip if block
								end
				when 14 then -- if:
								l_pos := -1 + 17 -- goto _L___1
				when 15 then -- if block done, skip else block:
								l_pos := -1 + 18
				when 16 then -- else:
								if ((misc2_inst.vim_strchr (l_arg, ('%%').code)).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
									l_pos := -1 + 18 -- skip if block
								end
				when 17 then -- if: | _L___1:
								if not globals_inst.got_int.to_boolean then
									message_inst.msg_puts (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%N%"%%   ")))
									dis_msg (globals_inst.curbuf.item.b_fname, 0)
								end
				when 18 then -- if done | if done
								if (l_arg.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									l_pos := -1 + 21 -- skip if block
								end
				when 19 then -- if:
									l_pos := -1 + 22 -- goto _L___2
				when 20 then -- if block done, skip else block:
									l_pos := -1 + 23
				when 21 then -- else:
									if ((misc2_inst.vim_strchr (l_arg, ('%%').code)).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
										l_pos := -1 + 23 -- skip if block
									end
				when 22 then -- if: | _L___2:
									if not globals_inst.got_int.to_boolean then
										if (buffer_inst.buflist_name_nr (0, l_fname.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_dummy___0))) /= 0 then
											message_inst.msg_puts (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%N%"#   ")))
											dis_msg (l_fname, 0)
										end
									end
				when 23 then -- if done
									if ((search_inst.last_search_pat).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
										l_pos := -1 + 29 -- skip if block
									end
				when 24 then -- if:
										if (l_arg.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
											l_pos := -1 + 27 -- skip if block
										end
				when 25 then -- if:
										l_pos := -1 + 28 -- goto _L___3
				when 26 then -- if block done, skip else block:
										l_pos := -1 + 29
				when 27 then -- else:
										if ((misc2_inst.vim_strchr (l_arg, ('/').code)).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
											l_pos := -1 + 29 -- skip if block
										end
				when 28 then -- if: | _L___3:
										if not globals_inst.got_int.to_boolean then
											message_inst.msg_puts (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%N%"/   ")))
											dis_msg ((search_inst.last_search_pat), 0)
										end
				when 29 then -- if done | if done
										if (expr_line.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
											l_pos := -1 + 35 -- skip if block
										end
				when 30 then -- if:
											if (l_arg.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
												l_pos := -1 + 33 -- skip if block
											end
				when 31 then -- if:
											l_pos := -1 + 34 -- goto _L___4
				when 32 then -- if block done, skip else block:
											l_pos := -1 + 35
				when 33 then -- else:
											if ((misc2_inst.vim_strchr (l_arg, ('=').code)).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
												l_pos := -1 + 35 -- skip if block
											end
				when 34 then -- if: | _L___4:
											if not globals_inst.got_int.to_boolean then
												message_inst.msg_puts (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%N%"=   ")))
												dis_msg (expr_line, 0)
											end
				when 35 then -- if done | if done
											l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
								end

	ex_display_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_display)
		end

	dis_msg (a_p___0: CE_POINTER [NATURAL_8]; a_skip_esc: INTEGER_32)
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_n: INTEGER_32
			l_l: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p___0.make
			create l_tmp.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p___0.ce_gets (a_p___0)
					l_n := globals_inst.Columns.to_integer_32 - 6
				when 1 then -- loop condition:
					if js.loop_left then
						l_pos := -1 + 10 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						if (l_p___0.item).to_integer_32 = 0 then
							l_pos := -1 + 8 -- skip if block
						end
				when 3 then -- if:
						if (l_p___0.item).to_integer_32 /= 27 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if a_skip_esc.to_boolean then
							if (l_p___0[1]).to_integer_32 = 0 then
								js.break
							else
								l_pos := -1 + 6 -- goto _L___0
							end
						else
							l_pos := -1 + 6 -- goto _L___0
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L___0:
						l_n := l_n - (charset_inst.ptr2cells (l_p___0))
						if not (l_n >= 0) then
							js.break
						end
				when 7 then -- if done | if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else:
						js.break
				when 9 then
						if not js.loop_jumped then
							if globals_inst.has_mbyte.to_boolean then
								l_l := globals_inst.mb_ptr2len.integer_32_item ([l_p___0])
								if l_l > 1 then
									message_inst.msg_outtrans_len (l_p___0, l_l).do_nothing
									l_p___0.ce_gets (l_p___0 + l_l)
								else
									l_tmp.ce_gets (l_p___0)
									l_p___0.ce_gets (l_p___0 + 1)
									message_inst.msg_outtrans_len (l_tmp, 1).do_nothing
								end
							else
								l_tmp.ce_gets (l_p___0)
								l_p___0.ce_gets (l_p___0 + 1)
								message_inst.msg_outtrans_len (l_tmp, 1).do_nothing
							end
						end
						l_pos := -1 + 1 -- back to loop condition
				when 10 then -- loop done
					js.reset
					ui_inst.ui_breakcheck
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	do_join (a_count___2: INTEGER_32; a_insert_space: INTEGER_32; a_save_undo: INTEGER_32): INTEGER_32
		local
			l_curr: CE_POINTER [NATURAL_8]
			l_cend: CE_POINTER [NATURAL_8]
			l_newp: CE_POINTER [NATURAL_8]
			l_spaces: CE_POINTER [NATURAL_8]
			l_endcurr1: INTEGER_32
			l_endcurr2: INTEGER_32
			l_currsize: INTEGER_32
			l_sumsize: INTEGER_32
			l_t: INTEGER_32
			l_col: INTEGER_32
			l_ret: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___9: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_curr.make
			create l_cend.make
			create l_newp.make
			create l_spaces.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_curr.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_endcurr1 := ('%/0/').code
					l_endcurr2 := ('%/0/').code
					l_currsize := 0
					l_sumsize := 0
					l_col := 0
					l_ret := 1
					if a_save_undo.to_boolean then
						if (undo_inst.u_save (globals_inst.curwin.item.w_cursor.lnum - 1, globals_inst.curwin.item.w_cursor.lnum + a_count___2)) = 0 then
							Result := 0
							js.return
						end
					end
					if not js.return_called then
						l_spaces.ce_gets (misc2_inst.lalloc_clear (a_count___2.to_natural_32, 1))
						if (l_spaces.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							Result := 0
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 25 -- skip if block
					end
				when 1 then -- if:
						l_t := (0).to_integer_32
				when 2 then -- loop condition:
						if not (l_t < a_count___2) then
							l_pos := -1 + 23 -- skip loop
						end
				when 3 then -- loop body:
						l_curr.ce_gets (memline_inst.ml_get (globals_inst.curwin.item.w_cursor.lnum + l_t))
						if not (a_insert_space.to_boolean) then
							l_pos := -1 + 21 -- skip if block
						end
				when 4 then -- if:
						if not (l_t > 0) then
							l_pos := -1 + 21 -- skip if block
						end
				when 5 then -- if:
						l_curr.ce_gets (charset_inst.skipwhite (l_curr))
						if (l_curr.item).to_integer_32 = 41 then
							l_pos := -1 + 21 -- skip if block
						end
				when 6 then -- if:
						if l_currsize = 0 then
							l_pos := -1 + 21 -- skip if block
						end
				when 7 then -- if:
						if l_endcurr1 = 9 then
							l_pos := -1 + 21 -- skip if block
						end
				when 8 then -- if:
						if not ((option_inst.has_format_option (('M').code)).to_boolean) then
							l_pos := -1 + 20 -- skip if block
						end
				when 9 then -- if:
						if not ((globals_inst.mb_ptr2char.integer_32_item ([l_curr])) < 256) then
							l_pos := -1 + 19 -- skip if block
						end
				when 10 then -- if:
						if not (l_endcurr1 < 256) then
							l_pos := -1 + 19 -- skip if block
						end
				when 11 then -- if: | _L___0:
						if not ((option_inst.has_format_option (('B').code)).to_boolean) then
							l_pos := -1 + 18 -- skip if block
						end
				when 12 then -- if:
						if not ((globals_inst.mb_ptr2char.integer_32_item ([l_curr])) < 256) then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						l_pos := -1 + 16 -- goto _L
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 15 then -- else:
						if not (l_endcurr1 < 256) then
							l_pos := -1 + 17 -- skip if block
						end
				when 16 then -- if: | _L:
						if l_endcurr1 = 32 then
							l_endcurr1 := l_endcurr2
						else
							l_spaces[l_t] := ((l_spaces[l_t]).to_integer_32 + 1).to_natural_8
						end
						if option_inst.p_js.to_boolean then
							if l_endcurr1 = 46 then
								l_spaces[l_t] := ((l_spaces[l_t]).to_integer_32 + 1).to_natural_8
							elseif ((misc2_inst.vim_strchr (option_inst.p_cpo, ('j').code)).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								if l_endcurr1 = 63 then
									l_spaces[l_t] := ((l_spaces[l_t]).to_integer_32 + 1).to_natural_8
								elseif l_endcurr1 = 33 then
									l_spaces[l_t] := ((l_spaces[l_t]).to_integer_32 + 1).to_natural_8
								end
							end
						end
				when 17 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 19
				when 18 then -- else:
						l_pos := -1 + 16 -- goto _L
				when 19 then -- if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 21
				when 20 then -- else:
						l_pos := -1 + 11 -- goto _L___0
				when 21 then -- if done | if done | if done | if done | if done
						l_currsize := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_curr))).to_integer_32
						l_sumsize := l_sumsize + (l_currsize + (l_spaces[l_t]).to_integer_32)
						l_endcurr2 := ('%/0/').code
						l_endcurr1 := l_endcurr2
						if a_insert_space.to_boolean then
							if l_currsize > 0 then
								if globals_inst.has_mbyte.to_boolean then
									l_cend.ce_gets (l_curr + l_currsize)
									if globals_inst.has_mbyte.to_boolean then
										l_tmp___7 := (globals_inst.mb_head_off.integer_32_item ([l_curr, l_cend - 1])) + 1
									else
										l_tmp___7 := 1
									end
									l_cend.ce_gets (l_cend - l_tmp___7)
									l_endcurr1 := globals_inst.mb_ptr2char.integer_32_item ([l_cend])
									if (l_cend.c_pointer.to_integer_32).to_natural_32 > (l_curr.c_pointer.to_integer_32).to_natural_32 then
										if globals_inst.has_mbyte.to_boolean then
											l_tmp___9 := (globals_inst.mb_head_off.integer_32_item ([l_curr, l_cend - 1])) + 1
										else
											l_tmp___9 := 1
										end
										l_cend.ce_gets (l_cend - l_tmp___9)
										l_endcurr2 := globals_inst.mb_ptr2char.integer_32_item ([l_cend])
									end
								else
									l_endcurr1 := ((l_curr + l_currsize)[-1]).to_integer_32
									if l_currsize > 1 then
										l_endcurr2 := ((l_curr + l_currsize)[-2]).to_integer_32
									end
								end
							end
						end
						misc1_inst.line_breakcheck
						if globals_inst.got_int.to_boolean then
							l_ret := 0
							l_pos := -1 + 24 -- goto theend
						end
				when 22 then
						l_t := l_t + 1
						l_pos := -1 + 2 -- back to loop condition
				when 23 then -- loop done
						l_col := (l_sumsize - l_currsize) - (l_spaces[(a_count___2 - 1)]).to_integer_32
						l_newp.ce_gets (misc2_inst.alloc_check ((l_sumsize + 1).to_natural_32))
						l_cend.ce_gets (l_newp + l_sumsize)
						l_cend.item := (0).to_natural_8
						l_t := a_count___2 - 1
						from
						until
							js.loop_left
						loop
							js.reset
							l_cend.ce_gets (l_cend - l_currsize)
							memmove (create {CE_POINTER [ANY]}.make_cast (l_cend), create {CE_POINTER [ANY]}.make_cast (l_curr), l_currsize.to_natural_32).do_nothing
							if (l_spaces[l_t]).to_integer_32 > 0 then
								l_cend.ce_gets (l_cend - (l_spaces[l_t]).to_integer_32)
								misc2_inst.copy_spaces (l_cend, (l_spaces[l_t]).to_natural_32)
							end
							mark_inst.mark_col_adjust (globals_inst.curwin.item.w_cursor.lnum + l_t, 0, -l_t, ((l_cend.distance (l_newp)) + (l_spaces[l_t]).to_integer_32).to_integer_32)
							if l_t = 0 then
								js.break
							end
							if not js.loop_jumped then
								l_curr.ce_gets (memline_inst.ml_get ((globals_inst.curwin.item.w_cursor.lnum + l_t) - 1))
								if a_insert_space.to_boolean then
									if l_t > 1 then
										l_curr.ce_gets (charset_inst.skipwhite (l_curr))
									end
								end
								l_currsize := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_curr))).to_integer_32
								l_t := l_t - 1
							end
						end
						js.reset
						memline_inst.ml_replace (globals_inst.curwin.item.w_cursor.lnum, l_newp, 0).do_nothing
						misc1_inst.changed_lines (globals_inst.curwin.item.w_cursor.lnum, l_currsize, globals_inst.curwin.item.w_cursor.lnum + 1, 0)
						l_t := globals_inst.curwin.item.w_cursor.lnum
						globals_inst.curwin.item.w_cursor.lnum := (globals_inst.curwin.item.w_cursor.lnum) + 1
						misc1_inst.del_lines (a_count___2 - 1, 0)
						globals_inst.curwin.item.w_cursor.lnum := l_t
						if ((misc2_inst.vim_strchr (option_inst.p_cpo, ('q').code)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							globals_inst.curwin.item.w_cursor.col := l_currsize
						else
							globals_inst.curwin.item.w_cursor.col := l_col
						end
						misc2_inst.check_cursor_col
						globals_inst.curwin.item.w_cursor.coladd := 0
						globals_inst.curwin.item.w_set_curswant := 1
				when 24 then -- theend:
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_spaces))
						Result := l_ret
				when 25 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	same_leader (a_lnum: INTEGER_32; a_leader1_len: INTEGER_32; a_leader1_flags: CE_POINTER [NATURAL_8]; a_leader2_len: INTEGER_32; a_leader2_flags: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_idx1: INTEGER_32
			l_idx2: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_line1: CE_POINTER [NATURAL_8]
			l_line2: CE_POINTER [NATURAL_8]
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p___0.make
			create l_line1.make
			create l_line2.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_idx1 := 0
					l_idx2 := 0
					if a_leader1_len = 0 then
						Result := (a_leader2_len = 0).to_integer
						js.return
					end
					if not js.return_called and then ((a_leader1_flags.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32) then
						l_p___0.ce_gets (a_leader1_flags)
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_p___0.item).to_boolean then
								if (l_p___0.item).to_integer_32 = 58 then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								if (l_p___0.item).to_integer_32 = 102 then
									Result := (a_leader2_len = 0).to_integer
									js.return
								end
								if not js.return_called and then ((l_p___0.item).to_integer_32 = 101) then
									Result := 0
									js.return
								end
								if not js.return_called and then ((l_p___0.item).to_integer_32 = 115) then
									if ((memline_inst.ml_get (a_lnum))[a_leader1_len]).to_integer_32 = 0 then
										Result := 0
										js.return
									end
									if not js.return_called then
										if (a_leader2_flags.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
											Result := 0
											js.return
										elseif a_leader2_len = 0 then
											Result := 0
											js.return
										end
									end
									if not js.return_called then
										l_p___0.ce_gets (a_leader2_flags)
										from
										until
											js.loop_left
										loop
											js.reset
											if (l_p___0.item).to_boolean then
												if (l_p___0.item).to_integer_32 = 58 then
													js.break
												end
											else
												js.break
											end
											if not js.loop_jumped then
												if (l_p___0.item).to_integer_32 = 109 then
													Result := 1
													js.return
												end
												if not js.return_called then
													l_p___0.ce_gets (l_p___0 + 1)
												end
											end
										end
										js.reset
									end
									if not js.return_called then
										Result := 0
										js.return
									end
								end
								if not js.return_called then
									l_p___0.ce_gets (l_p___0 + 1)
								end
							end
						end
						js.reset
					end
					if js.return_called then
						l_pos := -1 + 14 -- skip if block
					end
				when 1 then -- if:
						l_line1.ce_gets (misc2_inst.vim_strsave ((memline_inst.ml_get (a_lnum))))
						if (l_line1.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 13 -- skip if block
						end
				when 2 then -- if:
						l_idx1 := 0
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_line1[l_idx1]).to_integer_32 /= 32 then
								if (l_line1[l_idx1]).to_integer_32 /= 9 then
									js.break
								end
							end
							if not js.loop_jumped then
								l_idx1 := l_idx1 + 1
							end
						end
						js.reset
						l_line2.ce_gets (memline_inst.ml_get (a_lnum + 1))
						l_idx2 := 0
				when 3 then -- loop condition:
						if not (not js.loop_left and then (l_idx2 < a_leader2_len)) then
							l_pos := -1 + 12 -- skip loop
						end
				when 4 then -- loop body:
						js.reset
						if (l_line2[l_idx2]).to_integer_32 /= 32 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 7 then -- else:
						if (l_line2[l_idx2]).to_integer_32 /= 9 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_line1[l_idx1]).to_integer_32 /= 32 then
								if (l_line1[l_idx1]).to_integer_32 /= 9 then
									js.break
								end
							end
							if not js.loop_jumped then
								l_idx1 := l_idx1 + 1
							end
						end
						js.reset
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else:
						l_tmp___1 := l_idx1
						l_idx1 := l_idx1 + 1
						if (l_line1[l_tmp___1]).to_integer_32 /= (l_line2[l_idx2]).to_integer_32 then
							js.break
						end
				when 11 then -- if done
						if not js.loop_jumped then
							l_idx2 := l_idx2 + 1
						end
						l_pos := -1 + 3 -- back to loop condition
				when 12 then -- loop done
						js.reset
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_line1))
				when 13 then -- if done
						if l_idx2 = a_leader2_len then
							if l_idx1 = a_leader1_len then
								l_tmp___2 := 1
							else
								l_tmp___2 := 0
							end
						else
							l_tmp___2 := 0
						end
						Result := l_tmp___2
				when 14 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	op_format (a_oap: CE_POINTER [PD_OPARG_S]; a_keep_cursor: INTEGER_32)
		local
			l_old_line_count: INTEGER_32
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			js: JUMP_STATE
		do
			create l_wp___0.make

			l_old_line_count := globals_inst.curbuf.item.b_ml.ml_line_count
			globals_inst.curwin.item.w_cursor := a_oap.item.cursor_start
			if (undo_inst.u_save (a_oap.item.start.lnum - 1, a_oap.item.end2.lnum + 1)) = 0 then
				js.return
			end
			if not js.return_called then
				globals_inst.curwin.item.w_cursor := a_oap.item.start
				if (a_oap.item.is_VIsual).to_boolean then
					screen_inst.redraw_curbuf_later (20)
				end
				globals_inst.curbuf.item.b_op_start := a_oap.item.start
				if a_keep_cursor.to_boolean then
					globals_inst.saved_cursor.ce_gets (a_oap.item.cursor_start)
				end
				format_lines (a_oap.item.line_count, a_keep_cursor)
				if (a_oap.item.end_adjusted).to_boolean then
					if globals_inst.curwin.item.w_cursor.lnum < globals_inst.curbuf.item.b_ml.ml_line_count then
						globals_inst.curwin.item.w_cursor.lnum := (globals_inst.curwin.item.w_cursor.lnum) + 1
					end
				end
				edit_inst.beginline (5)
				l_old_line_count := globals_inst.curbuf.item.b_ml.ml_line_count - l_old_line_count
				misc1_inst.msgmore (l_old_line_count)
				globals_inst.curbuf.item.b_op_end := globals_inst.curwin.item.w_cursor
				if a_keep_cursor.to_boolean then
					globals_inst.curwin.item.w_cursor := globals_inst.saved_cursor
					globals_inst.saved_cursor.lnum := (0).to_integer_32
				end
				if (a_oap.item.is_VIsual).to_boolean then
					l_wp___0.ce_gets (globals_inst.firstwin)
					from
					until
						(l_wp___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32
					loop
						if l_wp___0.item.w_old_cursor_lnum /= 0 then
							if l_wp___0.item.w_old_cursor_lnum > l_wp___0.item.w_old_visual_lnum then
								l_wp___0.item.w_old_cursor_lnum := l_wp___0.item.w_old_cursor_lnum + l_old_line_count
							else
								l_wp___0.item.w_old_visual_lnum := l_wp___0.item.w_old_visual_lnum + l_old_line_count
							end
						end
						l_wp___0.ce_gets (l_wp___0.item.w_next)
					end
				end
			end
		end

	op_formatexpr (a_oap: CE_POINTER [PD_OPARG_S])
		do
			if (a_oap.item.is_VIsual).to_boolean then
				screen_inst.redraw_curbuf_later (20)
			end
			if (fex_format (a_oap.item.start.lnum, a_oap.item.line_count, ('%/0/').code)) /= 0 then
				op_format (a_oap, 0)
			end
		end

	fex_format (a_lnum: INTEGER_32; a_count___2: INTEGER_32; a_c: INTEGER_32): INTEGER_32
		local
			l_use_sandbox: INTEGER_32
			l_r: INTEGER_32
		do
			l_use_sandbox := (option_inst.was_set_insecurely (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("formatexpr")), 4))
			eval_inst.set_vim_var_nr (9, a_lnum)
			eval_inst.set_vim_var_nr (0, a_count___2)
			eval_inst.set_vim_var_char (a_c)
			if l_use_sandbox.to_boolean then
				globals_inst.sandbox := globals_inst.sandbox + 1
			end
			l_r := eval_inst.eval_to_number (globals_inst.curbuf.item.b_p_fex)
			if l_use_sandbox.to_boolean then
				globals_inst.sandbox := globals_inst.sandbox - 1
			end
			eval_inst.set_vim_var_string (48, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), -1)
			Result := l_r
		end

	format_lines (a_line_count: INTEGER_32; a_avoid_fex: INTEGER_32)
		local
			l_max_len: INTEGER_32
			l_is_not_par: INTEGER_32
			l_next_is_not_par: INTEGER_32
			l_is_end_par: INTEGER_32
			l_prev_is_end_par: INTEGER_32
			l_next_is_start_par: INTEGER_32
			l_leader_len: INTEGER_32
			l_next_leader_len: INTEGER_32
			l_leader_flags: CE_POINTER [NATURAL_8]
			l_next_leader_flags: CE_POINTER [NATURAL_8]
			l_do_comments: INTEGER_32
			l_advance: INTEGER_32
			l_second_indent: INTEGER_32
			l_do_second_indent: INTEGER_32
			l_do_number_indent: INTEGER_32
			l_do_trail_white: INTEGER_32
			l_first_par_line: INTEGER_32
			l_smd_save: INTEGER_32
			l_count___2: INTEGER_32
			l_need_set_indent: INTEGER_32
			l_force_format: INTEGER_32
			l_old_State: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___12: INTEGER_32
			l_tmp___13: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_leader_flags.make
			create l_next_leader_flags.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_prev_is_end_par := 0
					l_next_is_start_par := 0
					l_leader_len := 0
					l_leader_flags.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_advance := 1
					l_second_indent := -1
					l_first_par_line := 1
					l_need_set_indent := 1
					l_force_format := 0
					l_old_State := globals_inst.State
					l_max_len := (edit_inst.comp_textwidth (1)) * 3
					l_do_comments := option_inst.has_format_option (('q').code)
					l_do_second_indent := option_inst.has_format_option (('2').code)
					l_do_number_indent := option_inst.has_format_option (('n').code)
					l_do_trail_white := option_inst.has_format_option (('w').code)
					if globals_inst.curwin.item.w_cursor.lnum > 1 then
						l_is_not_par := fmt_check_par (globals_inst.curwin.item.w_cursor.lnum - 1, create {CE_POINTER [INTEGER_32]}.make_shared ($l_leader_len), l_leader_flags.address, l_do_comments)
					else
						l_is_not_par := 1
					end
					l_next_is_not_par := fmt_check_par (globals_inst.curwin.item.w_cursor.lnum, create {CE_POINTER [INTEGER_32]}.make_shared ($l_next_leader_len), l_next_leader_flags.address, l_do_comments)
					if l_is_not_par.to_boolean then
						l_tmp___0 := 1
					elseif l_next_is_not_par.to_boolean then
						l_tmp___0 := 1
					else
						l_tmp___0 := 0
					end
					l_is_end_par := l_tmp___0
					if not l_is_end_par.to_boolean then
						if l_do_trail_white.to_boolean then
							if (ends_in_white (globals_inst.curwin.item.w_cursor.lnum - 1)).to_boolean then
								l_tmp___2 := 0
							else
								l_tmp___2 := 1
							end
							l_is_end_par := l_tmp___2
						end
					end
					globals_inst.curwin.item.w_cursor.lnum := (globals_inst.curwin.item.w_cursor.lnum) - 1
					l_count___2 := a_line_count
				when 1 then -- loop condition:
					if js.loop_left then
						l_pos := -1 + 26 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						if l_count___2 /= 0 then
							if globals_inst.got_int.to_boolean then
								js.break
							end
						else
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 25 -- skip if block
						end
				when 3 then -- if:
						if l_advance.to_boolean then
							globals_inst.curwin.item.w_cursor.lnum := (globals_inst.curwin.item.w_cursor.lnum) + 1
							l_prev_is_end_par := l_is_end_par
							l_is_not_par := l_next_is_not_par
							l_leader_len := l_next_leader_len
							l_leader_flags.ce_gets (l_next_leader_flags)
						end
						if l_count___2 = 1 then
							l_next_is_not_par := 1
							l_next_leader_len := 0
							l_next_leader_flags.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						elseif globals_inst.curwin.item.w_cursor.lnum = globals_inst.curbuf.item.b_ml.ml_line_count then
							l_next_is_not_par := 1
							l_next_leader_len := 0
							l_next_leader_flags.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						else
							l_next_is_not_par := fmt_check_par (globals_inst.curwin.item.w_cursor.lnum + 1, create {CE_POINTER [INTEGER_32]}.make_shared ($l_next_leader_len), l_next_leader_flags.address, l_do_comments)
							if l_do_number_indent.to_boolean then
								l_next_is_start_par := ((misc1_inst.get_number_indent (globals_inst.curwin.item.w_cursor.lnum + 1)) > 0).to_integer
							end
						end
						l_advance := 1
						if l_is_not_par.to_boolean then
							l_tmp___4 := 1
						elseif l_next_is_not_par.to_boolean then
							l_tmp___4 := 1
						elseif l_next_is_start_par.to_boolean then
							l_tmp___4 := 1
						else
							l_tmp___4 := 0
						end
						l_is_end_par := l_tmp___4
						if not l_is_end_par.to_boolean then
							if l_do_trail_white.to_boolean then
								if (ends_in_white (globals_inst.curwin.item.w_cursor.lnum)).to_boolean then
									l_tmp___6 := 0
								else
									l_tmp___6 := 1
								end
								l_is_end_par := l_tmp___6
							end
						end
						if not (l_is_not_par.to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if a_line_count < 0 then
							js.break
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 6 then -- else:
						if not (l_first_par_line.to_boolean) then
							l_pos := -1 + 19 -- skip if block
						end
				when 7 then -- if:
						if not (l_do_second_indent.to_boolean) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 11 -- goto _L___0
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 10 then -- else:
						if not (l_do_number_indent.to_boolean) then
							l_pos := -1 + 19 -- skip if block
						end
				when 11 then -- if: | _L___0:
						if not (l_prev_is_end_par.to_boolean) then
							l_pos := -1 + 19 -- skip if block
						end
				when 12 then -- if:
						if not (globals_inst.curwin.item.w_cursor.lnum < globals_inst.curbuf.item.b_ml.ml_line_count) then
							l_pos := -1 + 19 -- skip if block
						end
				when 13 then -- if:
						if l_leader_len /= 0 then
							l_pos := -1 + 19 -- skip if block
						end
				when 14 then -- if:
						if l_next_leader_len /= 0 then
							l_pos := -1 + 19 -- skip if block
						end
				when 15 then -- if:
						if not (l_do_second_indent.to_boolean) then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						if ((memline_inst.ml_get (globals_inst.curwin.item.w_cursor.lnum + 1)).item).to_integer_32 = 0 then
							l_pos := -1 + 18 -- goto _L
						else
							l_second_indent := misc1_inst.get_indent_lnum (globals_inst.curwin.item.w_cursor.lnum + 1)
						end
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 18 then -- else: | _L:
						if l_do_number_indent.to_boolean then
							l_second_indent := misc1_inst.get_number_indent (globals_inst.curwin.item.w_cursor.lnum)
						end
				when 19 then -- if done | if done | if done | if done | if done | if done | if done
						if globals_inst.curwin.item.w_cursor.lnum >= globals_inst.curbuf.item.b_ml.ml_line_count then
							l_is_end_par := 1
						elseif not (same_leader (globals_inst.curwin.item.w_cursor.lnum, l_leader_len, l_leader_flags, l_next_leader_len, l_next_leader_flags)).to_boolean then
							l_is_end_par := 1
						end
						if not (l_is_end_par.to_boolean) then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						l_pos := -1 + 23 -- goto _L___1
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 22 then -- else:
						if not (l_force_format.to_boolean) then
							l_pos := -1 + 24 -- skip if block
						end
				when 23 then -- if: | _L___1:
						if l_need_set_indent.to_boolean then
							misc1_inst.set_indent ((misc1_inst.get_indent), 1).do_nothing
						end
						globals_inst.State := 1
						misc2_inst.coladvance ((2147483647).to_integer_32).do_nothing
						from
						until
							js.loop_left
						loop
							js.reset
							if (globals_inst.curwin.item.w_cursor.col).to_boolean then
								if not (misc2_inst.vim_isspace ((misc1_inst.gchar_cursor))).to_boolean then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								misc2_inst.dec_cursor.do_nothing
							end
						end
						js.reset
						globals_inst.State := 16
						l_smd_save := option_inst.p_smd
						option_inst.p_smd := 0
						if l_do_comments.to_boolean then
							l_tmp___12 := 2
						else
							l_tmp___12 := 0
						end
						if a_avoid_fex.to_boolean then
							l_tmp___13 := 8
						else
							l_tmp___13 := 0
						end
						edit_inst.insertchar (('%/0/').code, (1 + l_tmp___12) + l_tmp___13, l_second_indent)
						globals_inst.State := l_old_State
						option_inst.p_smd := l_smd_save
						l_second_indent := -1
						l_need_set_indent := l_is_end_par
						if l_is_end_par.to_boolean then
							if a_line_count < 0 then
								js.break
							end
							if not js.loop_jumped then
								l_first_par_line := 1
							end
						end
						if not js.loop_jumped then
							l_force_format := 0
						end
				when 24 then -- if done
						if not js.loop_jumped and then (not l_is_end_par.to_boolean) then
							l_advance := 0
							globals_inst.curwin.item.w_cursor.lnum := (globals_inst.curwin.item.w_cursor.lnum) + 1
							globals_inst.curwin.item.w_cursor.col := 0
							if a_line_count < 0 then
								if (undo_inst.u_save_cursor) = 0 then
									js.break
								end
							end
							if not js.loop_jumped then
								misc1_inst.del_bytes (l_next_leader_len.to_integer_32, 0, 0).do_nothing
								if l_next_leader_len > 0 then
									mark_inst.mark_col_adjust (globals_inst.curwin.item.w_cursor.lnum, 0, 0, (-l_next_leader_len).to_integer_32)
								end
								globals_inst.curwin.item.w_cursor.lnum := (globals_inst.curwin.item.w_cursor.lnum) - 1
								if (do_join (2, 1, 0)) = 0 then
									misc1_inst.beep_flush
									js.break
								end
							end
							if not js.loop_jumped then
								l_first_par_line := 0
								if (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((memline_inst.ml_get_curline)))) > l_max_len.to_natural_32 then
									l_force_format := 1
								else
									l_force_format := 0
								end
							end
						end
				when 25 then -- if done | if done
						if not js.loop_jumped then
							misc1_inst.line_breakcheck
							l_count___2 := l_count___2 - 1
						end
						l_pos := -1 + 1 -- back to loop condition
				when 26 then -- loop done
					js.reset
				when 27 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ends_in_white (a_lnum: INTEGER_32): INTEGER_32
		local
			l_s: CE_POINTER [NATURAL_8]
			l_l: NATURAL_32
			l_tmp___1: INTEGER_32
			js: JUMP_STATE
		do
			create l_s.make

			l_s.ce_gets ((memline_inst.ml_get (a_lnum)))
			if (l_s.item).to_integer_32 = 0 then
				Result := 0
				js.return
			end
			if not js.return_called then
				l_l := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_s))) - {NATURAL_32} 1
				if (l_s[l_l.to_integer_32]).to_integer_32 = 32 then
					l_tmp___1 := 1
				elseif (l_s[l_l.to_integer_32]).to_integer_32 = 9 then
					l_tmp___1 := 1
				else
					l_tmp___1 := 0
				end
				Result := l_tmp___1
			end
		end

	fmt_check_par (a_lnum: INTEGER_32; a_leader_len: CE_POINTER [INTEGER_32]; a_leader_flags: CE_POINTER [CE_POINTER [NATURAL_8]]; a_do_comments: INTEGER_32): INTEGER_32
		local
			l_flags___0: CE_POINTER [NATURAL_8]
			l_ptr: CE_POINTER [NATURAL_8]
			l_tmp___1: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_flags___0.make
			create l_ptr.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_flags___0.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_ptr.ce_gets (memline_inst.ml_get (a_lnum))
					if a_do_comments.to_boolean then
						a_leader_len.item := misc1_inst.get_leader_len (l_ptr, a_leader_flags, 0)
					else
						a_leader_len.item := 0
					end
					if a_leader_len.item > 0 then
						l_flags___0.ce_gets (a_leader_flags.item)
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_flags___0.item).to_boolean then
								if (l_flags___0.item).to_integer_32 /= 58 then
									if (l_flags___0.item).to_integer_32 = 101 then
										js.break
									end
								else
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_flags___0.ce_gets (l_flags___0 + 1)
							end
						end
						js.reset
					end
					if ((charset_inst.skipwhite (l_ptr + a_leader_len.item)).item).to_integer_32 /= 0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_tmp___1 := 1
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if not (a_leader_len.item > 0) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if (l_flags___0.item).to_integer_32 = 101 then
							l_tmp___1 := 1
						else
							l_pos := -1 + 6 -- goto _L
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L:
						if (search_inst.startPS (a_lnum, ('%/0/').code, 0)).to_boolean then
							l_tmp___1 := 1
						else
							l_tmp___1 := 0
						end
				when 7 then -- if done
						Result := l_tmp___1
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	paragraph_start (a_lnum: INTEGER_32): INTEGER_32
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_leader_len: INTEGER_32
			l_leader_flags: CE_POINTER [NATURAL_8]
			l_next_leader_len: INTEGER_32
			l_next_leader_flags: CE_POINTER [NATURAL_8]
			l_do_comments: INTEGER_32
			js: JUMP_STATE
		do
			create l_p___0.make
			create l_leader_flags.make
			create l_next_leader_flags.make

			l_leader_len := 0
			l_leader_flags.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
			if a_lnum <= 1 then
				Result := 1
				js.return
			end
			if not js.return_called then
				l_p___0.ce_gets (memline_inst.ml_get (a_lnum - 1))
				if (l_p___0.item).to_integer_32 = 0 then
					Result := 1
					js.return
				end
			end
			if not js.return_called then
				l_do_comments := option_inst.has_format_option (('q').code)
				if (fmt_check_par (a_lnum - 1, create {CE_POINTER [INTEGER_32]}.make_shared ($l_leader_len), l_leader_flags.address, l_do_comments)).to_boolean then
					Result := 1
					js.return
				end
			end
			if not js.return_called then
				if (fmt_check_par (a_lnum, create {CE_POINTER [INTEGER_32]}.make_shared ($l_next_leader_len), l_next_leader_flags.address, l_do_comments)).to_boolean then
					Result := 1
					js.return
				end
			end
			if not js.return_called then
				if (option_inst.has_format_option (('w').code)).to_boolean then
					if not (ends_in_white (a_lnum - 1)).to_boolean then
						Result := 1
						js.return
					end
				end
			end
			if not js.return_called then
				if (option_inst.has_format_option (('n').code)).to_boolean then
					if (misc1_inst.get_number_indent (a_lnum)) > 0 then
						Result := 1
						js.return
					end
				end
			end
			if not js.return_called then
				if not (same_leader (a_lnum - 1, l_leader_len, l_leader_flags, l_next_leader_len, l_next_leader_flags)).to_boolean then
					Result := 1
					js.return
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	block_prep (a_oap: CE_POINTER [PD_OPARG_S]; a_bdp: CE_POINTER [PD_BLOCK_DEF]; a_lnum: INTEGER_32; a_is_del: INTEGER_32)
		local
			l_incr: INTEGER_32
			l_pend: CE_POINTER [NATURAL_8]
			l_pstart: CE_POINTER [NATURAL_8]
			l_line: CE_POINTER [NATURAL_8]
			l_prev_pstart: CE_POINTER [NATURAL_8]
			l_prev_pend: CE_POINTER [NATURAL_8]
			l_tmp___0: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_pend.make
			create l_pstart.make
			create l_line.make
			create l_prev_pstart.make
			create l_prev_pend.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_incr := 0
					a_bdp.item.startspaces := 0
					a_bdp.item.endspaces := 0
					a_bdp.item.textlen := 0
					a_bdp.item.start_vcol := 0
					a_bdp.item.end_vcol := 0
					a_bdp.item.is_short := 0
					a_bdp.item.is_oneChar := 0
					a_bdp.item.pre_whitesp := 0
					a_bdp.item.pre_whitesp_c := 0
					a_bdp.item.end_char_vcols := 0
					a_bdp.item.start_char_vcols := 0
					l_line.ce_gets (memline_inst.ml_get (a_lnum))
					l_pstart.ce_gets (l_line)
					l_prev_pstart.ce_gets (l_line)
					from
					until
						js.loop_left
					loop
						js.reset
						if a_bdp.item.start_vcol < a_oap.item.start_vcol then
							if not (l_pstart.item).to_boolean then
								js.break
							end
						else
							js.break
						end
						if not js.loop_jumped then
							l_incr := charset_inst.lbr_chartabsize (l_pstart, a_bdp.item.start_vcol)
							a_bdp.item.start_vcol := a_bdp.item.start_vcol + l_incr
							if (l_pstart.item).to_integer_32 = 32 then
								a_bdp.item.pre_whitesp := a_bdp.item.pre_whitesp + l_incr
								a_bdp.item.pre_whitesp_c := (a_bdp.item.pre_whitesp_c) + 1
							elseif (l_pstart.item).to_integer_32 = 9 then
								a_bdp.item.pre_whitesp := a_bdp.item.pre_whitesp + l_incr
								a_bdp.item.pre_whitesp_c := (a_bdp.item.pre_whitesp_c) + 1
							else
								a_bdp.item.pre_whitesp := 0
								a_bdp.item.pre_whitesp_c := 0
							end
							l_prev_pstart.ce_gets (l_pstart)
							if globals_inst.has_mbyte.to_boolean then
								l_tmp___0 := (globals_inst.mb_ptr2len.integer_32_item ([l_pstart]))
							else
								l_tmp___0 := 1
							end
							l_pstart.ce_gets (l_pstart + l_tmp___0)
						end
					end
					js.reset
					a_bdp.item.start_char_vcols := l_incr
					if not (a_bdp.item.start_vcol < a_oap.item.start_vcol) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						a_bdp.item.end_vcol := a_bdp.item.start_vcol
						a_bdp.item.is_short := 1
						if not a_is_del.to_boolean then
							a_bdp.item.endspaces := (a_oap.item.end_vcol - a_oap.item.start_vcol) + 1
						elseif a_oap.item.op_type = 18 then
							a_bdp.item.endspaces := (a_oap.item.end_vcol - a_oap.item.start_vcol) + 1
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 3 then -- else:
						a_bdp.item.startspaces := a_bdp.item.start_vcol - a_oap.item.start_vcol
						if a_is_del.to_boolean then
							if (a_bdp.item.startspaces).to_boolean then
								a_bdp.item.startspaces := a_bdp.item.start_char_vcols - a_bdp.item.startspaces
							end
						end
						l_pend.ce_gets (l_pstart)
						a_bdp.item.end_vcol := a_bdp.item.start_vcol
						if not (a_bdp.item.end_vcol > a_oap.item.end_vcol) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						a_bdp.item.is_oneChar := 1
						if a_oap.item.op_type = 17 then
							a_bdp.item.endspaces := a_bdp.item.start_char_vcols - a_bdp.item.startspaces
						elseif a_oap.item.op_type = 18 then
							a_bdp.item.startspaces := a_bdp.item.startspaces + ((a_oap.item.end_vcol - a_oap.item.start_vcol) + 1)
							a_bdp.item.endspaces := a_bdp.item.start_char_vcols - a_bdp.item.startspaces
						else
							a_bdp.item.startspaces := (a_oap.item.end_vcol - a_oap.item.start_vcol) + 1
							if a_is_del.to_boolean then
								if a_oap.item.op_type /= 4 then
									a_bdp.item.startspaces := a_bdp.item.start_char_vcols - (a_bdp.item.start_vcol - a_oap.item.start_vcol)
									a_bdp.item.endspaces := (a_bdp.item.end_vcol - a_oap.item.end_vcol) - 1
								end
							end
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 6 then -- else:
						l_prev_pend.ce_gets (l_pend)
						from
						until
							js.loop_left
						loop
							js.reset
							if a_bdp.item.end_vcol <= a_oap.item.end_vcol then
								if (l_pend.item).to_integer_32 = 0 then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_prev_pend.ce_gets (l_pend)
								l_incr := charset_inst.lbr_chartabsize_adv (l_pend.address, a_bdp.item.end_vcol)
								a_bdp.item.end_vcol := a_bdp.item.end_vcol + l_incr
							end
						end
						js.reset
						if not (a_bdp.item.end_vcol <= a_oap.item.end_vcol) then
							l_pos := -1 + 18 -- skip if block
						end
				when 7 then -- if:
						if a_is_del.to_boolean then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 14 -- goto _L___0
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 10 then -- else:
						if a_oap.item.op_type /= 18 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_pos := -1 + 14 -- goto _L___0
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 13 then -- else:
						if a_oap.item.op_type /= 16 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if: | _L___0:
						a_bdp.item.is_short := 1
						if a_oap.item.op_type = 18 then
							a_bdp.item.endspaces := (a_oap.item.end_vcol - a_bdp.item.end_vcol) + a_oap.item.inclusive
						elseif globals_inst.virtual_op.to_boolean then
							a_bdp.item.endspaces := (a_oap.item.end_vcol - a_bdp.item.end_vcol) + a_oap.item.inclusive
						else
							a_bdp.item.endspaces := 0
						end
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 16 then -- else:
						l_pos := -1 + 18 -- goto _L
				when 17 then -- if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 19
				when 18 then -- else: | _L:
						if a_bdp.item.end_vcol > a_oap.item.end_vcol then
							a_bdp.item.endspaces := (a_bdp.item.end_vcol - a_oap.item.end_vcol) - 1
							if not a_is_del.to_boolean then
								if (a_bdp.item.endspaces).to_boolean then
									a_bdp.item.endspaces := l_incr - a_bdp.item.endspaces
									if (l_pend.c_pointer.to_integer_32).to_natural_32 /= (l_pstart.c_pointer.to_integer_32).to_natural_32 then
										l_pend.ce_gets (l_prev_pend)
									end
								end
							end
						end
				when 19 then -- if done
						a_bdp.item.end_char_vcols := l_incr
						if a_is_del.to_boolean then
							if (a_bdp.item.startspaces).to_boolean then
								l_pstart.ce_gets (l_prev_pstart)
							end
						end
						a_bdp.item.textlen := l_pend.distance (l_pstart)
				when 20 then -- if done
					a_bdp.item.textcol := l_pstart.distance (l_line)
					a_bdp.item.textstart := l_pstart
				when 21 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	do_addsub (a_command: INTEGER_32; a_Prenum1: INTEGER_32): INTEGER_32
		local
			l_col: INTEGER_32
			l_buf1: CE_POINTER [NATURAL_8]
			l_buf2: CE_ARRAY [NATURAL_8]
			l_hex: INTEGER_32
			l_n: NATURAL_32
			l_oldn: NATURAL_32
			l_ptr: CE_POINTER [NATURAL_8]
			l_c: INTEGER_32
			l_length: INTEGER_32
			l_todel: INTEGER_32
			l_dohex: INTEGER_32
			l_dooct: INTEGER_32
			l_doalp: INTEGER_32
			l_firstdigit: INTEGER_32
			l_negative: INTEGER_32
			l_subtract: INTEGER_32
			l_tmp___11: INTEGER_32
			l_tmp___13: INTEGER_32
			l_tmp___16: INTEGER_32
			l_tmp___17: CE_POINTER [NATURAL_8]
			l_tmp___18: CE_POINTER [NATURAL_8]
			l_tmp___19: CE_POINTER [NATURAL_8]
			l_tmp___21: CE_POINTER [NATURAL_8]
			l_tmp___22: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_buf1.make
			create l_buf2.make (<<30>>)
			create l_ptr.make
			create l_tmp___17.make
			create l_tmp___18.make
			create l_tmp___19.make
			create l_tmp___21.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_length := 0
					l_dohex := (((misc2_inst.vim_strchr (globals_inst.curbuf.item.b_p_nf, ('x').code)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer
					l_dooct := (((misc2_inst.vim_strchr (globals_inst.curbuf.item.b_p_nf, ('o').code)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer
					l_doalp := (((misc2_inst.vim_strchr (globals_inst.curbuf.item.b_p_nf, ('p').code)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer
					l_ptr.ce_gets (memline_inst.ml_get_curline)
					l_col := globals_inst.curwin.item.w_cursor.col
					if l_dohex.to_boolean then
						from
						until
							js.loop_left
						loop
							js.reset
							if l_col > 0 then
								if not (charset_inst.vim_isxdigit ((l_ptr[l_col]).to_integer_32)).to_boolean then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_col := l_col - 1
							end
						end
						js.reset
					end
					if not (l_dohex.to_boolean) then
						l_pos := -1 + 12 -- skip if block
					end
				when 1 then -- if:
						if not (l_col > 0) then
							l_pos := -1 + 10 -- skip if block
						end
				when 2 then -- if:
						if (l_ptr[l_col]).to_integer_32 /= 88 then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_pos := -1 + 6 -- goto _L___2
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 5 then -- else:
						if (l_ptr[l_col]).to_integer_32 /= 120 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if: | _L___2:
						if (l_ptr[(l_col - 1)]).to_integer_32 = 48 then
							if (charset_inst.vim_isxdigit ((l_ptr[(l_col + 1)]).to_integer_32)).to_boolean then
								l_col := l_col - 1
							else
								l_pos := -1 + 12 -- goto _L___3
							end
						else
							l_pos := -1 + 12 -- goto _L___3
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else:
						l_pos := -1 + 12 -- goto _L___3
				when 9 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else:
						l_pos := -1 + 12 -- goto _L___3
				when 11 then -- if done | if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else: | _L___3:
						l_col := globals_inst.curwin.item.w_cursor.col
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_ptr[l_col]).to_integer_32 /= 0 then
								if (charset_inst.vim_isdigit ((l_ptr[l_col]).to_integer_32)).to_boolean then
									js.break
								elseif l_doalp.to_boolean then
									if (l_ptr[l_col]).to_integer_32 < 127 then
										if ((((ctype_b_loc).item[(l_ptr[l_col]).to_integer_32]).to_integer_32).bit_and (1024)).to_boolean then
											js.break
										end
									end
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_col := l_col + 1
							end
						end
						js.reset
						from
						until
							js.loop_left
						loop
							js.reset
							if l_col > 0 then
								if (charset_inst.vim_isdigit ((l_ptr[(l_col - 1)]).to_integer_32)).to_boolean then
									if l_doalp.to_boolean then
										if (l_ptr[l_col]).to_integer_32 < 127 then
											if ((((ctype_b_loc).item[(l_ptr[l_col]).to_integer_32]).to_integer_32).bit_and (1024)).to_boolean then
												js.break
											end
										end
									end
								else
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_col := l_col - 1
							end
						end
						js.reset
				when 13 then
					l_firstdigit := (l_ptr[l_col]).to_integer_32
					if not (l_firstdigit >= 48) then
						l_pos := -1 + 19 -- skip if block
					end
				when 14 then -- if:
						if not (l_firstdigit <= 57) then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if: | _L___4:
						if (undo_inst.u_save_cursor) /= 1 then
							misc1_inst.beep_flush
							Result := 0
							js.return
						end
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 17 then -- else:
						l_pos := -1 + 19 -- goto _L___5
				when 18 then -- if done | if block done, skip else block:
						l_pos := -1 + 20
				when 19 then -- else: | _L___5:
						if l_doalp.to_boolean then
							if l_firstdigit < 127 then
								if ((((ctype_b_loc).item[l_firstdigit]).to_integer_32).bit_and (1024)).to_boolean then
									l_pos := -1 + 15 -- goto _L___4
								else
									misc1_inst.beep_flush
									Result := 0
									js.return
								end
							else
								misc1_inst.beep_flush
								Result := 0
								js.return
							end
						else
							misc1_inst.beep_flush
							Result := 0
							js.return
						end
				when 20 then
					if js.return_called then
						l_pos := -1 + 31 -- skip if block
					end
				when 21 then -- if:
						l_ptr.ce_gets (memline_inst.ml_get_curline)
						if not (l_doalp.to_boolean) then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if:
						if l_firstdigit < 127 then
							if ((((ctype_b_loc).item[l_firstdigit]).to_integer_32).bit_and (1024)).to_boolean then
								if a_command = 24 then
									if l_firstdigit < 97 then
										l_tmp___11 := l_firstdigit - 65
									else
										l_tmp___11 := l_firstdigit - 97
									end
									if l_tmp___11.to_integer_32 < a_Prenum1 then
										if ((((ctype_b_loc).item[l_firstdigit]).to_integer_32).bit_and (256)).to_boolean then
											l_firstdigit := ('A').code
										else
											l_firstdigit := ('a').code
										end
									else
										l_firstdigit := (l_firstdigit.to_integer_32 - a_Prenum1).to_integer_32
									end
								else
									if l_firstdigit < 97 then
										l_tmp___13 := l_firstdigit - 65
									else
										l_tmp___13 := l_firstdigit - 97
									end
									if ((26 - l_tmp___13) - 1).to_integer_32 < a_Prenum1 then
										if ((((ctype_b_loc).item[l_firstdigit]).to_integer_32).bit_and (256)).to_boolean then
											l_firstdigit := ('Z').code
										else
											l_firstdigit := ('z').code
										end
									else
										l_firstdigit := (l_firstdigit.to_integer_32 + a_Prenum1).to_integer_32
									end
								end
								globals_inst.curwin.item.w_cursor.col := l_col
								misc1_inst.del_char (0).do_nothing
								misc1_inst.ins_char (l_firstdigit)
							else
								l_pos := -1 + 24 -- goto _L___7
							end
						else
							l_pos := -1 + 24 -- goto _L___7
						end
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 24 then -- else: | _L___7:
						l_negative := 0
						if l_col > 0 then
							if (l_ptr[(l_col - 1)]).to_integer_32 = 45 then
								l_col := l_col - 1
								l_negative := 1
							end
						end
						charset_inst.vim_str2nr (l_ptr + l_col, create {CE_POINTER [INTEGER_32]}.make_shared ($l_hex), create {CE_POINTER [INTEGER_32]}.make_shared ($l_length), l_dooct, l_dohex, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_32]}.make_shared ($l_n))
						if l_hex.to_boolean then
							if l_negative.to_boolean then
								l_col := l_col + 1
								l_length := l_length - 1
								l_negative := 0
							end
						end
						l_subtract := 0
						if a_command = 24 then
							l_subtract := (l_subtract).bit_xor ((1))
						end
						if l_negative.to_boolean then
							l_subtract := (l_subtract).bit_xor ((1))
						end
						l_oldn := l_n
						if l_subtract.to_boolean then
							l_n := l_n - a_Prenum1.to_natural_32
						else
							l_n := l_n + a_Prenum1.to_natural_32
						end
						if not l_hex.to_boolean then
							if l_subtract.to_boolean then
								if l_n > l_oldn then
									l_n := {NATURAL_32} 1 + ((l_n).bit_xor ({NATURAL_32} 4294967295))
									l_negative := (l_negative).bit_xor ((1))
								end
							elseif l_n < l_oldn then
								l_n := (l_n).bit_xor (({NATURAL_32} 4294967295))
								l_negative := (l_negative).bit_xor ((1))
							end
							if l_n = {NATURAL_32} 0 then
								l_negative := 0
							end
						end
						globals_inst.curwin.item.w_cursor.col := l_col
						l_todel := l_length
						l_c := misc1_inst.gchar_cursor
						if l_c = 45 then
							l_length := l_length - 1
						end
						from
						until
							js.loop_left
						loop
							js.reset
							l_tmp___16 := l_todel
							l_todel := l_todel - 1
							if not (l_tmp___16 > 0) then
								js.break
							end
							if not js.loop_jumped then
								if l_c < 256 then
									if ((((ctype_b_loc).item[l_c]).to_integer_32).bit_and (1024)).to_boolean then
										if ((((ctype_b_loc).item[l_c]).to_integer_32).bit_and (256)).to_boolean then
											hexupper := 1
										else
											hexupper := 0
										end
									end
								end
								misc1_inst.del_char (0).do_nothing
								l_c := misc1_inst.gchar_cursor
							end
						end
						js.reset
						l_buf1.ce_gets (misc2_inst.alloc (l_length.to_natural_32 + {NATURAL_32} 30))
						if (l_buf1.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							Result := 0
							js.return
						end
						if js.return_called then
							l_pos := -1 + 31 -- skip if block
						end
				when 25 then -- if:
						l_ptr.ce_gets (l_buf1)
						if l_negative.to_boolean then
							l_tmp___17.ce_gets (l_ptr)
							l_ptr.ce_gets (l_ptr + 1)
							l_tmp___17.item := (('-').code).to_natural_8
						end
						if l_hex.to_boolean then
							l_tmp___18.ce_gets (l_ptr)
							l_ptr.ce_gets (l_ptr + 1)
							l_tmp___18.item := (('0').code).to_natural_8
							l_length := l_length - 1
						end
						if l_hex = 120 then
							l_tmp___19.ce_gets (l_ptr)
							l_ptr.ce_gets (l_ptr + 1)
							l_tmp___19.item := l_hex.to_natural_8
							l_length := l_length - 1
						elseif l_hex = 88 then
							l_tmp___19.ce_gets (l_ptr)
							l_ptr.ce_gets (l_ptr + 1)
							l_tmp___19.item := l_hex.to_natural_8
							l_length := l_length - 1
						end
						if l_hex = 0 then
							sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_buf2), ce_string ("%%lu"), l_n]).do_nothing
						elseif l_hex = 48 then
							sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_buf2), ce_string ("%%lo"), l_n]).do_nothing
						elseif l_hex.to_boolean then
							if hexupper.to_boolean then
								sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_buf2), ce_string ("%%lX"), l_n]).do_nothing
							else
								sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_buf2), ce_string ("%%lx"), l_n]).do_nothing
							end
						else
							sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_buf2), ce_string ("%%lx"), l_n]).do_nothing
						end
						l_length := l_length - (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_buf2))).to_integer_32
						if l_firstdigit /= 48 then
							l_pos := -1 + 30 -- skip if block
						end
				when 26 then -- if:
						if not (l_dooct.to_boolean) then
							l_pos := -1 + 29 -- skip if block
						end
				when 27 then -- if:
						if l_hex /= 0 then
							l_pos := -1 + 29 -- goto _L___6
						end
				when 28 then -- if block done, skip else block:
						l_pos := -1 + 30
				when 29 then -- else: | _L___6:
						from
						until
							js.loop_left
						loop
							js.reset
							l_tmp___22 := l_length
							l_length := l_length - 1
							if not (l_tmp___22 > 0) then
								js.break
							end
							if not js.loop_jumped then
								l_tmp___21.ce_gets (l_ptr)
								l_ptr.ce_gets (l_ptr + 1)
								l_tmp___21.item := (('0').code).to_natural_8
							end
						end
						js.reset
				when 30 then -- if done
						l_ptr.item := (('%/0/').code).to_natural_8
						strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_buf1), create {CE_POINTER [INTEGER_8]}.make_cast (l_buf2)).do_nothing
						misc1_inst.ins_str (l_buf1)
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_buf1))
				when 31 then -- if done | if done
						if not js.return_called then
							globals_inst.curwin.item.w_cursor.col := (globals_inst.curwin.item.w_cursor.col) - 1
							globals_inst.curwin.item.w_set_curswant := 1
							Result := 1
						end
				when 32 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	read_viminfo_register (a_virp: CE_POINTER [PD_VIR_T]; a_force: INTEGER_32): INTEGER_32
		local
			l_eof: INTEGER_32
			l_do_it: INTEGER_32
			l_size: INTEGER_32
			l_limit: INTEGER_32
			l_i___0: INTEGER_32
			l_set_prev: INTEGER_32
			l_str___1: CE_POINTER [NATURAL_8]
			l_array: CE_POINTER [CE_POINTER [NATURAL_8]]
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_tmp___3: CE_POINTER [CE_POINTER [NATURAL_8]]
			l_tmp___11: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_str___1.make
			create l_array.make
			create l_tmp___2.make
			create l_tmp___3.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_do_it := 1
					l_set_prev := 0
					l_array.ce_gets (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer))
					l_str___1.ce_gets (a_virp.item.vir_line + 1)
					if (l_str___1.item).to_integer_32 = 34 then
						l_set_prev := 1
						l_str___1.ce_gets (l_str___1 + 1)
					end
					if not ((l_str___1.item).to_integer_32 < 127) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if not ((((ctype_b_loc).item[(l_str___1.item).to_integer_32]).to_integer_32).bit_and (8)).to_boolean then
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						if (l_str___1.item).to_integer_32 /= 45 then
							if (ex_cmds_inst.viminfo_error (ce_string ("E577: "), (gettext (ce_string ("Illegal register name"))), a_virp.item.vir_line)).to_boolean then
								Result := 1
								js.return
							end
							if not js.return_called then
								l_do_it := 0
							end
						end
				when 4 then
					if not js.return_called then
						l_tmp___2.ce_gets (l_str___1)
						l_str___1.ce_gets (l_str___1 + 1)
						get_yank_register ((l_tmp___2.item).to_integer_32, 0)
						if not a_force.to_boolean then
							if ((y_current.item.y_array).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								l_do_it := 0
							end
						end
						if (l_str___1.item).to_integer_32 = 64 then
							if a_force.to_boolean then
								execreg_lastc := (l_str___1[-1]).to_integer_32
							elseif execreg_lastc = 0 then
								execreg_lastc := (l_str___1[-1]).to_integer_32
							end
						end
						l_size := 0
						l_limit := 100
						if l_do_it.to_boolean then
							if l_set_prev.to_boolean then
								y_previous.ce_gets (y_current)
							end
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (y_current.item.y_array))
							l_tmp___3.ce_gets (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast ((misc2_inst.alloc (l_limit.to_natural_32 * Pointer_bytes.to_natural_32))))
							y_current.item.y_array := l_tmp___3
							l_array.ce_gets (l_tmp___3)
							l_str___1.ce_gets (charset_inst.skipwhite ((charset_inst.skiptowhite (l_str___1))))
							if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_str___1), ce_string ("CHAR"), (4).to_natural_32)) = 0 then
								y_current.item.y_type := (0).to_natural_8
							elseif (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_str___1), ce_string ("BLOCK"), (5).to_natural_32)) = 0 then
								y_current.item.y_type := (2).to_natural_8
							else
								y_current.item.y_type := (1).to_natural_8
							end
							l_str___1.ce_gets (charset_inst.skipwhite ((charset_inst.skiptowhite (l_str___1))))
							y_current.item.y_width := (charset_inst.getdigits (l_str___1.address)).to_integer_32
						end
						from
						until
							js.loop_left
						loop
							js.reset
							l_eof := ex_cmds_inst.viminfo_readline (a_virp)
							if l_eof.to_boolean then
								js.break
							elseif (a_virp.item.vir_line[0]).to_integer_32 /= 9 then
								if (a_virp.item.vir_line[0]).to_integer_32 /= 60 then
									js.break
								end
							end
							if not js.loop_jumped and then (l_do_it.to_boolean) then
								if l_size >= l_limit then
									y_current.item.y_array := create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast ((misc2_inst.alloc ((l_limit * 2).to_natural_32 * Pointer_bytes.to_natural_32)))
									l_i___0 := 0
									from
									until
										not (l_i___0 < l_limit)
									loop
										y_current.item.y_array[l_i___0] := l_array[l_i___0]
										l_i___0 := l_i___0 + 1
									end
									misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_array))
									l_limit := l_limit * (2)
									l_array.ce_gets (y_current.item.y_array)
								end
								l_str___1.ce_gets (ex_cmds_inst.viminfo_readstring (a_virp, 1, 1))
								if (l_str___1.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									l_tmp___11 := l_size
									l_size := l_size + 1
									l_array[l_tmp___11] := l_str___1
								else
									l_do_it := 0
								end
							end
						end
						js.reset
						if l_do_it.to_boolean then
							if l_size = 0 then
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_array))
								y_current.item.y_array := create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer)
							elseif l_size < l_limit then
								y_current.item.y_array := create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast ((misc2_inst.alloc (l_size.to_natural_32 * Pointer_bytes.to_natural_32)))
								l_i___0 := 0
								from
								until
									not (l_i___0 < l_size)
								loop
									y_current.item.y_array[l_i___0] := l_array[l_i___0]
									l_i___0 := l_i___0 + 1
								end
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_array))
							end
							y_current.item.y_size := l_size.to_integer_32
						end
						Result := l_eof
					end
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	write_viminfo_registers (a_fp: CE_POINTER [SD_IO_FILE])
		local
			l_i___0: INTEGER_32
			l_j: INTEGER_32
			l_type: CE_POINTER [NATURAL_8]
			l_c: NATURAL_8
			l_num_lines: INTEGER_32
			l_max_num_lines: INTEGER_32
			l_max_kbyte: INTEGER_32
			l_len: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_type.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					fputs ((gettext (ce_string ("%N# Registers:%N"))), a_fp).do_nothing
					l_max_num_lines := option_inst.get_viminfo_parameter (('<').code)
					if l_max_num_lines < 0 then
						l_max_num_lines := option_inst.get_viminfo_parameter (('%"').code)
					end
					if l_max_num_lines = 0 then
						js.return
					end
					if not js.return_called then
						l_max_kbyte := option_inst.get_viminfo_parameter (('s').code)
						if l_max_kbyte = 0 then
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 11 -- skip if block
					end
				when 1 then -- if:
						l_i___0 := 0
				when 2 then -- loop condition:
						if not (not js.loop_left and then (l_i___0 < 40)) then
							l_pos := -1 + 11 -- skip loop
						end
				when 3 then -- loop body:
						js.reset
						if ((y_regs[l_i___0].y_array).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							js.continue
						end
						if not js.loop_jumped then
							if l_i___0 = 37 then
								js.continue
							elseif l_i___0 = 38 then
								js.continue
							end
						end
						if not js.loop_jumped and then (l_i___0 = 39) then
							js.continue
						end
						if not js.loop_jumped then
							l_num_lines := (y_regs[l_i___0].y_size).to_integer_32
							if l_num_lines = 0 then
								js.continue
							elseif l_num_lines = 1 then
								if (y_regs[l_i___0].y_type).to_integer_32 = 0 then
									if ((y_regs[l_i___0].y_array[0]).item).to_integer_32 = 0 then
										js.continue
									end
								end
							end
						end
						if not js.loop_jumped and then (l_max_kbyte > 0) then
							l_len := 0
							l_j := 0
							from
							until
								not (l_j < l_num_lines)
							loop
								l_len := l_len + ((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (y_regs[l_i___0].y_array[l_j]))).to_integer_32 + 1)
								l_j := l_j + 1
							end
							if l_len > l_max_kbyte.to_integer_32 * 1024 then
								js.continue
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 10 -- skip if block
						end
				when 4 then -- if:
						inspect (y_regs[l_i___0].y_type).to_integer_32 -- switch 1 head
						when 1 then l_pos := -1 + 5
						when 0 then l_pos := -1 + 6
						when 2 then l_pos := -1 + 7
						else l_pos := -1 + 8
						end
				when 5 then -- switch 1, case 1
						l_type.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("LINE")))
						l_pos := -1 + 9 -- switch 1; break
				when 6 then -- switch 1, case 0
						l_type.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("CHAR")))
						l_pos := -1 + 9 -- switch 1; break
				when 7 then -- switch 1, case 2
						l_type.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("BLOCK")))
						l_pos := -1 + 9 -- switch 1; break
				when 8 then -- switch 1, default:
						sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (gettext (ce_string ("E574: Unknown register type %%d"))), (y_regs[l_i___0].y_type).to_integer_32]).do_nothing
						message_inst.emsg (globals_inst.IObuff).do_nothing
						l_type.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("LINE")))
						l_pos := -1 + 9 -- switch 1; break
				when 9 then -- switch 1, done:
						if (y_previous.c_pointer.to_integer_32).to_natural_32 = ((y_regs + l_i___0).c_pointer.to_integer_32).to_natural_32 then
							fprintf ([a_fp, ce_string ("%"")]).do_nothing
						end
						l_c := (get_register_name (l_i___0)).to_natural_8
						fprintf ([a_fp, ce_string ("%"%%c"), l_c.to_integer_32]).do_nothing
						if l_c.to_integer_32 = execreg_lastc then
							fprintf ([a_fp, ce_string ("@")]).do_nothing
						end
						fprintf ([a_fp, ce_string ("%T%%s%T%%d%N"), l_type, y_regs[l_i___0].y_width]).do_nothing
						if l_max_num_lines > 0 then
							if l_num_lines > l_max_num_lines then
								l_num_lines := l_max_num_lines
							end
						end
						l_j := 0
						from
						until
							not (l_j < l_num_lines)
						loop
							IO_putc (('%T').code, a_fp).do_nothing
							ex_cmds_inst.viminfo_writestring (a_fp, y_regs[l_i___0].y_array[l_j])
							l_j := l_j + 1
						end
				when 10 then -- if done
						if not js.loop_left then
							l_i___0 := l_i___0 + 1
						end
						l_pos := -1 + 2 -- back to loop condition
				when 11 then -- loop done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	x11_export_final_selection
		local
			l_dpy: CE_POINTER [ANY]
			l_str___1: CE_POINTER [NATURAL_8]
			l_len: NATURAL_32
			l_motion_type: INTEGER_32
			l_vc: PD_VIMCONV_T
			l_intlen: INTEGER_32
			l_conv_str: CE_POINTER [NATURAL_8]
		do
			create l_dpy.make
			create l_str___1.make
			create l_vc.make
			create l_conv_str.make

			l_str___1.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
			l_len := (0).to_natural_32
			l_motion_type := -1
			if (gui_inst.gui.in_use).to_boolean then
				if (gui_inst.gui.in_use).to_boolean then
					l_dpy.ce_gets ((gui_gtk_x11_inst.gui_mch_get_display))
				else
					l_dpy.ce_gets (globals_inst.xterm_dpy)
				end
			else
				l_dpy.ce_gets (globals_inst.xterm_dpy)
			end
			if (globals_inst.clip_plus.owned).to_boolean then
				l_motion_type := clip_convert_selection (l_str___1.address, create {CE_POINTER [NATURAL_32]}.make_shared ($l_len), globals_inst.clip_plus.address)
			elseif (globals_inst.clip_star.owned).to_boolean then
				l_motion_type := clip_convert_selection (l_str___1.address, create {CE_POINTER [NATURAL_32]}.make_shared ($l_len), globals_inst.clip_star.address)
			end
			if (l_dpy.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				if (l_str___1.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					if l_motion_type >= 0 then
						if l_len < {NATURAL_32} 1048576 then
							if l_len > {NATURAL_32} 0 then
								if globals_inst.has_mbyte.to_boolean then
									l_vc.vc_type := 0
									if (mbyte_inst.convert_setup (l_vc.address, option_inst.p_enc, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("latin1")))) = 1 then
										l_intlen := l_len.to_integer_32
										l_conv_str.ce_gets (mbyte_inst.string_convert (l_vc.address, l_str___1, create {CE_POINTER [INTEGER_32]}.make_shared ($l_intlen)))
										l_len := l_intlen.to_natural_32
										if (l_conv_str.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
											misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_str___1))
											l_str___1.ce_gets (l_conv_str)
										end
										mbyte_inst.convert_setup (l_vc.address, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)).do_nothing
									end
								end
								XStoreBuffer (l_dpy, create {CE_POINTER [INTEGER_8]}.make_cast (l_str___1), l_len.to_integer_32, 0).do_nothing
								XFlush (l_dpy).do_nothing
							end
						end
					end
				end
			end
			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_str___1))
		end

	clip_free_selection (a_cbd: CE_POINTER [PD_VIMCLIPBOARD])
		local
			l_y_ptr: CE_POINTER [PD_YANKREG]
		do
			create l_y_ptr.make

			l_y_ptr.ce_gets (y_current)
			if (a_cbd.c_pointer.to_integer_32).to_natural_32 = ((globals_inst.clip_plus.address).c_pointer.to_integer_32).to_natural_32 then
				y_current.ce_gets (y_regs + 38)
			else
				y_current.ce_gets (y_regs + 37)
			end
			free_yank_all
			y_current.item.y_size := (0).to_integer_32
			y_current.ce_gets (l_y_ptr)
		end

	clip_get_selection (a_cbd: CE_POINTER [PD_VIMCLIPBOARD])
		local
			l_old_y_previous: CE_POINTER [PD_YANKREG]
			l_old_y_current: CE_POINTER [PD_YANKREG]
			l_old_cursor: PD_POS_T
			l_old_visual: PD_POS_T
			l_old_visual_mode: INTEGER_32
			l_old_curswant: INTEGER_32
			l_old_set_curswant: INTEGER_32
			l_old_op_start: PD_POS_T
			l_old_op_end: PD_POS_T
			l_oa: PD_OPARG_S
			l_ca: PD_CMDARG_S
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_old_y_previous.make
			create l_old_y_current.make
			create l_old_cursor.make
			create l_old_visual.make
			create l_old_op_start.make
			create l_old_op_end.make
			create l_oa.make
			create l_ca.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not ((a_cbd.item.owned).to_boolean) then
						l_pos := -1 + 7 -- skip if block
					end
				when 1 then -- if:
						if (a_cbd.c_pointer.to_integer_32).to_natural_32 /= ((globals_inst.clip_plus.address).c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if ((y_regs[38].y_array).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							js.return
						else
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						if (a_cbd.c_pointer.to_integer_32).to_natural_32 = ((globals_inst.clip_star.address).c_pointer.to_integer_32).to_natural_32 then
							if ((y_regs[37].y_array).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								js.return
							end
						end
				when 5 then
						if not js.return_called then
							l_old_y_previous.ce_gets (y_previous)
							l_old_y_current.ce_gets (y_current)
							l_old_cursor.ce_gets (globals_inst.curwin.item.w_cursor)
							l_old_curswant := globals_inst.curwin.item.w_curswant
							l_old_set_curswant := globals_inst.curwin.item.w_set_curswant
							l_old_op_start.ce_gets (globals_inst.curbuf.item.b_op_start)
							l_old_op_end.ce_gets (globals_inst.curbuf.item.b_op_end)
							l_old_visual.ce_gets (globals_inst.VIsual)
							l_old_visual_mode := globals_inst.VIsual_mode
							clear_oparg (l_oa.address)
							if (a_cbd.c_pointer.to_integer_32).to_natural_32 = ((globals_inst.clip_plus.address).c_pointer.to_integer_32).to_natural_32 then
								l_oa.regname := ('+').code
							else
								l_oa.regname := ('*').code
							end
							l_oa.op_type := 2
							memset (create {CE_POINTER [ANY]}.make_cast ((l_ca.address)), 0, {PD_CMDARG_S}.sizeof.to_natural_32).do_nothing
							l_ca.oap := l_oa.address
							l_ca.cmdchar := ('y').code
							l_ca.count1 := 1
							l_ca.retval := 2
							normal_inst.do_pending_operator (l_ca.address, 0, 1)
							y_previous.ce_gets (l_old_y_previous)
							y_current.ce_gets (l_old_y_current)
							globals_inst.curwin.item.w_cursor := l_old_cursor
							move_inst.changed_cline_bef_curs
							globals_inst.curwin.item.w_curswant := l_old_curswant
							globals_inst.curwin.item.w_set_curswant := l_old_set_curswant
							globals_inst.curbuf.item.b_op_start := l_old_op_start
							globals_inst.curbuf.item.b_op_end := l_old_op_end
							globals_inst.VIsual.ce_gets (l_old_visual)
							globals_inst.VIsual_mode := l_old_visual_mode
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else:
						clip_free_selection (a_cbd)
						ui_inst.clip_gen_request_selection (a_cbd)
				when 8 then -- if done
					if not js.return_called then
					end
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	clip_yank_selection (a_type: INTEGER_32; a_str___1: CE_POINTER [NATURAL_8]; a_len: INTEGER_32; a_cbd: CE_POINTER [PD_VIMCLIPBOARD])
		local
			l_y_ptr: CE_POINTER [PD_YANKREG]
		do
			create l_y_ptr.make

			if (a_cbd.c_pointer.to_integer_32).to_natural_32 = ((globals_inst.clip_plus.address).c_pointer.to_integer_32).to_natural_32 then
				l_y_ptr.ce_gets (y_regs + 38)
			else
				l_y_ptr.ce_gets (y_regs + 37)
			end
			clip_free_selection (a_cbd)
			str_to_reg (l_y_ptr, a_type, a_str___1, a_len, 0)
		end

	clip_convert_selection (a_str___1: CE_POINTER [CE_POINTER [NATURAL_8]]; a_len: CE_POINTER [NATURAL_32]; a_cbd: CE_POINTER [PD_VIMCLIPBOARD]): INTEGER_32
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_lnum: INTEGER_32
			l_i___0: INTEGER_32
			l_j: INTEGER_32
			l_eolsize: NATURAL_32
			l_y_ptr: CE_POINTER [PD_YANKREG]
			l_tmp___0: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_p___0.make
			create l_y_ptr.make
			create l_tmp___0.make

			if (a_cbd.c_pointer.to_integer_32).to_natural_32 = ((globals_inst.clip_plus.address).c_pointer.to_integer_32).to_natural_32 then
				l_y_ptr.ce_gets (y_regs + 38)
			else
				l_y_ptr.ce_gets (y_regs + 37)
			end
			l_eolsize := (1).to_natural_32
			a_str___1.item := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			a_len.item := (0).to_natural_32
			if ((l_y_ptr.item.y_array).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				Result := (-1)
				js.return
			end
			if not js.return_called then
				l_i___0 := 0
				from
				until
					not (l_i___0.to_integer_32 < l_y_ptr.item.y_size)
				loop
					a_len.item := a_len.item + ((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_y_ptr.item.y_array[l_i___0]))).to_natural_32 + l_eolsize.to_natural_32)
					l_i___0 := l_i___0 + 1
				end
				if (l_y_ptr.item.y_type).to_integer_32 = 0 then
					if a_len.item >= l_eolsize.to_natural_32 then
						a_len.item := a_len.item - l_eolsize.to_natural_32
					end
				end
				l_tmp___0.ce_gets (misc2_inst.lalloc (a_len.item + {NATURAL_32} 1, 1))
				a_str___1.item := l_tmp___0
				l_p___0.ce_gets (l_tmp___0)
				if (l_p___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					Result := (-1)
					js.return
				end
			end
			if not js.return_called then
				l_lnum := 0
				l_i___0 := 0
				l_j := 0
				from
				until
					not (l_i___0 < (a_len.item).to_integer_32)
				loop
					if ((l_y_ptr.item.y_array[l_lnum])[l_j]).to_integer_32 = 10 then
						l_p___0[l_i___0] := (('%/0/').code).to_natural_8
					elseif ((l_y_ptr.item.y_array[l_lnum])[l_j]).to_integer_32 = 0 then
						l_p___0[l_i___0] := (('%N').code).to_natural_8
						l_lnum := l_lnum + 1
						l_j := -1
					else
						l_p___0[l_i___0] := (l_y_ptr.item.y_array[l_lnum])[l_j]
					end
					l_i___0 := l_i___0 + 1
					l_j := l_j + 1
				end
				Result := (l_y_ptr.item.y_type).to_integer_32
			end
		end

	may_set_selection
		local
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (y_current.c_pointer.to_integer_32).to_natural_32 /= ((y_regs + 37).c_pointer.to_integer_32).to_natural_32 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if (globals_inst.clip_star.available).to_boolean then
							ui_inst.clip_own_selection (globals_inst.clip_star.address)
							ui_inst.clip_gen_set_selection (globals_inst.clip_star.address)
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						if (y_current.c_pointer.to_integer_32).to_natural_32 = ((y_regs + 38).c_pointer.to_integer_32).to_natural_32 then
							if (globals_inst.clip_plus.available).to_boolean then
								ui_inst.clip_own_selection (globals_inst.clip_plus.address)
								ui_inst.clip_gen_set_selection (globals_inst.clip_plus.address)
							end
						end
				when 4 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	dnd_yank_drag_data (a_str___1: CE_POINTER [NATURAL_8]; a_len: INTEGER_32)
		local
			l_curr: CE_POINTER [PD_YANKREG]
		do
			create l_curr.make

			l_curr.ce_gets (y_current)
			y_current.ce_gets (y_regs + 39)
			free_yank_all
			str_to_reg (y_current, 0, a_str___1, a_len, 0)
			y_current.ce_gets (l_curr)
		end

	get_reg_type (a_regname___0: INTEGER_32; a_reglen: CE_POINTER [INTEGER_32]): NATURAL_8
		local
			l_regname___0: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_regname___0 := a_regname___0
					inspect l_regname___0 -- switch 1 head
					when 37 then l_pos := -1 + 1
					when 35 then l_pos := -1 + 1
					when 61 then l_pos := -1 + 1
					when 58 then l_pos := -1 + 1
					when 47 then l_pos := -1 + 1
					when 46 then l_pos := -1 + 1
					when 6 then l_pos := -1 + 1
					when 16 then l_pos := -1 + 1
					when 23 then l_pos := -1 + 1
					when 1 then l_pos := -1 + 1
					when 95 then l_pos := -1 + 1
					else l_pos := -1 + 2
					end
				when 1 then -- switch 1, case 37 | switch 1, case 35 | switch 1, case 61 | switch 1, case 58 | switch 1, case 47 | switch 1, case 46 | switch 1, case 6 | switch 1, case 16 | switch 1, case 23 | switch 1, case 1 | switch 1, case 95
					Result := (0).to_natural_8
					js.return
				when 2 then -- switch 1, done:
					if not js.return_called then
						l_regname___0 := may_get_selection (l_regname___0)
						get_yank_register (l_regname___0, 0)
						if ((y_current.item.y_array).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							if (a_reglen.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								if (y_current.item.y_type).to_integer_32 = 2 then
									a_reglen.item := (y_current.item.y_width).to_integer_32
								end
							end
							Result := (y_current.item.y_type)
							js.return
						end
					end
					if not js.return_called then
						Result := (255).to_natural_8
					end
				when 3 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_reg_contents (a_regname___0: INTEGER_32; a_allowexpr: INTEGER_32; a_expr_src: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_regname___0: INTEGER_32
			l_i___0: INTEGER_32
			l_retval: CE_POINTER [NATURAL_8]
			l_allocated: INTEGER_32
			l_len: INTEGER_32
			l_tmp___5: INTEGER_32
			js: JUMP_STATE
		do
			create l_retval.make

			l_regname___0 := a_regname___0
			if l_regname___0 = 61 then
				if a_allowexpr.to_boolean then
					if a_expr_src.to_boolean then
						Result := (get_expr_line_src)
						js.return
					end
					if not js.return_called then
						Result := (get_expr_line)
						js.return
					end
				end
				if not js.return_called then
					Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					js.return
				end
			end
			if not js.return_called then
				if l_regname___0 = 64 then
					l_regname___0 := ('%"').code
				end
				if l_regname___0 /= 0 then
					if not (valid_yank_reg (l_regname___0, 0)).to_boolean then
						Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						js.return
					end
				end
			end
			if not js.return_called then
				l_regname___0 := may_get_selection (l_regname___0)
				if (get_spec_reg (l_regname___0, l_retval.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_allocated), 0)).to_boolean then
					if (l_retval.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						js.return
					end
					if not js.return_called then
						if not l_allocated.to_boolean then
							l_retval.ce_gets (misc2_inst.vim_strsave (l_retval))
						end
						Result := l_retval
						js.return
					end
				end
			end
			if not js.return_called then
				get_yank_register (l_regname___0, 0)
				if ((y_current.item.y_array).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					js.return
				end
			end
			if not js.return_called then
				l_len := 0
				l_i___0 := 0
				from
				until
					not (l_i___0 < y_current.item.y_size)
				loop
					l_len := l_len + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (y_current.item.y_array[l_i___0]))).to_integer_32
					if (y_current.item.y_type).to_integer_32 = 1 then
						l_len := l_len + 1
					elseif l_i___0 < y_current.item.y_size - 1 then
						l_len := l_len + 1
					end
					l_i___0 := l_i___0 + 1
				end
				l_retval.ce_gets (misc2_inst.lalloc ((l_len + 1).to_natural_32, 1))
				if (l_retval.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					l_len := 0
					l_i___0 := 0
					from
					until
						not (l_i___0 < y_current.item.y_size)
					loop
						strcpy (create {CE_POINTER [INTEGER_8]}.make_cast ((l_retval + l_len)), create {CE_POINTER [INTEGER_8]}.make_cast (y_current.item.y_array[l_i___0])).do_nothing
						l_len := l_len + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((l_retval + l_len)))).to_integer_32
						if (y_current.item.y_type).to_integer_32 = 1 then
							l_tmp___5 := l_len
							l_len := l_len + 1
							l_retval[l_tmp___5] := (('%N').code).to_natural_8
						elseif l_i___0 < y_current.item.y_size - 1 then
							l_tmp___5 := l_len
							l_len := l_len + 1
							l_retval[l_tmp___5] := (('%N').code).to_natural_8
						end
						l_i___0 := l_i___0 + 1
					end
					l_retval[l_len] := (('%/0/').code).to_natural_8
				end
				Result := l_retval
			end
		end

	write_reg_contents (a_name___1: INTEGER_32; a_str___1: CE_POINTER [NATURAL_8]; a_maxlen: INTEGER_32; a_must_append: INTEGER_32)
		do
			write_reg_contents_ex (a_name___1, a_str___1, a_maxlen, a_must_append, 255, 0)
		end

	write_reg_contents_ex (a_name___1: INTEGER_32; a_str___1: CE_POINTER [NATURAL_8]; a_maxlen: INTEGER_32; a_must_append: INTEGER_32; a_yank_type: INTEGER_32; a_block_len: INTEGER_32)
		local
			l_yank_type: INTEGER_32
			l_old_y_previous: CE_POINTER [PD_YANKREG]
			l_old_y_current: CE_POINTER [PD_YANKREG]
			l_len: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_s: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_old_y_previous.make
			create l_old_y_current.make
			create l_p___0.make
			create l_s.make

			l_yank_type := a_yank_type
			if a_maxlen >= 0 then
				l_len := a_maxlen.to_integer_32
			else
				l_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_str___1))).to_integer_32
			end
			if a_name___1 = 47 then
				search_inst.set_last_search_pat (a_str___1, 0, 1, 1)
				js.return
			end
			if not js.return_called and then (a_name___1 = 61) then
				l_p___0.ce_gets (misc2_inst.vim_strnsave (a_str___1, l_len.to_integer_32))
				if (l_p___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					js.return
				end
				if not js.return_called then
					if a_must_append.to_boolean then
						l_s.ce_gets (misc1_inst.concat_str ((get_expr_line_src), l_p___0))
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_p___0))
						l_p___0.ce_gets (l_s)
					end
					set_expr_line (l_p___0)
					js.return
				end
			end
			if not js.return_called then
				if not (valid_yank_reg (a_name___1, 1)).to_boolean then
					message_inst.emsg_invreg (a_name___1)
					js.return
				end
			end
			if not js.return_called and then (a_name___1 = 95) then
				js.return
			end
			if not js.return_called then
				l_old_y_previous.ce_gets (y_previous)
				l_old_y_current.ce_gets (y_current)
				get_yank_register (a_name___1, 1)
				if not y_append.to_boolean then
					if not a_must_append.to_boolean then
						free_yank_all
					end
				end
				if l_yank_type = 255 then
					if l_len > 0 then
						if (a_str___1[(l_len - 1)]).to_integer_32 = 10 then
							l_yank_type := 1
						elseif (a_str___1[(l_len - 1)]).to_integer_32 = 13 then
							l_yank_type := 1
						else
							l_yank_type := 0
						end
					else
						l_yank_type := 0
					end
				end
				str_to_reg (y_current, l_yank_type, a_str___1, l_len, a_block_len)
				may_set_selection
				if a_name___1 /= 34 then
					y_previous.ce_gets (l_old_y_previous)
				end
				y_current.ce_gets (l_old_y_current)
			end
		end

	str_to_reg (a_y_ptr: CE_POINTER [PD_YANKREG]; a_type: INTEGER_32; a_str___1: CE_POINTER [NATURAL_8]; a_len: INTEGER_32; a_blocklen: INTEGER_32)
		local
			l_lnum: INTEGER_32
			l_start___1: INTEGER_32
			l_i___0: INTEGER_32
			l_extra: INTEGER_32
			l_newlines: INTEGER_32
			l_extraline: INTEGER_32
			l_append: INTEGER_32
			l_s: CE_POINTER [NATURAL_8]
			l_pp: CE_POINTER [CE_POINTER [NATURAL_8]]
			l_maxlen: INTEGER_32
			l_tmp___1: INTEGER_32
			js: JUMP_STATE
		do
			create l_s.make
			create l_pp.make

			l_extraline := 0
			l_append := 0
			if ((a_y_ptr.item.y_array).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				a_y_ptr.item.y_size := (0).to_integer_32
			end
			l_newlines := 0
			l_i___0 := 0
			from
			until
				not (l_i___0 < a_len)
			loop
				if (a_str___1[l_i___0]).to_integer_32 = 10 then
					l_newlines := l_newlines + 1
				end
				l_i___0 := l_i___0 + 1
			end
			if a_type = 0 then
				l_extraline := 1
				l_newlines := l_newlines + 1
			elseif a_len = 0 then
				l_extraline := 1
				l_newlines := l_newlines + 1
			elseif (a_str___1[(a_len - 1)]).to_integer_32 /= 10 then
				l_extraline := 1
				l_newlines := l_newlines + 1
			end
			if a_y_ptr.item.y_size > 0 then
				if (a_y_ptr.item.y_type).to_integer_32 = 0 then
					l_append := 1
					l_newlines := l_newlines - 1
				end
			end
			l_pp.ce_gets (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast ((misc2_inst.lalloc_clear ((a_y_ptr.item.y_size + l_newlines.to_integer_32).to_natural_32 * (Pointer_bytes.to_natural_32).to_natural_32, 1))))
			if (l_pp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				js.return
			end
			if not js.return_called then
				l_lnum := 0
				from
				until
					not (l_lnum.to_integer_32 < a_y_ptr.item.y_size)
				loop
					l_pp[l_lnum] := a_y_ptr.item.y_array[l_lnum]
					l_lnum := l_lnum + 1
				end
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_y_ptr.item.y_array))
				a_y_ptr.item.y_array := l_pp
				l_maxlen := 0
				l_start___1 := 0
				from
				until
					not (not js.loop_left and then (l_start___1 < a_len + l_extraline.to_integer_32))
				loop
					js.reset
					l_i___0 := l_start___1
					from
					until
						not (not js.loop_left and then (l_i___0 < a_len))
					loop
						js.reset
						if (a_str___1[l_i___0]).to_integer_32 = 10 then
							js.break
						end
						if not js.loop_jumped then
							l_i___0 := l_i___0 + 1
						end
					end
					js.reset
					l_i___0 := l_i___0 - l_start___1
					if l_i___0 > l_maxlen then
						l_maxlen := l_i___0
					end
					if l_append.to_boolean then
						l_lnum := l_lnum - 1
						l_extra := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_y_ptr.item.y_array[l_lnum]))).to_integer_32
					else
						l_extra := 0
					end
					l_s.ce_gets (misc2_inst.alloc (((l_i___0 + l_extra.to_integer_32) + 1).to_natural_32))
					if (l_s.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						js.break
					end
					if not js.loop_jumped then
						if l_extra.to_boolean then
							memmove (create {CE_POINTER [ANY]}.make_cast (l_s), create {CE_POINTER [ANY]}.make_cast (a_y_ptr.item.y_array[l_lnum]), l_extra.to_natural_32).do_nothing
						end
						if l_append.to_boolean then
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_y_ptr.item.y_array[l_lnum]))
						end
						if l_i___0.to_boolean then
							memmove (create {CE_POINTER [ANY]}.make_cast ((l_s + l_extra)), create {CE_POINTER [ANY]}.make_cast ((a_str___1 + l_start___1)), l_i___0.to_natural_32).do_nothing
						end
						l_extra := (l_extra.to_integer_32 + l_i___0).to_integer_32
						l_s[l_extra] := (('%/0/').code).to_natural_8
						l_tmp___1 := l_lnum
						l_lnum := l_lnum + 1
						a_y_ptr.item.y_array[l_tmp___1] := l_s
						from
						until
							js.loop_left
						loop
							js.reset
							l_extra := l_extra - 1
							if not (l_extra >= 0) then
								js.break
							end
							if not js.loop_jumped then
								if (l_s.item).to_integer_32 = 0 then
									l_s.item := (('%N').code).to_natural_8
								end
								l_s.ce_gets (l_s + 1)
							end
						end
						js.reset
						l_append := 0
						l_start___1 := l_start___1 + (l_i___0 + 1)
					end
				end
				js.reset
				a_y_ptr.item.y_type := a_type.to_natural_8
				a_y_ptr.item.y_size := l_lnum.to_integer_32
				if a_type = 2 then
					if a_blocklen < 0 then
						a_y_ptr.item.y_width := (l_maxlen - 1).to_integer_32
					else
						a_y_ptr.item.y_width := a_blocklen.to_integer_32
					end
				else
					a_y_ptr.item.y_width := 0
				end
			end
		end

	clear_oparg (a_oap: CE_POINTER [PD_OPARG_S])
		do
			memset (create {CE_POINTER [ANY]}.make_cast (a_oap), 0, {PD_OPARG_S}.sizeof.to_natural_32).do_nothing
		end

	line_count_info (a_line: CE_POINTER [NATURAL_8]; a_wc: CE_POINTER [INTEGER_32]; a_cc___0: CE_POINTER [INTEGER_32]; a_limit: INTEGER_32; a_eol_size: INTEGER_32): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_words: INTEGER_32
			l_chars: INTEGER_32
			l_is_word: INTEGER_32
			js: JUMP_STATE
		do
			l_words := 0
			l_chars := 0
			l_is_word := 0
			l_i___0 := 0
			from
			until
				js.loop_left
			loop
				js.reset
				if (a_line[l_i___0]).to_boolean then
					if not (l_i___0 < a_limit) then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					if l_is_word.to_boolean then
						if (misc2_inst.vim_isspace ((a_line[l_i___0]).to_integer_32)).to_boolean then
							l_words := l_words + 1
							l_is_word := 0
						end
					elseif not (misc2_inst.vim_isspace ((a_line[l_i___0]).to_integer_32)).to_boolean then
						l_is_word := 1
					end
					l_chars := l_chars + 1
					l_i___0 := l_i___0 + (globals_inst.mb_ptr2len.integer_32_item ([a_line + l_i___0])).to_integer_32
				end
			end
			js.reset
			if l_is_word.to_boolean then
				l_words := l_words + 1
			end
			a_wc.item := a_wc.item + l_words
			if (a_line[l_i___0]).to_integer_32 = 0 then
				if l_i___0 < a_limit then
					l_i___0 := l_i___0 + a_eol_size.to_integer_32
					l_chars := l_chars + a_eol_size.to_integer_32
				end
			end
			a_cc___0.item := a_cc___0.item + l_chars
			Result := l_i___0
		end

	cursor_pos_info
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_buf1: CE_ARRAY [NATURAL_8]
			l_buf2: CE_ARRAY [NATURAL_8]
			l_lnum: INTEGER_32
			l_byte_count: INTEGER_32
			l_byte_count_cursor: INTEGER_32
			l_char_count: INTEGER_32
			l_char_count_cursor: INTEGER_32
			l_word_count: INTEGER_32
			l_word_count_cursor: INTEGER_32
			l_eol_size: INTEGER_32
			l_last_check: INTEGER_32
			l_line_count_selected: INTEGER_32
			l_min_pos: PD_POS_T
			l_max_pos: PD_POS_T
			l_oparg: PD_OPARG_S
			l_bd: PD_BLOCK_DEF
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_saved_sbr: CE_POINTER [NATURAL_8]
			l_s: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_start_col: INTEGER_32
			l_tmp___3: INTEGER_32
			l_end_col: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___14: CE_POINTER [INTEGER_8]
			l_tmp___15: INTEGER_32
			l_tmp___18: CE_POINTER [INTEGER_8]
			l_tmp___20: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p___0.make
			create l_buf1.make (<<50>>)
			create l_buf2.make (<<40>>)
			create l_min_pos.make
			create l_max_pos.make
			create l_oparg.make
			create l_bd.make
			create l_saved_sbr.make
			create l_s.make
			create l_tmp___14.make
			create l_tmp___18.make
			create l_tmp___20.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_byte_count := 0
					l_byte_count_cursor := 0
					l_char_count := 0
					l_char_count_cursor := 0
					l_word_count := 0
					l_word_count_cursor := 0
					l_last_check := 100000
					l_line_count_selected := 0
					if not (((globals_inst.curbuf.item.b_ml.ml_flags).bit_and (1)).to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						message_inst.msg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.no_lines_msg))))).do_nothing
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 3 then -- else:
						if (misc2_inst.get_fileformat (globals_inst.curbuf)) = 1 then
							l_eol_size := 2
						else
							l_eol_size := 1
						end
						if globals_inst.VIsual_active.to_boolean then
							if globals_inst.VIsual.lnum /= globals_inst.curwin.item.w_cursor.lnum then
								l_tmp___2 := (globals_inst.VIsual.lnum < globals_inst.curwin.item.w_cursor.lnum).to_integer
							else
								if globals_inst.VIsual.col /= globals_inst.curwin.item.w_cursor.col then
									l_tmp___1 := (globals_inst.VIsual.col < globals_inst.curwin.item.w_cursor.col).to_integer
								else
									l_tmp___1 := (globals_inst.VIsual.coladd < globals_inst.curwin.item.w_cursor.coladd).to_integer
								end
								l_tmp___2 := l_tmp___1
							end
							if l_tmp___2.to_boolean then
								l_min_pos.ce_gets (globals_inst.VIsual)
								l_max_pos.ce_gets (globals_inst.curwin.item.w_cursor)
							else
								l_min_pos.ce_gets (globals_inst.curwin.item.w_cursor)
								l_max_pos.ce_gets (globals_inst.VIsual)
							end
							if (option_inst.p_sel.item).to_integer_32 = 101 then
								if l_max_pos.col > 0 then
									l_max_pos.col := (l_max_pos.col) - 1
								end
							end
							if globals_inst.VIsual_mode = 22 then
								l_saved_sbr.ce_gets (option_inst.p_sbr)
								option_inst.p_sbr.ce_gets (globals_inst.empty_option)
								l_oparg.is_VIsual := 1
								l_oparg.block_mode := 1
								l_oparg.op_type := 0
								charset_inst.getvcols (globals_inst.curwin, l_min_pos.address, l_max_pos.address, create {CE_POINTER [INTEGER_32]}.make_shared (l_oparg.c_pointer + {PD_OPARG_S}.start_vcol_offset), create {CE_POINTER [INTEGER_32]}.make_shared (l_oparg.c_pointer + {PD_OPARG_S}.end_vcol_offset))
								option_inst.p_sbr.ce_gets (l_saved_sbr)
								if (globals_inst.curwin.item.w_curswant).to_integer_32 = 2147483647 then
									l_oparg.end_vcol := (2147483647).to_integer_32
								end
								if l_oparg.end_vcol < l_oparg.start_vcol then
									l_oparg.end_vcol := l_oparg.end_vcol + (l_oparg.start_vcol)
									l_oparg.start_vcol := l_oparg.end_vcol - l_oparg.start_vcol
									l_oparg.end_vcol := l_oparg.end_vcol - (l_oparg.start_vcol)
								end
							end
							l_line_count_selected := (l_max_pos.lnum - l_min_pos.lnum) + 1
						end
						l_lnum := (1).to_integer_32
				when 4 then -- loop condition:
						if not (not js.loop_left and then (l_lnum <= globals_inst.curbuf.item.b_ml.ml_line_count)) then
							l_pos := -1 + 22 -- skip loop
						end
				when 5 then -- loop body:
						if l_byte_count > l_last_check then
							ui_inst.ui_breakcheck
							if globals_inst.got_int.to_boolean then
								js.return
							end
							if not js.return_called then
								l_last_check := l_byte_count + 100000
							end
						end
						if js.return_called then
							l_pos := -1 + 21 -- skip if block
						end
				when 6 then -- if:
						if not (globals_inst.VIsual_active.to_boolean) then
							l_pos := -1 + 19 -- skip if block
						end
				when 7 then -- if:
						if not (l_lnum >= l_min_pos.lnum) then
							l_pos := -1 + 17 -- skip if block
						end
				when 8 then -- if:
						if not (l_lnum <= l_max_pos.lnum) then
							l_pos := -1 + 15 -- skip if block
						end
				when 9 then -- if:
						l_s.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						l_len := 0
						inspect globals_inst.VIsual_mode -- switch 1 head
						when 22 then l_pos := -1 + 10
						when 86 then l_pos := -1 + 11
						when 118 then l_pos := -1 + 12
						else l_pos := -1 + 13
						end
				when 10 then -- switch 1, case 22
						globals_inst.virtual_op := misc2_inst.virtual_active
						block_prep (l_oparg.address, l_bd.address, l_lnum, 0)
						globals_inst.virtual_op := 2
						l_s.ce_gets (l_bd.textstart)
						l_len := (l_bd.textlen).to_integer_32
						l_pos := -1 + 13 -- switch 1; break
				when 11 then -- switch 1, case 86
						l_s.ce_gets (memline_inst.ml_get (l_lnum))
						l_len := 2147483647
						l_pos := -1 + 13 -- switch 1; break
				when 12 then -- switch 1, case 118
						if l_lnum = l_min_pos.lnum then
							l_tmp___3 := l_min_pos.col
						else
							l_tmp___3 := 0
						end
						l_start_col := l_tmp___3
						if l_lnum = l_max_pos.lnum then
							l_tmp___4 := ((l_max_pos.col - l_start_col) + 1).to_integer_32
						else
							l_tmp___4 := 2147483647
						end
						l_end_col := l_tmp___4.to_integer_32
						l_s.ce_gets ((memline_inst.ml_get (l_lnum)) + l_start_col)
						l_len := l_end_col.to_integer_32
						l_pos := -1 + 13 -- switch 1; break
				when 13 then -- switch 1, done:
						if (l_s.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_byte_count_cursor := l_byte_count_cursor + (line_count_info (l_s, create {CE_POINTER [INTEGER_32]}.make_shared ($l_word_count_cursor), create {CE_POINTER [INTEGER_32]}.make_shared ($l_char_count_cursor), l_len, l_eol_size))
							if l_lnum = globals_inst.curbuf.item.b_ml.ml_line_count then
								if not (globals_inst.curbuf.item.b_p_eol).to_boolean then
									if (globals_inst.curbuf.item.b_p_bin).to_boolean then
										if (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_s))).to_integer_32 < l_len then
											l_byte_count_cursor := l_byte_count_cursor - l_eol_size.to_integer_32
										end
									end
								end
							end
						end
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 15 then -- else:
						l_pos := -1 + 19 -- goto _L___0
				when 16 then -- if done | if block done, skip else block:
						l_pos := -1 + 18
				when 17 then -- else:
						l_pos := -1 + 19 -- goto _L___0
				when 18 then -- if done | if block done, skip else block:
						l_pos := -1 + 20
				when 19 then -- else: | _L___0:
						if l_lnum = globals_inst.curwin.item.w_cursor.lnum then
							l_word_count_cursor := l_word_count_cursor + l_word_count
							l_char_count_cursor := l_char_count_cursor + l_char_count
							l_byte_count_cursor := l_byte_count + (line_count_info ((memline_inst.ml_get (l_lnum)), create {CE_POINTER [INTEGER_32]}.make_shared ($l_word_count_cursor), create {CE_POINTER [INTEGER_32]}.make_shared ($l_char_count_cursor), (globals_inst.curwin.item.w_cursor.col + 1).to_integer_32, l_eol_size))
						end
				when 20 then
						l_byte_count := l_byte_count + (line_count_info ((memline_inst.ml_get (l_lnum)), create {CE_POINTER [INTEGER_32]}.make_shared ($l_word_count), create {CE_POINTER [INTEGER_32]}.make_shared ($l_char_count), 2147483647, l_eol_size))
						l_lnum := l_lnum + 1
				when 21 then -- if done
						l_pos := -1 + 4 -- back to loop condition
				when 22 then -- loop done
						if not js.return_called then
							if not (globals_inst.curbuf.item.b_p_eol).to_boolean then
								if (globals_inst.curbuf.item.b_p_bin).to_boolean then
									l_byte_count := l_byte_count - l_eol_size.to_integer_32
								end
							end
							if globals_inst.VIsual_active.to_boolean then
								if globals_inst.VIsual_mode = 22 then
									if (globals_inst.curwin.item.w_curswant).to_integer_32 < 2147483647 then
										charset_inst.getvcols (globals_inst.curwin, l_min_pos.address, l_max_pos.address, create {CE_POINTER [INTEGER_32]}.make_shared (l_min_pos.c_pointer + {PD_POS_T}.col_offset), create {CE_POINTER [INTEGER_32]}.make_shared (l_max_pos.c_pointer + {PD_POS_T}.col_offset))
										message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_buf1), (Natural_8_bytes.to_natural_32 * (50).to_natural_32), (gettext (ce_string ("%%ld Cols; "))), ((l_oparg.end_vcol - l_oparg.start_vcol) + 1).to_integer_32]).do_nothing
									else
										l_buf1[0] := (('%/0/').code).to_natural_8
									end
								else
									l_buf1[0] := (('%/0/').code).to_natural_8
								end
								if l_char_count_cursor = l_byte_count_cursor then
									if l_char_count = l_byte_count then
										message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (1025).to_natural_32, (gettext (ce_string ("Selected %%s%%ld of %%ld Lines; %%ld of %%ld Words; %%ld of %%ld Bytes"))), l_buf1, l_line_count_selected, globals_inst.curbuf.item.b_ml.ml_line_count, l_word_count_cursor, l_word_count, l_byte_count_cursor, l_byte_count]).do_nothing
									else
										l_tmp___14.ce_gets (gettext (ce_string ("Selected %%s%%ld of %%ld Lines; %%ld of %%ld Words; %%ld of %%ld Chars; %%ld of %%ld Bytes")))
										message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (1025).to_natural_32, l_tmp___14, l_buf1, l_line_count_selected, globals_inst.curbuf.item.b_ml.ml_line_count, l_word_count_cursor, l_word_count, l_char_count_cursor, l_char_count, l_byte_count_cursor, l_byte_count]).do_nothing
									end
								else
									l_tmp___14.ce_gets (gettext (ce_string ("Selected %%s%%ld of %%ld Lines; %%ld of %%ld Words; %%ld of %%ld Chars; %%ld of %%ld Bytes")))
									message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (1025).to_natural_32, l_tmp___14, l_buf1, l_line_count_selected, globals_inst.curbuf.item.b_ml.ml_line_count, l_word_count_cursor, l_word_count, l_char_count_cursor, l_char_count, l_byte_count_cursor, l_byte_count]).do_nothing
								end
							else
								l_p___0.ce_gets (memline_inst.ml_get_curline)
								move_inst.validate_virtcol
								buffer_inst.col_print (l_buf1, (Natural_8_bytes.to_natural_32 * (50).to_natural_32), globals_inst.curwin.item.w_cursor.col + 1, globals_inst.curwin.item.w_virtcol + 1)
								l_tmp___15 := charset_inst.linetabsize (l_p___0)
								buffer_inst.col_print (l_buf2, (Natural_8_bytes.to_natural_32 * (40).to_natural_32), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0))).to_integer_32, l_tmp___15)
								if l_char_count_cursor = l_byte_count_cursor then
									if l_char_count = l_byte_count then
										message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (1025).to_natural_32, (gettext (ce_string ("Col %%s of %%s; Line %%ld of %%ld; Word %%ld of %%ld; Byte %%ld of %%ld"))), create {CE_POINTER [INTEGER_8]}.make_cast (l_buf1), create {CE_POINTER [INTEGER_8]}.make_cast (l_buf2), globals_inst.curwin.item.w_cursor.lnum, globals_inst.curbuf.item.b_ml.ml_line_count, l_word_count_cursor, l_word_count, l_byte_count_cursor, l_byte_count]).do_nothing
									else
										l_tmp___18.ce_gets (gettext (ce_string ("Col %%s of %%s; Line %%ld of %%ld; Word %%ld of %%ld; Char %%ld of %%ld; Byte %%ld of %%ld")))
										message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (1025).to_natural_32, l_tmp___18, create {CE_POINTER [INTEGER_8]}.make_cast (l_buf1), create {CE_POINTER [INTEGER_8]}.make_cast (l_buf2), globals_inst.curwin.item.w_cursor.lnum, globals_inst.curbuf.item.b_ml.ml_line_count, l_word_count_cursor, l_word_count, l_char_count_cursor, l_char_count, l_byte_count_cursor, l_byte_count]).do_nothing
									end
								else
									l_tmp___18.ce_gets (gettext (ce_string ("Col %%s of %%s; Line %%ld of %%ld; Word %%ld of %%ld; Char %%ld of %%ld; Byte %%ld of %%ld")))
									message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (1025).to_natural_32, l_tmp___18, create {CE_POINTER [INTEGER_8]}.make_cast (l_buf1), create {CE_POINTER [INTEGER_8]}.make_cast (l_buf2), globals_inst.curwin.item.w_cursor.lnum, globals_inst.curbuf.item.b_ml.ml_line_count, l_word_count_cursor, l_word_count, l_char_count_cursor, l_char_count, l_byte_count_cursor, l_byte_count]).do_nothing
								end
							end
							l_byte_count := (mbyte_inst.bomb_size).to_integer_32
							if l_byte_count > 0 then
								l_tmp___20.ce_gets (gettext (ce_string ("(+%%ld for BOM)")))
								sprintf ([(create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff) + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff))).to_integer_32), l_tmp___20, l_byte_count]).do_nothing
							end
							l_p___0.ce_gets (option_inst.p_shm)
							option_inst.p_shm.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")))
							message_inst.msg (globals_inst.IObuff).do_nothing
							option_inst.p_shm.ce_gets (l_p___0)
						end
				when 23 then -- if done
					if not js.return_called then
					end
				when 24 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
