class
	P_OS_UNIX

inherit
	VIM_DATA
		redefine
			default_create
		end
	S_LIBIO
	S_STDIO
	S_CTYPE
	S_SYS_STAT
	S_STDLIB
	S_STRING
	S_LIBINTL
	S_WCTYPE
	S_UNISTD
	S_TIME
	S_FCNTL
	S_MATH
	S_SYS_TIME
	S_LOCALE
	S_BITS_ERRNO
	S_ICONV
	S_UTIME
	S_GLIB_OBJECT
	S_GTK_GTK
	S_SYS_SELECT
	S_X11_XLIB
	S_SIGNAL
	S_DIRENT
	S_PWD
	S_GLIB
	S_PANGO_PANGO
	S_GDK_GDK
	S_LANGINFO
	S_X11_XUTIL
	S_X11_INTRINSIC
	S_SYS_IOCTL
	S_SYS_RESOURCE
	S_SYS_WAIT
	S_SYS_UTSNAME
	S_TERMIOS
	S_DLFCN
	S_X11_ICE_ICELIB
	S_X11_SM_SMLIB
	S_X11_SHELL
	S_X11_STRINGDEFS
	S_SYS_SYSINFO
	S_TERMCAP
	S_TERM
	S_GDK_PIXBUF_GDK_PIXBUF
	S_SYS_SOCKET
	S_NETINET_IN
	S_NETDB

feature {NONE} -- Initialization

	default_create
		do
			create xterm_Shell.make
			create x11_display.make
			create oldtitle.make
			create oldicon.make
			create extra_shell_arg.make
			create xsmp.make
			create signal_info.make (<<22>>)
			create sigstk.make
			create signal_stack.make
			create told.make
			create sh_vimglob_func.make
			create mouse_code.make
			create mouse_name.make (<<2>>)
			create xterm_hints.make
		end

feature {ANY} -- attributes

	xterm_Shell: CE_POINTER [ANY]

	x11_window: NATURAL_32 assign set_x11_window
		do
			Result := x11_window_address[0]
		end

	set_x11_window (a_x11_window: NATURAL_32)
		do
			x11_window_address[0] := a_x11_window
		end

	x11_window_address: CE_POINTER [NATURAL_32]
		once ("OBJECT")
			create Result.make_shared (default_pointer.memory_calloc (1, Natural_32_bytes))
		end

	x11_display: CE_POINTER [ANY]

	oldtitle: CE_POINTER [NATURAL_8]

	did_set_title___0: INTEGER_32 assign set_did_set_title___0

	set_did_set_title___0 (a_did_set_title___0: INTEGER_32)
		do
			did_set_title___0 := a_did_set_title___0
		end

	oldicon: CE_POINTER [NATURAL_8]

	did_set_icon: INTEGER_32 assign set_did_set_icon

	set_did_set_icon (a_did_set_icon: INTEGER_32)
		do
			did_set_icon := a_did_set_icon
		end

	do_resize: INTEGER_32 assign set_do_resize

	set_do_resize (a_do_resize: INTEGER_32)
		do
			do_resize := a_do_resize
		end

	extra_shell_arg: CE_POINTER [NATURAL_8]

	show_shell_mess: INTEGER_32 assign set_show_shell_mess

	set_show_shell_mess (a_show_shell_mess: INTEGER_32)
		do
			show_shell_mess := a_show_shell_mess
		end

	deadly_signal: INTEGER_32 assign set_deadly_signal

	set_deadly_signal (a_deadly_signal: INTEGER_32)
		do
			deadly_signal := a_deadly_signal
		end

	in_mch_delay: INTEGER_32 assign set_in_mch_delay

	set_in_mch_delay (a_in_mch_delay: INTEGER_32)
		do
			in_mch_delay := a_in_mch_delay
		end

	curr_tmode: INTEGER_32 assign set_curr_tmode

	set_curr_tmode (a_curr_tmode: INTEGER_32)
		do
			curr_tmode := a_curr_tmode
		end

	xsmp: PD_XSMP_CONFIG_T

	signal_info: CE_ARRAY [PD_SIGNALINFO]

	sigstk: SD_SIGALTSTACK

	signal_stack: CE_POINTER [INTEGER_8]

	entered___2: INTEGER_32 assign set_entered___2

	set_entered___2 (a_entered___2: INTEGER_32)
		do
			entered___2 := a_entered___2
		end

	sigcont_received: INTEGER_32 assign set_sigcont_received

	set_sigcont_received (a_sigcont_received: INTEGER_32)
		do
			sigcont_received := a_sigcont_received
		end

	got_signal: INTEGER_32 assign set_got_signal

	set_got_signal (a_got_signal: INTEGER_32)
		do
			got_signal := a_got_signal
		end

	blocked: INTEGER_32 assign set_blocked

	set_blocked (a_blocked: INTEGER_32)
		do
			blocked := a_blocked
		end

	got_x_error___0: INTEGER_32 assign set_got_x_error___0

	set_got_x_error___0 (a_got_x_error___0: INTEGER_32)
		do
			got_x_error___0 := a_got_x_error___0
		end

	result2: INTEGER_32 assign set_result2

	set_result2 (a_result2: INTEGER_32)
		do
			result2 := a_result2
		end

	x11_display_from: INTEGER_32 assign set_x11_display_from

	set_x11_display_from (a_x11_display_from: INTEGER_32)
		do
			x11_display_from := a_x11_display_from
		end

	did_set_error_handler: INTEGER_32 assign set_did_set_error_handler

	set_did_set_error_handler (a_did_set_error_handler: INTEGER_32)
		do
			did_set_error_handler := a_did_set_error_handler
		end

	recursive___3: INTEGER_32 assign set_recursive___3

	set_recursive___3 (a_recursive___3: INTEGER_32)
		do
			recursive___3 := a_recursive___3
		end

	dont_fchdir: INTEGER_32 assign set_dont_fchdir

	set_dont_fchdir (a_dont_fchdir: INTEGER_32)
		do
			dont_fchdir := a_dont_fchdir
		end

	first: INTEGER_32 assign set_first

	set_first (a_first: INTEGER_32)
		do
			first := a_first
		end

	told: SD_TERMIOS

	ison: INTEGER_32 assign set_ison

	set_ison (a_ison: INTEGER_32)
		do
			ison := a_ison
		end

	busy___0: INTEGER_32 assign set_busy___0

	set_busy___0 (a_busy___0: INTEGER_32)
		do
			busy___0 := a_busy___0
		end

	did_find_nul: INTEGER_32 assign set_did_find_nul

	set_did_find_nul (a_did_find_nul: INTEGER_32)
		do
			did_find_nul := a_did_find_nul
		end

	sh_vimglob_func: CE_POINTER [INTEGER_8]

	xterm_trace: INTEGER_32 assign set_xterm_trace

	set_xterm_trace (a_xterm_trace: INTEGER_32)
		do
			xterm_trace := a_xterm_trace
		end

	xterm_button: INTEGER_32 assign set_xterm_button

	set_xterm_button (a_xterm_button: INTEGER_32)
		do
			xterm_button := a_xterm_button
		end

	mouse_code: CE_POINTER [NATURAL_8]

	mouse_name: CE_ARRAY [NATURAL_8]

	prev_row: INTEGER_32 assign set_prev_row

	set_prev_row (a_prev_row: INTEGER_32)
		do
			prev_row := a_prev_row
		end

	prev_col: INTEGER_32 assign set_prev_col

	set_prev_col (a_prev_col: INTEGER_32)
		do
			prev_col := a_prev_col
		end

	xterm_hints: SD_XSIZEHINTS

	dummy: INTEGER_32 assign set_dummy
		do
			Result := dummy_address[0]
		end

	set_dummy (a_dummy: INTEGER_32)
		do
			dummy_address[0] := a_dummy
		end

	dummy_address: CE_POINTER [INTEGER_32]
		once ("OBJECT")
			create Result.make_shared (default_pointer.memory_calloc (1, Integer_32_bytes))
		end

feature {ANY} -- routines

	mch_chdir (a_path: CE_POINTER [INTEGER_8]): INTEGER_32
		do
			if option_inst.p_verbose >= 5 then
				message_inst.verbose_enter
				message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("chdir(%%s)")), a_path]).do_nothing
				message_inst.verbose_leave
			end
			Result := (chdir (a_path))
		end

	mch_write (a_s: CE_POINTER [NATURAL_8]; a_len: INTEGER_32)
		do
			globals_inst.ignored := (write (1, create {CE_POINTER [ANY]}.make_cast (a_s), a_len.to_natural_32))
			if option_inst.p_wd.to_boolean then
				RealWaitForChar (globals_inst.read_cmd_fd, option_inst.p_wd, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)).do_nothing
			end
		end

	mch_inchar (a_buf___6: CE_POINTER [NATURAL_8]; a_maxlen: INTEGER_32; a_wtime: INTEGER_32; a_tb_change_cnt: INTEGER_32): INTEGER_32
		local
			l_len: INTEGER_32
			js: JUMP_STATE
		do
			netbeans_inst.netbeans_parse_messages
			from
			until
				not (do_resize.to_boolean)
			loop
				handle_resize
			end
			if a_wtime >= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					if (WaitForChar (a_wtime)) /= 0 then
						js.break
					end
					if not js.loop_jumped then
						if not do_resize.to_boolean then
							Result := 0
							js.return
						end
						if not js.return_called then
							handle_resize
							netbeans_inst.netbeans_parse_messages
						end
					end
				end
				js.reset
			elseif (WaitForChar (option_inst.p_ut)) = 0 then
				if (fileio_inst.trigger_cursorhold).to_boolean then
					if a_maxlen >= 3 then
						if not (getchar_inst.typebuf_changed (a_tb_change_cnt)).to_boolean then
							a_buf___6[0] := (128).to_natural_8
							a_buf___6[1] := (253).to_natural_8
							a_buf___6[2] := (96).to_natural_8
							Result := 3
							js.return
						end
					end
				end
				if not js.return_called then
					getchar_inst.before_blocking
				end
			end
			if not js.return_called then
				from
				until
					js.loop_left
				loop
					from
					until
						not (do_resize.to_boolean)
					loop
						handle_resize
					end
					netbeans_inst.netbeans_parse_messages
					if (WaitForChar (-1)) = 0 then
						if do_resize.to_boolean then
							handle_resize
						end
						Result := 0
						js.return
					end
					if not js.return_called then
						if (getchar_inst.typebuf_changed (a_tb_change_cnt)).to_boolean then
							Result := 0
							js.return
						end
					end
					if not js.return_called then
						l_len := ui_inst.read_from_input_buf (a_buf___6, a_maxlen.to_integer_32)
						if l_len > 0 then
							Result := l_len
							js.return
						end
					end
				end
			end
		end

	handle_resize
		do
			do_resize := 0
			term_inst.shell_resized
		end

	mch_char_avail: INTEGER_32
		do
			Result := (WaitForChar (0))
		end

	mch_total_mem (a_special: INTEGER_32): NATURAL_32
		local
			l_mem: NATURAL_32
			l_shiftright: NATURAL_32
			l_sinfo: SD_SYSINFO
			l_pagesize: INTEGER_32
			l_pagecount: INTEGER_32
			l_rlp: SD_RLIMIT
			js: JUMP_STATE
		do
			create l_sinfo.make
			create l_rlp.make

			l_mem := (0).to_natural_32
			l_shiftright := (10).to_natural_32
			if l_mem = {NATURAL_32} 0 then
				if (sysinfo (l_sinfo.address)) = 0 then
					from
					until
						js.loop_left
					loop
						js.reset
						if l_shiftright > {NATURAL_32} 0 then
							if ((l_sinfo.mem_unit).bit_and ({NATURAL_32} 1)) /= {NATURAL_32} 0 then
								js.break
							end
						else
							js.break
						end
						if not js.loop_jumped then
							l_sinfo.mem_unit := (l_sinfo.mem_unit).bit_shift_right ((1))
							l_shiftright := l_shiftright - 1
						end
					end
					js.reset
					l_mem := l_sinfo.totalram * (l_sinfo.mem_unit).to_natural_32
				end
			end
			if l_mem = {NATURAL_32} 0 then
				l_pagesize := sysconf (30)
				l_pagecount := sysconf (85)
				if l_pagesize > 0 then
					if l_pagecount > 0 then
						from
						until
							js.loop_left
						loop
							js.reset
							if l_shiftright > {NATURAL_32} 0 then
								if ((l_pagesize).bit_and (1)) /= 0 then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_pagesize := ((l_pagesize.to_natural_32).bit_shift_right (1)).to_integer_32
								l_shiftright := l_shiftright - 1
							end
						end
						js.reset
						l_mem := l_pagesize.to_natural_32 * l_pagecount.to_natural_32
					end
				end
			end
			if (getrlimit ({SC_RLIMIT_RESOURCE}.RLIMIT_DATA, l_rlp.address)) = 0 then
				if l_rlp.rlim_cur < ({NATURAL_32} 1).bit_shift_left ((Natural_32_bytes.to_natural_32 * {NATURAL_32} 8 - {NATURAL_32} 1).to_integer_32) then
					if l_rlp.rlim_cur /= {NATURAL_32} 4294967295 then
						if (l_rlp.rlim_cur).bit_shift_right (10) < (l_mem).bit_shift_right (l_shiftright.to_integer_32) then
							l_mem := l_rlp.rlim_cur
							l_shiftright := (10).to_natural_32
						end
					end
				end
			end
			if l_mem > {NATURAL_32} 0 then
				Result := ((l_mem).bit_shift_right (l_shiftright.to_integer_32))
				js.return
			end
			if not js.return_called then
				Result := (2097151).to_natural_32
			end
		end

	mch_delay (a_msec: INTEGER_32; a_ignoreinput: INTEGER_32)
		local
			l_old_tmode: INTEGER_32
			l_ts: SD_TIMESPEC
		do
			create l_ts.make

			if a_ignoreinput.to_boolean then
				in_mch_delay := 1
				l_old_tmode := curr_tmode
				if curr_tmode = 2 then
					term_inst.settmode (1)
				end
				l_ts.tv_sec := a_msec // 1000
				l_ts.tv_nsec := (a_msec \\ 1000) * 1000000
				nanosleep ((l_ts.address), create {CE_POINTER [SD_TIMESPEC]}.make_shared (default_pointer)).do_nothing
				term_inst.settmode (l_old_tmode)
				in_mch_delay := 0
			else
				WaitForChar (a_msec).do_nothing
			end
		end

	init_signal_stack
		do
			if (signal_stack.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				sigstk.ss_sp := create {CE_POINTER [ANY]}.make_cast (signal_stack)
				sigstk.ss_size := (8192).to_natural_32
				sigstk.ss_flags := 0
				sigaltstack ((sigstk.address), create {CE_POINTER [SD_SIGALTSTACK]}.make_shared (default_pointer)).do_nothing
			end
		end

	sig_winch (a_sigarg: INTEGER_32)
		do
			sigset (28, (sig_winch_address)).do_nothing
			do_resize := 1
		end

	sig_winch_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent sig_winch)
		end

	catch_sigint (a_sigarg: INTEGER_32)
		do
			sigset (2, (catch_sigint_address)).do_nothing
			globals_inst.got_int := 1
		end

	catch_sigint_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent catch_sigint)
		end

	catch_sigpwr (a_sigarg: INTEGER_32)
		do
			sigset (30, (catch_sigpwr_address)).do_nothing
			memline_inst.ml_sync_all (0, 0)
		end

	catch_sigpwr_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent catch_sigpwr)
		end

	mch_startjmp
		do
			globals_inst.lc_signal := 0
			globals_inst.lc_active := 1
		end

	mch_endjmp
		do
			globals_inst.lc_active := 0
		end

	mch_didjmp
		do
			init_signal_stack
		end

	deathtrap (a_sigarg: INTEGER_32)
		local
			l_i___0: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if globals_inst.lc_active.to_boolean then
						globals_inst.lc_signal := a_sigarg
						globals_inst.lc_active := 0
						globals_inst.lc_jump_env.raise (1)
					end
					if in_mch_delay.to_boolean then
						if a_sigarg = 3 then
							js.return
						end
					end
					if not (not js.return_called and then (entered___2 = 0)) then
						l_pos := -1 + 18 -- skip if block
					end
				when 1 then -- if:
						if a_sigarg /= 1 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 17 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 4 then -- else:
						if a_sigarg /= 3 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 17 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 7 then -- else:
						if a_sigarg /= 15 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 17 -- goto _L
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 10 then -- else:
						if a_sigarg /= 30 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_pos := -1 + 17 -- goto _L
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 13 then -- else:
						if a_sigarg /= 10 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_pos := -1 + 17 -- goto _L
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 16 then -- else:
						if a_sigarg /= 12 then
							l_pos := -1 + 18 -- skip if block
						end
				when 17 then -- if: | _L:
						if not (vim_handle_signal (a_sigarg)).to_boolean then
							js.return
						end
				when 18 then -- if done | if done | if done | if done | if done | if done
						if not js.return_called then
							entered___2 := entered___2 + 1
							eval_inst.set_vim_var_nr (28, entered___2.to_integer_32)
							l_i___0 := 0
							from
							until
								not (not js.loop_left and then (signal_info[l_i___0].sig /= -1))
							loop
								js.reset
								if a_sigarg = signal_info[l_i___0].sig then
									js.break
								end
								if not js.loop_jumped then
									l_i___0 := l_i___0 + 1
								end
							end
							js.reset
							deadly_signal := a_sigarg
							globals_inst.full_screen := 0
							if entered___2 >= 3 then
								reset_signals
								may_core_dump
								if entered___2 >= 4 then
									exit2 (8)
								end
								exit (7)
							end
							if entered___2 = 2 then
								term_inst.out_str (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Vim: Double signal, exiting%N")))))
								term_inst.out_flush
								main_inst.getout (1)
							end
							sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (gettext (ce_string ("Vim: Caught deadly signal %%s%N"))), signal_info[l_i___0].name]).do_nothing
							misc1_inst.preserve_exit
						end
				when 19 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	deathtrap_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent deathtrap)
		end

	sigcont_handler (a_sigarg: INTEGER_32)
		do
			sigcont_received := 1
		end

	sigcont_handler_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent sigcont_handler)
		end

	mch_suspend
		local
			l_wait_time: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					term_inst.out_flush
					term_inst.settmode (0)
					term_inst.out_flush
					if not ((globals_inst.clip_star.owned).to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if not ((globals_inst.clip_plus.owned).to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						ops_inst.x11_export_final_selection
						if (globals_inst.clip_star.owned).to_boolean then
							ui_inst.clip_lose_selection (globals_inst.clip_star.address)
						end
						if (globals_inst.clip_plus.owned).to_boolean then
							ui_inst.clip_lose_selection (globals_inst.clip_plus.address)
						end
						if (x11_display.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							XFlush (x11_display).do_nothing
						end
				when 5 then -- if done
						sigcont_received := 0
						kill (0, 20).do_nothing
						l_wait_time := 0
						from
						until
							js.loop_left
						loop
							js.reset
							if not sigcont_received.to_boolean then
								if not (l_wait_time <= 3) then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								mch_delay (l_wait_time, 0)
								l_wait_time := l_wait_time + 1
							end
						end
						js.reset
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (oldtitle))
						oldtitle.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						term_inst.settmode (2)
						globals_inst.need_check_timestamps := 1
						globals_inst.did_check_timestamps := 0
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	mch_init
		do
			globals_inst.Columns := 80
			globals_inst.Rows := 24
			term_inst.out_flush
			set_signals
		end

	set_signals
		local
			l_tmp: CE_ROUTINE
		do
			create l_tmp.make

			sigset (28, (sig_winch_address)).do_nothing
			if globals_inst.restricted.to_boolean then
				l_tmp.ce_gets (create {CE_ROUTINE}.make_shared (default_pointer + 1))
			else
				l_tmp.ce_gets (create {CE_ROUTINE}.make_shared (default_pointer))
			end
			sigset (20, l_tmp).do_nothing
			sigset (18, sigcont_handler_address).do_nothing
			sigset (13, create {CE_ROUTINE}.make_shared (default_pointer + 1)).do_nothing
			catch_int_signal
			sigset (14, create {CE_ROUTINE}.make_shared (default_pointer + 1)).do_nothing
			sigset (30, (catch_sigpwr_address)).do_nothing
			catch_signals ((deathtrap_address), create {CE_ROUTINE}.make_shared (default_pointer + -1))
			if (gui_inst.gui.in_use).to_boolean then
				sigset (1, create {CE_ROUTINE}.make_shared (default_pointer + 1)).do_nothing
			end
		end

	catch_int_signal
		do
			sigset (2, (catch_sigint_address)).do_nothing
		end

	reset_signals
		do
			catch_signals (create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer))
			sigset (18, create {CE_ROUTINE}.make_shared (default_pointer)).do_nothing
		end

	catch_signals (a_func_deadly: CE_ROUTINE; a_func_other: CE_ROUTINE)
		local
			l_i___0: INTEGER_32
			l_sa: SD_SIGACTION
		do
			create l_sa.make

			l_i___0 := 0
			from
			until
				signal_info[l_i___0].sig = -1
			loop
				if (signal_info[l_i___0].deadly).to_boolean then
					l_sa.sigaction_handler.sa_handler := a_func_deadly
					sigemptyset (create {CE_POINTER [SD_SIGSET_T]}.make_shared (l_sa.c_pointer + {SD_SIGACTION}.sa_mask_offset)).do_nothing
					l_sa.sa_flags := 0
					sigaction (signal_info[l_i___0].sig, (l_sa.address), create {CE_POINTER [SD_SIGACTION]}.make_shared (default_pointer)).do_nothing
				elseif (a_func_other.c_pointer.to_integer_32).to_natural_32 /= (-1).to_natural_32 then
					sigset (signal_info[l_i___0].sig, a_func_other).do_nothing
				end
				l_i___0 := l_i___0 + 1
			end
		end

	vim_handle_signal (a_sig: INTEGER_32): INTEGER_32
		local
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect a_sig -- switch 1 head
					when -1 then l_pos := -1 + 1
					when -2 then l_pos := -1 + 2
					else l_pos := -1 + 3
					end
				when 1 then -- switch 1, case -1
					blocked := 1
					l_pos := -1 + 4 -- switch 1; break
				when 2 then -- switch 1, case -2
					blocked := 0
					if got_signal /= 0 then
						kill ((getpid), got_signal).do_nothing
						got_signal := 0
					end
					l_pos := -1 + 4 -- switch 1; break
				when 3 then -- switch 1, default:
					if not blocked.to_boolean then
						Result := 1
						js.return
					end
					if not js.return_called then
						got_signal := a_sig
						if a_sig /= 30 then
							globals_inst.got_int := 1
						end
					end
					l_pos := -1 + 4 -- switch 1; break
				when 4 then -- switch 1, done:
					if not js.return_called then
						Result := 0
					end
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	mch_check_win (a_argc: INTEGER_32; a_argv: CE_POINTER [CE_POINTER [INTEGER_8]]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if (isatty (1)).to_boolean then
				Result := 1
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	mch_input_isatty: INTEGER_32
		local
			js: JUMP_STATE
		do
			if (isatty (globals_inst.read_cmd_fd)).to_boolean then
				Result := 1
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	xopen_message (a_tvp: CE_POINTER [SD_TIMEVAL])
		local
			l_end_tv: SD_TIMEVAL
		do
			create l_end_tv.make

			gettimeofday ((l_end_tv.address), create {CE_POINTER [SD_TIMEZONE]}.make_shared (default_pointer)).do_nothing
			message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Opening the X display took %%ld msec")))), (l_end_tv.tv_sec - a_tvp.item.tv_sec) * 1000 + (l_end_tv.tv_usec - a_tvp.item.tv_usec) // 1000]).do_nothing
		end

	x_error_handler (a_dpy: CE_POINTER [ANY]; a_error_event: CE_POINTER [SD_XERROREVENT]): INTEGER_32
		do
			XGetErrorText (a_dpy, (a_error_event.item.error_code).to_integer_32, create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), 1025).do_nothing
			strcat (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (gettext (ce_string ("%NVim: Got X error%N")))).do_nothing
			misc1_inst.preserve_exit
			Result := 0
		end

	x_error_handler_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent x_error_handler)
		end

	x_error_check___0 (a_dpy: CE_POINTER [ANY]; a_error_event: CE_POINTER [SD_XERROREVENT]): INTEGER_32
		do
			got_x_error___0 := 1
			Result := 0
		end

	x_error_check___0_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent x_error_check___0)
		end

	x_IOerror_check (a_dpy: CE_POINTER [ANY]): INTEGER_32
		do
			globals_inst.lc_jump_env.raise (1)
		end

	x_IOerror_check_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent x_IOerror_check)
		end

	x_IOerror_handler (a_dpy: CE_POINTER [ANY]): INTEGER_32
		do
			globals_inst.xterm_dpy.ce_gets (create {CE_POINTER [ANY]}.make_shared (default_pointer))
			Current.x11_window := (0).to_natural_32
			x11_display.ce_gets (create {CE_POINTER [ANY]}.make_shared (default_pointer))
			xterm_Shell.ce_gets (create {CE_POINTER [ANY]}.make_shared (default_pointer))
			globals_inst.x_jump_env.raise (1)
		end

	x_IOerror_handler_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent x_IOerror_handler)
		end

	x_connect_to_server: INTEGER_32
		local
			l_regmatch___0: PD_REGMATCH_T
			js: JUMP_STATE
		do
			create l_regmatch___0.make

			if globals_inst.x_force_connect.to_boolean then
				Result := 1
				js.return
			end
			if not js.return_called and then (globals_inst.x_no_connect.to_boolean) then
				Result := 0
				js.return
			end
			if not js.return_called and then ((globals_inst.clip_exclude_prog.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32) then
				l_regmatch___0.rm_ic := 0
				l_regmatch___0.regprog := globals_inst.clip_exclude_prog
				if (regexp_inst.vim_regexec (l_regmatch___0.address, term_inst.term_strings[0], 0)).to_boolean then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	test_x11_window (a_dpy: CE_POINTER [ANY]): INTEGER_32
		local
			l_old_handler: CE_ROUTINE
			l_text_prop: SD_XTEXTPROPERTY
			l_tmp___2: INTEGER_32
		do
			create l_old_handler.make
			create l_text_prop.make

			l_old_handler.ce_gets ((XSetErrorHandler (x_error_check___0_address)))
			got_x_error___0 := 0
			if (XGetWMName (a_dpy, x11_window, l_text_prop.address)).to_boolean then
				XFree (create {CE_POINTER [ANY]}.make_cast (l_text_prop.value)).do_nothing
			end
			XSync (a_dpy, 0).do_nothing
			XSetErrorHandler (l_old_handler).do_nothing
			if option_inst.p_verbose > 0 then
				if got_x_error___0.to_boolean then
					message_inst.verb_msg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Testing the X display failed"))))).do_nothing
				end
			end
			if got_x_error___0.to_boolean then
				l_tmp___2 := 0
			else
				l_tmp___2 := 1
			end
			Result := l_tmp___2
		end

	get_x11_windis: INTEGER_32
		local
			l_winid: CE_POINTER [INTEGER_8]
			l_start_tv: SD_TIMEVAL
			js: JUMP_STATE
		do
			create l_winid.make
			create l_start_tv.make

			if not did_set_error_handler.to_boolean then
				XSetErrorHandler (x_error_handler_address).do_nothing
				did_set_error_handler := 1
			end
			if (gui_inst.gui.in_use).to_boolean then
				if x11_display_from = 1 then
					if (x11_display.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						XCloseDisplay (x11_display).do_nothing
						x11_display_from := 0
					end
				end
				if (gui_gtk_x11_inst.gui_get_x11_windis (x11_window_address, x11_display.address)) = 1 then
					x11_display_from := 2
					Result := 1
					js.return
				end
				if not js.return_called then
					x11_display.ce_gets (create {CE_POINTER [ANY]}.make_shared (default_pointer))
					Result := 0
					js.return
				end
			elseif x11_display_from = 2 then
				Current.x11_window := (0).to_natural_32
				x11_display.ce_gets (create {CE_POINTER [ANY]}.make_shared (default_pointer))
				x11_display_from := 0
			end
			if not js.return_called then
				if not (x_connect_to_server).to_boolean then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				if x11_window = {NATURAL_32} 0 then
					l_winid.ce_gets (getenv (ce_string ("WINDOWID")))
					if (l_winid.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						Current.x11_window := (atol (l_winid)).to_natural_32
					end
				end
				if (globals_inst.xterm_dpy.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					if x11_window /= {NATURAL_32} 0 then
						if x11_display_from /= 3 then
							if x11_display_from = 1 then
								if (x11_display.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									XCloseDisplay (x11_display).do_nothing
								end
							end
							x11_display.ce_gets (globals_inst.xterm_dpy)
							x11_display_from := 3
						end
						if (test_x11_window (x11_display)) = 0 then
							Current.x11_window := (0).to_natural_32
							x11_display.ce_gets (create {CE_POINTER [ANY]}.make_shared (default_pointer))
							x11_display_from := 0
							Result := 0
							js.return
						end
						if not js.return_called then
							Result := 1
							js.return
						end
					end
				end
			end
			if not js.return_called then
				if x11_window = {NATURAL_32} 0 then
					result2 := -1
				elseif (x11_display.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					result2 := -1
				end
				if result2 /= -1 then
					Result := result2
					js.return
				end
			end
			if not js.return_called then
				if x11_window /= {NATURAL_32} 0 then
					if (x11_display.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						if option_inst.p_verbose > 0 then
							gettimeofday ((l_start_tv.address), create {CE_POINTER [SD_TIMEZONE]}.make_shared (default_pointer)).do_nothing
						end
						x11_display.ce_gets (XOpenDisplay (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)))
						if (x11_display.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							if option_inst.p_verbose > 0 then
								message_inst.verbose_enter
								xopen_message (l_start_tv.address)
								message_inst.verbose_leave
							end
							if (test_x11_window (x11_display)) = 0 then
								Current.x11_window := (0).to_natural_32
								XCloseDisplay (x11_display).do_nothing
								x11_display.ce_gets (create {CE_POINTER [ANY]}.make_shared (default_pointer))
							else
								x11_display_from := 1
							end
						end
					end
				end
				if x11_window = {NATURAL_32} 0 then
					result2 := 0
					Result := result2
					js.return
				elseif (x11_display.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					result2 := 0
					Result := result2
					js.return
				end
			end
			if not js.return_called then
				result2 := 1
				Result := result2
			end
		end

	get_x11_title (a_test_only: INTEGER_32): INTEGER_32
		do
			Result := (get_x11_thing (1, a_test_only))
		end

	get_x11_icon (a_test_only: INTEGER_32): INTEGER_32
		local
			l_retval: INTEGER_32
		do
			l_retval := 0
			l_retval := get_x11_thing (0, a_test_only)
			if (oldicon.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				if not a_test_only.to_boolean then
					if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (term_inst.term_strings[0]), ce_string ("builtin_"), (8).to_natural_32)) = 0 then
						oldicon.ce_gets (misc2_inst.vim_strsave (term_inst.term_strings[0] + 8))
					else
						oldicon.ce_gets (misc2_inst.vim_strsave (term_inst.term_strings[0]))
					end
				end
			end
			Result := l_retval
		end

	get_x11_thing (a_get_title: INTEGER_32; a_test_only: INTEGER_32): INTEGER_32
		local
			l_text_prop: SD_XTEXTPROPERTY
			l_retval: INTEGER_32
			l_status: INTEGER_32
			l_root: NATURAL_32
			l_parent: NATURAL_32
			l_win: NATURAL_32
			l_children: CE_POINTER [NATURAL_32]
			l_num_children: NATURAL_32
			l_cl: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_transform_status: INTEGER_32
			l_n: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_text_prop.make
			create l_children.make
			create l_cl.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_retval := 0
					if (get_x11_windis) /= 1 then
						l_pos := -1 + 12 -- skip if block
					end
				when 1 then -- if:
						if a_get_title.to_boolean then
							l_status := XGetWMName (x11_display, x11_window, l_text_prop.address)
						else
							l_status := XGetWMIconName (x11_display, x11_window, l_text_prop.address)
						end
						l_win := x11_window
						from
						until
							js.loop_left
						loop
							js.reset
							if l_status.to_boolean then
								if ((l_text_prop.value).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									js.break
								end
							end
							if not js.loop_jumped then
								if not (XQueryTree (x11_display, l_win, create {CE_POINTER [NATURAL_32]}.make_shared ($l_root), create {CE_POINTER [NATURAL_32]}.make_shared ($l_parent), l_children.address, create {CE_POINTER [NATURAL_32]}.make_shared ($l_num_children))).to_boolean then
									js.break
								end
							end
							if not js.loop_jumped then
								if ((l_children).c_pointer /= default_pointer) then
									XFree (create {CE_POINTER [ANY]}.make_cast (l_children)).do_nothing
								end
								if l_parent = l_root then
									js.break
								elseif l_parent = {NATURAL_32} 0 then
									js.break
								end
							end
							if not js.loop_jumped then
								l_win := l_parent
								if a_get_title.to_boolean then
									l_status := XGetWMName (x11_display, l_win, l_text_prop.address)
								else
									l_status := XGetWMIconName (x11_display, l_win, l_text_prop.address)
								end
							end
						end
						js.reset
						if not (l_status.to_boolean) then
							l_pos := -1 + 12 -- skip if block
						end
				when 2 then -- if:
						if ((l_text_prop.value).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 12 -- skip if block
						end
				when 3 then -- if:
						l_retval := 1
						if a_test_only.to_boolean then
							l_pos := -1 + 11 -- skip if block
						end
				when 4 then -- if:
						if l_text_prop.encoding /= {NATURAL_32} 31 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if not globals_inst.has_mbyte.to_boolean then
							if a_get_title.to_boolean then
								oldtitle.ce_gets (misc2_inst.vim_strsave (l_text_prop.value))
							else
								oldicon.ce_gets (misc2_inst.vim_strsave (l_text_prop.value))
							end
						else
							l_pos := -1 + 7 -- goto _L___1
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 7 then -- else: | _L___1:
						l_n := 0
						l_transform_status := XmbTextPropertyToTextList (x11_display, (l_text_prop.address), l_cl.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_n))
						if not (l_transform_status >= 0) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						if l_n > 0 then
							if ((l_cl[0]).c_pointer /= default_pointer) then
								if a_get_title.to_boolean then
									oldtitle.ce_gets (misc2_inst.vim_strsave (create {CE_POINTER [NATURAL_8]}.make_cast (l_cl[0])))
								else
									oldicon.ce_gets (misc2_inst.vim_strsave (create {CE_POINTER [NATURAL_8]}.make_cast (l_cl[0])))
								end
								XFreeStringList (l_cl)
							else
								l_pos := -1 + 10 -- goto _L___0
							end
						else
							l_pos := -1 + 10 -- goto _L___0
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else: | _L___0:
						if a_get_title.to_boolean then
							oldtitle.ce_gets (misc2_inst.vim_strsave (l_text_prop.value))
						else
							oldicon.ce_gets (misc2_inst.vim_strsave (l_text_prop.value))
						end
				when 11 then -- if done | if done
						XFree (create {CE_POINTER [ANY]}.make_cast (l_text_prop.value)).do_nothing
				when 12 then -- if done | if done | if done
						Result := l_retval
				when 13 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	set_x11_title (a_title: CE_POINTER [NATURAL_8])
		local
			l_text_prop: SD_XTEXTPROPERTY
			l_c_title: CE_POINTER [INTEGER_8]
		do
			create l_text_prop.make
			create l_c_title.make

			if globals_inst.enc_utf8.to_boolean then
				Xutf8SetWMProperties (x11_display, x11_window, create {CE_POINTER [INTEGER_8]}.make_cast (a_title), create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_shared (default_pointer), 0, create {CE_POINTER [SD_XSIZEHINTS]}.make_shared (default_pointer), create {CE_POINTER [SD_XWMHINTS]}.make_shared (default_pointer), create {CE_POINTER [SD_XCLASSHINT]}.make_shared (default_pointer))
			else
				l_c_title.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast (a_title))
				XStringListToTextProperty (l_c_title.address, 1, l_text_prop.address).do_nothing
				XSetWMProperties (x11_display, x11_window, l_text_prop.address, create {CE_POINTER [SD_XTEXTPROPERTY]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_shared (default_pointer), 0, create {CE_POINTER [SD_XSIZEHINTS]}.make_shared (default_pointer), create {CE_POINTER [SD_XWMHINTS]}.make_shared (default_pointer), create {CE_POINTER [SD_XCLASSHINT]}.make_shared (default_pointer))
			end
			XFlush (x11_display).do_nothing
		end

	set_x11_icon (a_icon: CE_POINTER [NATURAL_8])
		local
			l_text_prop: SD_XTEXTPROPERTY
			l_c_icon: CE_POINTER [INTEGER_8]
		do
			create l_text_prop.make
			create l_c_icon.make

			if globals_inst.enc_utf8.to_boolean then
				Xutf8SetWMProperties (x11_display, x11_window, create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_8]}.make_cast (a_icon), create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_shared (default_pointer), 0, create {CE_POINTER [SD_XSIZEHINTS]}.make_shared (default_pointer), create {CE_POINTER [SD_XWMHINTS]}.make_shared (default_pointer), create {CE_POINTER [SD_XCLASSHINT]}.make_shared (default_pointer))
			else
				l_c_icon.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast (a_icon))
				XStringListToTextProperty (l_c_icon.address, 1, l_text_prop.address).do_nothing
				XSetWMProperties (x11_display, x11_window, create {CE_POINTER [SD_XTEXTPROPERTY]}.make_shared (default_pointer), l_text_prop.address, create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_shared (default_pointer), 0, create {CE_POINTER [SD_XSIZEHINTS]}.make_shared (default_pointer), create {CE_POINTER [SD_XWMHINTS]}.make_shared (default_pointer), create {CE_POINTER [SD_XCLASSHINT]}.make_shared (default_pointer))
			end
			XFlush (x11_display).do_nothing
		end

	mch_can_restore_title: INTEGER_32
		do
			Result := (get_x11_title (1))
		end

	mch_can_restore_icon: INTEGER_32
		do
			Result := (get_x11_icon (1))
		end

	mch_settitle (a_title: CE_POINTER [NATURAL_8]; a_icon: CE_POINTER [NATURAL_8])
		local
			l_type: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_type := 0
					if ((term_inst.term_strings[0]).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						js.return
					end
					if not js.return_called and then ((a_title.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32) then
						if (a_icon.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							js.return
						end
					end
					if not js.return_called and then (recursive___3.to_boolean) then
						js.return
					end
					if js.return_called then
						l_pos := -1 + 12 -- skip if block
					end
				when 1 then -- if:
						recursive___3 := recursive___3 + 1
						if (get_x11_windis) = 1 then
							l_type := 1
						end
						if not (l_type.to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if ((term_inst.term_strings[48]).item).to_integer_32 = 0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						if (a_title.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							if (oldtitle.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								if not (gui_inst.gui.in_use).to_boolean then
									get_x11_title (0).do_nothing
								end
							end
							if ((term_inst.term_strings[48]).item).to_integer_32 /= 0 then
								term_inst.term_settitle (a_title)
							elseif not (gui_inst.gui.in_use).to_boolean then
								set_x11_title (a_title)
							else
								gui_gtk_x11_inst.gui_mch_settitle (a_title, a_icon)
							end
							did_set_title___0 := 1
						end
				when 6 then -- if done
						if not (l_type.to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L___0
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 9 then -- else:
						if ((term_inst.term_strings[46]).item).to_integer_32 = 0 then
							l_pos := -1 + 11 -- skip if block
						end
				when 10 then -- if: | _L___0:
						if (a_icon.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							if (oldicon.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								if not (gui_inst.gui.in_use).to_boolean then
									get_x11_icon (0).do_nothing
								end
							end
							if ((term_inst.term_strings[46]).item).to_integer_32 /= 0 then
								term_inst.out_str (term_inst.term_strings[46])
								term_inst.out_str_nf (a_icon)
								term_inst.out_str (term_inst.term_strings[47])
								term_inst.out_flush
							elseif not (gui_inst.gui.in_use).to_boolean then
								set_x11_icon (a_icon)
							end
							did_set_icon := 1
						end
				when 11 then -- if done
						recursive___3 := recursive___3 - 1
				when 12 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	mch_restore_title (a_which: INTEGER_32)
		local
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [NATURAL_8]
		do
			create l_tmp.make
			create l_tmp___0.make
			create l_tmp___1.make

			if ((a_which).bit_and (2)).to_boolean then
				if did_set_icon.to_boolean then
					l_tmp.ce_gets (oldicon)
				else
					l_tmp.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				end
			else
				l_tmp.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
			end
			if ((a_which).bit_and (1)).to_boolean then
				if did_set_title___0.to_boolean then
					if ((oldtitle).c_pointer /= default_pointer) then
						l_tmp___0.ce_gets (oldtitle)
					else
						l_tmp___0.ce_gets (option_inst.p_titleold)
					end
					l_tmp___1.ce_gets (l_tmp___0)
				else
					l_tmp___1.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				end
			else
				l_tmp___1.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
			end
			mch_settitle (l_tmp___1, l_tmp)
		end

	vim_is_xterm (a_name___1: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_tmp___5: INTEGER_32
			js: JUMP_STATE
		do
			if (a_name___1.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				Result := 0
				js.return
			end
			if not js.return_called then
				if (strncasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_name___1), ce_string ("xterm"), (5).to_natural_32)) = 0 then
					l_tmp___5 := 1
				elseif (strncasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_name___1), ce_string ("nxterm"), (6).to_natural_32)) = 0 then
					l_tmp___5 := 1
				elseif (strncasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_name___1), ce_string ("kterm"), (5).to_natural_32)) = 0 then
					l_tmp___5 := 1
				elseif (strncasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_name___1), ce_string ("mlterm"), (6).to_natural_32)) = 0 then
					l_tmp___5 := 1
				elseif (strncasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_name___1), ce_string ("rxvt"), (4).to_natural_32)) = 0 then
					l_tmp___5 := 1
				elseif (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_name___1), ce_string ("builtin_xterm"))) = 0 then
					l_tmp___5 := 1
				else
					l_tmp___5 := 0
				end
				Result := l_tmp___5
			end
		end

	use_xterm_like_mouse (a_name___1: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_tmp___0: INTEGER_32
		do
			if (a_name___1.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				if globals_inst.term_is_xterm.to_boolean then
					l_tmp___0 := 1
				elseif (strncasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_name___1), ce_string ("screen"), (6).to_natural_32)) = 0 then
					l_tmp___0 := 1
				else
					l_tmp___0 := 0
				end
			else
				l_tmp___0 := 0
			end
			Result := l_tmp___0
		end

	use_xterm_mouse: INTEGER_32
		local
			js: JUMP_STATE
		do
			if option_inst.ttym_flags = {NATURAL_32} 2 then
				Result := 2
				js.return
			end
			if not js.return_called and then (option_inst.ttym_flags = {NATURAL_32} 1) then
				Result := 1
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	vim_is_iris (a_name___1: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_tmp___1: INTEGER_32
			js: JUMP_STATE
		do
			if (a_name___1.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				Result := 0
				js.return
			end
			if not js.return_called then
				if (strncasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_name___1), ce_string ("iris-ansi"), (9).to_natural_32)) = 0 then
					l_tmp___1 := 1
				elseif (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_name___1), ce_string ("builtin_iris-ansi"))) = 0 then
					l_tmp___1 := 1
				else
					l_tmp___1 := 0
				end
				Result := l_tmp___1
			end
		end

	vim_is_vt300 (a_name___1: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_tmp___2: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (a_name___1.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						Result := 0
						js.return
					end
					if js.return_called then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if (strncasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_name___1), ce_string ("vt"), (2).to_natural_32)) /= 0 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if ((misc2_inst.vim_strchr (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("12345")), (a_name___1[2]).to_integer_32)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_tmp___2 := 1
						else
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_name___1), ce_string ("builtin_vt320"))) = 0 then
							l_tmp___2 := 1
						else
							l_tmp___2 := 0
						end
				when 5 then
						Result := l_tmp___2
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	vim_is_fastterm (a_name___1: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_tmp___6: INTEGER_32
			js: JUMP_STATE
		do
			if (a_name___1.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				Result := 0
				js.return
			end
			if not js.return_called then
				if (vim_is_xterm (a_name___1)).to_boolean then
					Result := 1
					js.return
				elseif (vim_is_vt300 (a_name___1)).to_boolean then
					Result := 1
					js.return
				elseif (vim_is_iris (a_name___1)).to_boolean then
					Result := 1
					js.return
				end
			end
			if not js.return_called then
				if (strncasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_name___1), ce_string ("hpterm"), (6).to_natural_32)) = 0 then
					l_tmp___6 := 1
				elseif (strncasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_name___1), ce_string ("sun-cmd"), (7).to_natural_32)) = 0 then
					l_tmp___6 := 1
				elseif (strncasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_name___1), ce_string ("screen"), (6).to_natural_32)) = 0 then
					l_tmp___6 := 1
				elseif (strncasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_name___1), ce_string ("dtterm"), (6).to_natural_32)) = 0 then
					l_tmp___6 := 1
				else
					l_tmp___6 := 0
				end
				Result := l_tmp___6
			end
		end

	mch_get_user_name (a_s: CE_POINTER [NATURAL_8]; a_len: INTEGER_32): INTEGER_32
		do
			Result := (mch_get_uname ((getuid), a_s, a_len))
		end

	mch_get_uname (a_uid: NATURAL_32; a_s: CE_POINTER [NATURAL_8]; a_len: INTEGER_32): INTEGER_32
		local
			l_pw: CE_POINTER [SD_PASSWD]
			js: JUMP_STATE
		do
			create l_pw.make

			l_pw.ce_gets (getpwuid (a_uid))
			if (l_pw.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				if ((l_pw.item.pw_name).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					if ((l_pw.item.pw_name).item).to_integer_32 /= 0 then
						misc2_inst.vim_strncpy (a_s, create {CE_POINTER [NATURAL_8]}.make_cast (l_pw.item.pw_name), (a_len - 1).to_natural_32)
						Result := 1
						js.return
					end
				end
			end
			if not js.return_called then
				sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (a_s), ce_string ("%%d"), a_uid.to_integer_32]).do_nothing
				Result := 0
			end
		end

	mch_get_host_name (a_s: CE_POINTER [NATURAL_8]; a_len: INTEGER_32)
		local
			l_vutsname: SD_UTSNAME
		do
			create l_vutsname.make

			if (uname (l_vutsname.address)) < 0 then
				a_s.item := (('%/0/').code).to_natural_8
			else
				misc2_inst.vim_strncpy (a_s, create {CE_POINTER [NATURAL_8]}.make_cast ((l_vutsname.nodename)), (a_len - 1).to_natural_32)
			end
		end

	mch_get_pid: INTEGER_32
		do
			Result := (getpid).to_integer_32
		end

	mch_dirname (a_buf___6: CE_POINTER [NATURAL_8]; a_len: INTEGER_32): INTEGER_32
		local
			js: JUMP_STATE
		do
			if ((getcwd (create {CE_POINTER [INTEGER_8]}.make_cast (a_buf___6), a_len.to_natural_32)).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (a_buf___6), (strerror ((errno_location).item))).do_nothing
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 1
			end
		end

	mch_FullName (a_fname: CE_POINTER [NATURAL_8]; a_buf___6: CE_POINTER [NATURAL_8]; a_len: INTEGER_32; a_force: INTEGER_32): INTEGER_32
		local
			l_fname: CE_POINTER [NATURAL_8]
			l_l: INTEGER_32
			l_fd: INTEGER_32
			l_olddir: CE_ARRAY [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_retval: INTEGER_32
			l_tmp___8: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_fname.make
			create l_olddir.make (<<4096>>)
			create l_p___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_fname.ce_gets (a_fname)
					l_fd := -1
					l_retval := 1
					if not (a_force.to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L___0
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 3 then -- else:
						if (mch_isFullName (l_fname)).to_boolean then
							l_pos := -1 + 10 -- skip if block
						end
				when 4 then -- if: | _L___0:
						l_p___0.ce_gets (misc2_inst.vim_strrchr (l_fname, ('/').code))
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 9 -- skip if block
						end
				when 5 then -- if:
						if not dont_fchdir.to_boolean then
							l_fd := open ([ce_string ("."), 0, 0])
							if l_fd >= 0 then
								if (fchdir (l_fd)) < 0 then
									close (l_fd).do_nothing
									l_fd := -1
									dont_fchdir := 1
								end
							end
						end
						if not (l_fd < 0) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						if (mch_dirname (l_olddir, 4096)) = 0 then
							l_p___0.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							l_retval := 0
						elseif (mch_chdir (create {CE_POINTER [INTEGER_8]}.make_cast (l_olddir))) /= 0 then
							l_p___0.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							l_retval := 0
						else
							l_pos := -1 + 8 -- goto _L
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else: | _L:
						if l_p___0.distance (l_fname) >= a_len then
							l_retval := 0
						else
							misc2_inst.vim_strncpy (a_buf___6, l_fname, (l_p___0.distance (l_fname)).to_natural_32)
							if (mch_chdir (create {CE_POINTER [INTEGER_8]}.make_cast (a_buf___6))).to_boolean then
								l_retval := 0
							else
								l_fname.ce_gets (l_p___0 + 1)
							end
							a_buf___6.item := (('%/0/').code).to_natural_8
						end
				when 9 then -- if done
						if (mch_dirname (a_buf___6, a_len)) = 0 then
							l_retval := 0
							a_buf___6.item := (('%/0/').code).to_natural_8
						end
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							if l_fd >= 0 then
								if option_inst.p_verbose >= 5 then
									message_inst.verbose_enter
									message_inst.msg (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("fchdir() to previous dir"))).do_nothing
									message_inst.verbose_leave
								end
								l_l := fchdir (l_fd)
								close (l_fd).do_nothing
							else
								l_l := mch_chdir (create {CE_POINTER [INTEGER_8]}.make_cast (l_olddir))
							end
							if l_l /= 0 then
								message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_prev_dir))))).do_nothing
							end
						end
						l_l := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_buf___6))).to_integer_32
						if l_l >= a_len then
							l_retval := 0
						elseif l_l > 0 then
							if (a_buf___6[(l_l - 1)]).to_integer_32 /= 47 then
								if (l_fname.item).to_integer_32 /= 0 then
									if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_fname), ce_string ("."))) /= 0 then
										strcat (create {CE_POINTER [INTEGER_8]}.make_cast (a_buf___6), ce_string ("/")).do_nothing
									end
								end
							end
						end
				when 10 then -- if done
						if l_retval = 0 then
							Result := 0
							js.return
						else
							l_tmp___8 := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_buf___6))
							if (l_tmp___8 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_fname)))).to_integer_32 >= a_len then
								Result := 0
								js.return
							end
						end
						if not js.return_called then
							if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_fname), ce_string ("."))) /= 0 then
								strcat (create {CE_POINTER [INTEGER_8]}.make_cast (a_buf___6), create {CE_POINTER [INTEGER_8]}.make_cast (l_fname)).do_nothing
							end
							Result := 1
						end
				when 11 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	mch_isFullName (a_fname: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_tmp: INTEGER_32
		do
			if (a_fname.item).to_integer_32 = 47 then
				l_tmp := 1
			elseif (a_fname.item).to_integer_32 = 126 then
				l_tmp := 1
			else
				l_tmp := 0
			end
			Result := l_tmp
		end

	mch_getperm (a_name___1: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_statb: SD_STAT
			js: JUMP_STATE
		do
			create l_statb.make

			if (stat (create {CE_POINTER [INTEGER_8]}.make_cast (a_name___1), (l_statb.address))).to_boolean then
				Result := (-1)
				js.return
			end
			if not js.return_called then
				Result := (l_statb.st_mode).to_integer_32
			end
		end

	mch_setperm (a_name___1: CE_POINTER [NATURAL_8]; a_perm: INTEGER_32): INTEGER_32
		local
			l_tmp___0: INTEGER_32
		do
			if (chmod (create {CE_POINTER [INTEGER_8]}.make_cast (a_name___1), a_perm.to_natural_32)) = 0 then
				l_tmp___0 := 1
			else
				l_tmp___0 := 0
			end
			Result := l_tmp___0
		end

	mch_get_acl (a_fname: CE_POINTER [NATURAL_8]): CE_POINTER [ANY]
		local
			l_ret: CE_POINTER [ANY]
		do
			create l_ret.make

			l_ret.ce_gets (create {CE_POINTER [ANY]}.make_shared (default_pointer))
			Result := l_ret
		end

	mch_set_acl (a_fname: CE_POINTER [NATURAL_8]; a_aclent: CE_POINTER [ANY])
		local
			js: JUMP_STATE
		do
			if (a_aclent.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				js.return
			end
			if not js.return_called then
			end
		end

	mch_free_acl (a_aclent: CE_POINTER [ANY])
		local
			js: JUMP_STATE
		do
			if (a_aclent.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				js.return
			end
			if not js.return_called then
			end
		end

	mch_hide (a_name___1: CE_POINTER [NATURAL_8])
		do
		end

	mch_isdir (a_name___1: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_statb: SD_STAT
			l_tmp___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_statb.make

			if (a_name___1.item).to_integer_32 = 0 then
				Result := 0
				js.return
			end
			if not js.return_called then
				if (stat (create {CE_POINTER [INTEGER_8]}.make_cast (a_name___1), (l_statb.address))).to_boolean then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				if ((l_statb.st_mode).bit_and ({NATURAL_32} 61440)) = {NATURAL_32} 16384 then
					l_tmp___0 := 1
				else
					l_tmp___0 := 0
				end
				Result := l_tmp___0
			end
		end

	executable_file (a_name___1: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_st: SD_STAT
			l_tmp___1: INTEGER_32
			js: JUMP_STATE
		do
			create l_st.make

			if (stat (create {CE_POINTER [INTEGER_8]}.make_cast (a_name___1), (l_st.address))).to_boolean then
				Result := 0
				js.return
			end
			if not js.return_called then
				if ((l_st.st_mode).bit_and ({NATURAL_32} 61440)) = {NATURAL_32} 32768 then
					if (access (create {CE_POINTER [INTEGER_8]}.make_cast (a_name___1), 1)) = 0 then
						l_tmp___1 := 1
					else
						l_tmp___1 := 0
					end
				else
					l_tmp___1 := 0
				end
				Result := l_tmp___1
			end
		end

	mch_can_exe (a_name___1: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_buf___6: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_e: CE_POINTER [NATURAL_8]
			l_retval: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___2: NATURAL_32
			js: JUMP_STATE
		do
			create l_buf___6.make
			create l_p___0.make
			create l_e.make

			if (mch_isFullName (a_name___1)).to_boolean then
				l_tmp := executable_file (a_name___1)
				Result := l_tmp
				js.return
			elseif (a_name___1[0]).to_integer_32 = 46 then
				if (a_name___1[1]).to_integer_32 = 47 then
					l_tmp := executable_file (a_name___1)
					Result := l_tmp
					js.return
				elseif (a_name___1[1]).to_integer_32 = 46 then
					if (a_name___1[2]).to_integer_32 = 47 then
						l_tmp := executable_file (a_name___1)
						Result := l_tmp
						js.return
					end
				end
			end
			if not js.return_called then
				l_p___0.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((getenv (ce_string ("PATH")))))
				if (l_p___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					Result := (-1)
					js.return
				elseif (l_p___0.item).to_integer_32 = 0 then
					Result := (-1)
					js.return
				end
			end
			if not js.return_called then
				l_tmp___2 := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_name___1))
				l_buf___6.ce_gets (misc2_inst.alloc ((l_tmp___2 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0)))) + {NATURAL_32} 2))
				if (l_buf___6.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					Result := (-1)
					js.return
				end
			end
			if not js.return_called then
				from
				until
					js.loop_left
				loop
					js.reset
					l_e.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((strchr (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), (':').code))))
					if (l_e.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						l_e.ce_gets (l_p___0 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0))).to_integer_32)
					end
					if l_e.distance (l_p___0) <= 1 then
						strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6), ce_string ("./")).do_nothing
					else
						misc2_inst.vim_strncpy (l_buf___6, l_p___0, (l_e.distance (l_p___0)).to_natural_32)
						misc1_inst.add_pathsep (l_buf___6)
					end
					strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6), create {CE_POINTER [INTEGER_8]}.make_cast (a_name___1)).do_nothing
					l_retval := executable_file (l_buf___6)
					if l_retval = 1 then
						js.break
					end
					if not js.loop_jumped and then ((l_e.item).to_integer_32 /= 58) then
						js.break
					end
					if not js.loop_jumped then
						l_p___0.ce_gets (l_e + 1)
					end
				end
				js.reset
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_buf___6))
				Result := l_retval
			end
		end

	mch_nodetype (a_name___1: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_st: SD_STAT
			js: JUMP_STATE
		do
			create l_st.make

			if (stat (create {CE_POINTER [INTEGER_8]}.make_cast (a_name___1), (l_st.address))).to_boolean then
				Result := 0
				js.return
			end
			if not js.return_called then
				if ((l_st.st_mode).bit_and ({NATURAL_32} 61440)) = {NATURAL_32} 32768 then
					Result := 0
					js.return
				elseif ((l_st.st_mode).bit_and ({NATURAL_32} 61440)) = {NATURAL_32} 16384 then
					Result := 0
					js.return
				end
			end
			if not js.return_called and then (((l_st.st_mode).bit_and ({NATURAL_32} 61440)) = {NATURAL_32} 24576) then
				Result := 2
				js.return
			end
			if not js.return_called then
				Result := 1
			end
		end

	mch_early_init
		do
			signal_stack.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((misc2_inst.alloc ({NATURAL_32} 8192))))
			init_signal_stack
		end

	exit_scroll
		local
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if globals_inst.silent_mode.to_boolean then
						js.return
					end
					if js.return_called then
						l_pos := -1 + 8 -- skip if block
					end
				when 1 then -- if:
						if not (globals_inst.newline_on_exit.to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 4 then -- else:
						if not (globals_inst.msg_didout.to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if: | _L:
						if (message_inst.msg_use_printf).to_boolean then
							if globals_inst.info_message.to_boolean then
								message_inst.mch_msg (ce_string ("%N"))
							else
								message_inst.mch_errmsg (ce_string ("%R%N"))
							end
						else
							term_inst.out_char ((('%N').code).to_natural_32)
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else:
						syntax_inst.restore_cterm_colors
						message_inst.msg_clr_eos_force
						screen_inst.windgoto (globals_inst.Rows.to_integer_32 - 1, 0)
				when 8 then -- if done | if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	mch_exit (a_r: INTEGER_32)
		do
			globals_inst.exiting := 1
			ops_inst.x11_export_final_selection
			if not (gui_inst.gui.in_use).to_boolean then
				term_inst.settmode (0)
				mch_restore_title (3)
				if (term_inst.swapping_screen).to_boolean then
					if not globals_inst.newline_on_exit.to_boolean then
						exit_scroll
					end
				end
				term_inst.stoptermcap
				if (term_inst.swapping_screen).to_boolean then
					if globals_inst.newline_on_exit.to_boolean then
						exit_scroll
					end
				else
					exit_scroll
				end
				if globals_inst.full_screen.to_boolean then
					term_inst.cursor_on
				end
			end
			term_inst.out_flush
			memline_inst.ml_close_all (1)
			may_core_dump
			if (gui_inst.gui.in_use).to_boolean then
				gui_inst.gui_exit (a_r)
			end
			netbeans_inst.netbeans_send_disconnect
			exit (a_r)
		end

	may_core_dump
		do
			if deadly_signal /= 0 then
				sigset (deadly_signal, create {CE_ROUTINE}.make_shared (default_pointer)).do_nothing
				kill ((getpid), deadly_signal).do_nothing
			end
		end

	mch_settmode (a_tmode: INTEGER_32)
		local
			l_tnew: SD_TERMIOS
			l_n: INTEGER_32
			js: JUMP_STATE
		do
			create l_tnew.make

			if first.to_boolean then
				first := 0
				tcgetattr (globals_inst.read_cmd_fd, told.address).do_nothing
			end
			l_tnew.ce_gets (told)
			if a_tmode = 2 then
				l_tnew.c2_iflag := (l_tnew.c2_iflag).bit_and (({NATURAL_32} 4294967039))
				l_tnew.c2_lflag := (l_tnew.c2_lflag).bit_and (({NATURAL_32} 4294934500))
				l_tnew.c2_oflag := (l_tnew.c2_oflag).bit_and (({NATURAL_32} 4294967291))
				l_tnew.c2_cc[6] := (1).to_natural_8
				l_tnew.c2_cc[5] := (0).to_natural_8
			elseif a_tmode = 1 then
				l_tnew.c2_lflag := (l_tnew.c2_lflag).bit_and (({NATURAL_32} 4294967287))
			end
			l_n := 10
			from
			until
				js.loop_left
			loop
				js.reset
				if (tcsetattr (globals_inst.read_cmd_fd, 0, (l_tnew.address))) = -1 then
					if (errno_location).item = 4 then
						if not (l_n > 0) then
							js.break
						end
					else
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					l_n := l_n - 1
				end
			end
			js.reset
			curr_tmode := a_tmode
		end

	get_stty
		local
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_keys___0: SD_TERMIOS
		do
			create l_buf___6.make (<<2>>)
			create l_p___0.make
			create l_keys___0.make

			if (tcgetattr (globals_inst.read_cmd_fd, l_keys___0.address)) /= -1 then
				l_buf___6[0] := l_keys___0.c2_cc[2]
				globals_inst.intr_char := (l_keys___0.c2_cc[0]).to_integer_32
				l_buf___6[1] := (('%/0/').code).to_natural_8
				term_inst.add_termcode (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("kb")), l_buf___6, 0)
				l_p___0.ce_gets (term_inst.find_termcode (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("kD"))))
				if (l_p___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					if (l_p___0[0]).to_integer_32 = (l_buf___6[0]).to_integer_32 then
						if (l_p___0[1]).to_integer_32 = (l_buf___6[1]).to_integer_32 then
							ex_cmds_inst.do_fixdel (create {CE_POINTER [PD_EXARG]}.make_shared (default_pointer))
						end
					end
				end
			end
		end

	mch_setmouse (a_on: INTEGER_32)
		local
			l_xterm_mouse_vers: INTEGER_32
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_tmp.make
			create l_tmp___0.make

			if a_on = ison then
				js.return
			end
			if not js.return_called then
				l_xterm_mouse_vers := use_xterm_mouse
				if l_xterm_mouse_vers > 0 then
					if a_on.to_boolean then
						if l_xterm_mouse_vers > 1 then
							l_tmp.ce_gets (ce_string ("%/27/[?1002h"))
						else
							l_tmp.ce_gets (ce_string ("%/27/[?1000h"))
						end
						term_inst.out_str_nf (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp))
					else
						if l_xterm_mouse_vers > 1 then
							l_tmp___0.ce_gets (ce_string ("%/27/[?1002l"))
						else
							l_tmp___0.ce_gets (ce_string ("%/27/[?1000l"))
						end
						term_inst.out_str_nf (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___0))
					end
					ison := a_on
				end
			end
		end

	check_mouse_termcode
		local
			l_tmp___0: CE_POINTER [INTEGER_8]
		do
			create l_tmp___0.make

			if (use_xterm_mouse).to_boolean then
				if not (gui_inst.gui.in_use).to_boolean then
					if (term_inst.term_is_8bit (term_inst.term_strings[0])).to_boolean then
						l_tmp___0.ce_gets (ce_string ("%/155/M"))
					else
						l_tmp___0.ce_gets (ce_string ("%/27/[M"))
					end
					term_inst.set_mouse_termcode (251, create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___0))
					if (option_inst.p_mouse.item).to_integer_32 /= 0 then
						mch_setmouse (0)
						term_inst.setmouse
					end
				else
					term_inst.del_mouse_termcode (251)
				end
			else
				term_inst.del_mouse_termcode (251)
			end
		end

	mch_screenmode (a_arg: CE_POINTER [NATURAL_8]): INTEGER_32
		do
			message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_screenmode))))).do_nothing
			Result := 0
		end

	mch_get_shellsize: INTEGER_32
		local
			l_rows: INTEGER_32
			l_columns: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_ws: SD_WINSIZE
			l_fd: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p___0.make
			create l_ws.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_rows := 0
					l_columns := 0
					l_fd := 1
					if not (isatty (l_fd)).to_boolean then
						if (isatty (globals_inst.read_cmd_fd)).to_boolean then
							l_fd := globals_inst.read_cmd_fd
						end
					end
					if (ioctl ([l_fd, {NATURAL_32} 21523, l_ws.address])) = 0 then
						l_columns := (l_ws.ws_col).to_integer_32
						l_rows := (l_ws.ws_row).to_integer_32
					end
					if l_columns /= 0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 3 then -- else:
						if l_rows /= 0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 6 then -- else:
						if ((misc2_inst.vim_strchr (option_inst.p_cpo, ('|').code)).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 8 -- skip if block
						end
				when 7 then -- if: | _L:
						l_p___0.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((getenv (ce_string ("LINES")))))
						if ((l_p___0).c_pointer /= default_pointer) then
							l_rows := (atoi (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0))).to_integer_32
						end
						l_p___0.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((getenv (ce_string ("COLUMNS")))))
						if ((l_p___0).c_pointer /= default_pointer) then
							l_columns := (atoi (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0))).to_integer_32
						end
				when 8 then -- if done | if done
						if l_columns = 0 then
							term_inst.getlinecol (create {CE_POINTER [INTEGER_32]}.make_shared ($l_columns), create {CE_POINTER [INTEGER_32]}.make_shared ($l_rows))
						elseif l_rows = 0 then
							term_inst.getlinecol (create {CE_POINTER [INTEGER_32]}.make_shared ($l_columns), create {CE_POINTER [INTEGER_32]}.make_shared ($l_rows))
						end
						if l_columns <= 0 then
							Result := 0
							js.return
						elseif l_rows <= 0 then
							Result := 0
							js.return
						end
						if not js.return_called then
							globals_inst.Rows := l_rows
							globals_inst.Columns := l_columns
							Result := 1
						end
				when 9 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	mch_set_shellsize
		do
			if ((term_inst.term_strings[51]).item).to_boolean then
				term_inst.term_set_winsize (globals_inst.Rows.to_integer_32, globals_inst.Columns.to_integer_32)
				term_inst.out_flush
				screen_inst.screen_start
			end
		end

	mch_new_shellsize
		do
		end

	append_ga_line (a_gap: CE_POINTER [PD_GROWARRAY])
		local
			l_tmp: INTEGER_32
		do
			if a_gap.item.ga_len > 0 then
				if not (globals_inst.curbuf.item.b_p_bin).to_boolean then
					if (create {CE_POINTER [NATURAL_8]}.make_cast (a_gap.item.ga_data)[(a_gap.item.ga_len - 1)]).to_integer_32 = 13 then
						a_gap.item.ga_len := (a_gap.item.ga_len) - 1
					end
				end
			end
			misc2_inst.ga_append (a_gap, ('%/0/').code)
			l_tmp := globals_inst.curwin.item.w_cursor.lnum
			globals_inst.curwin.item.w_cursor.lnum := (globals_inst.curwin.item.w_cursor.lnum) + 1
			memline_inst.ml_append (l_tmp, create {CE_POINTER [NATURAL_8]}.make_cast (a_gap.item.ga_data), 0, 0).do_nothing
			a_gap.item.ga_len := 0
		end

	mch_call_shell (a_cmd: CE_POINTER [NATURAL_8]; a_options___0: INTEGER_32): INTEGER_32
		local
			l_tmode: INTEGER_32
			l_newcmd: CE_POINTER [NATURAL_8]
			l_pid: INTEGER_32
			l_wpid: INTEGER_32
			l_wait_pid: INTEGER_32
			l_status: INTEGER_32
			l_retval: INTEGER_32
			l_argv: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_argc: INTEGER_32
			l_i___0: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_inquote: INTEGER_32
			l_pty_master_fd: INTEGER_32
			l_pty_slave_fd: INTEGER_32
			l_tty_name: CE_POINTER [INTEGER_8]
			l_fd_toshell: CE_ARRAY [INTEGER_32]
			l_fd_fromshell: CE_ARRAY [INTEGER_32]
			l_pipe_error: INTEGER_32
			l_envbuf: CE_ARRAY [INTEGER_8]
			l_did_settmode: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_fd: INTEGER_32
			l_buffer: CE_ARRAY [NATURAL_8]
			l_buffer_off: INTEGER_32
			l_ta_buf: CE_ARRAY [NATURAL_8]
			l_ta_len___0: INTEGER_32
			l_len: INTEGER_32
			l_p_more_save: INTEGER_32
			l_old_State: INTEGER_32
			l_c: INTEGER_32
			l_toshell_fd: INTEGER_32
			l_fromshell_fd: INTEGER_32
			l_ga: PD_GROWARRAY
			l_noread_cnt: INTEGER_32
			l_start_tv: SD_TIMEVAL
			l_lnum: INTEGER_32
			l_written: INTEGER_32
			l_lp: CE_POINTER [NATURAL_8]
			l_s: CE_POINTER [NATURAL_8]
			l_l: NATURAL_32
			l_tmp___10: NATURAL_32
			l_l___0: INTEGER_32
			l_l___1: INTEGER_32
			l_now_tv: SD_TIMEVAL
			l_msec: INTEGER_32
			l_constr_expr_0: PD_ANONYMOUS
			l_constr_expr_1: PD_ANONYMOUS2
			l_constr_expr_2: PD_ANONYMOUS3
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_newcmd.make
			create l_argv.make
			create l_p___0.make
			create l_tty_name.make
			create l_fd_toshell.make (<<2>>)
			create l_fd_fromshell.make (<<2>>)
			create l_envbuf.make (<<50>>)
			create l_tmp.make
			create l_buffer.make (<<101>>)
			create l_ta_buf.make (<<101>>)
			create l_ga.make
			create l_start_tv.make
			create l_lp.make
			create l_s.make
			create l_now_tv.make
			create l_constr_expr_0.make
			create l_constr_expr_1.make
			create l_constr_expr_2.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_tmode := globals_inst.cur_tmode
					l_newcmd.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_wpid := 0
					l_wait_pid := 0
					l_status := -1
					l_retval := -1
					l_argv.ce_gets (create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_shared (default_pointer))
					l_pty_master_fd := -1
					l_pty_slave_fd := -1
					l_pipe_error := 0
					l_did_settmode := 0
					term_inst.out_flush
					if ((a_options___0).bit_and (4)).to_boolean then
						term_inst.settmode (0)
					end
					l_newcmd.ce_gets (misc2_inst.vim_strsave (option_inst.p_sh))
					if (l_newcmd.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						l_pos := -1 + 100 -- goto error
					end
				when 1 then
					l_i___0 := 0
				when 2 then -- loop condition:
					if not (not js.loop_left and then (l_i___0 < 2)) then
						l_pos := -1 + 5 -- skip loop
					end
				when 3 then -- loop body:
						l_p___0.ce_gets (l_newcmd)
						l_inquote := 0
						l_argc := 0
						from
						until
							js.loop_left
						loop
							js.reset
							if l_i___0 = 1 then
								l_argv[l_argc] := create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0)
							end
							l_argc := l_argc + 1
							from
							until
								js.loop_left
							loop
								js.reset
								if (l_p___0.item).to_boolean then
									if not l_inquote.to_boolean then
										if (l_p___0.item).to_integer_32 /= 32 then
											if (l_p___0.item).to_integer_32 = 9 then
												js.break
											end
										else
											js.break
										end
									end
								else
									js.break
								end
								if not js.loop_jumped then
									if (l_p___0.item).to_integer_32 = 34 then
										l_inquote := (not l_inquote.to_boolean).to_integer
									end
									l_p___0.ce_gets (l_p___0 + 1)
								end
							end
							js.reset
							if (l_p___0.item).to_integer_32 = 0 then
								js.break
							end
							if not js.loop_jumped then
								if l_i___0 = 1 then
									l_tmp.ce_gets (l_p___0)
									l_p___0.ce_gets (l_p___0 + 1)
									l_tmp.item := (('%/0/').code).to_natural_8
								end
								l_p___0.ce_gets (charset_inst.skipwhite (l_p___0))
							end
						end
						js.reset
						if (l_argv.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_argv.ce_gets (create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_cast ((misc2_inst.alloc ((l_argc + 4).to_natural_32 * Pointer_bytes.to_natural_32))))
							if (l_argv.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								l_pos := -1 + 100 -- goto error
							end
						end
				when 4 then
						l_i___0 := l_i___0 + 1
						l_pos := -1 + 2 -- back to loop condition
				when 5 then -- loop done
					if (a_cmd.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						if (extra_shell_arg.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_tmp___1 := l_argc
							l_argc := l_argc + 1
							l_argv[l_tmp___1] := create {CE_POINTER [INTEGER_8]}.make_cast (extra_shell_arg)
						end
						l_tmp___2 := l_argc
						l_argc := l_argc + 1
						l_argv[l_tmp___2] := create {CE_POINTER [INTEGER_8]}.make_cast (option_inst.p_shcf)
						l_tmp___3 := l_argc
						l_argc := l_argc + 1
						l_argv[l_tmp___3] := create {CE_POINTER [INTEGER_8]}.make_cast (a_cmd)
					end
					l_argv[l_argc] := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
					if not (((a_options___0).bit_and (96)).to_boolean) then
						l_pos := -1 + 8 -- skip if block
					end
				when 6 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 8 then -- else:
						if not ((gui_inst.gui.in_use).to_boolean) then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						if not (show_shell_mess.to_boolean) then
							l_pos := -1 + 11 -- skip if block
						end
				when 10 then -- if: | _L:
						if option_inst.p_guipty.to_boolean then
							if not ((a_options___0).bit_and (96)).to_boolean then
								l_pty_master_fd := pty_inst.OpenPTY (l_tty_name.address)
								if l_pty_master_fd >= 0 then
									l_pty_slave_fd := open ([l_tty_name, 2, 0])
									if l_pty_slave_fd < 0 then
										close (l_pty_master_fd).do_nothing
										l_pty_master_fd := -1
									end
								end
							end
						end
						if l_pty_master_fd < 0 then
							l_pipe_error := ((pipe (create {CE_POINTER [INTEGER_32]}.make_cast (l_fd_toshell))) < 0).to_integer
							if not l_pipe_error.to_boolean then
								l_pipe_error := ((pipe (create {CE_POINTER [INTEGER_32]}.make_cast (l_fd_fromshell))) < 0).to_integer
								if l_pipe_error.to_boolean then
									close (l_fd_toshell[0]).do_nothing
									close (l_fd_toshell[1]).do_nothing
								end
							end
							if l_pipe_error.to_boolean then
								message_inst.msg_puts (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("%NCannot create pipes%N")))))
								term_inst.out_flush
							end
						end
				when 11 then -- if done | if done
						if l_pipe_error.to_boolean then
							l_pos := -1 + 99 -- skip if block
						end
				when 12 then -- if:
							l_pid := fork
							if l_pid /= -1 then
								l_pos := -1 + 20 -- skip if block
							end
				when 13 then -- if:
							message_inst.msg_puts (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("%NCannot fork%N")))))
							if not (((a_options___0).bit_and (96)).to_boolean) then
								l_pos := -1 + 16 -- skip if block
							end
				when 14 then -- if:
							l_pos := -1 + 18 -- goto _L___0
				when 15 then -- if block done, skip else block:
							l_pos := -1 + 19
				when 16 then -- else:
							if not ((gui_inst.gui.in_use).to_boolean) then
								l_pos := -1 + 19 -- skip if block
							end
				when 17 then -- if:
							if not (show_shell_mess.to_boolean) then
								l_pos := -1 + 19 -- skip if block
							end
				when 18 then -- if: | _L___0:
							if l_pty_master_fd >= 0 then
								close (l_pty_master_fd).do_nothing
								close (l_pty_slave_fd).do_nothing
							else
								close (l_fd_toshell[0]).do_nothing
								close (l_fd_toshell[1]).do_nothing
								close (l_fd_fromshell[0]).do_nothing
								close (l_fd_fromshell[1]).do_nothing
							end
				when 19 then -- if done | if done | if done | if block done, skip else block:
							l_pos := -1 + 99
				when 20 then -- else:
							if l_pid /= 0 then
								l_pos := -1 + 34 -- skip if block
							end
				when 21 then -- if:
							reset_signals
							if show_shell_mess.to_boolean then
								l_pos := -1 + 24 -- skip if block
							end
				when 22 then -- if:
							l_pos := -1 + 25 -- goto _L___2
				when 23 then -- if block done, skip else block:
							l_pos := -1 + 32
				when 24 then -- else:
							if not (((a_options___0).bit_and (2)).to_boolean) then
								l_pos := -1 + 27 -- skip if block
							end
				when 25 then -- if: | _L___2:
							l_fd := open ([ce_string ("/dev/null"), 2, 0])
							fclose ((create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.input.file_pointer))).do_nothing
							fclose ((create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.output.file_pointer))).do_nothing
							fclose ((create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.error.file_pointer))).do_nothing
							if l_fd >= 0 then
								globals_inst.ignored := dup (l_fd)
								globals_inst.ignored := dup (l_fd)
								globals_inst.ignored := dup (l_fd)
								close (l_fd).do_nothing
							end
				when 26 then -- if block done, skip else block:
							l_pos := -1 + 32
				when 27 then -- else:
							if not (((a_options___0).bit_and (96)).to_boolean) then
								l_pos := -1 + 30 -- skip if block
							end
				when 28 then -- if:
							l_pos := -1 + 31 -- goto _L___1
				when 29 then -- if block done, skip else block:
							l_pos := -1 + 32
				when 30 then -- else:
							if not ((gui_inst.gui.in_use).to_boolean) then
								l_pos := -1 + 32 -- skip if block
							end
				when 31 then -- if: | _L___1:
							if option_inst.p_stmp.to_boolean then
								setsid.do_nothing
								sigset (1, create {CE_ROUTINE}.make_shared (default_pointer + 1)).do_nothing
							end
							if l_pty_slave_fd >= 0 then
								if ((a_options___0).bit_and (4)).to_boolean then
									pty_inst.SetupSlavePTY (l_pty_slave_fd).do_nothing
								end
								ioctl ([l_pty_slave_fd, {NATURAL_32} 21518, create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)]).do_nothing
							end
							setenv (ce_string ("TERM"), ce_string ("dumb"), 1).do_nothing
							sprintf ([l_envbuf, ce_string ("%%ld"), globals_inst.Rows]).do_nothing
							setenv (ce_string ("ROWS"), l_envbuf, 1).do_nothing
							sprintf ([l_envbuf, ce_string ("%%ld"), globals_inst.Rows]).do_nothing
							setenv (ce_string ("LINES"), l_envbuf, 1).do_nothing
							sprintf ([l_envbuf, ce_string ("%%ld"), globals_inst.Columns]).do_nothing
							setenv (ce_string ("COLUMNS"), l_envbuf, 1).do_nothing
							if l_pty_master_fd >= 0 then
								close (l_pty_master_fd).do_nothing
								close (0).do_nothing
								globals_inst.ignored := dup (l_pty_slave_fd)
								close (1).do_nothing
								globals_inst.ignored := dup (l_pty_slave_fd)
								if (gui_inst.gui.in_use).to_boolean then
									close (2).do_nothing
									globals_inst.ignored := dup (l_pty_slave_fd)
								end
								close (l_pty_slave_fd).do_nothing
							else
								close (l_fd_toshell[1]).do_nothing
								close (0).do_nothing
								globals_inst.ignored := dup (l_fd_toshell[0])
								close (l_fd_toshell[0]).do_nothing
								close (l_fd_fromshell[0]).do_nothing
								close (1).do_nothing
								globals_inst.ignored := dup (l_fd_fromshell[1])
								close (l_fd_fromshell[1]).do_nothing
								if (gui_inst.gui.in_use).to_boolean then
									close (2).do_nothing
									globals_inst.ignored := dup (1)
								end
							end
				when 32 then -- if done | if done | if done
							execvp (l_argv[0], l_argv).do_nothing
							exit2 (122)
				when 33 then -- if block done, skip else block:
							l_pos := -1 + 99
				when 34 then -- else:
							catch_signals (create {CE_ROUTINE}.make_shared (default_pointer + 1), create {CE_ROUTINE}.make_shared (default_pointer + -1))
							catch_int_signal
							if not (((a_options___0).bit_and (96)).to_boolean) then
								l_pos := -1 + 37 -- skip if block
							end
				when 35 then -- if:
							l_pos := -1 + 39 -- goto _L___11
				when 36 then -- if block done, skip else block:
							l_pos := -1 + 98
				when 37 then -- else:
							if not ((gui_inst.gui.in_use).to_boolean) then
								l_pos := -1 + 98 -- skip if block
							end
				when 38 then -- if:
							if not (show_shell_mess.to_boolean) then
								l_pos := -1 + 98 -- skip if block
							end
				when 39 then -- if: | _L___11:
							l_buffer_off := 0
							l_ta_len___0 := 0
							if l_pty_master_fd >= 0 then
								close (l_pty_slave_fd).do_nothing
								l_fromshell_fd := l_pty_master_fd
								l_toshell_fd := dup (l_pty_master_fd)
							else
								close (l_fd_toshell[0]).do_nothing
								close (l_fd_fromshell[1]).do_nothing
								l_toshell_fd := l_fd_toshell[1]
								l_fromshell_fd := l_fd_fromshell[0]
							end
							l_p_more_save := option_inst.p_more
							option_inst.p_more := 0
							l_old_State := globals_inst.State
							globals_inst.State := 1536
							if ((a_options___0).bit_and (64)).to_boolean then
								if l_toshell_fd >= 0 then
									l_wpid := fork
									if l_wpid = -1 then
										message_inst.msg_puts (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("%NCannot fork%N")))))
									elseif l_wpid = 0 then
										l_lnum := globals_inst.curbuf.item.b_op_start.lnum
										l_written := 0
										l_lp.ce_gets ((memline_inst.ml_get (l_lnum)))
										close (l_fromshell_fd).do_nothing
										from
										until
											js.loop_left
										loop
											js.reset
											l_l := strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((l_lp + l_written)))
											if l_l = {NATURAL_32} 0 then
												l_len := 0
											elseif (l_lp[l_written]).to_integer_32 = 10 then
												l_len := write (l_toshell_fd, create {CE_POINTER [ANY]}.make_cast (ce_string ("")), (1).to_natural_32)
											else
												l_s.ce_gets (misc2_inst.vim_strchr (l_lp + l_written, ('%N').code))
												if (l_s.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
													l_tmp___10 := l_l
												else
													l_tmp___10 := (l_s.distance ((l_lp + l_written))).to_natural_32
												end
												l_len := write (l_toshell_fd, create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [INTEGER_8]}.make_cast (l_lp) + l_written)), l_tmp___10)
											end
											if l_len = l_l.to_integer_32 then
												if l_lnum /= globals_inst.curbuf.item.b_op_end.lnum then
													globals_inst.ignored := write (l_toshell_fd, create {CE_POINTER [ANY]}.make_cast (ce_string ("%N")), (1).to_natural_32)
												elseif not (globals_inst.curbuf.item.b_p_bin).to_boolean then
													globals_inst.ignored := write (l_toshell_fd, create {CE_POINTER [ANY]}.make_cast (ce_string ("%N")), (1).to_natural_32)
												elseif l_lnum /= globals_inst.write_no_eol_lnum then
													if l_lnum /= globals_inst.curbuf.item.b_ml.ml_line_count then
														globals_inst.ignored := write (l_toshell_fd, create {CE_POINTER [ANY]}.make_cast (ce_string ("%N")), (1).to_natural_32)
													elseif (globals_inst.curbuf.item.b_p_eol).to_boolean then
														globals_inst.ignored := write (l_toshell_fd, create {CE_POINTER [ANY]}.make_cast (ce_string ("%N")), (1).to_natural_32)
													end
												end
												l_lnum := l_lnum + 1
												if l_lnum > globals_inst.curbuf.item.b_op_end.lnum then
													close (l_toshell_fd).do_nothing
													l_toshell_fd := -1
													js.break
												end
												if not js.loop_jumped then
													l_lp.ce_gets (memline_inst.ml_get (l_lnum))
													l_written := 0
												end
											elseif l_len > 0 then
												l_written := l_written + l_len
											end
										end
										js.reset
										exit2 (0)
									else
										close (l_toshell_fd).do_nothing
										l_toshell_fd := -1
									end
								end
							end
							if ((a_options___0).bit_and (32)).to_boolean then
								misc2_inst.ga_init2 (l_ga.address, 1, 100)
							end
							l_noread_cnt := 0
							gettimeofday ((l_start_tv.address), create {CE_POINTER [SD_TIMEZONE]}.make_shared (default_pointer)).do_nothing
				when 40 then -- loop condition:
							if js.loop_left then
								l_pos := -1 + 96 -- skip loop
							end
				when 41 then -- loop body:
							js.reset
							l_len := 0
							if ((a_options___0).bit_and (2)).to_boolean then
								l_pos := -1 + 84 -- skip if block
							end
				when 42 then -- if:
							if ((a_options___0).bit_and (100)) = 100 then
								l_pos := -1 + 45 -- skip if block
							end
				when 43 then -- if:
							l_pos := -1 + 46 -- goto _L___9
				when 44 then -- if block done, skip else block:
							l_pos := -1 + 84
				when 45 then -- else:
							if not ((gui_inst.gui.in_use).to_boolean) then
								l_pos := -1 + 84 -- skip if block
							end
				when 46 then -- if: | _L___9:
							if l_wait_pid /= 0 then
								l_pos := -1 + 84 -- skip if block
							end
				when 47 then -- if:
							if not (l_ta_len___0 > 0) then
								l_pos := -1 + 50 -- skip if block
							end
				when 48 then -- if:
							l_pos := -1 + 51 -- goto _L___8
				when 49 then -- if block done, skip else block:
							l_pos := -1 + 84
				when 50 then -- else:
							if not (l_noread_cnt > 4) then
								l_pos := -1 + 84 -- skip if block
							end
				when 51 then -- if: | _L___8:
							if l_ta_len___0 = 0 then
								l_noread_cnt := 0
								gettimeofday ((l_start_tv.address), create {CE_POINTER [SD_TIMEZONE]}.make_shared (default_pointer)).do_nothing
								l_len := ui_inst.ui_inchar (l_ta_buf, 100, 10, 0)
							end
							if not (l_ta_len___0 > 0) then
								l_pos := -1 + 54 -- skip if block
							end
				when 52 then -- if:
							l_pos := -1 + 55 -- goto _L___7
				when 53 then -- if block done, skip else block:
							l_pos := -1 + 84
				when 54 then -- else:
							if not (l_len > 0) then
								l_pos := -1 + 84 -- skip if block
							end
				when 55 then -- if: | _L___7:
							if l_len /= 1 then
								l_pos := -1 + 66 -- skip if block
							end
				when 56 then -- if:
							if not (l_pty_master_fd < 0) then
								l_pos := -1 + 59 -- skip if block
							end
				when 57 then -- if:
							l_pos := -1 + 60 -- goto _L___4
				when 58 then -- if block done, skip else block:
							l_pos := -1 + 66
				when 59 then -- else:
							if (a_cmd.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								l_pos := -1 + 66 -- skip if block
							end
				when 60 then -- if: | _L___4:
							if (l_ta_buf[l_ta_len___0]).to_integer_32 /= 3 then
								l_pos := -1 + 63 -- skip if block
							end
				when 61 then -- if:
							l_pos := -1 + 64 -- goto _L___3
				when 62 then -- if block done, skip else block:
							l_pos := -1 + 65
				when 63 then -- else:
							if (l_ta_buf[l_ta_len___0]).to_integer_32 /= globals_inst.intr_char then
								l_pos := -1 + 65 -- skip if block
							end
				when 64 then -- if: | _L___3:
							kill (-l_pid, 2).do_nothing
							if l_wpid > 0 then
								kill (l_wpid, 2).do_nothing
							end
				when 65 then -- if done
							if l_pty_master_fd < 0 then
								if l_toshell_fd >= 0 then
									if (l_ta_buf[l_ta_len___0]).to_integer_32 = 4 then
										close (l_toshell_fd).do_nothing
										l_toshell_fd := -1
									end
								end
							end
				when 66 then -- if done | if done
							l_i___0 := l_ta_len___0
				when 67 then -- loop condition:
							if not (l_i___0 < l_ta_len___0 + l_len) then
								l_pos := -1 + 83 -- skip loop
							end
				when 68 then -- loop body:
							if (l_ta_buf[l_i___0]).to_integer_32 /= 155 then
								l_pos := -1 + 81 -- skip if block
							end
				when 69 then -- if:
							if not (l_len - l_i___0 > 2) then
								l_pos := -1 + 79 -- skip if block
							end
				when 70 then -- if:
							l_c := -((l_ta_buf[l_i___0 + 1]).to_integer_32 + (((l_ta_buf[l_i___0 + 2]).to_integer_32).bit_shift_left (8)))
							if l_c /= -(107 + ((68).bit_shift_left (8))) then
								l_pos := -1 + 73 -- skip if block
							end
				when 71 then -- if:
							l_pos := -1 + 77 -- goto _L___5
				when 72 then -- if block done, skip else block:
							l_pos := -1 + 78
				when 73 then -- else:
							if l_c /= -(253 + ((80).bit_shift_left (8))) then
								l_pos := -1 + 76 -- skip if block
							end
				when 74 then -- if:
							l_pos := -1 + 77 -- goto _L___5
				when 75 then -- if block done, skip else block:
							l_pos := -1 + 78
				when 76 then -- else:
							if l_c /= -(107 + ((98).bit_shift_left (8))) then
								l_pos := -1 + 78 -- skip if block
							end
				when 77 then -- if: | _L___5:
							memmove (create {CE_POINTER [ANY]}.make_cast (((l_ta_buf + l_i___0) + 1)), create {CE_POINTER [ANY]}.make_cast (((l_ta_buf + l_i___0) + 3)), ((l_len - l_i___0) - 2).to_natural_32).do_nothing
							if l_c = -(107 + ((68).bit_shift_left (8))) then
								l_ta_buf[l_i___0] := (127).to_natural_8
							elseif l_c = -(253 + ((80).bit_shift_left (8))) then
								l_ta_buf[l_i___0] := (127).to_natural_8
							else
								l_ta_buf[l_i___0] := (8).to_natural_8
							end
							l_len := l_len - (2)
				when 78 then -- if done | if done | if done | if block done, skip else block:
							l_pos := -1 + 80
				when 79 then -- else:
							l_pos := -1 + 81 -- goto _L___6
				when 80 then -- if done | if block done, skip else block:
							l_pos := -1 + 82
				when 81 then -- else: | _L___6:
							if (l_ta_buf[l_i___0]).to_integer_32 = 13 then
								l_ta_buf[l_i___0] := (('%N').code).to_natural_8
							end
				when 82 then
							if globals_inst.has_mbyte.to_boolean then
								l_i___0 := l_i___0 + ((globals_inst.mb_ptr2len_len.integer_32_item ([l_ta_buf + l_i___0, (l_ta_len___0 + l_len) - l_i___0])) - 1)
							end
							l_i___0 := l_i___0 + 1
							l_pos := -1 + 67 -- back to loop condition
				when 83 then -- loop done
							if l_pty_master_fd < 0 then
								l_i___0 := l_ta_len___0
								from
								until
									not (l_i___0 < l_ta_len___0 + l_len)
								loop
									if (l_ta_buf[l_i___0]).to_integer_32 = 10 then
										message_inst.msg_putchar ((l_ta_buf[l_i___0]).to_integer_32)
									elseif (l_ta_buf[l_i___0]).to_integer_32 = 8 then
										message_inst.msg_putchar ((l_ta_buf[l_i___0]).to_integer_32)
									elseif globals_inst.has_mbyte.to_boolean then
										l_l___0 := (globals_inst.mb_ptr2len.integer_32_item ([l_ta_buf + l_i___0]))
										message_inst.msg_outtrans_len (l_ta_buf + l_i___0, l_l___0).do_nothing
										l_i___0 := l_i___0 + (l_l___0 - 1)
									else
										message_inst.msg_outtrans_len (l_ta_buf + l_i___0, 1).do_nothing
									end
									l_i___0 := l_i___0 + 1
								end
								screen_inst.windgoto (globals_inst.msg_row, globals_inst.msg_col)
								term_inst.out_flush
							end
							l_ta_len___0 := l_ta_len___0 + l_len
							if ((a_options___0).bit_and (64)).to_boolean then
								l_ta_len___0 := 0
							elseif l_toshell_fd >= 0 then
								l_len := write (l_toshell_fd, create {CE_POINTER [ANY]}.make_cast (l_ta_buf), (1).to_natural_32)
								if l_len > 0 then
									l_ta_len___0 := l_ta_len___0 - l_len
									memmove (create {CE_POINTER [ANY]}.make_cast (l_ta_buf), create {CE_POINTER [ANY]}.make_cast ((l_ta_buf + l_len)), l_ta_len___0.to_natural_32).do_nothing
								end
							end
				when 84 then -- if done | if done | if done | if done | if done | if done | if done
							if globals_inst.got_int.to_boolean then
								kill (-l_pid, 2).do_nothing
								if l_wpid > 0 then
									kill (l_wpid, 2).do_nothing
								end
								globals_inst.got_int := 0
							end
							l_noread_cnt := l_noread_cnt + 1
				when 85 then -- loop condition:
							if js.loop_left then
								l_pos := -1 + 90 -- skip loop
							end
				when 86 then -- loop body:
							js.reset
							if not (RealWaitForChar (l_fromshell_fd, 10, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))).to_boolean then
								js.break
							end
							if js.loop_jumped then
								l_pos := -1 + 89 -- skip if block
							end
				when 87 then -- if:
							l_len := read (l_fromshell_fd, create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [INTEGER_8]}.make_cast (l_buffer) + l_buffer_off)), (100 - l_buffer_off).to_natural_32)
							if l_len <= 0 then
								l_pos := -1 + 97 -- goto finished
							end
				when 88 then
							l_noread_cnt := 0
							if ((a_options___0).bit_and (32)).to_boolean then
								l_i___0 := 0
								from
								until
									not (l_i___0 < l_len)
								loop
									if (l_buffer[l_i___0]).to_integer_32 = 10 then
										append_ga_line (l_ga.address)
									elseif (l_buffer[l_i___0]).to_integer_32 = 0 then
										misc2_inst.ga_append (l_ga.address, ('%N').code)
									else
										misc2_inst.ga_append (l_ga.address, (l_buffer[l_i___0]).to_integer_32)
									end
									l_i___0 := l_i___0 + 1
								end
							elseif globals_inst.has_mbyte.to_boolean then
								l_len := l_len + l_buffer_off
								l_buffer[l_len] := (('%/0/').code).to_natural_8
								l_p___0.ce_gets (l_buffer)
								from
								until
									not (not js.loop_left and then ((l_p___0.c_pointer.to_integer_32).to_natural_32 < ((l_buffer + l_len).c_pointer.to_integer_32).to_natural_32))
								loop
									js.reset
									if globals_inst.enc_utf8.to_boolean then
										l_l___1 := (mbyte_inst.utf_ptr2len (l_p___0))
									else
										l_l___1 := (globals_inst.mb_ptr2len.integer_32_item ([l_p___0]))
									end
									if l_l___1 = 0 then
										l_l___1 := 1
									elseif (globals_inst.mb_bytelen_tab[(l_p___0.item).to_integer_32]).to_integer_32 /= l_l___1 then
										js.break
									end
									if not js.loop_jumped then
										l_p___0.ce_gets (l_p___0 + l_l___1)
									end
								end
								js.reset
								if (l_p___0.c_pointer.to_integer_32).to_natural_32 = (l_buffer.c_pointer.to_integer_32).to_natural_32 then
									if l_len >= 12 then
										l_p___0.ce_gets (l_p___0 + 1)
									else
										l_buffer_off := l_len
										js.continue
									end
								end
								if not js.loop_jumped then
									l_c := (l_p___0.item).to_integer_32
									l_p___0.item := (('%/0/').code).to_natural_8
									message_inst.msg_puts (l_buffer)
									if (l_p___0.c_pointer.to_integer_32).to_natural_32 < ((l_buffer + l_len).c_pointer.to_integer_32).to_natural_32 then
										l_p___0.item := l_c.to_natural_8
										l_buffer_off := (l_buffer + l_len).distance (l_p___0)
										memmove (create {CE_POINTER [ANY]}.make_cast (l_buffer), create {CE_POINTER [ANY]}.make_cast (l_p___0), l_buffer_off.to_natural_32).do_nothing
										js.continue
									end
								end
								if not js.loop_jumped then
									l_buffer_off := 0
								end
							else
								l_buffer[l_len] := (('%/0/').code).to_natural_8
								message_inst.msg_puts (l_buffer)
							end
				when 89 then -- if done
							if not js.loop_jumped then
								screen_inst.windgoto (globals_inst.msg_row, globals_inst.msg_col)
								term_inst.cursor_on
								term_inst.out_flush
								if globals_inst.got_int.to_boolean then
									js.break
								end
							end
							if not js.loop_jumped then
								gettimeofday ((l_now_tv.address), create {CE_POINTER [SD_TIMEZONE]}.make_shared (default_pointer)).do_nothing
								l_msec := (l_now_tv.tv_sec - l_start_tv.tv_sec) * 1000 + (l_now_tv.tv_usec - l_start_tv.tv_usec) // 1000
								if l_msec > 2000 then
									l_noread_cnt := 5
									js.break
								end
							end
							l_pos := -1 + 85 -- back to loop condition
				when 90 then -- loop done
							js.reset
							if l_wait_pid = l_pid then
								js.break
							end
							if js.loop_jumped then
								l_pos := -1 + 95 -- skip if block
							end
				when 91 then -- if:
							l_wait_pid := waitpid (l_pid, create {CE_POINTER [INTEGER_32]}.make_shared ($l_status), 1)
							if l_wait_pid /= -1 then
								l_pos := -1 + 94 -- skip if block
							end
				when 92 then -- if:
							if (errno_location).item = 10 then
								l_wait_pid := l_pid
							else
								l_pos := -1 + 94 -- goto _L___10
							end
				when 93 then -- if block done, skip else block:
							l_pos := -1 + 95
				when 94 then -- else: | _L___10:
							if l_wait_pid = l_pid then
								l_constr_expr_0.in := l_status
								if ((l_constr_expr_0.i).bit_and (127)) = 0 then
									l_wait_pid := l_pid
								else
									l_wait_pid := 0
								end
							else
								l_wait_pid := 0
							end
				when 95 then -- if done
							l_pos := -1 + 40 -- back to loop condition
				when 96 then -- loop done
							js.reset
				when 97 then -- finished:
							option_inst.p_more := l_p_more_save
							if ((a_options___0).bit_and (32)).to_boolean then
								if l_ga.ga_len > 0 then
									append_ga_line (l_ga.address)
									globals_inst.write_no_eol_lnum := globals_inst.curwin.item.w_cursor.lnum
								else
									globals_inst.write_no_eol_lnum := (0).to_integer_32
								end
								misc2_inst.ga_clear (l_ga.address)
							end
							if l_ta_len___0.to_boolean then
								ui_inst.ui_inchar_undo (l_ta_buf, l_ta_len___0)
							end
							globals_inst.State := l_old_State
							if l_toshell_fd >= 0 then
								close (l_toshell_fd).do_nothing
							end
							close (l_fromshell_fd).do_nothing
				when 98 then -- if done | if done
							from
							until
								not (not js.loop_left and then (l_wait_pid /= l_pid))
							loop
								js.reset
								l_wait_pid := wait (create {CE_POINTER [SD_WAIT]}.make_cast ((create {CE_POINTER [INTEGER_32]}.make_shared ($l_status))))
								if l_wait_pid <= 0 then
									if (errno_location).item = 10 then
										js.break
									end
								end
							end
							js.reset
							if l_wpid > 0 then
								kill (l_wpid, 9).do_nothing
							end
							if l_tmode = 2 then
								term_inst.settmode (2)
							end
							l_did_settmode := 1
							set_signals
							l_constr_expr_2.in := l_status
							if ((l_constr_expr_2.i).bit_and (127)) = 0 then
								l_constr_expr_1.in := l_status
								l_retval := (((l_constr_expr_1.i).bit_and (65280))).bit_shift_right (8)
								if l_retval.to_boolean then
									if not globals_inst.emsg_silent.to_boolean then
										if l_retval = 122 then
											message_inst.msg_puts (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("%NCannot execute shell ")))))
											message_inst.msg_outtrans (option_inst.p_sh).do_nothing
											message_inst.msg_putchar (('%N').code)
										elseif not ((a_options___0).bit_and (16)).to_boolean then
											message_inst.msg_puts (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("%Nshell returned ")))))
											message_inst.msg_outnum (l_retval.to_integer_32)
											message_inst.msg_putchar (('%N').code)
										end
									end
								end
							else
								message_inst.msg_puts (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("%NCommand terminated%N")))))
							end
				when 99 then -- if done | if done
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_argv))
				when 100 then -- error:
							if not l_did_settmode.to_boolean then
								if l_tmode = 2 then
									term_inst.settmode (2)
								end
							end
							buffer_inst.resettitle
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_newcmd))
							Result := l_retval
				when 101 then
							l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
				end

	mch_breakcheck
		do
			if curr_tmode = 2 then
				if (RealWaitForChar (globals_inst.read_cmd_fd, 0, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))).to_boolean then
					ui_inst.fill_input_buf (0)
				end
			end
		end

	WaitForChar (a_msec: INTEGER_32): INTEGER_32
		local
			l_msec: INTEGER_32
			l_rest___0: INTEGER_32
			l_avail: INTEGER_32
			js: JUMP_STATE
		do
			l_msec := a_msec
			if (getchar_inst.input_available).to_boolean then
				Result := 1
				js.return
			end
			if not js.return_called then
				l_rest___0 := 0
				if (do_xterm_trace).to_boolean then
					l_rest___0 := l_msec.to_integer_32
				end
				from
				until
					js.loop_left
				loop
					js.reset
					if l_rest___0 /= 0 then
						l_msec := 50
						if l_rest___0 >= 0 then
							if l_rest___0 < 50 then
								l_msec := l_rest___0.to_integer_32
							end
						end
						if l_rest___0 >= 0 then
							l_rest___0 := (l_rest___0.to_integer_32 - l_msec).to_integer_32
						end
					end
					l_avail := RealWaitForChar (globals_inst.read_cmd_fd, l_msec, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
					if not l_avail.to_boolean then
						if (getchar_inst.input_available).to_boolean then
							Result := 1
							js.return
						end
						if not js.return_called then
							if l_rest___0 = 0 then
								js.break
							elseif not (do_xterm_trace).to_boolean then
								js.break
							end
						end
					end
					if not js.loop_jumped then
						if not l_avail.to_boolean then
							if l_rest___0 = 0 then
								js.break
							end
						else
							js.break
						end
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := l_avail
			end
		end

	RealWaitForChar (a_fd: INTEGER_32; a_msec: INTEGER_32; a_check_for_gpm: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_msec: INTEGER_32
			l_ret: INTEGER_32
			l_nb_fd: INTEGER_32
			l_start_tv: SD_TIMEVAL
			l_finished: INTEGER_32
			l_tv: SD_TIMEVAL
			l_tvp: CE_POINTER [SD_TIMEVAL]
			l_rfds: SD_FD_SET
			l_efds: SD_FD_SET
			l_maxfd: INTEGER_32
			l_towait: INTEGER_32
			l_d0: INTEGER_32
			l_d1: INTEGER_32
			l_d0___0: INTEGER_32
			l_d1___0: INTEGER_32
			l_result: INTEGER_8
			l_result___0: INTEGER_8
			l_result___1: INTEGER_8
			l_result___2: INTEGER_8
			l_mtv: SD_TIMEVAL
			js: JUMP_STATE
		do
			create l_start_tv.make
			create l_tv.make
			create l_tvp.make
			create l_rfds.make
			create l_efds.make
			create l_mtv.make

			l_msec := a_msec
			l_nb_fd := (netbeans_inst.netbeans_filedesc)
			if l_msec > 0 then
				if (xterm_Shell.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					gettimeofday ((l_start_tv.address), create {CE_POINTER [SD_TIMEZONE]}.make_shared (default_pointer)).do_nothing
				elseif globals_inst.xsmp_icefd /= -1 then
					gettimeofday ((l_start_tv.address), create {CE_POINTER [SD_TIMEZONE]}.make_shared (default_pointer)).do_nothing
				end
			end
			if busy___0.to_boolean then
				Result := 0
				js.return
			end
			if not js.return_called then
				from
				until
					js.loop_left
				loop
					js.reset
					l_finished := 1
					l_towait := l_msec
					if l_towait >= 0 then
						l_tv.tv_sec := l_towait // 1000
						l_tv.tv_usec := (l_towait \\ 1000) * 1000
						l_tvp.ce_gets (l_tv.address)
					else
						l_tvp.ce_gets (create {CE_POINTER [SD_TIMEVAL]}.make_shared (default_pointer))
					end
					from
					until
						js.loop_left
					loop
						js.reset
						asm3 (create {CE_POINTER [INTEGER_32]}.make_shared ($l_d0), create {CE_POINTER [INTEGER_32]}.make_shared ($l_d1), l_rfds.address)
						js.break
					end
					js.reset
					from
					until
						js.loop_left
					loop
						js.reset
						asm4 (create {CE_POINTER [INTEGER_32]}.make_shared ($l_d0___0), create {CE_POINTER [INTEGER_32]}.make_shared ($l_d1___0), l_efds.address)
						js.break
					end
					js.reset
					asm5 (l_rfds.address, create {CE_POINTER [INTEGER_32]}.make_shared ($a_fd))
					asm6 (l_efds.address, create {CE_POINTER [INTEGER_32]}.make_shared ($a_fd))
					l_maxfd := a_fd
					if (xterm_Shell.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						asm7 (l_rfds.address, globals_inst.xterm_dpy.address)
						if l_maxfd < (create {CE_POINTER [SD_XPRIVDISPLAY]}.make_cast (globals_inst.xterm_dpy)).item.fd then
							l_maxfd := (create {CE_POINTER [SD_XPRIVDISPLAY]}.make_cast (globals_inst.xterm_dpy)).item.fd
						end
					end
					if globals_inst.xsmp_icefd /= -1 then
						asm8 (l_rfds.address, globals_inst.xsmp_icefd_address)
						asm9 (l_efds.address, globals_inst.xsmp_icefd_address)
						if l_maxfd < globals_inst.xsmp_icefd then
							l_maxfd := globals_inst.xsmp_icefd
						end
					end
					if l_nb_fd /= -1 then
						asm10 (l_rfds.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_nb_fd))
						if l_maxfd < l_nb_fd then
							l_maxfd := l_nb_fd
						end
					end
					l_ret := select2 (l_maxfd + 1, l_rfds.address, create {CE_POINTER [SD_FD_SET]}.make_shared (default_pointer), l_efds.address, l_tvp)
					if l_ret > 0 then
						if (xterm_Shell.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							asm11 (create {CE_POINTER [INTEGER_8]}.make_shared ($l_result), globals_inst.xterm_dpy.address, l_rfds.address)
							if l_result.to_boolean then
								xterm_update
								l_ret := l_ret - 1
								if l_ret = 0 then
									if not (getchar_inst.input_available).to_boolean then
										l_finished := 0
									end
								end
							end
						end
					end
					if l_ret > 0 then
						if globals_inst.xsmp_icefd /= -1 then
							asm12 (create {CE_POINTER [INTEGER_8]}.make_shared ($l_result___1), globals_inst.xsmp_icefd_address, l_efds.address)
							if l_result___1.to_boolean then
								if option_inst.p_verbose > 0 then
									message_inst.verb_msg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("XSMP lost ICE connection"))))).do_nothing
								end
								xsmp_close
								l_ret := l_ret - 1
								if l_ret = 0 then
									l_finished := 0
								end
							else
								asm13 (create {CE_POINTER [INTEGER_8]}.make_shared ($l_result___0), globals_inst.xsmp_icefd_address, l_rfds.address)
								if l_result___0.to_boolean then
									busy___0 := 1
									xsmp_handle_requests.do_nothing
									busy___0 := 0
									l_ret := l_ret - 1
									if l_ret = 0 then
										l_finished := 0
									end
								end
							end
						end
					end
					if l_ret > 0 then
						if l_nb_fd /= -1 then
							asm14 (create {CE_POINTER [INTEGER_8]}.make_shared ($l_result___2), create {CE_POINTER [INTEGER_32]}.make_shared ($l_nb_fd), l_rfds.address)
							if l_result___2.to_boolean then
								netbeans_inst.netbeans_read
								l_ret := l_ret - 1
							end
						end
					end
					if l_finished.to_boolean then
						js.break
					elseif l_msec = 0 then
						js.break
					end
					if not js.loop_jumped and then (l_msec > 0) then
						gettimeofday ((l_mtv.address), create {CE_POINTER [SD_TIMEZONE]}.make_shared (default_pointer)).do_nothing
						l_msec := l_msec - ((l_mtv.tv_sec - l_start_tv.tv_sec) * 1000 + (l_mtv.tv_usec - l_start_tv.tv_usec) // 1000)
						if l_msec <= 0 then
							js.break
						end
					end
				end
				js.reset
				Result := (l_ret > 0).to_integer
			end
		end

	mch_expandpath (a_gap: CE_POINTER [PD_GROWARRAY]; a_path: CE_POINTER [NATURAL_8]; a_flags___0: INTEGER_32): INTEGER_32
		do
			Result := (misc1_inst.unix_expandpath (a_gap, a_path, 0, a_flags___0, 0))
		end

	mch_expand_wildcards (a_num_pat: INTEGER_32; a_pat: CE_POINTER [CE_POINTER [NATURAL_8]]; a_num_file: CE_POINTER [INTEGER_32]; a_file: CE_POINTER [CE_POINTER [CE_POINTER [NATURAL_8]]]; a_flags___0: INTEGER_32): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_len: NATURAL_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_dir___0: INTEGER_32
			l_j: INTEGER_32
			l_tempname: CE_POINTER [NATURAL_8]
			l_command: CE_POINTER [NATURAL_8]
			l_fd: CE_POINTER [SD_IO_FILE]
			l_buffer: CE_POINTER [NATURAL_8]
			l_shell_style: INTEGER_32
			l_check_spaces: INTEGER_32
			l_ampersent: INTEGER_32
			l_tmp___14: CE_POINTER [NATURAL_8]
			l_intick: INTEGER_32
			l_tmp___16: CE_POINTER [NATURAL_8]
			l_tmp___17: CE_POINTER [NATURAL_8]
			l_tmp___19: CE_POINTER [NATURAL_8]
			l_tmp___21: CE_POINTER [NATURAL_8]
			l_tmp___30: CE_POINTER [NATURAL_8]
			l_tmp___34: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p___0.make
			create l_tempname.make
			create l_command.make
			create l_fd.make
			create l_buffer.make
			create l_tmp___14.make
			create l_tmp___16.make
			create l_tmp___17.make
			create l_tmp___19.make
			create l_tmp___21.make
			create l_tmp___30.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_shell_style := 0
					l_ampersent := 0
					a_num_file.item := 0
					a_file.item := create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer)
					if not (have_wildcard (a_num_pat, a_pat)).to_boolean then
						Result := (save_patterns (a_num_pat, a_pat, a_num_file, a_file))
						js.return
					end
					if not js.return_called and then (globals_inst.sandbox /= 0) then
						if (ex_cmds_inst.check_secure).to_boolean then
							Result := 0
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if not (globals_inst.secure.to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if not (globals_inst.restricted.to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						l_i___0 := 0
						from
						until
							not (not js.loop_left and then (l_i___0 < a_num_pat))
						loop
							if ((misc2_inst.vim_strchr (a_pat[l_i___0], ('`').code)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								if (ex_cmds_inst.check_restricted).to_boolean then
									Result := 0
									js.return
								elseif (ex_cmds_inst.check_secure).to_boolean then
									Result := 0
									js.return
								end
							end
							if not js.return_called then
								l_i___0 := l_i___0 + 1
							end
						end
				when 6 then -- if done | if done
						if not js.return_called then
							l_tempname.ce_gets (fileio_inst.vim_tempname (('o').code))
							if (l_tempname.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_notmp))))).do_nothing
								Result := 0
								js.return
							end
						end
						if js.return_called then
							l_pos := -1 + 12 -- skip if block
						end
				when 7 then -- if:
							if a_num_pat /= 1 then
								l_pos := -1 + 10 -- skip if block
							end
				when 8 then -- if:
							if ((a_pat[0]).item).to_integer_32 = 96 then
								l_len := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_pat[0]))
								if l_len > {NATURAL_32} 2 then
									if ((a_pat[0] + l_len.to_integer_32)[-1]).to_integer_32 = 96 then
										l_shell_style := 4
									else
										l_pos := -1 + 10 -- goto _L___2
									end
								else
									l_pos := -1 + 10 -- goto _L___2
								end
							else
								l_pos := -1 + 10 -- goto _L___2
							end
				when 9 then -- if block done, skip else block:
							l_pos := -1 + 11
				when 10 then -- else: | _L___2:
							l_len := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (option_inst.p_sh))
							if l_len >= {NATURAL_32} 3 then
								if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (((option_inst.p_sh + l_len.to_integer_32) - 3)), ce_string ("csh"))) = 0 then
									l_shell_style := 1
								elseif (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (((option_inst.p_sh + l_len.to_integer_32) - 3)), ce_string ("zsh"))) = 0 then
									l_shell_style := 3
								end
							end
				when 11 then
							if l_shell_style = 0 then
								if ((strstr (create {CE_POINTER [INTEGER_8]}.make_cast ((misc1_inst.gettail (option_inst.p_sh))), ce_string ("sh"))).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									l_shell_style := 2
								end
							end
							l_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_tempname))) + {NATURAL_32} 29
							if l_shell_style = 2 then
								l_len := l_len + (strlen (sh_vimglob_func))
							end
							l_i___0 := 0
							from
							until
								not (not js.loop_left and then (l_i___0 < a_num_pat))
							loop
								l_len := l_len + 1
								l_j := 0
								from
								until
									((a_pat[l_i___0])[l_j]).to_integer_32 = 0
								loop
									if ((misc2_inst.vim_strchr (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%T %"&%'$;<>()\|")), ((a_pat[l_i___0])[l_j]).to_integer_32)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
										l_len := l_len + 1
									end
									l_len := l_len + 1
									l_j := l_j + 1
								end
								l_i___0 := l_i___0 + 1
							end
							l_command.ce_gets (misc2_inst.alloc (l_len))
							if (l_command.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_tempname))
								Result := 0
								js.return
							end
				when 12 then -- if done
						if js.return_called then
							l_pos := -1 + 28 -- skip if block
						end
				when 13 then -- if:
							if l_shell_style = 4 then
								strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_command), ce_string ("(")).do_nothing
								strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_command), create {CE_POINTER [INTEGER_8]}.make_cast ((a_pat[0] + 1))).do_nothing
								l_p___0.ce_gets ((l_command + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_command))).to_integer_32) - 1)
								l_tmp___14.ce_gets (l_p___0)
								l_p___0.ce_gets (l_p___0 - 1)
								l_tmp___14.item := ((')').code).to_natural_8
								from
								until
									js.loop_left
								loop
									js.reset
									if (l_p___0.c_pointer.to_integer_32).to_natural_32 > (l_command.c_pointer.to_integer_32).to_natural_32 then
										if (l_p___0.item).to_integer_32 /= 32 then
											if (l_p___0.item).to_integer_32 /= 9 then
												js.break
											end
										end
									else
										js.break
									end
									if not js.loop_jumped then
										l_p___0.ce_gets (l_p___0 - 1)
									end
								end
								js.reset
								if (l_p___0.item).to_integer_32 = 38 then
									l_ampersent := 1
									l_p___0.item := ((' ').code).to_natural_8
								end
								strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_command), ce_string (">")).do_nothing
							else
								if ((a_flags___0).bit_and (4)).to_boolean then
									strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_command), ce_string ("set nonomatch; ")).do_nothing
								else
									strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_command), ce_string ("unset nonomatch; ")).do_nothing
								end
								if l_shell_style = 1 then
									strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_command), ce_string ("glob >")).do_nothing
								elseif l_shell_style = 3 then
									strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_command), ce_string ("print -N >")).do_nothing
								elseif l_shell_style = 2 then
									strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_command), sh_vimglob_func).do_nothing
								else
									strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_command), ce_string ("echo >")).do_nothing
								end
							end
							strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_command), create {CE_POINTER [INTEGER_8]}.make_cast (l_tempname)).do_nothing
							if l_shell_style = 4 then
								l_pos := -1 + 27 -- skip if block
							end
				when 14 then -- if:
							l_i___0 := 0
				when 15 then -- loop condition:
							if not (not js.loop_left and then (l_i___0 < a_num_pat)) then
								l_pos := -1 + 27 -- skip loop
							end
				when 16 then -- loop body:
							l_intick := 0
							l_p___0.ce_gets (l_command + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_command))).to_integer_32)
							l_tmp___16.ce_gets (l_p___0)
							l_p___0.ce_gets (l_p___0 + 1)
							l_tmp___16.item := ((' ').code).to_natural_8
							l_j := 0
				when 17 then -- loop condition:
							if ((a_pat[l_i___0])[l_j]).to_integer_32 = 0 then
								l_pos := -1 + 26 -- skip loop
							end
				when 18 then -- loop body:
							if ((a_pat[l_i___0])[l_j]).to_integer_32 /= 96 then
								l_pos := -1 + 21 -- skip if block
							end
				when 19 then -- if:
							l_intick := (not l_intick.to_boolean).to_integer
				when 20 then -- if block done, skip else block:
							l_pos := -1 + 25
				when 21 then -- else:
							if ((a_pat[l_i___0])[l_j]).to_integer_32 /= 92 then
								l_pos := -1 + 24 -- skip if block
							end
				when 22 then -- if:
							if ((a_pat[l_i___0])[(l_j + 1)]).to_integer_32 /= 0 then
								if l_intick.to_boolean then
									l_tmp___17.ce_gets (l_p___0)
									l_p___0.ce_gets (l_p___0 + 1)
									l_tmp___17.item := (('\').code).to_natural_8
								elseif ((misc2_inst.vim_strchr (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%T %"&%'$;<>()\|")), ((a_pat[l_i___0])[(l_j + 1)]).to_integer_32)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									l_tmp___17.ce_gets (l_p___0)
									l_p___0.ce_gets (l_p___0 + 1)
									l_tmp___17.item := (('\').code).to_natural_8
								elseif ((a_pat[l_i___0])[(l_j + 1)]).to_integer_32 = 96 then
									l_tmp___17.ce_gets (l_p___0)
									l_p___0.ce_gets (l_p___0 + 1)
									l_tmp___17.item := (('\').code).to_natural_8
								end
								l_j := l_j + 1
							else
								l_pos := -1 + 24 -- goto _L___3
							end
				when 23 then -- if block done, skip else block:
							l_pos := -1 + 25
				when 24 then -- else: | _L___3:
							if not l_intick.to_boolean then
								if ((misc2_inst.vim_strchr (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%T %"&%'$;<>()\|")), ((a_pat[l_i___0])[l_j]).to_integer_32)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									l_tmp___19.ce_gets (l_p___0)
									l_p___0.ce_gets (l_p___0 + 1)
									l_tmp___19.item := (('\').code).to_natural_8
								end
							end
				when 25 then -- if done
							l_tmp___21.ce_gets (l_p___0)
							l_p___0.ce_gets (l_p___0 + 1)
							l_tmp___21.item := (a_pat[l_i___0])[l_j]
							l_j := l_j + 1
							l_pos := -1 + 17 -- back to loop condition
				when 26 then -- loop done
							l_p___0.item := (('%/0/').code).to_natural_8
							l_i___0 := l_i___0 + 1
							l_pos := -1 + 15 -- back to loop condition
				when 27 then -- loop done | if done
							if ((a_flags___0).bit_and (32)).to_boolean then
								show_shell_mess := 0
							end
							if l_ampersent.to_boolean then
								strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_command), ce_string ("&")).do_nothing
							end
							if l_shell_style = 3 then
								extra_shell_arg.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("-G")))
							elseif l_shell_style = 1 then
								if not (have_dollars (a_num_pat, a_pat)).to_boolean then
									extra_shell_arg.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("-f")))
								end
							end
							l_i___0 := misc2_inst.call_shell (l_command, 18)
							if l_ampersent.to_boolean then
								mch_delay (10, 1)
							end
							extra_shell_arg.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							show_shell_mess := 1
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_command))
							if l_i___0 /= 0 then
								unlink (create {CE_POINTER [INTEGER_8]}.make_cast (l_tempname)).do_nothing
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_tempname))
								if not ((a_flags___0).bit_and (32)).to_boolean then
									screen_inst.redraw_later_clear
									message_inst.msg_putchar (('%N').code)
									globals_inst.cmdline_row := (globals_inst.Rows - 1).to_integer_32
									message_inst.msg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_wildexpand))))).do_nothing
									message_inst.msg_start
								end
								if l_shell_style = 4 then
									Result := 0
									js.return
								end
								if not js.return_called then
									l_pos := -1 + 75 -- goto notfound
								end
							end
				when 28 then
						if js.return_called then
							l_pos := -1 + 31 -- skip if block
						end
				when 29 then -- if:
							l_fd.ce_gets (fopen (create {CE_POINTER [INTEGER_8]}.make_cast (l_tempname), ce_string ("r")))
							if (l_fd.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								if not ((a_flags___0).bit_and (32)).to_boolean then
									message_inst.msg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_wildexpand))))).do_nothing
									message_inst.msg_start
								end
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_tempname))
								l_pos := -1 + 75 -- goto notfound
							end
				when 30 then
							fseek (l_fd, 0, 2).do_nothing
							l_len := (ftell (l_fd)).to_natural_32
							fseek (l_fd, 0, 0).do_nothing
							l_buffer.ce_gets (misc2_inst.alloc (l_len + {NATURAL_32} 1))
							if (l_buffer.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								unlink (create {CE_POINTER [INTEGER_8]}.make_cast (l_tempname)).do_nothing
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_tempname))
								fclose (l_fd).do_nothing
								Result := 0
								js.return
							end
				when 31 then -- if done
						if not js.return_called then
							l_i___0 := (fread (create {CE_POINTER [ANY]}.make_cast (l_buffer), (1).to_natural_32, l_len, l_fd)).to_integer_32
							fclose (l_fd).do_nothing
							unlink (create {CE_POINTER [INTEGER_8]}.make_cast (l_tempname)).do_nothing
							if l_i___0 /= l_len.to_integer_32 then
								message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_notread)))), l_tempname).do_nothing
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_tempname))
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_buffer))
								Result := 0
								js.return
							end
						end
						if js.return_called then
							l_pos := -1 + 44 -- skip if block
						end
				when 32 then -- if:
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_tempname))
							if l_shell_style /= 0 then
								l_pos := -1 + 35 -- skip if block
							end
				when 33 then -- if:
							l_buffer[l_len.to_integer_32] := (('%N').code).to_natural_8
							l_p___0.ce_gets (l_buffer)
							l_i___0 := 0
							from
							until
								not (not js.loop_left and then ((l_p___0.item).to_integer_32 /= 10))
							loop
								from
								until
									js.loop_left
								loop
									js.reset
									if (l_p___0.item).to_integer_32 /= 32 then
										if (l_p___0.item).to_integer_32 = 10 then
											js.break
										end
									else
										js.break
									end
									if not js.loop_jumped then
										l_p___0.ce_gets (l_p___0 + 1)
									end
								end
								js.reset
								l_p___0.ce_gets (charset_inst.skipwhite (l_p___0))
								l_i___0 := l_i___0 + 1
							end
				when 34 then -- if block done, skip else block:
							l_pos := -1 + 42
				when 35 then -- else:
							if l_shell_style /= 4 then
								l_pos := -1 + 38 -- skip if block
							end
				when 36 then -- if:
							l_pos := -1 + 39 -- goto _L___4
				when 37 then -- if block done, skip else block:
							l_pos := -1 + 42
				when 38 then -- else:
							if l_shell_style /= 2 then
								l_pos := -1 + 41 -- skip if block
							end
				when 39 then -- if: | _L___4:
							l_buffer[l_len.to_integer_32] := (('%/0/').code).to_natural_8
							l_p___0.ce_gets (l_buffer)
							l_i___0 := 0
							from
							until
								not (not js.loop_left and then ((l_p___0.item).to_integer_32 /= 0))
							loop
								from
								until
									js.loop_left
								loop
									js.reset
									if (l_p___0.item).to_integer_32 /= 10 then
										if (l_p___0.item).to_integer_32 = 0 then
											js.break
										end
									else
										js.break
									end
									if not js.loop_jumped then
										l_p___0.ce_gets (l_p___0 + 1)
									end
								end
								js.reset
								if (l_p___0.item).to_integer_32 /= 0 then
									l_p___0.ce_gets (l_p___0 + 1)
								end
								l_p___0.ce_gets (charset_inst.skipwhite (l_p___0))
								l_i___0 := l_i___0 + 1
							end
				when 40 then -- if block done, skip else block:
							l_pos := -1 + 42
				when 41 then -- else:
							l_check_spaces := 0
							if l_shell_style = 3 then
								if not did_find_nul.to_boolean then
									if l_len.to_boolean then
										if (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_buffer))).to_integer_32 < l_len.to_integer_32 - 1 then
											did_find_nul := 1
										else
											l_check_spaces := 1
										end
									else
										l_check_spaces := 1
									end
								end
							end
							if l_len.to_boolean then
								if (l_buffer[(l_len - {NATURAL_32} 1).to_integer_32]).to_integer_32 = 0 then
									l_len := l_len - 1
								else
									l_buffer[l_len.to_integer_32] := (('%/0/').code).to_natural_8
								end
							else
								l_buffer[l_len.to_integer_32] := (('%/0/').code).to_natural_8
							end
							l_i___0 := 0
							l_p___0.ce_gets (l_buffer)
							from
							until
								not ((l_p___0.c_pointer.to_integer_32).to_natural_32 < ((l_buffer + l_len.to_integer_32).c_pointer.to_integer_32).to_natural_32)
							loop
								if (l_p___0.item).to_integer_32 = 0 then
									l_i___0 := l_i___0 + 1
									l_p___0.item := (('%/0/').code).to_natural_8
								elseif (l_p___0.item).to_integer_32 = 32 then
									if l_check_spaces.to_boolean then
										l_i___0 := l_i___0 + 1
										l_p___0.item := (('%/0/').code).to_natural_8
									end
								end
								l_p___0.ce_gets (l_p___0 + 1)
							end
							if l_len.to_boolean then
								l_i___0 := l_i___0 + 1
							end
				when 42 then -- if done | if done
							if l_i___0 = 0 then
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_buffer))
								l_pos := -1 + 75 -- goto notfound
							end
				when 43 then
							a_num_file.item := l_i___0
							a_file.item := create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast ((misc2_inst.alloc (Pointer_bytes.to_natural_32 * l_i___0.to_natural_32)))
							if ((a_file.item).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_buffer))
								Result := 0
								js.return
							end
				when 44 then -- if done
						if js.return_called then
							l_pos := -1 + 74 -- skip if block
						end
				when 45 then -- if:
							l_p___0.ce_gets (l_buffer)
							l_i___0 := 0
				when 46 then -- loop condition:
							if not (not js.loop_left and then (l_i___0 < a_num_file.item)) then
								l_pos := -1 + 64 -- skip loop
							end
				when 47 then -- loop body:
							a_file.item[l_i___0] := l_p___0
							if l_shell_style /= 0 then
								l_pos := -1 + 50 -- skip if block
							end
				when 48 then -- if:
							l_pos := -1 + 54 -- goto _L___6
				when 49 then -- if block done, skip else block:
							l_pos := -1 + 63
				when 50 then -- else:
							if l_shell_style /= 4 then
								l_pos := -1 + 53 -- skip if block
							end
				when 51 then -- if:
							l_pos := -1 + 54 -- goto _L___6
				when 52 then -- if block done, skip else block:
							l_pos := -1 + 63
				when 53 then -- else:
							if l_shell_style /= 2 then
								l_pos := -1 + 62 -- skip if block
							end
				when 54 then -- if: | _L___6:
							if js.loop_left then
								l_pos := -1 + 60 -- skip loop
							end
				when 55 then -- loop body:
							js.reset
							if l_shell_style /= 0 then
								l_pos := -1 + 58 -- skip if block
							end
				when 56 then -- if:
							if (l_p___0.item).to_integer_32 = 32 then
								js.break
							else
								l_pos := -1 + 58 -- goto _L___5
							end
				when 57 then -- if block done, skip else block:
							l_pos := -1 + 59
				when 58 then -- else: | _L___5:
							if (l_p___0.item).to_integer_32 /= 10 then
								if (l_p___0.item).to_integer_32 = 0 then
									js.break
								end
							else
								js.break
							end
				when 59 then
							if not js.loop_jumped then
								l_p___0.ce_gets (l_p___0 + 1)
							end
							l_pos := -1 + 54 -- back to loop condition
				when 60 then -- loop done
							js.reset
							if (l_p___0.c_pointer.to_integer_32).to_natural_32 = ((l_buffer + l_len.to_integer_32).c_pointer.to_integer_32).to_natural_32 then
								l_p___0.item := (('%/0/').code).to_natural_8
							else
								l_tmp___30.ce_gets (l_p___0)
								l_p___0.ce_gets (l_p___0 + 1)
								l_tmp___30.item := (('%/0/').code).to_natural_8
								l_p___0.ce_gets (charset_inst.skipwhite (l_p___0))
							end
				when 61 then -- if block done, skip else block:
							l_pos := -1 + 63
				when 62 then -- else:
							from
							until
								js.loop_left
							loop
								js.reset
								if (l_p___0.item).to_boolean then
									if not ((l_p___0.c_pointer.to_integer_32).to_natural_32 < ((l_buffer + l_len.to_integer_32).c_pointer.to_integer_32).to_natural_32) then
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped then
									l_p___0.ce_gets (l_p___0 + 1)
								end
							end
							js.reset
							l_p___0.ce_gets (l_p___0 + 1)
				when 63 then -- if done | if done
							l_i___0 := l_i___0 + 1
							l_pos := -1 + 46 -- back to loop condition
				when 64 then -- loop done
							l_j := 0
							l_i___0 := 0
				when 65 then -- loop condition:
							if not (l_i___0 < a_num_file.item) then
								l_pos := -1 + 72 -- skip loop
							end
				when 66 then -- loop body:
							js.reset
							if not ((a_flags___0).bit_and (4)).to_boolean then
								if (mch_getperm (a_file.item[l_i___0])) < 0 then
									js.continue
								end
							end
							if js.loop_jumped then
								l_pos := -1 + 71 -- skip if block
							end
				when 67 then -- if:
							l_dir___0 := mch_isdir (a_file.item[l_i___0])
							if not (l_dir___0.to_boolean) then
								l_pos := -1 + 70 -- skip if block
							end
				when 68 then -- if:
							if not ((a_flags___0).bit_and (1)).to_boolean then
								js.continue
							else
								l_pos := -1 + 70 -- goto _L___7
							end
				when 69 then -- if block done, skip else block:
							l_pos := -1 + 71
				when 70 then -- else: | _L___7:
							if not l_dir___0.to_boolean then
								if not ((a_flags___0).bit_and (2)).to_boolean then
									js.continue
								end
							end
				when 71 then -- if done
							if not js.loop_jumped and then (not l_dir___0.to_boolean) then
								if ((a_flags___0).bit_and (64)).to_boolean then
									if not (mch_can_exe (a_file.item[l_i___0])).to_boolean then
										js.continue
									end
								end
							end
							if not js.loop_jumped then
								l_p___0.ce_gets (misc2_inst.alloc (((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_file.item[l_i___0]))) + {NATURAL_32} 1) + l_dir___0.to_natural_32))
								if ((l_p___0).c_pointer /= default_pointer) then
									strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), create {CE_POINTER [INTEGER_8]}.make_cast (a_file.item[l_i___0])).do_nothing
									if l_dir___0.to_boolean then
										misc1_inst.add_pathsep (l_p___0)
									end
									l_tmp___34 := l_j
									l_j := l_j + 1
									a_file.item[l_tmp___34] := l_p___0
								end
							end
							l_i___0 := l_i___0 + 1
							l_pos := -1 + 65 -- back to loop condition
				when 72 then -- loop done
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_buffer))
							a_num_file.item := l_j
							if a_num_file.item = 0 then
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_file.item))
								a_file.item := create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer)
								l_pos := -1 + 75 -- goto notfound
							end
				when 73 then
							Result := 1
							js.return
				when 74 then -- if done
						if js.return_called then
							l_pos := -1 + 76 -- skip if block
						end
				when 75 then -- if: | notfound:
							if ((a_flags___0).bit_and (4)).to_boolean then
								Result := (save_patterns (a_num_pat, a_pat, a_num_file, a_file))
								js.return
							end
				when 76 then -- if done
						if not js.return_called then
							Result := 0
						end
				when 77 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	save_patterns (a_num_pat: INTEGER_32; a_pat: CE_POINTER [CE_POINTER [NATURAL_8]]; a_num_file: CE_POINTER [INTEGER_32]; a_file: CE_POINTER [CE_POINTER [CE_POINTER [NATURAL_8]]]): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_s: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_s.make

			a_file.item := create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast ((misc2_inst.alloc (a_num_pat.to_natural_32 * Pointer_bytes.to_natural_32)))
			if ((a_file.item).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				Result := 0
				js.return
			end
			if not js.return_called then
				l_i___0 := 0
				from
				until
					not (l_i___0 < a_num_pat)
				loop
					l_s.ce_gets (misc2_inst.vim_strsave (a_pat[l_i___0]))
					if (l_s.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						charset_inst.backslash_halve (l_s)
					end
					a_file.item[l_i___0] := l_s
					l_i___0 := l_i___0 + 1
				end
				a_num_file.item := a_num_pat
				Result := 1
			end
		end

	mch_has_exp_wildcard (a_p___0: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp___0: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p___0.ce_gets (a_p___0)
				when 1 then -- loop condition:
					if not (not js.loop_left and then ((l_p___0.item).to_boolean)) then
						l_pos := -1 + 7 -- skip loop
					end
				when 2 then -- loop body:
						if (l_p___0.item).to_integer_32 /= 92 then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if (l_p___0[1]).to_integer_32 /= 0 then
							l_p___0.ce_gets (l_p___0 + 1)
						else
							l_pos := -1 + 5 -- goto _L
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 5 then -- else: | _L:
						if ((misc2_inst.vim_strchr (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("*?[{%'")), (l_p___0.item).to_integer_32)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							Result := 1
							js.return
						end
				when 6 then
						if not js.return_called then
							if globals_inst.has_mbyte.to_boolean then
								l_tmp___0 := (globals_inst.mb_ptr2len.integer_32_item ([l_p___0]))
							else
								l_tmp___0 := 1
							end
							l_p___0.ce_gets (l_p___0 + l_tmp___0)
						end
						l_pos := -1 + 1 -- back to loop condition
				when 7 then -- loop done
					if not js.return_called then
						Result := 0
					end
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	mch_has_wildcard (a_p___0: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp___0: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p___0.ce_gets (a_p___0)
				when 1 then -- loop condition:
					if not (not js.loop_left and then ((l_p___0.item).to_boolean)) then
						l_pos := -1 + 7 -- skip loop
					end
				when 2 then -- loop body:
						if (l_p___0.item).to_integer_32 /= 92 then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if (l_p___0[1]).to_integer_32 /= 0 then
							l_p___0.ce_gets (l_p___0 + 1)
						else
							l_pos := -1 + 5 -- goto _L
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 5 then -- else: | _L:
						if ((misc2_inst.vim_strchr (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("*?[{`%'$")), (l_p___0.item).to_integer_32)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							Result := 1
							js.return
						elseif (l_p___0.item).to_integer_32 = 126 then
							if (l_p___0[1]).to_integer_32 /= 0 then
								Result := 1
								js.return
							end
						end
				when 6 then
						if not js.return_called then
							if globals_inst.has_mbyte.to_boolean then
								l_tmp___0 := (globals_inst.mb_ptr2len.integer_32_item ([l_p___0]))
							else
								l_tmp___0 := 1
							end
							l_p___0.ce_gets (l_p___0 + l_tmp___0)
						end
						l_pos := -1 + 1 -- back to loop condition
				when 7 then -- loop done
					if not js.return_called then
						Result := 0
					end
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	have_wildcard (a_num: INTEGER_32; a_file: CE_POINTER [CE_POINTER [NATURAL_8]]): INTEGER_32
		local
			l_i___0: INTEGER_32
			js: JUMP_STATE
		do
			l_i___0 := 0
			from
			until
				not (not js.loop_left and then (l_i___0 < a_num))
			loop
				if (mch_has_wildcard (a_file[l_i___0])).to_boolean then
					Result := 1
					js.return
				end
				if not js.return_called then
					l_i___0 := l_i___0 + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	have_dollars (a_num: INTEGER_32; a_file: CE_POINTER [CE_POINTER [NATURAL_8]]): INTEGER_32
		local
			l_i___0: INTEGER_32
			js: JUMP_STATE
		do
			l_i___0 := 0
			from
			until
				not (not js.loop_left and then (l_i___0 < a_num))
			loop
				if ((misc2_inst.vim_strchr (a_file[l_i___0], ('$').code)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					Result := 1
					js.return
				end
				if not js.return_called then
					l_i___0 := l_i___0 + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	mch_libcall (a_libname: CE_POINTER [NATURAL_8]; a_funcname: CE_POINTER [NATURAL_8]; a_argstring: CE_POINTER [NATURAL_8]; a_argint: INTEGER_32; a_string_result: CE_POINTER [CE_POINTER [NATURAL_8]]; a_number_result: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_hinstLib: CE_POINTER [ANY]
			l_dlerr: CE_POINTER [INTEGER_8]
			l_ProcAdd: CE_ROUTINE
			l_ProcAddI: CE_ROUTINE
			l_retval_str: CE_POINTER [NATURAL_8]
			l_retval_int: INTEGER_32
			l_success___0: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___7: INTEGER_32
			l_i___0: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_hinstLib.make
			create l_dlerr.make
			create l_ProcAdd.make
			create l_ProcAddI.make
			create l_retval_str.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_dlerr.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
					l_retval_str.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_retval_int := 0
					l_success___0 := 0
					dlerror.do_nothing
					l_hinstLib.ce_gets (dlopen (create {CE_POINTER [INTEGER_8]}.make_cast (a_libname), 1))
					if (l_hinstLib.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						l_dlerr.ce_gets ((dlerror))
						if (l_dlerr.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("dlerror = %"%%s%"")))), create {CE_POINTER [NATURAL_8]}.make_cast (l_dlerr)).do_nothing
						end
					end
					if (l_hinstLib.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						mch_startjmp
						globals_inst.lc_jump_env := create {CE_EXCEPTION}.make ($mch_libcall, l_pos, $l_tmp___7)
				when 2 then -- continue here on raising lc_jump_env:
						if l_tmp___7 /= 0 then
							l_success___0 := 0
							l_dlerr.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							mch_didjmp
						else
							l_retval_str.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							l_retval_int := 0
							if (a_argstring.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								l_ProcAdd.ce_gets (create {CE_ROUTINE}.make_cast ((dlsym (l_hinstLib, create {CE_POINTER [INTEGER_8]}.make_cast (a_funcname)))))
								l_dlerr.ce_gets ((dlerror))
								if (l_ProcAdd.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									if (l_dlerr.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
										l_tmp___3 := 1
									else
										l_tmp___3 := 0
									end
								else
									l_tmp___3 := 0
								end
								l_success___0 := l_tmp___3
								if l_success___0.to_boolean then
									if (a_string_result.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
										l_retval_int := l_ProcAdd.integer_32_item ([a_argstring])
									else
										l_retval_str.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (l_ProcAdd.pointer_item ([a_argstring])))
									end
								end
							else
								l_ProcAddI.ce_gets (create {CE_ROUTINE}.make_cast ((dlsym (l_hinstLib, create {CE_POINTER [INTEGER_8]}.make_cast (a_funcname)))))
								l_dlerr.ce_gets ((dlerror))
								if (l_ProcAddI.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									if (l_dlerr.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
										l_tmp___6 := 1
									else
										l_tmp___6 := 0
									end
								else
									l_tmp___6 := 0
								end
								l_success___0 := l_tmp___6
								if l_success___0.to_boolean then
									if (a_string_result.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
										l_retval_int := l_ProcAddI.integer_32_item ([a_argint])
									else
										l_retval_str.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (l_ProcAddI.pointer_item ([a_argint])))
									end
								end
							end
							if (a_string_result.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								a_number_result.item := l_retval_int
							elseif (l_retval_str.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								if (l_retval_str.c_pointer.to_integer_32).to_natural_32 /= (1).to_natural_32 then
									if (l_retval_str.c_pointer.to_integer_32).to_natural_32 /= (-1).to_natural_32 then
										a_string_result.item := misc2_inst.vim_strsave (l_retval_str)
									end
								end
							end
						end
						mch_endjmp
						if globals_inst.lc_signal /= 0 then
							l_i___0 := 0
							from
							until
								not (not js.loop_left and then (signal_info[l_i___0].sig /= -1))
							loop
								js.reset
								if globals_inst.lc_signal = signal_info[l_i___0].sig then
									js.break
								end
								if not js.loop_jumped then
									l_i___0 := l_i___0 + 1
								end
							end
							js.reset
							message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E368: got SIG%%s in libcall()")), create {CE_POINTER [NATURAL_8]}.make_cast (signal_info[l_i___0].name)).do_nothing
						end
						if (l_dlerr.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("dlerror = %"%%s%"")))), create {CE_POINTER [NATURAL_8]}.make_cast (l_dlerr)).do_nothing
						end
						dlclose (l_hinstLib).do_nothing
				when 3 then -- if done
					if not l_success___0.to_boolean then
						message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_libcall)))), a_funcname).do_nothing
						Result := 0
						js.return
					end
					if not js.return_called then
						Result := 1
					end
				when 4 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		rescue
			if attached {CE_EXCEPTION} (create {EXCEPTION_MANAGER}).last_exception as ex then
				if ex.routine = $mch_libcall then
					l_pos := ex.position + 1
					retry
				end
				ex.re_raise
			end
		end

	setup_term_clip
		local
			l_z: INTEGER_32
			l_strp: CE_POINTER [INTEGER_8]
			l_AppShell: CE_POINTER [ANY]
			l_oldhandler: CE_ROUTINE
			l_oldIOhandler: CE_ROUTINE
			l_start_tv: SD_TIMEVAL
			l_tmp___2: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_strp.make
			create l_AppShell.make
			create l_oldhandler.make
			create l_oldIOhandler.make
			create l_start_tv.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_z := 0
					l_strp.ce_gets (ce_string (""))
					if not (x_connect_to_server).to_boolean then
						js.return
					end
					if js.return_called then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						ui_inst.open_app_context
						if (globals_inst.app_context.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 5 -- skip if block
						end
				when 2 then -- if:
						if (xterm_Shell.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if option_inst.p_verbose > 0 then
							gettimeofday ((l_start_tv.address), create {CE_POINTER [SD_TIMEZONE]}.make_shared (default_pointer)).do_nothing
						end
						l_oldhandler.ce_gets ((XSetErrorHandler (x_error_check___0_address)))
						l_oldIOhandler.ce_gets ((XSetIOErrorHandler (x_IOerror_check_address)))
						mch_startjmp
						globals_inst.lc_jump_env := create {CE_EXCEPTION}.make ($setup_term_clip, l_pos, $l_tmp___2)
				when 4 then -- continue here on raising lc_jump_env:
						if l_tmp___2 /= 0 then
							mch_didjmp
							globals_inst.xterm_dpy.ce_gets (create {CE_POINTER [ANY]}.make_shared (default_pointer))
						else
							globals_inst.xterm_dpy.ce_gets (XtOpenDisplay (globals_inst.app_context, globals_inst.xterm_display, ce_string ("vim_xterm"), ce_string ("Vim_xterm"), create {CE_POINTER [SD_XRMOPTIONDESCREC]}.make_shared (default_pointer), (0).to_natural_32, create {CE_POINTER [INTEGER_32]}.make_shared ($l_z), l_strp.address))
							mch_endjmp
						end
						XSetIOErrorHandler (l_oldIOhandler).do_nothing
						XSetErrorHandler (l_oldhandler).do_nothing
						if (globals_inst.xterm_dpy.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							if option_inst.p_verbose > 0 then
								message_inst.verb_msg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Opening the X display failed"))))).do_nothing
							end
							js.return
						end
						if not js.return_called then
							XSetIOErrorHandler (x_IOerror_handler_address).do_nothing
							if option_inst.p_verbose > 0 then
								message_inst.verbose_enter
								xopen_message (l_start_tv.address)
								message_inst.verbose_leave
							end
							l_AppShell.ce_gets (XtVaAppCreateShell ([ce_string ("vim_xterm"), ce_string ("Vim_xterm"), applicationShellWidgetClass, globals_inst.xterm_dpy, create {CE_POINTER [ANY]}.make_shared (default_pointer)]))
							if (l_AppShell.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								js.return
							end
						end
						if not js.return_called then
							xterm_Shell.ce_gets (XtVaCreatePopupShell ([ce_string ("VIM"), topLevelShellWidgetClass, l_AppShell, (XtStrings + 453), 0, (XtStrings + 872), 1, (XtStrings + 234), 1, create {CE_POINTER [ANY]}.make_shared (default_pointer)]))
							if (xterm_Shell.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								js.return
							end
						end
						if not js.return_called then
							ui_inst.x11_setup_atoms (globals_inst.xterm_dpy)
							ui_inst.x11_setup_selection (xterm_Shell)
							if (x11_display.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								x11_display.ce_gets (globals_inst.xterm_dpy)
							end
							XtRealizeWidget (xterm_Shell)
							XSync (globals_inst.xterm_dpy, 0).do_nothing
							xterm_update
						end
				when 5 then -- if done | if done | if done
						if not js.return_called and then ((xterm_Shell.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32) then
							ui_inst.clip_init (1)
							if x11_window = {NATURAL_32} 0 then
								l_strp.ce_gets (getenv (ce_string ("WINDOWID")))
								if (l_strp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									Current.x11_window := (atol (l_strp)).to_natural_32
								end
							end
							if (test_x11_window (globals_inst.xterm_dpy)) = 0 then
								Current.x11_window := (0).to_natural_32
							end
							if x11_window /= {NATURAL_32} 0 then
								xterm_trace := 0
							end
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		rescue
			if attached {CE_EXCEPTION} (create {EXCEPTION_MANAGER}).last_exception as ex then
				if ex.routine = $setup_term_clip then
					l_pos := ex.position + 1
					retry
				end
				ex.re_raise
			end
			end

	start_xterm_trace (a_button: INTEGER_32)
		local
			js: JUMP_STATE
		do
			if x11_window = {NATURAL_32} 0 then
				js.return
			elseif xterm_trace < 0 then
				js.return
			elseif (xterm_Shell.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				js.return
			end
			if not js.return_called then
				xterm_trace := 1
				xterm_button := a_button
				do_xterm_trace.do_nothing
			end
		end

	stop_xterm_trace
		local
			js: JUMP_STATE
		do
			if xterm_trace < 0 then
				js.return
			end
			if not js.return_called then
				xterm_trace := 0
			end
		end

	do_xterm_trace: INTEGER_32
		local
			l_root: NATURAL_32
			l_child: NATURAL_32
			l_root_x: INTEGER_32
			l_root_y: INTEGER_32
			l_win_x: INTEGER_32
			l_win_y: INTEGER_32
			l_row: INTEGER_32
			l_col: INTEGER_32
			l_mask_return: NATURAL_32
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_strp: CE_POINTER [NATURAL_8]
			l_got_hints: INTEGER_32
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_tmp___3: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_buf___6.make (<<50>>)
			create l_strp.make
			create l_tmp___1.make
			create l_tmp___2.make
			create l_tmp___3.make

			if xterm_trace <= 0 then
				Result := 0
				js.return
			end
			if not js.return_called and then (xterm_trace = 1) then
				if (XGetWMNormalHints (globals_inst.xterm_dpy, x11_window, xterm_hints.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_got_hints))).to_boolean then
					if not ((l_got_hints).bit_and (((1).bit_shift_left (6)))).to_boolean then
						xterm_trace := -1
						Result := 0
						js.return
					elseif xterm_hints.width_inc <= 1 then
						xterm_trace := -1
						Result := 0
						js.return
					elseif xterm_hints.height_inc <= 1 then
						xterm_trace := -1
						Result := 0
						js.return
					end
				else
					xterm_trace := -1
					Result := 0
					js.return
				end
				if not js.return_called then
					mouse_code.ce_gets (term_inst.find_termcode (mouse_name))
					prev_row := globals_inst.mouse_row
					prev_row := globals_inst.mouse_col
					xterm_trace := 2
					XQueryPointer (globals_inst.xterm_dpy, x11_window, create {CE_POINTER [NATURAL_32]}.make_shared ($l_root), create {CE_POINTER [NATURAL_32]}.make_shared ($l_child), create {CE_POINTER [INTEGER_32]}.make_shared ($l_root_x), create {CE_POINTER [INTEGER_32]}.make_shared ($l_root_y), create {CE_POINTER [INTEGER_32]}.make_shared ($l_win_x), create {CE_POINTER [INTEGER_32]}.make_shared ($l_win_y), create {CE_POINTER [NATURAL_32]}.make_shared ($l_mask_return)).do_nothing
					xterm_hints.y := (l_win_y - xterm_hints.height_inc * globals_inst.mouse_row) - xterm_hints.height_inc // 2
					if xterm_hints.y <= xterm_hints.height_inc // 2 then
						xterm_hints.y := 2
					end
					xterm_hints.x := (l_win_x - xterm_hints.width_inc * globals_inst.mouse_col) - xterm_hints.width_inc // 2
					if xterm_hints.x <= xterm_hints.width_inc // 2 then
						xterm_hints.x := 2
					end
					Result := 1
					js.return
				end
			end
			if not js.return_called and then ((mouse_code.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32) then
				xterm_trace := 0
				Result := 0
				js.return
			end
			if not js.return_called then
				XQueryPointer (globals_inst.xterm_dpy, x11_window, create {CE_POINTER [NATURAL_32]}.make_shared ($l_root), create {CE_POINTER [NATURAL_32]}.make_shared ($l_child), create {CE_POINTER [INTEGER_32]}.make_shared ($l_root_x), create {CE_POINTER [INTEGER_32]}.make_shared ($l_root_y), create {CE_POINTER [INTEGER_32]}.make_shared ($l_win_x), create {CE_POINTER [INTEGER_32]}.make_shared ($l_win_y), create {CE_POINTER [NATURAL_32]}.make_shared ($l_mask_return)).do_nothing
				l_row := ui_inst.check_row ((l_win_y - xterm_hints.y) // xterm_hints.height_inc)
				l_col := ui_inst.check_col ((l_win_x - xterm_hints.x) // xterm_hints.width_inc)
				if l_row = prev_row then
					if l_col = prev_col then
						Result := 1
						js.return
					end
				end
			end
			if not js.return_called then
				strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6), create {CE_POINTER [INTEGER_8]}.make_cast (mouse_code)).do_nothing
				l_strp.ce_gets (l_buf___6 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6))).to_integer_32)
				l_tmp___1.ce_gets (l_strp)
				l_strp.ce_gets (l_strp + 1)
				l_tmp___1.item := ((((xterm_button).bit_or (67))).bit_and (-33)).to_natural_8
				l_tmp___2.ce_gets (l_strp)
				l_strp.ce_gets (l_strp + 1)
				l_tmp___2.item := ((l_col + 32) + 1).to_natural_8
				l_tmp___3.ce_gets (l_strp)
				l_strp.ce_gets (l_strp + 1)
				l_tmp___3.item := ((l_row + 32) + 1).to_natural_8
				l_strp.item := (0).to_natural_8
				ui_inst.add_to_input_buf (l_buf___6, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6))).to_integer_32)
				prev_row := l_row
				prev_col := l_col
				Result := 1
			end
		end

	clear_xterm_clip
		do
			if (xterm_Shell.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				XtDestroyWidget (xterm_Shell)
				xterm_Shell.ce_gets (create {CE_POINTER [ANY]}.make_shared (default_pointer))
			end
			if (globals_inst.xterm_dpy.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				if (x11_display.c_pointer.to_integer_32).to_natural_32 = (globals_inst.xterm_dpy.c_pointer.to_integer_32).to_natural_32 then
					x11_display.ce_gets (create {CE_POINTER [ANY]}.make_shared (default_pointer))
				end
				globals_inst.xterm_dpy.ce_gets (create {CE_POINTER [ANY]}.make_shared (default_pointer))
			end
		end

	xterm_update
		local
			l_event: SD_XEVENT
			l_e: CE_POINTER [SD_XPROPERTYEVENT]
			js: JUMP_STATE
		do
			create l_event.make
			create l_e.make

			from
			until
				js.loop_left
			loop
				js.reset
				if (XtAppPending (globals_inst.app_context)).to_boolean then
					if (ui_inst.vim_is_input_buf_full).to_boolean then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					XtAppNextEvent (globals_inst.app_context, l_event.address)
					l_e.ce_gets (create {CE_POINTER [SD_XPROPERTYEVENT]}.make_cast ((l_event.address)))
					if l_e.item.type = 28 then
						if l_e.item.window = globals_inst.commWindow then
							if l_e.item.atom = globals_inst.commProperty then
								if l_e.item.state = 0 then
									if_xcmdsrv_inst.serverEventProc (globals_inst.xterm_dpy, l_event.address)
								end
							end
						end
					end
					XtDispatchEvent (l_event.address).do_nothing
				end
			end
			js.reset
		end

	clip_xterm_own_selection (a_cbd: CE_POINTER [PD_VIMCLIPBOARD]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if (xterm_Shell.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				Result := (ui_inst.clip_x11_own_selection (xterm_Shell, a_cbd))
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	clip_xterm_lose_selection (a_cbd: CE_POINTER [PD_VIMCLIPBOARD])
		do
			if (xterm_Shell.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				ui_inst.clip_x11_lose_selection (xterm_Shell, a_cbd)
			end
		end

	clip_xterm_request_selection (a_cbd: CE_POINTER [PD_VIMCLIPBOARD])
		do
			if (xterm_Shell.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				ui_inst.clip_x11_request_selection (xterm_Shell, globals_inst.xterm_dpy, a_cbd)
			end
		end

	clip_xterm_set_selection (a_cbd: CE_POINTER [PD_VIMCLIPBOARD])
		do
			ui_inst.clip_x11_set_selection (a_cbd)
		end

	xsmp_handle_interaction (a_smc_conn: CE_POINTER [ANY]; a_client_data: CE_POINTER [ANY])
		local
			l_save_cmdmod: PD_CMDMOD_T
			l_cancel_shutdown: INTEGER_32
		do
			create l_save_cmdmod.make

			l_cancel_shutdown := 0
			l_save_cmdmod.ce_gets (globals_inst.cmdmod)
			globals_inst.cmdmod.confirm := 1
			if (ex_cmds2_inst.check_changed_any (0)).to_boolean then
				l_cancel_shutdown := 1
			end
			globals_inst.cmdmod.ce_gets (l_save_cmdmod)
			screen_inst.setcursor
			term_inst.out_flush
			SmcInteractDone (a_smc_conn, l_cancel_shutdown)
			if not l_cancel_shutdown.to_boolean then
				xsmp.save_yourself := 0
				SmcSaveYourselfDone (a_smc_conn, 1)
			end
		end

	xsmp_handle_interaction_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent xsmp_handle_interaction)
		end

	xsmp_handle_save_yourself (a_smc_conn: CE_POINTER [ANY]; a_client_data: CE_POINTER [ANY]; a_save_type: INTEGER_32; a_shutdown: INTEGER_32; a_interact_style: INTEGER_32; a_fast: INTEGER_32)
		do
			if (xsmp.save_yourself).to_boolean then
				SmcSaveYourselfDone (a_smc_conn, 1)
			end
			xsmp.save_yourself := 1
			xsmp.shutdown := a_shutdown
			term_inst.out_flush
			memline_inst.ml_sync_all (0, 0)
			if option_inst.p_verbose > 0 then
				message_inst.verb_msg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("XSMP handling save-yourself request"))))).do_nothing
			end
			if a_shutdown.to_boolean then
				if not a_fast.to_boolean then
					if (gui_inst.gui.in_use).to_boolean then
						SmcInteractRequest (a_smc_conn, 0, xsmp_handle_interaction_address, a_client_data).do_nothing
					else
						SmcSaveYourselfDone (a_smc_conn, 1)
						xsmp.save_yourself := 0
					end
				else
					SmcSaveYourselfDone (a_smc_conn, 1)
					xsmp.save_yourself := 0
				end
			else
				SmcSaveYourselfDone (a_smc_conn, 1)
				xsmp.save_yourself := 0
			end
		end

	xsmp_handle_save_yourself_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent xsmp_handle_save_yourself)
		end

	xsmp_die (a_smc_conn: CE_POINTER [ANY]; a_client_data: CE_POINTER [ANY])
		do
			xsmp_close
			main_inst.getout_preserve_modified (0)
		end

	xsmp_die_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent xsmp_die)
		end

	xsmp_save_complete (a_smc_conn: CE_POINTER [ANY]; a_client_data: CE_POINTER [ANY])
		do
			xsmp.save_yourself := 0
		end

	xsmp_save_complete_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent xsmp_save_complete)
		end

	xsmp_shutdown_cancelled (a_smc_conn: CE_POINTER [ANY]; a_client_data: CE_POINTER [ANY])
		do
			if (xsmp.save_yourself).to_boolean then
				SmcSaveYourselfDone (a_smc_conn, 1)
			end
			xsmp.save_yourself := 0
			xsmp.shutdown := 0
		end

	xsmp_shutdown_cancelled_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent xsmp_shutdown_cancelled)
		end

	xsmp_ice_connection (a_iceConn: CE_POINTER [ANY]; a_clientData: CE_POINTER [ANY]; a_opening: INTEGER_32; a_watchData: CE_POINTER [CE_POINTER [ANY]])
		do
			if a_opening.to_boolean then
				globals_inst.xsmp_icefd := IceConnectionNumber (a_iceConn)
				IceRemoveConnectionWatch (xsmp_ice_connection_address, create {CE_POINTER [ANY]}.make_shared (default_pointer))
			end
		end

	xsmp_ice_connection_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent xsmp_ice_connection)
		end

	xsmp_handle_requests: INTEGER_32
		local
			l_rep: INTEGER_32
		do
			if (IceProcessMessages (xsmp.iceconn, create {CE_POINTER [SD_ICEREPLYWAITINFO]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared ($l_rep))).to_natural_32 = {NATURAL_32} 1 then
				if option_inst.p_verbose > 0 then
					message_inst.verb_msg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("XSMP lost ICE connection"))))).do_nothing
				end
				xsmp_close
				Result := 0
			else
				Result := 1
			end
		end

	xsmp_init
		local
			l_errorstring: CE_ARRAY [INTEGER_8]
			l_smcallbacks: SD_SMCCALLBACKS
			l_errorreport: CE_ARRAY [INTEGER_8]
			js: JUMP_STATE
		do
			create l_errorstring.make (<<80>>)
			create l_smcallbacks.make
			create l_errorreport.make (<<132>>)

			if option_inst.p_verbose > 0 then
				message_inst.verb_msg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("XSMP opening connection"))))).do_nothing
			end
			xsmp.shutdown := 0
			xsmp.save_yourself := xsmp.shutdown
			l_smcallbacks.save_yourself.callback := xsmp_handle_save_yourself_address
			l_smcallbacks.save_yourself.client_data := create {CE_POINTER [ANY]}.make_shared (default_pointer)
			l_smcallbacks.die.callback := xsmp_die_address
			l_smcallbacks.die.client_data := create {CE_POINTER [ANY]}.make_shared (default_pointer)
			l_smcallbacks.save_complete.callback := xsmp_save_complete_address
			l_smcallbacks.save_complete.client_data := create {CE_POINTER [ANY]}.make_shared (default_pointer)
			l_smcallbacks.shutdown_cancelled.callback := xsmp_shutdown_cancelled_address
			l_smcallbacks.shutdown_cancelled.client_data := create {CE_POINTER [ANY]}.make_shared (default_pointer)
			if (IceAddConnectionWatch (xsmp_ice_connection_address, create {CE_POINTER [ANY]}.make_cast ((dummy_address)))) = 0 then
				if option_inst.p_verbose > 0 then
					message_inst.verb_msg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("XSMP ICE connection watch failed"))))).do_nothing
				end
				js.return
			end
			if not js.return_called then
				xsmp.smcconn := SmcOpenConnection (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer), 1, 0, ((((((1).bit_or (((1).bit_shift_left (1))))).bit_or (((1).bit_shift_left (2))))).bit_or (((1).bit_shift_left (3)))).to_natural_32, l_smcallbacks.address, create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_shared (xsmp.c_pointer + {PD_XSMP_CONFIG_T}.clientid_offset), (Integer_8_bytes.to_natural_32 * (80).to_natural_32).to_integer_32, l_errorstring)
				if ((xsmp.smcconn).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					if option_inst.p_verbose > 0 then
						message_inst.vim_snprintf ([l_errorreport, (Integer_8_bytes.to_natural_32 * (132).to_natural_32), (gettext (ce_string ("XSMP SmcOpenConnection failed: %%s"))), l_errorstring]).do_nothing
						message_inst.verb_msg (create {CE_POINTER [NATURAL_8]}.make_cast (l_errorreport)).do_nothing
					end
					js.return
				end
			end
			if not js.return_called then
				xsmp.iceconn := SmcGetIceConnection (xsmp.smcconn)
			end
		end

	xsmp_close
		do
			if globals_inst.xsmp_icefd /= -1 then
				SmcCloseConnection (xsmp.smcconn, 0, create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_shared (default_pointer)).do_nothing
				if ((xsmp.clientid).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					free (create {CE_POINTER [ANY]}.make_cast (xsmp.clientid))
				end
				xsmp.clientid := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
				globals_inst.xsmp_icefd := -1
			end
		end

end
