class
	P_SEARCH

inherit
	VIM_DATA
		redefine
			default_create
		end
	S_LIBIO
	S_STDIO
	S_CTYPE
	S_SYS_STAT
	S_STDLIB
	S_STRING
	S_LIBINTL
	S_WCTYPE
	S_UNISTD
	S_TIME
	S_FCNTL
	S_MATH
	S_SYS_TIME
	S_LOCALE
	S_BITS_ERRNO
	S_ICONV
	S_UTIME
	S_GLIB_OBJECT
	S_GTK_GTK
	S_SYS_SELECT
	S_X11_XLIB
	S_SIGNAL
	S_DIRENT
	S_PWD
	S_GLIB
	S_PANGO_PANGO
	S_GDK_GDK
	S_LANGINFO
	S_X11_XUTIL
	S_X11_INTRINSIC
	S_SYS_IOCTL
	S_SYS_RESOURCE
	S_SYS_WAIT
	S_SYS_UTSNAME
	S_TERMIOS
	S_DLFCN
	S_X11_ICE_ICELIB
	S_X11_SM_SMLIB
	S_X11_SHELL
	S_X11_STRINGDEFS
	S_SYS_SYSINFO
	S_TERMCAP
	S_TERM
	S_GDK_PIXBUF_GDK_PIXBUF
	S_SYS_SOCKET
	S_NETINET_IN
	S_NETDB

feature {NONE} -- Initialization

	default_create
		do
			create spats.make (<<2>>)
			create saved_spats.make (<<2>>)
			create mr_pattern.make
			create bytes.make (<<21>>)
			create pos___1.make
		end

feature {ANY} -- attributes

	spats: CE_ARRAY [PD_SPAT]

	last_idx: INTEGER_32 assign set_last_idx

	set_last_idx (a_last_idx: INTEGER_32)
		do
			last_idx := a_last_idx
		end

	saved_spats: CE_ARRAY [PD_SPAT]

	saved_last_idx: INTEGER_32 assign set_saved_last_idx

	set_saved_last_idx (a_saved_last_idx: INTEGER_32)
		do
			saved_last_idx := a_saved_last_idx
		end

	saved_no_hlsearch: INTEGER_32 assign set_saved_no_hlsearch

	set_saved_no_hlsearch (a_saved_no_hlsearch: INTEGER_32)
		do
			saved_no_hlsearch := a_saved_no_hlsearch
		end

	mr_pattern: CE_POINTER [NATURAL_8]

	save_level___0: INTEGER_32 assign set_save_level___0

	set_save_level___0 (a_save_level___0: INTEGER_32)
		do
			save_level___0 := a_save_level___0
		end

	lastc: INTEGER_32 assign set_lastc

	set_lastc (a_lastc: INTEGER_32)
		do
			lastc := a_lastc
		end

	lastcdir: INTEGER_32 assign set_lastcdir

	set_lastcdir (a_lastcdir: INTEGER_32)
		do
			lastcdir := a_lastcdir
		end

	last_t_cmd: INTEGER_32 assign set_last_t_cmd

	set_last_t_cmd (a_last_t_cmd: INTEGER_32)
		do
			last_t_cmd := a_last_t_cmd
		end

	bytes: CE_ARRAY [NATURAL_8]

	bytelen: INTEGER_32 assign set_bytelen

	set_bytelen (a_bytelen: INTEGER_32)
		do
			bytelen := a_bytelen
		end

	pos___1: PD_POS_T

	cls_bigword: INTEGER_32 assign set_cls_bigword

	set_cls_bigword (a_cls_bigword: INTEGER_32)
		do
			cls_bigword := a_cls_bigword
		end

	hlsearch_on: INTEGER_32 assign set_hlsearch_on

	set_hlsearch_on (a_hlsearch_on: INTEGER_32)
		do
			hlsearch_on := a_hlsearch_on
		end

feature {ANY} -- routines

	search_regcomp (a_pat: CE_POINTER [NATURAL_8]; a_pat_save: INTEGER_32; a_pat_use: INTEGER_32; a_options___0: INTEGER_32; a_regmatch___0: CE_POINTER [PD_REGMMATCH_T]): INTEGER_32
		local
			l_pat: CE_POINTER [NATURAL_8]
			l_magic: INTEGER_32
			l_i___0: INTEGER_32
			l_tmp___1: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_pat.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_pat.ce_gets (a_pat)
					globals_inst.rc_did_emsg := 0
					l_magic := option_inst.p_magic
					if (l_pat.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if (l_pat.item).to_integer_32 /= 0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						if a_pat_use = 2 then
							l_i___0 := last_idx
						else
							l_i___0 := a_pat_use
						end
						if ((spats[l_i___0].pat).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							if a_pat_use = 1 then
								message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_nopresub))))).do_nothing
							else
								message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_noprevre))))).do_nothing
							end
							globals_inst.rc_did_emsg := 1
							Result := 0
							js.return
						end
						if not js.return_called then
							l_pat.ce_gets (spats[l_i___0].pat)
							l_magic := spats[l_i___0].magic
							globals_inst.no_smartcase := spats[l_i___0].no_scs
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						if ((a_options___0).bit_and (32)).to_boolean then
							ex_getln_inst.add_to_history (1, l_pat, 1, ('%/0/').code)
						end
				when 7 then -- if done
						if not js.return_called then
							mr_pattern.ce_gets (l_pat)
							if not ((a_options___0).bit_and (1024)).to_boolean then
								if a_pat_save = 0 then
									save_re_pat (0, l_pat, l_magic)
								elseif a_pat_save = 2 then
									save_re_pat (0, l_pat, l_magic)
								end
								if a_pat_save = 1 then
									save_re_pat (1, l_pat, l_magic)
								elseif a_pat_save = 2 then
									save_re_pat (1, l_pat, l_magic)
								end
							end
							a_regmatch___0.item.rmm_ic := ignorecase (l_pat)
							a_regmatch___0.item.rmm_maxcol := 0
							if l_magic.to_boolean then
								l_tmp___1 := 1
							else
								l_tmp___1 := 0
							end
							a_regmatch___0.item.regprog := regexp_inst.vim_regcomp (l_pat, l_tmp___1)
							if ((a_regmatch___0.item.regprog).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								Result := 0
								js.return
							end
						end
						if not js.return_called then
							Result := 1
						end
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	get_search_pat: CE_POINTER [NATURAL_8]
		do
			Result := mr_pattern
		end

	save_re_pat (a_idx: INTEGER_32; a_pat: CE_POINTER [NATURAL_8]; a_magic: INTEGER_32)
		do
			if ((spats[a_idx].pat).c_pointer.to_integer_32).to_natural_32 /= (a_pat.c_pointer.to_integer_32).to_natural_32 then
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (spats[a_idx].pat))
				spats[a_idx].pat := misc2_inst.vim_strsave (a_pat)
				spats[a_idx].magic := a_magic
				spats[a_idx].no_scs := globals_inst.no_smartcase
				last_idx := a_idx
				if option_inst.p_hls.to_boolean then
					screen_inst.redraw_all_later (35)
				end
				globals_inst.no_hlsearch := 0
			end
		end

	save_search_patterns
		local
			l_tmp: INTEGER_32
		do
			l_tmp := save_level___0
			save_level___0 := save_level___0 + 1
			if l_tmp = 0 then
				saved_spats[0] := spats[0]
				if ((spats[0].pat).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					saved_spats[0].pat := misc2_inst.vim_strsave (spats[0].pat)
				end
				saved_spats[1] := spats[1]
				if ((spats[1].pat).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					saved_spats[1].pat := misc2_inst.vim_strsave (spats[1].pat)
				end
				saved_last_idx := last_idx
				saved_no_hlsearch := globals_inst.no_hlsearch
			end
		end

	restore_search_patterns
		do
			save_level___0 := save_level___0 - 1
			if save_level___0 = 0 then
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (spats[0].pat))
				spats[0] := saved_spats[0]
				set_vv_searchforward
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (spats[1].pat))
				spats[1] := saved_spats[1]
				last_idx := saved_last_idx
				globals_inst.no_hlsearch := saved_no_hlsearch
			end
		end

	ignorecase (a_pat: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_ic: INTEGER_32
			l_tmp___0: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ic := option_inst.p_ic
					if not (l_ic.to_boolean) then
						l_pos := -1 + 7 -- skip if block
					end
				when 1 then -- if:
						if globals_inst.no_smartcase.to_boolean then
							l_pos := -1 + 7 -- skip if block
						end
				when 2 then -- if:
						if not (option_inst.p_scs.to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 3 then -- if:
						if not (globals_inst.ctrl_x_mode.to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if not (globals_inst.curbuf.item.b_p_inf).to_boolean then
							l_pos := -1 + 6 -- goto _L
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L:
						if (pat_has_uppercase (a_pat)).to_boolean then
							l_tmp___0 := 0
						else
							l_tmp___0 := 1
						end
						l_ic := l_tmp___0
				when 7 then -- if done | if done | if done
						globals_inst.no_smartcase := 0
						Result := l_ic
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	pat_has_uppercase (a_pat: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_l: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p___0.ce_gets (a_pat)
				when 1 then -- loop condition:
					if not (not js.loop_left and then ((l_p___0.item).to_integer_32 /= 0)) then
						l_pos := -1 + 16 -- skip loop
					end
				when 2 then -- loop body:
						if not (globals_inst.has_mbyte.to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_l := globals_inst.mb_ptr2len.integer_32_item ([l_p___0])
						if l_l > 1 then
							if globals_inst.enc_utf8.to_boolean then
								if (mbyte_inst.utf_isupper ((mbyte_inst.utf_ptr2char (l_p___0)))).to_boolean then
									Result := 1
									js.return
								end
							end
							if not js.return_called then
								l_p___0.ce_gets (l_p___0 + l_l)
							end
						else
							l_pos := -1 + 5 -- goto _L___1
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 5 then -- else: | _L___1:
						if (l_p___0.item).to_integer_32 /= 92 then
							l_pos := -1 + 14 -- skip if block
						end
				when 6 then -- if:
						if (l_p___0[1]).to_integer_32 /= 95 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if (l_p___0[2]).to_integer_32 /= 0 then
							l_p___0.ce_gets (l_p___0 + (3))
						else
							l_pos := -1 + 9 -- goto _L___0
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 9 then -- else: | _L___0:
						if (l_p___0[1]).to_integer_32 /= 37 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						if (l_p___0[2]).to_integer_32 /= 0 then
							l_p___0.ce_gets (l_p___0 + (3))
						else
							l_pos := -1 + 12 -- goto _L
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else: | _L:
						if (l_p___0[1]).to_integer_32 /= 0 then
							l_p___0.ce_gets (l_p___0 + (2))
						else
							l_p___0.ce_gets (l_p___0 + 1)
						end
				when 13 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 15
				when 14 then -- else:
						if (charset_inst.vim_isupper ((l_p___0.item).to_integer_32)).to_boolean then
							Result := 1
							js.return
						else
							l_p___0.ce_gets (l_p___0 + 1)
						end
				when 15 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 16 then -- loop done
					if not js.return_called then
						Result := 0
					end
				when 17 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	last_search_pat: CE_POINTER [NATURAL_8]
		do
			Result := (spats[last_idx].pat)
		end

	reset_search_dir
		do
			spats[0].off.dir := ('/').code
			set_vv_searchforward
		end

	set_last_search_pat (a_s: CE_POINTER [NATURAL_8]; a_idx: INTEGER_32; a_magic: INTEGER_32; a_setlast: INTEGER_32)
		do
			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (spats[a_idx].pat))
			if (a_s.item).to_integer_32 = 0 then
				spats[a_idx].pat := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			else
				spats[a_idx].pat := misc2_inst.vim_strsave (a_s)
			end
			spats[a_idx].magic := a_magic
			spats[a_idx].no_scs := 0
			spats[a_idx].off.dir := ('/').code
			set_vv_searchforward
			spats[a_idx].off.line := 0
			spats[a_idx].off.end2 := 0
			spats[a_idx].off.off := 0
			if a_setlast.to_boolean then
				last_idx := a_idx
			end
			if save_level___0.to_boolean then
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (saved_spats[a_idx].pat))
				saved_spats[a_idx] := spats[0]
				if ((spats[a_idx].pat).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					saved_spats[a_idx].pat := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
				else
					saved_spats[a_idx].pat := misc2_inst.vim_strsave (spats[a_idx].pat)
				end
				saved_last_idx := last_idx
			end
			if option_inst.p_hls.to_boolean then
				if a_idx = last_idx then
					if not globals_inst.no_hlsearch.to_boolean then
						screen_inst.redraw_all_later (35)
					end
				end
			end
		end

	last_pat_prog (a_regmatch___0: CE_POINTER [PD_REGMMATCH_T])
		local
			js: JUMP_STATE
		do
			if ((spats[last_idx].pat).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				a_regmatch___0.item.regprog := create {CE_POINTER [PD_REGPROG_T]}.make_shared (default_pointer)
				js.return
			end
			if not js.return_called then
				globals_inst.emsg_off := globals_inst.emsg_off + 1
				search_regcomp (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")), 0, last_idx, 1024, a_regmatch___0).do_nothing
				globals_inst.emsg_off := globals_inst.emsg_off - 1
			end
		end

	searchit (a_win: CE_POINTER [PD_WINDOW_S]; a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_pos___3: CE_POINTER [PD_POS_T]; a_dir___0: INTEGER_32; a_pat: CE_POINTER [NATURAL_8]; a_count___2: INTEGER_32; a_options___0: INTEGER_32; a_pat_use: INTEGER_32; a_stop_lnum: INTEGER_32; a_tm: CE_POINTER [SD_TIMEVAL]): INTEGER_32
		local
			l_count___2: INTEGER_32
			l_found: INTEGER_32
			l_lnum: INTEGER_32
			l_regmatch___0: PD_REGMMATCH_T
			l_ptr: CE_POINTER [NATURAL_8]
			l_matchcol: INTEGER_32
			l_endpos: PD_LPOS_T
			l_matchpos: PD_LPOS_T
			l_loop: INTEGER_32
			l_start_pos: PD_POS_T
			l_at_first_line: INTEGER_32
			l_extra_col: INTEGER_32
			l_match_ok: INTEGER_32
			l_nmatched: INTEGER_32
			l_submatch: INTEGER_32
			l_save_called_emsg: INTEGER_32
			l_break_loop: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___8: INTEGER_32
			l_tmp___9: INTEGER_32
			l_tmp___10: INTEGER_32
			l_tmp___11: INTEGER_32
			l_tmp___19: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_regmatch___0.make
			create l_ptr.make
			create l_endpos.make
			create l_matchpos.make
			create l_start_pos.make
			create l_tmp___19.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_count___2 := a_count___2
					l_submatch := 0
					l_save_called_emsg := globals_inst.called_emsg
					l_break_loop := 0
					if (search_regcomp (a_pat, 0, a_pat_use, (a_options___0).bit_and (1056), l_regmatch___0.address)) = 0 then
						if ((a_options___0).bit_and (12)).to_boolean then
							if not globals_inst.rc_did_emsg.to_boolean then
								message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E383: Invalid search string: %%s")))), mr_pattern).do_nothing
							end
						end
						Result := 0
						js.return
					end
					if js.return_called then
						l_pos := -1 + 24 -- skip if block
					end
				when 1 then -- if:
						if ((a_options___0).bit_and (256)).to_boolean then
							l_extra_col := 0
						elseif (a_pos___3.item.col).to_integer_32 = 2147483647 then
							l_extra_col := 0
						elseif globals_inst.has_mbyte.to_boolean then
							if a_pos___3.item.lnum >= 1 then
								if a_pos___3.item.lnum <= a_buf___6.item.b_ml.ml_line_count then
									if (a_pos___3.item.col).to_integer_32 < 2147483645 then
										l_ptr.ce_gets ((memline_inst.ml_get_buf (a_buf___6, a_pos___3.item.lnum, 0)) + a_pos___3.item.col)
										if (l_ptr.item).to_integer_32 = 0 then
											l_extra_col := 1
										else
											l_extra_col := globals_inst.mb_ptr2len.integer_32_item ([l_ptr])
										end
									else
										l_extra_col := 1
									end
								else
									l_extra_col := 1
								end
							else
								l_extra_col := 1
							end
						else
							l_extra_col := 1
						end
						globals_inst.called_emsg := 0
				when 2 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 23 -- skip loop
						end
				when 3 then -- loop body:
						js.reset
						l_start_pos.ce_gets (a_pos___3.item)
						l_found := 0
						l_at_first_line := 1
						if a_pos___3.item.lnum = 0 then
							a_pos___3.item.lnum := (1).to_integer_32
							a_pos___3.item.col := 0
							l_at_first_line := 0
						end
						if a_dir___0 = -1 then
							if l_start_pos.col = 0 then
								if ((a_options___0).bit_and (256)) = 0 then
									l_lnum := a_pos___3.item.lnum - 1
									l_at_first_line := 0
								else
									l_lnum := a_pos___3.item.lnum
								end
							else
								l_lnum := a_pos___3.item.lnum
							end
						else
							l_lnum := a_pos___3.item.lnum
						end
						l_loop := 0
				when 4 then -- loop condition:
						if not (not js.loop_left and then (l_loop <= 1)) then
							l_pos := -1 + 22 -- skip loop
						end
				when 5 then -- loop body:
						js.reset
				when 6 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 21 -- skip loop
						end
				when 7 then -- loop body:
						js.reset
						if l_lnum > 0 then
							if not (l_lnum <= a_buf___6.item.b_ml.ml_line_count) then
								js.break
							end
						else
							js.break
						end
						if not js.loop_jumped and then (a_stop_lnum /= 0) then
							if a_dir___0 = 1 then
								l_tmp___2 := (l_lnum > a_stop_lnum).to_integer
							else
								l_tmp___2 := (l_lnum < a_stop_lnum).to_integer
							end
							if l_tmp___2.to_boolean then
								js.break
							end
						end
						if not js.loop_jumped and then ((a_tm.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32) then
							if (ex_cmds2_inst.profile_passed_limit (a_tm)).to_boolean then
								js.break
							end
						end
						if not js.loop_jumped then
							l_nmatched := regexp_inst.vim_regexec_multi (l_regmatch___0.address, a_win, a_buf___6, l_lnum, 0, a_tm)
							if globals_inst.called_emsg.to_boolean then
								js.break
							end
						end
						if not (not js.loop_jumped and then (l_nmatched > 0)) then
							l_pos := -1 + 20 -- skip if block
						end
				when 8 then -- if:
						l_matchpos.ce_gets (l_regmatch___0.startpos[0])
						l_endpos.ce_gets (l_regmatch___0.endpos[0])
						l_submatch := first_submatch (l_regmatch___0.address)
						if l_lnum + l_matchpos.lnum > a_buf___6.item.b_ml.ml_line_count then
							l_ptr.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")))
						else
							l_ptr.ce_gets (memline_inst.ml_get_buf (a_buf___6, l_lnum + l_matchpos.lnum, 0))
						end
						if a_dir___0 = 1 then
							if l_at_first_line.to_boolean then
								l_match_ok := 1
								from
								until
									js.loop_left
								loop
									js.reset
									if l_matchpos.lnum = 0 then
										if ((a_options___0).bit_and (64)).to_boolean then
											if l_nmatched = 1 then
												if l_endpos.col - 1 < l_start_pos.col + l_extra_col then
													l_tmp___7 := 1
												else
													l_tmp___7 := 0
												end
											else
												l_tmp___7 := 0
											end
											l_tmp___8 := l_tmp___7
										else
											l_tmp___8 := (l_matchpos.col - ((l_ptr[l_matchpos.col]).to_integer_32 = 0).to_integer < l_start_pos.col + l_extra_col).to_integer
										end
										if not l_tmp___8.to_boolean then
											js.break
										end
									else
										js.break
									end
									if not js.loop_jumped then
										if ((misc2_inst.vim_strchr (option_inst.p_cpo, ('c').code)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
											if l_nmatched > 1 then
												l_match_ok := 0
												js.break
											end
											if not js.loop_jumped then
												l_matchcol := l_endpos.col
												if l_matchcol = l_matchpos.col then
													if (l_ptr[l_matchcol]).to_integer_32 /= 0 then
														if globals_inst.has_mbyte.to_boolean then
															l_matchcol := l_matchcol + (globals_inst.mb_ptr2len.integer_32_item ([l_ptr + l_matchcol]))
														else
															l_matchcol := l_matchcol + 1
														end
													end
												end
											end
										else
											l_matchcol := l_matchpos.col
											if (l_ptr[l_matchcol]).to_integer_32 /= 0 then
												if globals_inst.has_mbyte.to_boolean then
													l_matchcol := l_matchcol + (globals_inst.mb_ptr2len.integer_32_item ([l_ptr + l_matchcol]))
												else
													l_matchcol := l_matchcol + 1
												end
											end
										end
									end
									if not js.loop_jumped then
										if (l_ptr[l_matchcol]).to_integer_32 = 0 then
											l_match_ok := 0
											js.break
										else
											l_nmatched := regexp_inst.vim_regexec_multi (l_regmatch___0.address, a_win, a_buf___6, l_lnum + l_matchpos.lnum, l_matchcol, a_tm)
											if l_nmatched = 0 then
												l_match_ok := 0
												js.break
											end
										end
									end
									if not js.loop_jumped then
										l_matchpos.ce_gets (l_regmatch___0.startpos[0])
										l_endpos.ce_gets (l_regmatch___0.endpos[0])
										l_submatch := first_submatch (l_regmatch___0.address)
										l_ptr.ce_gets (memline_inst.ml_get_buf (a_buf___6, l_lnum + l_matchpos.lnum, 0))
									end
								end
								js.reset
								if not l_match_ok.to_boolean then
									js.continue
								end
							end
						end
						if not js.loop_jumped and then (a_dir___0 = -1) then
							l_match_ok := 0
							from
							until
								js.loop_left
							loop
								js.reset
								if l_loop.to_boolean then
									l_match_ok := 1
									l_matchpos.ce_gets (l_regmatch___0.startpos[0])
									l_endpos.ce_gets (l_regmatch___0.endpos[0])
									l_submatch := first_submatch (l_regmatch___0.address)
								else
									if ((a_options___0).bit_and (64)).to_boolean then
										if l_lnum + l_regmatch___0.endpos[0].lnum < l_start_pos.lnum then
											l_tmp___9 := 1
										elseif l_lnum + l_regmatch___0.endpos[0].lnum = l_start_pos.lnum then
											if (l_regmatch___0.endpos[0].col - 1) + l_extra_col <= l_start_pos.col then
												l_tmp___9 := 1
											else
												l_tmp___9 := 0
											end
										else
											l_tmp___9 := 0
										end
										l_tmp___11 := l_tmp___9
									else
										if l_lnum + l_regmatch___0.startpos[0].lnum < l_start_pos.lnum then
											l_tmp___10 := 1
										elseif l_lnum + l_regmatch___0.startpos[0].lnum = l_start_pos.lnum then
											if l_regmatch___0.startpos[0].col + l_extra_col <= l_start_pos.col then
												l_tmp___10 := 1
											else
												l_tmp___10 := 0
											end
										else
											l_tmp___10 := 0
										end
										l_tmp___11 := l_tmp___10
									end
									if l_tmp___11.to_boolean then
										l_match_ok := 1
										l_matchpos.ce_gets (l_regmatch___0.startpos[0])
										l_endpos.ce_gets (l_regmatch___0.endpos[0])
										l_submatch := first_submatch (l_regmatch___0.address)
									else
										js.break
									end
								end
								if not js.loop_jumped then
									if ((misc2_inst.vim_strchr (option_inst.p_cpo, ('c').code)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
										if l_nmatched > 1 then
											js.break
										end
										if not js.loop_jumped then
											l_matchcol := l_endpos.col
											if l_matchcol = l_matchpos.col then
												if (l_ptr[l_matchcol]).to_integer_32 /= 0 then
													if globals_inst.has_mbyte.to_boolean then
														l_matchcol := l_matchcol + (globals_inst.mb_ptr2len.integer_32_item ([l_ptr + l_matchcol]))
													else
														l_matchcol := l_matchcol + 1
													end
												end
											end
										end
									else
										if l_matchpos.lnum > 0 then
											js.break
										end
										if not js.loop_jumped then
											l_matchcol := l_matchpos.col
											if (l_ptr[l_matchcol]).to_integer_32 /= 0 then
												if globals_inst.has_mbyte.to_boolean then
													l_matchcol := l_matchcol + (globals_inst.mb_ptr2len.integer_32_item ([l_ptr + l_matchcol]))
												else
													l_matchcol := l_matchcol + 1
												end
											end
										end
									end
								end
								if not js.loop_jumped then
									if (l_ptr[l_matchcol]).to_integer_32 = 0 then
										js.break
									else
										l_nmatched := regexp_inst.vim_regexec_multi (l_regmatch___0.address, a_win, a_buf___6, l_lnum + l_matchpos.lnum, l_matchcol, a_tm)
										if l_nmatched = 0 then
											js.break
										end
									end
								end
								if not js.loop_jumped then
									l_ptr.ce_gets (memline_inst.ml_get_buf (a_buf___6, l_lnum + l_matchpos.lnum, 0))
								end
							end
							js.reset
							if not l_match_ok.to_boolean then
								js.continue
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 20 -- skip if block
						end
				when 9 then -- if:
						if not (((a_options___0).bit_and (64)).to_boolean) then
							l_pos := -1 + 18 -- skip if block
						end
				when 10 then -- if:
						if ((a_options___0).bit_and (128)).to_boolean then
							l_pos := -1 + 16 -- skip if block
						end
				when 11 then -- if:
						if l_matchpos.lnum /= l_endpos.lnum then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:
						if l_matchpos.col = l_endpos.col then
							a_pos___3.item.lnum := l_lnum + l_matchpos.lnum
							a_pos___3.item.col := l_matchpos.col
						else
							l_pos := -1 + 14 -- goto _L
						end
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 14 then -- else: | _L:
						a_pos___3.item.lnum := l_lnum + l_endpos.lnum
						a_pos___3.item.col := l_endpos.col
						if l_endpos.col = 0 then
							if a_pos___3.item.lnum > 1 then
								a_pos___3.item.lnum := (a_pos___3.item.lnum) - 1
								a_pos___3.item.col := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((memline_inst.ml_get_buf (a_buf___6, a_pos___3.item.lnum, 0))))).to_integer_32
							end
						else
							a_pos___3.item.col := (a_pos___3.item.col) - 1
							if globals_inst.has_mbyte.to_boolean then
								if a_pos___3.item.lnum <= a_buf___6.item.b_ml.ml_line_count then
									l_ptr.ce_gets (memline_inst.ml_get_buf (a_buf___6, a_pos___3.item.lnum, 0))
									a_pos___3.item.col := a_pos___3.item.col - (globals_inst.mb_head_off.integer_32_item ([l_ptr, l_ptr + a_pos___3.item.col]))
								end
							end
						end
				when 15 then -- if done | if block done, skip else block:
						l_pos := -1 + 17
				when 16 then -- else:
						a_pos___3.item.lnum := l_lnum + l_matchpos.lnum
						a_pos___3.item.col := l_matchpos.col
				when 17 then -- if done | if block done, skip else block:
						l_pos := -1 + 19
				when 18 then -- else:
						a_pos___3.item.lnum := l_lnum + l_matchpos.lnum
						a_pos___3.item.col := l_matchpos.col
				when 19 then
						a_pos___3.item.coladd := 0
						l_found := 1
						globals_inst.search_match_lines := l_endpos.lnum - l_matchpos.lnum
						globals_inst.search_match_endcol := l_endpos.col
						js.break
				when 20 then -- if done | if done
						if not js.loop_jumped then
							misc1_inst.line_breakcheck
							if globals_inst.got_int.to_boolean then
								js.break
							end
						end
						if not js.loop_jumped and then (((a_options___0).bit_and (2048)).to_boolean) then
							if (((l_lnum - a_pos___3.item.lnum)).bit_and (63)) = 0 then
								if (getchar_inst.char_avail).to_boolean then
									l_break_loop := 1
									js.break
								end
							end
						end
						if not js.loop_jumped and then (l_loop.to_boolean) then
							if l_lnum = l_start_pos.lnum then
								js.break
							end
						end
						if not js.loop_left then
							l_lnum := l_lnum + a_dir___0.to_integer_32
							l_at_first_line := 0
						end
						l_pos := -1 + 6 -- back to loop condition
				when 21 then -- loop done
						js.reset
						l_at_first_line := 0
						if not option_inst.p_ws.to_boolean then
							js.break
						elseif a_stop_lnum /= 0 then
							js.break
						elseif globals_inst.got_int.to_boolean then
							js.break
						elseif globals_inst.called_emsg.to_boolean then
							js.break
						elseif l_break_loop.to_boolean then
							js.break
						elseif l_found.to_boolean then
							js.break
						elseif l_loop.to_boolean then
							js.break
						end
						if not js.loop_jumped then
							if a_dir___0 = -1 then
								l_lnum := a_buf___6.item.b_ml.ml_line_count
							else
								l_lnum := (1).to_integer_32
							end
							if not (option_inst.shortmess (('s').code)).to_boolean then
								if ((a_options___0).bit_and (12)).to_boolean then
									if a_dir___0 = -1 then
										l_tmp___19.ce_gets (globals_inst.top_bot_msg)
									else
										l_tmp___19.ce_gets (globals_inst.bot_top_msg)
									end
									message_inst.give_warning (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (l_tmp___19))), 1)
								end
							end
							l_loop := l_loop + 1
						end
						l_pos := -1 + 4 -- back to loop condition
				when 22 then -- loop done
						js.reset
						if globals_inst.got_int.to_boolean then
							js.break
						elseif globals_inst.called_emsg.to_boolean then
							js.break
						elseif l_break_loop.to_boolean then
							js.break
						end
						if not js.loop_jumped then
							l_count___2 := l_count___2 - 1
							if l_count___2 > 0 then
								if not l_found.to_boolean then
									js.break
								end
							else
								js.break
							end
						end
						l_pos := -1 + 2 -- back to loop condition
				when 23 then -- loop done
						js.reset
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_regmatch___0.regprog))
						globals_inst.called_emsg := (globals_inst.called_emsg).bit_or (l_save_called_emsg)
						if not l_found.to_boolean then
							if globals_inst.got_int.to_boolean then
								message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_interr))))).do_nothing
							elseif ((a_options___0).bit_and (12)) = 12 then
								if option_inst.p_ws.to_boolean then
									message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_patnotf2)))), mr_pattern).do_nothing
								elseif l_lnum = 0 then
									message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E384: search hit TOP without match for: %%s")))), mr_pattern).do_nothing
								else
									message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E385: search hit BOTTOM without match for: %%s")))), mr_pattern).do_nothing
								end
							end
							Result := 0
							js.return
						end
				when 24 then -- if done
					if not js.return_called then
						if a_pos___3.item.lnum > a_buf___6.item.b_ml.ml_line_count then
							a_pos___3.item.lnum := a_buf___6.item.b_ml.ml_line_count
							a_pos___3.item.col := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((memline_inst.ml_get_buf (a_buf___6, a_pos___3.item.lnum, 0))))).to_integer_32
							if a_pos___3.item.col > 0 then
								a_pos___3.item.col := (a_pos___3.item.col) - 1
							end
						end
						Result := (l_submatch + 1)
					end
				when 25 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	set_search_direction (a_cdir: INTEGER_32)
		do
			spats[0].off.dir := a_cdir
		end

	set_vv_searchforward
		do
			eval_inst.set_vim_var_nr (53, (spats[0].off.dir = 47).to_integer)
		end

	first_submatch (a_rp: CE_POINTER [PD_REGMMATCH_T]): INTEGER_32
		local
			l_submatch: INTEGER_32
			js: JUMP_STATE
		do
			l_submatch := 1
			from
			until
				not (not js.loop_left and then (not (a_rp.item.startpos[l_submatch].lnum >= 0)))
			loop
				js.reset
				if l_submatch = 9 then
					l_submatch := 0
					js.break
				end
				if not js.loop_jumped then
					l_submatch := l_submatch + 1
				end
			end
			js.reset
			Result := l_submatch
		end

	do_search (a_oap: CE_POINTER [PD_OPARG_S]; a_dirc: INTEGER_32; a_pat: CE_POINTER [NATURAL_8]; a_count___2: INTEGER_32; a_options___0: INTEGER_32; a_tm: CE_POINTER [SD_TIMEVAL]): INTEGER_32
		local
			l_dirc: INTEGER_32
			l_pat: CE_POINTER [NATURAL_8]
			l_pos___3: PD_POS_T
			l_searchstr: CE_POINTER [NATURAL_8]
			l_old_off: PD_SOFFSET
			l_retval: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_c: INTEGER_32
			l_dircp: CE_POINTER [NATURAL_8]
			l_strcopy: CE_POINTER [NATURAL_8]
			l_ps: CE_POINTER [NATURAL_8]
			l_tmp___3: NATURAL_32
			l_tmp___5: CE_POINTER [NATURAL_8]
			l_msgbuf: CE_POINTER [NATURAL_8]
			l_trunc: CE_POINTER [NATURAL_8]
			l_tmp___10: CE_POINTER [NATURAL_8]
			l_tmp___11: CE_POINTER [NATURAL_8]
			l_tmp___12: CE_POINTER [NATURAL_8]
			l_tmp___13: CE_POINTER [NATURAL_8]
			l_tmp___17: INTEGER_32
			l_tmp___18: INTEGER_32
			l_tmp___21: INTEGER_32
			l_tmp___23: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_pat.make
			create l_pos___3.make
			create l_searchstr.make
			create l_old_off.make
			create l_p___0.make
			create l_dircp.make
			create l_strcopy.make
			create l_ps.make
			create l_tmp___5.make
			create l_msgbuf.make
			create l_trunc.make
			create l_tmp___10.make
			create l_tmp___11.make
			create l_tmp___12.make
			create l_tmp___13.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_dirc := a_dirc
					l_pat.ce_gets (a_pat)
					l_strcopy.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					if (spats[0].off.line).to_boolean then
						if ((misc2_inst.vim_strchr (option_inst.p_cpo, ('o').code)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							spats[0].off.line := 0
							spats[0].off.off := 0
						end
					end
					l_old_off.ce_gets (spats[0].off)
					l_pos___3.ce_gets (globals_inst.curwin.item.w_cursor)
					if l_dirc = 0 then
						l_dirc := spats[0].off.dir
					else
						spats[0].off.dir := l_dirc
						set_vv_searchforward
					end
					if ((a_options___0).bit_and (1)).to_boolean then
						if l_dirc = 47 then
							l_dirc := ('?').code
						else
							l_dirc := ('/').code
						end
					end
					if l_dirc = 47 then
						if (fold_inst.hasFolding (l_pos___3.lnum, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (l_pos___3.c_pointer + {PD_POS_T}.lnum_offset))).to_boolean then
							l_pos___3.col := (2147483645).to_integer_32
						end
					elseif (fold_inst.hasFolding (l_pos___3.lnum, create {CE_POINTER [INTEGER_32]}.make_shared (l_pos___3.c_pointer + {PD_POS_T}.lnum_offset), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))).to_boolean then
						l_pos___3.col := 0
					end
					if globals_inst.no_hlsearch.to_boolean then
						if not ((a_options___0).bit_and (1024)).to_boolean then
							screen_inst.redraw_all_later (35)
							globals_inst.no_hlsearch := 0
						end
					end
				when 1 then -- loop condition:
					if js.loop_left then
						l_pos := -1 + 72 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						l_searchstr.ce_gets (l_pat)
						l_dircp.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						if (l_pat.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_pos := -1 + 9 -- goto _L
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 5 then -- else:
						if (l_pat.item).to_integer_32 /= 0 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_pos := -1 + 9 -- goto _L
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 8 then -- else:
						if (l_pat.item).to_integer_32 /= l_dirc then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if: | _L:
						if ((spats[0].pat).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_noprevre))))).do_nothing
							l_retval := 0
							l_pos := -1 + 73 -- goto end_do_search
						end
				when 10 then
						l_searchstr.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")))
				when 11 then -- if done | if done
						if (l_pat.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 47 -- skip if block
						end
				when 12 then -- if:
						if (l_pat.item).to_integer_32 = 0 then
							l_pos := -1 + 47 -- skip if block
						end
				when 13 then -- if:
						l_ps.ce_gets (l_strcopy)
						l_p___0.ce_gets (regexp_inst.skip_regexp (l_pat, l_dirc, option_inst.p_magic, l_strcopy.address))
						if (l_strcopy.c_pointer.to_integer_32).to_natural_32 /= (l_ps.c_pointer.to_integer_32).to_natural_32 then
							l_tmp___3 := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_pat))
							globals_inst.searchcmdlen := globals_inst.searchcmdlen + (l_tmp___3 - (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_strcopy)))).to_integer_32
							l_pat.ce_gets (l_strcopy)
							l_searchstr.ce_gets (l_strcopy)
						end
						if (l_p___0.item).to_integer_32 = l_dirc then
							l_dircp.ce_gets (l_p___0)
							l_tmp___5.ce_gets (l_p___0)
							l_p___0.ce_gets (l_p___0 + 1)
							l_tmp___5.item := (('%/0/').code).to_natural_8
						end
						spats[0].off.line := 0
						spats[0].off.end2 := 0
						spats[0].off.off := 0
						if (l_p___0.item).to_integer_32 /= 43 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						spats[0].off.line := 1
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 16 then -- else:
						if (l_p___0.item).to_integer_32 /= 45 then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						spats[0].off.line := 1
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 19 then -- else:
						if not ((l_p___0.item).to_integer_32 >= 48) then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						if (l_p___0.item).to_integer_32 <= 57 then
							spats[0].off.line := 1
						else
							l_pos := -1 + 22 -- goto _L___1
						end
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 22 then -- else: | _L___1:
						if not (((a_options___0).bit_and (16)).to_boolean) then
							l_pos := -1 + 31 -- skip if block
						end
				when 23 then -- if:
						if (l_p___0.item).to_integer_32 /= 101 then
							l_pos := -1 + 26 -- skip if block
						end
				when 24 then -- if:
						l_pos := -1 + 30 -- goto _L___0
				when 25 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 26 then -- else:
						if (l_p___0.item).to_integer_32 /= 115 then
							l_pos := -1 + 29 -- skip if block
						end
				when 27 then -- if:
						l_pos := -1 + 30 -- goto _L___0
				when 28 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 29 then -- else:
						if (l_p___0.item).to_integer_32 /= 98 then
							l_pos := -1 + 31 -- skip if block
						end
				when 30 then -- if: | _L___0:
						if (l_p___0.item).to_integer_32 = 101 then
							spats[0].off.end2 := 64
						end
						l_p___0.ce_gets (l_p___0 + 1)
				when 31 then -- if done | if done | if done | if done | if done | if done
						if not ((l_p___0.item).to_integer_32 >= 48) then
							l_pos := -1 + 34 -- skip if block
						end
				when 32 then -- if:
						if (l_p___0.item).to_integer_32 <= 57 then
							l_pos := -1 + 38 -- goto _L___4
						else
							l_pos := -1 + 34 -- goto _L___5
						end
				when 33 then -- if block done, skip else block:
						l_pos := -1 + 46
				when 34 then -- else: | _L___5:
						if (l_p___0.item).to_integer_32 /= 43 then
							l_pos := -1 + 37 -- skip if block
						end
				when 35 then -- if:
						l_pos := -1 + 38 -- goto _L___4
				when 36 then -- if block done, skip else block:
						l_pos := -1 + 46
				when 37 then -- else:
						if (l_p___0.item).to_integer_32 /= 45 then
							l_pos := -1 + 46 -- skip if block
						end
				when 38 then -- if: | _L___4:
						if not ((l_p___0.item).to_integer_32 >= 48) then
							l_pos := -1 + 41 -- skip if block
						end
				when 39 then -- if:
						if (l_p___0.item).to_integer_32 <= 57 then
							spats[0].off.off := atol (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0))
						else
							l_pos := -1 + 41 -- goto _L___3
						end
				when 40 then -- if block done, skip else block:
						l_pos := -1 + 45
				when 41 then -- else: | _L___3:
						if not ((l_p___0[1]).to_integer_32 >= 48) then
							l_pos := -1 + 44 -- skip if block
						end
				when 42 then -- if:
						if (l_p___0[1]).to_integer_32 <= 57 then
							spats[0].off.off := atol (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0))
						else
							l_pos := -1 + 44 -- goto _L___2
						end
				when 43 then -- if block done, skip else block:
						l_pos := -1 + 45
				when 44 then -- else: | _L___2:
						if (l_p___0.item).to_integer_32 = 45 then
							spats[0].off.off := -1
						else
							spats[0].off.off := 1
						end
				when 45 then -- if done
						l_p___0.ce_gets (l_p___0 + 1)
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_p___0.item).to_integer_32 >= 48 then
								if not ((l_p___0.item).to_integer_32 <= 57) then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_p___0.ce_gets (l_p___0 + 1)
							end
						end
						js.reset
				when 46 then -- if done | if done
						globals_inst.searchcmdlen := globals_inst.searchcmdlen + (l_p___0.distance (l_pat))
						l_pat.ce_gets (l_p___0)
				when 47 then -- if done | if done
						if not (((a_options___0).bit_and (2)).to_boolean) then
							l_pos := -1 + 61 -- skip if block
						end
				when 48 then -- if:
						if not ((screen_inst.messaging).to_boolean) then
							l_pos := -1 + 61 -- skip if block
						end
				when 49 then -- if:
						if globals_inst.cmd_silent.to_boolean then
							l_pos := -1 + 61 -- skip if block
						end
				when 50 then -- if:
						if globals_inst.msg_silent /= 0 then
							l_pos := -1 + 61 -- skip if block
						end
				when 51 then -- if:
						if (l_searchstr.item).to_integer_32 = 0 then
							l_p___0.ce_gets (spats[last_idx].pat)
						else
							l_p___0.ce_gets (l_searchstr)
						end
						l_msgbuf.ce_gets (misc2_inst.alloc ((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0))) + {NATURAL_32} 40))
						if (l_msgbuf.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 61 -- skip if block
						end
				when 52 then -- if:
						l_msgbuf[0] := l_dirc.to_natural_8
						if globals_inst.enc_utf8.to_boolean then
							if (mbyte_inst.utf_iscomposing ((mbyte_inst.utf_ptr2char (l_p___0)))).to_boolean then
								l_msgbuf[1] := ((' ').code).to_natural_8
								strcpy (create {CE_POINTER [INTEGER_8]}.make_cast ((l_msgbuf + 2)), create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0)).do_nothing
							else
								strcpy (create {CE_POINTER [INTEGER_8]}.make_cast ((l_msgbuf + 1)), create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0)).do_nothing
							end
						else
							strcpy (create {CE_POINTER [INTEGER_8]}.make_cast ((l_msgbuf + 1)), create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0)).do_nothing
						end
						if not ((spats[0].off.line).to_boolean) then
							l_pos := -1 + 55 -- skip if block
						end
				when 53 then -- if:
						l_pos := -1 + 59 -- goto _L___6
				when 54 then -- if block done, skip else block:
						l_pos := -1 + 60
				when 55 then -- else:
						if not ((spats[0].off.end2).to_boolean) then
							l_pos := -1 + 58 -- skip if block
						end
				when 56 then -- if:
						l_pos := -1 + 59 -- goto _L___6
				when 57 then -- if block done, skip else block:
						l_pos := -1 + 60
				when 58 then -- else:
						if not ((spats[0].off.off).to_boolean) then
							l_pos := -1 + 60 -- skip if block
						end
				when 59 then -- if: | _L___6:
						l_p___0.ce_gets (l_msgbuf + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_msgbuf))).to_integer_32)
						l_tmp___10.ce_gets (l_p___0)
						l_p___0.ce_gets (l_p___0 + 1)
						l_tmp___10.item := l_dirc.to_natural_8
						if (spats[0].off.end2).to_boolean then
							l_tmp___11.ce_gets (l_p___0)
							l_p___0.ce_gets (l_p___0 + 1)
							l_tmp___11.item := (('e').code).to_natural_8
						elseif not (spats[0].off.line).to_boolean then
							l_tmp___12.ce_gets (l_p___0)
							l_p___0.ce_gets (l_p___0 + 1)
							l_tmp___12.item := (('s').code).to_natural_8
						end
						if spats[0].off.off > 0 then
							l_tmp___13.ce_gets (l_p___0)
							l_p___0.ce_gets (l_p___0 + 1)
							l_tmp___13.item := (('+').code).to_natural_8
						elseif (spats[0].off.line).to_boolean then
							l_tmp___13.ce_gets (l_p___0)
							l_p___0.ce_gets (l_p___0 + 1)
							l_tmp___13.item := (('+').code).to_natural_8
						end
						if spats[0].off.off /= 0 then
							sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), ce_string ("%%ld"), spats[0].off.off]).do_nothing
						elseif (spats[0].off.line).to_boolean then
							sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), ce_string ("%%ld"), spats[0].off.off]).do_nothing
						else
							l_p___0.item := (('%/0/').code).to_natural_8
						end
				when 60 then -- if done | if done
						message_inst.msg_start
						l_trunc.ce_gets (message_inst.msg_strtrunc (l_msgbuf, 0))
						if (l_trunc.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							message_inst.msg_outtrans (l_trunc).do_nothing
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_trunc))
						else
							message_inst.msg_outtrans (l_msgbuf).do_nothing
						end
						message_inst.msg_clr_eos
						message_inst.msg_check
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_msgbuf))
						ex_getln_inst.gotocmdline (0)
						term_inst.out_flush
						globals_inst.msg_nowait := 1
				when 61 then -- if done | if done | if done | if done | if done
						if not (spats[0].off.line).to_boolean then
							if (spats[0].off.off).to_boolean then
								if (l_pos___3.col).to_integer_32 < 2147483645 then
									if spats[0].off.off > 0 then
										l_c := spats[0].off.off
										from
										until
											not (not js.loop_left and then (l_c.to_boolean))
										loop
											js.reset
											if (misc2_inst.decl (l_pos___3.address)) = -1 then
												js.break
											end
											if not js.loop_jumped then
												l_c := l_c - 1
											end
										end
										js.reset
										if l_c.to_boolean then
											l_pos___3.lnum := (0).to_integer_32
											l_pos___3.col := (2147483647).to_integer_32
										end
									else
										l_c := spats[0].off.off
										from
										until
											not (not js.loop_left and then (l_c.to_boolean))
										loop
											js.reset
											if (misc2_inst.incl (l_pos___3.address)) = -1 then
												js.break
											end
											if not js.loop_jumped then
												l_c := l_c + 1
											end
										end
										js.reset
										if l_c.to_boolean then
											l_pos___3.lnum := globals_inst.curbuf.item.b_ml.ml_line_count + 1
											l_pos___3.col := 0
										end
									end
								end
							end
						end
						if (l_pat.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							if (l_pat.item).to_integer_32 = 59 then
								l_tmp___17 := 0
							else
								l_tmp___17 := 128
							end
						else
							l_tmp___17 := 128
						end
						if l_dirc = 47 then
							l_tmp___18 := 1
						else
							l_tmp___18 := -1
						end
						l_c := (searchit (globals_inst.curwin, globals_inst.curbuf, l_pos___3.address, l_tmp___18, l_searchstr, a_count___2, spats[0].off.end2 + ((a_options___0).bit_and ((3372 + l_tmp___17))), 2, (0).to_integer_32, a_tm)).to_integer_32
						if (l_dircp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_dircp.item := l_dirc.to_natural_8
						end
						if l_c = 0 then
							l_retval := 0
							l_pos := -1 + 73 -- goto end_do_search
						end
				when 62 then
						if (spats[0].off.end2).to_boolean then
							if (a_oap.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								a_oap.item.inclusive := 1
							end
						end
						l_retval := 1
						if ((a_options___0).bit_and (128)).to_boolean then
							l_pos := -1 + 65 -- skip if block
						end
				when 63 then -- if:
						l_pos := -1 + 67 -- goto _L___7
				when 64 then -- if block done, skip else block:
						l_pos := -1 + 68
				when 65 then -- else:
						if (l_pat.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 68 -- skip if block
						end
				when 66 then -- if:
						if (l_pat.item).to_integer_32 /= 59 then
							l_pos := -1 + 68 -- skip if block
						end
				when 67 then -- if: | _L___7:
						if (spats[0].off.line).to_boolean then
							l_c := l_pos___3.lnum + spats[0].off.off
							if l_c < 1 then
								l_pos___3.lnum := (1).to_integer_32
							elseif l_c > globals_inst.curbuf.item.b_ml.ml_line_count then
								l_pos___3.lnum := globals_inst.curbuf.item.b_ml.ml_line_count
							else
								l_pos___3.lnum := l_c
							end
							l_pos___3.col := 0
							l_retval := 2
						elseif (l_pos___3.col).to_integer_32 < 2147483645 then
							l_c := spats[0].off.off
							if l_c > 0 then
								from
								until
									js.loop_left
								loop
									js.reset
									l_tmp___21 := l_c
									l_c := l_c - 1
									if not (l_tmp___21 > 0) then
										js.break
									end
									if not js.loop_jumped then
										if (misc2_inst.incl (l_pos___3.address)) = -1 then
											js.break
										end
									end
								end
								js.reset
							else
								from
								until
									js.loop_left
								loop
									js.reset
									l_tmp___23 := l_c
									l_c := l_c + 1
									if not (l_tmp___23 < 0) then
										js.break
									end
									if not js.loop_jumped then
										if (misc2_inst.decl (l_pos___3.address)) = -1 then
											js.break
										end
									end
								end
								js.reset
							end
						end
				when 68 then -- if done | if done
						if not ((a_options___0).bit_and (16)).to_boolean then
							js.break
						elseif (l_pat.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							js.break
						elseif (l_pat.item).to_integer_32 /= 59 then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 71 -- skip if block
						end
				when 69 then -- if:
						l_pat.ce_gets (l_pat + 1)
						l_dirc := (l_pat.item).to_integer_32
						if l_dirc /= 63 then
							if l_dirc /= 47 then
								l_retval := 0
								message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E386: Expected %'?%' or %'/%'  after %';%'"))))).do_nothing
								l_pos := -1 + 73 -- goto end_do_search
							end
						end
				when 70 then
						l_pat.ce_gets (l_pat + 1)
				when 71 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 72 then -- loop done
					js.reset
					if ((a_options___0).bit_and (512)).to_boolean then
						mark_inst.setpcmark
					end
					globals_inst.curwin.item.w_cursor := l_pos___3
					globals_inst.curwin.item.w_set_curswant := 1
				when 73 then -- end_do_search:
					if ((a_options___0).bit_and (1024)).to_boolean then
						spats[0].off := l_old_off
					end
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_strcopy))
					Result := l_retval
				when 74 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	search_for_exact_line (a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_pos___3: CE_POINTER [PD_POS_T]; a_dir___0: INTEGER_32; a_pat: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_start___1: INTEGER_32
			l_ptr: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp___5: INTEGER_32
			l_tmp___8: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_ptr.make
			create l_p___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_start___1 := (0).to_integer_32
					if a_buf___6.item.b_ml.ml_line_count = 0 then
						Result := 0
						js.return
					end
					if js.return_called then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if: | loop condition:
						if js.loop_left then
							l_pos := -1 + 8 -- skip loop
						end
				when 2 then -- loop body:
						js.reset
						a_pos___3.item.lnum := a_pos___3.item.lnum + a_dir___0.to_integer_32
						if a_pos___3.item.lnum < 1 then
							if option_inst.p_ws.to_boolean then
								a_pos___3.item.lnum := a_buf___6.item.b_ml.ml_line_count
								if not (option_inst.shortmess (('s').code)).to_boolean then
									message_inst.give_warning (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (globals_inst.top_bot_msg))), 1)
								end
							else
								a_pos___3.item.lnum := (1).to_integer_32
								js.break
							end
						elseif a_pos___3.item.lnum > a_buf___6.item.b_ml.ml_line_count then
							if option_inst.p_ws.to_boolean then
								a_pos___3.item.lnum := (1).to_integer_32
								if not (option_inst.shortmess (('s').code)).to_boolean then
									message_inst.give_warning (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (globals_inst.bot_top_msg))), 1)
								end
							else
								a_pos___3.item.lnum := (1).to_integer_32
								js.break
							end
						end
						if not js.loop_jumped and then (a_pos___3.item.lnum = l_start___1) then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 7 -- skip if block
						end
				when 3 then -- if:
						if l_start___1 = 0 then
							l_start___1 := a_pos___3.item.lnum
						end
						l_ptr.ce_gets (memline_inst.ml_get_buf (a_buf___6, a_pos___3.item.lnum, 0))
						l_p___0.ce_gets (charset_inst.skipwhite (l_ptr))
						a_pos___3.item.col := l_p___0.distance (l_ptr)
						if not (((globals_inst.compl_cont_status).bit_and (1)).to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if not ((globals_inst.compl_cont_status).bit_and (16)).to_boolean then
							if option_inst.p_ic.to_boolean then
								l_tmp___5 := (mbyte_inst.mb_strnicmp (l_p___0, a_pat, (2147483647).to_natural_32))
							else
								l_tmp___5 := (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), create {CE_POINTER [INTEGER_8]}.make_cast (a_pat)))
							end
							if l_tmp___5 = 0 then
								Result := 1
								js.return
							end
						else
							l_pos := -1 + 6 -- goto _L
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L:
						if (l_p___0.item).to_integer_32 /= 0 then
							if option_inst.p_ic.to_boolean then
								l_tmp___8 := (mbyte_inst.mb_strnicmp (l_p___0, a_pat, globals_inst.compl_length.to_natural_32))
							else
								l_tmp___8 := (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), create {CE_POINTER [INTEGER_8]}.make_cast (a_pat), globals_inst.compl_length.to_natural_32))
							end
							if l_tmp___8 = 0 then
								Result := 1
								js.return
							end
						end
				when 7 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 8 then -- loop done
						js.reset
				when 9 then -- if done
					if not js.return_called then
						Result := 0
					end
				when 10 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	searchc (a_cap: CE_POINTER [PD_CMDARG_S]; a_t_cmd: INTEGER_32): INTEGER_32
		local
			l_t_cmd: INTEGER_32
			l_c: INTEGER_32
			l_dir___0: INTEGER_32
			l_count___2: INTEGER_32
			l_col: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_tmp___5: INTEGER_32
			js: JUMP_STATE
		do
			create l_p___0.make

			l_t_cmd := a_t_cmd
			l_c := a_cap.item.nchar
			l_dir___0 := a_cap.item.arg
			l_count___2 := a_cap.item.count1
			if l_c /= 0 then
				if not globals_inst.KeyStuffed.to_boolean then
					lastc := l_c
					lastcdir := l_dir___0
					last_t_cmd := l_t_cmd
					bytelen := globals_inst.mb_char2bytes.integer_32_item ([l_c, bytes])
					if a_cap.item.ncharC1 /= 0 then
						bytelen := bytelen + (globals_inst.mb_char2bytes.integer_32_item ([a_cap.item.ncharC1, bytes + bytelen]))
						if a_cap.item.ncharC2 /= 0 then
							bytelen := bytelen + (globals_inst.mb_char2bytes.integer_32_item ([a_cap.item.ncharC2, bytes + bytelen]))
						end
					end
				end
			else
				if lastc = 0 then
					Result := 0
					js.return
				end
				if not js.return_called then
					if l_dir___0.to_boolean then
						l_dir___0 := -lastcdir
					else
						l_dir___0 := lastcdir
					end
					l_t_cmd := last_t_cmd
					l_c := lastc
				end
			end
			if not js.return_called then
				if l_dir___0 = -1 then
					(a_cap.item.oap).item.inclusive := 0
				else
					(a_cap.item.oap).item.inclusive := 1
				end
				l_p___0.ce_gets (memline_inst.ml_get_curline)
				l_col := globals_inst.curwin.item.w_cursor.col
				l_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0))).to_integer_32
				from
				until
					js.loop_left
				loop
					js.reset
					l_tmp___5 := l_count___2
					l_count___2 := l_count___2 - 1
					if not l_tmp___5.to_boolean then
						js.break
					end
					if not js.loop_jumped then
						if globals_inst.has_mbyte.to_boolean then
							from
							until
								js.loop_left
							loop
								js.reset
								if l_dir___0 > 0 then
									l_col := l_col + (globals_inst.mb_ptr2len.integer_32_item ([l_p___0 + l_col]))
									if l_col >= l_len then
										Result := 0
										js.return
									end
								else
									if l_col = 0 then
										Result := 0
										js.return
									end
									if not js.return_called then
										l_col := l_col - ((globals_inst.mb_head_off.integer_32_item ([l_p___0, (l_p___0 + l_col) - 1])) + 1)
									end
								end
								if not js.return_called then
									if bytelen = 1 then
										if (l_p___0[l_col]).to_integer_32 = l_c then
											js.break
										end
									elseif (memcmp (create {CE_POINTER [ANY]}.make_cast ((l_p___0 + l_col)), create {CE_POINTER [ANY]}.make_cast (bytes), bytelen.to_natural_32)) = 0 then
										js.break
									end
								end
							end
							js.reset
						else
							from
							until
								js.loop_left
							loop
								js.reset
								l_col := l_col + l_dir___0
								if l_col < 0 then
									Result := 0
									js.return
								elseif l_col >= l_len then
									Result := 0
									js.return
								end
								if not js.return_called and then ((l_p___0[l_col]).to_integer_32 = l_c) then
									js.break
								end
							end
							js.reset
						end
					end
				end
				js.reset
			end
			if not js.return_called then
				if l_t_cmd.to_boolean then
					l_col := l_col - l_dir___0
					if globals_inst.has_mbyte.to_boolean then
						if l_dir___0 < 0 then
							l_col := l_col + (bytelen - 1)
						else
							l_col := l_col - (globals_inst.mb_head_off.integer_32_item ([l_p___0, l_p___0 + l_col]))
						end
					end
				end
				globals_inst.curwin.item.w_cursor.col := l_col
				Result := 1
			end
		end

	findmatch (a_oap: CE_POINTER [PD_OPARG_S]; a_initc: INTEGER_32): CE_POINTER [PD_POS_T]
		do
			Result := (findmatchlimit (a_oap, a_initc, 0, 0))
		end

	check_prevcol (a_linep: CE_POINTER [NATURAL_8]; a_col: INTEGER_32; a_ch: INTEGER_32; a_prevcol: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_col: INTEGER_32
			l_tmp___0: INTEGER_32
		do
			l_col := a_col
			l_col := l_col - 1
			if l_col > 0 then
				if globals_inst.has_mbyte.to_boolean then
					l_col := l_col - (globals_inst.mb_head_off.integer_32_item ([a_linep, a_linep + l_col]))
				end
			end
			if ((a_prevcol).c_pointer /= default_pointer) then
				a_prevcol.item := l_col
			end
			if l_col >= 0 then
				if (a_linep[l_col]).to_integer_32 = a_ch then
					l_tmp___0 := 1
				else
					l_tmp___0 := 0
				end
			else
				l_tmp___0 := 0
			end
			Result := l_tmp___0
		end

	findmatchlimit (a_oap: CE_POINTER [PD_OPARG_S]; a_initc: INTEGER_32; a_flags___0: INTEGER_32; a_maxtravel: INTEGER_32): CE_POINTER [PD_POS_T]
		local
			l_initc: INTEGER_32
			l_findc: INTEGER_32
			l_c: INTEGER_32
			l_count___2: INTEGER_32
			l_backwards: INTEGER_32
			l_inquote: INTEGER_32
			l_linep: CE_POINTER [NATURAL_8]
			l_ptr: CE_POINTER [NATURAL_8]
			l_do_quotes: INTEGER_32
			l_at_start___0: INTEGER_32
			l_hash_dir: INTEGER_32
			l_comment_dir: INTEGER_32
			l_match_pos: PD_POS_T
			l_start_in_quotes: INTEGER_32
			l_traveled: INTEGER_32
			l_ignore_cend: INTEGER_32
			l_cpo_match: INTEGER_32
			l_cpo_bsl: INTEGER_32
			l_match_escaped: INTEGER_32
			l_dir___0: INTEGER_32
			l_comment_col: INTEGER_32
			l_lispcomm: INTEGER_32
			l_lisp: INTEGER_32
			l_col: INTEGER_32
			l_bslcnt: INTEGER_32
			l_tmp___19: INTEGER_32
			l_col___0: INTEGER_32
			l_col___1: INTEGER_32
			l_bslcnt___0: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_linep.make
			create l_ptr.make
			create l_match_pos.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_initc := a_initc
					l_findc := 0
					l_count___2 := 0
					l_backwards := 0
					l_inquote := 0
					l_hash_dir := 0
					l_comment_dir := 0
					l_traveled := 0
					l_ignore_cend := 0
					l_match_escaped := 0
					l_comment_col := 2147483647
					l_lispcomm := 0
					l_lisp := globals_inst.curbuf.item.b_p_lisp
					pos___1.ce_gets (globals_inst.curwin.item.w_cursor)
					l_linep.ce_gets (memline_inst.ml_get (pos___1.lnum))
					l_cpo_match := (((misc2_inst.vim_strchr (option_inst.p_cpo, ('%%').code)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer
					l_cpo_bsl := (((misc2_inst.vim_strchr (option_inst.p_cpo, ('M').code)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer
					if ((a_flags___0).bit_and (1)).to_boolean then
						l_dir___0 := -1
					elseif ((a_flags___0).bit_and (2)).to_boolean then
						l_dir___0 := 1
					else
						l_dir___0 := 0
					end
					if l_initc /= 47 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L___2
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 36
				when 3 then -- else:
						if l_initc /= 42 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L___2:
						l_comment_dir := l_dir___0
						if l_initc = 47 then
							l_ignore_cend := 1
						end
						if l_dir___0 = 1 then
							l_backwards := 0
						else
							l_backwards := 1
						end
						l_initc := ('%/0/').code
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 36
				when 6 then -- else:
						if l_initc = 35 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if l_initc /= 0 then
							l_ptr.ce_gets (globals_inst.curbuf.item.b_p_mps)
							from
							until
								not (not js.loop_left and then ((l_ptr.item).to_boolean))
							loop
								js.reset
								if (l_ptr.item).to_integer_32 = l_initc then
									l_findc := l_initc
									l_initc := (l_ptr[2]).to_integer_32
									l_backwards := 1
									js.break
								end
								if not js.loop_jumped then
									l_ptr.ce_gets (l_ptr + (2))
									if (l_ptr.item).to_integer_32 = l_initc then
										l_findc := l_initc
										l_initc := (l_ptr[-2]).to_integer_32
										l_backwards := 0
										js.break
									end
								end
								if not js.loop_jumped and then ((l_ptr[1]).to_integer_32 /= 44) then
									js.break
								end
								if not js.loop_jumped then
									l_ptr.ce_gets (l_ptr + (2))
								end
							end
							js.reset
							if not l_findc.to_boolean then
								Result := (create {CE_POINTER [PD_POS_T]}.make_shared (default_pointer))
								js.return
							end
						else
							l_pos := -1 + 9 -- goto _L___1
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 36
				when 9 then -- else: | _L___1:
						if l_initc /= 35 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_hash_dir := l_dir___0
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 12 then -- else:
						if l_cpo_match.to_boolean then
							l_pos := -1 + 17 -- skip if block
						end
				when 13 then -- if:
						l_ptr.ce_gets (charset_inst.skipwhite (l_linep))
						if (l_ptr.item).to_integer_32 /= 35 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						if pos___1.col <= l_ptr.distance (l_linep) then
							l_ptr.ce_gets (charset_inst.skipwhite (l_ptr + 1))
							if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_ptr), ce_string ("if"), (2).to_natural_32)) = 0 then
								l_hash_dir := 1
							elseif (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_ptr), ce_string ("endif"), (5).to_natural_32)) = 0 then
								l_hash_dir := 1
							elseif (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_ptr), ce_string ("el"), (2).to_natural_32)) = 0 then
								l_hash_dir := 1
							end
						else
							l_pos := -1 + 16 -- goto _L
						end
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 16 then -- else: | _L:
						if (l_linep[pos___1.col]).to_integer_32 = 47 then
							if (l_linep[(pos___1.col + 1)]).to_integer_32 = 42 then
								l_comment_dir := 1
								l_backwards := 0
								pos___1.col := (pos___1.col) + 1
							elseif pos___1.col > 0 then
								if (l_linep[(pos___1.col - 1)]).to_integer_32 = 42 then
									l_comment_dir := -1
									l_backwards := 1
									pos___1.col := (pos___1.col) - 1
								end
							end
						elseif (l_linep[pos___1.col]).to_integer_32 = 42 then
							if (l_linep[(pos___1.col + 1)]).to_integer_32 = 47 then
								l_comment_dir := -1
								l_backwards := 1
							elseif pos___1.col > 0 then
								if (l_linep[(pos___1.col - 1)]).to_integer_32 = 47 then
									l_comment_dir := 1
									l_backwards := 0
								end
							end
						end
				when 17 then -- if done
						if not l_hash_dir.to_boolean then
							if not l_comment_dir.to_boolean then
								if (l_linep[pos___1.col]).to_integer_32 = 0 then
									if (pos___1.col).to_boolean then
										pos___1.col := (pos___1.col) - 1
									end
								end
								from
								until
									js.loop_left
								loop
									js.reset
									l_initc := (l_linep[pos___1.col]).to_integer_32
									if l_initc = 0 then
										js.break
									end
									if not js.loop_jumped then
										l_ptr.ce_gets (globals_inst.curbuf.item.b_p_mps)
										from
										until
											not (not js.loop_left and then ((l_ptr.item).to_boolean))
										loop
											js.reset
											if (l_ptr.item).to_integer_32 = l_initc then
												l_findc := (l_ptr[2]).to_integer_32
												l_backwards := 0
												js.break
											end
											if not js.loop_jumped then
												l_ptr.ce_gets (l_ptr + (2))
												if (l_ptr.item).to_integer_32 = l_initc then
													l_findc := (l_ptr[-2]).to_integer_32
													l_backwards := 1
													js.break
												end
											end
											if not js.loop_jumped then
												l_ptr.ce_gets (l_ptr + 1)
												if not (l_ptr.item).to_boolean then
													js.break
												end
											end
											if not js.loop_jumped then
												l_ptr.ce_gets (l_ptr + 1)
											end
										end
										js.reset
										if l_findc.to_boolean then
											js.break
										end
									end
									if not js.loop_jumped then
										if globals_inst.has_mbyte.to_boolean then
											pos___1.col := pos___1.col + (globals_inst.mb_ptr2len.integer_32_item ([l_linep + pos___1.col]))
										else
											pos___1.col := (pos___1.col) + 1
										end
									end
								end
								js.reset
								if not l_findc.to_boolean then
									if not l_cpo_match.to_boolean then
										if ((charset_inst.skipwhite (l_linep)).item).to_integer_32 = 35 then
											l_hash_dir := 1
										else
											Result := (create {CE_POINTER [PD_POS_T]}.make_shared (default_pointer))
											js.return
										end
									else
										Result := (create {CE_POINTER [PD_POS_T]}.make_shared (default_pointer))
										js.return
									end
								elseif not l_cpo_bsl.to_boolean then
									l_bslcnt := 0
									l_col := pos___1.col
									from
									until
										js.loop_left
									loop
										js.reset
										if not (check_prevcol (l_linep, l_col, ('\').code, create {CE_POINTER [INTEGER_32]}.make_shared ($l_col))).to_boolean then
											js.break
										end
										if not js.loop_jumped then
											l_bslcnt := l_bslcnt + 1
										end
									end
									js.reset
									l_match_escaped := (l_bslcnt).bit_and (1)
								end
							end
						end
				when 18 then -- if done
						if not (not js.return_called and then (l_hash_dir.to_boolean)) then
							l_pos := -1 + 36 -- skip if block
						end
				when 19 then -- if:
						if (a_oap.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							a_oap.item.motion_type := 1
						end
						if l_initc /= 35 then
							l_ptr.ce_gets (charset_inst.skipwhite ((charset_inst.skipwhite (l_linep)) + 1))
							if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_ptr), ce_string ("if"), (2).to_natural_32)) = 0 then
								l_hash_dir := 1
							elseif (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_ptr), ce_string ("el"), (2).to_natural_32)) = 0 then
								l_hash_dir := 1
							elseif (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_ptr), ce_string ("endif"), (5).to_natural_32)) = 0 then
								l_hash_dir := -1
							else
								Result := (create {CE_POINTER [PD_POS_T]}.make_shared (default_pointer))
								js.return
							end
						end
						if js.return_called then
							l_pos := -1 + 35 -- skip if block
						end
				when 20 then -- if:
						pos___1.col := 0
				when 21 then -- loop condition:
						if not (not js.loop_left and then (not globals_inst.got_int.to_boolean)) then
							l_pos := -1 + 34 -- skip loop
						end
				when 22 then -- loop body:
						js.reset
						if l_hash_dir > 0 then
							if pos___1.lnum = globals_inst.curbuf.item.b_ml.ml_line_count then
								js.break
							end
						elseif pos___1.lnum = 1 then
							js.break
						end
						if not js.loop_jumped then
							pos___1.lnum := pos___1.lnum + l_hash_dir.to_integer_32
							l_linep.ce_gets (memline_inst.ml_get (pos___1.lnum))
							misc1_inst.line_breakcheck
							l_ptr.ce_gets (charset_inst.skipwhite (l_linep))
							if (l_ptr.item).to_integer_32 /= 35 then
								js.continue
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 33 -- skip if block
						end
				when 23 then -- if:
						pos___1.col := l_ptr.distance (l_linep)
						l_ptr.ce_gets (charset_inst.skipwhite (l_ptr + 1))
						if not (l_hash_dir > 0) then
							l_pos := -1 + 26 -- skip if block
						end
				when 24 then -- if:
						if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_ptr), ce_string ("if"), (2).to_natural_32)) = 0 then
							l_count___2 := l_count___2 + 1
						elseif (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_ptr), ce_string ("el"), (2).to_natural_32)) = 0 then
							if l_count___2 = 0 then
								Result := (pos___1.address)
								js.return
							end
						elseif (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_ptr), ce_string ("endif"), (5).to_natural_32)) = 0 then
							if l_count___2 = 0 then
								Result := (pos___1.address)
								js.return
							end
							if not js.return_called then
								l_count___2 := l_count___2 - 1
							end
						end
				when 25 then -- if block done, skip else block:
						l_pos := -1 + 33
				when 26 then -- else:
						if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_ptr), ce_string ("if"), (2).to_natural_32)) /= 0 then
							l_pos := -1 + 29 -- skip if block
						end
				when 27 then -- if:
						if l_count___2 = 0 then
							Result := (pos___1.address)
							js.return
						end
						if not js.return_called then
							l_count___2 := l_count___2 - 1
						end
				when 28 then -- if block done, skip else block:
						l_pos := -1 + 33
				when 29 then -- else:
						if l_initc /= 35 then
							l_pos := -1 + 32 -- skip if block
						end
				when 30 then -- if:
						if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_ptr), ce_string ("el"), (2).to_natural_32)) = 0 then
							if l_count___2 = 0 then
								Result := (pos___1.address)
								js.return
							end
						else
							l_pos := -1 + 32 -- goto _L___0
						end
				when 31 then -- if block done, skip else block:
						l_pos := -1 + 33
				when 32 then -- else: | _L___0:
						if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_ptr), ce_string ("endif"), (5).to_natural_32)) = 0 then
							l_count___2 := l_count___2 + 1
						end
				when 33 then -- if done | if done | if done
						l_pos := -1 + 21 -- back to loop condition
				when 34 then -- loop done
						js.reset
				when 35 then -- if done
						if not js.return_called then
							Result := (create {CE_POINTER [PD_POS_T]}.make_shared (default_pointer))
							js.return
						end
				when 36 then -- if done | if done | if done
						if js.return_called then
							l_pos := -1 + 118 -- skip if block
						end
				when 37 then -- if:
							l_do_quotes := -1
							l_start_in_quotes := 2
							l_match_pos.lnum := (0).to_integer_32
							l_match_pos.col := 0
							l_match_pos.coladd := 0
							if not (l_backwards.to_boolean) then
								l_pos := -1 + 40 -- skip if block
							end
				when 38 then -- if:
							if l_comment_dir.to_boolean then
								l_comment_col := check_linecomment (l_linep)
							else
								l_pos := -1 + 40 -- goto _L___3
							end
				when 39 then -- if block done, skip else block:
							l_pos := -1 + 41
				when 40 then -- else: | _L___3:
							if l_lisp.to_boolean then
								l_comment_col := check_linecomment (l_linep)
							end
				when 41 then
							if l_lisp.to_boolean then
								if l_comment_col.to_integer_32 /= 2147483647 then
									if pos___1.col > l_comment_col then
										l_lispcomm := 1
									end
								end
							end
				when 42 then -- loop condition:
							if not (not js.loop_left and then (not globals_inst.got_int.to_boolean)) then
								l_pos := -1 + 117 -- skip loop
							end
				when 43 then -- loop body:
							js.reset
							if not (l_backwards.to_boolean) then
								l_pos := -1 + 46 -- skip if block
							end
				when 44 then -- if:
							if l_lispcomm.to_boolean then
								if pos___1.col < l_comment_col then
									js.break
								end
							end
							if not js.loop_jumped then
								if pos___1.col = 0 then
									if pos___1.lnum = 1 then
										js.break
									end
									if not js.loop_jumped then
										pos___1.lnum := (pos___1.lnum) - 1
										if a_maxtravel > 0 then
											l_traveled := l_traveled + 1
											if l_traveled > a_maxtravel then
												js.break
											end
										end
									end
									if not js.loop_jumped then
										l_linep.ce_gets (memline_inst.ml_get (pos___1.lnum))
										pos___1.col := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_linep))).to_integer_32
										l_do_quotes := -1
										misc1_inst.line_breakcheck
										if l_comment_dir.to_boolean then
											l_comment_col := check_linecomment (l_linep)
										elseif l_lisp.to_boolean then
											l_comment_col := check_linecomment (l_linep)
										end
										if l_lisp.to_boolean then
											if l_comment_col.to_integer_32 /= 2147483647 then
												pos___1.col := l_comment_col
											end
										end
									end
								else
									pos___1.col := (pos___1.col) - 1
									if globals_inst.has_mbyte.to_boolean then
										pos___1.col := pos___1.col - (globals_inst.mb_head_off.integer_32_item ([l_linep, l_linep + pos___1.col]))
									end
								end
							end
				when 45 then -- if block done, skip else block:
							l_pos := -1 + 59
				when 46 then -- else:
							if (l_linep[pos___1.col]).to_integer_32 /= 0 then
								l_pos := -1 + 49 -- skip if block
							end
				when 47 then -- if:
							l_pos := -1 + 52 -- goto _L___4
				when 48 then -- if block done, skip else block:
							l_pos := -1 + 59
				when 49 then -- else:
							if not (l_lisp.to_boolean) then
								l_pos := -1 + 58 -- skip if block
							end
				when 50 then -- if:
							if l_comment_col.to_integer_32 = 2147483647 then
								l_pos := -1 + 56 -- skip if block
							end
				when 51 then -- if:
							if pos___1.col /= l_comment_col then
								l_pos := -1 + 54 -- skip if block
							end
				when 52 then -- if: | _L___4:
							if pos___1.lnum = globals_inst.curbuf.item.b_ml.ml_line_count then
								js.break
							elseif l_lispcomm.to_boolean then
								js.break
							end
							if not js.loop_jumped then
								pos___1.lnum := (pos___1.lnum) + 1
								if a_maxtravel.to_boolean then
									l_tmp___19 := l_traveled
									l_traveled := l_traveled + 1
									if l_tmp___19 > a_maxtravel then
										js.break
									end
								end
							end
							if not js.loop_jumped then
								l_linep.ce_gets (memline_inst.ml_get (pos___1.lnum))
								pos___1.col := 0
								l_do_quotes := -1
								misc1_inst.line_breakcheck
								if l_lisp.to_boolean then
									l_comment_col := check_linecomment (l_linep)
								end
							end
				when 53 then -- if block done, skip else block:
							l_pos := -1 + 55
				when 54 then -- else:
							l_pos := -1 + 58 -- goto _L___6
				when 55 then -- if done | if block done, skip else block:
							l_pos := -1 + 57
				when 56 then -- else:
							l_pos := -1 + 58 -- goto _L___6
				when 57 then -- if done | if block done, skip else block:
							l_pos := -1 + 59
				when 58 then -- else: | _L___6:
							if globals_inst.has_mbyte.to_boolean then
								pos___1.col := pos___1.col + (globals_inst.mb_ptr2len.integer_32_item ([l_linep + pos___1.col]))
							else
								pos___1.col := (pos___1.col) + 1
							end
				when 59 then -- if done | if done
							if not (not js.loop_jumped and then (pos___1.col = 0)) then
								l_pos := -1 + 66 -- skip if block
							end
				when 60 then -- if:
							if not (((a_flags___0).bit_and (4)).to_boolean) then
								l_pos := -1 + 66 -- skip if block
							end
				when 61 then -- if:
							if (l_linep[0]).to_integer_32 /= 123 then
								l_pos := -1 + 64 -- skip if block
							end
				when 62 then -- if:
							l_pos := -1 + 65 -- goto _L___7
				when 63 then -- if block done, skip else block:
							l_pos := -1 + 66
				when 64 then -- else:
							if (l_linep[0]).to_integer_32 /= 125 then
								l_pos := -1 + 66 -- skip if block
							end
				when 65 then -- if: | _L___7:
							if (l_linep[0]).to_integer_32 = l_findc then
								if l_count___2 = 0 then
									Result := (pos___1.address)
									js.return
								end
							end
							if not js.return_called then
								js.break
							end
				when 66 then -- if done | if done | if done
							if not (not js.loop_jumped and then (l_comment_dir.to_boolean)) then
								l_pos := -1 + 87 -- skip if block
							end
				when 67 then -- if:
							if l_comment_dir /= 1 then
								l_pos := -1 + 70 -- skip if block
							end
				when 68 then -- if:
							if (l_linep[pos___1.col]).to_integer_32 = 42 then
								if (l_linep[(pos___1.col + 1)]).to_integer_32 = 47 then
									pos___1.col := (pos___1.col) + 1
									Result := (pos___1.address)
									js.return
								end
							end
				when 69 then -- if block done, skip else block:
							l_pos := -1 + 86
				when 70 then -- else:
							if pos___1.col /= 0 then
								l_pos := -1 + 73 -- skip if block
							end
				when 71 then -- if:
							js.continue
				when 72 then -- if block done, skip else block:
							l_pos := -1 + 86
				when 73 then -- else:
							if (l_linep[(pos___1.col - 1)]).to_integer_32 /= 47 then
								l_pos := -1 + 76 -- skip if block
							end
				when 74 then -- if:
							if (l_linep[pos___1.col]).to_integer_32 = 42 then
								if pos___1.col < l_comment_col then
									l_count___2 := l_count___2 + 1
									l_match_pos.ce_gets (pos___1)
									l_match_pos.col := (l_match_pos.col) - 1
								else
									l_pos := -1 + 76 -- goto _L___11
								end
							else
								l_pos := -1 + 76 -- goto _L___11
							end
				when 75 then -- if block done, skip else block:
							l_pos := -1 + 86
				when 76 then -- else: | _L___11:
							if (l_linep[(pos___1.col - 1)]).to_integer_32 /= 42 then
								l_pos := -1 + 86 -- skip if block
							end
				when 77 then -- if:
							if (l_linep[pos___1.col]).to_integer_32 /= 47 then
								l_pos := -1 + 86 -- skip if block
							end
				when 78 then -- if:
							if not (l_count___2 > 0) then
								l_pos := -1 + 81 -- skip if block
							end
				when 79 then -- if:
							pos___1.ce_gets (l_match_pos)
				when 80 then -- if block done, skip else block:
							l_pos := -1 + 85
				when 81 then -- else:
							if not (pos___1.col > 1) then
								l_pos := -1 + 84 -- skip if block
							end
				when 82 then -- if:
							if (l_linep[(pos___1.col - 2)]).to_integer_32 = 47 then
								if pos___1.col <= l_comment_col then
									pos___1.col := pos___1.col - (2)
								else
									l_pos := -1 + 84 -- goto _L___9
								end
							else
								l_pos := -1 + 84 -- goto _L___9
							end
				when 83 then -- if block done, skip else block:
							l_pos := -1 + 85
				when 84 then -- else: | _L___9:
							if l_ignore_cend.to_boolean then
								js.continue
							else
								Result := (create {CE_POINTER [PD_POS_T]}.make_shared (default_pointer))
								js.return
							end
				when 85 then -- if done
							if not js.loop_jumped then
								Result := (pos___1.address)
								js.return
							end
				when 86 then -- if done | if done | if done | if done
							if not js.loop_jumped then
								js.continue
							end
				when 87 then -- if done
							if js.loop_jumped then
								l_pos := -1 + 116 -- skip if block
							end
				when 88 then -- if:
							if l_cpo_match.to_boolean then
								l_do_quotes := 0
							elseif l_do_quotes = -1 then
								l_at_start___0 := l_do_quotes
								l_ptr.ce_gets (l_linep)
								from
								until
									not ((l_ptr.item).to_boolean)
								loop
									if (l_ptr.c_pointer.to_integer_32).to_natural_32 = (((l_linep + pos___1.col) + l_backwards).c_pointer.to_integer_32).to_natural_32 then
										l_at_start___0 := (l_do_quotes).bit_and (1)
									end
									if (l_ptr.item).to_integer_32 = 34 then
										if (l_ptr.c_pointer.to_integer_32).to_natural_32 = (l_linep.c_pointer.to_integer_32).to_natural_32 then
											l_do_quotes := l_do_quotes + 1
										elseif (l_ptr[-1]).to_integer_32 /= 39 then
											l_do_quotes := l_do_quotes + 1
										elseif (l_ptr[1]).to_integer_32 /= 39 then
											l_do_quotes := l_do_quotes + 1
										end
									end
									if (l_ptr.item).to_integer_32 = 92 then
										if (l_ptr[1]).to_integer_32 /= 0 then
											l_ptr.ce_gets (l_ptr + 1)
										end
									end
									l_ptr.ce_gets (l_ptr + 1)
								end
								l_do_quotes := (l_do_quotes).bit_and ((1))
								if not l_do_quotes.to_boolean then
									l_inquote := 0
									if (l_ptr[-1]).to_integer_32 = 92 then
										l_do_quotes := 1
										if l_start_in_quotes = 2 then
											l_inquote := 1
											l_start_in_quotes := 1
										elseif l_backwards.to_boolean then
											l_inquote := 1
										end
									end
									if pos___1.lnum > 1 then
										l_ptr.ce_gets (memline_inst.ml_get (pos___1.lnum - 1))
										if (l_ptr.item).to_boolean then
											if ((l_ptr + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_ptr))).to_integer_32)[-1]).to_integer_32 = 92 then
												l_do_quotes := 1
												if l_start_in_quotes = 2 then
													l_inquote := l_at_start___0
													if l_inquote.to_boolean then
														l_start_in_quotes := 1
													end
												elseif not l_backwards.to_boolean then
													l_inquote := 1
												end
											end
										end
										l_linep.ce_gets (memline_inst.ml_get (pos___1.lnum))
									end
								end
							end
							if l_start_in_quotes = 2 then
								l_start_in_quotes := 0
							end
							l_c := (l_linep[pos___1.col]).to_integer_32
							inspect l_c -- switch 1 head
							when 0 then l_pos := -1 + 89
							when 34 then l_pos := -1 + 90
							when 39 then l_pos := -1 + 91
							else l_pos := -1 + 102
							end
				when 89 then -- switch 1, case 0
							if pos___1.col = 0 then
								l_inquote := 0
								l_start_in_quotes := 0
							elseif (l_linep[(pos___1.col - 1)]).to_integer_32 /= 92 then
								l_inquote := 0
								l_start_in_quotes := 0
							end
							l_pos := -1 + 116 -- switch 1; break
				when 90 then -- switch 1, case 34
							if l_do_quotes.to_boolean then
								l_col___0 := pos___1.col - 1
								from
								until
									not (not js.loop_left and then (l_col___0 >= 0))
								loop
									js.reset
									if (l_linep[l_col___0]).to_integer_32 /= 92 then
										js.break
									end
									if not js.loop_jumped then
										l_col___0 := l_col___0 - 1
									end
								end
								js.reset
								if ((((pos___1.col - 1) - l_col___0)).bit_and (1)) = 0 then
									l_inquote := (not l_inquote.to_boolean).to_integer
									l_start_in_quotes := 0
								end
							end
							l_pos := -1 + 116 -- switch 1; break
				when 91 then -- switch 1, case 39
							if l_cpo_match.to_boolean then
								l_pos := -1 + 102 -- skip if block
							end
				when 92 then -- if:
							if l_initc = 39 then
								l_pos := -1 + 102 -- skip if block
							end
				when 93 then -- if:
							if l_findc = 39 then
								l_pos := -1 + 102 -- skip if block
							end
				when 94 then -- if:
							if not (l_backwards.to_boolean) then
								l_pos := -1 + 97 -- skip if block
							end
				when 95 then -- if:
							if pos___1.col > 1 then
								if (l_linep[(pos___1.col - 2)]).to_integer_32 = 39 then
									pos___1.col := pos___1.col - (2)
									l_pos := -1 + 116 -- switch 1; break
								elseif (l_linep[(pos___1.col - 2)]).to_integer_32 = 92 then
									if pos___1.col > 2 then
										if (l_linep[(pos___1.col - 3)]).to_integer_32 = 39 then
											pos___1.col := pos___1.col - (3)
											l_pos := -1 + 116 -- switch 1; break
										end
									end
								end
							end
				when 96 then -- if block done, skip else block:
							l_pos := -1 + 102
				when 97 then -- else:
							if not ((l_linep[(pos___1.col + 1)]).to_boolean) then
								l_pos := -1 + 102 -- skip if block
							end
				when 98 then -- if:
							if (l_linep[(pos___1.col + 1)]).to_integer_32 /= 92 then
								l_pos := -1 + 101 -- skip if block
							end
				when 99 then -- if:
							if (l_linep[(pos___1.col + 2)]).to_boolean then
								if (l_linep[(pos___1.col + 3)]).to_integer_32 = 39 then
									pos___1.col := pos___1.col + (3)
									l_pos := -1 + 116 -- switch 1; break
								else
									l_pos := -1 + 101 -- goto _L___13
								end
							else
								l_pos := -1 + 101 -- goto _L___13
							end
				when 100 then -- if block done, skip else block:
							l_pos := -1 + 102
				when 101 then -- else: | _L___13:
							if (l_linep[(pos___1.col + 2)]).to_integer_32 = 39 then
								pos___1.col := pos___1.col + (2)
								l_pos := -1 + 116 -- switch 1; break
							end
				when 102 then -- if done | if done | if done | if done | if done | switch 1, default:
							if (globals_inst.curbuf.item.b_p_lisp).to_boolean then
								if ((misc2_inst.vim_strchr (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("(){}[]")), l_c)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									if pos___1.col > 1 then
										if (check_prevcol (l_linep, pos___1.col, ('\').code, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))).to_boolean then
											if (check_prevcol (l_linep, pos___1.col - 1, ('#').code, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))).to_boolean then
												l_pos := -1 + 116 -- switch 1; break
											end
										end
									end
								end
							end
				when 103 then
							if l_inquote.to_boolean then
								l_pos := -1 + 106 -- skip if block
							end
				when 104 then -- if:
							l_pos := -1 + 107 -- goto _L___16
				when 105 then -- if block done, skip else block:
							l_pos := -1 + 116
				when 106 then -- else:
							if l_start_in_quotes /= 1 then
								l_pos := -1 + 116 -- skip if block
							end
				when 107 then -- if: | _L___16:
							if l_c /= l_initc then
								l_pos := -1 + 110 -- skip if block
							end
				when 108 then -- if:
							l_pos := -1 + 111 -- goto _L___15
				when 109 then -- if block done, skip else block:
							l_pos := -1 + 116
				when 110 then -- else:
							if l_c /= l_findc then
								l_pos := -1 + 116 -- skip if block
							end
				when 111 then -- if: | _L___15:
							l_bslcnt___0 := 0
							if not l_cpo_bsl.to_boolean then
								l_col___1 := pos___1.col
								from
								until
									js.loop_left
								loop
									js.reset
									if not (check_prevcol (l_linep, l_col___1, ('\').code, create {CE_POINTER [INTEGER_32]}.make_shared ($l_col___1))).to_boolean then
										js.break
									end
									if not js.loop_jumped then
										l_bslcnt___0 := l_bslcnt___0 + 1
									end
								end
								js.reset
							end
							if not (l_cpo_bsl.to_boolean) then
								l_pos := -1 + 114 -- skip if block
							end
				when 112 then -- if:
							l_pos := -1 + 115 -- goto _L___14
				when 113 then -- if block done, skip else block:
							l_pos := -1 + 116
				when 114 then -- else:
							if ((l_bslcnt___0).bit_and (1)) /= l_match_escaped then
								l_pos := -1 + 116 -- skip if block
							end
				when 115 then -- if: | _L___14:
							if l_c = l_initc then
								l_count___2 := l_count___2 + 1
							else
								if l_count___2 = 0 then
									Result := (pos___1.address)
									js.return
								end
								if not js.return_called then
									l_count___2 := l_count___2 - 1
								end
							end
				when 116 then -- if done | if done | if done | if done | if done | switch 1, done: | if done
							l_pos := -1 + 42 -- back to loop condition
				when 117 then -- loop done
							js.reset
				when 118 then -- if done
						if not js.return_called and then (l_comment_dir = -1) then
							if l_count___2 > 0 then
								pos___1.ce_gets (l_match_pos)
								Result := (pos___1.address)
								js.return
							end
						end
						if not js.return_called then
							Result := (create {CE_POINTER [PD_POS_T]}.make_shared (default_pointer))
						end
				when 119 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	check_linecomment (a_line: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_instr: INTEGER_32
			js: JUMP_STATE
		do
			create l_p___0.make

			l_p___0.ce_gets (a_line)
			if (globals_inst.curbuf.item.b_p_lisp).to_boolean then
				if ((misc2_inst.vim_strchr (l_p___0, (';').code)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					l_instr := 0
					l_p___0.ce_gets (a_line)
					from
					until
						js.loop_left
					loop
						js.reset
						l_p___0.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((strpbrk (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), ce_string ("%";")))))
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							js.break
						end
						if not js.loop_jumped then
							if (l_p___0.item).to_integer_32 = 34 then
								if l_instr.to_boolean then
									if (l_p___0[-1]).to_integer_32 /= 92 then
										l_instr := 0
									end
								elseif (l_p___0.c_pointer.to_integer_32).to_natural_32 = (a_line.c_pointer.to_integer_32).to_natural_32 then
									l_instr := 1
								elseif l_p___0.distance (a_line) >= 2 then
									if (l_p___0[-1]).to_integer_32 /= 92 then
										if (l_p___0[-2]).to_integer_32 /= 35 then
											l_instr := 1
										end
									end
								end
							elseif not l_instr.to_boolean then
								if l_p___0.distance (a_line) < 2 then
									js.break
								elseif (l_p___0[-1]).to_integer_32 /= 92 then
									if (l_p___0[-2]).to_integer_32 /= 35 then
										js.break
									end
								end
							end
						end
						if not js.loop_jumped then
							l_p___0.ce_gets (l_p___0 + 1)
						end
					end
					js.reset
				else
					l_p___0.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				end
			else
				from
				until
					js.loop_left
				loop
					js.reset
					l_p___0.ce_gets (misc2_inst.vim_strchr (l_p___0, ('/').code))
					if (l_p___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						js.break
					end
					if not js.loop_jumped and then ((l_p___0[1]).to_integer_32 = 47) then
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 = (a_line.c_pointer.to_integer_32).to_natural_32 then
							js.break
						elseif (l_p___0[-1]).to_integer_32 /= 42 then
							js.break
						elseif (l_p___0[2]).to_integer_32 /= 42 then
							js.break
						end
					end
					if not js.loop_jumped then
						l_p___0.ce_gets (l_p___0 + 1)
					end
				end
				js.reset
			end
			if (l_p___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				Result := 2147483647
				js.return
			end
			if not js.return_called then
				Result := (l_p___0.distance (a_line))
			end
		end

	showmatch (a_c: INTEGER_32)
		local
			l_lpos: CE_POINTER [PD_POS_T]
			l_save_cursor: PD_POS_T
			l_mpos: PD_POS_T
			l_vcol: INTEGER_32
			l_save_so: INTEGER_32
			l_save_siso: INTEGER_32
			l_save_state: INTEGER_32
			l_save_dollar_vcol: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_lpos.make
			create l_save_cursor.make
			create l_mpos.make
			create l_p___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p___0.ce_gets (globals_inst.curbuf.item.b_p_mps)
					from
					until
						not (not js.loop_left and then ((l_p___0.item).to_integer_32 /= 0))
					loop
						js.reset
						l_p___0.ce_gets (l_p___0 + (2))
						if (l_p___0.item).to_integer_32 = a_c then
							js.break
						end
						if not js.loop_jumped then
							if (l_p___0[1]).to_integer_32 /= 44 then
								js.return
							end
							if not js.return_called then
								l_p___0.ce_gets (l_p___0 + (2))
							end
						end
					end
					js.reset
					if js.return_called then
						l_pos := -1 + 11 -- skip if block
					end
				when 1 then -- if:
						l_lpos.ce_gets (findmatch (create {CE_POINTER [PD_OPARG_S]}.make_shared (default_pointer), ('%/0/').code))
						if (l_lpos.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						misc1_inst.vim_beep
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 4 then -- else:
						if not (l_lpos.item.lnum >= globals_inst.curwin.item.w_topline) then
							l_pos := -1 + 11 -- skip if block
						end
				when 5 then -- if:
						if not (globals_inst.curwin.item.w_onebuf_opt.wo_wrap).to_boolean then
							charset_inst.getvcol (globals_inst.curwin, l_lpos, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared ($l_vcol), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
						end
						if not ((globals_inst.curwin.item.w_onebuf_opt.wo_wrap).to_boolean) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 8 then -- else:
						if not (l_vcol >= globals_inst.curwin.item.w_leftcol) then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						if not (l_vcol < globals_inst.curwin.item.w_leftcol + globals_inst.curwin.item.w_width) then
							l_pos := -1 + 11 -- skip if block
						end
				when 10 then -- if: | _L:
						l_mpos.ce_gets (l_lpos.item)
						l_save_cursor.ce_gets (globals_inst.curwin.item.w_cursor)
						l_save_so := option_inst.p_so
						l_save_siso := option_inst.p_siso
						if globals_inst.dollar_vcol > 0 then
							if globals_inst.dollar_vcol = globals_inst.curwin.item.w_virtcol then
								globals_inst.dollar_vcol := 0
							end
						end
						globals_inst.curwin.item.w_virtcol := (globals_inst.curwin.item.w_virtcol) + 1
						screen_inst.update_screen (10)
						l_save_dollar_vcol := globals_inst.dollar_vcol
						l_save_state := globals_inst.State
						globals_inst.State := 1808
						ui_inst.ui_cursor_shape
						globals_inst.curwin.item.w_cursor := l_mpos
						option_inst.p_so := 0
						option_inst.p_siso := 0
						screen_inst.showruler (0)
						screen_inst.setcursor
						term_inst.cursor_on
						term_inst.out_flush
						if (gui_inst.gui.in_use).to_boolean then
							gui_inst.gui_update_cursor (1, 0)
							gui_gtk_x11_inst.gui_mch_flush
						end
						globals_inst.dollar_vcol := l_save_dollar_vcol
						if ((misc2_inst.vim_strchr (option_inst.p_cpo, ('m').code)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							ui_inst.ui_delay (option_inst.p_mat * 100, 1)
						elseif not (getchar_inst.char_avail).to_boolean then
							ui_inst.ui_delay (option_inst.p_mat * 100, 0)
						end
						globals_inst.curwin.item.w_cursor := l_save_cursor
						option_inst.p_so := l_save_so
						option_inst.p_siso := l_save_siso
						globals_inst.State := l_save_state
						ui_inst.ui_cursor_shape
				when 11 then -- if done | if done | if done | if done | if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	findsent (a_dir___0: INTEGER_32; a_count___2: INTEGER_32): INTEGER_32
		local
			l_count___2: INTEGER_32
			l_pos___3: PD_POS_T
			l_tpos: PD_POS_T
			l_c: INTEGER_32
			l_func: CE_ROUTINE
			l_startlnum: INTEGER_32
			l_noskip: INTEGER_32
			l_cpo_J: INTEGER_32
			l_found_dot: INTEGER_32
			l_tmp___15: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_pos___3.make
			create l_tpos.make
			create l_func.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_count___2 := a_count___2
					l_noskip := 0
					l_pos___3.ce_gets (globals_inst.curwin.item.w_cursor)
					if a_dir___0 = 1 then
						l_func.ce_gets (misc2_inst.incl_address)
					else
						l_func.ce_gets (misc2_inst.decl_address)
					end
				when 1 then -- loop condition:
					if js.loop_left then
						l_pos := -1 + 50 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						l_tmp___15 := l_count___2
						l_count___2 := l_count___2 - 1
						if not l_tmp___15.to_boolean then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 49 -- skip if block
						end
				when 3 then -- if:
						if (misc1_inst.gchar_pos (l_pos___3.address)) /= 0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_func.integer_32_item ([l_pos___3.address])) = -1 then
								js.break
							end
							if not js.loop_jumped then
								if (misc1_inst.gchar_pos (l_pos___3.address)) /= 0 then
									js.break
								end
							end
						end
						js.reset
						if a_dir___0 = 1 then
							l_pos := -1 + 48 -- goto found
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 6 then -- else:
						if a_dir___0 /= 1 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if l_pos___3.col = 0 then
							if (startPS (l_pos___3.lnum, ('%/0/').code, 0)).to_boolean then
								if l_pos___3.lnum = globals_inst.curbuf.item.b_ml.ml_line_count then
									Result := 0
									js.return
								end
								if not js.return_called then
									l_pos___3.lnum := (l_pos___3.lnum) + 1
									l_pos := -1 + 48 -- goto found
								end
							else
								l_pos := -1 + 9 -- goto _L___0
							end
						else
							l_pos := -1 + 9 -- goto _L___0
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else: | _L___0:
						if a_dir___0 = -1 then
							misc2_inst.decl (l_pos___3.address).do_nothing
						end
				when 10 then -- if done
						if js.return_called then
							l_pos := -1 + 47 -- skip if block
						end
				when 11 then -- if:
						l_found_dot := 0
				when 12 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 15 -- skip loop
						end
				when 13 then -- loop body:
						js.reset
						l_c := misc1_inst.gchar_pos (l_pos___3.address)
						if l_c /= 32 then
							if l_c /= 9 then
								if a_dir___0 = -1 then
									if ((misc2_inst.vim_strchr (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (".!?)]%"%'")), l_c)).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
										js.break
									end
								else
									js.break
								end
							end
						end
						if not js.loop_jumped then
							if ((misc2_inst.vim_strchr (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (".!?")), l_c)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								if l_found_dot.to_boolean then
									js.break
								end
								if not js.loop_jumped then
									l_found_dot := 1
								end
							end
						end
						if not js.loop_jumped then
							if (misc2_inst.decl (l_pos___3.address)) = -1 then
								js.break
							end
						end
						if not js.loop_jumped then
							if ((memline_inst.ml_get (l_pos___3.lnum)).item).to_integer_32 = 0 then
								if a_dir___0 = 1 then
									misc2_inst.incl (l_pos___3.address).do_nothing
									l_pos := -1 + 48 -- goto found
								end
							end
						end
				when 14 then
						l_pos := -1 + 12 -- back to loop condition
				when 15 then -- loop done
						js.reset
						l_startlnum := (l_pos___3.lnum).to_integer_32
						l_cpo_J := (((misc2_inst.vim_strchr (option_inst.p_cpo, ('J').code)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer
				when 16 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 46 -- skip loop
						end
				when 17 then -- loop body:
						js.reset
						l_c := misc1_inst.gchar_pos (l_pos___3.address)
						if l_c /= 0 then
							l_pos := -1 + 20 -- skip if block
						end
				when 18 then -- if:
						l_pos := -1 + 22 -- goto _L___1
				when 19 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 20 then -- else:
						if l_pos___3.col /= 0 then
							l_pos := -1 + 23 -- skip if block
						end
				when 21 then -- if:
						if not ((startPS (l_pos___3.lnum, ('%/0/').code, 0)).to_boolean) then
							l_pos := -1 + 23 -- skip if block
						end
				when 22 then -- if: | _L___1:
						if a_dir___0 = -1 then
							if l_pos___3.lnum /= l_startlnum.to_integer_32 then
								l_pos___3.lnum := (l_pos___3.lnum) + 1
							end
						end
						js.break
				when 23 then -- if done | if done
						if js.loop_jumped then
							l_pos := -1 + 45 -- skip if block
						end
				when 24 then -- if:
						if l_c /= 46 then
							l_pos := -1 + 27 -- skip if block
						end
				when 25 then -- if:
						l_pos := -1 + 31 -- goto _L___4
				when 26 then -- if block done, skip else block:
						l_pos := -1 + 45
				when 27 then -- else:
						if l_c /= 33 then
							l_pos := -1 + 30 -- skip if block
						end
				when 28 then -- if:
						l_pos := -1 + 31 -- goto _L___4
				when 29 then -- if block done, skip else block:
						l_pos := -1 + 45
				when 30 then -- else:
						if l_c /= 63 then
							l_pos := -1 + 45 -- skip if block
						end
				when 31 then -- if: | _L___4:
						l_tpos.ce_gets (l_pos___3)
						from
						until
							js.loop_left
						loop
							js.reset
							l_c := misc2_inst.inc (l_tpos.address)
							if l_c = -1 then
								js.break
							end
							if not js.loop_jumped then
								l_c := misc1_inst.gchar_pos (l_tpos.address)
								if ((misc2_inst.vim_strchr (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (")]%"%'")), l_c)).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
									js.break
								end
							end
						end
						js.reset
						if l_c /= -1 then
							l_pos := -1 + 34 -- skip if block
						end
				when 32 then -- if:
						l_pos := -1 + 44 -- goto _L___2
				when 33 then -- if block done, skip else block:
						l_pos := -1 + 45
				when 34 then -- else:
						if l_cpo_J.to_boolean then
							l_pos := -1 + 37 -- skip if block
						end
				when 35 then -- if:
						if l_c = 32 then
							l_pos := -1 + 44 -- goto _L___2
						elseif l_c = 9 then
							l_pos := -1 + 44 -- goto _L___2
						else
							l_pos := -1 + 37 -- goto _L___3
						end
				when 36 then -- if block done, skip else block:
						l_pos := -1 + 45
				when 37 then -- else: | _L___3:
						if l_c /= 0 then
							l_pos := -1 + 40 -- skip if block
						end
				when 38 then -- if:
						l_pos := -1 + 44 -- goto _L___2
				when 39 then -- if block done, skip else block:
						l_pos := -1 + 45
				when 40 then -- else:
						if not (l_cpo_J.to_boolean) then
							l_pos := -1 + 45 -- skip if block
						end
				when 41 then -- if:
						if l_c /= 32 then
							l_pos := -1 + 45 -- skip if block
						end
				when 42 then -- if:
						if not ((misc2_inst.inc (l_tpos.address)) >= 0) then
							l_pos := -1 + 45 -- skip if block
						end
				when 43 then -- if:
						if (misc1_inst.gchar_pos (l_tpos.address)) /= 32 then
							l_pos := -1 + 45 -- skip if block
						end
				when 44 then -- if: | _L___2:
						l_pos___3.ce_gets (l_tpos)
						if (misc1_inst.gchar_pos (l_pos___3.address)) = 0 then
							misc2_inst.inc (l_pos___3.address).do_nothing
						end
						js.break
				when 45 then -- if done | if done | if done | if done | if done | if done | if done | if done | if done | if done
						if not js.loop_jumped then
							if (l_func.integer_32_item ([l_pos___3.address])) = -1 then
								if l_count___2.to_boolean then
									Result := 0
									js.return
								end
								if not js.return_called then
									l_noskip := 1
									js.break
								end
							end
						end
						l_pos := -1 + 16 -- back to loop condition
				when 46 then -- loop done
						js.reset
				when 47 then -- if done
						if js.return_called then
							l_pos := -1 + 49 -- skip if block
						end
				when 48 then -- if: | found:
						from
						until
							js.loop_left
						loop
							js.reset
							if not l_noskip.to_boolean then
								l_c := misc1_inst.gchar_pos (l_pos___3.address)
								if l_c /= 32 then
									if l_c /= 9 then
										js.break
									end
								end
							else
								js.break
							end
							if not js.loop_jumped then
								if (misc2_inst.incl (l_pos___3.address)) = -1 then
									js.break
								end
							end
						end
						js.reset
				when 49 then -- if done | if done
						l_pos := -1 + 1 -- back to loop condition
				when 50 then -- loop done
					js.reset
					if not js.return_called then
						mark_inst.setpcmark
						globals_inst.curwin.item.w_cursor := l_pos___3
						Result := 1
					end
				when 51 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	findpar (a_pincl: CE_POINTER [INTEGER_32]; a_dir___0: INTEGER_32; a_count___2: INTEGER_32; a_what: INTEGER_32; a_both: INTEGER_32): INTEGER_32
		local
			l_count___2: INTEGER_32
			l_curr: INTEGER_32
			l_did_skip: INTEGER_32
			l_first___0: INTEGER_32
			l_posix: INTEGER_32
			l_fold_first: INTEGER_32
			l_fold_last: INTEGER_32
			l_fold_skipped: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___7: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_count___2 := a_count___2
					l_posix := (((misc2_inst.vim_strchr (option_inst.p_cpo, ('{').code)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer
					l_curr := globals_inst.curwin.item.w_cursor.lnum
				when 1 then -- loop condition:
					if js.loop_left then
						l_pos := -1 + 14 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						l_tmp___5 := l_count___2
						l_count___2 := l_count___2 - 1
						if not l_tmp___5.to_boolean then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 13 -- skip if block
						end
				when 3 then -- if:
						l_did_skip := 0
						l_first___0 := 1
				when 4 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 12 -- skip loop
						end
				when 5 then -- loop body:
						js.reset
						if ((memline_inst.ml_get (l_curr)).item).to_integer_32 /= 0 then
							l_did_skip := 1
						end
						l_fold_skipped := 0
						if l_first___0.to_boolean then
							if (fold_inst.hasFolding (l_curr, create {CE_POINTER [INTEGER_32]}.make_shared ($l_fold_first), create {CE_POINTER [INTEGER_32]}.make_shared ($l_fold_last))).to_boolean then
								if a_dir___0 > 0 then
									l_tmp___1 := l_fold_last
								else
									l_tmp___1 := l_fold_first
								end
								l_curr := l_tmp___1 + a_dir___0.to_integer_32
								l_fold_skipped := 1
							end
						end
						if not l_first___0.to_boolean then
							if l_did_skip.to_boolean then
								if (startPS (l_curr, a_what, a_both)).to_boolean then
									js.break
								elseif l_posix.to_boolean then
									if a_what = 0 then
										if ((memline_inst.ml_get (l_curr)).item).to_integer_32 = 123 then
											js.break
										end
									end
								end
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 11 -- skip if block
						end
				when 6 then -- if:
						if l_fold_skipped.to_boolean then
							l_curr := l_curr - a_dir___0.to_integer_32
						end
						l_curr := l_curr + a_dir___0.to_integer_32
						if not (l_curr < 1) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 9 then -- else:
						if not (l_curr > globals_inst.curbuf.item.b_ml.ml_line_count) then
							l_pos := -1 + 11 -- skip if block
						end
				when 10 then -- if: | _L:
						if l_count___2.to_boolean then
							Result := 0
							js.return
						end
						if not js.return_called then
							l_curr := l_curr - a_dir___0.to_integer_32
							js.break
						end
				when 11 then -- if done | if done
						if not js.loop_jumped then
							l_first___0 := 0
						end
						l_pos := -1 + 4 -- back to loop condition
				when 12 then -- loop done
						js.reset
				when 13 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 14 then -- loop done
					js.reset
					if not js.return_called then
						mark_inst.setpcmark
						if a_both.to_boolean then
							if ((memline_inst.ml_get (l_curr)).item).to_integer_32 = 125 then
								l_curr := l_curr + 1
							end
						end
						globals_inst.curwin.item.w_cursor.lnum := l_curr
						if l_curr = globals_inst.curbuf.item.b_ml.ml_line_count then
							if a_what /= 125 then
								l_tmp___7 := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((memline_inst.ml_get (l_curr))))).to_integer_32
								globals_inst.curwin.item.w_cursor.col := l_tmp___7
								if l_tmp___7 /= 0 then
									globals_inst.curwin.item.w_cursor.col := (globals_inst.curwin.item.w_cursor.col) - 1
									a_pincl.item := 1
								end
							else
								globals_inst.curwin.item.w_cursor.col := 0
							end
						else
							globals_inst.curwin.item.w_cursor.col := 0
						end
						Result := 1
					end
				when 15 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	inmacro (a_opt: CE_POINTER [NATURAL_8]; a_s: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_macro: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_macro.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_macro.ce_gets (a_opt)
				when 1 then -- loop condition:
					if not (not js.loop_left and then ((l_macro[0]).to_boolean)) then
						l_pos := -1 + 19 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						if (l_macro[0]).to_integer_32 /= (a_s[0]).to_integer_32 then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_pos := -1 + 10 -- goto _L___1
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 5 then -- else:
						if (l_macro[0]).to_integer_32 /= 32 then
							l_pos := -1 + 18 -- skip if block
						end
				when 6 then -- if:
						if (a_s[0]).to_integer_32 /= 0 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L___1
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 9 then -- else:
						if (a_s[0]).to_integer_32 /= 32 then
							l_pos := -1 + 18 -- skip if block
						end
				when 10 then -- if: | _L___1:
						if (l_macro[1]).to_integer_32 /= (a_s[1]).to_integer_32 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						js.break
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 13 then -- else:
						if (l_macro[1]).to_integer_32 /= 0 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_pos := -1 + 17 -- goto _L
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 16 then -- else:
						if (l_macro[1]).to_integer_32 /= 32 then
							l_pos := -1 + 18 -- skip if block
						end
				when 17 then -- if: | _L:
						if (a_s[0]).to_integer_32 = 0 then
							js.break
						elseif (a_s[1]).to_integer_32 = 0 then
							js.break
						elseif (a_s[1]).to_integer_32 = 32 then
							js.break
						end
				when 18 then -- if done | if done | if done | if done | if done | if done
						if not js.loop_jumped then
							l_macro.ce_gets (l_macro + 1)
							if (l_macro[0]).to_integer_32 = 0 then
								js.break
							end
						end
						if not js.loop_jumped then
							l_macro.ce_gets (l_macro + 1)
						end
						l_pos := -1 + 1 -- back to loop condition
				when 19 then -- loop done
					js.reset
					Result := ((l_macro[0]).to_integer_32 /= 0).to_integer
				when 20 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	startPS (a_lnum: INTEGER_32; a_para: INTEGER_32; a_both: INTEGER_32): INTEGER_32
		local
			l_s: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_s.make

			l_s.ce_gets (memline_inst.ml_get (a_lnum))
			if (l_s.item).to_integer_32 = a_para then
				Result := 1
				js.return
			elseif (l_s.item).to_integer_32 = 12 then
				Result := 1
				js.return
			elseif a_both.to_boolean then
				if (l_s.item).to_integer_32 = 125 then
					Result := 1
					js.return
				end
			end
			if not js.return_called and then ((l_s.item).to_integer_32 = 46) then
				if (inmacro (option_inst.p_sections, l_s + 1)).to_boolean then
					Result := 1
					js.return
				elseif not a_para.to_boolean then
					if (inmacro (option_inst.p_para, l_s + 1)).to_boolean then
						Result := 1
						js.return
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	cls: INTEGER_32
		local
			l_c: INTEGER_32
			js: JUMP_STATE
		do
			l_c := misc1_inst.gchar_cursor
			if l_c = 32 then
				Result := 0
				js.return
			elseif l_c = 9 then
				Result := 0
				js.return
			elseif l_c = 0 then
				Result := 0
				js.return
			end
			if not js.return_called and then (globals_inst.enc_dbcs /= 0) then
				if l_c > 255 then
					if globals_inst.enc_dbcs = 949 then
						if cls_bigword.to_boolean then
							Result := 1
							js.return
						end
					end
					if not js.return_called then
						Result := (mbyte_inst.dbcs_class ((l_c.to_natural_32).bit_shift_right (8), ((l_c).bit_and (255)).to_natural_32))
						js.return
					end
				end
			end
			if not js.return_called and then (globals_inst.enc_utf8.to_boolean) then
				l_c := mbyte_inst.utf_class (l_c)
				if l_c /= 0 then
					if cls_bigword.to_boolean then
						Result := 1
						js.return
					end
				end
				if not js.return_called then
					Result := l_c
					js.return
				end
			end
			if not js.return_called and then (cls_bigword.to_boolean) then
				Result := 1
				js.return
			end
			if not js.return_called then
				if (charset_inst.vim_iswordc (l_c)).to_boolean then
					Result := 2
					js.return
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	fwd_word (a_count___2: INTEGER_32; a_bigword: INTEGER_32; a_eol: INTEGER_32): INTEGER_32
		local
			l_count___2: INTEGER_32
			l_sclass: INTEGER_32
			l_i___0: INTEGER_32
			l_last_line: INTEGER_32
			js: JUMP_STATE
		do
			l_count___2 := a_count___2
			globals_inst.curwin.item.w_cursor.coladd := 0
			cls_bigword := a_bigword
			from
			until
				js.loop_left
			loop
				js.reset
				l_count___2 := l_count___2 - 1
				if not (l_count___2 >= 0) then
					js.break
				end
				if not js.loop_jumped then
					if (fold_inst.hasFolding (globals_inst.curwin.item.w_cursor.lnum, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (globals_inst.curwin.c_pointer + {PD_WINDOW_S}.w_cursor_offset + {PD_POS_T}.lnum_offset))).to_boolean then
						misc2_inst.coladvance ((2147483647).to_integer_32).do_nothing
					end
					l_sclass := cls
					l_last_line := (globals_inst.curwin.item.w_cursor.lnum = globals_inst.curbuf.item.b_ml.ml_line_count).to_integer
					l_i___0 := misc2_inst.inc_cursor
					if l_i___0 = -1 then
						Result := 0
						js.return
					elseif l_i___0 >= 1 then
						if l_last_line.to_boolean then
							Result := 0
							js.return
						end
					end
					if not js.return_called and then (l_i___0 >= 1) then
						if a_eol.to_boolean then
							if l_count___2 = 0 then
								Result := 1
								js.return
							end
						end
					end
					if not js.return_called and then (l_sclass /= 0) then
						from
						until
							js.loop_left
						loop
							js.reset
							if (cls) /= l_sclass then
								js.break
							end
							if not js.loop_jumped then
								l_i___0 := misc2_inst.inc_cursor
								if l_i___0 = -1 then
									Result := 1
									js.return
								elseif l_i___0 >= 1 then
									if a_eol.to_boolean then
										if l_count___2 = 0 then
											Result := 1
											js.return
										end
									end
								end
							end
						end
						js.reset
					end
					if not js.return_called then
						from
						until
							js.loop_left
						loop
							js.reset
							if (cls) /= 0 then
								js.break
							end
							if not js.loop_jumped and then (globals_inst.curwin.item.w_cursor.col = 0) then
								if ((memline_inst.ml_get_curline).item).to_integer_32 = 0 then
									js.break
								end
							end
							if not js.loop_jumped then
								l_i___0 := misc2_inst.inc_cursor
								if l_i___0 = -1 then
									Result := 1
									js.return
								elseif l_i___0 >= 1 then
									if a_eol.to_boolean then
										if l_count___2 = 0 then
											Result := 1
											js.return
										end
									end
								end
							end
						end
						js.reset
					end
				end
			end
			js.reset
			if not js.return_called then
				Result := 1
			end
		end

	bck_word (a_count___2: INTEGER_32; a_bigword: INTEGER_32; a_stop: INTEGER_32): INTEGER_32
		local
			l_count___2: INTEGER_32
			l_stop: INTEGER_32
			l_sclass: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_count___2 := a_count___2
					l_stop := a_stop
					globals_inst.curwin.item.w_cursor.coladd := 0
					cls_bigword := a_bigword
				when 1 then -- loop condition:
					if js.loop_left then
						l_pos := -1 + 21 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						l_count___2 := l_count___2 - 1
						if not (l_count___2 >= 0) then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 20 -- skip if block
						end
				when 3 then -- if:
						if (fold_inst.hasFolding (globals_inst.curwin.item.w_cursor.lnum, create {CE_POINTER [INTEGER_32]}.make_shared (globals_inst.curwin.c_pointer + {PD_WINDOW_S}.w_cursor_offset + {PD_POS_T}.lnum_offset), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))).to_boolean then
							globals_inst.curwin.item.w_cursor.col := 0
						end
						l_sclass := cls
						if (misc2_inst.dec_cursor) = -1 then
							Result := 0
							js.return
						end
						if js.return_called then
							l_pos := -1 + 17 -- skip if block
						end
				when 4 then -- if:
						if l_stop.to_boolean then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 11 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 7 then -- else:
						if l_sclass /= (cls) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 11 -- goto _L
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 10 then -- else:
						if l_sclass /= 0 then
							l_pos := -1 + 17 -- skip if block
						end
				when 11 then -- if: | _L:
						if js.loop_left then
							l_pos := -1 + 16 -- skip loop
						end
				when 12 then -- loop body:
						js.reset
						if (cls) /= 0 then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						if globals_inst.curwin.item.w_cursor.col = 0 then
							if ((memline_inst.ml_get (globals_inst.curwin.item.w_cursor.lnum)).item).to_integer_32 = 0 then
								l_pos := -1 + 19 -- goto finished
							end
						end
				when 14 then
						if (misc2_inst.dec_cursor) = -1 then
							Result := 1
							js.return
						end
				when 15 then -- if done
						l_pos := -1 + 11 -- back to loop condition
				when 16 then -- loop done
						js.reset
						if not js.return_called then
							if (skip_chars ((cls), -1)).to_boolean then
								Result := 1
								js.return
							end
						end
				when 17 then -- if done | if done | if done
						if js.return_called then
							l_pos := -1 + 20 -- skip if block
						end
				when 18 then -- if:
						misc2_inst.inc_cursor.do_nothing
				when 19 then -- finished:
						l_stop := 0
				when 20 then -- if done | if done
						l_pos := -1 + 1 -- back to loop condition
				when 21 then -- loop done
					js.reset
					if not js.return_called then
						Result := 1
					end
				when 22 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	end_word (a_count___2: INTEGER_32; a_bigword: INTEGER_32; a_stop: INTEGER_32; a_empty: INTEGER_32): INTEGER_32
		local
			l_count___2: INTEGER_32
			l_stop: INTEGER_32
			l_sclass: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_count___2 := a_count___2
					l_stop := a_stop
					globals_inst.curwin.item.w_cursor.coladd := 0
					cls_bigword := a_bigword
				when 1 then -- loop condition:
					if js.loop_left then
						l_pos := -1 + 21 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						l_count___2 := l_count___2 - 1
						if not (l_count___2 >= 0) then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 20 -- skip if block
						end
				when 3 then -- if:
						if (fold_inst.hasFolding (globals_inst.curwin.item.w_cursor.lnum, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (globals_inst.curwin.c_pointer + {PD_WINDOW_S}.w_cursor_offset + {PD_POS_T}.lnum_offset))).to_boolean then
							misc2_inst.coladvance ((2147483647).to_integer_32).do_nothing
						end
						l_sclass := cls
						if (misc2_inst.inc_cursor) = -1 then
							Result := 0
							js.return
						end
						if js.return_called then
							l_pos := -1 + 17 -- skip if block
						end
				when 4 then -- if:
						if (cls) /= l_sclass then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if l_sclass /= 0 then
							if (skip_chars (l_sclass, 1)).to_boolean then
								Result := 0
								js.return
							end
						else
							l_pos := -1 + 7 -- goto _L___0
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 7 then -- else: | _L___0:
						if l_stop.to_boolean then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 11 -- goto _L
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 10 then -- else:
						if l_sclass /= 0 then
							l_pos := -1 + 17 -- skip if block
						end
				when 11 then -- if: | _L:
						if js.loop_left then
							l_pos := -1 + 16 -- skip loop
						end
				when 12 then -- loop body:
						js.reset
						if (cls) /= 0 then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						if a_empty.to_boolean then
							if globals_inst.curwin.item.w_cursor.col = 0 then
								if ((memline_inst.ml_get (globals_inst.curwin.item.w_cursor.lnum)).item).to_integer_32 = 0 then
									l_pos := -1 + 19 -- goto finished
								end
							end
						end
				when 14 then
						if (misc2_inst.inc_cursor) = -1 then
							Result := 0
							js.return
						end
				when 15 then -- if done
						l_pos := -1 + 11 -- back to loop condition
				when 16 then -- loop done
						js.reset
						if not js.return_called then
							if (skip_chars ((cls), 1)).to_boolean then
								Result := 0
								js.return
							end
						end
				when 17 then -- if done | if done | if done
						if js.return_called then
							l_pos := -1 + 20 -- skip if block
						end
				when 18 then -- if:
						misc2_inst.dec_cursor.do_nothing
				when 19 then -- finished:
						l_stop := 0
				when 20 then -- if done | if done
						l_pos := -1 + 1 -- back to loop condition
				when 21 then -- loop done
					js.reset
					if not js.return_called then
						Result := 1
					end
				when 22 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	bckend_word (a_count___2: INTEGER_32; a_bigword: INTEGER_32; a_eol: INTEGER_32): INTEGER_32
		local
			l_count___2: INTEGER_32
			l_sclass: INTEGER_32
			l_i___0: INTEGER_32
			js: JUMP_STATE
		do
			l_count___2 := a_count___2
			globals_inst.curwin.item.w_cursor.coladd := 0
			cls_bigword := a_bigword
			from
			until
				js.loop_left
			loop
				js.reset
				l_count___2 := l_count___2 - 1
				if not (l_count___2 >= 0) then
					js.break
				end
				if not js.loop_jumped then
					l_sclass := cls
					l_i___0 := misc2_inst.dec_cursor
					if l_i___0 = -1 then
						Result := 0
						js.return
					end
					if not js.return_called and then (a_eol.to_boolean) then
						if l_i___0 = 1 then
							Result := 1
							js.return
						end
					end
					if not js.return_called and then (l_sclass /= 0) then
						from
						until
							js.loop_left
						loop
							js.reset
							if (cls) /= l_sclass then
								js.break
							end
							if not js.loop_jumped then
								l_i___0 := misc2_inst.dec_cursor
								if l_i___0 = -1 then
									Result := 1
									js.return
								elseif a_eol.to_boolean then
									if l_i___0 = 1 then
										Result := 1
										js.return
									end
								end
							end
						end
						js.reset
					end
					if not js.return_called then
						from
						until
							js.loop_left
						loop
							js.reset
							if (cls) /= 0 then
								js.break
							end
							if not js.loop_jumped and then (globals_inst.curwin.item.w_cursor.col = 0) then
								if ((memline_inst.ml_get (globals_inst.curwin.item.w_cursor.lnum)).item).to_integer_32 = 0 then
									js.break
								end
							end
							if not js.loop_jumped then
								l_i___0 := misc2_inst.dec_cursor
								if l_i___0 = -1 then
									Result := 1
									js.return
								elseif a_eol.to_boolean then
									if l_i___0 = 1 then
										Result := 1
										js.return
									end
								end
							end
						end
						js.reset
					end
				end
			end
			js.reset
			if not js.return_called then
				Result := 1
			end
		end

	skip_chars (a_cclass: INTEGER_32; a_dir___0: INTEGER_32): INTEGER_32
		local
			l_tmp___1: INTEGER_32
			js: JUMP_STATE
		do
			from
			until
				js.loop_left
			loop
				js.reset
				if (cls) /= a_cclass then
					js.break
				end
				if not js.loop_jumped then
					if a_dir___0 = 1 then
						l_tmp___1 := (misc2_inst.inc_cursor)
					else
						l_tmp___1 := (misc2_inst.dec_cursor)
					end
					if l_tmp___1 = -1 then
						Result := 1
						js.return
					end
				end
			end
			js.reset
			if not js.return_called then
				Result := 0
			end
		end

	back_in_line
		local
			l_sclass: INTEGER_32
			js: JUMP_STATE
		do
			l_sclass := cls
			from
			until
				not (not js.loop_left and then (globals_inst.curwin.item.w_cursor.col /= 0))
			loop
				js.reset
				misc2_inst.dec_cursor.do_nothing
				if (cls) /= l_sclass then
					misc2_inst.inc_cursor.do_nothing
					js.break
				end
			end
			js.reset
		end

	find_first_blank (a_posp: CE_POINTER [PD_POS_T])
		local
			l_c: INTEGER_32
			js: JUMP_STATE
		do
			from
			until
				js.loop_left
			loop
				js.reset
				if (misc2_inst.decl (a_posp)) = -1 then
					js.break
				end
				if not js.loop_jumped then
					l_c := misc1_inst.gchar_pos (a_posp)
					if l_c /= 32 then
						if l_c /= 9 then
							misc2_inst.incl (a_posp).do_nothing
							js.break
						end
					end
				end
			end
			js.reset
		end

	findsent_forward (a_count___2: INTEGER_32; a_at_start_sent: INTEGER_32)
		local
			l_count___2: INTEGER_32
			l_at_start_sent: INTEGER_32
			l_tmp: INTEGER_32
			js: JUMP_STATE
		do
			l_count___2 := a_count___2
			l_at_start_sent := a_at_start_sent
			from
			until
				js.loop_left
			loop
				js.reset
				l_tmp := l_count___2
				l_count___2 := l_count___2 - 1
				if not l_tmp.to_boolean then
					js.break
				end
				if not js.loop_jumped then
					findsent (1, 1).do_nothing
					if l_at_start_sent.to_boolean then
						find_first_blank (create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curwin.c_pointer + {PD_WINDOW_S}.w_cursor_offset))
					end
					if l_count___2 = 0 then
						misc2_inst.decl (create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curwin.c_pointer + {PD_WINDOW_S}.w_cursor_offset)).do_nothing
					elseif l_at_start_sent.to_boolean then
						misc2_inst.decl (create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curwin.c_pointer + {PD_WINDOW_S}.w_cursor_offset)).do_nothing
					end
					l_at_start_sent := (not l_at_start_sent.to_boolean).to_integer
				end
			end
			js.reset
		end

	current_word (a_oap: CE_POINTER [PD_OPARG_S]; a_count___2: INTEGER_32; a_include: INTEGER_32; a_bigword: INTEGER_32): INTEGER_32
		local
			l_count___2: INTEGER_32
			l_start_pos: PD_POS_T
			l_pos___3: PD_POS_T
			l_inclusive: INTEGER_32
			l_include_white: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___12: INTEGER_32
			l_tmp___13: INTEGER_32
			l_tmp___17: INTEGER_32
			l_tmp___18: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_start_pos.make
			create l_pos___3.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_count___2 := a_count___2
					l_inclusive := 1
					l_include_white := 0
					cls_bigword := a_bigword
					l_start_pos.lnum := (0).to_integer_32
					l_start_pos.col := 0
					l_start_pos.coladd := 0
					if globals_inst.VIsual_active.to_boolean then
						if (option_inst.p_sel.item).to_integer_32 = 101 then
							if globals_inst.VIsual.lnum /= globals_inst.curwin.item.w_cursor.lnum then
								l_tmp___0 := (globals_inst.VIsual.lnum < globals_inst.curwin.item.w_cursor.lnum).to_integer
							else
								if globals_inst.VIsual.col /= globals_inst.curwin.item.w_cursor.col then
									l_tmp := (globals_inst.VIsual.col < globals_inst.curwin.item.w_cursor.col).to_integer
								else
									l_tmp := (globals_inst.VIsual.coladd < globals_inst.curwin.item.w_cursor.coladd).to_integer
								end
								l_tmp___0 := l_tmp
							end
							if l_tmp___0.to_boolean then
								misc2_inst.dec_cursor.do_nothing
							end
						end
					end
					if globals_inst.VIsual_active.to_boolean then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 6 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if globals_inst.curwin.item.w_cursor.lnum /= globals_inst.VIsual.lnum then
							l_pos := -1 + 7 -- skip if block
						end
				when 4 then -- if:
						if globals_inst.curwin.item.w_cursor.col /= globals_inst.VIsual.col then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if globals_inst.curwin.item.w_cursor.coladd /= globals_inst.VIsual.coladd then
							l_pos := -1 + 7 -- skip if block
						end
				when 6 then -- if: | _L:
						back_in_line
						l_start_pos.ce_gets (globals_inst.curwin.item.w_cursor)
						if ((cls) = 0) = a_include.to_boolean then
							if (end_word (1, a_bigword, 1, 1)) = 0 then
								Result := 0
								js.return
							end
						else
							fwd_word (1, a_bigword, 1).do_nothing
							if globals_inst.curwin.item.w_cursor.col = 0 then
								misc2_inst.decl (create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curwin.c_pointer + {PD_WINDOW_S}.w_cursor_offset)).do_nothing
							else
								edit_inst.oneleft.do_nothing
							end
							if a_include.to_boolean then
								l_include_white := 1
							end
						end
						if not js.return_called then
							if globals_inst.VIsual_active.to_boolean then
								globals_inst.VIsual.ce_gets (l_start_pos)
								screen_inst.redraw_curbuf_later (20)
							else
								a_oap.item.start := l_start_pos
								a_oap.item.motion_type := 0
							end
							l_count___2 := l_count___2 - 1
						end
				when 7 then -- if done | if done | if done
						if js.return_called then
							l_pos := -1 + 14 -- skip if block
						end
				when 8 then -- if: | loop condition:
							if not (not js.loop_left and then (l_count___2 > 0)) then
								l_pos := -1 + 14 -- skip loop
							end
				when 9 then -- loop body:
							l_inclusive := 1
							if not (globals_inst.VIsual_active.to_boolean) then
								l_pos := -1 + 12 -- skip if block
							end
				when 10 then -- if:
							if globals_inst.curwin.item.w_cursor.lnum /= globals_inst.VIsual.lnum then
								l_tmp___13 := (globals_inst.curwin.item.w_cursor.lnum < globals_inst.VIsual.lnum).to_integer
							else
								if globals_inst.curwin.item.w_cursor.col /= globals_inst.VIsual.col then
									l_tmp___12 := (globals_inst.curwin.item.w_cursor.col < globals_inst.VIsual.col).to_integer
								else
									l_tmp___12 := (globals_inst.curwin.item.w_cursor.coladd < globals_inst.VIsual.coladd).to_integer
								end
								l_tmp___13 := l_tmp___12
							end
							if l_tmp___13.to_boolean then
								if (misc2_inst.decl (create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curwin.c_pointer + {PD_WINDOW_S}.w_cursor_offset))) = -1 then
									Result := 0
									js.return
								end
								if not js.return_called then
									if a_include.to_boolean /= ((cls) /= 0) then
										if (bck_word (1, a_bigword, 1)) = 0 then
											Result := 0
											js.return
										end
									else
										if (bckend_word (1, a_bigword, 1)) = 0 then
											Result := 0
											js.return
										end
										if not js.return_called then
											misc2_inst.incl (create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curwin.c_pointer + {PD_WINDOW_S}.w_cursor_offset)).do_nothing
										end
									end
								end
							else
								l_pos := -1 + 12 -- goto _L___0
							end
				when 11 then -- if block done, skip else block:
							l_pos := -1 + 13
				when 12 then -- else: | _L___0:
							if (misc2_inst.incl (create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curwin.c_pointer + {PD_WINDOW_S}.w_cursor_offset))) = -1 then
								Result := 0
								js.return
							end
							if not js.return_called then
								if a_include.to_boolean /= ((cls) = 0) then
									if (fwd_word (1, a_bigword, 1)) = 0 then
										if l_count___2 > 1 then
											Result := 0
											js.return
										end
									end
									if not js.return_called then
										if (edit_inst.oneleft) = 0 then
											l_inclusive := 0
										end
									end
								elseif (end_word (1, a_bigword, 1, 1)) = 0 then
									Result := 0
									js.return
								end
							end
				when 13 then
							if not js.return_called then
								l_count___2 := l_count___2 - 1
							end
							l_pos := -1 + 8 -- back to loop condition
				when 14 then -- loop done | if done
							if js.return_called then
								l_pos := -1 + 23 -- skip if block
							end
				when 15 then -- if:
								if not (l_include_white.to_boolean) then
									l_pos := -1 + 22 -- skip if block
								end
				when 16 then -- if:
								if (cls) = 0 then
									l_pos := -1 + 19 -- skip if block
								end
				when 17 then -- if:
								l_pos := -1 + 21 -- goto _L___1
				when 18 then -- if block done, skip else block:
								l_pos := -1 + 22
				when 19 then -- else:
								if globals_inst.curwin.item.w_cursor.col /= 0 then
									l_pos := -1 + 22 -- skip if block
								end
				when 20 then -- if:
								if l_inclusive.to_boolean then
									l_pos := -1 + 22 -- skip if block
								end
				when 21 then -- if: | _L___1:
								l_pos___3.ce_gets (globals_inst.curwin.item.w_cursor)
								globals_inst.curwin.item.w_cursor := l_start_pos
								if (edit_inst.oneleft) = 1 then
									back_in_line
									if (cls) = 0 then
										if globals_inst.curwin.item.w_cursor.col > 0 then
											if globals_inst.VIsual_active.to_boolean then
												globals_inst.VIsual.ce_gets (globals_inst.curwin.item.w_cursor)
											else
												a_oap.item.start := globals_inst.curwin.item.w_cursor
											end
										end
									end
								end
								globals_inst.curwin.item.w_cursor := l_pos___3
				when 22 then -- if done | if done | if done
								if globals_inst.VIsual_active.to_boolean then
									if (option_inst.p_sel.item).to_integer_32 = 101 then
										if l_inclusive.to_boolean then
											if globals_inst.VIsual.lnum /= globals_inst.curwin.item.w_cursor.lnum then
												l_tmp___18 := (globals_inst.VIsual.lnum < globals_inst.curwin.item.w_cursor.lnum).to_integer
											else
												if globals_inst.VIsual.col /= globals_inst.curwin.item.w_cursor.col then
													l_tmp___17 := (globals_inst.VIsual.col < globals_inst.curwin.item.w_cursor.col).to_integer
												else
													l_tmp___17 := (globals_inst.VIsual.coladd < globals_inst.curwin.item.w_cursor.coladd).to_integer
												end
												l_tmp___18 := l_tmp___17
											end
											if l_tmp___18.to_boolean then
												misc2_inst.inc_cursor.do_nothing
											elseif globals_inst.VIsual.lnum = globals_inst.curwin.item.w_cursor.lnum then
												if globals_inst.VIsual.col = globals_inst.curwin.item.w_cursor.col then
													if globals_inst.VIsual.coladd = globals_inst.curwin.item.w_cursor.coladd then
														misc2_inst.inc_cursor.do_nothing
													end
												end
											end
										end
									end
									if globals_inst.VIsual_mode = 86 then
										globals_inst.VIsual_mode := ('v').code
										globals_inst.redraw_cmdline := 1
									end
								else
									a_oap.item.inclusive := l_inclusive
								end
								Result := 1
				when 23 then
							l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
				end

	current_sent (a_oap: CE_POINTER [PD_OPARG_S]; a_count___2: INTEGER_32; a_include: INTEGER_32): INTEGER_32
		local
			l_count___2: INTEGER_32
			l_start_pos: PD_POS_T
			l_pos___3: PD_POS_T
			l_start_blank: INTEGER_32
			l_c: INTEGER_32
			l_at_start_sent: INTEGER_32
			l_ncount: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___7: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_start_pos.make
			create l_pos___3.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_count___2 := a_count___2
					l_start_pos.ce_gets (globals_inst.curwin.item.w_cursor)
					l_pos___3.ce_gets (l_start_pos)
					findsent (1, 1).do_nothing
					if not (globals_inst.VIsual_active.to_boolean) then
						l_pos := -1 + 13 -- skip if block
					end
				when 1 then -- if:
						if l_start_pos.lnum /= globals_inst.VIsual.lnum then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_start_pos.col = globals_inst.VIsual.col then
							if l_start_pos.coladd /= globals_inst.VIsual.coladd then
								l_pos := -1 + 4 -- goto extend
							end
						else
							l_pos := -1 + 4 -- goto extend
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 4 then -- else: | extend:
						if l_start_pos.lnum /= globals_inst.VIsual.lnum then
							l_tmp___5 := (l_start_pos.lnum < globals_inst.VIsual.lnum).to_integer
						else
							if l_start_pos.col /= globals_inst.VIsual.col then
								l_tmp___4 := (l_start_pos.col < globals_inst.VIsual.col).to_integer
							else
								l_tmp___4 := (l_start_pos.coladd < globals_inst.VIsual.coladd).to_integer
							end
							l_tmp___5 := l_tmp___4
						end
						if not (l_tmp___5.to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_at_start_sent := 1
						misc2_inst.decl (l_pos___3.address).do_nothing
						from
						until
							js.loop_left
						loop
							js.reset
							if l_pos___3.lnum /= globals_inst.curwin.item.w_cursor.lnum then
								l_tmp___0 := (l_pos___3.lnum < globals_inst.curwin.item.w_cursor.lnum).to_integer
							else
								if l_pos___3.col /= globals_inst.curwin.item.w_cursor.col then
									l_tmp := (l_pos___3.col < globals_inst.curwin.item.w_cursor.col).to_integer
								else
									l_tmp := (l_pos___3.coladd < globals_inst.curwin.item.w_cursor.coladd).to_integer
								end
								l_tmp___0 := l_tmp
							end
							if not l_tmp___0.to_boolean then
								js.break
							end
							if not js.loop_jumped then
								l_c := misc1_inst.gchar_pos (l_pos___3.address)
								if l_c /= 32 then
									if l_c /= 9 then
										l_at_start_sent := 0
										js.break
									end
								end
							end
							if not js.loop_jumped then
								misc2_inst.incl (l_pos___3.address).do_nothing
							end
						end
						js.reset
						if not l_at_start_sent.to_boolean then
							findsent (-1, 1).do_nothing
							if globals_inst.curwin.item.w_cursor.lnum = l_start_pos.lnum then
								if globals_inst.curwin.item.w_cursor.col = l_start_pos.col then
									if globals_inst.curwin.item.w_cursor.coladd = l_start_pos.coladd then
										l_at_start_sent := 1
									else
										findsent (1, 1).do_nothing
									end
								else
									findsent (1, 1).do_nothing
								end
							else
								findsent (1, 1).do_nothing
							end
						end
						if a_include.to_boolean then
							l_count___2 := l_count___2 * (2)
						end
						from
						until
							js.loop_left
						loop
							js.reset
							l_tmp___1 := l_count___2
							l_count___2 := l_count___2 - 1
							if not l_tmp___1.to_boolean then
								js.break
							end
							if not js.loop_jumped then
								if l_at_start_sent.to_boolean then
									find_first_blank (create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curwin.c_pointer + {PD_WINDOW_S}.w_cursor_offset))
								end
								l_c := misc1_inst.gchar_cursor
								if not l_at_start_sent.to_boolean then
									findsent (-1, 1).do_nothing
								elseif not a_include.to_boolean then
									if l_c /= 32 then
										if l_c /= 9 then
											findsent (-1, 1).do_nothing
										end
									end
								end
								l_at_start_sent := (not l_at_start_sent.to_boolean).to_integer
							end
						end
						js.reset
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 7 then -- else:
						misc2_inst.incl (l_pos___3.address).do_nothing
						l_at_start_sent := 1
						if l_pos___3.lnum /= globals_inst.curwin.item.w_cursor.lnum then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						if l_pos___3.col = globals_inst.curwin.item.w_cursor.col then
							if l_pos___3.coladd /= globals_inst.curwin.item.w_cursor.coladd then
								l_pos := -1 + 10 -- goto _L___0
							end
						else
							l_pos := -1 + 10 -- goto _L___0
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else: | _L___0:
						l_at_start_sent := 0
						from
						until
							js.loop_left
						loop
							js.reset
							if l_pos___3.lnum /= globals_inst.curwin.item.w_cursor.lnum then
								l_tmp___3 := (l_pos___3.lnum < globals_inst.curwin.item.w_cursor.lnum).to_integer
							else
								if l_pos___3.col /= globals_inst.curwin.item.w_cursor.col then
									l_tmp___2 := (l_pos___3.col < globals_inst.curwin.item.w_cursor.col).to_integer
								else
									l_tmp___2 := (l_pos___3.coladd < globals_inst.curwin.item.w_cursor.coladd).to_integer
								end
								l_tmp___3 := l_tmp___2
							end
							if not l_tmp___3.to_boolean then
								js.break
							end
							if not js.loop_jumped then
								l_c := misc1_inst.gchar_pos (l_pos___3.address)
								if l_c /= 32 then
									if l_c /= 9 then
										l_at_start_sent := 1
										js.break
									end
								end
							end
							if not js.loop_jumped then
								misc2_inst.incl (l_pos___3.address).do_nothing
							end
						end
						js.reset
						if l_at_start_sent.to_boolean then
							findsent (-1, 1).do_nothing
						else
							globals_inst.curwin.item.w_cursor := l_start_pos
						end
				when 11 then
						if a_include.to_boolean then
							l_count___2 := l_count___2 * (2)
						end
						findsent_forward (l_count___2, l_at_start_sent)
						if (option_inst.p_sel.item).to_integer_32 = 101 then
							globals_inst.curwin.item.w_cursor.col := (globals_inst.curwin.item.w_cursor.col) + 1
						end
				when 12 then -- if done
						Result := 1
						js.return
				when 13 then -- if done
						if js.return_called then
							l_pos := -1 + 20 -- skip if block
						end
				when 14 then -- if:
							from
							until
								js.loop_left
							loop
								js.reset
								l_c := misc1_inst.gchar_pos (l_pos___3.address)
								if l_c = 32 then
									l_tmp___6 := 1
								elseif l_c = 9 then
									l_tmp___6 := 1
								else
									l_tmp___6 := 0
								end
								if not l_tmp___6.to_boolean then
									js.break
								end
								if not js.loop_jumped then
									misc2_inst.incl (l_pos___3.address).do_nothing
								end
							end
							js.reset
							if l_pos___3.lnum = globals_inst.curwin.item.w_cursor.lnum then
								if l_pos___3.col = globals_inst.curwin.item.w_cursor.col then
									if l_pos___3.coladd = globals_inst.curwin.item.w_cursor.coladd then
										l_start_blank := 1
										find_first_blank (l_start_pos.address)
									else
										l_start_blank := 0
										findsent (-1, 1).do_nothing
										l_start_pos.ce_gets (globals_inst.curwin.item.w_cursor)
									end
								else
									l_start_blank := 0
									findsent (-1, 1).do_nothing
									l_start_pos.ce_gets (globals_inst.curwin.item.w_cursor)
								end
							else
								l_start_blank := 0
								findsent (-1, 1).do_nothing
								l_start_pos.ce_gets (globals_inst.curwin.item.w_cursor)
							end
							if a_include.to_boolean then
								l_ncount := l_count___2 * 2
							else
								l_ncount := l_count___2
								if l_start_blank.to_boolean then
									l_ncount := l_ncount - 1
								end
							end
							if l_ncount > 0 then
								findsent_forward (l_ncount, 1)
							else
								misc2_inst.decl (create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curwin.c_pointer + {PD_WINDOW_S}.w_cursor_offset)).do_nothing
							end
							if a_include.to_boolean then
								if l_start_blank.to_boolean then
									find_first_blank (create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curwin.c_pointer + {PD_WINDOW_S}.w_cursor_offset))
									l_c := misc1_inst.gchar_pos (create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curwin.c_pointer + {PD_WINDOW_S}.w_cursor_offset))
									if l_c = 32 then
										misc2_inst.decl (create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curwin.c_pointer + {PD_WINDOW_S}.w_cursor_offset)).do_nothing
									elseif l_c = 9 then
										misc2_inst.decl (create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curwin.c_pointer + {PD_WINDOW_S}.w_cursor_offset)).do_nothing
									end
								else
									l_c := misc1_inst.gchar_cursor
									if l_c = 32 then
										l_tmp___7 := 0
									elseif l_c = 9 then
										l_tmp___7 := 0
									else
										l_tmp___7 := 1
									end
									if l_tmp___7.to_boolean then
										find_first_blank (l_start_pos.address)
									end
								end
							end
							if not (globals_inst.VIsual_active.to_boolean) then
								l_pos := -1 + 18 -- skip if block
							end
				when 15 then -- if:
							if l_start_pos.lnum = globals_inst.curwin.item.w_cursor.lnum then
								if l_start_pos.col = globals_inst.curwin.item.w_cursor.col then
									if l_start_pos.coladd = globals_inst.curwin.item.w_cursor.coladd then
										l_pos := -1 + 4 -- goto extend
									end
								end
							end
				when 16 then
							if (option_inst.p_sel.item).to_integer_32 = 101 then
								globals_inst.curwin.item.w_cursor.col := (globals_inst.curwin.item.w_cursor.col) + 1
							end
							globals_inst.VIsual.ce_gets (l_start_pos)
							globals_inst.VIsual_mode := ('v').code
							screen_inst.redraw_curbuf_later (20)
				when 17 then -- if block done, skip else block:
							l_pos := -1 + 19
				when 18 then -- else:
							if (misc2_inst.incl (create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curwin.c_pointer + {PD_WINDOW_S}.w_cursor_offset))) = -1 then
								a_oap.item.inclusive := 1
							else
								a_oap.item.inclusive := 0
							end
							a_oap.item.start := l_start_pos
							a_oap.item.motion_type := 0
				when 19 then -- if done
							Result := 1
				when 20 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	current_block (a_oap: CE_POINTER [PD_OPARG_S]; a_count___2: INTEGER_32; a_include: INTEGER_32; a_what: INTEGER_32; a_other: INTEGER_32): INTEGER_32
		local
			l_count___2: INTEGER_32
			l_old_pos: PD_POS_T
			l_pos___3: CE_POINTER [PD_POS_T]
			l_start_pos: PD_POS_T
			l_end_pos: CE_POINTER [PD_POS_T]
			l_old_start: PD_POS_T
			l_old_end: PD_POS_T
			l_save_cpo: CE_POINTER [NATURAL_8]
			l_sol: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___8: INTEGER_32
			l_tmp___9: INTEGER_32
			l_tmp___10: INTEGER_32
			l_tmp___12: INTEGER_32
			l_tmp___13: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_old_pos.make
			create l_pos___3.make
			create l_start_pos.make
			create l_end_pos.make
			create l_old_start.make
			create l_old_end.make
			create l_save_cpo.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_count___2 := a_count___2
					l_pos___3.ce_gets (create {CE_POINTER [PD_POS_T]}.make_shared (default_pointer))
					l_sol := 0
					l_old_pos.ce_gets (globals_inst.curwin.item.w_cursor)
					l_old_end.ce_gets (globals_inst.curwin.item.w_cursor)
					l_old_start.ce_gets (l_old_end)
					if globals_inst.VIsual_active.to_boolean then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 6 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 3 then -- else:
						if globals_inst.VIsual.lnum /= globals_inst.curwin.item.w_cursor.lnum then
							l_pos := -1 + 12 -- skip if block
						end
				when 4 then -- if:
						if globals_inst.VIsual.col /= globals_inst.curwin.item.w_cursor.col then
							l_pos := -1 + 10 -- skip if block
						end
				when 5 then -- if:
						if globals_inst.VIsual.coladd /= globals_inst.curwin.item.w_cursor.coladd then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if: | _L:
						mark_inst.setpcmark
						if a_what = 123 then
							from
							until
								js.loop_left
							loop
								js.reset
								if not (misc1_inst.inindent (1)).to_boolean then
									js.break
								end
								if not js.loop_jumped then
									if (misc2_inst.inc_cursor) /= 0 then
										js.break
									end
								end
							end
							js.reset
						end
						if (misc1_inst.gchar_cursor) = a_what then
							globals_inst.curwin.item.w_cursor.col := (globals_inst.curwin.item.w_cursor.col) + 1
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else:
						l_pos := -1 + 12 -- goto _L___1
				when 9 then -- if done | if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else:
						l_pos := -1 + 12 -- goto _L___1
				when 11 then -- if done | if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else: | _L___1:
						if globals_inst.VIsual.lnum /= globals_inst.curwin.item.w_cursor.lnum then
							l_tmp___3 := (globals_inst.VIsual.lnum < globals_inst.curwin.item.w_cursor.lnum).to_integer
						else
							if globals_inst.VIsual.col /= globals_inst.curwin.item.w_cursor.col then
								l_tmp___2 := (globals_inst.VIsual.col < globals_inst.curwin.item.w_cursor.col).to_integer
							else
								l_tmp___2 := (globals_inst.VIsual.coladd < globals_inst.curwin.item.w_cursor.coladd).to_integer
							end
							l_tmp___3 := l_tmp___2
						end
						if l_tmp___3.to_boolean then
							l_old_start.ce_gets (globals_inst.VIsual)
							globals_inst.curwin.item.w_cursor := globals_inst.VIsual
						else
							l_old_end.ce_gets (globals_inst.VIsual)
						end
				when 13 then -- if done
						l_save_cpo.ce_gets (option_inst.p_cpo)
						option_inst.p_cpo.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%%")))
						from
						until
							js.loop_left
						loop
							js.reset
							l_tmp___4 := l_count___2
							l_count___2 := l_count___2 - 1
							if not (l_tmp___4 > 0) then
								js.break
							end
							if not js.loop_jumped then
								l_pos___3.ce_gets (findmatch (create {CE_POINTER [PD_OPARG_S]}.make_shared (default_pointer), a_what))
								if (l_pos___3.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
									js.break
								end
							end
							if not js.loop_jumped then
								globals_inst.curwin.item.w_cursor := l_pos___3.item
								l_start_pos.ce_gets (l_pos___3.item)
							end
						end
						js.reset
						option_inst.p_cpo.ce_gets (l_save_cpo)
						if (l_pos___3.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							globals_inst.curwin.item.w_cursor := l_old_pos
							Result := 0
							js.return
						else
							l_end_pos.ce_gets (findmatch (create {CE_POINTER [PD_OPARG_S]}.make_shared (default_pointer), a_other))
							if (l_end_pos.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								globals_inst.curwin.item.w_cursor := l_old_pos
								Result := 0
								js.return
							end
						end
						if not js.return_called then
							globals_inst.curwin.item.w_cursor := l_end_pos.item
							from
							until
								not (not js.loop_left and then (not a_include.to_boolean))
							loop
								js.reset
								misc2_inst.incl (l_start_pos.address).do_nothing
								l_sol := (globals_inst.curwin.item.w_cursor.col = 0).to_integer
								misc2_inst.decl (create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curwin.c_pointer + {PD_WINDOW_S}.w_cursor_offset)).do_nothing
								if a_what = 123 then
									from
									until
										js.loop_left
									loop
										js.reset
										if not (misc1_inst.inindent (1)).to_boolean then
											js.break
										end
										if not js.loop_jumped then
											l_sol := 1
											if (misc2_inst.decl (create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curwin.c_pointer + {PD_WINDOW_S}.w_cursor_offset))) /= 0 then
												js.break
											end
										end
									end
									js.reset
								end
								if l_start_pos.lnum /= l_old_start.lnum then
									l_tmp___8 := (l_start_pos.lnum < l_old_start.lnum).to_integer
								else
									if l_start_pos.col /= l_old_start.col then
										l_tmp___7 := (l_start_pos.col < l_old_start.col).to_integer
									else
										l_tmp___7 := (l_start_pos.coladd < l_old_start.coladd).to_integer
									end
									l_tmp___8 := l_tmp___7
								end
								if l_tmp___8.to_boolean then
									js.break
								else
									if l_old_end.lnum /= globals_inst.curwin.item.w_cursor.lnum then
										l_tmp___10 := (l_old_end.lnum < globals_inst.curwin.item.w_cursor.lnum).to_integer
									else
										if l_old_end.col /= globals_inst.curwin.item.w_cursor.col then
											l_tmp___9 := (l_old_end.col < globals_inst.curwin.item.w_cursor.col).to_integer
										else
											l_tmp___9 := (l_old_end.coladd < globals_inst.curwin.item.w_cursor.coladd).to_integer
										end
										l_tmp___10 := l_tmp___9
									end
									if l_tmp___10.to_boolean then
										js.break
									elseif globals_inst.VIsual_active.to_boolean then
										globals_inst.curwin.item.w_cursor := l_old_start
										misc2_inst.decl (create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curwin.c_pointer + {PD_WINDOW_S}.w_cursor_offset)).do_nothing
										l_pos___3.ce_gets (findmatch (create {CE_POINTER [PD_OPARG_S]}.make_shared (default_pointer), a_what))
										if (l_pos___3.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
											globals_inst.curwin.item.w_cursor := l_old_pos
											Result := 0
											js.return
										end
										if not js.return_called then
											l_start_pos.ce_gets (l_pos___3.item)
											globals_inst.curwin.item.w_cursor := l_pos___3.item
											l_end_pos.ce_gets (findmatch (create {CE_POINTER [PD_OPARG_S]}.make_shared (default_pointer), a_other))
											if (l_end_pos.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
												globals_inst.curwin.item.w_cursor := l_old_pos
												Result := 0
												js.return
											end
										end
										if not js.return_called then
											globals_inst.curwin.item.w_cursor := l_end_pos.item
										end
									else
										js.break
									end
								end
							end
							js.reset
						end
						if not js.return_called then
							if globals_inst.VIsual_active.to_boolean then
								if (option_inst.p_sel.item).to_integer_32 = 101 then
									globals_inst.curwin.item.w_cursor.col := (globals_inst.curwin.item.w_cursor.col) + 1
								end
								if l_sol.to_boolean then
									if (misc1_inst.gchar_cursor) /= 0 then
										misc2_inst.inc (create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curwin.c_pointer + {PD_WINDOW_S}.w_cursor_offset)).do_nothing
									end
								end
								globals_inst.VIsual.ce_gets (l_start_pos)
								globals_inst.VIsual_mode := ('v').code
								screen_inst.redraw_curbuf_later (20)
								screen_inst.showmode.do_nothing
							else
								a_oap.item.start := l_start_pos
								a_oap.item.motion_type := 0
								a_oap.item.inclusive := 0
								if l_sol.to_boolean then
									misc2_inst.incl (create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curwin.c_pointer + {PD_WINDOW_S}.w_cursor_offset)).do_nothing
								else
									if l_start_pos.lnum /= globals_inst.curwin.item.w_cursor.lnum then
										l_tmp___13 := (l_start_pos.lnum < globals_inst.curwin.item.w_cursor.lnum).to_integer
									else
										if l_start_pos.col /= globals_inst.curwin.item.w_cursor.col then
											l_tmp___12 := (l_start_pos.col < globals_inst.curwin.item.w_cursor.col).to_integer
										else
											l_tmp___12 := (l_start_pos.coladd < globals_inst.curwin.item.w_cursor.coladd).to_integer
										end
										l_tmp___13 := l_tmp___12
									end
									if l_tmp___13.to_boolean then
										a_oap.item.inclusive := 1
									elseif l_start_pos.lnum = globals_inst.curwin.item.w_cursor.lnum then
										if l_start_pos.col = globals_inst.curwin.item.w_cursor.col then
											if l_start_pos.coladd = globals_inst.curwin.item.w_cursor.coladd then
												a_oap.item.inclusive := 1
											else
												globals_inst.curwin.item.w_cursor := l_start_pos
											end
										else
											globals_inst.curwin.item.w_cursor := l_start_pos
										end
									else
										globals_inst.curwin.item.w_cursor := l_start_pos
									end
								end
							end
							Result := 1
						end
				when 14 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	in_html_tag (a_end_tag: INTEGER_32): INTEGER_32
		local
			l_line: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_c: INTEGER_32
			l_lc: INTEGER_32
			l_pos___3: PD_POS_T
			l_lp: CE_POINTER [NATURAL_8]
			l_tmp___1: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___5: INTEGER_32
			js: JUMP_STATE
		do
			create l_line.make
			create l_p___0.make
			create l_pos___3.make
			create l_lp.make

			l_line.ce_gets ((memline_inst.ml_get_curline))
			l_lc := ('%/0/').code
			if globals_inst.enc_dbcs.to_boolean then
				l_lp.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				l_p___0.ce_gets (l_line)
				from
				until
					not ((l_p___0.c_pointer.to_integer_32).to_natural_32 < ((l_line + globals_inst.curwin.item.w_cursor.col).c_pointer.to_integer_32).to_natural_32)
				loop
					if (l_p___0.item).to_integer_32 = 62 then
						l_lc := (l_p___0.item).to_integer_32
						l_lp.ce_gets (l_p___0)
					elseif (l_p___0.item).to_integer_32 = 60 then
						l_lc := (l_p___0.item).to_integer_32
						l_lp.ce_gets (l_p___0)
					end
					if globals_inst.has_mbyte.to_boolean then
						l_tmp___1 := (globals_inst.mb_ptr2len.integer_32_item ([l_p___0]))
					else
						l_tmp___1 := 1
					end
					l_p___0.ce_gets (l_p___0 + l_tmp___1)
				end
				if (l_p___0.item).to_integer_32 /= 60 then
					if l_lc /= 60 then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_p___0.ce_gets (l_lp)
					end
				end
			else
				l_p___0.ce_gets (l_line + globals_inst.curwin.item.w_cursor.col)
				from
				until
					not (not js.loop_left and then ((l_p___0.c_pointer.to_integer_32).to_natural_32 > (l_line.c_pointer.to_integer_32).to_natural_32))
				loop
					js.reset
					if (l_p___0.item).to_integer_32 = 60 then
						js.break
					end
					if not js.loop_jumped then
						if globals_inst.has_mbyte.to_boolean then
							l_tmp___3 := (globals_inst.mb_head_off.integer_32_item ([l_line, l_p___0 - 1])) + 1
						else
							l_tmp___3 := 1
						end
						l_p___0.ce_gets (l_p___0 - l_tmp___3)
						if (l_p___0.item).to_integer_32 = 62 then
							js.break
						end
					end
				end
				js.reset
				if (l_p___0.item).to_integer_32 /= 60 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				l_pos___3.lnum := globals_inst.curwin.item.w_cursor.lnum
				l_pos___3.col := l_p___0.distance (l_line)
				if globals_inst.has_mbyte.to_boolean then
					l_tmp___5 := (globals_inst.mb_ptr2len.integer_32_item ([l_p___0]))
				else
					l_tmp___5 := 1
				end
				l_p___0.ce_gets (l_p___0 + l_tmp___5)
				if a_end_tag.to_boolean then
					Result := ((l_p___0.item).to_integer_32 = 47).to_integer
					js.return
				end
			end
			if not js.return_called and then ((l_p___0.item).to_integer_32 = 47) then
				Result := 0
				js.return
			end
			if not js.return_called then
				from
				until
					js.loop_left
				loop
					js.reset
					if (misc2_inst.inc (l_pos___3.address)) < 0 then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_c := ((memline_inst.ml_get_pos (l_pos___3.address)).item).to_integer_32
						if l_c = 62 then
							js.break
						end
						if not js.loop_jumped then
							l_lc := l_c
						end
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_lc /= 47).to_integer
			end
		end

	current_tagblock (a_oap: CE_POINTER [PD_OPARG_S]; a_count_arg: INTEGER_32; a_include: INTEGER_32): INTEGER_32
		local
			l_count___2: INTEGER_32
			l_n: INTEGER_32
			l_old_pos: PD_POS_T
			l_start_pos: PD_POS_T
			l_end_pos: PD_POS_T
			l_old_start: PD_POS_T
			l_old_end: PD_POS_T
			l_spat: CE_POINTER [NATURAL_8]
			l_epat: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_cp: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_r: INTEGER_32
			l_do_include: INTEGER_32
			l_save_p_ws: INTEGER_32
			l_retval: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___8: INTEGER_32
			l_tmp___11: INTEGER_32
			l_tmp___13: INTEGER_32
			l_tmp___14: INTEGER_32
			l_tmp___20: INTEGER_32
			l_tmp___21: INTEGER_32
			l_tmp___22: INTEGER_32
			l_tmp___23: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_old_pos.make
			create l_start_pos.make
			create l_end_pos.make
			create l_old_start.make
			create l_old_end.make
			create l_spat.make
			create l_epat.make
			create l_p___0.make
			create l_cp.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_count___2 := a_count_arg
					l_do_include := a_include
					l_save_p_ws := option_inst.p_ws
					l_retval := 0
					option_inst.p_ws := 0
					l_old_pos.ce_gets (globals_inst.curwin.item.w_cursor)
					l_old_end.ce_gets (globals_inst.curwin.item.w_cursor)
					l_old_start.ce_gets (l_old_end)
					if not globals_inst.VIsual_active.to_boolean then
						misc2_inst.decl (l_old_end.address).do_nothing
					elseif (option_inst.p_sel.item).to_integer_32 = 101 then
						misc2_inst.decl (l_old_end.address).do_nothing
					end
					if globals_inst.VIsual_active.to_boolean then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 6 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 3 then -- else:
						if globals_inst.VIsual.lnum /= globals_inst.curwin.item.w_cursor.lnum then
							l_pos := -1 + 12 -- skip if block
						end
				when 4 then -- if:
						if globals_inst.VIsual.col /= globals_inst.curwin.item.w_cursor.col then
							l_pos := -1 + 10 -- skip if block
						end
				when 5 then -- if:
						if globals_inst.VIsual.coladd /= globals_inst.curwin.item.w_cursor.coladd then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if: | _L:
						mark_inst.setpcmark
						from
						until
							js.loop_left
						loop
							js.reset
							if not (misc1_inst.inindent (1)).to_boolean then
								js.break
							end
							if not js.loop_jumped then
								if (misc2_inst.inc_cursor) /= 0 then
									js.break
								end
							end
						end
						js.reset
						if (in_html_tag (0)).to_boolean then
							from
							until
								js.loop_left
							loop
								js.reset
								if ((memline_inst.ml_get_cursor).item).to_integer_32 = 62 then
									js.break
								end
								if not js.loop_jumped then
									if (misc2_inst.inc_cursor) < 0 then
										js.break
									end
								end
							end
							js.reset
						elseif (in_html_tag (1)).to_boolean then
							from
							until
								js.loop_left
							loop
								js.reset
								if ((memline_inst.ml_get_cursor).item).to_integer_32 = 60 then
									js.break
								end
								if not js.loop_jumped then
									if (misc2_inst.dec_cursor) < 0 then
										js.break
									end
								end
							end
							js.reset
							misc2_inst.dec_cursor.do_nothing
							l_old_end.ce_gets (globals_inst.curwin.item.w_cursor)
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else:
						l_pos := -1 + 12 -- goto _L___1
				when 9 then -- if done | if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else:
						l_pos := -1 + 12 -- goto _L___1
				when 11 then -- if done | if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else: | _L___1:
						if globals_inst.VIsual.lnum /= globals_inst.curwin.item.w_cursor.lnum then
							l_tmp___8 := (globals_inst.VIsual.lnum < globals_inst.curwin.item.w_cursor.lnum).to_integer
						else
							if globals_inst.VIsual.col /= globals_inst.curwin.item.w_cursor.col then
								l_tmp___7 := (globals_inst.VIsual.col < globals_inst.curwin.item.w_cursor.col).to_integer
							else
								l_tmp___7 := (globals_inst.VIsual.coladd < globals_inst.curwin.item.w_cursor.coladd).to_integer
							end
							l_tmp___8 := l_tmp___7
						end
						if l_tmp___8.to_boolean then
							l_old_start.ce_gets (globals_inst.VIsual)
							globals_inst.curwin.item.w_cursor := globals_inst.VIsual
						else
							l_old_end.ce_gets (globals_inst.VIsual)
						end
				when 13 then -- if done | again:
						l_n := 0
				when 14 then -- loop condition:
						if not (l_n < l_count___2) then
							l_pos := -1 + 17 -- skip loop
						end
				when 15 then -- loop body:
							if (eval_inst.do_searchpair (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("<[^ %T>/!]\+\%%(\_s\_[^>]\{-}[^/]>\|$\|\_s\=>\)")), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("</[^>]*>")), -1, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")), 0, create {CE_POINTER [PD_POS_T]}.make_shared (default_pointer), (0).to_integer_32, 0)) <= 0 then
								globals_inst.curwin.item.w_cursor := l_old_pos
								l_pos := -1 + 29 -- goto theend
							end
				when 16 then
							l_n := l_n + 1
							l_pos := -1 + 14 -- back to loop condition
				when 17 then -- loop done
						l_start_pos.ce_gets (globals_inst.curwin.item.w_cursor)
						misc2_inst.inc_cursor.do_nothing
						l_p___0.ce_gets (memline_inst.ml_get_cursor)
						l_cp.ce_gets (l_p___0)
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_cp.item).to_integer_32 /= 0 then
								if (l_cp.item).to_integer_32 /= 62 then
									if (l_cp.item).to_integer_32 = 32 then
										js.break
									elseif (l_cp.item).to_integer_32 = 9 then
										js.break
									end
								else
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								if globals_inst.has_mbyte.to_boolean then
									l_tmp___11 := (globals_inst.mb_ptr2len.integer_32_item ([l_cp]))
								else
									l_tmp___11 := 1
								end
								l_cp.ce_gets (l_cp + l_tmp___11)
							end
						end
						js.reset
						l_len := l_cp.distance (l_p___0)
						if l_len = 0 then
							globals_inst.curwin.item.w_cursor := l_old_pos
							l_pos := -1 + 29 -- goto theend
						end
				when 18 then
						l_spat.ce_gets (misc2_inst.alloc ((l_len + 29).to_natural_32))
						l_epat.ce_gets (misc2_inst.alloc ((l_len + 9).to_natural_32))
						if (l_spat.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_spat))
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_epat))
							globals_inst.curwin.item.w_cursor := l_old_pos
							l_pos := -1 + 29 -- goto theend
						elseif (l_epat.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_spat))
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_epat))
							globals_inst.curwin.item.w_cursor := l_old_pos
							l_pos := -1 + 29 -- goto theend
						end
				when 19 then
						sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_spat), ce_string ("<%%.*s\%%%%(\_[^>]\{-}[^/]>\|>\)\c"), l_len, l_p___0]).do_nothing
						sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_epat), ce_string ("</%%.*s>\c"), l_len, l_p___0]).do_nothing
						l_r := (eval_inst.do_searchpair (l_spat, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")), l_epat, 1, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")), 0, create {CE_POINTER [PD_POS_T]}.make_shared (default_pointer), (0).to_integer_32, 0)).to_integer_32
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_spat))
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_epat))
						if l_r < 1 then
							l_count___2 := 1
							globals_inst.curwin.item.w_cursor := l_start_pos
							l_pos := -1 + 13 -- goto again
						else
							if globals_inst.curwin.item.w_cursor.lnum /= l_old_end.lnum then
								l_tmp___14 := (globals_inst.curwin.item.w_cursor.lnum < l_old_end.lnum).to_integer
							else
								if globals_inst.curwin.item.w_cursor.col /= l_old_end.col then
									l_tmp___13 := (globals_inst.curwin.item.w_cursor.col < l_old_end.col).to_integer
								else
									l_tmp___13 := (globals_inst.curwin.item.w_cursor.coladd < l_old_end.coladd).to_integer
								end
								l_tmp___14 := l_tmp___13
							end
							if l_tmp___14.to_boolean then
								l_count___2 := 1
								globals_inst.curwin.item.w_cursor := l_start_pos
								l_pos := -1 + 13 -- goto again
							end
						end
				when 20 then
						if not (l_do_include.to_boolean) then
							l_pos := -1 + 23 -- skip if block
						end
				when 21 then -- if:
							l_pos := -1 + 24 -- goto _L___2
				when 22 then -- if block done, skip else block:
							l_pos := -1 + 27
				when 23 then -- else:
							if not (l_r < 1) then
								l_pos := -1 + 26 -- skip if block
							end
				when 24 then -- if: | _L___2:
							from
							until
								js.loop_left
							loop
								js.reset
								if ((memline_inst.ml_get_cursor).item).to_integer_32 = 62 then
									js.break
								end
								if not js.loop_jumped then
									if (misc2_inst.inc_cursor) < 0 then
										js.break
									end
								end
							end
							js.reset
				when 25 then -- if block done, skip else block:
							l_pos := -1 + 27
				when 26 then -- else:
							if ((memline_inst.ml_get_cursor).item).to_integer_32 = 60 then
								misc2_inst.dec_cursor.do_nothing
							end
				when 27 then -- if done
							l_end_pos.ce_gets (globals_inst.curwin.item.w_cursor)
							if not l_do_include.to_boolean then
								globals_inst.curwin.item.w_cursor := l_start_pos
								from
								until
									js.loop_left
								loop
									js.reset
									if not ((misc2_inst.inc_cursor) >= 0) then
										js.break
									end
									if not js.loop_jumped then
										if ((memline_inst.ml_get_cursor).item).to_integer_32 = 62 then
											misc2_inst.inc_cursor.do_nothing
											l_start_pos.ce_gets (globals_inst.curwin.item.w_cursor)
											js.break
										end
									end
								end
								js.reset
								globals_inst.curwin.item.w_cursor := l_end_pos
								if l_start_pos.lnum = l_old_start.lnum then
									if l_start_pos.col = l_old_start.col then
										if l_start_pos.coladd = l_old_start.coladd then
											if l_end_pos.lnum = l_old_end.lnum then
												if l_end_pos.col = l_old_end.col then
													if l_end_pos.coladd = l_old_end.coladd then
														l_do_include := 1
														globals_inst.curwin.item.w_cursor := l_old_start
														l_count___2 := a_count_arg
														l_pos := -1 + 13 -- goto again
													end
												end
											end
										end
									end
								end
							end
				when 28 then
							if globals_inst.VIsual_active.to_boolean then
								if l_end_pos.lnum /= l_start_pos.lnum then
									l_tmp___21 := (l_end_pos.lnum < l_start_pos.lnum).to_integer
								else
									if l_end_pos.col /= l_start_pos.col then
										l_tmp___20 := (l_end_pos.col < l_start_pos.col).to_integer
									else
										l_tmp___20 := (l_end_pos.coladd < l_start_pos.coladd).to_integer
									end
									l_tmp___21 := l_tmp___20
								end
								if l_tmp___21.to_boolean then
									globals_inst.curwin.item.w_cursor := l_start_pos
								elseif (option_inst.p_sel.item).to_integer_32 = 101 then
									globals_inst.curwin.item.w_cursor.col := (globals_inst.curwin.item.w_cursor.col) + 1
								end
								globals_inst.VIsual.ce_gets (l_start_pos)
								globals_inst.VIsual_mode := ('v').code
								screen_inst.redraw_curbuf_later (20)
								screen_inst.showmode.do_nothing
							else
								a_oap.item.start := l_start_pos
								a_oap.item.motion_type := 0
								if l_end_pos.lnum /= l_start_pos.lnum then
									l_tmp___23 := (l_end_pos.lnum < l_start_pos.lnum).to_integer
								else
									if l_end_pos.col /= l_start_pos.col then
										l_tmp___22 := (l_end_pos.col < l_start_pos.col).to_integer
									else
										l_tmp___22 := (l_end_pos.coladd < l_start_pos.coladd).to_integer
									end
									l_tmp___23 := l_tmp___22
								end
								if l_tmp___23.to_boolean then
									globals_inst.curwin.item.w_cursor := l_start_pos
									a_oap.item.inclusive := 0
								else
									a_oap.item.inclusive := 1
								end
							end
							l_retval := 1
				when 29 then -- theend:
							option_inst.p_ws := l_save_p_ws
							Result := l_retval
				when 30 then
							l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
				end

	current_par (a_oap: CE_POINTER [PD_OPARG_S]; a_count___2: INTEGER_32; a_include: INTEGER_32; a_type: INTEGER_32): INTEGER_32
		local
			l_start_lnum: INTEGER_32
			l_end_lnum: INTEGER_32
			l_white_in_front: INTEGER_32
			l_dir___0: INTEGER_32
			l_start_is_white: INTEGER_32
			l_prev_start_is_white: INTEGER_32
			l_retval: INTEGER_32
			l_do_white: INTEGER_32
			l_t: INTEGER_32
			l_i___0: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___12: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_retval := 1
					l_do_white := 0
					if a_type = 83 then
						Result := 0
						js.return
					end
					if js.return_called then
						l_pos := -1 + 4 -- skip if block
					end
				when 1 then -- if:
						l_start_lnum := globals_inst.curwin.item.w_cursor.lnum
						if not (globals_inst.VIsual_active.to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_start_lnum = globals_inst.VIsual.lnum then
							l_pos := -1 + 4 -- skip if block
						end
				when 3 then -- if: | extend:
						if l_start_lnum < globals_inst.VIsual.lnum then
							l_dir___0 := -1
						else
							l_dir___0 := 1
						end
						l_i___0 := a_count___2.to_integer_32
						from
						until
							js.loop_left
						loop
							js.reset
							l_i___0 := l_i___0 - 1
							if not (l_i___0 >= 0) then
								js.break
							end
							if not js.loop_jumped then
								if l_dir___0 = -1 then
									l_tmp := (1).to_integer_32
								else
									l_tmp := globals_inst.curbuf.item.b_ml.ml_line_count
								end
								if l_start_lnum = l_tmp then
									l_retval := 0
									js.break
								end
							end
							if not js.loop_jumped then
								l_prev_start_is_white := -1
								l_t := 0
								from
								until
									not (not js.loop_left and then (l_t < 2))
								loop
									js.reset
									l_start_lnum := l_start_lnum + l_dir___0.to_integer_32
									l_start_is_white := linewhite (l_start_lnum)
									if l_prev_start_is_white = l_start_is_white then
										l_start_lnum := l_start_lnum - l_dir___0.to_integer_32
										js.break
									end
									if not js.loop_jumped then
										from
										until
											js.loop_left
										loop
											js.reset
											if l_dir___0 = -1 then
												l_tmp___0 := (1).to_integer_32
											else
												l_tmp___0 := globals_inst.curbuf.item.b_ml.ml_line_count
											end
											if l_start_lnum = l_tmp___0 then
												js.break
											end
											if not js.loop_jumped then
												if l_start_is_white /= (linewhite (l_start_lnum + l_dir___0.to_integer_32)) then
													js.break
												elseif not l_start_is_white.to_boolean then
													if l_dir___0 > 0 then
														l_tmp___2 := 1
													else
														l_tmp___2 := 0
													end
													if (startPS (l_start_lnum + l_tmp___2.to_integer_32, 0, 0)).to_boolean then
														js.break
													end
												end
											end
											if not js.loop_jumped then
												l_start_lnum := l_start_lnum + l_dir___0.to_integer_32
											end
										end
										js.reset
										if not a_include.to_boolean then
											js.break
										end
									end
									if not js.loop_jumped then
										if l_dir___0 = -1 then
											l_tmp___4 := (1).to_integer_32
										else
											l_tmp___4 := globals_inst.curbuf.item.b_ml.ml_line_count
										end
										if l_start_lnum = l_tmp___4 then
											js.break
										end
									end
									if not js.loop_jumped then
										l_prev_start_is_white := l_start_is_white
										l_t := l_t + 1
									end
								end
								js.reset
							end
						end
						js.reset
						globals_inst.curwin.item.w_cursor.lnum := l_start_lnum
						globals_inst.curwin.item.w_cursor.col := 0
						Result := l_retval
						js.return
				when 4 then -- if done | if done | if done
						if js.return_called then
							l_pos := -1 + 22 -- skip if block
						end
				when 5 then -- if:
							l_white_in_front := linewhite (l_start_lnum)
							from
							until
								not (not js.loop_left and then (l_start_lnum > 1))
							loop
								js.reset
								if l_white_in_front.to_boolean then
									if not (linewhite (l_start_lnum - 1)).to_boolean then
										js.break
									end
								elseif (linewhite (l_start_lnum - 1)).to_boolean then
									js.break
								elseif (startPS (l_start_lnum, 0, 0)).to_boolean then
									js.break
								end
								if not js.loop_jumped then
									l_start_lnum := l_start_lnum - 1
								end
							end
							js.reset
							l_end_lnum := l_start_lnum
							from
							until
								js.loop_left
							loop
								js.reset
								if l_end_lnum <= globals_inst.curbuf.item.b_ml.ml_line_count then
									if not (linewhite (l_end_lnum)).to_boolean then
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped then
									l_end_lnum := l_end_lnum + 1
								end
							end
							js.reset
							l_end_lnum := l_end_lnum - 1
							l_i___0 := a_count___2.to_integer_32
							if not a_include.to_boolean then
								if l_white_in_front.to_boolean then
									l_i___0 := l_i___0 - 1
								end
							end
				when 6 then -- loop condition:
							if js.loop_left then
								l_pos := -1 + 21 -- skip loop
							end
				when 7 then -- loop body:
							js.reset
							l_tmp___12 := l_i___0
							l_i___0 := l_i___0 - 1
							if not l_tmp___12.to_boolean then
								js.break
							end
							if js.loop_jumped then
								l_pos := -1 + 20 -- skip if block
							end
				when 8 then -- if:
							if l_end_lnum = globals_inst.curbuf.item.b_ml.ml_line_count then
								Result := 0
								js.return
							end
							if js.return_called then
								l_pos := -1 + 20 -- skip if block
							end
				when 9 then -- if:
							if not a_include.to_boolean then
								l_do_white := linewhite (l_end_lnum + 1)
							end
							if not (a_include.to_boolean) then
								l_pos := -1 + 12 -- skip if block
							end
				when 10 then -- if:
							l_pos := -1 + 13 -- goto _L
				when 11 then -- if block done, skip else block:
							l_pos := -1 + 14
				when 12 then -- else:
							if l_do_white.to_boolean then
								l_pos := -1 + 14 -- skip if block
							end
				when 13 then -- if: | _L:
							l_end_lnum := l_end_lnum + 1
							from
							until
								js.loop_left
							loop
								js.reset
								if l_end_lnum < globals_inst.curbuf.item.b_ml.ml_line_count then
									if (linewhite (l_end_lnum + 1)).to_boolean then
										js.break
									elseif (startPS (l_end_lnum + 1, 0, 0)).to_boolean then
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped then
									l_end_lnum := l_end_lnum + 1
								end
							end
							js.reset
				when 14 then -- if done
							if l_i___0 = 0 then
								if l_white_in_front.to_boolean then
									if a_include.to_boolean then
										js.break
									end
								end
							end
							if js.loop_jumped then
								l_pos := -1 + 20 -- skip if block
							end
				when 15 then -- if:
							if not (a_include.to_boolean) then
								l_pos := -1 + 18 -- skip if block
							end
				when 16 then -- if:
							l_pos := -1 + 19 -- goto _L___0
				when 17 then -- if block done, skip else block:
							l_pos := -1 + 20
				when 18 then -- else:
							if not (l_do_white.to_boolean) then
								l_pos := -1 + 20 -- skip if block
							end
				when 19 then -- if: | _L___0:
							from
							until
								js.loop_left
							loop
								js.reset
								if l_end_lnum < globals_inst.curbuf.item.b_ml.ml_line_count then
									if not (linewhite (l_end_lnum + 1)).to_boolean then
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped then
									l_end_lnum := l_end_lnum + 1
								end
							end
							js.reset
				when 20 then -- if done | if done | if done | if done
							l_pos := -1 + 6 -- back to loop condition
				when 21 then -- loop done
							js.reset
				when 22 then -- if done
						if js.return_called then
							l_pos := -1 + 29 -- skip if block
						end
				when 23 then -- if:
							if not l_white_in_front.to_boolean then
								if not (linewhite (l_end_lnum)).to_boolean then
									if a_include.to_boolean then
										from
										until
											js.loop_left
										loop
											js.reset
											if l_start_lnum > 1 then
												if not (linewhite (l_start_lnum - 1)).to_boolean then
													js.break
												end
											else
												js.break
											end
											if not js.loop_jumped then
												l_start_lnum := l_start_lnum - 1
											end
										end
										js.reset
									end
								end
							end
							if not (globals_inst.VIsual_active.to_boolean) then
								l_pos := -1 + 27 -- skip if block
							end
				when 24 then -- if:
							if globals_inst.VIsual_mode = 86 then
								if l_start_lnum = globals_inst.curwin.item.w_cursor.lnum then
									l_pos := -1 + 3 -- goto extend
								end
							end
				when 25 then
							globals_inst.VIsual.lnum := l_start_lnum
							globals_inst.VIsual_mode := ('V').code
							screen_inst.redraw_curbuf_later (20)
							screen_inst.showmode.do_nothing
				when 26 then -- if block done, skip else block:
							l_pos := -1 + 28
				when 27 then -- else:
							a_oap.item.start.lnum := l_start_lnum
							a_oap.item.start.col := 0
							a_oap.item.motion_type := 1
				when 28 then -- if done
							globals_inst.curwin.item.w_cursor.lnum := l_end_lnum
							globals_inst.curwin.item.w_cursor.col := 0
							Result := 1
				when 29 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	find_next_quote (a_line: CE_POINTER [NATURAL_8]; a_col: INTEGER_32; a_quotechar: INTEGER_32; a_escape: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_col: INTEGER_32
			l_c: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_col := a_col
				when 1 then -- loop condition:
					if js.loop_left then
						l_pos := -1 + 10 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						l_c := (a_line[l_col]).to_integer_32
						if l_c /= 0 then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						Result := (-1)
						js.return
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 5 then -- else:
						if (a_escape.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						if (((misc2_inst.vim_strchr (a_escape, l_c))).c_pointer /= default_pointer) then
							l_col := l_col + 1
						else
							l_pos := -1 + 8 -- goto _L
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else: | _L:
						if l_c = a_quotechar then
							js.break
						end
				when 9 then -- if done
						if not js.loop_jumped then
							if globals_inst.has_mbyte.to_boolean then
								l_col := l_col + (globals_inst.mb_ptr2len.integer_32_item ([a_line + l_col]))
							else
								l_col := l_col + 1
							end
						end
						l_pos := -1 + 1 -- back to loop condition
				when 10 then -- loop done
					js.reset
					if not js.return_called then
						Result := l_col
					end
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	find_prev_quote (a_line: CE_POINTER [NATURAL_8]; a_col_start: INTEGER_32; a_quotechar: INTEGER_32; a_escape: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_col_start: INTEGER_32
			l_n: INTEGER_32
			js: JUMP_STATE
		do
			l_col_start := a_col_start
			from
			until
				not (not js.loop_left and then (l_col_start > 0))
			loop
				js.reset
				l_col_start := l_col_start - 1
				l_col_start := l_col_start - (globals_inst.mb_head_off.integer_32_item ([a_line, a_line + l_col_start]))
				l_n := 0
				if (a_escape.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					from
					until
						js.loop_left
					loop
						js.reset
						if l_col_start - l_n > 0 then
							if ((misc2_inst.vim_strchr (a_escape, (a_line[((l_col_start - l_n) - 1)]).to_integer_32)).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								js.break
							end
						else
							js.break
						end
						if not js.loop_jumped then
							l_n := l_n + 1
						end
					end
					js.reset
				end
				if ((l_n).bit_and (1)).to_boolean then
					l_col_start := l_col_start - l_n
				elseif (a_line[l_col_start]).to_integer_32 = a_quotechar then
					js.break
				end
			end
			js.reset
			Result := l_col_start
		end

	current_quote (a_oap: CE_POINTER [PD_OPARG_S]; a_count___2: INTEGER_32; a_include: INTEGER_32; a_quotechar: INTEGER_32): INTEGER_32
		local
			l_line: CE_POINTER [NATURAL_8]
			l_col_end: INTEGER_32
			l_col_start: INTEGER_32
			l_inclusive: INTEGER_32
			l_vis_empty: INTEGER_32
			l_vis_bef_curs: INTEGER_32
			l_inside_quotes: INTEGER_32
			l_selected_quote: INTEGER_32
			l_i___0: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_first_col: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_line.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_line.ce_gets ((memline_inst.ml_get_curline))
					l_col_start := globals_inst.curwin.item.w_cursor.col
					l_inclusive := 0
					l_vis_empty := 1
					l_vis_bef_curs := 0
					l_inside_quotes := 0
					l_selected_quote := 0
					if globals_inst.VIsual_active.to_boolean then
						if globals_inst.VIsual.lnum /= globals_inst.curwin.item.w_cursor.lnum then
							l_vis_bef_curs := (globals_inst.VIsual.lnum < globals_inst.curwin.item.w_cursor.lnum).to_integer
						else
							if globals_inst.VIsual.col /= globals_inst.curwin.item.w_cursor.col then
								l_tmp___0 := (globals_inst.VIsual.col < globals_inst.curwin.item.w_cursor.col).to_integer
							else
								l_tmp___0 := (globals_inst.VIsual.coladd < globals_inst.curwin.item.w_cursor.coladd).to_integer
							end
							l_vis_bef_curs := l_tmp___0
						end
						if (option_inst.p_sel.item).to_integer_32 = 101 then
							if l_vis_bef_curs.to_boolean then
								misc2_inst.dec_cursor.do_nothing
							end
						end
						if globals_inst.VIsual.lnum = globals_inst.curwin.item.w_cursor.lnum then
							if globals_inst.VIsual.col = globals_inst.curwin.item.w_cursor.col then
								if globals_inst.VIsual.coladd = globals_inst.curwin.item.w_cursor.coladd then
									l_tmp___1 := 1
								else
									l_tmp___1 := 0
								end
							else
								l_tmp___1 := 0
							end
						else
							l_tmp___1 := 0
						end
						l_vis_empty := l_tmp___1
					end
					if not l_vis_empty.to_boolean then
						if l_vis_bef_curs.to_boolean then
							if globals_inst.VIsual.col > 0 then
								if (l_line[(globals_inst.VIsual.col - 1)]).to_integer_32 = a_quotechar then
									if (l_line[globals_inst.curwin.item.w_cursor.col]).to_integer_32 /= 0 then
										if (l_line[(globals_inst.curwin.item.w_cursor.col + 1)]).to_integer_32 = a_quotechar then
											l_tmp___2 := 1
										else
											l_tmp___2 := 0
										end
									else
										l_tmp___2 := 0
									end
								else
									l_tmp___2 := 0
								end
							else
								l_tmp___2 := 0
							end
							l_inside_quotes := l_tmp___2
							l_i___0 := globals_inst.VIsual.col
							l_col_end := globals_inst.curwin.item.w_cursor.col
						else
							if globals_inst.curwin.item.w_cursor.col > 0 then
								if (l_line[(globals_inst.curwin.item.w_cursor.col - 1)]).to_integer_32 = a_quotechar then
									if (l_line[globals_inst.VIsual.col]).to_integer_32 /= 0 then
										if (l_line[(globals_inst.VIsual.col + 1)]).to_integer_32 = a_quotechar then
											l_tmp___3 := 1
										else
											l_tmp___3 := 0
										end
									else
										l_tmp___3 := 0
									end
								else
									l_tmp___3 := 0
								end
							else
								l_tmp___3 := 0
							end
							l_inside_quotes := l_tmp___3
							l_i___0 := globals_inst.curwin.item.w_cursor.col
							l_col_end := globals_inst.VIsual.col
						end
						from
						until
							not (not js.loop_left and then (l_i___0 <= l_col_end))
						loop
							js.reset
							l_tmp___4 := l_i___0
							l_i___0 := l_i___0 + 1
							if (l_line[l_tmp___4]).to_integer_32 = a_quotechar then
								l_selected_quote := 1
								js.break
							end
						end
						js.reset
					end
					if l_vis_empty.to_boolean then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if (l_line[l_col_start]).to_integer_32 = a_quotechar then
							if l_vis_bef_curs.to_boolean then
								l_col_start := find_next_quote (l_line, l_col_start + 1, a_quotechar, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
								if l_col_start < 0 then
									Result := 0
									js.return
								end
								if not js.return_called then
									l_col_end := find_next_quote (l_line, l_col_start + 1, a_quotechar, globals_inst.curbuf.item.b_p_qe)
									if l_col_end < 0 then
										l_col_end := l_col_start
										l_col_start := globals_inst.curwin.item.w_cursor.col
									end
								end
							else
								l_col_end := find_prev_quote (l_line, l_col_start, a_quotechar, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
								if (l_line[l_col_end]).to_integer_32 /= a_quotechar then
									Result := 0
									js.return
								end
								if not js.return_called then
									l_col_start := find_prev_quote (l_line, l_col_end, a_quotechar, globals_inst.curbuf.item.b_p_qe)
									if (l_line[l_col_start]).to_integer_32 /= a_quotechar then
										l_col_start := l_col_end
										l_col_end := globals_inst.curwin.item.w_cursor.col
									end
								end
							end
						else
							l_pos := -1 + 3 -- goto _L___0
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 3 then -- else: | _L___0:
						if (l_line[l_col_start]).to_integer_32 /= a_quotechar then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 6 then -- else:
						if l_vis_empty.to_boolean then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if: | _L:
						l_first_col := l_col_start
						if not l_vis_empty.to_boolean then
							if l_vis_bef_curs.to_boolean then
								l_first_col := find_next_quote (l_line, l_col_start, a_quotechar, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							else
								l_first_col := find_prev_quote (l_line, l_col_start, a_quotechar, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							end
						end
						l_col_start := 0
						from
						until
							js.loop_left
						loop
							js.reset
							l_col_start := find_next_quote (l_line, l_col_start, a_quotechar, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							if l_col_start < 0 then
								Result := 0
								js.return
							elseif l_col_start > l_first_col then
								Result := 0
								js.return
							end
							if not js.return_called then
								l_col_end := find_next_quote (l_line, l_col_start + 1, a_quotechar, globals_inst.curbuf.item.b_p_qe)
								if l_col_end < 0 then
									Result := 0
									js.return
								end
							end
							if not js.return_called then
								if l_col_start <= l_first_col then
									if l_first_col <= l_col_end then
										js.break
									end
								end
								if not js.loop_jumped then
									l_col_start := l_col_end + 1
								end
							end
						end
						js.reset
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else:
						l_col_start := find_prev_quote (l_line, l_col_start, a_quotechar, globals_inst.curbuf.item.b_p_qe)
						if (l_line[l_col_start]).to_integer_32 /= a_quotechar then
							l_col_start := find_next_quote (l_line, l_col_start, a_quotechar, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							if l_col_start < 0 then
								Result := 0
								js.return
							end
						end
						if not js.return_called then
							l_col_end := find_next_quote (l_line, l_col_start + 1, a_quotechar, globals_inst.curbuf.item.b_p_qe)
							if l_col_end < 0 then
								Result := 0
								js.return
							end
						end
				when 10 then -- if done | if done
						if js.return_called then
							l_pos := -1 + 40 -- skip if block
						end
				when 11 then -- if:
							if not (a_include.to_boolean) then
								l_pos := -1 + 19 -- skip if block
							end
				when 12 then -- if:
							if (l_line[(l_col_end + 1)]).to_integer_32 /= 32 then
								l_pos := -1 + 15 -- skip if block
							end
				when 13 then -- if:
							l_pos := -1 + 16 -- goto _L___1
				when 14 then -- if block done, skip else block:
							l_pos := -1 + 19
				when 15 then -- else:
							if (l_line[(l_col_end + 1)]).to_integer_32 /= 9 then
								l_pos := -1 + 18 -- skip if block
							end
				when 16 then -- if: | _L___1:
							from
							until
								js.loop_left
							loop
								js.reset
								if (l_line[(l_col_end + 1)]).to_integer_32 /= 32 then
									if (l_line[(l_col_end + 1)]).to_integer_32 /= 9 then
										js.break
									end
								end
								if not js.loop_jumped then
									l_col_end := l_col_end + 1
								end
							end
							js.reset
				when 17 then -- if block done, skip else block:
							l_pos := -1 + 19
				when 18 then -- else:
							from
							until
								js.loop_left
							loop
								js.reset
								if l_col_start > 0 then
									if (l_line[(l_col_start - 1)]).to_integer_32 /= 32 then
										if (l_line[(l_col_start - 1)]).to_integer_32 /= 9 then
											js.break
										end
									end
								else
									js.break
								end
								if not js.loop_jumped then
									l_col_start := l_col_start - 1
								end
							end
							js.reset
				when 19 then -- if done | if done
							if not a_include.to_boolean then
								if a_count___2 < 2 then
									if l_vis_empty.to_boolean then
										l_col_start := l_col_start + 1
									elseif not l_inside_quotes.to_boolean then
										l_col_start := l_col_start + 1
									end
								end
							end
							globals_inst.curwin.item.w_cursor.col := l_col_start
							if globals_inst.VIsual_active.to_boolean then
								if l_vis_empty.to_boolean then
									globals_inst.VIsual.ce_gets (globals_inst.curwin.item.w_cursor)
									screen_inst.redraw_curbuf_later (20)
								elseif l_vis_bef_curs.to_boolean then
									if not l_selected_quote.to_boolean then
										if l_inside_quotes.to_boolean then
											globals_inst.VIsual.ce_gets (globals_inst.curwin.item.w_cursor)
											screen_inst.redraw_curbuf_later (20)
										elseif (l_line[globals_inst.VIsual.col]).to_integer_32 /= a_quotechar then
											if globals_inst.VIsual.col = 0 then
												globals_inst.VIsual.ce_gets (globals_inst.curwin.item.w_cursor)
												screen_inst.redraw_curbuf_later (20)
											elseif (l_line[(globals_inst.VIsual.col - 1)]).to_integer_32 /= a_quotechar then
												globals_inst.VIsual.ce_gets (globals_inst.curwin.item.w_cursor)
												screen_inst.redraw_curbuf_later (20)
											end
										end
									end
								end
							else
								a_oap.item.start := globals_inst.curwin.item.w_cursor
								a_oap.item.motion_type := 0
							end
							globals_inst.curwin.item.w_cursor.col := l_col_end
							if not (a_include.to_boolean) then
								l_pos := -1 + 22 -- skip if block
							end
				when 20 then -- if:
							l_pos := -1 + 27 -- goto _L___2
				when 21 then -- if block done, skip else block:
							l_pos := -1 + 28
				when 22 then -- else:
							if not (a_count___2 > 1) then
								l_pos := -1 + 25 -- skip if block
							end
				when 23 then -- if:
							l_pos := -1 + 27 -- goto _L___2
				when 24 then -- if block done, skip else block:
							l_pos := -1 + 28
				when 25 then -- else:
							if l_vis_empty.to_boolean then
								l_pos := -1 + 28 -- skip if block
							end
				when 26 then -- if:
							if not (l_inside_quotes.to_boolean) then
								l_pos := -1 + 28 -- skip if block
							end
				when 27 then -- if: | _L___2:
							if (misc2_inst.inc_cursor) = 2 then
								l_inclusive := 1
							end
				when 28 then -- if done | if done | if done
							if not (globals_inst.VIsual_active.to_boolean) then
								l_pos := -1 + 38 -- skip if block
							end
				when 29 then -- if:
							if not (l_vis_empty.to_boolean) then
								l_pos := -1 + 32 -- skip if block
							end
				when 30 then -- if:
							l_pos := -1 + 33 -- goto _L___3
				when 31 then -- if block done, skip else block:
							l_pos := -1 + 36
				when 32 then -- else:
							if not (l_vis_bef_curs.to_boolean) then
								l_pos := -1 + 35 -- skip if block
							end
				when 33 then -- if: | _L___3:
							if (option_inst.p_sel.item).to_integer_32 /= 101 then
								misc2_inst.dec_cursor.do_nothing
							end
				when 34 then -- if block done, skip else block:
							l_pos := -1 + 36
				when 35 then -- else:
							if l_inside_quotes.to_boolean then
								misc2_inst.dec_cursor.do_nothing
								globals_inst.VIsual.ce_gets (globals_inst.curwin.item.w_cursor)
							elseif not l_selected_quote.to_boolean then
								if (l_line[globals_inst.VIsual.col]).to_integer_32 /= a_quotechar then
									if (l_line[globals_inst.VIsual.col]).to_integer_32 = 0 then
										misc2_inst.dec_cursor.do_nothing
										globals_inst.VIsual.ce_gets (globals_inst.curwin.item.w_cursor)
									elseif (l_line[(globals_inst.VIsual.col + 1)]).to_integer_32 /= a_quotechar then
										misc2_inst.dec_cursor.do_nothing
										globals_inst.VIsual.ce_gets (globals_inst.curwin.item.w_cursor)
									end
								end
							end
							globals_inst.curwin.item.w_cursor.col := l_col_start
				when 36 then -- if done
							if globals_inst.VIsual_mode = 86 then
								globals_inst.VIsual_mode := ('v').code
								globals_inst.redraw_cmdline := 1
							end
				when 37 then -- if block done, skip else block:
							l_pos := -1 + 39
				when 38 then -- else:
							a_oap.item.inclusive := l_inclusive
				when 39 then -- if done
							Result := 1
				when 40 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	linewhite (a_lnum: INTEGER_32): INTEGER_32
		local
			l_p___0: CE_POINTER [NATURAL_8]
		do
			create l_p___0.make

			l_p___0.ce_gets (charset_inst.skipwhite ((memline_inst.ml_get (a_lnum))))
			Result := ((l_p___0.item).to_integer_32 = 0).to_integer
		end

	find_pattern_in_path (a_ptr: CE_POINTER [NATURAL_8]; a_dir___0: INTEGER_32; a_len: INTEGER_32; a_whole: INTEGER_32; a_skip_comments: INTEGER_32; a_type: INTEGER_32; a_count___2: INTEGER_32; a_action: INTEGER_32; a_start_lnum: INTEGER_32; a_end_lnum: INTEGER_32)
		local
			l_dir___0: INTEGER_32
			l_count___2: INTEGER_32
			l_end_lnum: INTEGER_32
			l_files: CE_POINTER [PD_SEARCHEDFILE]
			l_bigger: CE_POINTER [PD_SEARCHEDFILE]
			l_max_path_depth: INTEGER_32
			l_match_count: INTEGER_32
			l_pat: CE_POINTER [NATURAL_8]
			l_new_fname: CE_POINTER [NATURAL_8]
			l_curr_fname: CE_POINTER [NATURAL_8]
			l_prev_fname: CE_POINTER [NATURAL_8]
			l_lnum: INTEGER_32
			l_depth___1: INTEGER_32
			l_depth_displayed: INTEGER_32
			l_old_files: INTEGER_32
			l_already_searched: INTEGER_32
			l_file_line: CE_POINTER [NATURAL_8]
			l_line: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_save_char: NATURAL_8
			l_define_matched: INTEGER_32
			l_regmatch___0: PD_REGMATCH_T
			l_incl_regmatch: PD_REGMATCH_T
			l_def_regmatch: PD_REGMATCH_T
			l_matched: INTEGER_32
			l_did_show: INTEGER_32
			l_found: INTEGER_32
			l_i___0: INTEGER_32
			l_already: CE_POINTER [NATURAL_8]
			l_startp: CE_POINTER [NATURAL_8]
			l_inc_opt: CE_POINTER [NATURAL_8]
			l_curwin_save: CE_POINTER [PD_WINDOW_S]
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_p_fname: CE_POINTER [NATURAL_8]
			l_tmp___5: CE_POINTER [NATURAL_8]
			l_tmp___20: CE_POINTER [SD_IO_FILE]
			l_tmp___24: INTEGER_32
			l_tmp___26: INTEGER_32
			l_reuse: INTEGER_32
			l_add_r: INTEGER_32
			l_aux: CE_POINTER [NATURAL_8]
			l_tmp___35: INTEGER_32
			l_tmp___36: INTEGER_32
			l_tmp___38: CE_POINTER [NATURAL_8]
			l_tmp___39: INTEGER_32
			l_tmp___40: CE_POINTER [INTEGER_32]
			l_tmp___41: CE_POINTER [SD_IO_FILE]
			l_tmp___43: CE_POINTER [INTEGER_32]
			l_tmp___44: CE_POINTER [SD_IO_FILE]
			l_tmp___52: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_files.make
			create l_bigger.make
			create l_pat.make
			create l_new_fname.make
			create l_curr_fname.make
			create l_prev_fname.make
			create l_file_line.make
			create l_line.make
			create l_p___0.make
			create l_regmatch___0.make
			create l_incl_regmatch.make
			create l_def_regmatch.make
			create l_already.make
			create l_startp.make
			create l_inc_opt.make
			create l_curwin_save.make
			create l_tmp.make
			create l_tmp___3.make
			create l_p_fname.make
			create l_tmp___5.make
			create l_tmp___20.make
			create l_aux.make
			create l_tmp___38.make
			create l_tmp___40.make
			create l_tmp___41.make
			create l_tmp___43.make
			create l_tmp___44.make
			create l_tmp___52.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_dir___0 := a_dir___0
					l_count___2 := a_count___2
					l_end_lnum := a_end_lnum
					l_max_path_depth := 50
					l_match_count := 1
					l_curr_fname.ce_gets (globals_inst.curbuf.item.b_fname)
					l_prev_fname.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_matched := 0
					l_did_show := 0
					l_found := 0
					l_already.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_startp.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_inc_opt.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_curwin_save.ce_gets (create {CE_POINTER [PD_WINDOW_S]}.make_shared (default_pointer))
					l_regmatch___0.regprog := create {CE_POINTER [PD_REGPROG_T]}.make_shared (default_pointer)
					l_incl_regmatch.regprog := create {CE_POINTER [PD_REGPROG_T]}.make_shared (default_pointer)
					l_def_regmatch.regprog := create {CE_POINTER [PD_REGPROG_T]}.make_shared (default_pointer)
					l_file_line.ce_gets (misc2_inst.alloc ({NATURAL_32} 512))
					if (l_file_line.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						js.return
					end
					if js.return_called then
						l_pos := -1 + 107 -- skip if block
					end
				when 1 then -- if:
						if a_type = 3 then
							l_pos := -1 + 6 -- skip if block
						end
				when 2 then -- if:
						if a_type = 2 then
							l_pos := -1 + 6 -- skip if block
						end
				when 3 then -- if:
						if ((globals_inst.compl_cont_status).bit_and (16)).to_boolean then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pat.ce_gets (misc2_inst.alloc ((a_len + 5).to_natural_32))
						if (l_pat.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 106 -- goto fpip_end
						end
				when 5 then
						if a_whole.to_boolean then
							l_tmp.ce_gets (ce_string ("\<%%.*s\>"))
						else
							l_tmp.ce_gets (ce_string ("%%.*s"))
						end
						sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_pat), l_tmp, a_len, a_ptr]).do_nothing
						l_regmatch___0.rm_ic := ignorecase (l_pat)
						if option_inst.p_magic.to_boolean then
							l_tmp___0 := 1
						else
							l_tmp___0 := 0
						end
						l_regmatch___0.regprog := regexp_inst.vim_regcomp (l_pat, l_tmp___0)
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_pat))
						if ((l_regmatch___0.regprog).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 106 -- goto fpip_end
						end
				when 6 then -- if done | if done
						if ((globals_inst.curbuf.item.b_p_inc).item).to_integer_32 = 0 then
							l_inc_opt.ce_gets (option_inst.p_inc)
						else
							l_inc_opt.ce_gets (globals_inst.curbuf.item.b_p_inc)
						end
						if (l_inc_opt.item).to_integer_32 = 0 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if option_inst.p_magic.to_boolean then
							l_tmp___1 := 1
						else
							l_tmp___1 := 0
						end
						l_incl_regmatch.regprog := regexp_inst.vim_regcomp (l_inc_opt, l_tmp___1)
						if ((l_incl_regmatch.regprog).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 106 -- goto fpip_end
						end
				when 8 then
						l_incl_regmatch.rm_ic := 0
				when 9 then -- if done
						if a_type /= 2 then
							l_pos := -1 + 16 -- skip if block
						end
				when 10 then -- if:
						if ((globals_inst.curbuf.item.b_p_def).item).to_integer_32 = 0 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_pos := -1 + 14 -- goto _L
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 13 then -- else:
						if (option_inst.p_def.item).to_integer_32 = 0 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if: | _L:
						if option_inst.p_magic.to_boolean then
							l_tmp___2 := 1
						else
							l_tmp___2 := 0
						end
						if ((globals_inst.curbuf.item.b_p_def).item).to_integer_32 = 0 then
							l_tmp___3.ce_gets (option_inst.p_def)
						else
							l_tmp___3.ce_gets (globals_inst.curbuf.item.b_p_def)
						end
						l_def_regmatch.regprog := regexp_inst.vim_regcomp (l_tmp___3, l_tmp___2)
						if ((l_def_regmatch.regprog).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 106 -- goto fpip_end
						end
				when 15 then
						l_def_regmatch.rm_ic := 0
				when 16 then -- if done | if done
						l_files.ce_gets (create {CE_POINTER [PD_SEARCHEDFILE]}.make_cast ((misc2_inst.lalloc_clear ((l_max_path_depth.to_natural_32 * {PD_SEARCHEDFILE}.sizeof.to_natural_32).to_natural_32, 1))))
						if (l_files.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 106 -- goto fpip_end
						end
				when 17 then
						l_old_files := l_max_path_depth
						l_depth_displayed := -1
						l_depth___1 := l_depth_displayed
						l_lnum := a_start_lnum
						if l_end_lnum > globals_inst.curbuf.item.b_ml.ml_line_count then
							l_end_lnum := globals_inst.curbuf.item.b_ml.ml_line_count
						end
						if l_lnum > l_end_lnum then
							l_lnum := l_end_lnum
						end
						l_line.ce_gets (memline_inst.ml_get (l_lnum))
				when 18 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 105 -- skip loop
						end
				when 19 then -- loop body:
						js.reset
						if ((l_incl_regmatch.regprog).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 32 -- skip if block
						end
				when 20 then -- if:
						if not ((regexp_inst.vim_regexec (l_incl_regmatch.address, l_line, 0)).to_boolean) then
							l_pos := -1 + 30 -- skip if block
						end
				when 21 then -- if:
						if (l_curr_fname.c_pointer.to_integer_32).to_natural_32 = ((globals_inst.curbuf.item.b_fname).c_pointer.to_integer_32).to_natural_32 then
							l_tmp___5.ce_gets (globals_inst.curbuf.item.b_ffname)
						else
							l_tmp___5.ce_gets (l_curr_fname)
						end
						l_p_fname.ce_gets (l_tmp___5)
						if (l_inc_opt.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							if ((strstr (create {CE_POINTER [INTEGER_8]}.make_cast (l_inc_opt), ce_string ("\zs"))).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								l_new_fname.ce_gets (window_inst.find_file_name_in_path (l_incl_regmatch.startp[0], (l_incl_regmatch.endp[0]).distance ((l_incl_regmatch.startp[0])), 26, 1, l_p_fname))
							else
								l_new_fname.ce_gets (window_inst.file_name_in_line (l_incl_regmatch.endp[0], 0, 26, 1, l_p_fname, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)))
							end
						else
							l_new_fname.ce_gets (window_inst.file_name_in_line (l_incl_regmatch.endp[0], 0, 26, 1, l_p_fname, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)))
						end
						l_already_searched := 0
						if (l_new_fname.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_i___0 := 0
							from
							until
								js.loop_left
							loop
								js.reset
								if l_i___0 = l_depth___1 + 1 then
									l_i___0 := l_old_files
								end
								if l_i___0 = l_max_path_depth then
									js.break
								end
								if not js.loop_jumped then
									if (((misc1_inst.fullpathcmp (l_new_fname, (l_files + l_i___0).item.name, 1))).bit_and (1)).to_boolean then
										if a_type /= 3 then
											if a_action = 4 then
												if ((l_files + l_i___0).item.matched).to_boolean then
													message_inst.msg_putchar (('%N').code)
													if not globals_inst.got_int.to_boolean then
														message_inst.msg_home_replace_hl (l_new_fname)
														message_inst.msg_puts (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string (" (includes previously listed match)")))))
														l_prev_fname.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
													end
												end
											end
										end
										misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_new_fname))
										l_new_fname.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
										l_already_searched := 1
										js.break
									end
								end
								if not js.loop_jumped then
									l_i___0 := l_i___0 + 1
								end
							end
							js.reset
						end
						if a_type /= 3 then
							l_pos := -1 + 28 -- skip if block
						end
				when 22 then -- if:
						if a_action /= 4 then
							l_pos := -1 + 25 -- skip if block
						end
				when 23 then -- if:
						l_pos := -1 + 27 -- goto _L___0
				when 24 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 25 then -- else:
						if (l_new_fname.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_pos := -1 + 28 -- skip if block
						end
				when 26 then -- if:
						if l_already_searched.to_boolean then
							l_pos := -1 + 28 -- skip if block
						end
				when 27 then -- if: | _L___0:
						if l_did_show.to_boolean then
							message_inst.msg_putchar (('%N').code)
						else
							ex_getln_inst.gotocmdline (1)
							message_inst.msg_puts_title (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("--- Included files ")))))
							if a_action /= 4 then
								message_inst.msg_puts_title (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("not found ")))))
							end
							message_inst.msg_puts_title (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("in path ---%N")))))
						end
						l_did_show := 1
						from
						until
							js.loop_left
						loop
							js.reset
							if l_depth_displayed < l_depth___1 then
								if globals_inst.got_int.to_boolean then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_depth_displayed := l_depth_displayed + 1
								l_i___0 := 0
								from
								until
									not (l_i___0 < l_depth_displayed)
								loop
									message_inst.msg_puts (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("  ")))
									l_i___0 := l_i___0 + 1
								end
								message_inst.msg_home_replace ((l_files + l_depth_displayed).item.name)
								message_inst.msg_puts (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" -->%N")))
							end
						end
						js.reset
						if not globals_inst.got_int.to_boolean then
							l_i___0 := 0
							from
							until
								not (l_i___0 <= l_depth_displayed)
							loop
								message_inst.msg_puts (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("  ")))
								l_i___0 := l_i___0 + 1
							end
							if (l_new_fname.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								message_inst.msg_outtrans_attr (l_new_fname, globals_inst.highlight_attr[2]).do_nothing
							else
								l_p___0.ce_gets (l_incl_regmatch.endp[0])
								from
								until
									js.loop_left
								loop
									js.reset
									if (charset_inst.vim_isfilec ((l_p___0.item).to_integer_32)).to_boolean then
										js.break
									end
									if not js.loop_jumped then
										l_p___0.ce_gets (l_p___0 + 1)
									end
								end
								js.reset
								l_i___0 := 0
								from
								until
									js.loop_left
								loop
									js.reset
									if not (charset_inst.vim_isfilec ((l_p___0[l_i___0]).to_integer_32)).to_boolean then
										js.break
									end
									if not js.loop_jumped then
										l_i___0 := l_i___0 + 1
									end
								end
								js.reset
								if l_i___0 = 0 then
									l_p___0.ce_gets (l_incl_regmatch.endp[0])
									l_i___0 := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0))).to_integer_32
								else
									if (l_p___0[-1]).to_integer_32 = 34 then
										l_p___0.ce_gets (l_p___0 - 1)
										l_i___0 := l_i___0 + 1
									elseif (l_p___0[-1]).to_integer_32 = 60 then
										l_p___0.ce_gets (l_p___0 - 1)
										l_i___0 := l_i___0 + 1
									end
									if (l_p___0[l_i___0]).to_integer_32 = 34 then
										l_i___0 := l_i___0 + 1
									elseif (l_p___0[l_i___0]).to_integer_32 = 62 then
										l_i___0 := l_i___0 + 1
									end
								end
								l_save_char := l_p___0[l_i___0]
								l_p___0[l_i___0] := (('%/0/').code).to_natural_8
								message_inst.msg_outtrans_attr (l_p___0, globals_inst.highlight_attr[2]).do_nothing
								l_p___0[l_i___0] := l_save_char
							end
							if (l_new_fname.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								if a_action = 4 then
									if l_already_searched.to_boolean then
										message_inst.msg_puts (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("  (Already listed)")))))
									else
										message_inst.msg_puts (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("  NOT FOUND")))))
									end
								end
							end
						end
						term_inst.out_flush
				when 28 then -- if done | if done | if done
						if (l_new_fname.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							if l_depth___1 + 1 = l_old_files then
								l_bigger.ce_gets (create {CE_POINTER [PD_SEARCHEDFILE]}.make_cast ((misc2_inst.lalloc (((l_max_path_depth * 2).to_natural_32 * {PD_SEARCHEDFILE}.sizeof.to_natural_32).to_natural_32, 1))))
								if (l_bigger.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									l_i___0 := 0
									from
									until
										not (l_i___0 <= l_depth___1)
									loop
										l_bigger[l_i___0] := l_files[l_i___0]
										l_i___0 := l_i___0 + 1
									end
									l_i___0 := l_depth___1 + 1
									from
									until
										not (l_i___0 < l_old_files + l_max_path_depth)
									loop
										(l_bigger + l_i___0).item.fp := create {CE_POINTER [SD_IO_FILE]}.make_shared (default_pointer);
										(l_bigger + l_i___0).item.name := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer);
										(l_bigger + l_i___0).item.lnum := (0).to_integer_32;
										(l_bigger + l_i___0).item.matched := 0
										l_i___0 := l_i___0 + 1
									end
									l_i___0 := l_old_files
									from
									until
										not (l_i___0 < l_max_path_depth)
									loop
										l_bigger[(l_i___0 + l_max_path_depth)] := l_files[l_i___0]
										l_i___0 := l_i___0 + 1
									end
									l_old_files := l_old_files + l_max_path_depth
									l_max_path_depth := l_max_path_depth * (2)
									misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_files))
									l_files.ce_gets (l_bigger)
								end
							end
							l_tmp___20.ce_gets (fopen (create {CE_POINTER [INTEGER_8]}.make_cast (l_new_fname), ce_string ("r")));
							(l_files + (l_depth___1 + 1)).item.fp := l_tmp___20
							if (l_tmp___20.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_new_fname))
							else
								l_depth___1 := l_depth___1 + 1
								if l_depth___1 = l_old_files then
									misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast ((l_files + l_old_files).item.name))
									l_old_files := l_old_files + 1
								end
								l_curr_fname.ce_gets (l_new_fname);
								(l_files + l_depth___1).item.name := l_curr_fname;
								(l_files + l_depth___1).item.lnum := (0).to_integer_32;
								(l_files + l_depth___1).item.matched := 0
								if a_action = 5 then
									globals_inst.msg_hist_off := 1
									message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (1025).to_natural_32, (gettext (ce_string ("Scanning included file: %%s"))), create {CE_POINTER [INTEGER_8]}.make_cast (l_new_fname)]).do_nothing
									message_inst.msg_trunc_attr (globals_inst.IObuff, 1, globals_inst.highlight_attr[10]).do_nothing
								elseif option_inst.p_verbose >= 5 then
									message_inst.verbose_enter
									message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Searching included file %%s")))), create {CE_POINTER [INTEGER_8]}.make_cast (l_new_fname)]).do_nothing
									message_inst.verbose_leave
								end
							end
						end
				when 29 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 30 then -- else:
						l_pos := -1 + 32 -- goto _L___9
				when 31 then -- if done | if block done, skip else block:
						l_pos := -1 + 77
				when 32 then -- else: | _L___9:
						l_p___0.ce_gets (l_line)
				when 33 then -- search_line:
						l_define_matched := 0
						if ((l_def_regmatch.regprog).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							if (regexp_inst.vim_regexec (l_def_regmatch.address, l_line, 0)).to_boolean then
								l_p___0.ce_gets (l_def_regmatch.endp[0])
								from
								until
									js.loop_left
								loop
									js.reset
									if (l_p___0.item).to_boolean then
										if (charset_inst.vim_iswordc ((l_p___0.item).to_integer_32)).to_boolean then
											js.break
										end
									else
										js.break
									end
									if not js.loop_jumped then
										l_p___0.ce_gets (l_p___0 + 1)
									end
								end
								js.reset
								l_define_matched := 1
							end
						end
						if ((l_def_regmatch.regprog).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_pos := -1 + 36 -- skip if block
						end
				when 34 then -- if:
						l_pos := -1 + 37 -- goto _L___8
				when 35 then -- if block done, skip else block:
						l_pos := -1 + 77
				when 36 then -- else:
						if not (l_define_matched.to_boolean) then
							l_pos := -1 + 77 -- skip if block
						end
				when 37 then -- if: | _L___8:
						if not (l_define_matched.to_boolean) then
							l_pos := -1 + 40 -- skip if block
						end
				when 38 then -- if:
						l_pos := -1 + 41 -- goto _L___7
				when 39 then -- if block done, skip else block:
						l_pos := -1 + 77
				when 40 then -- else:
						if not (((globals_inst.compl_cont_status).bit_and (16)).to_boolean) then
							l_pos := -1 + 43 -- skip if block
						end
				when 41 then -- if: | _L___7:
						l_startp.ce_gets (charset_inst.skipwhite (l_p___0))
						if option_inst.p_ic.to_boolean then
							if (mbyte_inst.mb_strnicmp (l_startp, a_ptr, a_len.to_natural_32)).to_boolean then
								l_tmp___24 := 0
							else
								l_tmp___24 := 1
							end
							l_matched := l_tmp___24
						else
							if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_startp), create {CE_POINTER [INTEGER_8]}.make_cast (a_ptr), a_len.to_natural_32)).to_boolean then
								l_tmp___26 := 0
							else
								l_tmp___26 := 1
							end
							l_matched := l_tmp___26
						end
						if l_matched.to_boolean then
							if l_define_matched.to_boolean then
								if a_whole.to_boolean then
									if (charset_inst.vim_iswordc ((l_startp[a_len]).to_integer_32)).to_boolean then
										l_matched := 0
									end
								end
							end
						end
				when 42 then -- if block done, skip else block:
						l_pos := -1 + 77
				when 43 then -- else:
						if ((l_regmatch___0.regprog).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 77 -- skip if block
						end
				when 44 then -- if:
						if not ((regexp_inst.vim_regexec (l_regmatch___0.address, l_line, l_p___0.distance (l_line))).to_boolean) then
							l_pos := -1 + 77 -- skip if block
						end
				when 45 then -- if:
						l_matched := 1
						l_startp.ce_gets (l_regmatch___0.startp[0])
						if l_define_matched.to_boolean then
							l_pos := -1 + 77 -- skip if block
						end
				when 46 then -- if:
						if not (a_skip_comments.to_boolean) then
							l_pos := -1 + 77 -- skip if block
						end
				when 47 then -- if:
						if (l_line.item).to_integer_32 = 35 then
							l_pos := -1 + 50 -- skip if block
						end
				when 48 then -- if:
						l_pos := -1 + 51 -- goto _L___1
				when 49 then -- if block done, skip else block:
						l_pos := -1 + 52
				when 50 then -- else:
						if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast ((charset_inst.skipwhite (l_line + 1))), ce_string ("define"), (6).to_natural_32)) = 0 then
							l_pos := -1 + 52 -- skip if block
						end
				when 51 then -- if: | _L___1:
						if (misc1_inst.get_leader_len (l_line, create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), 0)).to_boolean then
							l_matched := 0
						end
				when 52 then -- if done
						l_p___0.ce_gets (charset_inst.skipwhite (l_line))
						if not (l_matched.to_boolean) then
							l_pos := -1 + 55 -- skip if block
						end
				when 53 then -- if:
						l_pos := -1 + 59 -- goto _L___5
				when 54 then -- if block done, skip else block:
						l_pos := -1 + 77
				when 55 then -- else:
						if (l_p___0[0]).to_integer_32 /= 47 then
							l_pos := -1 + 58 -- skip if block
						end
				when 56 then -- if:
						if (l_p___0[1]).to_integer_32 = 42 then
							l_pos := -1 + 59 -- goto _L___5
						else
							l_pos := -1 + 58 -- goto _L___6
						end
				when 57 then -- if block done, skip else block:
						l_pos := -1 + 77
				when 58 then -- else: | _L___6:
						if (l_p___0[0]).to_integer_32 /= 42 then
							l_pos := -1 + 77 -- skip if block
						end
				when 59 then -- if: | _L___5:
						l_p___0.ce_gets (l_line)
				when 60 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 76 -- skip loop
						end
				when 61 then -- loop body:
						js.reset
						if (l_p___0.item).to_boolean then
							if not ((l_p___0.c_pointer.to_integer_32).to_natural_32 < (l_startp.c_pointer.to_integer_32).to_natural_32) then
								js.break
							end
						else
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 75 -- skip if block
						end
				when 62 then -- if:
						if not (l_matched.to_boolean) then
							l_pos := -1 + 74 -- skip if block
						end
				when 63 then -- if:
						if (l_p___0[0]).to_integer_32 /= 47 then
							l_pos := -1 + 72 -- skip if block
						end
				when 64 then -- if:
						if (l_p___0[1]).to_integer_32 /= 42 then
							l_pos := -1 + 67 -- skip if block
						end
				when 65 then -- if:
						l_pos := -1 + 68 -- goto _L___3
				when 66 then -- if block done, skip else block:
						l_pos := -1 + 71
				when 67 then -- else:
						if (l_p___0[1]).to_integer_32 /= 47 then
							l_pos := -1 + 70 -- skip if block
						end
				when 68 then -- if: | _L___3:
						l_matched := 0
						if (l_p___0[1]).to_integer_32 = 47 then
							js.break
						end
						if not js.loop_jumped then
							l_p___0.ce_gets (l_p___0 + 1)
						end
				when 69 then -- if block done, skip else block:
						l_pos := -1 + 71
				when 70 then -- else:
						l_pos := -1 + 74 -- goto _L___4
				when 71 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 73
				when 72 then -- else:
						l_pos := -1 + 74 -- goto _L___4
				when 73 then -- if done | if block done, skip else block:
						l_pos := -1 + 75
				when 74 then -- else: | _L___4:
						if not l_matched.to_boolean then
							if (l_p___0[0]).to_integer_32 = 42 then
								if (l_p___0[1]).to_integer_32 = 47 then
									l_matched := 1
									l_p___0.ce_gets (l_p___0 + 1)
								end
							end
						end
				when 75 then -- if done
						if not js.loop_jumped then
							l_p___0.ce_gets (l_p___0 + 1)
						end
						l_pos := -1 + 60 -- back to loop condition
				when 76 then -- loop done
						js.reset
				when 77 then -- if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done
						if not (l_matched.to_boolean) then
							l_pos := -1 + 104 -- skip if block
						end
				when 78 then -- if:
						if a_action /= 5 then
							l_pos := -1 + 93 -- skip if block
						end
				when 79 then -- if:
						l_reuse := 0
						if l_depth___1 = -1 then
							if l_lnum = globals_inst.curwin.item.w_cursor.lnum then
								js.break
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 92 -- skip if block
						end
				when 80 then -- if:
						l_found := 1
						l_p___0.ce_gets (l_startp)
						l_aux.ce_gets (l_p___0)
						if not (((globals_inst.compl_cont_status).bit_and (1)).to_boolean) then
							l_pos := -1 + 83 -- skip if block
						end
				when 81 then -- if:
						l_p___0.ce_gets (l_p___0 + globals_inst.compl_length)
						if (charset_inst.vim_iswordp (l_p___0)).to_boolean then
							l_pos := -1 + 103 -- goto exit_matched
						end
				when 82 then
						l_p___0.ce_gets (edit_inst.find_word_start (l_p___0))
				when 83 then -- if done
						l_p___0.ce_gets (edit_inst.find_word_end (l_p___0))
						l_i___0 := l_p___0.distance (l_aux)
						if not (((globals_inst.compl_cont_status).bit_and (1)).to_boolean) then
							l_pos := -1 + 91 -- skip if block
						end
				when 84 then -- if:
						if l_i___0 /= globals_inst.compl_length then
							l_pos := -1 + 91 -- skip if block
						end
				when 85 then -- if:
						strncpy (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), create {CE_POINTER [INTEGER_8]}.make_cast (l_aux), l_i___0.to_natural_32).do_nothing
						if not (l_depth___1 < 0) then
							l_pos := -1 + 89 -- skip if block
						end
				when 86 then -- if:
						if l_lnum >= l_end_lnum then
							l_pos := -1 + 103 -- goto exit_matched
						end
				when 87 then
						l_lnum := l_lnum + 1
						l_line.ce_gets (memline_inst.ml_get (l_lnum))
				when 88 then -- if block done, skip else block:
						l_pos := -1 + 90
				when 89 then -- else:
						l_line.ce_gets (l_file_line)
						if (fileio_inst.vim_fgets (l_line, 512, (l_files + l_depth___1).item.fp)).to_boolean then
							l_pos := -1 + 103 -- goto exit_matched
						end
				when 90 then
						l_p___0.ce_gets (charset_inst.skipwhite (l_line))
						l_aux.ce_gets (l_p___0)
						l_already.ce_gets (l_aux)
						l_p___0.ce_gets (edit_inst.find_word_start (l_p___0))
						l_p___0.ce_gets (edit_inst.find_word_end (l_p___0))
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 > (l_aux.c_pointer.to_integer_32).to_natural_32 then
							if (l_aux.item).to_integer_32 /= 41 then
								if (globals_inst.IObuff[(l_i___0 - 1)]).to_integer_32 /= 9 then
									if (globals_inst.IObuff[(l_i___0 - 1)]).to_integer_32 /= 32 then
										l_tmp___35 := l_i___0
										l_i___0 := l_i___0 + 1
										globals_inst.IObuff[l_tmp___35] := ((' ').code).to_natural_8
									end
									if option_inst.p_js.to_boolean then
										if (globals_inst.IObuff[(l_i___0 - 2)]).to_integer_32 = 46 then
											l_tmp___36 := l_i___0
											l_i___0 := l_i___0 + 1
											globals_inst.IObuff[l_tmp___36] := ((' ').code).to_natural_8
										elseif ((misc2_inst.vim_strchr (option_inst.p_cpo, ('j').code)).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
											if (globals_inst.IObuff[(l_i___0 - 2)]).to_integer_32 = 63 then
												l_tmp___36 := l_i___0
												l_i___0 := l_i___0 + 1
												globals_inst.IObuff[l_tmp___36] := ((' ').code).to_natural_8
											elseif (globals_inst.IObuff[(l_i___0 - 2)]).to_integer_32 = 33 then
												l_tmp___36 := l_i___0
												l_i___0 := l_i___0 + 1
												globals_inst.IObuff[l_tmp___36] := ((' ').code).to_natural_8
											end
										end
									end
								end
							end
							if l_p___0.distance (l_aux) >= 1025 - l_i___0 then
								l_p___0.ce_gets (((l_aux + 1025) - l_i___0) - 1)
							end
							strncpy (create {CE_POINTER [INTEGER_8]}.make_cast ((globals_inst.IObuff + l_i___0)), create {CE_POINTER [INTEGER_8]}.make_cast (l_aux), (l_p___0.distance (l_aux)).to_natural_32).do_nothing
							l_i___0 := l_i___0 + (l_p___0.distance (l_aux))
							l_reuse := (l_reuse).bit_or ((8))
						end
						globals_inst.IObuff[l_i___0] := (('%/0/').code).to_natural_8
						l_aux.ce_gets (globals_inst.IObuff)
						if l_i___0 = globals_inst.compl_length then
							l_pos := -1 + 103 -- goto exit_matched
						end
				when 91 then -- if done
						if (l_curr_fname.c_pointer.to_integer_32).to_natural_32 = ((globals_inst.curbuf.item.b_fname).c_pointer.to_integer_32).to_natural_32 then
							l_tmp___38.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						else
							l_tmp___38.ce_gets (l_curr_fname)
						end
						l_add_r := edit_inst.ins_compl_add_infercase (l_aux, l_i___0, option_inst.p_ic, l_tmp___38, l_dir___0, l_reuse)
						if l_add_r = 1 then
							l_dir___0 := 1
						elseif l_add_r = 0 then
							js.break
						end
				when 92 then -- if done | if block done, skip else block:
						l_pos := -1 + 102
				when 93 then -- else:
						if a_action /= 4 then
							l_pos := -1 + 96 -- skip if block
						end
				when 94 then -- if:
						l_found := 1
						if not l_did_show.to_boolean then
							ex_getln_inst.gotocmdline (1)
						end
						if (l_curr_fname.c_pointer.to_integer_32).to_natural_32 /= (l_prev_fname.c_pointer.to_integer_32).to_natural_32 then
							if l_did_show.to_boolean then
								message_inst.msg_putchar (('%N').code)
							end
							if not globals_inst.got_int.to_boolean then
								message_inst.msg_home_replace_hl (l_curr_fname)
							end
							l_prev_fname.ce_gets (l_curr_fname)
						end
						l_did_show := 1
						if not globals_inst.got_int.to_boolean then
							l_tmp___39 := l_match_count
							l_match_count := l_match_count + 1
							if l_depth___1 = -1 then
								l_tmp___40.ce_gets (create {CE_POINTER [INTEGER_32]}.make_shared ($l_lnum))
							else
								l_tmp___40.ce_gets (create {CE_POINTER [INTEGER_32]}.make_shared ((l_files + l_depth___1).c_pointer + {PD_SEARCHEDFILE}.lnum_offset))
							end
							if l_depth___1 = -1 then
								l_tmp___41.ce_gets (create {CE_POINTER [SD_IO_FILE]}.make_shared (default_pointer))
							else
								l_tmp___41.ce_gets ((l_files + l_depth___1).item.fp)
							end
							show_pat_in_path (l_line, a_type, 1, a_action, l_tmp___41, l_tmp___40, l_tmp___39)
						end
						l_i___0 := 0
						from
						until
							not (l_i___0 <= l_depth___1)
						loop
							(l_files + l_i___0).item.matched := 1
							l_i___0 := l_i___0 + 1
						end
				when 95 then -- if block done, skip else block:
						l_pos := -1 + 102
				when 96 then -- else:
						l_count___2 := l_count___2 - 1
						if not (l_count___2 <= 0) then
							l_pos := -1 + 102 -- skip if block
						end
				when 97 then -- if:
						l_found := 1
						if l_depth___1 /= -1 then
							l_pos := -1 + 100 -- skip if block
						end
				when 98 then -- if:
						if l_lnum = globals_inst.curwin.item.w_cursor.lnum then
							if globals_inst.g_do_tagpreview = 0 then
								message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E387: Match is on current line"))))).do_nothing
							else
								l_pos := -1 + 100 -- goto _L___11
							end
						else
							l_pos := -1 + 100 -- goto _L___11
						end
				when 99 then -- if block done, skip else block:
						l_pos := -1 + 101
				when 100 then -- else: | _L___11:
						if a_action = 1 then
							if l_depth___1 = -1 then
								l_tmp___43.ce_gets (create {CE_POINTER [INTEGER_32]}.make_shared ($l_lnum))
							else
								l_tmp___43.ce_gets (create {CE_POINTER [INTEGER_32]}.make_shared ((l_files + l_depth___1).c_pointer + {PD_SEARCHEDFILE}.lnum_offset))
							end
							if l_depth___1 = -1 then
								l_tmp___44.ce_gets (create {CE_POINTER [SD_IO_FILE]}.make_shared (default_pointer))
							else
								l_tmp___44.ce_gets ((l_files + l_depth___1).item.fp)
							end
							show_pat_in_path (l_line, a_type, l_did_show, a_action, l_tmp___44, l_tmp___43, 1)
							l_did_show := 1
						else
							globals_inst.need_mouse_correct := 1
							if globals_inst.g_do_tagpreview /= 0 then
								l_curwin_save.ce_gets (globals_inst.curwin)
								ex_cmds_inst.prepare_tagpreview (1).do_nothing
							end
							if a_action = 3 then
								if (window_inst.win_split (0, 0)) = 0 then
									js.break
								end
								if not js.loop_jumped then
									globals_inst.curwin.item.w_onebuf_opt.wo_scb := 0
								end
							end
							if not js.loop_jumped then
								if l_depth___1 = -1 then
									if globals_inst.g_do_tagpreview /= 0 then
										if (ex_cmds_inst.getfile (0, (l_curwin_save.item.w_buffer).item.b_fname, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 1, l_lnum, 0)) > 0 then
											js.break
										end
									else
										mark_inst.setpcmark
									end
									if not js.loop_jumped then
										globals_inst.curwin.item.w_cursor.lnum := l_lnum
									end
								else
									if (ex_cmds_inst.getfile (0, (l_files + l_depth___1).item.name, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 1, (l_files + l_depth___1).item.lnum, 0)) > 0 then
										js.break
									end
									if not js.loop_jumped then
										globals_inst.curwin.item.w_cursor.lnum := (l_files + l_depth___1).item.lnum
									end
								end
							end
						end
				when 101 then
						if not js.loop_jumped then
							if a_action /= 1 then
								globals_inst.curwin.item.w_cursor.col := l_startp.distance (l_line)
								globals_inst.curwin.item.w_set_curswant := 1
							end
							if globals_inst.g_do_tagpreview /= 0 then
								if (globals_inst.curwin.c_pointer.to_integer_32).to_natural_32 /= (l_curwin_save.c_pointer.to_integer_32).to_natural_32 then
									if (window_inst.win_valid (l_curwin_save)).to_boolean then
										move_inst.validate_cursor
										screen_inst.redraw_later (10)
										window_inst.win_enter (l_curwin_save, 1)
									end
								end
							end
							js.break
						end
				when 102 then -- if done | if done | if done
						if js.loop_jumped then
							l_pos := -1 + 104 -- skip if block
						end
				when 103 then -- if: | exit_matched:
						l_matched := 0
						if ((l_def_regmatch.regprog).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							if a_action = 5 then
								if not ((globals_inst.compl_cont_status).bit_and (16)).to_boolean then
									if (l_startp.item).to_integer_32 /= 0 then
										l_p___0.ce_gets (l_startp + 1)
										if (l_p___0.item).to_integer_32 /= 0 then
											l_pos := -1 + 33 -- goto search_line
										end
									end
								end
							end
						end
				when 104 then -- if done
						if not js.loop_jumped then
							misc1_inst.line_breakcheck
							if a_action = 5 then
								edit_inst.ins_compl_check_keys (30)
							end
							if globals_inst.got_int.to_boolean then
								js.break
							elseif globals_inst.compl_interrupted.to_boolean then
								js.break
							end
						end
						if not js.loop_jumped then
							from
							until
								js.loop_left
							loop
								js.reset
								if l_depth___1 >= 0 then
									if (l_already).c_pointer = default_pointer then
										l_line.ce_gets (l_file_line)
										if not (fileio_inst.vim_fgets (l_line, 512, (l_files + l_depth___1).item.fp)).to_boolean then
											js.break
										end
									else
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped then
									fclose ((l_files + l_depth___1).item.fp).do_nothing
									l_old_files := l_old_files - 1;
									(l_files + l_old_files).item.name := (l_files + l_depth___1).item.name;
									(l_files + l_old_files).item.matched := (l_files + l_depth___1).item.matched
									l_depth___1 := l_depth___1 - 1
									if l_depth___1 = -1 then
										l_curr_fname.ce_gets (globals_inst.curbuf.item.b_fname)
									else
										l_curr_fname.ce_gets ((l_files + l_depth___1).item.name)
									end
									if l_depth___1 < l_depth_displayed then
										l_depth_displayed := l_depth___1
									end
								end
							end
							js.reset
							if l_depth___1 >= 0 then
								(l_files + l_depth___1).item.lnum := ((l_files + l_depth___1).item.lnum) + 1
							elseif (l_already).c_pointer = default_pointer then
								l_lnum := l_lnum + 1
								if l_lnum > l_end_lnum then
									js.break
								end
								if not js.loop_jumped then
									l_line.ce_gets (memline_inst.ml_get (l_lnum))
								end
							end
						end
						if not js.loop_jumped then
							l_already.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						end
						l_pos := -1 + 18 -- back to loop condition
				when 105 then -- loop done
						js.reset
						l_i___0 := 0
						from
						until
							not (l_i___0 <= l_depth___1)
						loop
							fclose ((l_files + l_i___0).item.fp).do_nothing
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast ((l_files + l_i___0).item.name))
							l_i___0 := l_i___0 + 1
						end
						l_i___0 := l_old_files
						from
						until
							not (l_i___0 < l_max_path_depth)
						loop
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast ((l_files + l_i___0).item.name))
							l_i___0 := l_i___0 + 1
						end
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_files))
						if a_type = 3 then
							if not l_did_show.to_boolean then
								if a_action /= 4 then
									message_inst.msg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("All included files were found"))))).do_nothing
								else
									message_inst.msg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("No included files"))))).do_nothing
								end
							end
						elseif not l_found.to_boolean then
							if a_action /= 5 then
								if globals_inst.got_int.to_boolean then
									l_tmp___52.ce_gets (gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_interr)))
									message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___52)).do_nothing
								elseif globals_inst.compl_interrupted.to_boolean then
									l_tmp___52.ce_gets (gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_interr)))
									message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___52)).do_nothing
								elseif a_type = 2 then
									message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E388: Couldn%'t find definition"))))).do_nothing
								else
									message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E389: Couldn%'t find pattern"))))).do_nothing
								end
							end
						end
						if a_action = 1 then
							message_inst.msg_end.do_nothing
						elseif a_action = 4 then
							message_inst.msg_end.do_nothing
						end
				when 106 then -- fpip_end:
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_file_line))
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_regmatch___0.regprog))
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_incl_regmatch.regprog))
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_def_regmatch.regprog))
				when 107 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	show_pat_in_path (a_line: CE_POINTER [NATURAL_8]; a_type: INTEGER_32; a_did_show: INTEGER_32; a_action: INTEGER_32; a_fp: CE_POINTER [SD_IO_FILE]; a_lnum: CE_POINTER [INTEGER_32]; a_count___2: INTEGER_32)
		local
			l_line: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_line.make
			create l_p___0.make

			l_line.ce_gets (a_line)
			if a_did_show.to_boolean then
				message_inst.msg_putchar (('%N').code)
			elseif not globals_inst.msg_silent.to_boolean then
				ex_getln_inst.gotocmdline (1)
			end
			if globals_inst.got_int.to_boolean then
				js.return
			end
			if not js.return_called then
				from
				until
					js.loop_left
				loop
					js.reset
					l_p___0.ce_gets ((l_line + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_line))).to_integer_32) - 1)
					if (a_fp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 >= (l_line.c_pointer.to_integer_32).to_natural_32 then
							if (l_p___0.item).to_integer_32 = 10 then
								l_p___0.ce_gets (l_p___0 - 1)
							end
						end
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 >= (l_line.c_pointer.to_integer_32).to_natural_32 then
							if (l_p___0.item).to_integer_32 = 13 then
								l_p___0.ce_gets (l_p___0 - 1)
							end
						end
						l_p___0[1] := (('%/0/').code).to_natural_8
					end
					if a_action = 4 then
						sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), ce_string ("%%3ld: "), a_count___2]).do_nothing
						message_inst.msg_puts (globals_inst.IObuff)
						sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), ce_string ("%%4ld"), a_lnum.item]).do_nothing
						message_inst.msg_puts_attr (globals_inst.IObuff, globals_inst.highlight_attr[9])
						message_inst.msg_puts (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")))
					end
					message_inst.msg_prt_line (l_line, 0)
					term_inst.out_flush
					if globals_inst.got_int.to_boolean then
						js.break
					elseif a_type /= 2 then
						js.break
					elseif (l_p___0.c_pointer.to_integer_32).to_natural_32 < (l_line.c_pointer.to_integer_32).to_natural_32 then
						js.break
					elseif (l_p___0.item).to_integer_32 /= 92 then
						js.break
					end
					if not js.loop_jumped then
						if (a_fp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							if (fileio_inst.vim_fgets (l_line, 512, a_fp)).to_boolean then
								js.break
							end
							if not js.loop_jumped then
								a_lnum.item := (a_lnum.item) + 1
							end
						else
							a_lnum.item := (a_lnum.item) + 1
							if a_lnum.item > globals_inst.curbuf.item.b_ml.ml_line_count then
								js.break
							end
							if not js.loop_jumped then
								l_line.ce_gets (memline_inst.ml_get (a_lnum.item))
							end
						end
					end
					if not js.loop_jumped then
						message_inst.msg_putchar (('%N').code)
					end
				end
				js.reset
			end
		end

	read_viminfo_search_pattern (a_virp: CE_POINTER [PD_VIR_T]; a_force: INTEGER_32): INTEGER_32
		local
			l_lp: CE_POINTER [NATURAL_8]
			l_idx: INTEGER_32
			l_magic: INTEGER_32
			l_no_scs: INTEGER_32
			l_off_line: INTEGER_32
			l_off_end: INTEGER_32
			l_off___0: INTEGER_32
			l_setlast: INTEGER_32
			l_val___0: CE_POINTER [NATURAL_8]
			l_pos: INTEGER_32
		do
			create l_lp.make
			create l_val___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_idx := -1
					l_magic := 0
					l_no_scs := 0
					l_off_line := 0
					l_off_end := 0
					l_off___0 := 0
					l_setlast := 0
					l_lp.ce_gets (a_virp.item.vir_line)
					if (l_lp[0]).to_integer_32 /= 126 then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if (l_lp[1]).to_integer_32 /= 109 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if (l_lp[1]).to_integer_32 /= 77 then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						if (l_lp[1]).to_integer_32 = 77 then
							l_magic := 1
						end
						if (l_lp[2]).to_integer_32 = 115 then
							l_no_scs := 1
						end
						if (l_lp[3]).to_integer_32 = 76 then
							l_off_line := 1
						end
						if (l_lp[4]).to_integer_32 = 69 then
							l_off_end := 64
						end
						l_lp.ce_gets (l_lp + (5))
						l_off___0 := charset_inst.getdigits (l_lp.address)
				when 6 then -- if done | if done
						if (l_lp[0]).to_integer_32 = 126 then
							l_setlast := 1
							l_lp.ce_gets (l_lp + 1)
						end
						if (l_lp[0]).to_integer_32 = 47 then
							l_idx := 0
						elseif (l_lp[0]).to_integer_32 = 38 then
							l_idx := 1
						elseif (l_lp[0]).to_integer_32 = 104 then
							hlsearch_on := 0
						elseif (l_lp[0]).to_integer_32 = 72 then
							hlsearch_on := 1
						end
						if not (l_idx >= 0) then
							l_pos := -1 + 12 -- skip if block
						end
				when 7 then -- if:
							if not (a_force.to_boolean) then
								l_pos := -1 + 10 -- skip if block
							end
				when 8 then -- if:
							l_pos := -1 + 11 -- goto _L___0
				when 9 then -- if block done, skip else block:
							l_pos := -1 + 12
				when 10 then -- else:
							if ((spats[l_idx].pat).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								l_pos := -1 + 12 -- skip if block
							end
				when 11 then -- if: | _L___0:
							l_val___0.ce_gets (ex_cmds_inst.viminfo_readstring (a_virp, (l_lp.distance ((a_virp.item.vir_line))) + 1, 1))
							if (l_val___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								set_last_search_pat (l_val___0, l_idx, l_magic, l_setlast)
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_val___0))
								spats[l_idx].no_scs := l_no_scs
								spats[l_idx].off.line := l_off_line
								spats[l_idx].off.end2 := l_off_end
								spats[l_idx].off.off := l_off___0
								if l_setlast.to_boolean then
									globals_inst.no_hlsearch := (not hlsearch_on.to_boolean).to_integer
								end
							end
				when 12 then -- if done | if done
							Result := (ex_cmds_inst.viminfo_readline (a_virp))
				when 13 then
							l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
				end

	write_viminfo_search_pattern (a_fp: CE_POINTER [SD_IO_FILE])
		local
			l_tmp___0: INTEGER_32
		do
			if (option_inst.get_viminfo_parameter (('/').code)) /= 0 then
				if globals_inst.no_hlsearch.to_boolean then
					l_tmp___0 := ('h').code
				elseif ((option_inst.find_viminfo_parameter (('h').code)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					l_tmp___0 := ('h').code
				else
					l_tmp___0 := ('H').code
				end
				fprintf ([a_fp, ce_string ("%N# hlsearch on (H) or off (h):%N~%%c"), l_tmp___0]).do_nothing
				wvsp_one (a_fp, 0, ce_string (""), ('/').code)
				wvsp_one (a_fp, 1, (gettext (ce_string ("Substitute "))), ('&').code)
			end
		end

	wvsp_one (a_fp: CE_POINTER [SD_IO_FILE]; a_idx: INTEGER_32; a_s: CE_POINTER [INTEGER_8]; a_sc: INTEGER_32)
		local
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
		do
			create l_tmp___0.make

			if ((spats[a_idx].pat).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				fprintf ([a_fp, (gettext (ce_string ("%N# Last %%sSearch Pattern:%N~"))), a_s]).do_nothing
				if last_idx = a_idx then
					l_tmp___0.ce_gets (ce_string ("~"))
				else
					l_tmp___0.ce_gets (ce_string (""))
				end
				if (spats[a_idx].off.end2).to_boolean then
					l_tmp___1 := ('E').code
				else
					l_tmp___1 := ('e').code
				end
				if (spats[a_idx].off.line).to_boolean then
					l_tmp___2 := ('L').code
				else
					l_tmp___2 := ('l').code
				end
				if (spats[a_idx].no_scs).to_boolean then
					l_tmp___3 := ('s').code
				else
					l_tmp___3 := ('S').code
				end
				if (spats[a_idx].magic).to_boolean then
					l_tmp___4 := ('M').code
				else
					l_tmp___4 := ('m').code
				end
				fprintf ([a_fp, ce_string ("%%c%%c%%c%%c%%ld%%s%%c"), l_tmp___4, l_tmp___3, l_tmp___2, l_tmp___1, spats[a_idx].off.off, l_tmp___0, a_sc]).do_nothing
				ex_cmds_inst.viminfo_writestring (a_fp, spats[a_idx].pat)
			end
		end

end
