class
	P_URL

inherit
	LIBCURL_DATA
		redefine
			default_create
		end
	S_STDIO
	S_STDLIB
	S_STRING
	S_CTYPE
	S_SYS_STAT
	S_TIME
	S_UNISTD
	S_FCNTL
	S_SYS_TIME
	S_ARPA_INET
	S_SIGNAL
	S_LIBGEN
	S_SYS_SOCKET
	S_BITS_ERRNO
	S_NETINET_IN
	S_IFADDRS
	S_PWD
	S_SYS_POLL
	S_NETDB

feature {NONE} -- Initialization

	default_create
		do
			create protocols.make (<<12>>)
			create Curl_handler_dummy.make
		end

feature {ANY} -- attributes

	protocols: CE_ARRAY [CE_POINTER [PD_CURL_HANDLER]]

	Curl_handler_dummy: PD_CURL_HANDLER

feature {ANY} -- routines

	Curl_safefree (a_ptr: CE_POINTER [ANY])
		do
			if ((a_ptr).c_pointer /= default_pointer) then
				easy_inst.Curl_cfree.call ([a_ptr])
			end
		end

	close_connections (a_data: CE_POINTER [PD_SESSIONHANDLE])
		local
			l_i: INTEGER_32
			js: JUMP_STATE
		do
			from
			until
				js.loop_left
			loop
				js.reset
				l_i := ConnectionKillOne (a_data)
				if l_i = -1 then
					js.break
				end
			end
			js.reset
		end

	Curl_freeset (a_data: CE_POINTER [PD_SESSIONHANDLE])
		local
			l_i: INTEGER_32
		do
			l_i := {PC_DUPSTRING}.STRING_CERT
			from
			until
				not (l_i.to_natural_32 < {NATURAL_32} 37)
			loop
				Curl_safefree (create {CE_POINTER [ANY]}.make_cast (a_data.item.set.str[l_i]))
				l_i := (l_i.to_natural_32 + {NATURAL_32} 1).to_integer_32
			end
		end

	setstropt (a_charp: CE_POINTER [CE_POINTER [INTEGER_8]]; a_s: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_s: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_s.make

			l_s.ce_gets (a_s)
			if ((a_charp.item).c_pointer /= default_pointer) then
				easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (a_charp.item)])
				a_charp.item := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			end
			if ((l_s).c_pointer /= default_pointer) then
				l_s.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast (easy_inst.Curl_cstrdup.pointer_item ([l_s])))
				if (l_s).c_pointer = default_pointer then
					Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
					js.return
				end
				if not js.return_called then
					a_charp.item := l_s
				end
			end
			if not js.return_called then
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	setstropt_userpwd (a_option: CE_POINTER [INTEGER_8]; a_user_storage: CE_POINTER [CE_POINTER [INTEGER_8]]; a_pwd_storage: CE_POINTER [CE_POINTER [INTEGER_8]]): INTEGER_32
		local
			l_separator: CE_POINTER [INTEGER_8]
			l_result: INTEGER_32
			l_p: CE_POINTER [INTEGER_8]
			l_username_len: NATURAL_32
			js: JUMP_STATE
		do
			create l_separator.make
			create l_p.make

			l_result := {PC_CURLCODE}.CURLE_OK
			if (a_option).c_pointer = default_pointer then
				Curl_safefree (create {CE_POINTER [ANY]}.make_cast (a_user_storage.item))
				a_user_storage.item := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
				Curl_safefree (create {CE_POINTER [ANY]}.make_cast (a_pwd_storage.item))
				a_pwd_storage.item := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
				Result := ({PC_CURLCODE}.CURLE_OK)
				js.return
			end
			if not js.return_called then
				l_separator.ce_gets (strchr (a_option, (':').code))
				if (l_separator.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					l_username_len := (l_separator.distance (a_option)).to_natural_32
					l_p.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_cmalloc.pointer_item ([l_username_len + {NATURAL_32} 1])))))
					if (l_p).c_pointer = default_pointer then
						l_result := {PC_CURLCODE}.CURLE_OUT_OF_MEMORY
					else
						memcpy (create {CE_POINTER [ANY]}.make_cast (l_p), create {CE_POINTER [ANY]}.make_cast (a_option), l_username_len).do_nothing
						l_p[l_username_len.to_integer_32] := (('%/0/').code).to_integer_8
						Curl_safefree (create {CE_POINTER [ANY]}.make_cast (a_user_storage.item))
						a_user_storage.item := l_p
					end
					if l_result.to_natural_32 = {NATURAL_32} 0 then
						l_result := setstropt (a_pwd_storage, l_separator + 1)
					end
				else
					l_result := setstropt (a_user_storage, a_option)
				end
				Result := l_result
			end
		end

	Curl_dupset (a_dst: CE_POINTER [PD_SESSIONHANDLE]; a_src: CE_POINTER [PD_SESSIONHANDLE]): INTEGER_32
		local
			l_r: INTEGER_32
			l_i: INTEGER_32
			js: JUMP_STATE
		do
			l_r := {PC_CURLCODE}.CURLE_OK
			a_dst.item.set := a_src.item.set
			memset (create {CE_POINTER [ANY]}.make_cast ((a_dst.item.set.str)), 0, {NATURAL_32} 37 * Pointer_bytes.to_natural_32).do_nothing
			l_i := {PC_DUPSTRING}.STRING_CERT
			from
			until
				not (not js.loop_left and then (l_i.to_natural_32 < {NATURAL_32} 37))
			loop
				js.reset
				l_r := setstropt (a_dst.item.set.str + l_i, a_src.item.set.str[l_i])
				if l_r.to_natural_32 /= {NATURAL_32} 0 then
					js.break
				end
				if not js.loop_jumped then
					l_i := (l_i.to_natural_32 + {NATURAL_32} 1).to_integer_32
				end
			end
			js.reset
			Result := l_r
		end

	flush_cookies (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_cleanup: INTEGER_32)
		do
			if ((a_data.item.set.str[3]).c_pointer /= default_pointer) then
				if ((a_data.item.change.cookielist).c_pointer /= default_pointer) then
					cookie_inst.Curl_cookie_loadfiles (a_data)
				end
				share_inst.Curl_share_lock (a_data, {PC_CURL_LOCK_DATA}.CURL_LOCK_DATA_COOKIE, {PC_CURL_LOCK_ACCESS}.CURL_LOCK_ACCESS_SINGLE).do_nothing
				if (cookie_inst.Curl_cookie_output (a_data.item.cookies, a_data.item.set.str[3])).to_boolean then
					sendf_inst.Curl_infof ([a_data, ce_string ("WARNING: failed to save cookies in %%s%N"), a_data.item.set.str[3]])
				end
			else
				if a_cleanup.to_boolean then
					if ((a_data.item.change.cookielist).c_pointer /= default_pointer) then
						slist_inst.curl_slist_free_all (a_data.item.change.cookielist)
					end
				end
				share_inst.Curl_share_lock (a_data, {PC_CURL_LOCK_DATA}.CURL_LOCK_DATA_COOKIE, {PC_CURL_LOCK_ACCESS}.CURL_LOCK_ACCESS_SINGLE).do_nothing
			end
			if a_cleanup.to_boolean then
				if (a_data.item.share).c_pointer = default_pointer then
					cookie_inst.Curl_cookie_cleanup (a_data.item.cookies)
				elseif ((a_data.item.cookies).c_pointer.to_integer_32).to_natural_32 /= (((a_data.item.share).item.cookies).c_pointer.to_integer_32).to_natural_32 then
					cookie_inst.Curl_cookie_cleanup (a_data.item.cookies)
				end
			end
			share_inst.Curl_share_unlock (a_data, {PC_CURL_LOCK_DATA}.CURL_LOCK_DATA_COOKIE).do_nothing
		end

	Curl_close (a_data: CE_POINTER [PD_SESSIONHANDLE]): INTEGER_32
		local
			l_m: CE_POINTER [PD_CURL_MULTI]
			js: JUMP_STATE
		do
			create l_m.make

			l_m.ce_gets (a_data.item.multi)
			multi_inst.Curl_expire (a_data, 0)
			if ((l_m).c_pointer /= default_pointer) then
				multi_inst.curl_multi_remove_handle (create {CE_POINTER [ANY]}.make_cast (a_data.item.multi), create {CE_POINTER [ANY]}.make_cast (a_data)).do_nothing
			end
			if ((a_data.item.state.timeoutlist).c_pointer /= default_pointer) then
				llist_inst.Curl_llist_destroy (a_data.item.state.timeoutlist, create {CE_POINTER [ANY]}.make_shared (default_pointer))
				a_data.item.state.timeoutlist := create {CE_POINTER [PD_CURL_LLIST]}.make_shared (default_pointer)
			end
			a_data.item.magic := {NATURAL_32} 0
			if ((a_data.item.state.connc).c_pointer /= default_pointer) then
				if ((a_data.item.state.connc).item.type).to_natural_32 = {NATURAL_32} 0 then
					close_connections (a_data)
					Curl_rm_connc (a_data.item.state.connc)
				end
			end
			if ((a_data.item.state.shared_conn).c_pointer /= default_pointer) then
				a_data.item.state.closed := (1).to_boolean
				Result := ({PC_CURLCODE}.CURLE_OK)
				js.return
			end
			if not js.return_called then
				if (a_data.item.dns.hostcachetype).to_natural_32 = {NATURAL_32} 1 then
					hash_inst.Curl_hash_destroy (a_data.item.dns.hostcache)
					a_data.item.dns.hostcachetype := {PC_HOSTCACHETYPE}.HCACHE_NONE
					a_data.item.dns.hostcache := create {CE_POINTER [PD_CURL_HASH]}.make_shared (default_pointer)
				end
				if a_data.item.state.rangestringalloc then
					easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (a_data.item.state.range)])
				end
				Curl_safefree (create {CE_POINTER [ANY]}.make_cast (a_data.item.state.pathbuffer))
				Curl_safefree (a_data.item.state.proto.generic)
				Curl_safefree (create {CE_POINTER [ANY]}.make_cast (a_data.item.state.first_host))
				Curl_safefree (create {CE_POINTER [ANY]}.make_cast (a_data.item.state.scratch))
				if a_data.item.change.referer_alloc then
					easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (a_data.item.change.referer)])
				end
				if a_data.item.change.url_alloc then
					easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (a_data.item.change.url)])
				end
				Curl_safefree (create {CE_POINTER [ANY]}.make_cast (a_data.item.state.headerbuff))
				flush_cookies (a_data, 1)
				http_digest_inst.Curl_digest_cleanup (a_data)
				Curl_safefree (create {CE_POINTER [ANY]}.make_cast (a_data.item.info.contenttype))
				Curl_safefree (create {CE_POINTER [ANY]}.make_cast (a_data.item.info.wouldredirect))
				if ((a_data.item.share).c_pointer /= default_pointer) then
					share_inst.Curl_share_lock (a_data, {PC_CURL_LOCK_DATA}.CURL_LOCK_DATA_SHARE, {PC_CURL_LOCK_ACCESS}.CURL_LOCK_ACCESS_SINGLE).do_nothing;
					(a_data.item.share).item.dirty := (a_data.item.share).item.dirty - (1).to_natural_32
					share_inst.Curl_share_unlock (a_data, {PC_CURL_LOCK_DATA}.CURL_LOCK_DATA_SHARE).do_nothing
				end
				Curl_freeset (a_data)
				easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (a_data)])
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	Curl_mk_connc (a_type: INTEGER_32; a_amount: INTEGER_32): CE_POINTER [PD_CONNCACHE]
		local
			l_c: CE_POINTER [PD_CONNCACHE]
			l_default_amount: INTEGER_32
			l_max_amount: INTEGER_32
			js: JUMP_STATE
		do
			create l_c.make

			l_max_amount := ({NATURAL_32} 2147483647 // Pointer_bytes.to_natural_32).to_integer_32
			if a_type = 0 then
				if a_amount < 1 then
					l_default_amount := 5
				else
					l_default_amount := a_amount
				end
			elseif a_amount < 1 then
				l_default_amount := 10
			else
				l_default_amount := a_amount
			end
			if l_default_amount > l_max_amount then
				l_default_amount := l_max_amount
			end
			l_c.ce_gets (create {CE_POINTER [PD_CONNCACHE]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_ccalloc.pointer_item ([(1).to_natural_32, {PD_CONNCACHE}.sizeof.to_natural_32])))))
			if (l_c).c_pointer = default_pointer then
				Result := (create {CE_POINTER [PD_CONNCACHE]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				l_c.item.connects := create {CE_POINTER [CE_POINTER [PD_CONNECTDATA]]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_ccalloc.pointer_item ([l_default_amount.to_natural_32, Pointer_bytes.to_natural_32]))))
				if (l_c.item.connects).c_pointer = default_pointer then
					easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_c)])
					Result := (create {CE_POINTER [PD_CONNCACHE]}.make_shared (default_pointer))
					js.return
				end
			end
			if not js.return_called then
				l_c.item.num := l_default_amount
				Result := l_c
			end
		end

	Curl_ch_connc (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_c: CE_POINTER [PD_CONNCACHE]; a_newamount: INTEGER_32): INTEGER_32
		local
			l_newamount: INTEGER_32
			l_i: INTEGER_32
			l_newptr: CE_POINTER [CE_POINTER [PD_CONNECTDATA]]
			l_max_amount: INTEGER_32
			js: JUMP_STATE
		do
			create l_newptr.make

			l_newamount := a_newamount
			l_max_amount := ({NATURAL_32} 2147483647 // Pointer_bytes.to_natural_32).to_integer_32
			if l_newamount < 1 then
				l_newamount := 1
			end
			if (a_c).c_pointer = default_pointer then
				a_data.item.state.connc := Curl_mk_connc (0, l_newamount)
				if (a_data.item.state.connc).c_pointer = default_pointer then
					Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
					js.return
				end
				if not js.return_called then
					Result := ({PC_CURLCODE}.CURLE_OK)
					js.return
				end
			end
			if not js.return_called then
				if l_newamount < a_c.item.num then
					l_i := l_newamount
					from
					until
						not (l_i < a_c.item.num)
					loop
						Curl_disconnect (a_c.item.connects[l_i]).do_nothing
						l_i := l_i + 1
					end
					if a_data.item.state.lastconnect <= l_newamount then
						a_data.item.state.lastconnect := -1
					end
				end
				if l_newamount > 0 then
					if l_newamount > l_max_amount then
						l_newamount := l_max_amount
					end
					l_newptr.ce_gets (create {CE_POINTER [CE_POINTER [PD_CONNECTDATA]]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_crealloc.pointer_item ([create {CE_POINTER [ANY]}.make_cast (a_c.item.connects), ((Pointer_bytes.to_natural_32).to_natural_32 * l_newamount.to_natural_32).to_natural_32])))))
					if (l_newptr).c_pointer = default_pointer then
						Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
						js.return
					end
					if not js.return_called then
						l_i := a_c.item.num
						from
						until
							not (l_i < l_newamount)
						loop
							l_newptr[l_i] := create {CE_POINTER [PD_CONNECTDATA]}.make_shared (default_pointer)
							l_i := l_i + 1
						end
						a_c.item.connects := l_newptr
						a_c.item.num := l_newamount
					end
				end
			end
			if not js.return_called then
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	Curl_rm_connc (a_c: CE_POINTER [PD_CONNCACHE])
		local
			l_i: INTEGER_32
		do
			if ((a_c.item.connects).c_pointer /= default_pointer) then
				l_i := 0
				from
				until
					not (l_i < a_c.item.num)
				loop
					conn_free (a_c.item.connects[l_i])
					l_i := l_i + 1
				end
				easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (a_c.item.connects)])
			end
			easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (a_c)])
		end

	Curl_init_userdefined (a_set: CE_POINTER [PD_USERDEFINED]): INTEGER_32
		local
			l_res: INTEGER_32
		do
			l_res := {PC_CURLCODE}.CURLE_OK
			a_set.item.out2 := create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.output.file_pointer)))
			a_set.item.in := create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.input.file_pointer)))
			a_set.item.err := (create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.error.file_pointer))
			a_set.item.fwrite_func := (fwrite_address)
			a_set.item.fread_func := (fread_address)
			a_set.item.is_fread_set := 0
			a_set.item.is_fwrite_set := 0
			a_set.item.seek_func := create {CE_ROUTINE}.make_shared (default_pointer)
			a_set.item.seek_client := create {CE_POINTER [ANY]}.make_shared (default_pointer)
			a_set.item.convfromnetwork := create {CE_ROUTINE}.make_shared (default_pointer)
			a_set.item.convtonetwork := create {CE_ROUTINE}.make_shared (default_pointer)
			a_set.item.convfromutf8 := create {CE_ROUTINE}.make_shared (default_pointer)
			a_set.item.infilesize := (-1).to_integer_64
			a_set.item.postfieldsize := (-1).to_integer_64
			a_set.item.maxredirs := -1
			a_set.item.httpreq := {PC_CURL_HTTPREQ}.HTTPREQ_GET
			a_set.item.rtspreq := {PC_CURL_RTSPREQ}.RTSPREQ_OPTIONS
			a_set.item.ftp_use_epsv := (1).to_boolean
			a_set.item.ftp_use_eprt := (1).to_boolean
			a_set.item.ftp_use_pret := (0).to_boolean
			a_set.item.ftp_filemethod := {PC_CURL_FTPFILE}.FTPFILE_MULTICWD
			a_set.item.dns_cache_timeout := 60
			a_set.item.ssl.numsessions := 5
			a_set.item.proxyport := 1080
			a_set.item.proxytype := {PC_CURL_PROXYTYPE}.CURLPROXY_HTTP
			a_set.item.httpauth := 1
			a_set.item.proxyauth := 1
			a_set.item.hide_progress := (1).to_boolean
			a_set.item.ssl.verifypeer := 1
			a_set.item.ssl.verifyhost := 2
			a_set.item.ssh_auth_types := ((0).bit_not).to_integer_32
			a_set.item.ssl.sessionid := (1).to_boolean
			a_set.item.new_file_perms := 420
			a_set.item.new_directory_perms := 493
			a_set.item.allowed_protocols := 67108863
			a_set.item.redir_protocols := ((67108863).bit_and ((((((1).bit_shift_left (10))).bit_or (((1).bit_shift_left (4))))).bit_not)).to_integer_32
			a_set.item.wildcardmatch := (0).to_boolean
			a_set.item.chunk_bgn := create {CE_ROUTINE}.make_shared (default_pointer)
			a_set.item.chunk_end := create {CE_ROUTINE}.make_shared (default_pointer)
			Result := l_res
		end

	Curl_open (a_curl: CE_POINTER [CE_POINTER [PD_SESSIONHANDLE]]): INTEGER_32
		local
			l_res: INTEGER_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			js: JUMP_STATE
		do
			create l_data.make

			l_res := {PC_CURLCODE}.CURLE_OK
			l_data.ce_gets (create {CE_POINTER [PD_SESSIONHANDLE]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_ccalloc.pointer_item ([(1).to_natural_32, {PD_SESSIONHANDLE}.sizeof.to_natural_32])))))
			if (l_data).c_pointer = default_pointer then
				Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
				js.return
			end
			if not js.return_called then
				l_data.item.magic := {NATURAL_32} 3235830701
				l_data.item.state.headerbuff := create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_cmalloc.pointer_item ([(256).to_natural_32]))))
				if (l_data.item.state.headerbuff).c_pointer = default_pointer then
					l_res := {PC_CURLCODE}.CURLE_OUT_OF_MEMORY
				else
					easy_inst.Curl_easy_initHandleData (l_data)
					l_res := Curl_init_userdefined (create {CE_POINTER [PD_USERDEFINED]}.make_shared (l_data.c_pointer + {PD_SESSIONHANDLE}.set_offset))
					l_data.item.state.headersize := (256).to_natural_32
					l_data.item.state.lastconnect := -1
					l_data.item.progress.flags := (l_data.item.progress.flags).bit_or (((1).bit_shift_left (4)))
					l_data.item.state.current_speed := (-1).to_integer_64
					l_data.item.wildcard.state := {PC_CURL_WILDCARD_STATES}.CURLWC_INIT
					l_data.item.wildcard.filelist := create {CE_POINTER [PD_CURL_LLIST]}.make_shared (default_pointer)
					l_data.item.set.fnmatch := create {CE_ROUTINE}.make_shared (default_pointer)
				end
				if l_res.to_boolean then
					if ((l_data.item.state.headerbuff).c_pointer /= default_pointer) then
						easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_data.item.state.headerbuff)])
					end
					Curl_freeset (l_data)
					easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_data)])
					l_data.ce_gets (create {CE_POINTER [PD_SESSIONHANDLE]}.make_shared (default_pointer))
				else
					a_curl.item := l_data
				end
				Result := l_res
			end
		end

	Curl_setopt (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_option: INTEGER_32; a_param: CE_VA_LIST): INTEGER_32
		local
			l_param: CE_VA_LIST
			l_argptr: CE_POINTER [INTEGER_8]
			l_result: INTEGER_32
			l_bigsize: INTEGER_64
			l_use_cache: INTEGER_32
			l_tmp___24: CE_POINTER [INTEGER_8]
			l_postRedir: INTEGER_32
			l_tmp___28: INTEGER_32
			l_tmp___29: INTEGER_32
			l_p: CE_POINTER [INTEGER_8]
			l_tmp___31: INTEGER_64
			l_cl: CE_POINTER [PD_CURL_SLIST]
			l_auth: INTEGER_32
			l_tmp___46: INTEGER_32
			l_auth___0: INTEGER_32
			l_tmp___50: INTEGER_32
			l_set: CE_POINTER [PD_CURL_SHARE]
			l_curl_rtspreq: INTEGER_32
			l_rtspreq: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_argptr.make
			create l_tmp___24.make
			create l_p.make
			create l_cl.make
			create l_set.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					create l_param.make_copy (a_param)
					l_result := {PC_CURLCODE}.CURLE_OK
					inspect a_option -- switch 1 head
					when 92 then l_pos := -1 + 1
					when 91 then l_pos := -1 + 2
					when 10083 then l_pos := -1 + 3
					when 10076 then l_pos := -1 + 4
					when 10077 then l_pos := -1 + 5
					when 71 then l_pos := -1 + 6
					when 75 then l_pos := -1 + 7
					when 74 then l_pos := -1 + 8
					when 41 then l_pos := -1 + 9
					when 42 then l_pos := -1 + 10
					when 43 then l_pos := -1 + 11
					when 44 then l_pos := -1 + 12
					when 45 then l_pos := -1 + 13
					when 46 then l_pos := -1 + 14
					when 54 then l_pos := -1 + 14
					when 69 then l_pos := -1 + 15
					when 110 then l_pos := -1 + 16
					when 112 then l_pos := -1 + 17
					when 178 then l_pos := -1 + 18
					when 48 then l_pos := -1 + 19
					when 50 then l_pos := -1 + 20
					when 138 then l_pos := -1 + 21
					when 51 then l_pos := -1 + 22
					when 10118 then l_pos := -1 + 23
					when 53 then l_pos := -1 + 24
					when 33 then l_pos := -1 + 25
					when 34 then l_pos := -1 + 26
					when 32 then l_pos := -1 + 27
					when 58 then l_pos := -1 + 28
					when 10102 then l_pos := -1 + 29
					when 52 then l_pos := -1 + 30
					when 105 then l_pos := -1 + 31
					when 68 then l_pos := -1 + 32
					when 161 then l_pos := -1 + 33
					when 47 then l_pos := -1 + 34
					when 10165 then l_pos := -1 + 35
					when 10015 then l_pos := -1 + 49
					when 60 then l_pos := -1 + 50
					when 30120 then l_pos := -1 + 51
					when 10024 then l_pos := -1 + 52
					when 10016 then l_pos := -1 + 53
					when 10018 then l_pos := -1 + 54
					when 10023 then l_pos := -1 + 55
					when 10104 then l_pos := -1 + 56
					when 10022 then l_pos := -1 + 57
					when 10031 then l_pos := -1 + 58
					when 10082 then l_pos := -1 + 59
					when 96 then l_pos := -1 + 60
					when 10135 then l_pos := -1 + 61
					when 80 then l_pos := -1 + 65
					when 84 then l_pos := -1 + 66
					when 107 then l_pos := -1 + 67
					when 10036 then l_pos := -1 + 68
					when 61 then l_pos := -1 + 69
					when 59 then l_pos := -1 + 70
					when 111 then l_pos := -1 + 71
					when 10004 then l_pos := -1 + 72
					when 101 then l_pos := -1 + 73
					when 166 then l_pos := -1 + 74
					when 10029 then l_pos := -1 + 79
					when 10010 then l_pos := -1 + 80
					when 10001 then l_pos := -1 + 81
					when 10017 then l_pos := -1 + 82
					when 106 then l_pos := -1 + 83
					when 85 then l_pos := -1 + 84
					when 188 then l_pos := -1 + 85
					when 154 then l_pos := -1 + 86
					when 137 then l_pos := -1 + 87
					when 10009 then l_pos := -1 + 88
					when 14 then l_pos := -1 + 89
					when 30115 then l_pos := -1 + 90
					when 19 then l_pos := -1 + 91
					when 30145 then l_pos := -1 + 92
					when 30146 then l_pos := -1 + 93
					when 20 then l_pos := -1 + 94
					when 10002 then l_pos := -1 + 95
					when 3 then l_pos := -1 + 96
					when 13 then l_pos := -1 + 97
					when 155 then l_pos := -1 + 98
					when 78 then l_pos := -1 + 99
					when 156 then l_pos := -1 + 100
					when 10005 then l_pos := -1 + 101
					when 10173 then l_pos := -1 + 102
					when 10174 then l_pos := -1 + 103
					when 10039 then l_pos := -1 + 104
					when 10093 then l_pos := -1 + 105
					when 10028 then l_pos := -1 + 106
					when 20056 then l_pos := -1 + 107
					when 10057 then l_pos := -1 + 108
					when 10006 then l_pos := -1 + 109
					when 10175 then l_pos := -1 + 110
					when 10176 then l_pos := -1 + 111
					when 10177 then l_pos := -1 + 112
					when 10007 then l_pos := -1 + 113
					when 21 then l_pos := -1 + 114
					when 30116 then l_pos := -1 + 115
					when 20094 then l_pos := -1 + 116
					when 10095 then l_pos := -1 + 117
					when 10037 then l_pos := -1 + 118
					when 20079 then l_pos := -1 + 119
					when 20011 then l_pos := -1 + 120
					when 20012 then l_pos := -1 + 121
					when 20167 then l_pos := -1 + 122
					when 10168 then l_pos := -1 + 123
					when 20142 then l_pos := -1 + 124
					when 20143 then l_pos := -1 + 125
					when 20144 then l_pos := -1 + 126
					when 20130 then l_pos := -1 + 127
					when 10131 then l_pos := -1 + 128
					when 10025 then l_pos := -1 + 129
					when 10086 then l_pos := -1 + 130
					when 10087 then l_pos := -1 + 131
					when 10088 then l_pos := -1 + 132
					when 10026 then l_pos := -1 + 133
					when 10089 then l_pos := -1 + 134
					when 90 then l_pos := -1 + 135
					when 27 then l_pos := -1 + 136
					when 10062 then l_pos := -1 + 137
					when 139 then l_pos := -1 + 138
					when 140 then l_pos := -1 + 139
					when 10063 then l_pos := -1 + 140
					when 64 then l_pos := -1 + 141
					when 81 then l_pos := -1 + 142
					when 10065 then l_pos := -1 + 143
					when 10097 then l_pos := -1 + 144
					when 10169 then l_pos := -1 + 145
					when 10170 then l_pos := -1 + 146
					when 10070 then l_pos := -1 + 147
					when 98 then l_pos := -1 + 148
					when 99 then l_pos := -1 + 149
					when 10100 then l_pos := -1 + 150
					when 10103 then l_pos := -1 + 151
					when 114 then l_pos := -1 + 152
					when 119 then l_pos := -1 + 153
					when 129 then l_pos := -1 + 154
					when 113 then l_pos := -1 + 155
					when 30117 then l_pos := -1 + 156
					when 121 then l_pos := -1 + 157
					when 10134 then l_pos := -1 + 158
					when 136 then l_pos := -1 + 159
					when 141 then l_pos := -1 + 160
					when 10147 then l_pos := -1 + 161
					when 20148 then l_pos := -1 + 162
					when 10149 then l_pos := -1 + 163
					when 20163 then l_pos := -1 + 164
					when 10164 then l_pos := -1 + 165
					when 150 then l_pos := -1 + 166
					when 157 then l_pos := -1 + 167
					when 158 then l_pos := -1 + 168
					when 159 then l_pos := -1 + 169
					when 160 then l_pos := -1 + 170
					when 171 then l_pos := -1 + 171
					when 181 then l_pos := -1 + 172
					when 182 then l_pos := -1 + 173
					when 10186 then l_pos := -1 + 174
					when 10187 then l_pos := -1 + 175
					when 189 then l_pos := -1 + 176
					when 10190 then l_pos := -1 + 190
					when 10191 then l_pos := -1 + 191
					when 10192 then l_pos := -1 + 192
					when 193 then l_pos := -1 + 193
					when 194 then l_pos := -1 + 194
					when 10195 then l_pos := -1 + 195
					when 20196 then l_pos := -1 + 196
					when 197 then l_pos := -1 + 197
					when 20198 then l_pos := -1 + 198
					when 20199 then l_pos := -1 + 199
					when 20200 then l_pos := -1 + 200
					when 10201 then l_pos := -1 + 201
					when 10202 then l_pos := -1 + 202
					else l_pos := -1 + 203
					end
				when 1 then -- switch 1, case 92
					a_data.item.set.dns_cache_timeout := l_param.integer_32_item
					l_pos := -1 + 204 -- switch 1; break
				when 2 then -- switch 1, case 91
					l_use_cache := (l_param.integer_32_item)
					a_data.item.set.global_dns_cache := (0 /= l_use_cache)
					l_pos := -1 + 204 -- switch 1; break
				when 3 then -- switch 1, case 10083
					l_result := setstropt (a_data.item.set.str + 22, (create {CE_POINTER [INTEGER_8]}.make_cast (l_param.pointer_item)))
					l_pos := -1 + 204 -- switch 1; break
				when 4 then -- switch 1, case 10076
					l_result := setstropt (a_data.item.set.str + 24, (create {CE_POINTER [INTEGER_8]}.make_cast (l_param.pointer_item)))
					l_pos := -1 + 204 -- switch 1; break
				when 5 then -- switch 1, case 10077
					l_result := setstropt (a_data.item.set.str + 23, (create {CE_POINTER [INTEGER_8]}.make_cast (l_param.pointer_item)))
					l_pos := -1 + 204 -- switch 1; break
				when 6 then -- switch 1, case 71
					l_result := Curl_ch_connc (a_data, a_data.item.state.connc, (l_param.integer_32_item))
					l_pos := -1 + 204 -- switch 1; break
				when 7 then -- switch 1, case 75
					a_data.item.set.reuse_forbid := (0 /= (l_param.integer_32_item))
					l_pos := -1 + 204 -- switch 1; break
				when 8 then -- switch 1, case 74
					a_data.item.set.reuse_fresh := (0 /= (l_param.integer_32_item))
					l_pos := -1 + 204 -- switch 1; break
				when 9 then -- switch 1, case 41
					a_data.item.set.verbose := (0 /= (l_param.integer_32_item))
					l_pos := -1 + 204 -- switch 1; break
				when 10 then -- switch 1, case 42
					a_data.item.set.include_header := (0 /= (l_param.integer_32_item))
					l_pos := -1 + 204 -- switch 1; break
				when 11 then -- switch 1, case 43
					a_data.item.set.hide_progress := (0 /= (l_param.integer_32_item))
					if a_data.item.set.hide_progress then
						a_data.item.progress.flags := (a_data.item.progress.flags).bit_or (((1).bit_shift_left (4)))
					else
						a_data.item.progress.flags := (a_data.item.progress.flags).bit_and (((((1).bit_shift_left (4))).bit_not))
					end
					l_pos := -1 + 204 -- switch 1; break
				when 12 then -- switch 1, case 44
					a_data.item.set.opt_no_body := (0 /= (l_param.integer_32_item))
					l_pos := -1 + 204 -- switch 1; break
				when 13 then -- switch 1, case 45
					a_data.item.set.http_fail_on_error := (0 /= (l_param.integer_32_item))
					l_pos := -1 + 204 -- switch 1; break
				when 14 then -- switch 1, case 46 | switch 1, case 54
					a_data.item.set.upload := (0 /= (l_param.integer_32_item))
					if a_data.item.set.upload then
						a_data.item.set.httpreq := {PC_CURL_HTTPREQ}.HTTPREQ_PUT
						a_data.item.set.opt_no_body := (0).to_boolean
					else
						a_data.item.set.httpreq := {PC_CURL_HTTPREQ}.HTTPREQ_GET
					end
					l_pos := -1 + 204 -- switch 1; break
				when 15 then -- switch 1, case 69
					a_data.item.set.get_filetime := (0 /= (l_param.integer_32_item))
					l_pos := -1 + 204 -- switch 1; break
				when 16 then -- switch 1, case 110
					a_data.item.set.ftp_create_missing_dirs := (l_param.integer_32_item).to_integer_32
					l_pos := -1 + 204 -- switch 1; break
				when 17 then -- switch 1, case 112
					a_data.item.set.server_response_timeout := (l_param.integer_32_item) * 1000
					l_pos := -1 + 204 -- switch 1; break
				when 18 then -- switch 1, case 178
					a_data.item.set.tftp_blksize := l_param.integer_32_item
					l_pos := -1 + 204 -- switch 1; break
				when 19 then -- switch 1, case 48
					a_data.item.set.ftp_list_only := (0 /= (l_param.integer_32_item))
					l_pos := -1 + 204 -- switch 1; break
				when 20 then -- switch 1, case 50
					a_data.item.set.ftp_append := (0 /= (l_param.integer_32_item))
					l_pos := -1 + 204 -- switch 1; break
				when 21 then -- switch 1, case 138
					a_data.item.set.ftp_filemethod := (l_param.integer_32_item).to_integer_32
					l_pos := -1 + 204 -- switch 1; break
				when 22 then -- switch 1, case 51
					a_data.item.set.use_netrc := (l_param.integer_32_item).to_integer_32
					l_pos := -1 + 204 -- switch 1; break
				when 23 then -- switch 1, case 10118
					l_result := setstropt (a_data.item.set.str + 14, (create {CE_POINTER [INTEGER_8]}.make_cast (l_param.pointer_item)))
					l_pos := -1 + 204 -- switch 1; break
				when 24 then -- switch 1, case 53
					a_data.item.set.prefer_ascii := (0 /= (l_param.integer_32_item))
					l_pos := -1 + 204 -- switch 1; break
				when 25 then -- switch 1, case 33
					a_data.item.set.timecondition := (l_param.integer_32_item).to_integer_32
					l_pos := -1 + 204 -- switch 1; break
				when 26 then -- switch 1, case 34
					a_data.item.set.timevalue := (l_param.integer_32_item)
					l_pos := -1 + 204 -- switch 1; break
				when 27 then -- switch 1, case 32
					a_data.item.set.ssl.version := l_param.integer_32_item
					l_pos := -1 + 204 -- switch 1; break
				when 28 then -- switch 1, case 58
					a_data.item.set.http_auto_referer := (0 /= (l_param.integer_32_item))
					l_pos := -1 + 204 -- switch 1; break
				when 29 then -- switch 1, case 10102
					l_argptr.ce_gets ((create {CE_POINTER [INTEGER_8]}.make_cast (l_param.pointer_item)))
					if ((l_argptr).c_pointer /= default_pointer) then
						if not (l_argptr[0]).to_boolean then
							l_tmp___24.ce_gets (ce_string ("identity"))
						else
							l_tmp___24.ce_gets (l_argptr)
						end
					else
						l_tmp___24.ce_gets (l_argptr)
					end
					l_result := setstropt (a_data.item.set.str + 6, l_tmp___24)
					l_pos := -1 + 204 -- switch 1; break
				when 30 then -- switch 1, case 52
					a_data.item.set.http_follow_location := (0 /= (l_param.integer_32_item))
					l_pos := -1 + 204 -- switch 1; break
				when 31 then -- switch 1, case 105
					a_data.item.set.http_disable_hostname_check_before_authentication := (0 /= (l_param.integer_32_item))
					l_pos := -1 + 204 -- switch 1; break
				when 32 then -- switch 1, case 68
					a_data.item.set.maxredirs := l_param.integer_32_item
					l_pos := -1 + 204 -- switch 1; break
				when 33 then -- switch 1, case 161
					l_postRedir := (l_param.integer_32_item)
					if ((l_postRedir).bit_and (1)).to_boolean then
						l_tmp___28 := 1
					else
						l_tmp___28 := 0
					end
					a_data.item.set.post301 := l_tmp___28.to_boolean
					if ((l_postRedir).bit_and (2)).to_boolean then
						l_tmp___29 := 1
					else
						l_tmp___29 := 0
					end
					a_data.item.set.post302 := l_tmp___29.to_boolean
					l_pos := -1 + 204 -- switch 1; break
				when 34 then -- switch 1, case 47
					if (l_param.integer_32_item).to_boolean then
						a_data.item.set.httpreq := {PC_CURL_HTTPREQ}.HTTPREQ_POST
						a_data.item.set.opt_no_body := (0).to_boolean
					else
						a_data.item.set.httpreq := {PC_CURL_HTTPREQ}.HTTPREQ_GET
					end
					l_pos := -1 + 204 -- switch 1; break
				when 35 then -- switch 1, case 10165
					l_argptr.ce_gets ((create {CE_POINTER [INTEGER_8]}.make_cast (l_param.pointer_item)))
					if ((l_argptr).c_pointer /= default_pointer) then
						l_pos := -1 + 38 -- skip if block
					end
				when 36 then -- if:
						l_result := setstropt (a_data.item.set.str + 15, l_argptr)
				when 37 then -- if block done, skip else block:
						l_pos := -1 + 48
				when 38 then -- else:
						if a_data.item.set.postfieldsize /= -{INTEGER_64} 1 then
							l_pos := -1 + 41 -- skip if block
						end
				when 39 then -- if:
						l_result := setstropt (a_data.item.set.str + 15, l_argptr)
				when 40 then -- if block done, skip else block:
						l_pos := -1 + 48
				when 41 then -- else:
						if not (a_data.item.set.postfieldsize < {INTEGER_64} 0) then
							l_pos := -1 + 44 -- skip if block
						end
				when 42 then -- if:
						l_result := {PC_CURLCODE}.CURLE_OUT_OF_MEMORY
				when 43 then -- if block done, skip else block:
						l_pos := -1 + 48
				when 44 then -- else:
						if Integer_64_bytes.to_natural_32 = Natural_32_bytes.to_natural_32 then
							l_pos := -1 + 47 -- skip if block
						end
				when 45 then -- if:
						if a_data.item.set.postfieldsize > {INTEGER_64} 4294967295 then
							l_result := {PC_CURLCODE}.CURLE_OUT_OF_MEMORY
						else
							l_pos := -1 + 47 -- goto _L
						end
				when 46 then -- if block done, skip else block:
						l_pos := -1 + 48
				when 47 then -- else: | _L:
						setstropt (a_data.item.set.str + 15, create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)).do_nothing
						if (a_data.item.set.postfieldsize).to_boolean then
							l_tmp___31 := a_data.item.set.postfieldsize
						else
							l_tmp___31 := (1).to_integer_64
						end
						l_p.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_cmalloc.pointer_item ([l_tmp___31.to_natural_32])))))
						if (l_p).c_pointer = default_pointer then
							l_result := {PC_CURLCODE}.CURLE_OUT_OF_MEMORY
						else
							if (a_data.item.set.postfieldsize).to_boolean then
								memcpy (create {CE_POINTER [ANY]}.make_cast (l_p), create {CE_POINTER [ANY]}.make_cast (l_argptr), (a_data.item.set.postfieldsize).to_natural_32).do_nothing
							end
							a_data.item.set.str[15] := l_p
						end
				when 48 then -- if done | if done | if done
						a_data.item.set.postfields := create {CE_POINTER [ANY]}.make_cast (a_data.item.set.str[15])
						a_data.item.set.httpreq := {PC_CURL_HTTPREQ}.HTTPREQ_POST
						l_pos := -1 + 204 -- switch 1; break
				when 49 then -- switch 1, case 10015
						a_data.item.set.postfields := (create {CE_POINTER [ANY]}.make_cast (l_param.pointer_item))
						setstropt (a_data.item.set.str + 15, create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)).do_nothing
						a_data.item.set.httpreq := {PC_CURL_HTTPREQ}.HTTPREQ_POST
						l_pos := -1 + 204 -- switch 1; break
				when 50 then -- switch 1, case 60
						l_bigsize := l_param.integer_32_item
						if a_data.item.set.postfieldsize < l_bigsize then
							if ((a_data.item.set.postfields).c_pointer.to_integer_32).to_natural_32 = ((a_data.item.set.str[15]).c_pointer.to_integer_32).to_natural_32 then
								setstropt (a_data.item.set.str + 15, create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)).do_nothing
								a_data.item.set.postfields := create {CE_POINTER [ANY]}.make_shared (default_pointer)
							end
						end
						a_data.item.set.postfieldsize := l_bigsize
						l_pos := -1 + 204 -- switch 1; break
				when 51 then -- switch 1, case 30120
						l_bigsize := l_param.integer_64_item
						if a_data.item.set.postfieldsize < l_bigsize then
							if ((a_data.item.set.postfields).c_pointer.to_integer_32).to_natural_32 = ((a_data.item.set.str[15]).c_pointer.to_integer_32).to_natural_32 then
								setstropt (a_data.item.set.str + 15, create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)).do_nothing
								a_data.item.set.postfields := create {CE_POINTER [ANY]}.make_shared (default_pointer)
							end
						end
						a_data.item.set.postfieldsize := l_bigsize
						l_pos := -1 + 204 -- switch 1; break
				when 52 then -- switch 1, case 10024
						a_data.item.set.httppost := (create {CE_POINTER [PD_CURL_HTTPPOST]}.make_cast (l_param.pointer_item))
						a_data.item.set.httpreq := {PC_CURL_HTTPREQ}.HTTPREQ_POST_FORM
						a_data.item.set.opt_no_body := (0).to_boolean
						l_pos := -1 + 204 -- switch 1; break
				when 53 then -- switch 1, case 10016
						if a_data.item.change.referer_alloc then
							easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (a_data.item.change.referer)])
							a_data.item.change.referer_alloc := (0).to_boolean
						end
						l_result := setstropt (a_data.item.set.str + 18, (create {CE_POINTER [INTEGER_8]}.make_cast (l_param.pointer_item)))
						a_data.item.change.referer := a_data.item.set.str[18]
						l_pos := -1 + 204 -- switch 1; break
				when 54 then -- switch 1, case 10018
						l_result := setstropt (a_data.item.set.str + 25, (create {CE_POINTER [INTEGER_8]}.make_cast (l_param.pointer_item)))
						l_pos := -1 + 204 -- switch 1; break
				when 55 then -- switch 1, case 10023
						a_data.item.set.headers := (create {CE_POINTER [PD_CURL_SLIST]}.make_cast (l_param.pointer_item))
						l_pos := -1 + 204 -- switch 1; break
				when 56 then -- switch 1, case 10104
						a_data.item.set.http200aliases := (create {CE_POINTER [PD_CURL_SLIST]}.make_cast (l_param.pointer_item))
						l_pos := -1 + 204 -- switch 1; break
				when 57 then -- switch 1, case 10022
						l_result := setstropt (a_data.item.set.str + 2, (create {CE_POINTER [INTEGER_8]}.make_cast (l_param.pointer_item)))
						l_pos := -1 + 204 -- switch 1; break
				when 58 then -- switch 1, case 10031
						l_argptr.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (l_param.pointer_item))))
						if ((l_argptr).c_pointer /= default_pointer) then
							l_cl.ce_gets (slist_inst.curl_slist_append (a_data.item.change.cookielist, l_argptr))
							if (l_cl).c_pointer = default_pointer then
								Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
								js.return
							end
							if not js.return_called then
								a_data.item.change.cookielist := l_cl
							end
						end
						l_pos := -1 + 204 -- switch 1; break
				when 59 then -- switch 1, case 10082
						l_result := setstropt (a_data.item.set.str + 3, (create {CE_POINTER [INTEGER_8]}.make_cast (l_param.pointer_item)))
						a_data.item.cookies := cookie_inst.Curl_cookie_init (a_data, create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), a_data.item.cookies, a_data.item.set.cookiesession)
						l_pos := -1 + 204 -- switch 1; break
				when 60 then -- switch 1, case 96
						a_data.item.set.cookiesession := (0 /= (l_param.integer_32_item))
						l_pos := -1 + 204 -- switch 1; break
				when 61 then -- switch 1, case 10135
						l_argptr.ce_gets ((create {CE_POINTER [INTEGER_8]}.make_cast (l_param.pointer_item)))
						if (l_argptr.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 204 -- switch 1; break
						end
				when 62 then
						if (rawstr_inst.Curl_raw_equal (l_argptr, ce_string ("ALL"))).to_boolean then
							cookie_inst.Curl_cookie_clearall (a_data.item.cookies)
							l_pos := -1 + 204 -- switch 1; break
						elseif (rawstr_inst.Curl_raw_equal (l_argptr, ce_string ("SESS"))).to_boolean then
							cookie_inst.Curl_cookie_clearsess (a_data.item.cookies)
							l_pos := -1 + 204 -- switch 1; break
						elseif (rawstr_inst.Curl_raw_equal (l_argptr, ce_string ("FLUSH"))).to_boolean then
							flush_cookies (a_data, 0)
							l_pos := -1 + 204 -- switch 1; break
						end
				when 63 then
						if (a_data.item.cookies).c_pointer = default_pointer then
							a_data.item.cookies := cookie_inst.Curl_cookie_init (a_data, create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), create {CE_POINTER [PD_COOKIEINFO]}.make_shared (default_pointer), (1).to_boolean)
						end
						l_argptr.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast (easy_inst.Curl_cstrdup.pointer_item ([l_argptr])))
						if (l_argptr).c_pointer = default_pointer then
							l_result := {PC_CURLCODE}.CURLE_OUT_OF_MEMORY
							l_pos := -1 + 204 -- switch 1; break
						end
				when 64 then
						if (rawstr_inst.Curl_raw_nequal (ce_string ("Set-Cookie:"), l_argptr, (strlen (ce_string ("Set-Cookie:"))))).to_boolean then
							cookie_inst.Curl_cookie_add (a_data, a_data.item.cookies, (1).to_boolean, l_argptr + 11, create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)).do_nothing
						else
							cookie_inst.Curl_cookie_add (a_data, a_data.item.cookies, (0).to_boolean, l_argptr, create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)).do_nothing
						end
						easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_argptr)])
						l_pos := -1 + 204 -- switch 1; break
				when 65 then -- switch 1, case 80
						if (l_param.integer_32_item).to_boolean then
							a_data.item.set.httpreq := {PC_CURL_HTTPREQ}.HTTPREQ_GET
							a_data.item.set.upload := (0).to_boolean
							a_data.item.set.opt_no_body := (0).to_boolean
						end
						l_pos := -1 + 204 -- switch 1; break
				when 66 then -- switch 1, case 84
						a_data.item.set.httpversion := l_param.integer_32_item
						l_pos := -1 + 204 -- switch 1; break
				when 67 then -- switch 1, case 107
						l_auth := (l_param.integer_32_item)
						if ((l_auth).bit_and (((1).bit_shift_left (4)).to_integer_32)).to_boolean then
							l_tmp___46 := 1
						else
							l_tmp___46 := 0
						end
						a_data.item.state.authhost.iestyle := l_tmp___46.to_boolean
						if ((l_auth).bit_and (((1).bit_shift_left (4)).to_integer_32)).to_boolean then
							l_auth := (l_auth).bit_or (((1).bit_shift_left (1)).to_integer_32)
							l_auth := (l_auth).bit_and (((((1).bit_shift_left (4))).bit_not).to_integer_32)
						end
						l_auth := (l_auth).bit_and (((((1).bit_shift_left (3))).bit_not).to_integer_32)
						l_auth := (l_auth).bit_and (((((1).bit_shift_left (2))).bit_not).to_integer_32)
						if not l_auth.to_boolean then
							Result := ({PC_CURLCODE}.CURLE_FAILED_INIT)
							js.return
						end
						if not js.return_called then
							a_data.item.set.httpauth := l_auth
						end
						l_pos := -1 + 204 -- switch 1; break
				when 68 then -- switch 1, case 10036
						l_result := setstropt (a_data.item.set.str + 4, (create {CE_POINTER [INTEGER_8]}.make_cast (l_param.pointer_item)))
						l_pos := -1 + 204 -- switch 1; break
				when 69 then -- switch 1, case 61
						a_data.item.set.tunnel_thru_httpproxy := (0 /= (l_param.integer_32_item))
						l_pos := -1 + 204 -- switch 1; break
				when 70 then -- switch 1, case 59
						a_data.item.set.proxyport := l_param.integer_32_item
						l_pos := -1 + 204 -- switch 1; break
				when 71 then -- switch 1, case 111
						l_auth___0 := (l_param.integer_32_item)
						if ((l_auth___0).bit_and (((1).bit_shift_left (4)).to_integer_32)).to_boolean then
							l_tmp___50 := 1
						else
							l_tmp___50 := 0
						end
						a_data.item.state.authproxy.iestyle := l_tmp___50.to_boolean
						if ((l_auth___0).bit_and (((1).bit_shift_left (4)).to_integer_32)).to_boolean then
							l_auth___0 := (l_auth___0).bit_or (((1).bit_shift_left (1)).to_integer_32)
							l_auth___0 := (l_auth___0).bit_and (((((1).bit_shift_left (4))).bit_not).to_integer_32)
						end
						l_auth___0 := (l_auth___0).bit_and (((((1).bit_shift_left (3))).bit_not).to_integer_32)
						l_auth___0 := (l_auth___0).bit_and (((((1).bit_shift_left (2))).bit_not).to_integer_32)
						if not l_auth___0.to_boolean then
							Result := ({PC_CURLCODE}.CURLE_FAILED_INIT)
							js.return
						end
						if not js.return_called then
							a_data.item.set.proxyauth := l_auth___0
						end
						l_pos := -1 + 204 -- switch 1; break
				when 72 then -- switch 1, case 10004
						l_result := setstropt (a_data.item.set.str + 16, (create {CE_POINTER [INTEGER_8]}.make_cast (l_param.pointer_item)))
						l_pos := -1 + 204 -- switch 1; break
				when 73 then -- switch 1, case 101
						a_data.item.set.proxytype := (l_param.integer_32_item).to_integer_32
						l_pos := -1 + 204 -- switch 1; break
				when 74 then -- switch 1, case 166
						inspect (l_param.integer_32_item).to_integer_32 -- switch 2 head
						when 0 then l_pos := -1 + 75
						when 1 then l_pos := -1 + 76
						else l_pos := -1 + 77
						end
				when 75 then -- switch 2, case 0
						a_data.item.set.proxy_transfer_mode := (0).to_boolean
						l_pos := -1 + 78 -- switch 2; break
				when 76 then -- switch 2, case 1
						a_data.item.set.proxy_transfer_mode := (1).to_boolean
						l_pos := -1 + 78 -- switch 2; break
				when 77 then -- switch 2, default:
						l_result := {PC_CURLCODE}.CURLE_FAILED_INIT
						l_pos := -1 + 78 -- switch 2; break
				when 78 then -- switch 2, done:
						l_pos := -1 + 204 -- switch 1; break
				when 79 then -- switch 1, case 10029
						a_data.item.set.writeheader := (create {CE_POINTER [ANY]}.make_cast (l_param.pointer_item))
						l_pos := -1 + 204 -- switch 1; break
				when 80 then -- switch 1, case 10010
						a_data.item.set.errorbuffer := (create {CE_POINTER [INTEGER_8]}.make_cast (l_param.pointer_item))
						l_pos := -1 + 204 -- switch 1; break
				when 81 then -- switch 1, case 10001
						a_data.item.set.out2 := (create {CE_POINTER [SD_IO_FILE]}.make_cast (l_param.pointer_item))
						l_pos := -1 + 204 -- switch 1; break
				when 82 then -- switch 1, case 10017
						l_result := setstropt (a_data.item.set.str + 9, (create {CE_POINTER [INTEGER_8]}.make_cast (l_param.pointer_item)))
						a_data.item.set.ftp_use_port := ((0).to_natural_32 /= ((a_data.item.set.str[9]).c_pointer.to_integer_32).to_natural_32)
						l_pos := -1 + 204 -- switch 1; break
				when 83 then -- switch 1, case 106
						a_data.item.set.ftp_use_eprt := (0 /= (l_param.integer_32_item))
						l_pos := -1 + 204 -- switch 1; break
				when 84 then -- switch 1, case 85
						a_data.item.set.ftp_use_epsv := (0 /= (l_param.integer_32_item))
						l_pos := -1 + 204 -- switch 1; break
				when 85 then -- switch 1, case 188
						a_data.item.set.ftp_use_pret := (0 /= (l_param.integer_32_item))
						l_pos := -1 + 204 -- switch 1; break
				when 86 then -- switch 1, case 154
						a_data.item.set.ftp_ccc := (l_param.integer_32_item).to_integer_32
						l_pos := -1 + 204 -- switch 1; break
				when 87 then -- switch 1, case 137
						a_data.item.set.ftp_skip_ip := (0 /= (l_param.integer_32_item))
						l_pos := -1 + 204 -- switch 1; break
				when 88 then -- switch 1, case 10009
						a_data.item.set.in := (create {CE_POINTER [SD_IO_FILE]}.make_cast (l_param.pointer_item))
						l_pos := -1 + 204 -- switch 1; break
				when 89 then -- switch 1, case 14
						a_data.item.set.infilesize := l_param.integer_32_item
						l_pos := -1 + 204 -- switch 1; break
				when 90 then -- switch 1, case 30115
						a_data.item.set.infilesize := l_param.integer_64_item
						l_pos := -1 + 204 -- switch 1; break
				when 91 then -- switch 1, case 19
						a_data.item.set.low_speed_limit := l_param.integer_32_item
						l_pos := -1 + 204 -- switch 1; break
				when 92 then -- switch 1, case 30145
						a_data.item.set.max_send_speed := l_param.integer_64_item
						l_pos := -1 + 204 -- switch 1; break
				when 93 then -- switch 1, case 30146
						a_data.item.set.max_recv_speed := l_param.integer_64_item
						l_pos := -1 + 204 -- switch 1; break
				when 94 then -- switch 1, case 20
						a_data.item.set.low_speed_time := l_param.integer_32_item
						l_pos := -1 + 204 -- switch 1; break
				when 95 then -- switch 1, case 10002
						if a_data.item.change.url_alloc then
							easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (a_data.item.change.url)])
							a_data.item.change.url_alloc := (0).to_boolean
						end
						l_result := setstropt (a_data.item.set.str + 19, (create {CE_POINTER [INTEGER_8]}.make_cast (l_param.pointer_item)))
						a_data.item.change.url := a_data.item.set.str[19]
						l_pos := -1 + 204 -- switch 1; break
				when 96 then -- switch 1, case 3
						a_data.item.set.use_port := l_param.integer_32_item
						l_pos := -1 + 204 -- switch 1; break
				when 97 then -- switch 1, case 13
						a_data.item.set.timeout := (l_param.integer_32_item) * 1000
						l_pos := -1 + 204 -- switch 1; break
				when 98 then -- switch 1, case 155
						a_data.item.set.timeout := l_param.integer_32_item
						l_pos := -1 + 204 -- switch 1; break
				when 99 then -- switch 1, case 78
						a_data.item.set.connecttimeout := (l_param.integer_32_item) * 1000
						l_pos := -1 + 204 -- switch 1; break
				when 100 then -- switch 1, case 156
						a_data.item.set.connecttimeout := l_param.integer_32_item
						l_pos := -1 + 204 -- switch 1; break
				when 101 then -- switch 1, case 10005
						l_result := setstropt_userpwd ((create {CE_POINTER [INTEGER_8]}.make_cast (l_param.pointer_item)), a_data.item.set.str + 28, a_data.item.set.str + 29)
						l_pos := -1 + 204 -- switch 1; break
				when 102 then -- switch 1, case 10173
						l_result := setstropt (a_data.item.set.str + 28, (create {CE_POINTER [INTEGER_8]}.make_cast (l_param.pointer_item)))
						l_pos := -1 + 204 -- switch 1; break
				when 103 then -- switch 1, case 10174
						l_result := setstropt (a_data.item.set.str + 29, (create {CE_POINTER [INTEGER_8]}.make_cast (l_param.pointer_item)))
						l_pos := -1 + 204 -- switch 1; break
				when 104 then -- switch 1, case 10039
						a_data.item.set.postquote := (create {CE_POINTER [PD_CURL_SLIST]}.make_cast (l_param.pointer_item))
						l_pos := -1 + 204 -- switch 1; break
				when 105 then -- switch 1, case 10093
						a_data.item.set.prequote := (create {CE_POINTER [PD_CURL_SLIST]}.make_cast (l_param.pointer_item))
						l_pos := -1 + 204 -- switch 1; break
				when 106 then -- switch 1, case 10028
						a_data.item.set.quote := (create {CE_POINTER [PD_CURL_SLIST]}.make_cast (l_param.pointer_item))
						l_pos := -1 + 204 -- switch 1; break
				when 107 then -- switch 1, case 20056
						a_data.item.set.fprogress := (create {CE_ROUTINE}.make_cast (l_param.pointer_item))
						if ((a_data.item.set.fprogress).c_pointer /= default_pointer) then
							a_data.item.progress.callback := (1).to_boolean
						else
							a_data.item.progress.callback := (0).to_boolean
						end
						l_pos := -1 + 204 -- switch 1; break
				when 108 then -- switch 1, case 10057
						a_data.item.set.progress_client := (create {CE_POINTER [ANY]}.make_cast (l_param.pointer_item))
						l_pos := -1 + 204 -- switch 1; break
				when 109 then -- switch 1, case 10006
						l_result := setstropt_userpwd ((create {CE_POINTER [INTEGER_8]}.make_cast (l_param.pointer_item)), a_data.item.set.str + 30, a_data.item.set.str + 31)
						l_pos := -1 + 204 -- switch 1; break
				when 110 then -- switch 1, case 10175
						l_result := setstropt (a_data.item.set.str + 30, (create {CE_POINTER [INTEGER_8]}.make_cast (l_param.pointer_item)))
						l_pos := -1 + 204 -- switch 1; break
				when 111 then -- switch 1, case 10176
						l_result := setstropt (a_data.item.set.str + 31, (create {CE_POINTER [INTEGER_8]}.make_cast (l_param.pointer_item)))
						l_pos := -1 + 204 -- switch 1; break
				when 112 then -- switch 1, case 10177
						l_result := setstropt (a_data.item.set.str + 32, (create {CE_POINTER [INTEGER_8]}.make_cast (l_param.pointer_item)))
						l_pos := -1 + 204 -- switch 1; break
				when 113 then -- switch 1, case 10007
						l_result := setstropt (a_data.item.set.str + 17, (create {CE_POINTER [INTEGER_8]}.make_cast (l_param.pointer_item)))
						l_pos := -1 + 204 -- switch 1; break
				when 114 then -- switch 1, case 21
						a_data.item.set.set_resume_from := l_param.integer_32_item
						l_pos := -1 + 204 -- switch 1; break
				when 115 then -- switch 1, case 30116
						a_data.item.set.set_resume_from := l_param.integer_64_item
						l_pos := -1 + 204 -- switch 1; break
				when 116 then -- switch 1, case 20094
						a_data.item.set.fdebug := (create {CE_ROUTINE}.make_cast (l_param.pointer_item))
						l_pos := -1 + 204 -- switch 1; break
				when 117 then -- switch 1, case 10095
						a_data.item.set.debugdata := (create {CE_POINTER [ANY]}.make_cast (l_param.pointer_item))
						l_pos := -1 + 204 -- switch 1; break
				when 118 then -- switch 1, case 10037
						a_data.item.set.err := (create {CE_POINTER [SD_IO_FILE]}.make_cast (l_param.pointer_item))
						if (a_data.item.set.err).c_pointer = default_pointer then
							a_data.item.set.err := (create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.error.file_pointer))
						end
						l_pos := -1 + 204 -- switch 1; break
				when 119 then -- switch 1, case 20079
						a_data.item.set.fwrite_header := (create {CE_ROUTINE}.make_cast (l_param.pointer_item))
						l_pos := -1 + 204 -- switch 1; break
				when 120 then -- switch 1, case 20011
						a_data.item.set.fwrite_func := (create {CE_ROUTINE}.make_cast (l_param.pointer_item))
						if (a_data.item.set.fwrite_func).c_pointer = default_pointer then
							a_data.item.set.is_fwrite_set := 0
							a_data.item.set.fwrite_func := (fwrite_address)
						else
							a_data.item.set.is_fwrite_set := 1
						end
						l_pos := -1 + 204 -- switch 1; break
				when 121 then -- switch 1, case 20012
						a_data.item.set.fread_func := (create {CE_ROUTINE}.make_cast (l_param.pointer_item))
						if (a_data.item.set.fread_func).c_pointer = default_pointer then
							a_data.item.set.is_fread_set := 0
							a_data.item.set.fread_func := (fread_address)
						else
							a_data.item.set.is_fread_set := 1
						end
						l_pos := -1 + 204 -- switch 1; break
				when 122 then -- switch 1, case 20167
						a_data.item.set.seek_func := (create {CE_ROUTINE}.make_cast (l_param.pointer_item))
						l_pos := -1 + 204 -- switch 1; break
				when 123 then -- switch 1, case 10168
						a_data.item.set.seek_client := (create {CE_POINTER [ANY]}.make_cast (l_param.pointer_item))
						l_pos := -1 + 204 -- switch 1; break
				when 124 then -- switch 1, case 20142
						a_data.item.set.convfromnetwork := (create {CE_ROUTINE}.make_cast (l_param.pointer_item))
						l_pos := -1 + 204 -- switch 1; break
				when 125 then -- switch 1, case 20143
						a_data.item.set.convtonetwork := (create {CE_ROUTINE}.make_cast (l_param.pointer_item))
						l_pos := -1 + 204 -- switch 1; break
				when 126 then -- switch 1, case 20144
						a_data.item.set.convfromutf8 := (create {CE_ROUTINE}.make_cast (l_param.pointer_item))
						l_pos := -1 + 204 -- switch 1; break
				when 127 then -- switch 1, case 20130
						a_data.item.set.ioctl_func := (create {CE_ROUTINE}.make_cast (l_param.pointer_item))
						l_pos := -1 + 204 -- switch 1; break
				when 128 then -- switch 1, case 10131
						a_data.item.set.ioctl_client := (create {CE_POINTER [ANY]}.make_cast (l_param.pointer_item))
						l_pos := -1 + 204 -- switch 1; break
				when 129 then -- switch 1, case 10025
						l_result := setstropt (a_data.item.set.str + 0, (create {CE_POINTER [INTEGER_8]}.make_cast (l_param.pointer_item)))
						l_pos := -1 + 204 -- switch 1; break
				when 130 then -- switch 1, case 10086
						l_result := setstropt (a_data.item.set.str + 1, (create {CE_POINTER [INTEGER_8]}.make_cast (l_param.pointer_item)))
						l_pos := -1 + 204 -- switch 1; break
				when 131 then -- switch 1, case 10087
						l_result := setstropt (a_data.item.set.str + 10, (create {CE_POINTER [INTEGER_8]}.make_cast (l_param.pointer_item)))
						l_pos := -1 + 204 -- switch 1; break
				when 132 then -- switch 1, case 10088
						l_result := setstropt (a_data.item.set.str + 12, (create {CE_POINTER [INTEGER_8]}.make_cast (l_param.pointer_item)))
						l_pos := -1 + 204 -- switch 1; break
				when 133 then -- switch 1, case 10026
						l_result := setstropt (a_data.item.set.str + 11, (create {CE_POINTER [INTEGER_8]}.make_cast (l_param.pointer_item)))
						l_pos := -1 + 204 -- switch 1; break
				when 134 then -- switch 1, case 10089
						l_argptr.ce_gets ((create {CE_POINTER [INTEGER_8]}.make_cast (l_param.pointer_item)))
						if ((l_argptr).c_pointer /= default_pointer) then
							if (l_argptr[0]).to_boolean then
								l_result := {PC_CURLCODE}.CURLE_FAILED_INIT
							end
						end
						l_pos := -1 + 204 -- switch 1; break
				when 135 then -- switch 1, case 90
						l_result := {PC_CURLCODE}.CURLE_FAILED_INIT
						l_pos := -1 + 204 -- switch 1; break
				when 136 then -- switch 1, case 27
						a_data.item.set.crlf := (0 /= (l_param.integer_32_item))
						l_pos := -1 + 204 -- switch 1; break
				when 137 then -- switch 1, case 10062
						l_result := setstropt (a_data.item.set.str + 5, (create {CE_POINTER [INTEGER_8]}.make_cast (l_param.pointer_item)))
						l_pos := -1 + 204 -- switch 1; break
				when 138 then -- switch 1, case 139
						a_data.item.set.localport := (l_param.integer_32_item).to_natural_16
						l_pos := -1 + 204 -- switch 1; break
				when 139 then -- switch 1, case 140
						a_data.item.set.localportrange := (l_param.integer_32_item).to_integer_32
						l_pos := -1 + 204 -- switch 1; break
				when 140 then -- switch 1, case 10063
						l_result := setstropt (a_data.item.set.str + 13, (create {CE_POINTER [INTEGER_8]}.make_cast (l_param.pointer_item)))
						a_data.item.set.krb := ((0).to_natural_32 /= ((a_data.item.set.str[13]).c_pointer.to_integer_32).to_natural_32)
						l_pos := -1 + 204 -- switch 1; break
				when 141 then -- switch 1, case 64
						a_data.item.set.ssl.verifypeer := l_param.integer_32_item
						l_pos := -1 + 204 -- switch 1; break
				when 142 then -- switch 1, case 81
						a_data.item.set.ssl.verifyhost := l_param.integer_32_item
						l_pos := -1 + 204 -- switch 1; break
				when 143 then -- switch 1, case 10065
						l_result := setstropt (a_data.item.set.str + 21, (create {CE_POINTER [INTEGER_8]}.make_cast (l_param.pointer_item)))
						l_pos := -1 + 204 -- switch 1; break
				when 144 then -- switch 1, case 10097
						l_result := setstropt (a_data.item.set.str + 20, (create {CE_POINTER [INTEGER_8]}.make_cast (l_param.pointer_item)))
						l_pos := -1 + 204 -- switch 1; break
				when 145 then -- switch 1, case 10169
						l_result := setstropt (a_data.item.set.str + 26, (create {CE_POINTER [INTEGER_8]}.make_cast (l_param.pointer_item)))
						l_pos := -1 + 204 -- switch 1; break
				when 146 then -- switch 1, case 10170
						l_result := setstropt (a_data.item.set.str + 27, (create {CE_POINTER [INTEGER_8]}.make_cast (l_param.pointer_item)))
						l_pos := -1 + 204 -- switch 1; break
				when 147 then -- switch 1, case 10070
						a_data.item.set.telnet_options := (create {CE_POINTER [PD_CURL_SLIST]}.make_cast (l_param.pointer_item))
						l_pos := -1 + 204 -- switch 1; break
				when 148 then -- switch 1, case 98
						a_data.item.set.buffer_size := l_param.integer_32_item
						if a_data.item.set.buffer_size > 16383 then
							a_data.item.set.buffer_size := 0
						elseif a_data.item.set.buffer_size < 1 then
							a_data.item.set.buffer_size := 0
						end
						l_pos := -1 + 204 -- switch 1; break
				when 149 then -- switch 1, case 99
						a_data.item.set.no_signal := (0 /= (l_param.integer_32_item))
						l_pos := -1 + 204 -- switch 1; break
				when 150 then -- switch 1, case 10100
						l_set.ce_gets ((create {CE_POINTER [PD_CURL_SHARE]}.make_cast (l_param.pointer_item)))
						if ((a_data.item.share).c_pointer /= default_pointer) then
							share_inst.Curl_share_lock (a_data, {PC_CURL_LOCK_DATA}.CURL_LOCK_DATA_SHARE, {PC_CURL_LOCK_ACCESS}.CURL_LOCK_ACCESS_SINGLE).do_nothing
							if (a_data.item.dns.hostcachetype).to_natural_32 = {NATURAL_32} 4 then
								a_data.item.dns.hostcache := create {CE_POINTER [PD_CURL_HASH]}.make_shared (default_pointer)
								a_data.item.dns.hostcachetype := {PC_HOSTCACHETYPE}.HCACHE_NONE
							end
							if (((a_data.item.share).item.cookies).c_pointer.to_integer_32).to_natural_32 = ((a_data.item.cookies).c_pointer.to_integer_32).to_natural_32 then
								a_data.item.cookies := create {CE_POINTER [PD_COOKIEINFO]}.make_shared (default_pointer)
							end
							(a_data.item.share).item.dirty := (a_data.item.share).item.dirty - (1).to_natural_32
							share_inst.Curl_share_unlock (a_data, {PC_CURL_LOCK_DATA}.CURL_LOCK_DATA_SHARE).do_nothing
							a_data.item.share := create {CE_POINTER [PD_CURL_SHARE]}.make_shared (default_pointer)
						end
						a_data.item.share := l_set
						if ((a_data.item.share).c_pointer /= default_pointer) then
							share_inst.Curl_share_lock (a_data, {PC_CURL_LOCK_DATA}.CURL_LOCK_DATA_SHARE, {PC_CURL_LOCK_ACCESS}.CURL_LOCK_ACCESS_SINGLE).do_nothing;
							(a_data.item.share).item.dirty := (a_data.item.share).item.dirty + (1).to_natural_32
							if (((a_data.item.share).item.hostcache).c_pointer /= default_pointer) then
								if (a_data.item.dns.hostcachetype).to_natural_32 = {NATURAL_32} 1 then
									hash_inst.Curl_hash_destroy (a_data.item.dns.hostcache)
								end
								a_data.item.dns.hostcache := (a_data.item.share).item.hostcache
								a_data.item.dns.hostcachetype := {PC_HOSTCACHETYPE}.HCACHE_SHARED
							end
							if (((a_data.item.share).item.cookies).c_pointer /= default_pointer) then
								if ((a_data.item.cookies).c_pointer /= default_pointer) then
									cookie_inst.Curl_cookie_cleanup (a_data.item.cookies)
								end
								a_data.item.cookies := (a_data.item.share).item.cookies
							end
							share_inst.Curl_share_unlock (a_data, {PC_CURL_LOCK_DATA}.CURL_LOCK_DATA_SHARE).do_nothing
						end
						l_pos := -1 + 204 -- switch 1; break
				when 151 then -- switch 1, case 10103
						a_data.item.set.private_data := (create {CE_POINTER [ANY]}.make_cast (l_param.pointer_item))
						l_pos := -1 + 204 -- switch 1; break
				when 152 then -- switch 1, case 114
						a_data.item.set.max_filesize := l_param.integer_32_item
						l_pos := -1 + 204 -- switch 1; break
				when 153 then -- switch 1, case 119
						a_data.item.set.ftp_ssl := (l_param.integer_32_item).to_integer_32
						l_pos := -1 + 204 -- switch 1; break
				when 154 then -- switch 1, case 129
						a_data.item.set.ftpsslauth := (l_param.integer_32_item).to_integer_32
						l_pos := -1 + 204 -- switch 1; break
				when 155 then -- switch 1, case 113
						a_data.item.set.ip_version := l_param.integer_32_item
						l_pos := -1 + 204 -- switch 1; break
				when 156 then -- switch 1, case 30117
						a_data.item.set.max_filesize := l_param.integer_64_item
						l_pos := -1 + 204 -- switch 1; break
				when 157 then -- switch 1, case 121
						a_data.item.set.tcp_nodelay := (0 /= (l_param.integer_32_item))
						l_pos := -1 + 204 -- switch 1; break
				when 158 then -- switch 1, case 10134
						l_result := setstropt (a_data.item.set.str + 7, (create {CE_POINTER [INTEGER_8]}.make_cast (l_param.pointer_item)))
						l_pos := -1 + 204 -- switch 1; break
				when 159 then -- switch 1, case 136
						a_data.item.set.ignorecl := (0 /= (l_param.integer_32_item))
						l_pos := -1 + 204 -- switch 1; break
				when 160 then -- switch 1, case 141
						a_data.item.set.connect_only := (0 /= (l_param.integer_32_item))
						l_pos := -1 + 204 -- switch 1; break
				when 161 then -- switch 1, case 10147
						l_result := setstropt (a_data.item.set.str + 8, (create {CE_POINTER [INTEGER_8]}.make_cast (l_param.pointer_item)))
						l_pos := -1 + 204 -- switch 1; break
				when 162 then -- switch 1, case 20148
						a_data.item.set.fsockopt := (create {CE_ROUTINE}.make_cast (l_param.pointer_item))
						l_pos := -1 + 204 -- switch 1; break
				when 163 then -- switch 1, case 10149
						a_data.item.set.sockopt_client := (create {CE_POINTER [ANY]}.make_cast (l_param.pointer_item))
						l_pos := -1 + 204 -- switch 1; break
				when 164 then -- switch 1, case 20163
						a_data.item.set.fopensocket := (create {CE_ROUTINE}.make_cast (l_param.pointer_item))
						l_pos := -1 + 204 -- switch 1; break
				when 165 then -- switch 1, case 10164
						a_data.item.set.opensocket_client := (create {CE_POINTER [ANY]}.make_cast (l_param.pointer_item))
						l_pos := -1 + 204 -- switch 1; break
				when 166 then -- switch 1, case 150
						a_data.item.set.ssl.sessionid := (0 /= (l_param.integer_32_item))
						l_pos := -1 + 204 -- switch 1; break
				when 167 then -- switch 1, case 157
						a_data.item.set.http_te_skip := (0 = (l_param.integer_32_item))
						l_pos := -1 + 204 -- switch 1; break
				when 168 then -- switch 1, case 158
						a_data.item.set.http_ce_skip := (0 = (l_param.integer_32_item))
						l_pos := -1 + 204 -- switch 1; break
				when 169 then -- switch 1, case 159
						a_data.item.set.new_file_perms := l_param.integer_32_item
						l_pos := -1 + 204 -- switch 1; break
				when 170 then -- switch 1, case 160
						a_data.item.set.new_directory_perms := l_param.integer_32_item
						l_pos := -1 + 204 -- switch 1; break
				when 171 then -- switch 1, case 171
						a_data.item.set.scope := (l_param.integer_32_item).to_natural_32
						l_pos := -1 + 204 -- switch 1; break
				when 172 then -- switch 1, case 181
						a_data.item.set.allowed_protocols := ((l_param.integer_32_item)).bit_and (67108863)
						l_pos := -1 + 204 -- switch 1; break
				when 173 then -- switch 1, case 182
						a_data.item.set.redir_protocols := ((l_param.integer_32_item)).bit_and (67108863)
						l_pos := -1 + 204 -- switch 1; break
				when 174 then -- switch 1, case 10186
						l_result := setstropt (a_data.item.set.str + 36, (create {CE_POINTER [INTEGER_8]}.make_cast (l_param.pointer_item)))
						l_pos := -1 + 204 -- switch 1; break
				when 175 then -- switch 1, case 10187
						a_data.item.set.mail_rcpt := (create {CE_POINTER [PD_CURL_SLIST]}.make_cast (l_param.pointer_item))
						l_pos := -1 + 204 -- switch 1; break
				when 176 then -- switch 1, case 189
						l_curl_rtspreq := (l_param.integer_32_item)
						l_rtspreq := {PC_CURL_RTSPREQ}.RTSPREQ_NONE
						inspect l_curl_rtspreq.to_integer_32 -- switch 3 head
						when 1 then l_pos := -1 + 177
						when 2 then l_pos := -1 + 178
						when 3 then l_pos := -1 + 179
						when 4 then l_pos := -1 + 180
						when 5 then l_pos := -1 + 181
						when 6 then l_pos := -1 + 182
						when 7 then l_pos := -1 + 183
						when 8 then l_pos := -1 + 184
						when 9 then l_pos := -1 + 185
						when 10 then l_pos := -1 + 186
						when 11 then l_pos := -1 + 187
						else l_pos := -1 + 188
						end
				when 177 then -- switch 3, case 1
						l_rtspreq := {PC_CURL_RTSPREQ}.RTSPREQ_OPTIONS
						l_pos := -1 + 189 -- switch 3; break
				when 178 then -- switch 3, case 2
						l_rtspreq := {PC_CURL_RTSPREQ}.RTSPREQ_DESCRIBE
						l_pos := -1 + 189 -- switch 3; break
				when 179 then -- switch 3, case 3
						l_rtspreq := {PC_CURL_RTSPREQ}.RTSPREQ_ANNOUNCE
						l_pos := -1 + 189 -- switch 3; break
				when 180 then -- switch 3, case 4
						l_rtspreq := {PC_CURL_RTSPREQ}.RTSPREQ_SETUP
						l_pos := -1 + 189 -- switch 3; break
				when 181 then -- switch 3, case 5
						l_rtspreq := {PC_CURL_RTSPREQ}.RTSPREQ_PLAY
						l_pos := -1 + 189 -- switch 3; break
				when 182 then -- switch 3, case 6
						l_rtspreq := {PC_CURL_RTSPREQ}.RTSPREQ_PAUSE
						l_pos := -1 + 189 -- switch 3; break
				when 183 then -- switch 3, case 7
						l_rtspreq := {PC_CURL_RTSPREQ}.RTSPREQ_TEARDOWN
						l_pos := -1 + 189 -- switch 3; break
				when 184 then -- switch 3, case 8
						l_rtspreq := {PC_CURL_RTSPREQ}.RTSPREQ_GET_PARAMETER
						l_pos := -1 + 189 -- switch 3; break
				when 185 then -- switch 3, case 9
						l_rtspreq := {PC_CURL_RTSPREQ}.RTSPREQ_SET_PARAMETER
						l_pos := -1 + 189 -- switch 3; break
				when 186 then -- switch 3, case 10
						l_rtspreq := {PC_CURL_RTSPREQ}.RTSPREQ_RECORD
						l_pos := -1 + 189 -- switch 3; break
				when 187 then -- switch 3, case 11
						l_rtspreq := {PC_CURL_RTSPREQ}.RTSPREQ_RECEIVE
						l_pos := -1 + 189 -- switch 3; break
				when 188 then -- switch 3, default:
						l_rtspreq := {PC_CURL_RTSPREQ}.RTSPREQ_NONE
				when 189 then -- switch 3, done:
						a_data.item.set.rtspreq := l_rtspreq
						l_pos := -1 + 204 -- switch 1; break
				when 190 then -- switch 1, case 10190
						l_result := setstropt (a_data.item.set.str + 33, (create {CE_POINTER [INTEGER_8]}.make_cast (l_param.pointer_item)))
						l_pos := -1 + 204 -- switch 1; break
				when 191 then -- switch 1, case 10191
						l_result := setstropt (a_data.item.set.str + 34, (create {CE_POINTER [INTEGER_8]}.make_cast (l_param.pointer_item)))
						l_pos := -1 + 204 -- switch 1; break
				when 192 then -- switch 1, case 10192
						l_result := setstropt (a_data.item.set.str + 35, (create {CE_POINTER [INTEGER_8]}.make_cast (l_param.pointer_item)))
						l_pos := -1 + 204 -- switch 1; break
				when 193 then -- switch 1, case 193
						a_data.item.state.rtsp_next_client_CSeq := l_param.integer_32_item
						l_pos := -1 + 204 -- switch 1; break
				when 194 then -- switch 1, case 194
						a_data.item.state.rtsp_next_client_CSeq := l_param.integer_32_item
						l_pos := -1 + 204 -- switch 1; break
				when 195 then -- switch 1, case 10195
						a_data.item.set.rtp_out := (create {CE_POINTER [ANY]}.make_cast (l_param.pointer_item))
						l_pos := -1 + 204 -- switch 1; break
				when 196 then -- switch 1, case 20196
						a_data.item.set.fwrite_rtp := (create {CE_ROUTINE}.make_cast (l_param.pointer_item))
						l_pos := -1 + 204 -- switch 1; break
				when 197 then -- switch 1, case 197
						a_data.item.set.wildcardmatch := (0 /= (l_param.integer_32_item))
						l_pos := -1 + 204 -- switch 1; break
				when 198 then -- switch 1, case 20198
						a_data.item.set.chunk_bgn := (create {CE_ROUTINE}.make_cast (l_param.pointer_item))
						l_pos := -1 + 204 -- switch 1; break
				when 199 then -- switch 1, case 20199
						a_data.item.set.chunk_end := (create {CE_ROUTINE}.make_cast (l_param.pointer_item))
						l_pos := -1 + 204 -- switch 1; break
				when 200 then -- switch 1, case 20200
						a_data.item.set.fnmatch := (create {CE_ROUTINE}.make_cast (l_param.pointer_item))
						l_pos := -1 + 204 -- switch 1; break
				when 201 then -- switch 1, case 10201
						a_data.item.wildcard.customptr := (create {CE_POINTER [ANY]}.make_cast (l_param.pointer_item))
						l_pos := -1 + 204 -- switch 1; break
				when 202 then -- switch 1, case 10202
						a_data.item.set.fnmatch_data := (create {CE_POINTER [ANY]}.make_cast (l_param.pointer_item))
						l_pos := -1 + 204 -- switch 1; break
				when 203 then -- switch 1, default:
						l_result := {PC_CURLCODE}.CURLE_FAILED_INIT
						l_pos := -1 + 204 -- switch 1; break
				when 204 then -- switch 1, done:
						if not js.return_called then
							Result := l_result
						end
				when 205 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	conn_free (a_conn: CE_POINTER [PD_CONNECTDATA])
		local
			js: JUMP_STATE
		do
			if (a_conn).c_pointer = default_pointer then
				js.return
			end
			if not js.return_called then
				if -1 /= a_conn.item.sock[1] then
					close (a_conn.item.sock[1]).do_nothing
				end
				if -1 /= a_conn.item.sock[0] then
					close (a_conn.item.sock[0]).do_nothing
				end
				Curl_safefree (create {CE_POINTER [ANY]}.make_cast (a_conn.item.user))
				Curl_safefree (create {CE_POINTER [ANY]}.make_cast (a_conn.item.passwd))
				Curl_safefree (create {CE_POINTER [ANY]}.make_cast (a_conn.item.proxyuser))
				Curl_safefree (create {CE_POINTER [ANY]}.make_cast (a_conn.item.proxypasswd))
				Curl_safefree (create {CE_POINTER [ANY]}.make_cast (a_conn.item.allocptr.proxyuserpwd))
				Curl_safefree (create {CE_POINTER [ANY]}.make_cast (a_conn.item.allocptr.uagent))
				Curl_safefree (create {CE_POINTER [ANY]}.make_cast (a_conn.item.allocptr.userpwd))
				Curl_safefree (create {CE_POINTER [ANY]}.make_cast (a_conn.item.allocptr.accept_encoding))
				Curl_safefree (create {CE_POINTER [ANY]}.make_cast (a_conn.item.allocptr.rangeline))
				Curl_safefree (create {CE_POINTER [ANY]}.make_cast (a_conn.item.allocptr.ref))
				Curl_safefree (create {CE_POINTER [ANY]}.make_cast (a_conn.item.allocptr.host))
				Curl_safefree (create {CE_POINTER [ANY]}.make_cast (a_conn.item.allocptr.cookiehost))
				Curl_safefree (create {CE_POINTER [ANY]}.make_cast (a_conn.item.allocptr.rtsp_transport))
				Curl_safefree (create {CE_POINTER [ANY]}.make_cast (a_conn.item.trailer))
				Curl_safefree (create {CE_POINTER [ANY]}.make_cast (a_conn.item.host.rawalloc))
				Curl_safefree (create {CE_POINTER [ANY]}.make_cast (a_conn.item.proxy.rawalloc))
				Curl_safefree (create {CE_POINTER [ANY]}.make_cast (a_conn.item.master_buffer))
				llist_inst.Curl_llist_destroy (a_conn.item.send_pipe, create {CE_POINTER [ANY]}.make_shared (default_pointer))
				llist_inst.Curl_llist_destroy (a_conn.item.recv_pipe, create {CE_POINTER [ANY]}.make_shared (default_pointer))
				llist_inst.Curl_llist_destroy (a_conn.item.pend_pipe, create {CE_POINTER [ANY]}.make_shared (default_pointer))
				llist_inst.Curl_llist_destroy (a_conn.item.done_pipe, create {CE_POINTER [ANY]}.make_shared (default_pointer))
				sslgen_inst.Curl_free_ssl_config (create {CE_POINTER [PD_SSL_CONFIG_DATA]}.make_shared (a_conn.c_pointer + {PD_CONNECTDATA}.ssl_config_offset))
				easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (a_conn)])
			end
		end

	Curl_disconnect (a_conn: CE_POINTER [PD_CONNECTDATA]): INTEGER_32
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_has_host_ntlm: INTEGER_32
			l_has_proxy_ntlm: INTEGER_32
			js: JUMP_STATE
		do
			create l_data.make

			if (a_conn).c_pointer = default_pointer then
				Result := ({PC_CURLCODE}.CURLE_OK)
				js.return
			end
			if not js.return_called then
				l_data.ce_gets (a_conn.item.data)
				if (l_data).c_pointer = default_pointer then
					Result := ({PC_CURLCODE}.CURLE_OK)
					js.return
				end
			end
			if not js.return_called then
				if ((a_conn.item.dns_entry).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					hostip_inst.Curl_resolv_unlock (l_data, a_conn.item.dns_entry)
					a_conn.item.dns_entry := create {CE_POINTER [PD_CURL_DNS_ENTRY]}.make_shared (default_pointer)
				end
				hostip_inst.Curl_hostcache_prune (l_data)
				l_has_host_ntlm := ((a_conn.item.ntlm.state).to_natural_32 /= {NATURAL_32} 0).to_integer
				l_has_proxy_ntlm := ((a_conn.item.proxyntlm.state).to_natural_32 /= {NATURAL_32} 0).to_integer
				if l_has_host_ntlm.to_boolean then
					l_data.item.state.authhost.done := (0).to_boolean
					l_data.item.state.authhost.picked := l_data.item.state.authhost.want
				end
				if l_has_proxy_ntlm.to_boolean then
					l_data.item.state.authproxy.done := (0).to_boolean
					l_data.item.state.authproxy.picked := l_data.item.state.authproxy.want
				end
				if l_has_host_ntlm.to_boolean then
					l_data.item.state.authproblem := (0).to_boolean
				elseif l_has_proxy_ntlm.to_boolean then
					l_data.item.state.authproblem := (0).to_boolean
				end
				if ((l_data.item.req.newurl).c_pointer /= default_pointer) then
					easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_data.item.req.newurl)])
					l_data.item.req.newurl := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
				end
				if (((a_conn.item.handler).item.disconnect).c_pointer /= default_pointer) then
					((a_conn.item.handler).item.disconnect).call ([a_conn])
				end
				if -1 /= a_conn.item.connectindex then
					sendf_inst.Curl_infof ([l_data, ce_string ("Closing connection #%%ld%N"), a_conn.item.connectindex])
					if ((l_data.item.state.connc).c_pointer /= default_pointer) then
						(l_data.item.state.connc).item.connects[a_conn.item.connectindex] := create {CE_POINTER [PD_CONNECTDATA]}.make_shared (default_pointer)
					end
				end
				if (Curl_isPipeliningEnabled (l_data)) then
					signalPipeClose (a_conn.item.send_pipe, (1).to_boolean)
					signalPipeClose (a_conn.item.recv_pipe, (1).to_boolean)
					signalPipeClose (a_conn.item.pend_pipe, (1).to_boolean)
					signalPipeClose (a_conn.item.done_pipe, (0).to_boolean)
				end
				conn_free (a_conn)
				l_data.item.state.current_conn := create {CE_POINTER [PD_CONNECTDATA]}.make_shared (default_pointer)
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	SocketIsDead (a_sock: INTEGER_32): BOOLEAN
		local
			l_sval: INTEGER_32
			l_ret_val: BOOLEAN
		do
			l_ret_val := (1).to_boolean
			l_sval := select_inst.Curl_socket_ready (a_sock, -1, 0)
			if l_sval = 0 then
				l_ret_val := (0).to_boolean
			end
			Result := l_ret_val
		end

	RTSPConnIsDead (a_check: CE_POINTER [PD_CONNECTDATA]): BOOLEAN
		local
			l_check: CE_POINTER [PD_CONNECTDATA]
			l_sval: INTEGER_32
			l_ret_val: BOOLEAN
			l_connectinfo: INTEGER_32
		do
			create l_check.make

			l_check.ce_gets (a_check)
			l_ret_val := (1).to_boolean
			l_sval := select_inst.Curl_socket_ready (l_check.item.sock[0], -1, 0)
			if l_sval = 0 then
				l_ret_val := (0).to_boolean
			elseif ((l_sval).bit_and (4)).to_boolean then
				l_ret_val := (1).to_boolean
			elseif ((l_sval).bit_and (1)).to_boolean then
				l_connectinfo := (connect_inst.Curl_getconnectinfo (l_check.item.data, l_check.address))
				if l_connectinfo /= -1 then
					l_ret_val := (0).to_boolean
				end
			end
			Result := l_ret_val
		end

	IsPipeliningPossible (a_handle: CE_POINTER [PD_SESSIONHANDLE]): BOOLEAN
		local
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (a_handle.item.multi).c_pointer = default_pointer then
						l_pos := -1 + 7 -- skip if block
					end
				when 1 then -- if:
						if not (multi_inst.Curl_multi_canPipeline (a_handle.item.multi)) then
							l_pos := -1 + 7 -- skip if block
						end
				when 2 then -- if:
						if (a_handle.item.set.httpreq).to_natural_32 /= {NATURAL_32} 1 then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_pos := -1 + 6 -- goto _L
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 5 then -- else:
						if (a_handle.item.set.httpreq).to_natural_32 /= {NATURAL_32} 5 then
							l_pos := -1 + 7 -- skip if block
						end
				when 6 then -- if: | _L:
						if a_handle.item.set.httpversion /= 1 then
							Result := (1).to_boolean
							js.return
						end
				when 7 then -- if done | if done | if done
						if not js.return_called then
							Result := (0).to_boolean
						end
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	Curl_isPipeliningEnabled (a_handle: CE_POINTER [PD_SESSIONHANDLE]): BOOLEAN
		local
			js: JUMP_STATE
		do
			if ((a_handle.item.multi).c_pointer /= default_pointer) then
				if (multi_inst.Curl_multi_canPipeline (a_handle.item.multi)) then
					Result := (1).to_boolean
					js.return
				end
			end
			if not js.return_called then
				Result := (0).to_boolean
			end
		end

	Curl_addHandleToPipeline (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_pipeline: CE_POINTER [PD_CURL_LLIST]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if not (llist_inst.Curl_llist_insert_next (a_pipeline, a_pipeline.item.tail, create {CE_POINTER [ANY]}.make_cast (a_data))).to_boolean then
				Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
				js.return
			end
			if not js.return_called then
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	Curl_removeHandleFromPipeline (a_handle: CE_POINTER [PD_SESSIONHANDLE]; a_pipeline: CE_POINTER [PD_CURL_LLIST]): INTEGER_32
		local
			l_curr: CE_POINTER [PD_CURL_LLIST_ELEMENT]
			js: JUMP_STATE
		do
			create l_curr.make

			l_curr.ce_gets (a_pipeline.item.head)
			from
			until
				not (not js.loop_left and then ((l_curr).c_pointer /= default_pointer))
			loop
				if ((l_curr.item.ptr).c_pointer.to_integer_32).to_natural_32 = (a_handle.c_pointer.to_integer_32).to_natural_32 then
					llist_inst.Curl_llist_remove (a_pipeline, l_curr, create {CE_POINTER [ANY]}.make_shared (default_pointer)).do_nothing
					Result := 1
					js.return
				end
				if not js.return_called then
					l_curr.ce_gets (l_curr.item.next)
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gethandleathead (a_pipeline: CE_POINTER [PD_CURL_LLIST]): CE_POINTER [PD_SESSIONHANDLE]
		local
			l_curr: CE_POINTER [PD_CURL_LLIST_ELEMENT]
			js: JUMP_STATE
		do
			create l_curr.make

			l_curr.ce_gets (a_pipeline.item.head)
			if ((l_curr).c_pointer /= default_pointer) then
				Result := (create {CE_POINTER [PD_SESSIONHANDLE]}.make_cast (l_curr.item.ptr))
				js.return
			end
			if not js.return_called then
				Result := (create {CE_POINTER [PD_SESSIONHANDLE]}.make_shared (default_pointer))
			end
		end

	Curl_getoff_all_pipelines (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_conn: CE_POINTER [PD_CONNECTDATA])
		local
			l_recv_head: BOOLEAN
			l_tmp___0: INTEGER_32
			l_send_head: BOOLEAN
			l_tmp___2: INTEGER_32
		do
			if a_conn.item.readchannel_inuse then
				if ((gethandleathead (a_conn.item.recv_pipe)).c_pointer.to_integer_32).to_natural_32 = (a_data.c_pointer.to_integer_32).to_natural_32 then
					l_tmp___0 := 1
				else
					l_tmp___0 := 0
				end
			else
				l_tmp___0 := 0
			end
			l_recv_head := l_tmp___0.to_boolean
			if a_conn.item.writechannel_inuse then
				if ((gethandleathead (a_conn.item.send_pipe)).c_pointer.to_integer_32).to_natural_32 = (a_data.c_pointer.to_integer_32).to_natural_32 then
					l_tmp___2 := 1
				else
					l_tmp___2 := 0
				end
			else
				l_tmp___2 := 0
			end
			l_send_head := l_tmp___2.to_boolean
			if (Curl_removeHandleFromPipeline (a_data, a_conn.item.recv_pipe)).to_boolean then
				if l_recv_head then
					a_conn.item.readchannel_inuse := (0).to_boolean
				end
			end
			if (Curl_removeHandleFromPipeline (a_data, a_conn.item.send_pipe)).to_boolean then
				if l_send_head then
					a_conn.item.writechannel_inuse := (0).to_boolean
				end
			end
			Curl_removeHandleFromPipeline (a_data, a_conn.item.pend_pipe).do_nothing
			Curl_removeHandleFromPipeline (a_data, a_conn.item.done_pipe).do_nothing
		end

	signalPipeClose (a_pipeline: CE_POINTER [PD_CURL_LLIST]; a_pipe_broke: BOOLEAN)
		local
			l_curr: CE_POINTER [PD_CURL_LLIST_ELEMENT]
			l_next: CE_POINTER [PD_CURL_LLIST_ELEMENT]
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			js: JUMP_STATE
		do
			create l_curr.make
			create l_next.make
			create l_data.make

			if (a_pipeline).c_pointer = default_pointer then
				js.return
			end
			if not js.return_called then
				l_curr.ce_gets (a_pipeline.item.head)
				from
				until
					(l_curr).c_pointer = default_pointer
				loop
					l_next.ce_gets (l_curr.item.next)
					l_data.ce_gets (create {CE_POINTER [PD_SESSIONHANDLE]}.make_cast (l_curr.item.ptr))
					if a_pipe_broke then
						l_data.item.state.pipe_broke := (1).to_boolean
					end
					multi_inst.Curl_multi_handlePipeBreak (l_data)
					llist_inst.Curl_llist_remove (a_pipeline, l_curr, create {CE_POINTER [ANY]}.make_shared (default_pointer)).do_nothing
					l_curr.ce_gets (l_next)
				end
			end
		end

	ConnectionExists (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_needle: CE_POINTER [PD_CONNECTDATA]; a_usethis: CE_POINTER [CE_POINTER [PD_CONNECTDATA]]): BOOLEAN
		local
			l_i: INTEGER_32
			l_check: CE_POINTER [PD_CONNECTDATA]
			l_canPipeline: BOOLEAN
			l_match: BOOLEAN
			l_pipeLen: NATURAL_32
			l_dead: BOOLEAN
			l_sh: CE_POINTER [PD_SESSIONHANDLE]
			l_rh: CE_POINTER [PD_SESSIONHANDLE]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_check.make
			create l_sh.make
			create l_rh.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_canPipeline := (IsPipeliningPossible (a_data))
					l_i := 0
				when 1 then -- loop condition:
					if not (not js.loop_left and then (l_i < (a_data.item.state.connc).item.num)) then
						l_pos := -1 + 39 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						l_match := (0).to_boolean
						l_pipeLen := (0).to_natural_32
						l_check.ce_gets ((a_data.item.state.connc).item.connects[l_i])
						if (l_check).c_pointer = default_pointer then
							js.continue
						end
						if not js.loop_jumped then
							l_pipeLen := (l_check.item.send_pipe).item.size + (l_check.item.recv_pipe).item.size
							if l_check.item.connectindex = -1 then
								l_check.item.connectindex := l_i
							end
							if not l_pipeLen.to_boolean then
								if not l_check.item.inuse then
									if ((l_check.item.protocol).bit_and (((1).bit_shift_left (18)).to_integer_32)).to_boolean then
										l_dead := RTSPConnIsDead (l_check)
									else
										l_dead := SocketIsDead (l_check.item.sock[0])
									end
									if l_dead then
										l_check.item.data := a_data
										sendf_inst.Curl_infof ([a_data, ce_string ("Connection #%%ld seems to be dead!%N"), l_i])
										Curl_disconnect (l_check).do_nothing;
										(a_data.item.state.connc).item.connects[l_i] := create {CE_POINTER [PD_CONNECTDATA]}.make_shared (default_pointer)
										js.continue
									end
								end
							end
						end
						if not js.loop_jumped then
							if l_canPipeline then
								l_sh.ce_gets ((gethandleathead (l_check.item.send_pipe)))
								l_rh.ce_gets ((gethandleathead (l_check.item.recv_pipe)))
								if ((l_sh).c_pointer /= default_pointer) then
									if not (IsPipeliningPossible (l_sh)) then
										js.continue
									end
								elseif ((l_rh).c_pointer /= default_pointer) then
									if not (IsPipeliningPossible (l_rh)) then
										js.continue
									end
								end
							else
								if l_pipeLen > {NATURAL_32} 0 then
									js.continue
								end
								if not js.loop_jumped then
									if l_check.item.sock[0] = -1 then
										sendf_inst.Curl_infof ([a_data, ce_string ("Connection #%%ld isn%'t open enough, can%'t reuse%N"), l_check.item.connectindex])
										js.continue
									elseif l_check.item.bits.close then
										sendf_inst.Curl_infof ([a_data, ce_string ("Connection #%%ld isn%'t open enough, can%'t reuse%N"), l_check.item.connectindex])
										js.continue
									end
								end
							end
						end
						if not js.loop_jumped and then (((a_needle.item.protocol).bit_and (((1).bit_shift_left (29)).to_integer_32)) /= ((l_check.item.protocol).bit_and (((1).bit_shift_left (29)).to_integer_32))) then
							js.continue
						end
						if not js.loop_jumped and then (((a_needle.item.protocol).bit_and (((1).bit_shift_left (29)).to_integer_32)).to_boolean) then
							if a_data.item.set.ssl.verifypeer /= l_check.item.verifypeer then
								js.continue
							elseif a_data.item.set.ssl.verifyhost /= l_check.item.verifyhost then
								js.continue
							end
						end
						if not js.loop_jumped and then ((a_needle.item.bits.proxy).to_integer /= (l_check.item.bits.proxy).to_integer) then
							js.continue
						end
						if not js.loop_jumped and then (not l_canPipeline) then
							if l_check.item.inuse then
								js.continue
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 38 -- skip if block
						end
				when 3 then -- if:
						if a_needle.item.bits.httpproxy then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 15 -- goto _L___0
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 38
				when 6 then -- else:
						if not (((a_needle.item.protocol).bit_and (((1).bit_shift_left (29)).to_integer_32)).to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 15 -- goto _L___0
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 38
				when 9 then -- else:
						if not (a_needle.item.bits.httpproxy) then
							l_pos := -1 + 37 -- skip if block
						end
				when 10 then -- if:
						if not (l_check.item.bits.httpproxy) then
							l_pos := -1 + 35 -- skip if block
						end
				when 11 then -- if:
						if not (a_needle.item.bits.tunnel_proxy) then
							l_pos := -1 + 33 -- skip if block
						end
				when 12 then -- if:
						if not (l_check.item.bits.tunnel_proxy) then
							l_pos := -1 + 31 -- skip if block
						end
				when 13 then -- if:
						if not ((rawstr_inst.Curl_raw_equal (a_needle.item.proxy.name, l_check.item.proxy.name)).to_boolean) then
							l_pos := -1 + 29 -- skip if block
						end
				when 14 then -- if:
						if a_needle.item.port /= l_check.item.port then
							l_pos := -1 + 27 -- skip if block
						end
				when 15 then -- if: | _L___0:
						if not ((rawstr_inst.Curl_raw_equal ((a_needle.item.handler).item.scheme, (l_check.item.handler).item.scheme)).to_boolean) then
							l_pos := -1 + 26 -- skip if block
						end
				when 16 then -- if:
						if not ((rawstr_inst.Curl_raw_equal (a_needle.item.host.name, l_check.item.host.name)).to_boolean) then
							l_pos := -1 + 26 -- skip if block
						end
				when 17 then -- if:
						if (a_needle.item.remote_port).to_integer_32 /= (l_check.item.remote_port).to_integer_32 then
							l_pos := -1 + 26 -- skip if block
						end
				when 18 then -- if:
						if ((a_needle.item.protocol).bit_and (((1).bit_shift_left (29)).to_integer_32)).to_boolean then
							if (sslgen_inst.Curl_ssl_config_matches (create {CE_POINTER [PD_SSL_CONFIG_DATA]}.make_shared (a_needle.c_pointer + {PD_CONNECTDATA}.ssl_config_offset), create {CE_POINTER [PD_SSL_CONFIG_DATA]}.make_shared (l_check.c_pointer + {PD_CONNECTDATA}.ssl_config_offset))) then
								if (l_check.item.ssl[0].state).to_natural_32 /= {NATURAL_32} 2 then
									js.continue
								end
							else
								js.continue
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 25 -- skip if block
						end
				when 19 then -- if:
						if not (((a_needle.item.protocol).bit_and (((1).bit_shift_left (2)).to_integer_32)).to_boolean) then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						l_pos := -1 + 24 -- goto _L
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 22 then -- else:
						if not (((a_needle.item.protocol).bit_and (1)).to_boolean) then
							l_pos := -1 + 25 -- skip if block
						end
				when 23 then -- if:
						if a_data.item.state.authhost.want /= ((1).bit_shift_left (3)).to_integer_32 then
							l_pos := -1 + 25 -- skip if block
						end
				when 24 then -- if: | _L:
						if (strequal_inst.curl_strequal (a_needle.item.user, l_check.item.user)).to_boolean then
							if not (strequal_inst.curl_strequal (a_needle.item.passwd, l_check.item.passwd)).to_boolean then
								js.continue
							end
						else
							js.continue
						end
				when 25 then -- if done | if done | if done
						if not js.loop_jumped then
							l_match := (1).to_boolean
						end
				when 26 then -- if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 28
				when 27 then -- else:
						l_pos := -1 + 37 -- goto _L___5
				when 28 then -- if done | if block done, skip else block:
						l_pos := -1 + 30
				when 29 then -- else:
						l_pos := -1 + 37 -- goto _L___5
				when 30 then -- if done | if block done, skip else block:
						l_pos := -1 + 32
				when 31 then -- else:
						l_pos := -1 + 37 -- goto _L___5
				when 32 then -- if done | if block done, skip else block:
						l_pos := -1 + 34
				when 33 then -- else:
						l_pos := -1 + 37 -- goto _L___5
				when 34 then -- if done | if block done, skip else block:
						l_pos := -1 + 36
				when 35 then -- else:
						l_pos := -1 + 37 -- goto _L___5
				when 36 then -- if done | if block done, skip else block:
						l_pos := -1 + 38
				when 37 then -- else: | _L___5:
						if l_check.item.bits.proxy then
							if (a_needle.item.proxytype).to_natural_32 = (l_check.item.proxytype).to_natural_32 then
								if (a_needle.item.bits.tunnel_proxy).to_integer = (l_check.item.bits.tunnel_proxy).to_integer then
									if (rawstr_inst.Curl_raw_equal (a_needle.item.proxy.name, l_check.item.proxy.name)).to_boolean then
										if a_needle.item.port = l_check.item.port then
											l_match := (1).to_boolean
										end
									end
								end
							end
						end
				when 38 then -- if done | if done | if done
						if not js.loop_jumped and then l_match then
							l_check.item.inuse := (1).to_boolean
							a_usethis.item := l_check
							Result := (1).to_boolean
							js.return
						end
						if not js.loop_left then
							l_i := l_i + 1
						end
						l_pos := -1 + 1 -- back to loop condition
				when 39 then -- loop done
					if not js.return_called then
						Result := (0).to_boolean
					end
				when 40 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ConnectionKillOne (a_data: CE_POINTER [PD_SESSIONHANDLE]): INTEGER_32
		local
			l_i: INTEGER_32
			l_conn: CE_POINTER [PD_CONNECTDATA]
			l_highscore: INTEGER_32
			l_connindex: INTEGER_32
			l_score: INTEGER_32
			l_now: SD_TIMEVAL
			js: JUMP_STATE
		do
			create l_conn.make
			create l_now.make

			l_highscore := -1
			l_connindex := -1
			l_now.ce_gets (timeval_inst.curlx_tvnow)
			l_i := 0
			from
			until
				js.loop_left
			loop
				js.reset
				if ((a_data.item.state.connc).c_pointer /= default_pointer) then
					if not (l_i < (a_data.item.state.connc).item.num) then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					l_conn.ce_gets ((a_data.item.state.connc).item.connects[l_i])
					if (l_conn).c_pointer = default_pointer then
						js.continue
					elseif l_conn.item.inuse then
						js.continue
					end
				end
				if not js.loop_jumped then
					l_score := timeval_inst.curlx_tvdiff (l_now, l_conn.item.now)
					if l_score > l_highscore then
						l_highscore := l_score
						l_connindex := l_i
					end
				end
				if not js.loop_left then
					l_i := l_i + 1
				end
			end
			js.reset
			if l_connindex >= 0 then
				l_conn.ce_gets ((a_data.item.state.connc).item.connects[l_connindex])
				l_conn.item.data := a_data
				Curl_disconnect (l_conn).do_nothing;
				(a_data.item.state.connc).item.connects[l_connindex] := create {CE_POINTER [PD_CONNECTDATA]}.make_shared (default_pointer)
			end
			Result := l_connindex
		end

	ConnectionDone (a_conn: CE_POINTER [PD_CONNECTDATA])
		do
			a_conn.item.inuse := (0).to_boolean
		end

	ConnectionStore (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_conn: CE_POINTER [PD_CONNECTDATA]): INTEGER_32
		local
			l_i: INTEGER_32
			js: JUMP_STATE
		do
			l_i := 0
			from
			until
				not (not js.loop_left and then (l_i < (a_data.item.state.connc).item.num))
			loop
				js.reset
				if ((a_data.item.state.connc).item.connects[l_i]).c_pointer = default_pointer then
					js.break
				end
				if not js.loop_jumped then
					l_i := l_i + 1
				end
			end
			js.reset
			if l_i = (a_data.item.state.connc).item.num then
				l_i := ConnectionKillOne (a_data)
				if -1 /= l_i then
					sendf_inst.Curl_infof ([a_data, ce_string ("Connection (#%%ld) was killed to make room (holds %%ld)%N"), l_i, (a_data.item.state.connc).item.num])
				else
					sendf_inst.Curl_infof ([a_data, ce_string ("This connection did not fit in the connection cache%N")])
				end
			end
			a_conn.item.connectindex := l_i
			a_conn.item.inuse := (1).to_boolean
			if -1 /= l_i then
				(a_data.item.state.connc).item.connects[l_i] := a_conn
				a_conn.item.data := a_data
			end
			Result := l_i
		end

	Curl_connected_proxy (a_conn: CE_POINTER [PD_CONNECTDATA]): INTEGER_32
		local
			l_result: INTEGER_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_pos: INTEGER_32
		do
			create l_data.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_result := {PC_CURLCODE}.CURLE_OK
					l_data.ce_gets (a_conn.item.data)
					inspect l_data.item.set.proxytype -- switch 1 head
					when 5 then l_pos := -1 + 1
					when 7 then l_pos := -1 + 1
					when 4 then l_pos := -1 + 2
					when 6 then l_pos := -1 + 3
					when 0 then l_pos := -1 + 4
					when 1 then l_pos := -1 + 4
					else l_pos := -1 + 5
					end
				when 1 then -- switch 1, case 5 | switch 1, case 7
					l_result := socks_inst.Curl_SOCKS5 (a_conn.item.proxyuser, a_conn.item.proxypasswd, a_conn.item.host.name, (a_conn.item.remote_port).to_integer_32, 0, a_conn)
					l_pos := -1 + 6 -- switch 1; break
				when 2 then -- switch 1, case 4
					l_result := socks_inst.Curl_SOCKS4 (a_conn.item.proxyuser, a_conn.item.host.name, (a_conn.item.remote_port).to_integer_32, 0, a_conn, (0).to_boolean)
					l_pos := -1 + 6 -- switch 1; break
				when 3 then -- switch 1, case 6
					l_result := socks_inst.Curl_SOCKS4 (a_conn.item.proxyuser, a_conn.item.host.name, (a_conn.item.remote_port).to_integer_32, 0, a_conn, (1).to_boolean)
					l_pos := -1 + 6 -- switch 1; break
				when 4 then -- switch 1, case 0 | switch 1, case 1
					l_pos := -1 + 6 -- switch 1; break
				when 5 then -- switch 1, default:
					l_pos := -1 + 6 -- switch 1; break
				when 6 then -- switch 1, done:
					Result := l_result
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ConnectPlease (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_conn: CE_POINTER [PD_CONNECTDATA]; a_connected: CE_POINTER [BOOLEAN]): INTEGER_32
		local
			l_result: INTEGER_32
			l_addr: CE_POINTER [PD_CURL_ADDRINFO]
			l_hostname: CE_POINTER [INTEGER_8]
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
		do
			create l_addr.make
			create l_hostname.make
			create l_tmp.make
			create l_tmp___0.make

			if a_conn.item.bits.proxy then
				l_tmp.ce_gets (a_conn.item.proxy.name)
			else
				l_tmp.ce_gets (a_conn.item.host.name)
			end
			l_hostname.ce_gets (l_tmp)
			if a_conn.item.bits.proxy then
				l_tmp___0.ce_gets (ce_string ("proxy "))
			else
				l_tmp___0.ce_gets (ce_string (""))
			end
			sendf_inst.Curl_infof ([a_data, ce_string ("About to connect() to %%s%%s port %%ld (#%%ld)%N"), l_tmp___0, l_hostname, a_conn.item.port, a_conn.item.connectindex])
			l_result := connect_inst.Curl_connecthost (a_conn, a_conn.item.dns_entry, a_conn.item.sock + 0, l_addr.address, a_connected)
			if {NATURAL_32} 0 = l_result.to_natural_32 then
				a_conn.item.ip_addr := l_addr
				if a_connected.item then
					l_result := Curl_connected_proxy (a_conn)
				end
			end
			if l_result.to_boolean then
				a_connected.item := (0).to_boolean
			end
			Result := l_result
		end

	Curl_verboseconnect (a_conn: CE_POINTER [PD_CONNECTDATA])
		local
			l_tmp: CE_POINTER [INTEGER_8]
		do
			create l_tmp.make

			if (a_conn.item.data).item.set.verbose then
				if a_conn.item.bits.proxy then
					l_tmp.ce_gets (a_conn.item.proxy.dispname)
				else
					l_tmp.ce_gets (a_conn.item.host.dispname)
				end
				sendf_inst.Curl_infof ([a_conn.item.data, ce_string ("Connected to %%s (%%s) port %%ld (#%%ld)%N"), l_tmp, a_conn.item.ip_addr_str, a_conn.item.port, a_conn.item.connectindex])
			end
		end

	Curl_protocol_getsock (a_conn: CE_POINTER [PD_CONNECTDATA]; a_socks: CE_POINTER [INTEGER_32]; a_numsocks: INTEGER_32): INTEGER_32
		local
			js: JUMP_STATE
		do
			if (((a_conn.item.handler).item.proto_getsock).c_pointer /= default_pointer) then
				Result := (((a_conn.item.handler).item.proto_getsock).integer_32_item ([a_conn, a_socks, a_numsocks]))
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	Curl_doing_getsock (a_conn: CE_POINTER [PD_CONNECTDATA]; a_socks: CE_POINTER [INTEGER_32]; a_numsocks: INTEGER_32): INTEGER_32
		local
			js: JUMP_STATE
		do
			if ((a_conn).c_pointer /= default_pointer) then
				if (((a_conn.item.handler).item.doing_getsock).c_pointer /= default_pointer) then
					Result := (((a_conn.item.handler).item.doing_getsock).integer_32_item ([a_conn, a_socks, a_numsocks]))
					js.return
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	Curl_protocol_connecting (a_conn: CE_POINTER [PD_CONNECTDATA]; a_done: CE_POINTER [BOOLEAN]): INTEGER_32
		local
			l_result: INTEGER_32
		do
			l_result := {PC_CURLCODE}.CURLE_OK
			if ((a_conn).c_pointer /= default_pointer) then
				if (((a_conn.item.handler).item.connecting).c_pointer /= default_pointer) then
					a_done.item := (0).to_boolean
					l_result := ((a_conn.item.handler).item.connecting).integer_32_item ([a_conn, a_done])
				else
					a_done.item := (1).to_boolean
				end
			else
				a_done.item := (1).to_boolean
			end
			Result := l_result
		end

	Curl_protocol_doing (a_conn: CE_POINTER [PD_CONNECTDATA]; a_done: CE_POINTER [BOOLEAN]): INTEGER_32
		local
			l_result: INTEGER_32
		do
			l_result := {PC_CURLCODE}.CURLE_OK
			if ((a_conn).c_pointer /= default_pointer) then
				if (((a_conn.item.handler).item.doing).c_pointer /= default_pointer) then
					a_done.item := (0).to_boolean
					l_result := ((a_conn.item.handler).item.doing).integer_32_item ([a_conn, a_done])
				else
					a_done.item := (1).to_boolean
				end
			else
				a_done.item := (1).to_boolean
			end
			Result := l_result
		end

	Curl_protocol_connect (a_conn: CE_POINTER [PD_CONNECTDATA]; a_protocol_done: CE_POINTER [BOOLEAN]): INTEGER_32
		local
			l_result: INTEGER_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			js: JUMP_STATE
		do
			create l_data.make

			l_result := {PC_CURLCODE}.CURLE_OK
			l_data.ce_gets (a_conn.item.data)
			a_protocol_done.item := (0).to_boolean
			if a_conn.item.bits.tcpconnect then
				if a_conn.item.bits.protoconnstart then
					if ((a_conn.item.handler).item.connecting).c_pointer = default_pointer then
						a_protocol_done.item := (1).to_boolean
					end
					Result := ({PC_CURLCODE}.CURLE_OK)
					js.return
				end
			end
			if not js.return_called then
				if not a_conn.item.bits.tcpconnect then
					progress_inst.Curl_pgrsTime (l_data, {PC_TIMERID}.TIMER_CONNECT)
					Curl_verboseconnect (a_conn)
				end
				if not a_conn.item.bits.protoconnstart then
					if (((a_conn.item.handler).item.connect_it).c_pointer /= default_pointer) then
						a_conn.item.now := timeval_inst.curlx_tvnow
						l_result := ((a_conn.item.handler).item.connect_it).integer_32_item ([a_conn, a_protocol_done])
					else
						a_protocol_done.item := (1).to_boolean
					end
					if not l_result.to_boolean then
						a_conn.item.bits.protoconnstart := (1).to_boolean
					end
				end
				Result := l_result
			end
		end

	fix_hostname (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_conn: CE_POINTER [PD_CONNECTDATA]; a_host: CE_POINTER [PD_HOSTNAME])
		do
			a_host.item.dispname := a_host.item.name
		end

	allocate_conn: CE_POINTER [PD_CONNECTDATA]
		local
			l_conn: CE_POINTER [PD_CONNECTDATA]
			js: JUMP_STATE
		do
			create l_conn.make

			l_conn.ce_gets (create {CE_POINTER [PD_CONNECTDATA]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_ccalloc.pointer_item ([(1).to_natural_32, {PD_CONNECTDATA}.sizeof.to_natural_32])))))
			if (l_conn).c_pointer = default_pointer then
				Result := (create {CE_POINTER [PD_CONNECTDATA]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				l_conn.item.handler := Curl_handler_dummy.address
				l_conn.item.sock[0] := -1
				l_conn.item.sock[1] := -1
				l_conn.item.connectindex := -1
				l_conn.item.port := -1
				l_conn.item.bits.close := (1).to_boolean
				l_conn.item.created := timeval_inst.curlx_tvnow
				Result := l_conn
			end
		end

	findprotocol (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_conn: CE_POINTER [PD_CONNECTDATA]; a_protostr: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_pp: CE_POINTER [CE_POINTER [PD_CURL_HANDLER]]
			l_p: CE_POINTER [PD_CURL_HANDLER]
			js: JUMP_STATE
		do
			create l_pp.make
			create l_p.make

			l_pp.ce_gets (protocols)
			from
			until
				js.loop_left
			loop
				js.reset
				l_p.ce_gets (l_pp.item)
				if (l_p.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					js.break
				end
				if not js.loop_jumped then
					if (rawstr_inst.Curl_raw_equal (l_p.item.scheme, a_protostr)).to_boolean then
						if not ((a_data.item.set.allowed_protocols).bit_and (l_p.item.protocol)).to_boolean then
							js.break
						end
						if not js.loop_jumped and then (a_data.item.state.this_is_a_follow) then
							if not ((a_data.item.set.redir_protocols).bit_and (l_p.item.protocol)).to_boolean then
								js.break
							end
						end
						if not js.loop_jumped then
							a_conn.item.handler := l_p
							a_conn.item.protocol := (a_conn.item.protocol).bit_or ((l_p.item.protocol))
							Result := ({PC_CURLCODE}.CURLE_OK)
							js.return
						end
					end
				end
				if not js.loop_jumped then
					l_pp.ce_gets (l_pp + 1)
				end
			end
			js.reset
			if not js.return_called then
				sendf_inst.Curl_failf ([a_data, ce_string ("Protocol %%s not supported or disabled in libcurl"), a_protostr])
				Result := ({PC_CURLCODE}.CURLE_UNSUPPORTED_PROTOCOL)
			end
		end

	parseurlandfillconn (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_conn: CE_POINTER [PD_CONNECTDATA]; a_prot_missing: CE_POINTER [BOOLEAN]): INTEGER_32
		local
			l_at: CE_POINTER [INTEGER_8]
			l_fragment: CE_POINTER [INTEGER_8]
			l_path: CE_POINTER [INTEGER_8]
			l_query: CE_POINTER [INTEGER_8]
			l_rc: INTEGER_32
			l_protobuf: CE_ARRAY [INTEGER_8]
			l_protop: CE_POINTER [INTEGER_8]
			l_ptr: CE_POINTER [INTEGER_8]
			l_hostlen: NATURAL_32
			l_pathlen: NATURAL_32
			l_percent: CE_POINTER [INTEGER_8]
			l_endp: CE_POINTER [INTEGER_8]
			l_scope: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_at.make
			create l_fragment.make
			create l_path.make
			create l_query.make
			create l_protobuf.make (<<16>>)
			create l_protop.make
			create l_ptr.make
			create l_percent.make
			create l_endp.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_path.ce_gets (a_data.item.state.path)
					a_prot_missing.item := (0).to_boolean
					if 2 /= (sscanf ([a_data.item.change.url, ce_string ("%%15[^:]:%%[^%N]"), l_protobuf, l_path])) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if (rawstr_inst.Curl_raw_equal (l_protobuf, ce_string ("file"))).to_boolean then
							if (l_path[0]).to_integer_32 = 47 then
								if (l_path[1]).to_integer_32 = 47 then
									memmove (create {CE_POINTER [ANY]}.make_cast (l_path), create {CE_POINTER [ANY]}.make_cast ((l_path + 2)), (strlen ((l_path + 2))) + {NATURAL_32} 1).do_nothing
								end
							end
							if (l_path[0]).to_integer_32 /= 47 then
								l_ptr.ce_gets ((strchr (l_path, ('/').code)))
								if ((l_ptr).c_pointer /= default_pointer) then
									if (l_ptr[1]).to_boolean then
										if 47 = (l_ptr[1]).to_integer_32 then
											l_ptr.ce_gets (l_ptr + 1)
										end
									end
									memmove (create {CE_POINTER [ANY]}.make_cast (l_path), create {CE_POINTER [ANY]}.make_cast (l_ptr), (strlen (l_ptr)) + {NATURAL_32} 1).do_nothing
								end
							end
							l_protop.ce_gets (ce_string ("file"))
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						l_path[0] := (0).to_integer_8
						if 2 > (sscanf ([a_data.item.change.url, ce_string ("%%15[^%N:]://%%[^%N/]%%[^%N]"), l_protobuf, a_conn.item.host.name, l_path])) then
							l_rc := sscanf ([a_data.item.change.url, ce_string ("%%[^%N/]%%[^%N]"), a_conn.item.host.name, l_path])
							if 1 > l_rc then
								sendf_inst.Curl_failf ([a_data, ce_string ("<url> malformed")])
								Result := ({PC_CURLCODE}.CURLE_URL_MALFORMAT)
								js.return
							end
							if not js.return_called then
								if (rawstr_inst.Curl_raw_nequal (ce_string ("FTP."), a_conn.item.host.name, (strlen (ce_string ("FTP."))))).to_boolean then
									l_protop.ce_gets (ce_string ("ftp"))
								elseif (rawstr_inst.Curl_raw_nequal (ce_string ("DICT."), a_conn.item.host.name, (strlen (ce_string ("DICT."))))).to_boolean then
									l_protop.ce_gets (ce_string ("DICT"))
								elseif (rawstr_inst.Curl_raw_nequal (ce_string ("LDAP."), a_conn.item.host.name, (strlen (ce_string ("LDAP."))))).to_boolean then
									l_protop.ce_gets (ce_string ("LDAP"))
								elseif (rawstr_inst.Curl_raw_nequal (ce_string ("IMAP."), a_conn.item.host.name, (strlen (ce_string ("IMAP."))))).to_boolean then
									l_protop.ce_gets (ce_string ("IMAP"))
								else
									l_protop.ce_gets (ce_string ("http"))
								end
								a_prot_missing.item := (1).to_boolean
							end
						else
							l_protop.ce_gets (l_protobuf)
						end
				when 4 then
					if not js.return_called then
						l_at.ce_gets (strchr (a_conn.item.host.name, ('@').code))
						if ((l_at).c_pointer /= default_pointer) then
							l_query.ce_gets (strchr ((l_at + 1), ('?').code))
						else
							l_query.ce_gets (strchr (a_conn.item.host.name, ('?').code))
						end
						if ((l_query).c_pointer /= default_pointer) then
							l_hostlen := (strlen (l_query))
							l_pathlen := (strlen (l_path))
							memmove (create {CE_POINTER [ANY]}.make_cast (((l_path + l_hostlen.to_integer_32) + 1)), create {CE_POINTER [ANY]}.make_cast (l_path), l_pathlen + {NATURAL_32} 1).do_nothing
							memcpy (create {CE_POINTER [ANY]}.make_cast ((l_path + 1)), create {CE_POINTER [ANY]}.make_cast (l_query), l_hostlen).do_nothing
							l_path[0] := (('/').code).to_integer_8
							l_query[0] := (0).to_integer_8
						elseif not (l_path[0]).to_boolean then
							strcpy (l_path, ce_string ("/")).do_nothing
						end
						if (l_path[0]).to_integer_32 = 63 then
							memmove (create {CE_POINTER [ANY]}.make_cast ((l_path + 1)), create {CE_POINTER [ANY]}.make_cast (l_path), (strlen (l_path)) + {NATURAL_32} 1).do_nothing
							l_path[0] := (('/').code).to_integer_8
						end
						if (a_conn.item.host.name[0]).to_integer_32 = 91 then
							l_percent.ce_gets ((strstr (a_conn.item.host.name, ce_string ("%%25"))))
							if ((l_percent).c_pointer /= default_pointer) then
								l_scope := (strtoul ((l_percent + 3), (l_endp.address), 10))
								if (l_endp[0]).to_integer_32 = 93 then
									memmove (create {CE_POINTER [ANY]}.make_cast (l_percent), create {CE_POINTER [ANY]}.make_cast (l_endp), (strlen (l_endp)) + {NATURAL_32} 1).do_nothing
									if not a_data.item.state.this_is_a_follow then
										a_conn.item.scope := l_scope.to_natural_32
									end
								else
									sendf_inst.Curl_infof ([a_data, ce_string ("Invalid IPv6 address format%N")])
								end
							end
						end
						if (a_data.item.set.scope).to_boolean then
							a_conn.item.scope := a_data.item.set.scope
						end
						l_fragment.ce_gets (strchr (l_path, ('#').code))
						if ((l_fragment).c_pointer /= default_pointer) then
							l_fragment[0] := (0).to_integer_8
						end
						Result := (findprotocol (a_data, a_conn, l_protop))
					end
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	llist_dtor (a_user: CE_POINTER [ANY]; a_element: CE_POINTER [ANY])
		do
		end

	llist_dtor_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent llist_dtor)
		end

	setup_range (a_data: CE_POINTER [PD_SESSIONHANDLE]): INTEGER_32
		local
			l_s: CE_POINTER [PD_URLSTATE]
			l_tmp: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_s.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_s.ce_gets (create {CE_POINTER [PD_URLSTATE]}.make_shared (a_data.c_pointer + {PD_SESSIONHANDLE}.state_offset))
					l_s.item.resume_from := a_data.item.set.set_resume_from
					if not ((l_s.item.resume_from).to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if (a_data.item.set.str[17]).c_pointer = default_pointer then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						if l_s.item.rangestringalloc then
							easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_s.item.range)])
						end
						if (l_s.item.resume_from).to_boolean then
							l_s.item.range := mprintf_inst.curl_maprintf ([ce_string ("%%llu-"), l_s.item.resume_from])
						else
							l_s.item.range := create {CE_POINTER [INTEGER_8]}.make_cast (easy_inst.Curl_cstrdup.pointer_item ([a_data.item.set.str[17]]))
						end
						if ((l_s.item.range).c_pointer /= default_pointer) then
							l_tmp := 1
						else
							l_tmp := 0
						end
						l_s.item.rangestringalloc := l_tmp.to_boolean
						if (l_s.item.range).c_pointer = default_pointer then
							Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
							js.return
						end
						if not js.return_called then
							l_s.item.use_range := (1).to_boolean
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						l_s.item.use_range := (0).to_boolean
				when 7 then -- if done
						if not js.return_called then
							Result := ({PC_CURLCODE}.CURLE_OK)
						end
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	setup_connection_internals (a_conn: CE_POINTER [PD_CONNECTDATA]): INTEGER_32
		local
			l_p: CE_POINTER [PD_CURL_HANDLER]
			l_result: INTEGER_32
			js: JUMP_STATE
		do
			create l_p.make

			a_conn.item.socktype := 1
			l_p.ce_gets (a_conn.item.handler)
			if ((l_p.item.setup_connection).c_pointer /= default_pointer) then
				l_result := (l_p.item.setup_connection).integer_32_item ([a_conn])
				if l_result.to_natural_32 /= {NATURAL_32} 0 then
					Result := l_result
					js.return
				end
				if not js.return_called then
					l_p.ce_gets (a_conn.item.handler)
				end
			end
			if not js.return_called then
				if a_conn.item.port < 0 then
					a_conn.item.port := l_p.item.defport
				end
				a_conn.item.remote_port := (l_p.item.defport).to_natural_16
				a_conn.item.protocol := (a_conn.item.protocol).bit_or ((l_p.item.protocol))
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	check_noproxy (a_name: CE_POINTER [INTEGER_8]; a_no_proxy: CE_POINTER [INTEGER_8]): BOOLEAN
		local
			l_tok_start: NATURAL_32
			l_tok_end: NATURAL_32
			l_separator: CE_POINTER [INTEGER_8]
			l_no_proxy_len: NATURAL_32
			l_namelen: NATURAL_32
			l_endptr: CE_POINTER [INTEGER_8]
			l_checkn: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_separator.make
			create l_endptr.make
			create l_checkn.make

			l_separator.ce_gets (ce_string (", "))
			if ((a_no_proxy).c_pointer /= default_pointer) then
				if (a_no_proxy[0]).to_boolean then
					if (rawstr_inst.Curl_raw_equal (ce_string ("*"), a_no_proxy)).to_boolean then
						Result := (1).to_boolean
						js.return
					end
					if not js.return_called then
						l_no_proxy_len := strlen (a_no_proxy)
						l_endptr.ce_gets (strchr (a_name, (':').code))
						if ((l_endptr).c_pointer /= default_pointer) then
							l_namelen := (l_endptr.distance (a_name)).to_natural_32
						else
							l_namelen := strlen (a_name)
						end
						l_tok_start := (0).to_natural_32
						from
						until
							not (not js.loop_left and then (l_tok_start < l_no_proxy_len))
						loop
							js.reset
							from
							until
								js.loop_left
							loop
								js.reset
								if l_tok_start < l_no_proxy_len then
									if ((strchr (l_separator, (a_no_proxy[l_tok_start.to_integer_32]).to_integer_32)).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped then
									l_tok_start := l_tok_start + 1
								end
							end
							js.reset
							if l_tok_start = l_no_proxy_len then
								js.break
							end
							if not js.loop_jumped then
								l_tok_end := l_tok_start
								from
								until
									js.loop_left
								loop
									js.reset
									if l_tok_end < l_no_proxy_len then
										if ((strchr (l_separator, (a_no_proxy[l_tok_end.to_integer_32]).to_integer_32)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
											js.break
										end
									else
										js.break
									end
									if not js.loop_jumped then
										l_tok_end := l_tok_end + 1
									end
								end
								js.reset
								if (a_no_proxy[l_tok_start.to_integer_32]).to_integer_32 = 46 then
									l_tok_start := l_tok_start + 1
								end
								if l_tok_end - l_tok_start <= l_namelen then
									l_checkn.ce_gets ((a_name + l_namelen.to_integer_32) - (l_tok_end - l_tok_start).to_integer_32)
									if (rawstr_inst.Curl_raw_nequal (a_no_proxy + l_tok_start.to_integer_32, l_checkn, l_tok_end - l_tok_start)).to_boolean then
										if l_tok_end - l_tok_start = l_namelen then
											Result := (1).to_boolean
											js.return
										elseif (l_checkn[-1]).to_integer_32 = 46 then
											Result := (1).to_boolean
											js.return
										end
									end
								end
								if not js.return_called then
									l_tok_start := l_tok_end + {NATURAL_32} 1
								end
							end
						end
						js.reset
					end
				end
			end
			if not js.return_called then
				Result := (0).to_boolean
			end
		end

	detect_proxy (a_conn: CE_POINTER [PD_CONNECTDATA]): CE_POINTER [INTEGER_8]
		local
			l_proxy: CE_POINTER [INTEGER_8]
			l_no_proxy: CE_POINTER [INTEGER_8]
			l_proxy_env: CE_ARRAY [INTEGER_8]
			l_protop: CE_POINTER [INTEGER_8]
			l_envp: CE_POINTER [INTEGER_8]
			l_prox: CE_POINTER [INTEGER_8]
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_pos: INTEGER_32
		do
			create l_proxy.make
			create l_no_proxy.make
			create l_proxy_env.make (<<128>>)
			create l_protop.make
			create l_envp.make
			create l_prox.make
			create l_tmp.make
			create l_tmp___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_proxy.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
					l_no_proxy.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
					l_no_proxy.ce_gets (getenv_inst.curl_getenv (ce_string ("no_proxy")))
					if (l_no_proxy).c_pointer = default_pointer then
						l_no_proxy.ce_gets (getenv_inst.curl_getenv (ce_string ("NO_PROXY")))
					end
					if (check_noproxy (a_conn.item.host.name, l_no_proxy)) then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						l_protop.ce_gets ((a_conn.item.handler).item.scheme)
						l_envp.ce_gets (l_proxy_env)
						from
						until
							not ((l_protop[0]).to_boolean)
						loop
							l_tmp.ce_gets (l_envp)
							l_envp.ce_gets (l_envp + 1)
							l_tmp___0.ce_gets (l_protop)
							l_protop.ce_gets (l_protop + 1)
							l_tmp[0] := (tolower ((l_tmp___0[0]).to_integer_32)).to_integer_8
						end
						strcpy (l_envp, ce_string ("_proxy")).do_nothing
						l_prox.ce_gets (getenv_inst.curl_getenv (l_proxy_env))
						if (l_prox).c_pointer = default_pointer then
							if not (rawstr_inst.Curl_raw_equal (ce_string ("http_proxy"), l_proxy_env)).to_boolean then
								rawstr_inst.Curl_strntoupper (l_proxy_env, l_proxy_env, (Integer_8_bytes.to_natural_32 * (128).to_natural_32))
								l_prox.ce_gets (getenv_inst.curl_getenv (l_proxy_env))
							end
						end
						if (l_prox).c_pointer = default_pointer then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if (l_prox[0]).to_boolean then
							l_proxy.ce_gets (l_prox)
						else
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						l_proxy.ce_gets (getenv_inst.curl_getenv (ce_string ("all_proxy")))
						if (l_proxy).c_pointer = default_pointer then
							l_proxy.ce_gets (getenv_inst.curl_getenv (ce_string ("ALL_PROXY")))
						end
				when 5 then -- if done
						if ((l_no_proxy).c_pointer /= default_pointer) then
							easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_no_proxy)])
						end
						Result := l_proxy
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	parse_proxy (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_conn: CE_POINTER [PD_CONNECTDATA]; a_proxy: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_proxy: CE_POINTER [INTEGER_8]
			l_prox_portno: CE_POINTER [INTEGER_8]
			l_endofprot: CE_POINTER [INTEGER_8]
			l_proxyptr: CE_POINTER [INTEGER_8]
			l_portptr: CE_POINTER [INTEGER_8]
			l_atsign: CE_POINTER [INTEGER_8]
			l_proxyuser: CE_ARRAY [INTEGER_8]
			l_proxypasswd: CE_ARRAY [INTEGER_8]
			l_res: INTEGER_32
			l_ptr: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_proxy.make
			create l_prox_portno.make
			create l_endofprot.make
			create l_proxyptr.make
			create l_portptr.make
			create l_atsign.make
			create l_proxyuser.make (<<256>>)
			create l_proxypasswd.make (<<256>>)
			create l_ptr.make
			create l_tmp___1.make

			l_proxy.ce_gets (a_proxy)
			l_endofprot.ce_gets (strstr (l_proxy, ce_string ("://")))
			if ((l_endofprot).c_pointer /= default_pointer) then
				l_proxyptr.ce_gets (l_endofprot + 3)
			else
				l_proxyptr.ce_gets (l_proxy)
			end
			l_atsign.ce_gets (strchr (l_proxyptr, ('@').code))
			if ((l_atsign).c_pointer /= default_pointer) then
				l_proxypasswd[0] := (0).to_integer_8
				if 1 <= (sscanf ([l_proxyptr, ce_string ("%%255[^:@]:%%255[^@]"), l_proxyuser, l_proxypasswd])) then
					l_res := {PC_CURLCODE}.CURLE_OK
					Curl_safefree (create {CE_POINTER [ANY]}.make_cast (a_conn.item.proxyuser))
					a_conn.item.proxyuser := escape_inst.curl_easy_unescape (create {CE_POINTER [ANY]}.make_cast (a_data), l_proxyuser, 0, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
					if (a_conn.item.proxyuser).c_pointer = default_pointer then
						l_res := {PC_CURLCODE}.CURLE_OUT_OF_MEMORY
					else
						Curl_safefree (create {CE_POINTER [ANY]}.make_cast (a_conn.item.proxypasswd))
						a_conn.item.proxypasswd := escape_inst.curl_easy_unescape (create {CE_POINTER [ANY]}.make_cast (a_data), l_proxypasswd, 0, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
						if (a_conn.item.proxypasswd).c_pointer = default_pointer then
							l_res := {PC_CURLCODE}.CURLE_OUT_OF_MEMORY
						end
					end
					if {NATURAL_32} 0 = l_res.to_natural_32 then
						a_conn.item.bits.proxy_user_passwd := (1).to_boolean
						l_atsign.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast (easy_inst.Curl_cstrdup.pointer_item ([(l_atsign + 1)])))
						if ((l_atsign).c_pointer /= default_pointer) then
							easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_proxy)])
							l_proxyptr.ce_gets (l_atsign)
							l_proxy.ce_gets (l_proxyptr)
						else
							l_res := {PC_CURLCODE}.CURLE_OUT_OF_MEMORY
						end
					end
					if l_res.to_boolean then
						easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_proxy)])
						Result := l_res
						js.return
					end
				end
			end
			if not js.return_called then
				l_portptr.ce_gets (l_proxyptr)
				if (l_proxyptr[0]).to_integer_32 = 91 then
					l_proxyptr.ce_gets (l_proxyptr + 1)
					l_ptr.ce_gets (l_proxyptr)
					from
					until
						js.loop_left
					loop
						js.reset
						if (l_ptr[0]).to_boolean then
							if not ((((ctype_b_loc).item[((l_ptr[0]).to_natural_8).to_integer_32]).to_integer_32).bit_and (4096)).to_boolean then
								if (l_ptr[0]).to_integer_32 /= 58 then
									if (l_ptr[0]).to_integer_32 /= 37 then
										if (l_ptr[0]).to_integer_32 /= 46 then
											js.break
										end
									end
								end
							end
						else
							js.break
						end
						if not js.loop_jumped then
							l_ptr.ce_gets (l_ptr + 1)
						end
					end
					js.reset
					if (l_ptr[0]).to_integer_32 = 93 then
						l_tmp___1.ce_gets (l_ptr)
						l_ptr.ce_gets (l_ptr + 1)
						l_tmp___1[0] := (0).to_integer_8
					else
						sendf_inst.Curl_infof ([a_data, ce_string ("Invalid IPv6 address format%N")])
					end
					l_portptr.ce_gets (l_ptr)
				end
				l_prox_portno.ce_gets (strchr (l_portptr, (':').code))
				if ((l_prox_portno).c_pointer /= default_pointer) then
					l_prox_portno[0] := (0).to_integer_8
					l_prox_portno.ce_gets (l_prox_portno + 1)
					a_conn.item.port := (atoi (l_prox_portno)).to_integer_32
				else
					l_atsign.ce_gets (strchr (l_proxyptr, ('/').code))
					if ((l_atsign).c_pointer /= default_pointer) then
						l_atsign[0] := (0).to_integer_8
					end
					if (a_data.item.set.proxyport).to_boolean then
						a_conn.item.port := a_data.item.set.proxyport
					end
				end
				a_conn.item.proxy.rawalloc := create {CE_POINTER [INTEGER_8]}.make_cast (easy_inst.Curl_cstrdup.pointer_item ([l_proxyptr]))
				a_conn.item.proxy.name := a_conn.item.proxy.rawalloc
				easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_proxy)])
				if (a_conn.item.proxy.rawalloc).c_pointer = default_pointer then
					Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
					js.return
				end
			end
			if not js.return_called then
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	parse_proxy_auth (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_conn: CE_POINTER [PD_CONNECTDATA]): INTEGER_32
		local
			l_proxyuser: CE_ARRAY [INTEGER_8]
			l_proxypasswd: CE_ARRAY [INTEGER_8]
			js: JUMP_STATE
		do
			create l_proxyuser.make (<<256>>)
			create l_proxypasswd.make (<<256>>)

			l_proxyuser[0] := (('%/0/').code).to_integer_8
			l_proxypasswd[0] := (('%/0/').code).to_integer_8
			if ((a_data.item.set.str[30]).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				strncpy (l_proxyuser, a_data.item.set.str[30], (256).to_natural_32).do_nothing
				l_proxyuser[255] := (('%/0/').code).to_integer_8
			end
			if ((a_data.item.set.str[31]).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				strncpy (l_proxypasswd, a_data.item.set.str[31], (256).to_natural_32).do_nothing
				l_proxypasswd[255] := (('%/0/').code).to_integer_8
			end
			a_conn.item.proxyuser := escape_inst.curl_easy_unescape (create {CE_POINTER [ANY]}.make_cast (a_data), l_proxyuser, 0, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
			if (a_conn.item.proxyuser).c_pointer = default_pointer then
				Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
				js.return
			end
			if not js.return_called then
				a_conn.item.proxypasswd := escape_inst.curl_easy_unescape (create {CE_POINTER [ANY]}.make_cast (a_data), l_proxypasswd, 0, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
				if (a_conn.item.proxypasswd).c_pointer = default_pointer then
					Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
					js.return
				end
			end
			if not js.return_called then
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	parse_url_userpass (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_conn: CE_POINTER [PD_CONNECTDATA]; a_user: CE_POINTER [INTEGER_8]; a_passwd: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_ptr: CE_POINTER [INTEGER_8]
			l_userpass: CE_POINTER [INTEGER_8]
			l_newname: CE_POINTER [INTEGER_8]
			l_newpasswd: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_ptr.make
			create l_userpass.make
			create l_newname.make
			create l_newpasswd.make

			l_ptr.ce_gets ((strchr (a_conn.item.host.name, ('@').code)))
			l_userpass.ce_gets (a_conn.item.host.name)
			a_user[0] := (0).to_integer_8
			a_passwd[0] := (0).to_integer_8
			if (l_ptr.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				l_ptr.ce_gets (l_ptr + 1)
				a_conn.item.host.name := l_ptr
				a_conn.item.bits.userpwd_in_url := (1).to_boolean
				if (a_data.item.set.use_netrc).to_natural_32 /= {NATURAL_32} 2 then
					a_conn.item.bits.user_passwd := (1).to_boolean
					if (l_userpass[0]).to_integer_32 /= 58 then
						sscanf ([l_userpass, ce_string ("%%255[^:@]:%%255[^@]"), a_user, a_passwd]).do_nothing
					else
						sscanf ([l_userpass, ce_string (":%%255[^@]"), a_passwd]).do_nothing
					end
					if (a_user[0]).to_boolean then
						l_newname.ce_gets ((escape_inst.curl_easy_unescape (create {CE_POINTER [ANY]}.make_cast (a_data), a_user, 0, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))))
						if (l_newname).c_pointer = default_pointer then
							Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
							js.return
						end
						if not js.return_called then
							if (strlen (l_newname)) < {NATURAL_32} 256 then
								strcpy (a_user, l_newname).do_nothing
							end
							easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_newname)])
						end
					end
					if not js.return_called and then ((a_passwd[0]).to_boolean) then
						l_newpasswd.ce_gets ((escape_inst.curl_easy_unescape (create {CE_POINTER [ANY]}.make_cast (a_data), a_passwd, 0, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))))
						if (l_newpasswd).c_pointer = default_pointer then
							Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
							js.return
						end
						if not js.return_called then
							if (strlen (l_newpasswd)) < {NATURAL_32} 256 then
								strcpy (a_passwd, l_newpasswd).do_nothing
							end
							easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_newpasswd)])
						end
					end
				end
			end
			if not js.return_called then
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	parse_remote_port (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_conn: CE_POINTER [PD_CONNECTDATA]): INTEGER_32
		local
			l_portptr: CE_POINTER [INTEGER_8]
			l_endbracket: INTEGER_8
			l_tmp: CE_POINTER [INTEGER_8]
			l_url: CE_POINTER [INTEGER_8]
			l_type: CE_ARRAY [INTEGER_8]
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_rest: CE_POINTER [INTEGER_8]
			l_port: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_portptr.make
			create l_tmp.make
			create l_url.make
			create l_type.make (<<12>>)
			create l_tmp___3.make
			create l_tmp___4.make
			create l_tmp___5.make
			create l_rest.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if 1 = (sscanf ([a_conn.item.host.name, ce_string ("[%%*45[0123456789abcdefABCDEF:.]%%c"), create {CE_POINTER [INTEGER_8]}.make_shared ($l_endbracket)])) then
						if 93 = l_endbracket.to_integer_32 then
							a_conn.item.bits.ipv6_ip := (1).to_boolean
							a_conn.item.host.name := (a_conn.item.host.name) + 1
							l_portptr.ce_gets (strchr (a_conn.item.host.name, (']').code))
							if ((l_portptr).c_pointer /= default_pointer) then
								l_tmp.ce_gets (l_portptr)
								l_portptr.ce_gets (l_portptr + 1)
								l_tmp[0] := (('%/0/').code).to_integer_8
								if 58 /= (l_portptr[0]).to_integer_32 then
									l_portptr.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
								end
							end
						else
							l_portptr.ce_gets (strrchr (a_conn.item.host.name, (':').code))
						end
					else
						l_portptr.ce_gets (strrchr (a_conn.item.host.name, (':').code))
					end
					if not ((a_data.item.set.use_port).to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if a_data.item.state.allow_port then
							a_conn.item.remote_port := (a_data.item.set.use_port).to_natural_16
							if ((l_portptr).c_pointer /= default_pointer) then
								l_portptr[0] := (('%/0/').code).to_integer_8
							end
							if a_conn.item.bits.httpproxy then
								l_type[0] := (('%/0/').code).to_integer_8
								l_type[1] := (0).to_integer_8
								l_type[2] := (0).to_integer_8
								l_type[3] := (0).to_integer_8
								l_type[4] := (0).to_integer_8
								l_type[5] := (0).to_integer_8
								l_type[6] := (0).to_integer_8
								l_type[7] := (0).to_integer_8
								l_type[8] := (0).to_integer_8
								l_type[9] := (0).to_integer_8
								l_type[10] := (0).to_integer_8
								l_type[11] := (0).to_integer_8
								if a_conn.item.bits.type_set then
									if a_data.item.set.prefer_ascii then
										l_tmp___2 := ('A').code
									else
										if a_data.item.set.ftp_list_only then
											l_tmp___1 := ('D').code
										else
											l_tmp___1 := ('I').code
										end
										l_tmp___2 := l_tmp___1
									end
									mprintf_inst.curl_msnprintf ([l_type, (Integer_8_bytes.to_natural_32 * (12).to_natural_32), ce_string (";type=%%c"), l_tmp___2]).do_nothing
								end
								if a_data.item.state.slash_removed then
									l_tmp___3.ce_gets (ce_string ("/"))
								else
									l_tmp___3.ce_gets (ce_string (""))
								end
								if a_conn.item.bits.ipv6_ip then
									l_tmp___4.ce_gets (ce_string ("]"))
								else
									l_tmp___4.ce_gets (ce_string (""))
								end
								if a_conn.item.bits.ipv6_ip then
									l_tmp___5.ce_gets (ce_string ("["))
								else
									l_tmp___5.ce_gets (ce_string (""))
								end
								l_url.ce_gets (mprintf_inst.curl_maprintf ([ce_string ("%%s://%%s%%s%%s:%%hu%%s%%s%%s"), (a_conn.item.handler).item.scheme, l_tmp___5, a_conn.item.host.name, l_tmp___4, (a_conn.item.remote_port).to_integer_32, l_tmp___3, a_data.item.state.path, l_type]))
								if (l_url).c_pointer = default_pointer then
									Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
									js.return
								end
								if not js.return_called then
									if a_data.item.change.url_alloc then
										easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (a_data.item.change.url)])
									end
									a_data.item.change.url := l_url
									a_data.item.change.url_alloc := (1).to_boolean
								end
							end
						else
							l_pos := -1 + 3 -- goto _L___0
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 3 then -- else: | _L___0:
						if (l_portptr).c_pointer = default_pointer then
							l_pos := -1 + 8 -- skip if block
						end
				when 4 then -- if:
						l_port := strtoul ((l_portptr + 1), (l_rest.address), 10)
						if (l_rest.c_pointer.to_integer_32).to_natural_32 = ((l_portptr + 1).c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if (l_rest[0]).to_integer_32 = 0 then
							if l_port > {NATURAL_32} 65535 then
								sendf_inst.Curl_failf ([a_data, ce_string ("Port number too large: %%lu"), l_port])
								Result := ({PC_CURLCODE}.CURLE_URL_MALFORMAT)
								js.return
							end
							if not js.return_called then
								l_portptr[0] := (('%/0/').code).to_integer_8
								a_conn.item.remote_port := warnless_inst.curlx_ultous (l_port)
							end
						else
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						if not l_port.to_boolean then
							l_portptr[0] := (('%/0/').code).to_integer_8
						end
				when 8 then -- if done | if done
						if not js.return_called then
							Result := ({PC_CURLCODE}.CURLE_OK)
						end
				when 9 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	override_userpass (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_conn: CE_POINTER [PD_CONNECTDATA]; a_user: CE_POINTER [INTEGER_8]; a_passwd: CE_POINTER [INTEGER_8])
		do
			if ((a_data.item.set.str[28]).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				strncpy (a_user, a_data.item.set.str[28], (256).to_natural_32).do_nothing
				a_user[255] := (('%/0/').code).to_integer_8
			end
			if ((a_data.item.set.str[29]).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				strncpy (a_passwd, a_data.item.set.str[29], (256).to_natural_32).do_nothing
				a_passwd[255] := (('%/0/').code).to_integer_8
			end
			a_conn.item.bits.netrc := (0).to_boolean
			if (a_data.item.set.use_netrc).to_natural_32 /= {NATURAL_32} 0 then
				if (netrc_inst.Curl_parsenetrc (a_conn.item.host.name, a_user, a_passwd, a_data.item.set.str[14])).to_boolean then
					sendf_inst.Curl_infof ([a_data, ce_string ("Couldn%'t find host %%s in the .netrc file; using defaults%N"), a_conn.item.host.name])
				else
					a_conn.item.bits.netrc := (1).to_boolean
					a_conn.item.bits.user_passwd := (1).to_boolean
				end
			end
		end

	set_userpass (a_conn: CE_POINTER [PD_CONNECTDATA]; a_user: CE_POINTER [INTEGER_8]; a_passwd: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (((a_conn.item.protocol).bit_and (((((1).bit_shift_left (2))).bit_or (((1).bit_shift_left (12)))).to_integer_32)).to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if not a_conn.item.bits.user_passwd then
							a_conn.item.user := create {CE_POINTER [INTEGER_8]}.make_cast (easy_inst.Curl_cstrdup.pointer_item ([ce_string ("anonymous")]))
							if ((a_conn.item.user).c_pointer /= default_pointer) then
								a_conn.item.passwd := create {CE_POINTER [INTEGER_8]}.make_cast (easy_inst.Curl_cstrdup.pointer_item ([ce_string ("ftp@example.com")]))
							else
								a_conn.item.passwd := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
							end
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						a_conn.item.user := create {CE_POINTER [INTEGER_8]}.make_cast (easy_inst.Curl_cstrdup.pointer_item ([a_user]))
						if ((a_conn.item.user).c_pointer /= default_pointer) then
							a_conn.item.passwd := create {CE_POINTER [INTEGER_8]}.make_cast (easy_inst.Curl_cstrdup.pointer_item ([a_passwd]))
						else
							a_conn.item.passwd := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
						end
				when 4 then
					if (a_conn.item.user).c_pointer = default_pointer then
						Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
						js.return
					elseif (a_conn.item.passwd).c_pointer = default_pointer then
						Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
						js.return
					end
					if not js.return_called then
						Result := ({PC_CURLCODE}.CURLE_OK)
					end
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	resolve_server (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_conn: CE_POINTER [PD_CONNECTDATA]; a_async: CE_POINTER [BOOLEAN]): INTEGER_32
		local
			l_result: INTEGER_32
			l_timeout_ms: INTEGER_32
			l_rc: INTEGER_32
			l_hostaddr: CE_POINTER [PD_CURL_DNS_ENTRY]
			l_pos: INTEGER_32
		do
			create l_hostaddr.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_result := {PC_CURLCODE}.CURLE_OK
					l_timeout_ms := (connect_inst.Curl_timeleft (a_conn, create {CE_POINTER [SD_TIMEVAL]}.make_shared (default_pointer), (1).to_boolean))
					if not (a_conn.item.bits.reuse) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						a_async.item := (0).to_boolean
						if a_conn.item.bits.proxy then
							fix_hostname (a_data, a_conn, create {CE_POINTER [PD_HOSTNAME]}.make_shared (a_conn.c_pointer + {PD_CONNECTDATA}.host_offset))
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 3 then -- else:
						fix_hostname (a_data, a_conn, create {CE_POINTER [PD_HOSTNAME]}.make_shared (a_conn.c_pointer + {PD_CONNECTDATA}.host_offset))
						if ((a_conn.item.proxy.name).c_pointer /= default_pointer) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 6 then -- else:
						if ((a_conn.item.proxy.name).item).to_boolean then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if: | _L:
						a_conn.item.port := (a_conn.item.remote_port).to_integer_32
						l_rc := hostip_inst.Curl_resolv_timeout (a_conn, a_conn.item.host.name, (a_conn.item.port).to_integer_32, l_hostaddr.address, l_timeout_ms)
						if l_rc = 1 then
							a_async.item := (1).to_boolean
						elseif l_rc = -2 then
							l_result := {PC_CURLCODE}.CURLE_OPERATION_TIMEDOUT
						elseif (l_hostaddr).c_pointer = default_pointer then
							sendf_inst.Curl_failf ([a_data, ce_string ("Couldn%'t resolve host %'%%s%'"), a_conn.item.host.dispname])
							l_result := {PC_CURLCODE}.CURLE_COULDNT_RESOLVE_HOST
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else:
						fix_hostname (a_data, a_conn, create {CE_POINTER [PD_HOSTNAME]}.make_shared (a_conn.c_pointer + {PD_CONNECTDATA}.proxy_offset))
						l_rc := hostip_inst.Curl_resolv_timeout (a_conn, a_conn.item.proxy.name, (a_conn.item.port).to_integer_32, l_hostaddr.address, l_timeout_ms)
						if l_rc = 1 then
							a_async.item := (1).to_boolean
						elseif l_rc = -2 then
							l_result := {PC_CURLCODE}.CURLE_OPERATION_TIMEDOUT
						elseif (l_hostaddr).c_pointer = default_pointer then
							sendf_inst.Curl_failf ([a_data, ce_string ("Couldn%'t resolve proxy %'%%s%'"), a_conn.item.proxy.dispname])
							l_result := {PC_CURLCODE}.CURLE_COULDNT_RESOLVE_PROXY
						end
				when 10 then -- if done
						a_conn.item.dns_entry := l_hostaddr
				when 11 then -- if done
					Result := l_result
				when 12 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	reuse_conn (a_old_conn: CE_POINTER [PD_CONNECTDATA]; a_conn: CE_POINTER [PD_CONNECTDATA])
		do
			if ((a_old_conn.item.proxy.rawalloc).c_pointer /= default_pointer) then
				easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (a_old_conn.item.proxy.rawalloc)])
			end
			sslgen_inst.Curl_free_ssl_config (create {CE_POINTER [PD_SSL_CONFIG_DATA]}.make_shared (a_old_conn.c_pointer + {PD_CONNECTDATA}.ssl_config_offset))
			a_conn.item.data := a_old_conn.item.data
			a_conn.item.bits.user_passwd := a_old_conn.item.bits.user_passwd
			if a_conn.item.bits.user_passwd then
				Curl_safefree (create {CE_POINTER [ANY]}.make_cast (a_conn.item.user))
				Curl_safefree (create {CE_POINTER [ANY]}.make_cast (a_conn.item.passwd))
				a_conn.item.user := a_old_conn.item.user
				a_conn.item.passwd := a_old_conn.item.passwd
				a_old_conn.item.user := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
				a_old_conn.item.passwd := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			end
			a_conn.item.bits.proxy_user_passwd := a_old_conn.item.bits.proxy_user_passwd
			if a_conn.item.bits.proxy_user_passwd then
				Curl_safefree (create {CE_POINTER [ANY]}.make_cast (a_conn.item.proxyuser))
				Curl_safefree (create {CE_POINTER [ANY]}.make_cast (a_conn.item.proxypasswd))
				a_conn.item.proxyuser := a_old_conn.item.proxyuser
				a_conn.item.proxypasswd := a_old_conn.item.proxypasswd
				a_old_conn.item.proxyuser := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
				a_old_conn.item.proxypasswd := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			end
			if a_conn.item.bits.proxy then
				easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (a_conn.item.host.rawalloc)])
				a_conn.item.host := a_old_conn.item.host
			else
				easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (a_old_conn.item.host.rawalloc)])
			end
			a_conn.item.bits.reuse := (1).to_boolean
			Curl_safefree (create {CE_POINTER [ANY]}.make_cast (a_old_conn.item.user))
			Curl_safefree (create {CE_POINTER [ANY]}.make_cast (a_old_conn.item.passwd))
			Curl_safefree (create {CE_POINTER [ANY]}.make_cast (a_old_conn.item.proxyuser))
			Curl_safefree (create {CE_POINTER [ANY]}.make_cast (a_old_conn.item.proxypasswd))
			llist_inst.Curl_llist_destroy (a_old_conn.item.send_pipe, create {CE_POINTER [ANY]}.make_shared (default_pointer))
			llist_inst.Curl_llist_destroy (a_old_conn.item.recv_pipe, create {CE_POINTER [ANY]}.make_shared (default_pointer))
			llist_inst.Curl_llist_destroy (a_old_conn.item.pend_pipe, create {CE_POINTER [ANY]}.make_shared (default_pointer))
			llist_inst.Curl_llist_destroy (a_old_conn.item.done_pipe, create {CE_POINTER [ANY]}.make_shared (default_pointer))
			Curl_safefree (create {CE_POINTER [ANY]}.make_cast (a_old_conn.item.master_buffer))
		end

	create_conn (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_in_connect: CE_POINTER [CE_POINTER [PD_CONNECTDATA]]; a_async: CE_POINTER [BOOLEAN]): INTEGER_32
		local
			l_result: INTEGER_32
			l_conn: CE_POINTER [PD_CONNECTDATA]
			l_conn_temp: CE_POINTER [PD_CONNECTDATA]
			l_urllen: NATURAL_32
			l_user: CE_ARRAY [INTEGER_8]
			l_passwd: CE_ARRAY [INTEGER_8]
			l_reuse: BOOLEAN
			l_proxy: CE_POINTER [INTEGER_8]
			l_prot_missing: BOOLEAN
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_reurl: CE_POINTER [INTEGER_8]
			l_bits: INTEGER_32
			l_done: BOOLEAN
			l_tmp___7: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_conn.make
			create l_conn_temp.make
			create l_user.make (<<256>>)
			create l_passwd.make (<<256>>)
			create l_proxy.make
			create l_reurl.make
			create l_tmp___7.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_result := {PC_CURLCODE}.CURLE_OK
					l_conn_temp.ce_gets (create {CE_POINTER [PD_CONNECTDATA]}.make_shared (default_pointer))
					l_proxy.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
					l_prot_missing := (0).to_boolean
					a_async.item := (0).to_boolean
					if (a_data.item.change.url).c_pointer = default_pointer then
						Result := ({PC_CURLCODE}.CURLE_URL_MALFORMAT)
						js.return
					end
					if not js.return_called then
						l_conn.ce_gets (allocate_conn)
						a_in_connect.item := l_conn
						if (l_conn).c_pointer = default_pointer then
							Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
							js.return
						end
					end
					if not js.return_called then
						l_conn.item.data := a_data
						l_conn.item.proxytype := a_data.item.set.proxytype
						if ((a_data.item.set.str[16]).c_pointer /= default_pointer) then
							if ((a_data.item.set.str[16]).item).to_boolean then
								l_tmp := 1
							else
								l_tmp := 0
							end
						else
							l_tmp := 0
						end
						l_conn.item.bits.proxy := l_tmp.to_boolean
						if l_conn.item.bits.proxy then
							if (l_conn.item.proxytype).to_natural_32 = {NATURAL_32} 0 then
								l_tmp___0 := 1
							elseif (l_conn.item.proxytype).to_natural_32 = {NATURAL_32} 1 then
								l_tmp___0 := 1
							else
								l_tmp___0 := 0
							end
						else
							l_tmp___0 := 0
						end
						l_conn.item.bits.httpproxy := l_tmp___0.to_boolean
						l_conn.item.bits.proxy_user_passwd := ((0).to_natural_32 /= ((a_data.item.set.str[30]).c_pointer.to_integer_32).to_natural_32)
						l_conn.item.bits.tunnel_proxy := a_data.item.set.tunnel_thru_httpproxy
						l_conn.item.bits.user_passwd := ((0).to_natural_32 /= ((a_data.item.set.str[28]).c_pointer.to_integer_32).to_natural_32)
						l_conn.item.bits.ftp_use_epsv := a_data.item.set.ftp_use_epsv
						l_conn.item.bits.ftp_use_eprt := a_data.item.set.ftp_use_eprt
						l_conn.item.verifypeer := a_data.item.set.ssl.verifypeer
						l_conn.item.verifyhost := a_data.item.set.ssl.verifyhost
						if ((a_data.item.multi).c_pointer /= default_pointer) then
							if (multi_inst.Curl_multi_canPipeline (a_data.item.multi)) then
								if (l_conn.item.master_buffer).c_pointer = default_pointer then
									l_conn.item.master_buffer := create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_ccalloc.pointer_item ([(16384).to_natural_32, Integer_8_bytes.to_natural_32]))))
									if (l_conn.item.master_buffer).c_pointer = default_pointer then
										Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
										js.return
									end
								end
							end
						end
					end
					if not js.return_called then
						l_conn.item.send_pipe := llist_inst.Curl_llist_alloc (llist_dtor_address)
						l_conn.item.recv_pipe := llist_inst.Curl_llist_alloc (llist_dtor_address)
						l_conn.item.pend_pipe := llist_inst.Curl_llist_alloc (llist_dtor_address)
						l_conn.item.done_pipe := llist_inst.Curl_llist_alloc (llist_dtor_address)
						if (l_conn.item.send_pipe).c_pointer = default_pointer then
							Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
							js.return
						elseif (l_conn.item.recv_pipe).c_pointer = default_pointer then
							Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
							js.return
						elseif (l_conn.item.pend_pipe).c_pointer = default_pointer then
							Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
							js.return
						elseif (l_conn.item.done_pipe).c_pointer = default_pointer then
							Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
							js.return
						end
					end
					if not js.return_called then
						l_urllen := strlen (a_data.item.change.url)
						if l_urllen < {NATURAL_32} 256 then
							l_urllen := (256).to_natural_32
						end
						Curl_safefree (create {CE_POINTER [ANY]}.make_cast (a_data.item.state.pathbuffer))
						a_data.item.state.pathbuffer := create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_cmalloc.pointer_item ([l_urllen + {NATURAL_32} 2]))))
						if (0).to_natural_32 = ((a_data.item.state.pathbuffer).c_pointer.to_integer_32).to_natural_32 then
							Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
							js.return
						end
					end
					if not js.return_called then
						a_data.item.state.path := a_data.item.state.pathbuffer
						l_conn.item.host.rawalloc := create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_cmalloc.pointer_item ([l_urllen + {NATURAL_32} 2]))))
						if (0).to_natural_32 = ((l_conn.item.host.rawalloc).c_pointer.to_integer_32).to_natural_32 then
							Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
							js.return
						end
					end
					if not js.return_called then
						l_conn.item.host.name := l_conn.item.host.rawalloc
						l_conn.item.host.name[0] := (0).to_integer_8
						l_result := parseurlandfillconn (a_data, l_conn, create {CE_POINTER [BOOLEAN]}.make_shared ($l_prot_missing))
						if l_result.to_natural_32 /= {NATURAL_32} 0 then
							Result := l_result
							js.return
						end
					end
					if not js.return_called and then l_prot_missing then
						l_reurl.ce_gets (mprintf_inst.curl_maprintf ([ce_string ("%%s://%%s"), (l_conn.item.handler).item.scheme, a_data.item.change.url]))
						if (l_reurl).c_pointer = default_pointer then
							Curl_safefree (create {CE_POINTER [ANY]}.make_cast (l_proxy))
							Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
							js.return
						end
						if not js.return_called then
							a_data.item.change.url := l_reurl
							a_data.item.change.url_alloc := (1).to_boolean
						end
					end
					if not js.return_called then
						l_result := parse_url_userpass (a_data, l_conn, l_user, l_passwd)
						if l_result.to_natural_32 /= {NATURAL_32} 0 then
							Result := l_result
							js.return
						end
					end
					if not js.return_called and then (l_conn.item.bits.proxy_user_passwd) then
						l_result := parse_proxy_auth (a_data, l_conn)
						if l_result.to_natural_32 /= {NATURAL_32} 0 then
							Result := l_result
							js.return
						end
					end
					if not js.return_called and then ((a_data.item.set.str[16]).c_pointer /= default_pointer) then
						l_proxy.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast (easy_inst.Curl_cstrdup.pointer_item ([a_data.item.set.str[16]])))
						if (0).to_natural_32 = (l_proxy.c_pointer.to_integer_32).to_natural_32 then
							sendf_inst.Curl_failf ([a_data, ce_string ("memory shortage")])
							Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if (a_data.item.set.str[32]).c_pointer = default_pointer then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if (check_noproxy (l_conn.item.host.name, a_data.item.set.str[32])) then
							if ((l_proxy).c_pointer /= default_pointer) then
								easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_proxy)])
								l_proxy.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							end
						else
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						if (l_proxy).c_pointer = default_pointer then
							l_proxy.ce_gets (detect_proxy (l_conn))
						end
				when 5 then
						if ((l_proxy).c_pointer /= default_pointer) then
							if not (l_proxy[0]).to_boolean then
								easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_proxy)])
								l_proxy.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							end
						end
						if ((l_proxy).c_pointer /= default_pointer) then
							l_bits := (l_conn.item.protocol).bit_and (((((1).bit_shift_left (1))).bit_or (((1).bit_shift_left (29)))).to_integer_32)
							if (l_conn.item.proxytype).to_natural_32 = {NATURAL_32} 0 then
								l_conn.item.protocol := (1).bit_or (l_bits)
								l_conn.item.bits.httpproxy := (1).to_boolean
							elseif (l_conn.item.proxytype).to_natural_32 = {NATURAL_32} 1 then
								l_conn.item.protocol := (1).bit_or (l_bits)
								l_conn.item.bits.httpproxy := (1).to_boolean
							end
							l_conn.item.bits.proxy := (1).to_boolean
						else
							l_conn.item.bits.proxy := (0).to_boolean
							l_conn.item.bits.httpproxy := (0).to_boolean
							l_conn.item.bits.proxy_user_passwd := (0).to_boolean
							l_conn.item.bits.tunnel_proxy := (0).to_boolean
						end
						if ((l_proxy).c_pointer /= default_pointer) then
							l_result := parse_proxy (a_data, l_conn, l_proxy)
							l_proxy.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							if l_result.to_natural_32 /= {NATURAL_32} 0 then
								Result := l_result
								js.return
							end
						end
				when 6 then -- if done
					if not js.return_called then
						l_result := setup_connection_internals (l_conn)
						if l_result.to_natural_32 /= {NATURAL_32} 0 then
							Curl_safefree (create {CE_POINTER [ANY]}.make_cast (l_proxy))
							Result := l_result
							js.return
						end
					end
					if not js.return_called then
						l_conn.item.recv[0] := sendf_inst.Curl_recv_plain_address
						l_conn.item.send[0] := sendf_inst.Curl_send_plain_address
						l_conn.item.recv[1] := sendf_inst.Curl_recv_plain_address
						l_conn.item.send[1] := sendf_inst.Curl_send_plain_address
						if ((l_conn.item.protocol).bit_and (((1).bit_shift_left (10)).to_integer_32)).to_boolean then
							l_result := ((l_conn.item.handler).item.connect_it).integer_32_item ([l_conn, create {CE_POINTER [BOOLEAN]}.make_shared ($l_done)])
							if {NATURAL_32} 0 = l_result.to_natural_32 then
								l_conn.item.data := a_data
								l_conn.item.bits.tcpconnect := (1).to_boolean
								ConnectionStore (a_data, l_conn).do_nothing
								l_result := setup_range (a_data)
								if l_result.to_boolean then
									((l_conn.item.handler).item.done).call ([l_conn, l_result, (0).to_boolean])
									Result := l_result
									js.return
								end
								if not js.return_called then
									transfer_inst.Curl_setup_transfer (l_conn, -1, (-1).to_integer_64, (0).to_boolean, create {CE_POINTER [INTEGER_64]}.make_shared (default_pointer), -1, create {CE_POINTER [INTEGER_64]}.make_shared (default_pointer))
								end
							end
							if not js.return_called then
								Result := l_result
								js.return
							end
						end
					end
					if not js.return_called then
						if ((l_conn.item.protocol).bit_and (((1).bit_shift_left (29)).to_integer_32)).to_boolean then
							if l_conn.item.bits.httpproxy then
								l_conn.item.bits.tunnel_proxy := (1).to_boolean
							end
						end
						l_result := parse_remote_port (a_data, l_conn)
						if l_result.to_natural_32 /= {NATURAL_32} 0 then
							Result := l_result
							js.return
						end
					end
					if not js.return_called then
						override_userpass (a_data, l_conn, l_user, l_passwd)
						l_result := set_userpass (l_conn, l_user, l_passwd)
						if l_result.to_natural_32 /= {NATURAL_32} 0 then
							Result := l_result
							js.return
						end
					end
					if not js.return_called then
						a_data.item.set.ssl.CApath := a_data.item.set.str[20]
						a_data.item.set.ssl.CAfile := a_data.item.set.str[21]
						a_data.item.set.ssl.CRLfile := a_data.item.set.str[26]
						a_data.item.set.ssl.issuercert := a_data.item.set.str[27]
						a_data.item.set.ssl.random_file := a_data.item.set.str[24]
						a_data.item.set.ssl.egdsocket := a_data.item.set.str[23]
						a_data.item.set.ssl.cipher_list := a_data.item.set.str[22]
						if not (sslgen_inst.Curl_clone_ssl_config (create {CE_POINTER [PD_SSL_CONFIG_DATA]}.make_shared (a_data.c_pointer + {PD_SESSIONHANDLE}.set_offset + {PD_USERDEFINED}.ssl_offset), create {CE_POINTER [PD_SSL_CONFIG_DATA]}.make_shared (l_conn.c_pointer + {PD_CONNECTDATA}.ssl_config_offset))) then
							Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
							js.return
						end
					end
					if not js.return_called then
						if a_data.item.set.reuse_fresh then
							if not a_data.item.state.this_is_a_follow then
								l_reuse := (0).to_boolean
							else
								l_reuse := ConnectionExists (a_data, l_conn, l_conn_temp.address)
							end
						else
							l_reuse := ConnectionExists (a_data, l_conn, l_conn_temp.address)
						end
						if l_reuse then
							reuse_conn (l_conn, l_conn_temp)
							easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_conn)])
							l_conn.ce_gets (l_conn_temp)
							a_in_connect.item := l_conn
							if ((l_conn.item.proxy.name).c_pointer /= default_pointer) then
								l_tmp___7.ce_gets (l_conn.item.proxy.dispname)
							else
								l_tmp___7.ce_gets (l_conn.item.host.dispname)
							end
							sendf_inst.Curl_infof ([a_data, ce_string ("Re-using existing connection! (#%%ld) with host %%s%N"), l_conn.item.connectindex, l_tmp___7])
							strcpy ((a_data.item.info.ip), (l_conn.item.ip_addr_str)).do_nothing
						else
							ConnectionStore (a_data, l_conn).do_nothing
						end
						l_result := setup_range (a_data)
						if l_result.to_boolean then
							Result := l_result
							js.return
						end
					end
					if not js.return_called then
						l_conn.item.fread_func := a_data.item.set.fread_func
						l_conn.item.fread_in := a_data.item.set.in
						l_conn.item.seek_func := a_data.item.set.seek_func
						l_conn.item.seek_client := a_data.item.set.seek_client
						l_result := resolve_server (a_data, l_conn, a_async)
						Result := l_result
					end
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	setup_conn (a_conn: CE_POINTER [PD_CONNECTDATA]; a_protocol_done: CE_POINTER [BOOLEAN]): INTEGER_32
		local
			l_result: INTEGER_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_connected: BOOLEAN
			js: JUMP_STATE
		do
			create l_data.make

			l_result := {PC_CURLCODE}.CURLE_OK
			l_data.ce_gets (a_conn.item.data)
			progress_inst.Curl_pgrsTime (l_data, {PC_TIMERID}.TIMER_NAMELOOKUP)
			if ((a_conn.item.protocol).bit_and (((1).bit_shift_left (10)).to_integer_32)).to_boolean then
				a_protocol_done.item := (1).to_boolean
				Result := l_result
				js.return
			end
			if not js.return_called then
				a_protocol_done.item := (0).to_boolean
				a_conn.item.bits.proxy_connect_closed := (0).to_boolean
				if ((l_data.item.set.str[25]).c_pointer /= default_pointer) then
					Curl_safefree (create {CE_POINTER [ANY]}.make_cast (a_conn.item.allocptr.uagent))
					a_conn.item.allocptr.uagent := mprintf_inst.curl_maprintf ([ce_string ("User-Agent: %%s%R%N"), l_data.item.set.str[25]])
					if (a_conn.item.allocptr.uagent).c_pointer = default_pointer then
						Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
						js.return
					end
				end
			end
			if not js.return_called then
				l_data.item.req.headerbytecount := 0
				l_data.item.state.crlf_conversions := (0).to_integer_64
				from
				until
					js.loop_left
				loop
					js.reset
					if -1 = a_conn.item.sock[0] then
						l_connected := (0).to_boolean
						l_result := ConnectPlease (l_data, a_conn, create {CE_POINTER [BOOLEAN]}.make_shared ($l_connected))
						if l_connected then
							l_result := Curl_protocol_connect (a_conn, a_protocol_done)
							if {NATURAL_32} 0 = l_result.to_natural_32 then
								a_conn.item.bits.tcpconnect := (1).to_boolean
							end
						else
							a_conn.item.bits.tcpconnect := (0).to_boolean
						end
						if a_conn.item.bits.proxy_connect_closed then
							if ((l_data.item.set.errorbuffer).c_pointer /= default_pointer) then
								l_data.item.set.errorbuffer[0] := (('%/0/').code).to_integer_8
							end
							l_data.item.state.errorbuf := (0).to_boolean
							js.continue
						end
						if not js.loop_jumped and then ({NATURAL_32} 0 /= l_result.to_natural_32) then
							Result := l_result
							js.return
						end
					else
						progress_inst.Curl_pgrsTime (l_data, {PC_TIMERID}.TIMER_CONNECT)
						progress_inst.Curl_pgrsTime (l_data, {PC_TIMERID}.TIMER_APPCONNECT)
						a_conn.item.bits.tcpconnect := (1).to_boolean
						a_protocol_done.item := (1).to_boolean
						Curl_verboseconnect (a_conn)
						connect_inst.Curl_updateconninfo (a_conn, a_conn.item.sock[0])
					end
					if not js.return_called then
						if not js.loop_jumped then
							js.break
						end
						if not js.loop_left then
							
						end
					end
				end
				js.reset
			end
			if not js.return_called then
				a_conn.item.now := timeval_inst.curlx_tvnow
				Result := l_result
			end
		end

	Curl_connect (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_in_connect: CE_POINTER [CE_POINTER [PD_CONNECTDATA]]; a_asyncp: CE_POINTER [BOOLEAN]; a_protocol_done: CE_POINTER [BOOLEAN]): INTEGER_32
		local
			l_code: INTEGER_32
		do
			a_asyncp.item := (0).to_boolean
			l_code := create_conn (a_data, a_in_connect, a_asyncp)
			if {NATURAL_32} 0 = l_code.to_natural_32 then
				if (((a_in_connect.item).item.send_pipe).item.size).to_boolean then
					a_protocol_done.item := (1).to_boolean
				elseif (((a_in_connect.item).item.recv_pipe).item.size).to_boolean then
					a_protocol_done.item := (1).to_boolean
				elseif not a_asyncp.item then
					l_code := setup_conn (a_in_connect.item, a_protocol_done)
				end
			end
			if l_code.to_boolean then
				if ((a_in_connect.item).c_pointer /= default_pointer) then
					Curl_disconnect (a_in_connect.item).do_nothing
					a_in_connect.item := create {CE_POINTER [PD_CONNECTDATA]}.make_shared (default_pointer)
				end
			end
			Result := l_code
		end

	Curl_async_resolved (a_conn: CE_POINTER [PD_CONNECTDATA]; a_protocol_done: CE_POINTER [BOOLEAN]): INTEGER_32
		do
			Result := ({PC_CURLCODE}.CURLE_OK)
		end

	Curl_done (a_connp: CE_POINTER [CE_POINTER [PD_CONNECTDATA]]; a_status: INTEGER_32; a_premature: BOOLEAN): INTEGER_32
		local
			l_result: INTEGER_32
			l_conn: CE_POINTER [PD_CONNECTDATA]
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_res2: INTEGER_32
			l_tmp___0: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_conn.make
			create l_data.make
			create l_tmp___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_conn.ce_gets (a_connp.item)
					l_data.ce_gets (l_conn.item.data)
					if l_conn.item.bits.done then
						Result := ({PC_CURLCODE}.CURLE_OK)
						js.return
					end
					if not js.return_called then
						Curl_getoff_all_pipelines (l_data, l_conn)
						if (l_conn.item.send_pipe).item.size + (l_conn.item.recv_pipe).item.size /= {NATURAL_32} 0 then
							if not l_data.item.set.reuse_forbid then
								if not l_conn.item.bits.close then
									Result := ({PC_CURLCODE}.CURLE_OK)
									js.return
								end
							end
						end
					end
					if js.return_called then
						l_pos := -1 + 15 -- skip if block
					end
				when 1 then -- if:
						l_conn.item.bits.done := (1).to_boolean
						if ((l_data.item.req.newurl).c_pointer /= default_pointer) then
							easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_data.item.req.newurl)])
							l_data.item.req.newurl := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
						end
						if ((l_data.item.req.location).c_pointer /= default_pointer) then
							easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_data.item.req.location)])
							l_data.item.req.location := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
						end
						if ((l_conn.item.dns_entry).c_pointer /= default_pointer) then
							hostip_inst.Curl_resolv_unlock (l_data, l_conn.item.dns_entry)
							l_conn.item.dns_entry := create {CE_POINTER [PD_CURL_DNS_ENTRY]}.make_shared (default_pointer)
						end
						if (((l_conn.item.handler).item.done).c_pointer /= default_pointer) then
							l_result := ((l_conn.item.handler).item.done).integer_32_item ([l_conn, a_status, a_premature])
						else
							l_result := {PC_CURLCODE}.CURLE_OK
						end
						progress_inst.Curl_pgrsDone (l_conn)
						if ((l_data.item.state.tempwrite).c_pointer /= default_pointer) then
							easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_data.item.state.tempwrite)])
							l_data.item.state.tempwrite := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
						end
						if not (l_data.item.set.reuse_forbid) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 11 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 4 then -- else:
						if not (l_conn.item.bits.close) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 11 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 7 then -- else:
						if not a_premature then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 11 -- goto _L
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 10 then -- else:
						if -1 /= l_conn.item.connectindex then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if: | _L:
						l_res2 := (Curl_disconnect (l_conn))
						if not l_result.to_boolean then
							if l_res2.to_boolean then
								l_result := l_res2
							end
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 13 then -- else:
						ConnectionDone (l_conn)
						l_data.item.state.lastconnect := l_conn.item.connectindex
						if l_conn.item.bits.httpproxy then
							l_tmp___0.ce_gets (l_conn.item.proxy.dispname)
						else
							l_tmp___0.ce_gets (l_conn.item.host.dispname)
						end
						sendf_inst.Curl_infof ([l_data, ce_string ("Connection #%%ld to host %%s left intact%N"), l_conn.item.connectindex, l_tmp___0])
				when 14 then -- if done | if done | if done
						a_connp.item := create {CE_POINTER [PD_CONNECTDATA]}.make_shared (default_pointer)
						Result := l_result
				when 15 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	do_init (a_conn: CE_POINTER [PD_CONNECTDATA]): INTEGER_32
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_k: CE_POINTER [PD_SINGLEREQUEST]
		do
			create l_data.make
			create l_k.make

			l_data.ce_gets (a_conn.item.data)
			l_k.ce_gets (create {CE_POINTER [PD_SINGLEREQUEST]}.make_shared (l_data.c_pointer + {PD_SESSIONHANDLE}.req_offset))
			a_conn.item.bits.done := (0).to_boolean
			a_conn.item.bits.do_more := (0).to_boolean
			l_data.item.state.expect100header := (0).to_boolean
			if l_data.item.set.opt_no_body then
				l_data.item.set.httpreq := {PC_CURL_HTTPREQ}.HTTPREQ_HEAD
			elseif {NATURAL_32} 5 = (l_data.item.set.httpreq).to_natural_32 then
				l_data.item.set.httpreq := {PC_CURL_HTTPREQ}.HTTPREQ_GET
			end
			easy_inst.Curl_easy_initHandleData (l_data)
			l_k.item.start := timeval_inst.curlx_tvnow
			l_k.item.now := l_k.item.start
			l_k.item.header := (1).to_boolean
			l_k.item.bytecount := (0).to_integer_64
			l_k.item.buf := l_data.item.state.buffer
			l_k.item.uploadbuf := l_data.item.state.uploadbuffer
			l_k.item.hbufp := l_data.item.state.headerbuff
			l_k.item.ignorebody := (0).to_boolean
			progress_inst.Curl_pgrsTime (l_data, {PC_TIMERID}.TIMER_PRETRANSFER)
			speedcheck_inst.Curl_speedinit (l_data)
			progress_inst.Curl_pgrsSetUploadCounter (l_data, (0).to_integer_64)
			progress_inst.Curl_pgrsSetDownloadCounter (l_data, (0).to_integer_64)
			Result := ({PC_CURLCODE}.CURLE_OK)
		end

	do_complete (a_conn: CE_POINTER [PD_CONNECTDATA])
		local
			l_tmp: INTEGER_32
		do
			(a_conn.item.data).item.req.chunk := (0).to_boolean
			if a_conn.item.sockfd > a_conn.item.writesockfd then
				l_tmp := a_conn.item.sockfd
			else
				l_tmp := a_conn.item.writesockfd
			end
			(a_conn.item.data).item.req.maxfd := l_tmp + 1
		end

	Curl_do (a_connp: CE_POINTER [CE_POINTER [PD_CONNECTDATA]]; a_done: CE_POINTER [BOOLEAN]): INTEGER_32
		local
			l_result: INTEGER_32
			l_conn: CE_POINTER [PD_CONNECTDATA]
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			js: JUMP_STATE
		do
			create l_conn.make
			create l_data.make

			l_result := {PC_CURLCODE}.CURLE_OK
			l_conn.ce_gets (a_connp.item)
			l_data.ce_gets (l_conn.item.data)
			do_init (l_conn).do_nothing
			if (((l_conn.item.handler).item.do_it).c_pointer /= default_pointer) then
				l_result := ((l_conn.item.handler).item.do_it).integer_32_item ([l_conn, a_done])
				if {NATURAL_32} 55 = l_result.to_natural_32 then
					if l_conn.item.bits.reuse then
						if (l_data.item.multi).c_pointer = default_pointer then
							l_result := transfer_inst.Curl_reconnect_request (a_connp)
							if l_result.to_natural_32 = {NATURAL_32} 0 then
								l_result := ((l_conn.item.handler).item.do_it).integer_32_item ([l_conn, a_done])
							end
						else
							Result := l_result
							js.return
						end
					end
				end
				if not js.return_called and then (l_result.to_natural_32 = {NATURAL_32} 0) then
					if a_done.item then
						do_complete (l_conn)
					end
				end
			end
			if not js.return_called then
				Result := l_result
			end
		end

	Curl_do_more (a_conn: CE_POINTER [PD_CONNECTDATA]): INTEGER_32
		local
			l_result: INTEGER_32
		do
			l_result := {PC_CURLCODE}.CURLE_OK
			if (((a_conn.item.handler).item.do_more).c_pointer /= default_pointer) then
				l_result := ((a_conn.item.handler).item.do_more).integer_32_item ([a_conn])
			end
			if l_result.to_natural_32 = {NATURAL_32} 0 then
				do_complete (a_conn)
			end
			Result := l_result
		end

	Curl_reset_reqproto (a_conn: CE_POINTER [PD_CONNECTDATA])
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
		do
			create l_data.make

			l_data.ce_gets (a_conn.item.data)
			if ((l_data.item.state.proto.generic).c_pointer /= default_pointer) then
				if ((l_data.item.state.current_conn).c_pointer.to_integer_32).to_natural_32 /= (a_conn.c_pointer.to_integer_32).to_natural_32 then
					easy_inst.Curl_cfree.call ([l_data.item.state.proto.generic])
					l_data.item.state.proto.generic := create {CE_POINTER [ANY]}.make_shared (default_pointer)
				end
			end
			l_data.item.state.current_conn := a_conn
		end

end
