class
	P_BLAS

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_blas_sdsdot (a_alpha: REAL_32; a_X: CE_POINTER [PD_GSL_VECTOR_FLOAT]; a_Y: CE_POINTER [PD_GSL_VECTOR_FLOAT]; a_result: CE_POINTER [REAL_32]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_X.item.size = a_Y.item.size then
				a_result.item := sdsdot_inst.cblas_sdsdot ((a_X.item.size).to_integer_32, a_alpha, a_X.item.data, (a_X.item.stride).to_integer_32, a_Y.item.data, (a_Y.item.stride).to_integer_32)
				Result := 0
				js.return
			else
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 57, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_blas_dsdot (a_X: CE_POINTER [PD_GSL_VECTOR_FLOAT]; a_Y: CE_POINTER [PD_GSL_VECTOR_FLOAT]; a_result: CE_POINTER [REAL_64]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_X.item.size = a_Y.item.size then
				a_result.item := dsdot_inst.cblas_dsdot ((a_X.item.size).to_integer_32, a_X.item.data, (a_X.item.stride).to_integer_32, a_Y.item.data, (a_Y.item.stride).to_integer_32)
				Result := 0
				js.return
			else
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 74, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_blas_sdot (a_X: CE_POINTER [PD_GSL_VECTOR_FLOAT]; a_Y: CE_POINTER [PD_GSL_VECTOR_FLOAT]; a_result: CE_POINTER [REAL_32]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_X.item.size = a_Y.item.size then
				a_result.item := sdot_inst.cblas_sdot ((a_X.item.size).to_integer_32, a_X.item.data, (a_X.item.stride).to_integer_32, a_Y.item.data, (a_Y.item.stride).to_integer_32)
				Result := 0
				js.return
			else
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 91, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_blas_ddot (a_X: CE_POINTER [PD_GSL_VECTOR]; a_Y: CE_POINTER [PD_GSL_VECTOR]; a_result: CE_POINTER [REAL_64]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_X.item.size = a_Y.item.size then
				a_result.item := ddot_inst.cblas_ddot ((a_X.item.size).to_integer_32, a_X.item.data, (a_X.item.stride).to_integer_32, a_Y.item.data, (a_Y.item.stride).to_integer_32)
				Result := 0
				js.return
			else
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 107, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_blas_cdotu (a_X: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]; a_Y: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]; a_dotu: CE_POINTER [PD_GSL_COMPLEX_FLOAT]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_X.item.size = a_Y.item.size then
				cdotu_sub_inst.cblas_cdotu_sub ((a_X.item.size).to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_X.item.data), (a_X.item.stride).to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_Y.item.data), (a_Y.item.stride).to_integer_32, create {CE_POINTER [ANY]}.make_cast ((a_dotu.item.dat)))
				Result := 0
				js.return
			else
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 124, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_blas_cdotc (a_X: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]; a_Y: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]; a_dotc: CE_POINTER [PD_GSL_COMPLEX_FLOAT]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_X.item.size = a_Y.item.size then
				cdotc_sub_inst.cblas_cdotc_sub ((a_X.item.size).to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_X.item.data), (a_X.item.stride).to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_Y.item.data), (a_Y.item.stride).to_integer_32, create {CE_POINTER [ANY]}.make_cast ((a_dotc.item.dat)))
				Result := 0
				js.return
			else
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 141, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_blas_zdotu (a_X: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_Y: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_dotu: CE_POINTER [PD_GSL_COMPLEX]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_X.item.size = a_Y.item.size then
				zdotu_sub_inst.cblas_zdotu_sub ((a_X.item.size).to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_X.item.data), (a_X.item.stride).to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_Y.item.data), (a_Y.item.stride).to_integer_32, create {CE_POINTER [ANY]}.make_cast ((a_dotu.item.dat)))
				Result := 0
				js.return
			else
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 158, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_blas_zdotc (a_X: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_Y: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_dotc: CE_POINTER [PD_GSL_COMPLEX]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_X.item.size = a_Y.item.size then
				zdotc_sub_inst.cblas_zdotc_sub ((a_X.item.size).to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_X.item.data), (a_X.item.stride).to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_Y.item.data), (a_Y.item.stride).to_integer_32, create {CE_POINTER [ANY]}.make_cast ((a_dotc.item.dat)))
				Result := 0
				js.return
			else
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 175, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_blas_snrm2 (a_X: CE_POINTER [PD_GSL_VECTOR_FLOAT]): REAL_32
		do
			Result := (snrm2_inst.cblas_snrm2 ((a_X.item.size).to_integer_32, a_X.item.data, (a_X.item.stride).to_integer_32))
		end

	gsl_blas_dnrm2 (a_X: CE_POINTER [PD_GSL_VECTOR]): REAL_64
		do
			Result := (dnrm2_inst.cblas_dnrm2 ((a_X.item.size).to_integer_32, a_X.item.data, (a_X.item.stride).to_integer_32))
		end

	gsl_blas_scnrm2 (a_X: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]): REAL_32
		do
			Result := (scnrm2_inst.cblas_scnrm2 ((a_X.item.size).to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_X.item.data), (a_X.item.stride).to_integer_32))
		end

	gsl_blas_dznrm2 (a_X: CE_POINTER [PD_GSL_VECTOR_COMPLEX]): REAL_64
		do
			Result := (dznrm2_inst.cblas_dznrm2 ((a_X.item.size).to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_X.item.data), (a_X.item.stride).to_integer_32))
		end

	gsl_blas_sasum (a_X: CE_POINTER [PD_GSL_VECTOR_FLOAT]): REAL_32
		do
			Result := (sasum_inst.cblas_sasum ((a_X.item.size).to_integer_32, a_X.item.data, (a_X.item.stride).to_integer_32))
		end

	gsl_blas_dasum (a_X: CE_POINTER [PD_GSL_VECTOR]): REAL_64
		do
			Result := (dasum_inst.cblas_dasum ((a_X.item.size).to_integer_32, a_X.item.data, (a_X.item.stride).to_integer_32))
		end

	gsl_blas_scasum (a_X: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]): REAL_32
		do
			Result := (scasum_inst.cblas_scasum ((a_X.item.size).to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_X.item.data), (a_X.item.stride).to_integer_32))
		end

	gsl_blas_dzasum (a_X: CE_POINTER [PD_GSL_VECTOR_COMPLEX]): REAL_64
		do
			Result := (dzasum_inst.cblas_dzasum ((a_X.item.size).to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_X.item.data), (a_X.item.stride).to_integer_32))
		end

	gsl_blas_isamax (a_X: CE_POINTER [PD_GSL_VECTOR_FLOAT]): NATURAL_32
		do
			Result := (isamax_inst.cblas_isamax ((a_X.item.size).to_integer_32, a_X.item.data, (a_X.item.stride).to_integer_32))
		end

	gsl_blas_idamax (a_X: CE_POINTER [PD_GSL_VECTOR]): NATURAL_32
		do
			Result := (idamax_inst.cblas_idamax ((a_X.item.size).to_integer_32, a_X.item.data, (a_X.item.stride).to_integer_32))
		end

	gsl_blas_icamax (a_X: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]): NATURAL_32
		do
			Result := (icamax_inst.cblas_icamax ((a_X.item.size).to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_X.item.data), (a_X.item.stride).to_integer_32))
		end

	gsl_blas_izamax (a_X: CE_POINTER [PD_GSL_VECTOR_COMPLEX]): NATURAL_32
		do
			Result := (izamax_inst.cblas_izamax ((a_X.item.size).to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_X.item.data), (a_X.item.stride).to_integer_32))
		end

	gsl_blas_sswap (a_X: CE_POINTER [PD_GSL_VECTOR_FLOAT]; a_Y: CE_POINTER [PD_GSL_VECTOR_FLOAT]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_X.item.size = a_Y.item.size then
				sswap_inst.cblas_sswap ((a_X.item.size).to_integer_32, a_X.item.data, (a_X.item.stride).to_integer_32, a_Y.item.data, (a_Y.item.stride).to_integer_32)
				Result := 0
				js.return
			else
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 271, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_blas_dswap (a_X: CE_POINTER [PD_GSL_VECTOR]; a_Y: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_X.item.size = a_Y.item.size then
				dswap_inst.cblas_dswap ((a_X.item.size).to_integer_32, a_X.item.data, (a_X.item.stride).to_integer_32, a_Y.item.data, (a_Y.item.stride).to_integer_32)
				Result := 0
				js.return
			else
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 286, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_blas_cswap (a_X: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]; a_Y: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_X.item.size = a_Y.item.size then
				cswap_inst.cblas_cswap ((a_X.item.size).to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_X.item.data), (a_X.item.stride).to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_Y.item.data), (a_Y.item.stride).to_integer_32)
				Result := 0
				js.return
			else
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 301, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_blas_zswap (a_X: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_Y: CE_POINTER [PD_GSL_VECTOR_COMPLEX]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_X.item.size = a_Y.item.size then
				zswap_inst.cblas_zswap ((a_X.item.size).to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_X.item.data), (a_X.item.stride).to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_Y.item.data), (a_Y.item.stride).to_integer_32)
				Result := 0
				js.return
			else
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 316, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_blas_scopy (a_X: CE_POINTER [PD_GSL_VECTOR_FLOAT]; a_Y: CE_POINTER [PD_GSL_VECTOR_FLOAT]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_X.item.size = a_Y.item.size then
				scopy_inst.cblas_scopy ((a_X.item.size).to_integer_32, a_X.item.data, (a_X.item.stride).to_integer_32, a_Y.item.data, (a_Y.item.stride).to_integer_32)
				Result := 0
				js.return
			else
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 334, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_blas_dcopy (a_X: CE_POINTER [PD_GSL_VECTOR]; a_Y: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_X.item.size = a_Y.item.size then
				dcopy_inst.cblas_dcopy ((a_X.item.size).to_integer_32, a_X.item.data, (a_X.item.stride).to_integer_32, a_Y.item.data, (a_Y.item.stride).to_integer_32)
				Result := 0
				js.return
			else
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 349, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_blas_ccopy (a_X: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]; a_Y: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_X.item.size = a_Y.item.size then
				ccopy_inst.cblas_ccopy ((a_X.item.size).to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_X.item.data), (a_X.item.stride).to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_Y.item.data), (a_Y.item.stride).to_integer_32)
				Result := 0
				js.return
			else
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 365, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_blas_zcopy (a_X: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_Y: CE_POINTER [PD_GSL_VECTOR_COMPLEX]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_X.item.size = a_Y.item.size then
				zcopy_inst.cblas_zcopy ((a_X.item.size).to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_X.item.data), (a_X.item.stride).to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_Y.item.data), (a_Y.item.stride).to_integer_32)
				Result := 0
				js.return
			else
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 380, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_blas_saxpy (a_alpha: REAL_32; a_X: CE_POINTER [PD_GSL_VECTOR_FLOAT]; a_Y: CE_POINTER [PD_GSL_VECTOR_FLOAT]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_X.item.size = a_Y.item.size then
				saxpy_inst.cblas_saxpy ((a_X.item.size).to_integer_32, a_alpha, a_X.item.data, (a_X.item.stride).to_integer_32, a_Y.item.data, (a_Y.item.stride).to_integer_32)
				Result := 0
				js.return
			else
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 398, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_blas_daxpy (a_alpha: REAL_64; a_X: CE_POINTER [PD_GSL_VECTOR]; a_Y: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_X.item.size = a_Y.item.size then
				daxpy_inst.cblas_daxpy ((a_X.item.size).to_integer_32, a_alpha, a_X.item.data, (a_X.item.stride).to_integer_32, a_Y.item.data, (a_Y.item.stride).to_integer_32)
				Result := 0
				js.return
			else
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 413, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_blas_caxpy (a_alpha: PD_GSL_COMPLEX_FLOAT; a_X: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]; a_Y: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_X.item.size = a_Y.item.size then
				caxpy_inst.cblas_caxpy ((a_X.item.size).to_integer_32, create {CE_POINTER [ANY]}.make_cast ((a_alpha.dat)), create {CE_POINTER [ANY]}.make_cast (a_X.item.data), (a_X.item.stride).to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_Y.item.data), (a_Y.item.stride).to_integer_32)
				Result := 0
				js.return
			else
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 430, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_blas_zaxpy (a_alpha: PD_GSL_COMPLEX; a_X: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_Y: CE_POINTER [PD_GSL_VECTOR_COMPLEX]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_X.item.size = a_Y.item.size then
				zaxpy_inst.cblas_zaxpy ((a_X.item.size).to_integer_32, create {CE_POINTER [ANY]}.make_cast ((a_alpha.dat)), create {CE_POINTER [ANY]}.make_cast (a_X.item.data), (a_X.item.stride).to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_Y.item.data), (a_Y.item.stride).to_integer_32)
				Result := 0
				js.return
			else
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 446, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_blas_srotg (a_a___5: CE_POINTER [REAL_32]; a_b___0: CE_POINTER [REAL_32]; a_c___1: CE_POINTER [REAL_32]; a_s: CE_POINTER [REAL_32]): INTEGER_32
		do
			srotg_inst.cblas_srotg (a_a___5, a_b___0, a_c___1, a_s)
			Result := 0
		end

	gsl_blas_drotg (a_a___5: CE_POINTER [REAL_64]; a_b___0: CE_POINTER [REAL_64]; a_c___1: CE_POINTER [REAL_64]; a_s: CE_POINTER [REAL_64]): INTEGER_32
		do
			drotg_inst.cblas_drotg (a_a___5, a_b___0, a_c___1, a_s)
			Result := 0
		end

	gsl_blas_srot (a_X: CE_POINTER [PD_GSL_VECTOR_FLOAT]; a_Y: CE_POINTER [PD_GSL_VECTOR_FLOAT]; a_c___1: REAL_32; a_s: REAL_32): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_X.item.size = a_Y.item.size then
				srot_inst.cblas_srot ((a_X.item.size).to_integer_32, a_X.item.data, (a_X.item.stride).to_integer_32, a_Y.item.data, (a_Y.item.stride).to_integer_32, a_c___1, a_s)
				Result := 0
				js.return
			else
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 479, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_blas_drot (a_X: CE_POINTER [PD_GSL_VECTOR]; a_Y: CE_POINTER [PD_GSL_VECTOR]; a_c___1: REAL_64; a_s: REAL_64): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_X.item.size = a_Y.item.size then
				drot_inst.cblas_drot ((a_X.item.size).to_integer_32, a_X.item.data, (a_X.item.stride).to_integer_32, a_Y.item.data, (a_Y.item.stride).to_integer_32, a_c___1, a_s)
				Result := 0
				js.return
			else
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 494, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_blas_srotmg (a_d1: CE_POINTER [REAL_32]; a_d2: CE_POINTER [REAL_32]; a_b1___0: CE_POINTER [REAL_32]; a_b2: REAL_32; a_P___2: CE_POINTER [REAL_32]): INTEGER_32
		do
			srotmg_inst.cblas_srotmg (a_d1, a_d2, a_b1___0, a_b2, a_P___2)
			Result := 0
		end

	gsl_blas_drotmg (a_d1: CE_POINTER [REAL_64]; a_d2: CE_POINTER [REAL_64]; a_b1___0: CE_POINTER [REAL_64]; a_b2: REAL_64; a_P___2: CE_POINTER [REAL_64]): INTEGER_32
		do
			drotmg_inst.cblas_drotmg (a_d1, a_d2, a_b1___0, a_b2, a_P___2)
			Result := 0
		end

	gsl_blas_srotm (a_X: CE_POINTER [PD_GSL_VECTOR_FLOAT]; a_Y: CE_POINTER [PD_GSL_VECTOR_FLOAT]; a_P___2: CE_POINTER [REAL_32]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_X.item.size = a_Y.item.size then
				srotm_inst.cblas_srotm ((a_X.item.size).to_integer_32, a_X.item.data, (a_X.item.stride).to_integer_32, a_Y.item.data, (a_Y.item.stride).to_integer_32, a_P___2)
				Result := 0
				js.return
			else
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 529, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_blas_drotm (a_X: CE_POINTER [PD_GSL_VECTOR]; a_Y: CE_POINTER [PD_GSL_VECTOR]; a_P___2: CE_POINTER [REAL_64]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_X.item.size = a_Y.item.size then
				drotm_inst.cblas_drotm ((a_X.item.size).to_integer_32, a_X.item.data, (a_X.item.stride).to_integer_32, a_Y.item.data, (a_Y.item.stride).to_integer_32, a_P___2)
				Result := 0
				js.return
			else
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 544, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_blas_sscal (a_alpha: REAL_32; a_X: CE_POINTER [PD_GSL_VECTOR_FLOAT])
		do
			sscal_inst.cblas_sscal ((a_X.item.size).to_integer_32, a_alpha, a_X.item.data, (a_X.item.stride).to_integer_32)
		end

	gsl_blas_dscal (a_alpha: REAL_64; a_X: CE_POINTER [PD_GSL_VECTOR])
		do
			dscal_inst.cblas_dscal ((a_X.item.size).to_integer_32, a_alpha, a_X.item.data, (a_X.item.stride).to_integer_32)
		end

	gsl_blas_cscal (a_alpha: PD_GSL_COMPLEX_FLOAT; a_X: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT])
		do
			cscal_inst.cblas_cscal ((a_X.item.size).to_integer_32, create {CE_POINTER [ANY]}.make_cast ((a_alpha.dat)), create {CE_POINTER [ANY]}.make_cast (a_X.item.data), (a_X.item.stride).to_integer_32)
		end

	gsl_blas_zscal (a_alpha: PD_GSL_COMPLEX; a_X: CE_POINTER [PD_GSL_VECTOR_COMPLEX])
		do
			zscal_inst.cblas_zscal ((a_X.item.size).to_integer_32, create {CE_POINTER [ANY]}.make_cast ((a_alpha.dat)), create {CE_POINTER [ANY]}.make_cast (a_X.item.data), (a_X.item.stride).to_integer_32)
		end

	gsl_blas_csscal (a_alpha: REAL_32; a_X: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT])
		do
			csscal_inst.cblas_csscal ((a_X.item.size).to_integer_32, a_alpha, create {CE_POINTER [ANY]}.make_cast (a_X.item.data), (a_X.item.stride).to_integer_32)
		end

	gsl_blas_zdscal (a_alpha: REAL_64; a_X: CE_POINTER [PD_GSL_VECTOR_COMPLEX])
		do
			zdscal_inst.cblas_zdscal ((a_X.item.size).to_integer_32, a_alpha, create {CE_POINTER [ANY]}.make_cast (a_X.item.data), (a_X.item.stride).to_integer_32)
		end

	gsl_blas_sgemv (a_TransA: INTEGER_32; a_alpha: REAL_32; a_A___0: CE_POINTER [PD_GSL_MATRIX_FLOAT]; a_X: CE_POINTER [PD_GSL_VECTOR_FLOAT]; a_beta: REAL_32; a_Y: CE_POINTER [PD_GSL_VECTOR_FLOAT]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := a_A___0.item.size1
					l_N := a_A___0.item.size2
					if a_TransA.to_natural_32 /= {NATURAL_32} 111 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if l_N = a_X.item.size then
							if l_M = a_Y.item.size then
								sgemv_inst.cblas_sgemv ({PC_CBLAS_ORDER}.CblasRowMajor, a_TransA, l_M.to_integer_32, l_N.to_integer_32, a_alpha, a_A___0.item.data, (a_A___0.item.tda).to_integer_32, a_X.item.data, (a_X.item.stride).to_integer_32, a_beta, a_Y.item.data, (a_Y.item.stride).to_integer_32)
								Result := 0
								js.return
							else
								l_pos := -1 + 3 -- goto _L___2
							end
						else
							l_pos := -1 + 3 -- goto _L___2
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else: | _L___2:
						if a_TransA.to_natural_32 /= {NATURAL_32} 112 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if l_M = a_X.item.size then
							if l_N = a_Y.item.size then
								sgemv_inst.cblas_sgemv ({PC_CBLAS_ORDER}.CblasRowMajor, a_TransA, l_M.to_integer_32, l_N.to_integer_32, a_alpha, a_A___0.item.data, (a_A___0.item.tda).to_integer_32, a_X.item.data, (a_X.item.stride).to_integer_32, a_beta, a_Y.item.data, (a_Y.item.stride).to_integer_32)
								Result := 0
								js.return
							else
								l_pos := -1 + 6 -- goto _L___0
							end
						else
							l_pos := -1 + 6 -- goto _L___0
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L___0:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 614, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 7 then -- if done
						if not js.return_called then
							Result := 0
						end
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_blas_dgemv (a_TransA: INTEGER_32; a_alpha: REAL_64; a_A___0: CE_POINTER [PD_GSL_MATRIX]; a_X: CE_POINTER [PD_GSL_VECTOR]; a_beta: REAL_64; a_Y: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := a_A___0.item.size1
					l_N := a_A___0.item.size2
					if a_TransA.to_natural_32 /= {NATURAL_32} 111 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if l_N = a_X.item.size then
							if l_M = a_Y.item.size then
								dgemv_inst.cblas_dgemv ({PC_CBLAS_ORDER}.CblasRowMajor, a_TransA, l_M.to_integer_32, l_N.to_integer_32, a_alpha, a_A___0.item.data, (a_A___0.item.tda).to_integer_32, a_X.item.data, (a_X.item.stride).to_integer_32, a_beta, a_Y.item.data, (a_Y.item.stride).to_integer_32)
								Result := 0
								js.return
							else
								l_pos := -1 + 3 -- goto _L___2
							end
						else
							l_pos := -1 + 3 -- goto _L___2
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else: | _L___2:
						if a_TransA.to_natural_32 /= {NATURAL_32} 112 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if l_M = a_X.item.size then
							if l_N = a_Y.item.size then
								dgemv_inst.cblas_dgemv ({PC_CBLAS_ORDER}.CblasRowMajor, a_TransA, l_M.to_integer_32, l_N.to_integer_32, a_alpha, a_A___0.item.data, (a_A___0.item.tda).to_integer_32, a_X.item.data, (a_X.item.stride).to_integer_32, a_beta, a_Y.item.data, (a_Y.item.stride).to_integer_32)
								Result := 0
								js.return
							else
								l_pos := -1 + 6 -- goto _L___0
							end
						else
							l_pos := -1 + 6 -- goto _L___0
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L___0:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 636, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 7 then -- if done
						if not js.return_called then
							Result := 0
						end
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_blas_cgemv (a_TransA: INTEGER_32; a_alpha: PD_GSL_COMPLEX_FLOAT; a_A___0: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]; a_X: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]; a_beta: PD_GSL_COMPLEX_FLOAT; a_Y: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := a_A___0.item.size1
					l_N := a_A___0.item.size2
					if a_TransA.to_natural_32 /= {NATURAL_32} 111 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if l_N = a_X.item.size then
							if l_M = a_Y.item.size then
								cgemv_inst.cblas_cgemv ({PC_CBLAS_ORDER}.CblasRowMajor, a_TransA, l_M.to_integer_32, l_N.to_integer_32, create {CE_POINTER [ANY]}.make_cast ((a_alpha.dat)), create {CE_POINTER [ANY]}.make_cast (a_A___0.item.data), (a_A___0.item.tda).to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_X.item.data), (a_X.item.stride).to_integer_32, create {CE_POINTER [ANY]}.make_cast ((a_beta.dat)), create {CE_POINTER [ANY]}.make_cast (a_Y.item.data), (a_Y.item.stride).to_integer_32)
								Result := 0
								js.return
							else
								l_pos := -1 + 3 -- goto _L___4
							end
						else
							l_pos := -1 + 3 -- goto _L___4
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 3 then -- else: | _L___4:
						if a_TransA.to_natural_32 /= {NATURAL_32} 112 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if l_M = a_X.item.size then
							if l_N = a_Y.item.size then
								cgemv_inst.cblas_cgemv ({PC_CBLAS_ORDER}.CblasRowMajor, a_TransA, l_M.to_integer_32, l_N.to_integer_32, create {CE_POINTER [ANY]}.make_cast ((a_alpha.dat)), create {CE_POINTER [ANY]}.make_cast (a_A___0.item.data), (a_A___0.item.tda).to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_X.item.data), (a_X.item.stride).to_integer_32, create {CE_POINTER [ANY]}.make_cast ((a_beta.dat)), create {CE_POINTER [ANY]}.make_cast (a_Y.item.data), (a_Y.item.stride).to_integer_32)
								Result := 0
								js.return
							else
								l_pos := -1 + 6 -- goto _L___2
							end
						else
							l_pos := -1 + 6 -- goto _L___2
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 6 then -- else: | _L___2:
						if a_TransA.to_natural_32 /= {NATURAL_32} 113 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if l_M = a_X.item.size then
							if l_N = a_Y.item.size then
								cgemv_inst.cblas_cgemv ({PC_CBLAS_ORDER}.CblasRowMajor, a_TransA, l_M.to_integer_32, l_N.to_integer_32, create {CE_POINTER [ANY]}.make_cast ((a_alpha.dat)), create {CE_POINTER [ANY]}.make_cast (a_A___0.item.data), (a_A___0.item.tda).to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_X.item.data), (a_X.item.stride).to_integer_32, create {CE_POINTER [ANY]}.make_cast ((a_beta.dat)), create {CE_POINTER [ANY]}.make_cast (a_Y.item.data), (a_Y.item.stride).to_integer_32)
								Result := 0
								js.return
							else
								l_pos := -1 + 9 -- goto _L___0
							end
						else
							l_pos := -1 + 9 -- goto _L___0
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else: | _L___0:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 662, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 10 then -- if done | if done
						if not js.return_called then
							Result := 0
						end
				when 11 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_blas_zgemv (a_TransA: INTEGER_32; a_alpha: PD_GSL_COMPLEX; a_A___0: CE_POINTER [PD_GSL_MATRIX_COMPLEX]; a_X: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_beta: PD_GSL_COMPLEX; a_Y: CE_POINTER [PD_GSL_VECTOR_COMPLEX]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := a_A___0.item.size1
					l_N := a_A___0.item.size2
					if a_TransA.to_natural_32 /= {NATURAL_32} 111 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if l_N = a_X.item.size then
							if l_M = a_Y.item.size then
								zgemv_inst.cblas_zgemv ({PC_CBLAS_ORDER}.CblasRowMajor, a_TransA, l_M.to_integer_32, l_N.to_integer_32, create {CE_POINTER [ANY]}.make_cast ((a_alpha.dat)), create {CE_POINTER [ANY]}.make_cast (a_A___0.item.data), (a_A___0.item.tda).to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_X.item.data), (a_X.item.stride).to_integer_32, create {CE_POINTER [ANY]}.make_cast ((a_beta.dat)), create {CE_POINTER [ANY]}.make_cast (a_Y.item.data), (a_Y.item.stride).to_integer_32)
								Result := 0
								js.return
							else
								l_pos := -1 + 3 -- goto _L___4
							end
						else
							l_pos := -1 + 3 -- goto _L___4
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 3 then -- else: | _L___4:
						if a_TransA.to_natural_32 /= {NATURAL_32} 112 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if l_M = a_X.item.size then
							if l_N = a_Y.item.size then
								zgemv_inst.cblas_zgemv ({PC_CBLAS_ORDER}.CblasRowMajor, a_TransA, l_M.to_integer_32, l_N.to_integer_32, create {CE_POINTER [ANY]}.make_cast ((a_alpha.dat)), create {CE_POINTER [ANY]}.make_cast (a_A___0.item.data), (a_A___0.item.tda).to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_X.item.data), (a_X.item.stride).to_integer_32, create {CE_POINTER [ANY]}.make_cast ((a_beta.dat)), create {CE_POINTER [ANY]}.make_cast (a_Y.item.data), (a_Y.item.stride).to_integer_32)
								Result := 0
								js.return
							else
								l_pos := -1 + 6 -- goto _L___2
							end
						else
							l_pos := -1 + 6 -- goto _L___2
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 6 then -- else: | _L___2:
						if a_TransA.to_natural_32 /= {NATURAL_32} 113 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if l_M = a_X.item.size then
							if l_N = a_Y.item.size then
								zgemv_inst.cblas_zgemv ({PC_CBLAS_ORDER}.CblasRowMajor, a_TransA, l_M.to_integer_32, l_N.to_integer_32, create {CE_POINTER [ANY]}.make_cast ((a_alpha.dat)), create {CE_POINTER [ANY]}.make_cast (a_A___0.item.data), (a_A___0.item.tda).to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_X.item.data), (a_X.item.stride).to_integer_32, create {CE_POINTER [ANY]}.make_cast ((a_beta.dat)), create {CE_POINTER [ANY]}.make_cast (a_Y.item.data), (a_Y.item.stride).to_integer_32)
								Result := 0
								js.return
							else
								l_pos := -1 + 9 -- goto _L___0
							end
						else
							l_pos := -1 + 9 -- goto _L___0
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else: | _L___0:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 687, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 10 then -- if done | if done
						if not js.return_called then
							Result := 0
						end
				when 11 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_blas_chemv (a_Uplo: INTEGER_32; a_alpha: PD_GSL_COMPLEX_FLOAT; a_A___0: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]; a_X: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]; a_beta: PD_GSL_COMPLEX_FLOAT; a_Y: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := a_A___0.item.size1
					l_N := a_A___0.item.size2
					if l_M = l_N then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("matrix must be square"), ce_string ("blas.c"), 706, 20)
							Result := 20
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 3 then -- else:
						if l_N = a_X.item.size then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 6 then -- else:
						if l_N = a_Y.item.size then
							l_pos := -1 + 8 -- skip if block
						end
				when 7 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 710, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 8 then -- if done | if done
						if not js.return_called then
							chemv_inst.cblas_chemv ({PC_CBLAS_ORDER}.CblasRowMajor, a_Uplo, l_N.to_integer_32, create {CE_POINTER [ANY]}.make_cast ((a_alpha.dat)), create {CE_POINTER [ANY]}.make_cast (a_A___0.item.data), (a_A___0.item.tda).to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_X.item.data), (a_X.item.stride).to_integer_32, create {CE_POINTER [ANY]}.make_cast ((a_beta.dat)), create {CE_POINTER [ANY]}.make_cast (a_Y.item.data), (a_Y.item.stride).to_integer_32)
							Result := 0
						end
				when 9 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_blas_zhemv (a_Uplo: INTEGER_32; a_alpha: PD_GSL_COMPLEX; a_A___0: CE_POINTER [PD_GSL_MATRIX_COMPLEX]; a_X: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_beta: PD_GSL_COMPLEX; a_Y: CE_POINTER [PD_GSL_VECTOR_COMPLEX]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := a_A___0.item.size1
					l_N := a_A___0.item.size2
					if l_M = l_N then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("matrix must be square"), ce_string ("blas.c"), 729, 20)
							Result := 20
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 3 then -- else:
						if l_N = a_X.item.size then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 6 then -- else:
						if l_N = a_Y.item.size then
							l_pos := -1 + 8 -- skip if block
						end
				when 7 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 733, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 8 then -- if done | if done
						if not js.return_called then
							zhemv_inst.cblas_zhemv ({PC_CBLAS_ORDER}.CblasRowMajor, a_Uplo, l_N.to_integer_32, create {CE_POINTER [ANY]}.make_cast ((a_alpha.dat)), create {CE_POINTER [ANY]}.make_cast (a_A___0.item.data), (a_A___0.item.tda).to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_X.item.data), (a_X.item.stride).to_integer_32, create {CE_POINTER [ANY]}.make_cast ((a_beta.dat)), create {CE_POINTER [ANY]}.make_cast (a_Y.item.data), (a_Y.item.stride).to_integer_32)
							Result := 0
						end
				when 9 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_blas_ssymv (a_Uplo: INTEGER_32; a_alpha: REAL_32; a_A___0: CE_POINTER [PD_GSL_MATRIX_FLOAT]; a_X: CE_POINTER [PD_GSL_VECTOR_FLOAT]; a_beta: REAL_32; a_Y: CE_POINTER [PD_GSL_VECTOR_FLOAT]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := a_A___0.item.size1
					l_N := a_A___0.item.size2
					if l_M = l_N then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("matrix must be square"), ce_string ("blas.c"), 754, 20)
							Result := 20
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 3 then -- else:
						if l_N = a_X.item.size then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 6 then -- else:
						if l_N = a_Y.item.size then
							l_pos := -1 + 8 -- skip if block
						end
				when 7 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 758, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 8 then -- if done | if done
						if not js.return_called then
							ssymv_inst.cblas_ssymv ({PC_CBLAS_ORDER}.CblasRowMajor, a_Uplo, l_N.to_integer_32, a_alpha, a_A___0.item.data, (a_A___0.item.tda).to_integer_32, a_X.item.data, (a_X.item.stride).to_integer_32, a_beta, a_Y.item.data, (a_Y.item.stride).to_integer_32)
							Result := 0
						end
				when 9 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_blas_dsymv (a_Uplo: INTEGER_32; a_alpha: REAL_64; a_A___0: CE_POINTER [PD_GSL_MATRIX]; a_X: CE_POINTER [PD_GSL_VECTOR]; a_beta: REAL_64; a_Y: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := a_A___0.item.size1
					l_N := a_A___0.item.size2
					if l_M = l_N then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("matrix must be square"), ce_string ("blas.c"), 775, 20)
							Result := 20
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 3 then -- else:
						if l_N = a_X.item.size then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 6 then -- else:
						if l_N = a_Y.item.size then
							l_pos := -1 + 8 -- skip if block
						end
				when 7 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 779, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 8 then -- if done | if done
						if not js.return_called then
							dsymv_inst.cblas_dsymv ({PC_CBLAS_ORDER}.CblasRowMajor, a_Uplo, l_N.to_integer_32, a_alpha, a_A___0.item.data, (a_A___0.item.tda).to_integer_32, a_X.item.data, (a_X.item.stride).to_integer_32, a_beta, a_Y.item.data, (a_Y.item.stride).to_integer_32)
							Result := 0
						end
				when 9 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_blas_strmv (a_Uplo: INTEGER_32; a_TransA: INTEGER_32; a_Diag: INTEGER_32; a_A___0: CE_POINTER [PD_GSL_MATRIX_FLOAT]; a_X: CE_POINTER [PD_GSL_VECTOR_FLOAT]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			js: JUMP_STATE
		do
			l_M := a_A___0.item.size1
			l_N := a_A___0.item.size2
			if l_M /= l_N then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix must be square"), ce_string ("blas.c"), 800, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif l_N /= a_X.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 804, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				strmv_inst.cblas_strmv ({PC_CBLAS_ORDER}.CblasRowMajor, a_Uplo, a_TransA, a_Diag, l_N.to_integer_32, a_A___0.item.data, (a_A___0.item.tda).to_integer_32, a_X.item.data, (a_X.item.stride).to_integer_32)
				Result := 0
			end
		end

	gsl_blas_dtrmv (a_Uplo: INTEGER_32; a_TransA: INTEGER_32; a_Diag: INTEGER_32; a_A___0: CE_POINTER [PD_GSL_MATRIX]; a_X: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			js: JUMP_STATE
		do
			l_M := a_A___0.item.size1
			l_N := a_A___0.item.size2
			if l_M /= l_N then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix must be square"), ce_string ("blas.c"), 822, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif l_N /= a_X.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 826, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				dtrmv_inst.cblas_dtrmv ({PC_CBLAS_ORDER}.CblasRowMajor, a_Uplo, a_TransA, a_Diag, l_N.to_integer_32, a_A___0.item.data, (a_A___0.item.tda).to_integer_32, a_X.item.data, (a_X.item.stride).to_integer_32)
				Result := 0
			end
		end

	gsl_blas_ctrmv (a_Uplo: INTEGER_32; a_TransA: INTEGER_32; a_Diag: INTEGER_32; a_A___0: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]; a_X: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			js: JUMP_STATE
		do
			l_M := a_A___0.item.size1
			l_N := a_A___0.item.size2
			if l_M /= l_N then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix must be square"), ce_string ("blas.c"), 845, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif l_N /= a_X.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 849, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				ctrmv_inst.cblas_ctrmv ({PC_CBLAS_ORDER}.CblasRowMajor, a_Uplo, a_TransA, a_Diag, l_N.to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_A___0.item.data), (a_A___0.item.tda).to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_X.item.data), (a_X.item.stride).to_integer_32)
				Result := 0
			end
		end

	gsl_blas_ztrmv (a_Uplo: INTEGER_32; a_TransA: INTEGER_32; a_Diag: INTEGER_32; a_A___0: CE_POINTER [PD_GSL_MATRIX_COMPLEX]; a_X: CE_POINTER [PD_GSL_VECTOR_COMPLEX]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			js: JUMP_STATE
		do
			l_M := a_A___0.item.size1
			l_N := a_A___0.item.size2
			if l_M /= l_N then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix must be square"), ce_string ("blas.c"), 868, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif l_N /= a_X.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 872, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				ztrmv_inst.cblas_ztrmv ({PC_CBLAS_ORDER}.CblasRowMajor, a_Uplo, a_TransA, a_Diag, l_N.to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_A___0.item.data), (a_A___0.item.tda).to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_X.item.data), (a_X.item.stride).to_integer_32)
				Result := 0
			end
		end

	gsl_blas_strsv (a_Uplo: INTEGER_32; a_TransA: INTEGER_32; a_Diag: INTEGER_32; a_A___0: CE_POINTER [PD_GSL_MATRIX_FLOAT]; a_X: CE_POINTER [PD_GSL_VECTOR_FLOAT]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			js: JUMP_STATE
		do
			l_M := a_A___0.item.size1
			l_N := a_A___0.item.size2
			if l_M /= l_N then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix must be square"), ce_string ("blas.c"), 893, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif l_N /= a_X.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 897, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				strsv_inst.cblas_strsv ({PC_CBLAS_ORDER}.CblasRowMajor, a_Uplo, a_TransA, a_Diag, l_N.to_integer_32, a_A___0.item.data, (a_A___0.item.tda).to_integer_32, a_X.item.data, (a_X.item.stride).to_integer_32)
				Result := 0
			end
		end

	gsl_blas_dtrsv (a_Uplo: INTEGER_32; a_TransA: INTEGER_32; a_Diag: INTEGER_32; a_A___0: CE_POINTER [PD_GSL_MATRIX]; a_X: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			js: JUMP_STATE
		do
			l_M := a_A___0.item.size1
			l_N := a_A___0.item.size2
			if l_M /= l_N then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix must be square"), ce_string ("blas.c"), 915, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif l_N /= a_X.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 919, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				dtrsv_inst.cblas_dtrsv ({PC_CBLAS_ORDER}.CblasRowMajor, a_Uplo, a_TransA, a_Diag, l_N.to_integer_32, a_A___0.item.data, (a_A___0.item.tda).to_integer_32, a_X.item.data, (a_X.item.stride).to_integer_32)
				Result := 0
			end
		end

	gsl_blas_ctrsv (a_Uplo: INTEGER_32; a_TransA: INTEGER_32; a_Diag: INTEGER_32; a_A___0: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]; a_X: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			js: JUMP_STATE
		do
			l_M := a_A___0.item.size1
			l_N := a_A___0.item.size2
			if l_M /= l_N then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix must be square"), ce_string ("blas.c"), 938, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif l_N /= a_X.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 942, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				ctrsv_inst.cblas_ctrsv ({PC_CBLAS_ORDER}.CblasRowMajor, a_Uplo, a_TransA, a_Diag, l_N.to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_A___0.item.data), (a_A___0.item.tda).to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_X.item.data), (a_X.item.stride).to_integer_32)
				Result := 0
			end
		end

	gsl_blas_ztrsv (a_Uplo: INTEGER_32; a_TransA: INTEGER_32; a_Diag: INTEGER_32; a_A___0: CE_POINTER [PD_GSL_MATRIX_COMPLEX]; a_X: CE_POINTER [PD_GSL_VECTOR_COMPLEX]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			js: JUMP_STATE
		do
			l_M := a_A___0.item.size1
			l_N := a_A___0.item.size2
			if l_M /= l_N then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix must be square"), ce_string ("blas.c"), 961, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif l_N /= a_X.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 965, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				ztrsv_inst.cblas_ztrsv ({PC_CBLAS_ORDER}.CblasRowMajor, a_Uplo, a_TransA, a_Diag, l_N.to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_A___0.item.data), (a_A___0.item.tda).to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_X.item.data), (a_X.item.stride).to_integer_32)
				Result := 0
			end
		end

	gsl_blas_sger (a_alpha: REAL_32; a_X: CE_POINTER [PD_GSL_VECTOR_FLOAT]; a_Y: CE_POINTER [PD_GSL_VECTOR_FLOAT]; a_A___0: CE_POINTER [PD_GSL_MATRIX_FLOAT]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := a_A___0.item.size1
					l_N := a_A___0.item.size2
					if a_X.item.size /= l_M then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if a_Y.item.size = l_N then
							sger_inst.cblas_sger ({PC_CBLAS_ORDER}.CblasRowMajor, l_M.to_integer_32, l_N.to_integer_32, a_alpha, a_X.item.data, (a_X.item.stride).to_integer_32, a_Y.item.data, (a_Y.item.stride).to_integer_32, a_A___0.item.data, (a_A___0.item.tda).to_integer_32)
							Result := 0
							js.return
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 992, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 4 then
					if not js.return_called then
						Result := 0
					end
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gsl_blas_dger (a_alpha: REAL_64; a_X: CE_POINTER [PD_GSL_VECTOR]; a_Y: CE_POINTER [PD_GSL_VECTOR]; a_A___0: CE_POINTER [PD_GSL_MATRIX]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := a_A___0.item.size1
					l_N := a_A___0.item.size2
					if a_X.item.size /= l_M then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if a_Y.item.size = l_N then
							dger_inst.cblas_dger ({PC_CBLAS_ORDER}.CblasRowMajor, l_M.to_integer_32, l_N.to_integer_32, a_alpha, a_X.item.data, (a_X.item.stride).to_integer_32, a_Y.item.data, (a_Y.item.stride).to_integer_32, a_A___0.item.data, (a_A___0.item.tda).to_integer_32)
							Result := 0
							js.return
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 1013, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 4 then
					if not js.return_called then
						Result := 0
					end
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gsl_blas_cgeru (a_alpha: PD_GSL_COMPLEX_FLOAT; a_X: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]; a_Y: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]; a_A___0: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := a_A___0.item.size1
					l_N := a_A___0.item.size2
					if a_X.item.size /= l_M then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if a_Y.item.size = l_N then
							cgeru_inst.cblas_cgeru ({PC_CBLAS_ORDER}.CblasRowMajor, l_M.to_integer_32, l_N.to_integer_32, create {CE_POINTER [ANY]}.make_cast ((a_alpha.dat)), create {CE_POINTER [ANY]}.make_cast (a_X.item.data), (a_X.item.stride).to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_Y.item.data), (a_Y.item.stride).to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_A___0.item.data), (a_A___0.item.tda).to_integer_32)
							Result := 0
							js.return
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 1038, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 4 then
					if not js.return_called then
						Result := 0
					end
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gsl_blas_zgeru (a_alpha: PD_GSL_COMPLEX; a_X: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_Y: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_A___0: CE_POINTER [PD_GSL_MATRIX_COMPLEX]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := a_A___0.item.size1
					l_N := a_A___0.item.size2
					if a_X.item.size /= l_M then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if a_Y.item.size = l_N then
							zgeru_inst.cblas_zgeru ({PC_CBLAS_ORDER}.CblasRowMajor, l_M.to_integer_32, l_N.to_integer_32, create {CE_POINTER [ANY]}.make_cast ((a_alpha.dat)), create {CE_POINTER [ANY]}.make_cast (a_X.item.data), (a_X.item.stride).to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_Y.item.data), (a_Y.item.stride).to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_A___0.item.data), (a_A___0.item.tda).to_integer_32)
							Result := 0
							js.return
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 1058, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 4 then
					if not js.return_called then
						Result := 0
					end
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gsl_blas_cgerc (a_alpha: PD_GSL_COMPLEX_FLOAT; a_X: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]; a_Y: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]; a_A___0: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := a_A___0.item.size1
					l_N := a_A___0.item.size2
					if a_X.item.size /= l_M then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if a_Y.item.size = l_N then
							cgerc_inst.cblas_cgerc ({PC_CBLAS_ORDER}.CblasRowMajor, l_M.to_integer_32, l_N.to_integer_32, create {CE_POINTER [ANY]}.make_cast ((a_alpha.dat)), create {CE_POINTER [ANY]}.make_cast (a_X.item.data), (a_X.item.stride).to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_Y.item.data), (a_Y.item.stride).to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_A___0.item.data), (a_A___0.item.tda).to_integer_32)
							Result := 0
							js.return
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 1083, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 4 then
					if not js.return_called then
						Result := 0
					end
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gsl_blas_zgerc (a_alpha: PD_GSL_COMPLEX; a_X: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_Y: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_A___0: CE_POINTER [PD_GSL_MATRIX_COMPLEX]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := a_A___0.item.size1
					l_N := a_A___0.item.size2
					if a_X.item.size /= l_M then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if a_Y.item.size = l_N then
							zgerc_inst.cblas_zgerc ({PC_CBLAS_ORDER}.CblasRowMajor, l_M.to_integer_32, l_N.to_integer_32, create {CE_POINTER [ANY]}.make_cast ((a_alpha.dat)), create {CE_POINTER [ANY]}.make_cast (a_X.item.data), (a_X.item.stride).to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_Y.item.data), (a_Y.item.stride).to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_A___0.item.data), (a_A___0.item.tda).to_integer_32)
							Result := 0
							js.return
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 1104, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 4 then
					if not js.return_called then
						Result := 0
					end
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gsl_blas_cher (a_Uplo: INTEGER_32; a_alpha: REAL_32; a_X: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]; a_A___0: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			js: JUMP_STATE
		do
			l_M := a_A___0.item.size1
			l_N := a_A___0.item.size2
			if l_M /= l_N then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix must be square"), ce_string ("blas.c"), 1120, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_X.item.size /= l_N then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 1124, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				cher_inst.cblas_cher ({PC_CBLAS_ORDER}.CblasRowMajor, a_Uplo, l_M.to_integer_32, a_alpha, create {CE_POINTER [ANY]}.make_cast (a_X.item.data), (a_X.item.stride).to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_A___0.item.data), (a_A___0.item.tda).to_integer_32)
				Result := 0
			end
		end

	gsl_blas_zher (a_Uplo: INTEGER_32; a_alpha: REAL_64; a_X: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_A___0: CE_POINTER [PD_GSL_MATRIX_COMPLEX]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			js: JUMP_STATE
		do
			l_M := a_A___0.item.size1
			l_N := a_A___0.item.size2
			if l_M /= l_N then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix must be square"), ce_string ("blas.c"), 1142, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_X.item.size /= l_N then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 1146, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				zher_inst.cblas_zher ({PC_CBLAS_ORDER}.CblasRowMajor, a_Uplo, l_N.to_integer_32, a_alpha, create {CE_POINTER [ANY]}.make_cast (a_X.item.data), (a_X.item.stride).to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_A___0.item.data), (a_A___0.item.tda).to_integer_32)
				Result := 0
			end
		end

	gsl_blas_cher2 (a_Uplo: INTEGER_32; a_alpha: PD_GSL_COMPLEX_FLOAT; a_X: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]; a_Y: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]; a_A___0: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := a_A___0.item.size1
					l_N := a_A___0.item.size2
					if l_M = l_N then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("matrix must be square"), ce_string ("blas.c"), 1168, 20)
							Result := 20
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 3 then -- else:
						if a_X.item.size = l_N then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 6 then -- else:
						if a_Y.item.size = l_N then
							l_pos := -1 + 8 -- skip if block
						end
				when 7 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 1172, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 8 then -- if done | if done
						if not js.return_called then
							cher2_inst.cblas_cher2 ({PC_CBLAS_ORDER}.CblasRowMajor, a_Uplo, l_N.to_integer_32, create {CE_POINTER [ANY]}.make_cast ((a_alpha.dat)), create {CE_POINTER [ANY]}.make_cast (a_X.item.data), (a_X.item.stride).to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_Y.item.data), (a_Y.item.stride).to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_A___0.item.data), (a_A___0.item.tda).to_integer_32)
							Result := 0
						end
				when 9 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_blas_zher2 (a_Uplo: INTEGER_32; a_alpha: PD_GSL_COMPLEX; a_X: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_Y: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_A___0: CE_POINTER [PD_GSL_MATRIX_COMPLEX]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := a_A___0.item.size1
					l_N := a_A___0.item.size2
					if l_M = l_N then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("matrix must be square"), ce_string ("blas.c"), 1192, 20)
							Result := 20
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 3 then -- else:
						if a_X.item.size = l_N then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 6 then -- else:
						if a_Y.item.size = l_N then
							l_pos := -1 + 8 -- skip if block
						end
				when 7 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 1196, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 8 then -- if done | if done
						if not js.return_called then
							zher2_inst.cblas_zher2 ({PC_CBLAS_ORDER}.CblasRowMajor, a_Uplo, l_N.to_integer_32, create {CE_POINTER [ANY]}.make_cast ((a_alpha.dat)), create {CE_POINTER [ANY]}.make_cast (a_X.item.data), (a_X.item.stride).to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_Y.item.data), (a_Y.item.stride).to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_A___0.item.data), (a_A___0.item.tda).to_integer_32)
							Result := 0
						end
				when 9 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_blas_ssyr (a_Uplo: INTEGER_32; a_alpha: REAL_32; a_X: CE_POINTER [PD_GSL_VECTOR_FLOAT]; a_A___0: CE_POINTER [PD_GSL_MATRIX_FLOAT]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			js: JUMP_STATE
		do
			l_M := a_A___0.item.size1
			l_N := a_A___0.item.size2
			if l_M /= l_N then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix must be square"), ce_string ("blas.c"), 1217, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_X.item.size /= l_N then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 1221, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				ssyr_inst.cblas_ssyr ({PC_CBLAS_ORDER}.CblasRowMajor, a_Uplo, l_N.to_integer_32, a_alpha, a_X.item.data, (a_X.item.stride).to_integer_32, a_A___0.item.data, (a_A___0.item.tda).to_integer_32)
				Result := 0
			end
		end

	gsl_blas_dsyr (a_Uplo: INTEGER_32; a_alpha: REAL_64; a_X: CE_POINTER [PD_GSL_VECTOR]; a_A___0: CE_POINTER [PD_GSL_MATRIX]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			js: JUMP_STATE
		do
			l_M := a_A___0.item.size1
			l_N := a_A___0.item.size2
			if l_M /= l_N then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix must be square"), ce_string ("blas.c"), 1239, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_X.item.size /= l_N then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 1243, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				dsyr_inst.cblas_dsyr ({PC_CBLAS_ORDER}.CblasRowMajor, a_Uplo, l_N.to_integer_32, a_alpha, a_X.item.data, (a_X.item.stride).to_integer_32, a_A___0.item.data, (a_A___0.item.tda).to_integer_32)
				Result := 0
			end
		end

	gsl_blas_ssyr2 (a_Uplo: INTEGER_32; a_alpha: REAL_32; a_X: CE_POINTER [PD_GSL_VECTOR_FLOAT]; a_Y: CE_POINTER [PD_GSL_VECTOR_FLOAT]; a_A___0: CE_POINTER [PD_GSL_MATRIX_FLOAT]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := a_A___0.item.size1
					l_N := a_A___0.item.size2
					if l_M = l_N then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("matrix must be square"), ce_string ("blas.c"), 1263, 20)
							Result := 20
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 3 then -- else:
						if a_X.item.size = l_N then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 6 then -- else:
						if a_Y.item.size = l_N then
							l_pos := -1 + 8 -- skip if block
						end
				when 7 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 1267, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 8 then -- if done | if done
						if not js.return_called then
							ssyr2_inst.cblas_ssyr2 ({PC_CBLAS_ORDER}.CblasRowMajor, a_Uplo, l_N.to_integer_32, a_alpha, a_X.item.data, (a_X.item.stride).to_integer_32, a_Y.item.data, (a_Y.item.stride).to_integer_32, a_A___0.item.data, (a_A___0.item.tda).to_integer_32)
							Result := 0
						end
				when 9 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_blas_dsyr2 (a_Uplo: INTEGER_32; a_alpha: REAL_64; a_X: CE_POINTER [PD_GSL_VECTOR]; a_Y: CE_POINTER [PD_GSL_VECTOR]; a_A___0: CE_POINTER [PD_GSL_MATRIX]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := a_A___0.item.size1
					l_N := a_A___0.item.size2
					if l_M = l_N then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("matrix must be square"), ce_string ("blas.c"), 1285, 20)
							Result := 20
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 3 then -- else:
						if a_X.item.size = l_N then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 6 then -- else:
						if a_Y.item.size = l_N then
							l_pos := -1 + 8 -- skip if block
						end
				when 7 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 1289, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 8 then -- if done | if done
						if not js.return_called then
							dsyr2_inst.cblas_dsyr2 ({PC_CBLAS_ORDER}.CblasRowMajor, a_Uplo, l_N.to_integer_32, a_alpha, a_X.item.data, (a_X.item.stride).to_integer_32, a_Y.item.data, (a_Y.item.stride).to_integer_32, a_A___0.item.data, (a_A___0.item.tda).to_integer_32)
							Result := 0
						end
				when 9 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_blas_sgemm (a_TransA: INTEGER_32; a_TransB: INTEGER_32; a_alpha: REAL_32; a_A___0: CE_POINTER [PD_GSL_MATRIX_FLOAT]; a_B: CE_POINTER [PD_GSL_MATRIX_FLOAT]; a_beta: REAL_32; a_C: CE_POINTER [PD_GSL_MATRIX_FLOAT]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_MA: NATURAL_32
			l_tmp: NATURAL_32
			l_NA: NATURAL_32
			l_tmp___0: NATURAL_32
			l_MB: NATURAL_32
			l_tmp___1: NATURAL_32
			l_NB: NATURAL_32
			l_tmp___2: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := a_C.item.size1
					l_N := a_C.item.size2
					if a_TransA.to_natural_32 = {NATURAL_32} 111 then
						l_tmp := a_A___0.item.size1
					else
						l_tmp := a_A___0.item.size2
					end
					l_MA := l_tmp
					if a_TransA.to_natural_32 = {NATURAL_32} 111 then
						l_tmp___0 := a_A___0.item.size2
					else
						l_tmp___0 := a_A___0.item.size1
					end
					l_NA := l_tmp___0
					if a_TransB.to_natural_32 = {NATURAL_32} 111 then
						l_tmp___1 := a_B.item.size1
					else
						l_tmp___1 := a_B.item.size2
					end
					l_MB := l_tmp___1
					if a_TransB.to_natural_32 = {NATURAL_32} 111 then
						l_tmp___2 := a_B.item.size2
					else
						l_tmp___2 := a_B.item.size1
					end
					l_NB := l_tmp___2
					if l_M /= l_MA then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if l_N = l_NB then
							if l_NA = l_MB then
								sgemm_inst.cblas_sgemm ({PC_CBLAS_ORDER}.CblasRowMajor, a_TransA, a_TransB, l_M.to_integer_32, l_N.to_integer_32, l_NA.to_integer_32, a_alpha, a_A___0.item.data, (a_A___0.item.tda).to_integer_32, a_B.item.data, (a_B.item.tda).to_integer_32, a_beta, a_C.item.data, (a_C.item.tda).to_integer_32)
								Result := 0
								js.return
							else
								l_pos := -1 + 3 -- goto _L___0
							end
						else
							l_pos := -1 + 3 -- goto _L___0
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L___0:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 1328, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 4 then
					if not js.return_called then
						Result := 0
					end
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gsl_blas_dgemm (a_TransA: INTEGER_32; a_TransB: INTEGER_32; a_alpha: REAL_64; a_A___0: CE_POINTER [PD_GSL_MATRIX]; a_B: CE_POINTER [PD_GSL_MATRIX]; a_beta: REAL_64; a_C: CE_POINTER [PD_GSL_MATRIX]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_MA: NATURAL_32
			l_tmp: NATURAL_32
			l_NA: NATURAL_32
			l_tmp___0: NATURAL_32
			l_MB: NATURAL_32
			l_tmp___1: NATURAL_32
			l_NB: NATURAL_32
			l_tmp___2: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := a_C.item.size1
					l_N := a_C.item.size2
					if a_TransA.to_natural_32 = {NATURAL_32} 111 then
						l_tmp := a_A___0.item.size1
					else
						l_tmp := a_A___0.item.size2
					end
					l_MA := l_tmp
					if a_TransA.to_natural_32 = {NATURAL_32} 111 then
						l_tmp___0 := a_A___0.item.size2
					else
						l_tmp___0 := a_A___0.item.size1
					end
					l_NA := l_tmp___0
					if a_TransB.to_natural_32 = {NATURAL_32} 111 then
						l_tmp___1 := a_B.item.size1
					else
						l_tmp___1 := a_B.item.size2
					end
					l_MB := l_tmp___1
					if a_TransB.to_natural_32 = {NATURAL_32} 111 then
						l_tmp___2 := a_B.item.size2
					else
						l_tmp___2 := a_B.item.size1
					end
					l_NB := l_tmp___2
					if l_M /= l_MA then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if l_N = l_NB then
							if l_NA = l_MB then
								dgemm_inst.cblas_dgemm ({PC_CBLAS_ORDER}.CblasRowMajor, a_TransA, a_TransB, l_M.to_integer_32, l_N.to_integer_32, l_NA.to_integer_32, a_alpha, a_A___0.item.data, (a_A___0.item.tda).to_integer_32, a_B.item.data, (a_B.item.tda).to_integer_32, a_beta, a_C.item.data, (a_C.item.tda).to_integer_32)
								Result := 0
								js.return
							else
								l_pos := -1 + 3 -- goto _L___0
							end
						else
							l_pos := -1 + 3 -- goto _L___0
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L___0:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 1354, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 4 then
					if not js.return_called then
						Result := 0
					end
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gsl_blas_cgemm (a_TransA: INTEGER_32; a_TransB: INTEGER_32; a_alpha: PD_GSL_COMPLEX_FLOAT; a_A___0: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]; a_B: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]; a_beta: PD_GSL_COMPLEX_FLOAT; a_C: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_MA: NATURAL_32
			l_tmp: NATURAL_32
			l_NA: NATURAL_32
			l_tmp___0: NATURAL_32
			l_MB: NATURAL_32
			l_tmp___1: NATURAL_32
			l_NB: NATURAL_32
			l_tmp___2: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := a_C.item.size1
					l_N := a_C.item.size2
					if a_TransA.to_natural_32 = {NATURAL_32} 111 then
						l_tmp := a_A___0.item.size1
					else
						l_tmp := a_A___0.item.size2
					end
					l_MA := l_tmp
					if a_TransA.to_natural_32 = {NATURAL_32} 111 then
						l_tmp___0 := a_A___0.item.size2
					else
						l_tmp___0 := a_A___0.item.size1
					end
					l_NA := l_tmp___0
					if a_TransB.to_natural_32 = {NATURAL_32} 111 then
						l_tmp___1 := a_B.item.size1
					else
						l_tmp___1 := a_B.item.size2
					end
					l_MB := l_tmp___1
					if a_TransB.to_natural_32 = {NATURAL_32} 111 then
						l_tmp___2 := a_B.item.size2
					else
						l_tmp___2 := a_B.item.size1
					end
					l_NB := l_tmp___2
					if l_M /= l_MA then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if l_N = l_NB then
							if l_NA = l_MB then
								cgemm_inst.cblas_cgemm ({PC_CBLAS_ORDER}.CblasRowMajor, a_TransA, a_TransB, l_M.to_integer_32, l_N.to_integer_32, l_NA.to_integer_32, create {CE_POINTER [ANY]}.make_cast ((a_alpha.dat)), create {CE_POINTER [ANY]}.make_cast (a_A___0.item.data), (a_A___0.item.tda).to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_B.item.data), (a_B.item.tda).to_integer_32, create {CE_POINTER [ANY]}.make_cast ((a_beta.dat)), create {CE_POINTER [ANY]}.make_cast (a_C.item.data), (a_C.item.tda).to_integer_32)
								Result := 0
								js.return
							else
								l_pos := -1 + 3 -- goto _L___0
							end
						else
							l_pos := -1 + 3 -- goto _L___0
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L___0:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 1383, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 4 then
					if not js.return_called then
						Result := 0
					end
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gsl_blas_zgemm (a_TransA: INTEGER_32; a_TransB: INTEGER_32; a_alpha: PD_GSL_COMPLEX; a_A___0: CE_POINTER [PD_GSL_MATRIX_COMPLEX]; a_B: CE_POINTER [PD_GSL_MATRIX_COMPLEX]; a_beta: PD_GSL_COMPLEX; a_C: CE_POINTER [PD_GSL_MATRIX_COMPLEX]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_MA: NATURAL_32
			l_tmp: NATURAL_32
			l_NA: NATURAL_32
			l_tmp___0: NATURAL_32
			l_MB: NATURAL_32
			l_tmp___1: NATURAL_32
			l_NB: NATURAL_32
			l_tmp___2: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := a_C.item.size1
					l_N := a_C.item.size2
					if a_TransA.to_natural_32 = {NATURAL_32} 111 then
						l_tmp := a_A___0.item.size1
					else
						l_tmp := a_A___0.item.size2
					end
					l_MA := l_tmp
					if a_TransA.to_natural_32 = {NATURAL_32} 111 then
						l_tmp___0 := a_A___0.item.size2
					else
						l_tmp___0 := a_A___0.item.size1
					end
					l_NA := l_tmp___0
					if a_TransB.to_natural_32 = {NATURAL_32} 111 then
						l_tmp___1 := a_B.item.size1
					else
						l_tmp___1 := a_B.item.size2
					end
					l_MB := l_tmp___1
					if a_TransB.to_natural_32 = {NATURAL_32} 111 then
						l_tmp___2 := a_B.item.size2
					else
						l_tmp___2 := a_B.item.size1
					end
					l_NB := l_tmp___2
					if l_M /= l_MA then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if l_N = l_NB then
							if l_NA = l_MB then
								zgemm_inst.cblas_zgemm ({PC_CBLAS_ORDER}.CblasRowMajor, a_TransA, a_TransB, l_M.to_integer_32, l_N.to_integer_32, l_NA.to_integer_32, create {CE_POINTER [ANY]}.make_cast ((a_alpha.dat)), create {CE_POINTER [ANY]}.make_cast (a_A___0.item.data), (a_A___0.item.tda).to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_B.item.data), (a_B.item.tda).to_integer_32, create {CE_POINTER [ANY]}.make_cast ((a_beta.dat)), create {CE_POINTER [ANY]}.make_cast (a_C.item.data), (a_C.item.tda).to_integer_32)
								Result := 0
								js.return
							else
								l_pos := -1 + 3 -- goto _L___0
							end
						else
							l_pos := -1 + 3 -- goto _L___0
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L___0:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 1411, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 4 then
					if not js.return_called then
						Result := 0
					end
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gsl_blas_ssymm (a_Side: INTEGER_32; a_Uplo: INTEGER_32; a_alpha: REAL_32; a_A___0: CE_POINTER [PD_GSL_MATRIX_FLOAT]; a_B: CE_POINTER [PD_GSL_MATRIX_FLOAT]; a_beta: REAL_32; a_C: CE_POINTER [PD_GSL_MATRIX_FLOAT]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_MA: NATURAL_32
			l_NA: NATURAL_32
			l_MB: NATURAL_32
			l_NB: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := a_C.item.size1
					l_N := a_C.item.size2
					l_MA := a_A___0.item.size1
					l_NA := a_A___0.item.size2
					l_MB := a_B.item.size1
					l_NB := a_B.item.size2
					if l_MA /= l_NA then
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("matrix A must be square"), ce_string ("blas.c"), 1432, 20)
							Result := 20
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if js.return_called then
						l_pos := -1 + 8 -- skip if block
					end
				when 1 then -- if:
						if a_Side.to_natural_32 /= {NATURAL_32} 141 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_M = l_MA then
							if l_N = l_NB then
								if l_NA = l_MB then
									ssymm_inst.cblas_ssymm ({PC_CBLAS_ORDER}.CblasRowMajor, a_Side, a_Uplo, l_M.to_integer_32, l_N.to_integer_32, a_alpha, a_A___0.item.data, (a_A___0.item.tda).to_integer_32, a_B.item.data, (a_B.item.tda).to_integer_32, a_beta, a_C.item.data, (a_C.item.tda).to_integer_32)
									Result := 0
									js.return
								else
									l_pos := -1 + 4 -- goto _L___0
								end
							else
								l_pos := -1 + 4 -- goto _L___0
							end
						else
							l_pos := -1 + 4 -- goto _L___0
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 4 then -- else: | _L___0:
						if a_Side.to_natural_32 /= {NATURAL_32} 142 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if l_M = l_MB then
							if l_N = l_NA then
								if l_NB = l_MA then
									ssymm_inst.cblas_ssymm ({PC_CBLAS_ORDER}.CblasRowMajor, a_Side, a_Uplo, l_M.to_integer_32, l_N.to_integer_32, a_alpha, a_A___0.item.data, (a_A___0.item.tda).to_integer_32, a_B.item.data, (a_B.item.tda).to_integer_32, a_beta, a_C.item.data, (a_C.item.tda).to_integer_32)
									Result := 0
									js.return
								else
									l_pos := -1 + 7 -- goto _L
								end
							else
								l_pos := -1 + 7 -- goto _L
							end
						else
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 1445, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 8 then -- if done | if done
						if not js.return_called then
							Result := 0
						end
				when 9 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_blas_dsymm (a_Side: INTEGER_32; a_Uplo: INTEGER_32; a_alpha: REAL_64; a_A___0: CE_POINTER [PD_GSL_MATRIX]; a_B: CE_POINTER [PD_GSL_MATRIX]; a_beta: REAL_64; a_C: CE_POINTER [PD_GSL_MATRIX]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_MA: NATURAL_32
			l_NA: NATURAL_32
			l_MB: NATURAL_32
			l_NB: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := a_C.item.size1
					l_N := a_C.item.size2
					l_MA := a_A___0.item.size1
					l_NA := a_A___0.item.size2
					l_MB := a_B.item.size1
					l_NB := a_B.item.size2
					if l_MA /= l_NA then
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("matrix A must be square"), ce_string ("blas.c"), 1465, 20)
							Result := 20
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if js.return_called then
						l_pos := -1 + 8 -- skip if block
					end
				when 1 then -- if:
						if a_Side.to_natural_32 /= {NATURAL_32} 141 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_M = l_MA then
							if l_N = l_NB then
								if l_NA = l_MB then
									dsymm_inst.cblas_dsymm ({PC_CBLAS_ORDER}.CblasRowMajor, a_Side, a_Uplo, l_M.to_integer_32, l_N.to_integer_32, a_alpha, a_A___0.item.data, (a_A___0.item.tda).to_integer_32, a_B.item.data, (a_B.item.tda).to_integer_32, a_beta, a_C.item.data, (a_C.item.tda).to_integer_32)
									Result := 0
									js.return
								else
									l_pos := -1 + 4 -- goto _L___0
								end
							else
								l_pos := -1 + 4 -- goto _L___0
							end
						else
							l_pos := -1 + 4 -- goto _L___0
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 4 then -- else: | _L___0:
						if a_Side.to_natural_32 /= {NATURAL_32} 142 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if l_M = l_MB then
							if l_N = l_NA then
								if l_NB = l_MA then
									dsymm_inst.cblas_dsymm ({PC_CBLAS_ORDER}.CblasRowMajor, a_Side, a_Uplo, l_M.to_integer_32, l_N.to_integer_32, a_alpha, a_A___0.item.data, (a_A___0.item.tda).to_integer_32, a_B.item.data, (a_B.item.tda).to_integer_32, a_beta, a_C.item.data, (a_C.item.tda).to_integer_32)
									Result := 0
									js.return
								else
									l_pos := -1 + 7 -- goto _L
								end
							else
								l_pos := -1 + 7 -- goto _L
							end
						else
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 1478, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 8 then -- if done | if done
						if not js.return_called then
							Result := 0
						end
				when 9 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_blas_csymm (a_Side: INTEGER_32; a_Uplo: INTEGER_32; a_alpha: PD_GSL_COMPLEX_FLOAT; a_A___0: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]; a_B: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]; a_beta: PD_GSL_COMPLEX_FLOAT; a_C: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_MA: NATURAL_32
			l_NA: NATURAL_32
			l_MB: NATURAL_32
			l_NB: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := a_C.item.size1
					l_N := a_C.item.size2
					l_MA := a_A___0.item.size1
					l_NA := a_A___0.item.size2
					l_MB := a_B.item.size1
					l_NB := a_B.item.size2
					if l_MA /= l_NA then
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("matrix A must be square"), ce_string ("blas.c"), 1499, 20)
							Result := 20
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if js.return_called then
						l_pos := -1 + 8 -- skip if block
					end
				when 1 then -- if:
						if a_Side.to_natural_32 /= {NATURAL_32} 141 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_M = l_MA then
							if l_N = l_NB then
								if l_NA = l_MB then
									csymm_inst.cblas_csymm ({PC_CBLAS_ORDER}.CblasRowMajor, a_Side, a_Uplo, l_M.to_integer_32, l_N.to_integer_32, create {CE_POINTER [ANY]}.make_cast ((a_alpha.dat)), create {CE_POINTER [ANY]}.make_cast (a_A___0.item.data), (a_A___0.item.tda).to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_B.item.data), (a_B.item.tda).to_integer_32, create {CE_POINTER [ANY]}.make_cast ((a_beta.dat)), create {CE_POINTER [ANY]}.make_cast (a_C.item.data), (a_C.item.tda).to_integer_32)
									Result := 0
									js.return
								else
									l_pos := -1 + 4 -- goto _L___0
								end
							else
								l_pos := -1 + 4 -- goto _L___0
							end
						else
							l_pos := -1 + 4 -- goto _L___0
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 4 then -- else: | _L___0:
						if a_Side.to_natural_32 /= {NATURAL_32} 142 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if l_M = l_MB then
							if l_N = l_NA then
								if l_NB = l_MA then
									csymm_inst.cblas_csymm ({PC_CBLAS_ORDER}.CblasRowMajor, a_Side, a_Uplo, l_M.to_integer_32, l_N.to_integer_32, create {CE_POINTER [ANY]}.make_cast ((a_alpha.dat)), create {CE_POINTER [ANY]}.make_cast (a_A___0.item.data), (a_A___0.item.tda).to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_B.item.data), (a_B.item.tda).to_integer_32, create {CE_POINTER [ANY]}.make_cast ((a_beta.dat)), create {CE_POINTER [ANY]}.make_cast (a_C.item.data), (a_C.item.tda).to_integer_32)
									Result := 0
									js.return
								else
									l_pos := -1 + 7 -- goto _L
								end
							else
								l_pos := -1 + 7 -- goto _L
							end
						else
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 1513, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 8 then -- if done | if done
						if not js.return_called then
							Result := 0
						end
				when 9 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_blas_zsymm (a_Side: INTEGER_32; a_Uplo: INTEGER_32; a_alpha: PD_GSL_COMPLEX; a_A___0: CE_POINTER [PD_GSL_MATRIX_COMPLEX]; a_B: CE_POINTER [PD_GSL_MATRIX_COMPLEX]; a_beta: PD_GSL_COMPLEX; a_C: CE_POINTER [PD_GSL_MATRIX_COMPLEX]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_MA: NATURAL_32
			l_NA: NATURAL_32
			l_MB: NATURAL_32
			l_NB: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := a_C.item.size1
					l_N := a_C.item.size2
					l_MA := a_A___0.item.size1
					l_NA := a_A___0.item.size2
					l_MB := a_B.item.size1
					l_NB := a_B.item.size2
					if l_MA /= l_NA then
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("matrix A must be square"), ce_string ("blas.c"), 1532, 20)
							Result := 20
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if js.return_called then
						l_pos := -1 + 8 -- skip if block
					end
				when 1 then -- if:
						if a_Side.to_natural_32 /= {NATURAL_32} 141 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_M = l_MA then
							if l_N = l_NB then
								if l_NA = l_MB then
									zsymm_inst.cblas_zsymm ({PC_CBLAS_ORDER}.CblasRowMajor, a_Side, a_Uplo, l_M.to_integer_32, l_N.to_integer_32, create {CE_POINTER [ANY]}.make_cast ((a_alpha.dat)), create {CE_POINTER [ANY]}.make_cast (a_A___0.item.data), (a_A___0.item.tda).to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_B.item.data), (a_B.item.tda).to_integer_32, create {CE_POINTER [ANY]}.make_cast ((a_beta.dat)), create {CE_POINTER [ANY]}.make_cast (a_C.item.data), (a_C.item.tda).to_integer_32)
									Result := 0
									js.return
								else
									l_pos := -1 + 4 -- goto _L___0
								end
							else
								l_pos := -1 + 4 -- goto _L___0
							end
						else
							l_pos := -1 + 4 -- goto _L___0
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 4 then -- else: | _L___0:
						if a_Side.to_natural_32 /= {NATURAL_32} 142 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if l_M = l_MB then
							if l_N = l_NA then
								if l_NB = l_MA then
									zsymm_inst.cblas_zsymm ({PC_CBLAS_ORDER}.CblasRowMajor, a_Side, a_Uplo, l_M.to_integer_32, l_N.to_integer_32, create {CE_POINTER [ANY]}.make_cast ((a_alpha.dat)), create {CE_POINTER [ANY]}.make_cast (a_A___0.item.data), (a_A___0.item.tda).to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_B.item.data), (a_B.item.tda).to_integer_32, create {CE_POINTER [ANY]}.make_cast ((a_beta.dat)), create {CE_POINTER [ANY]}.make_cast (a_C.item.data), (a_C.item.tda).to_integer_32)
									Result := 0
									js.return
								else
									l_pos := -1 + 7 -- goto _L
								end
							else
								l_pos := -1 + 7 -- goto _L
							end
						else
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 1546, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 8 then -- if done | if done
						if not js.return_called then
							Result := 0
						end
				when 9 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_blas_chemm (a_Side: INTEGER_32; a_Uplo: INTEGER_32; a_alpha: PD_GSL_COMPLEX_FLOAT; a_A___0: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]; a_B: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]; a_beta: PD_GSL_COMPLEX_FLOAT; a_C: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_MA: NATURAL_32
			l_NA: NATURAL_32
			l_MB: NATURAL_32
			l_NB: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := a_C.item.size1
					l_N := a_C.item.size2
					l_MA := a_A___0.item.size1
					l_NA := a_A___0.item.size2
					l_MB := a_B.item.size1
					l_NB := a_B.item.size2
					if l_MA /= l_NA then
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("matrix A must be square"), ce_string ("blas.c"), 1569, 20)
							Result := 20
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if js.return_called then
						l_pos := -1 + 8 -- skip if block
					end
				when 1 then -- if:
						if a_Side.to_natural_32 /= {NATURAL_32} 141 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_M = l_MA then
							if l_N = l_NB then
								if l_NA = l_MB then
									chemm_inst.cblas_chemm ({PC_CBLAS_ORDER}.CblasRowMajor, a_Side, a_Uplo, l_M.to_integer_32, l_N.to_integer_32, create {CE_POINTER [ANY]}.make_cast ((a_alpha.dat)), create {CE_POINTER [ANY]}.make_cast (a_A___0.item.data), (a_A___0.item.tda).to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_B.item.data), (a_B.item.tda).to_integer_32, create {CE_POINTER [ANY]}.make_cast ((a_beta.dat)), create {CE_POINTER [ANY]}.make_cast (a_C.item.data), (a_C.item.tda).to_integer_32)
									Result := 0
									js.return
								else
									l_pos := -1 + 4 -- goto _L___0
								end
							else
								l_pos := -1 + 4 -- goto _L___0
							end
						else
							l_pos := -1 + 4 -- goto _L___0
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 4 then -- else: | _L___0:
						if a_Side.to_natural_32 /= {NATURAL_32} 142 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if l_M = l_MB then
							if l_N = l_NA then
								if l_NB = l_MA then
									chemm_inst.cblas_chemm ({PC_CBLAS_ORDER}.CblasRowMajor, a_Side, a_Uplo, l_M.to_integer_32, l_N.to_integer_32, create {CE_POINTER [ANY]}.make_cast ((a_alpha.dat)), create {CE_POINTER [ANY]}.make_cast (a_A___0.item.data), (a_A___0.item.tda).to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_B.item.data), (a_B.item.tda).to_integer_32, create {CE_POINTER [ANY]}.make_cast ((a_beta.dat)), create {CE_POINTER [ANY]}.make_cast (a_C.item.data), (a_C.item.tda).to_integer_32)
									Result := 0
									js.return
								else
									l_pos := -1 + 7 -- goto _L
								end
							else
								l_pos := -1 + 7 -- goto _L
							end
						else
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 1583, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 8 then -- if done | if done
						if not js.return_called then
							Result := 0
						end
				when 9 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_blas_zhemm (a_Side: INTEGER_32; a_Uplo: INTEGER_32; a_alpha: PD_GSL_COMPLEX; a_A___0: CE_POINTER [PD_GSL_MATRIX_COMPLEX]; a_B: CE_POINTER [PD_GSL_MATRIX_COMPLEX]; a_beta: PD_GSL_COMPLEX; a_C: CE_POINTER [PD_GSL_MATRIX_COMPLEX]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_MA: NATURAL_32
			l_NA: NATURAL_32
			l_MB: NATURAL_32
			l_NB: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := a_C.item.size1
					l_N := a_C.item.size2
					l_MA := a_A___0.item.size1
					l_NA := a_A___0.item.size2
					l_MB := a_B.item.size1
					l_NB := a_B.item.size2
					if l_MA /= l_NA then
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("matrix A must be square"), ce_string ("blas.c"), 1604, 20)
							Result := 20
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if js.return_called then
						l_pos := -1 + 8 -- skip if block
					end
				when 1 then -- if:
						if a_Side.to_natural_32 /= {NATURAL_32} 141 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_M = l_MA then
							if l_N = l_NB then
								if l_NA = l_MB then
									zhemm_inst.cblas_zhemm ({PC_CBLAS_ORDER}.CblasRowMajor, a_Side, a_Uplo, l_M.to_integer_32, l_N.to_integer_32, create {CE_POINTER [ANY]}.make_cast ((a_alpha.dat)), create {CE_POINTER [ANY]}.make_cast (a_A___0.item.data), (a_A___0.item.tda).to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_B.item.data), (a_B.item.tda).to_integer_32, create {CE_POINTER [ANY]}.make_cast ((a_beta.dat)), create {CE_POINTER [ANY]}.make_cast (a_C.item.data), (a_C.item.tda).to_integer_32)
									Result := 0
									js.return
								else
									l_pos := -1 + 4 -- goto _L___0
								end
							else
								l_pos := -1 + 4 -- goto _L___0
							end
						else
							l_pos := -1 + 4 -- goto _L___0
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 4 then -- else: | _L___0:
						if a_Side.to_natural_32 /= {NATURAL_32} 142 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if l_M = l_MB then
							if l_N = l_NA then
								if l_NB = l_MA then
									zhemm_inst.cblas_zhemm ({PC_CBLAS_ORDER}.CblasRowMajor, a_Side, a_Uplo, l_M.to_integer_32, l_N.to_integer_32, create {CE_POINTER [ANY]}.make_cast ((a_alpha.dat)), create {CE_POINTER [ANY]}.make_cast (a_A___0.item.data), (a_A___0.item.tda).to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_B.item.data), (a_B.item.tda).to_integer_32, create {CE_POINTER [ANY]}.make_cast ((a_beta.dat)), create {CE_POINTER [ANY]}.make_cast (a_C.item.data), (a_C.item.tda).to_integer_32)
									Result := 0
									js.return
								else
									l_pos := -1 + 7 -- goto _L
								end
							else
								l_pos := -1 + 7 -- goto _L
							end
						else
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 1618, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 8 then -- if done | if done
						if not js.return_called then
							Result := 0
						end
				when 9 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_blas_ssyrk (a_Uplo: INTEGER_32; a_Trans: INTEGER_32; a_alpha: REAL_32; a_A___0: CE_POINTER [PD_GSL_MATRIX_FLOAT]; a_beta: REAL_32; a_C: CE_POINTER [PD_GSL_MATRIX_FLOAT]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_J: NATURAL_32
			l_tmp: NATURAL_32
			l_K: NATURAL_32
			l_tmp___0: NATURAL_32
			js: JUMP_STATE
		do
			l_M := a_C.item.size1
			l_N := a_C.item.size2
			if a_Trans.to_natural_32 = {NATURAL_32} 111 then
				l_tmp := a_A___0.item.size1
			else
				l_tmp := a_A___0.item.size2
			end
			l_J := l_tmp
			if a_Trans.to_natural_32 = {NATURAL_32} 111 then
				l_tmp___0 := a_A___0.item.size2
			else
				l_tmp___0 := a_A___0.item.size1
			end
			l_K := l_tmp___0
			if l_M /= l_N then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix C must be square"), ce_string ("blas.c"), 1635, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif l_N /= l_J then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 1639, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				ssyrk_inst.cblas_ssyrk ({PC_CBLAS_ORDER}.CblasRowMajor, a_Uplo, a_Trans, l_N.to_integer_32, l_K.to_integer_32, a_alpha, a_A___0.item.data, (a_A___0.item.tda).to_integer_32, a_beta, a_C.item.data, (a_C.item.tda).to_integer_32)
				Result := 0
			end
		end

	gsl_blas_dsyrk (a_Uplo: INTEGER_32; a_Trans: INTEGER_32; a_alpha: REAL_64; a_A___0: CE_POINTER [PD_GSL_MATRIX]; a_beta: REAL_64; a_C: CE_POINTER [PD_GSL_MATRIX]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_J: NATURAL_32
			l_tmp: NATURAL_32
			l_K: NATURAL_32
			l_tmp___0: NATURAL_32
			js: JUMP_STATE
		do
			l_M := a_C.item.size1
			l_N := a_C.item.size2
			if a_Trans.to_natural_32 = {NATURAL_32} 111 then
				l_tmp := a_A___0.item.size1
			else
				l_tmp := a_A___0.item.size2
			end
			l_J := l_tmp
			if a_Trans.to_natural_32 = {NATURAL_32} 111 then
				l_tmp___0 := a_A___0.item.size2
			else
				l_tmp___0 := a_A___0.item.size1
			end
			l_K := l_tmp___0
			if l_M /= l_N then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix C must be square"), ce_string ("blas.c"), 1659, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif l_N /= l_J then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 1663, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				dsyrk_inst.cblas_dsyrk ({PC_CBLAS_ORDER}.CblasRowMajor, a_Uplo, a_Trans, l_N.to_integer_32, l_K.to_integer_32, a_alpha, a_A___0.item.data, (a_A___0.item.tda).to_integer_32, a_beta, a_C.item.data, (a_C.item.tda).to_integer_32)
				Result := 0
			end
		end

	gsl_blas_csyrk (a_Uplo: INTEGER_32; a_Trans: INTEGER_32; a_alpha: PD_GSL_COMPLEX_FLOAT; a_A___0: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]; a_beta: PD_GSL_COMPLEX_FLOAT; a_C: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_J: NATURAL_32
			l_tmp: NATURAL_32
			l_K: NATURAL_32
			l_tmp___0: NATURAL_32
			js: JUMP_STATE
		do
			l_M := a_C.item.size1
			l_N := a_C.item.size2
			if a_Trans.to_natural_32 = {NATURAL_32} 111 then
				l_tmp := a_A___0.item.size1
			else
				l_tmp := a_A___0.item.size2
			end
			l_J := l_tmp
			if a_Trans.to_natural_32 = {NATURAL_32} 111 then
				l_tmp___0 := a_A___0.item.size2
			else
				l_tmp___0 := a_A___0.item.size1
			end
			l_K := l_tmp___0
			if l_M /= l_N then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix C must be square"), ce_string ("blas.c"), 1686, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif l_N /= l_J then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 1690, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				csyrk_inst.cblas_csyrk ({PC_CBLAS_ORDER}.CblasRowMajor, a_Uplo, a_Trans, l_N.to_integer_32, l_K.to_integer_32, create {CE_POINTER [ANY]}.make_cast ((a_alpha.dat)), create {CE_POINTER [ANY]}.make_cast (a_A___0.item.data), (a_A___0.item.tda).to_integer_32, create {CE_POINTER [ANY]}.make_cast ((a_beta.dat)), create {CE_POINTER [ANY]}.make_cast (a_C.item.data), (a_C.item.tda).to_integer_32)
				Result := 0
			end
		end

	gsl_blas_zsyrk (a_Uplo: INTEGER_32; a_Trans: INTEGER_32; a_alpha: PD_GSL_COMPLEX; a_A___0: CE_POINTER [PD_GSL_MATRIX_COMPLEX]; a_beta: PD_GSL_COMPLEX; a_C: CE_POINTER [PD_GSL_MATRIX_COMPLEX]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_J: NATURAL_32
			l_tmp: NATURAL_32
			l_K: NATURAL_32
			l_tmp___0: NATURAL_32
			js: JUMP_STATE
		do
			l_M := a_C.item.size1
			l_N := a_C.item.size2
			if a_Trans.to_natural_32 = {NATURAL_32} 111 then
				l_tmp := a_A___0.item.size1
			else
				l_tmp := a_A___0.item.size2
			end
			l_J := l_tmp
			if a_Trans.to_natural_32 = {NATURAL_32} 111 then
				l_tmp___0 := a_A___0.item.size2
			else
				l_tmp___0 := a_A___0.item.size1
			end
			l_K := l_tmp___0
			if l_M /= l_N then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix C must be square"), ce_string ("blas.c"), 1712, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif l_N /= l_J then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 1716, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				zsyrk_inst.cblas_zsyrk ({PC_CBLAS_ORDER}.CblasRowMajor, a_Uplo, a_Trans, l_N.to_integer_32, l_K.to_integer_32, create {CE_POINTER [ANY]}.make_cast ((a_alpha.dat)), create {CE_POINTER [ANY]}.make_cast (a_A___0.item.data), (a_A___0.item.tda).to_integer_32, create {CE_POINTER [ANY]}.make_cast ((a_beta.dat)), create {CE_POINTER [ANY]}.make_cast (a_C.item.data), (a_C.item.tda).to_integer_32)
				Result := 0
			end
		end

	gsl_blas_cherk (a_Uplo: INTEGER_32; a_Trans: INTEGER_32; a_alpha: REAL_32; a_A___0: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]; a_beta: REAL_32; a_C: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_J: NATURAL_32
			l_tmp: NATURAL_32
			l_K: NATURAL_32
			l_tmp___0: NATURAL_32
			js: JUMP_STATE
		do
			l_M := a_C.item.size1
			l_N := a_C.item.size2
			if a_Trans.to_natural_32 = {NATURAL_32} 111 then
				l_tmp := a_A___0.item.size1
			else
				l_tmp := a_A___0.item.size2
			end
			l_J := l_tmp
			if a_Trans.to_natural_32 = {NATURAL_32} 111 then
				l_tmp___0 := a_A___0.item.size2
			else
				l_tmp___0 := a_A___0.item.size1
			end
			l_K := l_tmp___0
			if l_M /= l_N then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix C must be square"), ce_string ("blas.c"), 1739, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif l_N /= l_J then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 1743, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				cherk_inst.cblas_cherk ({PC_CBLAS_ORDER}.CblasRowMajor, a_Uplo, a_Trans, l_N.to_integer_32, l_K.to_integer_32, a_alpha, create {CE_POINTER [ANY]}.make_cast (a_A___0.item.data), (a_A___0.item.tda).to_integer_32, a_beta, create {CE_POINTER [ANY]}.make_cast (a_C.item.data), (a_C.item.tda).to_integer_32)
				Result := 0
			end
		end

	gsl_blas_zherk (a_Uplo: INTEGER_32; a_Trans: INTEGER_32; a_alpha: REAL_64; a_A___0: CE_POINTER [PD_GSL_MATRIX_COMPLEX]; a_beta: REAL_64; a_C: CE_POINTER [PD_GSL_MATRIX_COMPLEX]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_J: NATURAL_32
			l_tmp: NATURAL_32
			l_K: NATURAL_32
			l_tmp___0: NATURAL_32
			js: JUMP_STATE
		do
			l_M := a_C.item.size1
			l_N := a_C.item.size2
			if a_Trans.to_natural_32 = {NATURAL_32} 111 then
				l_tmp := a_A___0.item.size1
			else
				l_tmp := a_A___0.item.size2
			end
			l_J := l_tmp
			if a_Trans.to_natural_32 = {NATURAL_32} 111 then
				l_tmp___0 := a_A___0.item.size2
			else
				l_tmp___0 := a_A___0.item.size1
			end
			l_K := l_tmp___0
			if l_M /= l_N then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix C must be square"), ce_string ("blas.c"), 1764, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif l_N /= l_J then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 1768, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				zherk_inst.cblas_zherk ({PC_CBLAS_ORDER}.CblasRowMajor, a_Uplo, a_Trans, l_N.to_integer_32, l_K.to_integer_32, a_alpha, create {CE_POINTER [ANY]}.make_cast (a_A___0.item.data), (a_A___0.item.tda).to_integer_32, a_beta, create {CE_POINTER [ANY]}.make_cast (a_C.item.data), (a_C.item.tda).to_integer_32)
				Result := 0
			end
		end

	gsl_blas_ssyr2k (a_Uplo: INTEGER_32; a_Trans: INTEGER_32; a_alpha: REAL_32; a_A___0: CE_POINTER [PD_GSL_MATRIX_FLOAT]; a_B: CE_POINTER [PD_GSL_MATRIX_FLOAT]; a_beta: REAL_32; a_C: CE_POINTER [PD_GSL_MATRIX_FLOAT]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_MA: NATURAL_32
			l_tmp: NATURAL_32
			l_NA: NATURAL_32
			l_tmp___0: NATURAL_32
			l_MB: NATURAL_32
			l_tmp___1: NATURAL_32
			l_NB: NATURAL_32
			l_tmp___2: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := a_C.item.size1
					l_N := a_C.item.size2
					if a_Trans.to_natural_32 = {NATURAL_32} 111 then
						l_tmp := a_A___0.item.size1
					else
						l_tmp := a_A___0.item.size2
					end
					l_MA := l_tmp
					if a_Trans.to_natural_32 = {NATURAL_32} 111 then
						l_tmp___0 := a_A___0.item.size2
					else
						l_tmp___0 := a_A___0.item.size1
					end
					l_NA := l_tmp___0
					if a_Trans.to_natural_32 = {NATURAL_32} 111 then
						l_tmp___1 := a_B.item.size1
					else
						l_tmp___1 := a_B.item.size2
					end
					l_MB := l_tmp___1
					if a_Trans.to_natural_32 = {NATURAL_32} 111 then
						l_tmp___2 := a_B.item.size2
					else
						l_tmp___2 := a_B.item.size1
					end
					l_NB := l_tmp___2
					if l_M = l_N then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("matrix C must be square"), ce_string ("blas.c"), 1792, 20)
							Result := 20
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 3 then -- else:
						if l_N = l_MA then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 6 then -- else:
						if l_N = l_MB then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 9 then -- else:
						if l_NA = l_NB then
							l_pos := -1 + 11 -- skip if block
						end
				when 10 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 1796, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 11 then -- if done | if done | if done
						if not js.return_called then
							ssyr2k_inst.cblas_ssyr2k ({PC_CBLAS_ORDER}.CblasRowMajor, a_Uplo, a_Trans, l_N.to_integer_32, l_NA.to_integer_32, a_alpha, a_A___0.item.data, (a_A___0.item.tda).to_integer_32, a_B.item.data, (a_B.item.tda).to_integer_32, a_beta, a_C.item.data, (a_C.item.tda).to_integer_32)
							Result := 0
						end
				when 12 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_blas_dsyr2k (a_Uplo: INTEGER_32; a_Trans: INTEGER_32; a_alpha: REAL_64; a_A___0: CE_POINTER [PD_GSL_MATRIX]; a_B: CE_POINTER [PD_GSL_MATRIX]; a_beta: REAL_64; a_C: CE_POINTER [PD_GSL_MATRIX]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_MA: NATURAL_32
			l_tmp: NATURAL_32
			l_NA: NATURAL_32
			l_tmp___0: NATURAL_32
			l_MB: NATURAL_32
			l_tmp___1: NATURAL_32
			l_NB: NATURAL_32
			l_tmp___2: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := a_C.item.size1
					l_N := a_C.item.size2
					if a_Trans.to_natural_32 = {NATURAL_32} 111 then
						l_tmp := a_A___0.item.size1
					else
						l_tmp := a_A___0.item.size2
					end
					l_MA := l_tmp
					if a_Trans.to_natural_32 = {NATURAL_32} 111 then
						l_tmp___0 := a_A___0.item.size2
					else
						l_tmp___0 := a_A___0.item.size1
					end
					l_NA := l_tmp___0
					if a_Trans.to_natural_32 = {NATURAL_32} 111 then
						l_tmp___1 := a_B.item.size1
					else
						l_tmp___1 := a_B.item.size2
					end
					l_MB := l_tmp___1
					if a_Trans.to_natural_32 = {NATURAL_32} 111 then
						l_tmp___2 := a_B.item.size2
					else
						l_tmp___2 := a_B.item.size1
					end
					l_NB := l_tmp___2
					if l_M = l_N then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("matrix C must be square"), ce_string ("blas.c"), 1820, 20)
							Result := 20
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 3 then -- else:
						if l_N = l_MA then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 6 then -- else:
						if l_N = l_MB then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 9 then -- else:
						if l_NA = l_NB then
							l_pos := -1 + 11 -- skip if block
						end
				when 10 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 1824, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 11 then -- if done | if done | if done
						if not js.return_called then
							dsyr2k_inst.cblas_dsyr2k ({PC_CBLAS_ORDER}.CblasRowMajor, a_Uplo, a_Trans, l_N.to_integer_32, l_NA.to_integer_32, a_alpha, a_A___0.item.data, (a_A___0.item.tda).to_integer_32, a_B.item.data, (a_B.item.tda).to_integer_32, a_beta, a_C.item.data, (a_C.item.tda).to_integer_32)
							Result := 0
						end
				when 12 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_blas_csyr2k (a_Uplo: INTEGER_32; a_Trans: INTEGER_32; a_alpha: PD_GSL_COMPLEX_FLOAT; a_A___0: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]; a_B: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]; a_beta: PD_GSL_COMPLEX_FLOAT; a_C: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_MA: NATURAL_32
			l_tmp: NATURAL_32
			l_NA: NATURAL_32
			l_tmp___0: NATURAL_32
			l_MB: NATURAL_32
			l_tmp___1: NATURAL_32
			l_NB: NATURAL_32
			l_tmp___2: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := a_C.item.size1
					l_N := a_C.item.size2
					if a_Trans.to_natural_32 = {NATURAL_32} 111 then
						l_tmp := a_A___0.item.size1
					else
						l_tmp := a_A___0.item.size2
					end
					l_MA := l_tmp
					if a_Trans.to_natural_32 = {NATURAL_32} 111 then
						l_tmp___0 := a_A___0.item.size2
					else
						l_tmp___0 := a_A___0.item.size1
					end
					l_NA := l_tmp___0
					if a_Trans.to_natural_32 = {NATURAL_32} 111 then
						l_tmp___1 := a_B.item.size1
					else
						l_tmp___1 := a_B.item.size2
					end
					l_MB := l_tmp___1
					if a_Trans.to_natural_32 = {NATURAL_32} 111 then
						l_tmp___2 := a_B.item.size2
					else
						l_tmp___2 := a_B.item.size1
					end
					l_NB := l_tmp___2
					if l_M = l_N then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("matrix C must be square"), ce_string ("blas.c"), 1850, 20)
							Result := 20
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 3 then -- else:
						if l_N = l_MA then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 6 then -- else:
						if l_N = l_MB then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 9 then -- else:
						if l_NA = l_NB then
							l_pos := -1 + 11 -- skip if block
						end
				when 10 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 1854, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 11 then -- if done | if done | if done
						if not js.return_called then
							csyr2k_inst.cblas_csyr2k ({PC_CBLAS_ORDER}.CblasRowMajor, a_Uplo, a_Trans, l_N.to_integer_32, l_NA.to_integer_32, create {CE_POINTER [ANY]}.make_cast ((a_alpha.dat)), create {CE_POINTER [ANY]}.make_cast (a_A___0.item.data), (a_A___0.item.tda).to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_B.item.data), (a_B.item.tda).to_integer_32, create {CE_POINTER [ANY]}.make_cast ((a_beta.dat)), create {CE_POINTER [ANY]}.make_cast (a_C.item.data), (a_C.item.tda).to_integer_32)
							Result := 0
						end
				when 12 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_blas_zsyr2k (a_Uplo: INTEGER_32; a_Trans: INTEGER_32; a_alpha: PD_GSL_COMPLEX; a_A___0: CE_POINTER [PD_GSL_MATRIX_COMPLEX]; a_B: CE_POINTER [PD_GSL_MATRIX_COMPLEX]; a_beta: PD_GSL_COMPLEX; a_C: CE_POINTER [PD_GSL_MATRIX_COMPLEX]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_MA: NATURAL_32
			l_tmp: NATURAL_32
			l_NA: NATURAL_32
			l_tmp___0: NATURAL_32
			l_MB: NATURAL_32
			l_tmp___1: NATURAL_32
			l_NB: NATURAL_32
			l_tmp___2: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := a_C.item.size1
					l_N := a_C.item.size2
					if a_Trans.to_natural_32 = {NATURAL_32} 111 then
						l_tmp := a_A___0.item.size1
					else
						l_tmp := a_A___0.item.size2
					end
					l_MA := l_tmp
					if a_Trans.to_natural_32 = {NATURAL_32} 111 then
						l_tmp___0 := a_A___0.item.size2
					else
						l_tmp___0 := a_A___0.item.size1
					end
					l_NA := l_tmp___0
					if a_Trans.to_natural_32 = {NATURAL_32} 111 then
						l_tmp___1 := a_B.item.size1
					else
						l_tmp___1 := a_B.item.size2
					end
					l_MB := l_tmp___1
					if a_Trans.to_natural_32 = {NATURAL_32} 111 then
						l_tmp___2 := a_B.item.size2
					else
						l_tmp___2 := a_B.item.size1
					end
					l_NB := l_tmp___2
					if l_M = l_N then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("matrix C must be square"), ce_string ("blas.c"), 1880, 20)
							Result := 20
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 3 then -- else:
						if l_N = l_MA then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 6 then -- else:
						if l_N = l_MB then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 9 then -- else:
						if l_NA = l_NB then
							l_pos := -1 + 11 -- skip if block
						end
				when 10 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 1884, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 11 then -- if done | if done | if done
						if not js.return_called then
							zsyr2k_inst.cblas_zsyr2k ({PC_CBLAS_ORDER}.CblasRowMajor, a_Uplo, a_Trans, l_N.to_integer_32, l_NA.to_integer_32, create {CE_POINTER [ANY]}.make_cast ((a_alpha.dat)), create {CE_POINTER [ANY]}.make_cast (a_A___0.item.data), (a_A___0.item.tda).to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_B.item.data), (a_B.item.tda).to_integer_32, create {CE_POINTER [ANY]}.make_cast ((a_beta.dat)), create {CE_POINTER [ANY]}.make_cast (a_C.item.data), (a_C.item.tda).to_integer_32)
							Result := 0
						end
				when 12 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_blas_cher2k (a_Uplo: INTEGER_32; a_Trans: INTEGER_32; a_alpha: PD_GSL_COMPLEX_FLOAT; a_A___0: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]; a_B: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]; a_beta: REAL_32; a_C: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_MA: NATURAL_32
			l_tmp: NATURAL_32
			l_NA: NATURAL_32
			l_tmp___0: NATURAL_32
			l_MB: NATURAL_32
			l_tmp___1: NATURAL_32
			l_NB: NATURAL_32
			l_tmp___2: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := a_C.item.size1
					l_N := a_C.item.size2
					if a_Trans.to_natural_32 = {NATURAL_32} 111 then
						l_tmp := a_A___0.item.size1
					else
						l_tmp := a_A___0.item.size2
					end
					l_MA := l_tmp
					if a_Trans.to_natural_32 = {NATURAL_32} 111 then
						l_tmp___0 := a_A___0.item.size2
					else
						l_tmp___0 := a_A___0.item.size1
					end
					l_NA := l_tmp___0
					if a_Trans.to_natural_32 = {NATURAL_32} 111 then
						l_tmp___1 := a_B.item.size1
					else
						l_tmp___1 := a_B.item.size2
					end
					l_MB := l_tmp___1
					if a_Trans.to_natural_32 = {NATURAL_32} 111 then
						l_tmp___2 := a_B.item.size2
					else
						l_tmp___2 := a_B.item.size1
					end
					l_NB := l_tmp___2
					if l_M = l_N then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("matrix C must be square"), ce_string ("blas.c"), 1911, 20)
							Result := 20
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 3 then -- else:
						if l_N = l_MA then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 6 then -- else:
						if l_N = l_MB then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 9 then -- else:
						if l_NA = l_NB then
							l_pos := -1 + 11 -- skip if block
						end
				when 10 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 1915, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 11 then -- if done | if done | if done
						if not js.return_called then
							cher2k_inst.cblas_cher2k ({PC_CBLAS_ORDER}.CblasRowMajor, a_Uplo, a_Trans, l_N.to_integer_32, l_NA.to_integer_32, create {CE_POINTER [ANY]}.make_cast ((a_alpha.dat)), create {CE_POINTER [ANY]}.make_cast (a_A___0.item.data), (a_A___0.item.tda).to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_B.item.data), (a_B.item.tda).to_integer_32, a_beta, create {CE_POINTER [ANY]}.make_cast (a_C.item.data), (a_C.item.tda).to_integer_32)
							Result := 0
						end
				when 12 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_blas_zher2k (a_Uplo: INTEGER_32; a_Trans: INTEGER_32; a_alpha: PD_GSL_COMPLEX; a_A___0: CE_POINTER [PD_GSL_MATRIX_COMPLEX]; a_B: CE_POINTER [PD_GSL_MATRIX_COMPLEX]; a_beta: REAL_64; a_C: CE_POINTER [PD_GSL_MATRIX_COMPLEX]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_MA: NATURAL_32
			l_tmp: NATURAL_32
			l_NA: NATURAL_32
			l_tmp___0: NATURAL_32
			l_MB: NATURAL_32
			l_tmp___1: NATURAL_32
			l_NB: NATURAL_32
			l_tmp___2: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := a_C.item.size1
					l_N := a_C.item.size2
					if a_Trans.to_natural_32 = {NATURAL_32} 111 then
						l_tmp := a_A___0.item.size1
					else
						l_tmp := a_A___0.item.size2
					end
					l_MA := l_tmp
					if a_Trans.to_natural_32 = {NATURAL_32} 111 then
						l_tmp___0 := a_A___0.item.size2
					else
						l_tmp___0 := a_A___0.item.size1
					end
					l_NA := l_tmp___0
					if a_Trans.to_natural_32 = {NATURAL_32} 111 then
						l_tmp___1 := a_B.item.size1
					else
						l_tmp___1 := a_B.item.size2
					end
					l_MB := l_tmp___1
					if a_Trans.to_natural_32 = {NATURAL_32} 111 then
						l_tmp___2 := a_B.item.size2
					else
						l_tmp___2 := a_B.item.size1
					end
					l_NB := l_tmp___2
					if l_M = l_N then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("matrix C must be square"), ce_string ("blas.c"), 1941, 20)
							Result := 20
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 3 then -- else:
						if l_N = l_MA then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 6 then -- else:
						if l_N = l_MB then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 9 then -- else:
						if l_NA = l_NB then
							l_pos := -1 + 11 -- skip if block
						end
				when 10 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 1945, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 11 then -- if done | if done | if done
						if not js.return_called then
							zher2k_inst.cblas_zher2k ({PC_CBLAS_ORDER}.CblasRowMajor, a_Uplo, a_Trans, l_N.to_integer_32, l_NA.to_integer_32, create {CE_POINTER [ANY]}.make_cast ((a_alpha.dat)), create {CE_POINTER [ANY]}.make_cast (a_A___0.item.data), (a_A___0.item.tda).to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_B.item.data), (a_B.item.tda).to_integer_32, a_beta, create {CE_POINTER [ANY]}.make_cast (a_C.item.data), (a_C.item.tda).to_integer_32)
							Result := 0
						end
				when 12 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_blas_strmm (a_Side: INTEGER_32; a_Uplo: INTEGER_32; a_TransA: INTEGER_32; a_Diag: INTEGER_32; a_alpha: REAL_32; a_A___0: CE_POINTER [PD_GSL_MATRIX_FLOAT]; a_B: CE_POINTER [PD_GSL_MATRIX_FLOAT]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_MA: NATURAL_32
			l_NA: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := a_B.item.size1
					l_N := a_B.item.size2
					l_MA := a_A___0.item.size1
					l_NA := a_A___0.item.size2
					if l_MA /= l_NA then
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("matrix A must be square"), ce_string ("blas.c"), 1969, 20)
							Result := 20
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if js.return_called then
						l_pos := -1 + 8 -- skip if block
					end
				when 1 then -- if:
						if a_Side.to_natural_32 /= {NATURAL_32} 141 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_M = l_MA then
							strmm_inst.cblas_strmm ({PC_CBLAS_ORDER}.CblasRowMajor, a_Side, a_Uplo, a_TransA, a_Diag, l_M.to_integer_32, l_N.to_integer_32, a_alpha, a_A___0.item.data, (a_A___0.item.tda).to_integer_32, a_B.item.data, (a_B.item.tda).to_integer_32)
							Result := 0
							js.return
						else
							l_pos := -1 + 4 -- goto _L___0
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 4 then -- else: | _L___0:
						if a_Side.to_natural_32 /= {NATURAL_32} 142 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if l_N = l_MA then
							strmm_inst.cblas_strmm ({PC_CBLAS_ORDER}.CblasRowMajor, a_Side, a_Uplo, a_TransA, a_Diag, l_M.to_integer_32, l_N.to_integer_32, a_alpha, a_A___0.item.data, (a_A___0.item.tda).to_integer_32, a_B.item.data, (a_B.item.tda).to_integer_32)
							Result := 0
							js.return
						else
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 1980, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 8 then -- if done | if done
						if not js.return_called then
							Result := 0
						end
				when 9 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_blas_dtrmm (a_Side: INTEGER_32; a_Uplo: INTEGER_32; a_TransA: INTEGER_32; a_Diag: INTEGER_32; a_alpha: REAL_64; a_A___0: CE_POINTER [PD_GSL_MATRIX]; a_B: CE_POINTER [PD_GSL_MATRIX]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_MA: NATURAL_32
			l_NA: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := a_B.item.size1
					l_N := a_B.item.size2
					l_MA := a_A___0.item.size1
					l_NA := a_A___0.item.size2
					if l_MA /= l_NA then
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("matrix A must be square"), ce_string ("blas.c"), 1997, 20)
							Result := 20
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if js.return_called then
						l_pos := -1 + 8 -- skip if block
					end
				when 1 then -- if:
						if a_Side.to_natural_32 /= {NATURAL_32} 141 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_M = l_MA then
							dtrmm_inst.cblas_dtrmm ({PC_CBLAS_ORDER}.CblasRowMajor, a_Side, a_Uplo, a_TransA, a_Diag, l_M.to_integer_32, l_N.to_integer_32, a_alpha, a_A___0.item.data, (a_A___0.item.tda).to_integer_32, a_B.item.data, (a_B.item.tda).to_integer_32)
							Result := 0
							js.return
						else
							l_pos := -1 + 4 -- goto _L___0
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 4 then -- else: | _L___0:
						if a_Side.to_natural_32 /= {NATURAL_32} 142 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if l_N = l_MA then
							dtrmm_inst.cblas_dtrmm ({PC_CBLAS_ORDER}.CblasRowMajor, a_Side, a_Uplo, a_TransA, a_Diag, l_M.to_integer_32, l_N.to_integer_32, a_alpha, a_A___0.item.data, (a_A___0.item.tda).to_integer_32, a_B.item.data, (a_B.item.tda).to_integer_32)
							Result := 0
							js.return
						else
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 2008, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 8 then -- if done | if done
						if not js.return_called then
							Result := 0
						end
				when 9 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_blas_ctrmm (a_Side: INTEGER_32; a_Uplo: INTEGER_32; a_TransA: INTEGER_32; a_Diag: INTEGER_32; a_alpha: PD_GSL_COMPLEX_FLOAT; a_A___0: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]; a_B: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_MA: NATURAL_32
			l_NA: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := a_B.item.size1
					l_N := a_B.item.size2
					l_MA := a_A___0.item.size1
					l_NA := a_A___0.item.size2
					if l_MA /= l_NA then
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("matrix A must be square"), ce_string ("blas.c"), 2027, 20)
							Result := 20
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if js.return_called then
						l_pos := -1 + 8 -- skip if block
					end
				when 1 then -- if:
						if a_Side.to_natural_32 /= {NATURAL_32} 141 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_M = l_MA then
							ctrmm_inst.cblas_ctrmm ({PC_CBLAS_ORDER}.CblasRowMajor, a_Side, a_Uplo, a_TransA, a_Diag, l_M.to_integer_32, l_N.to_integer_32, create {CE_POINTER [ANY]}.make_cast ((a_alpha.dat)), create {CE_POINTER [ANY]}.make_cast (a_A___0.item.data), (a_A___0.item.tda).to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_B.item.data), (a_B.item.tda).to_integer_32)
							Result := 0
							js.return
						else
							l_pos := -1 + 4 -- goto _L___0
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 4 then -- else: | _L___0:
						if a_Side.to_natural_32 /= {NATURAL_32} 142 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if l_N = l_MA then
							ctrmm_inst.cblas_ctrmm ({PC_CBLAS_ORDER}.CblasRowMajor, a_Side, a_Uplo, a_TransA, a_Diag, l_M.to_integer_32, l_N.to_integer_32, create {CE_POINTER [ANY]}.make_cast ((a_alpha.dat)), create {CE_POINTER [ANY]}.make_cast (a_A___0.item.data), (a_A___0.item.tda).to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_B.item.data), (a_B.item.tda).to_integer_32)
							Result := 0
							js.return
						else
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 2039, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 8 then -- if done | if done
						if not js.return_called then
							Result := 0
						end
				when 9 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_blas_ztrmm (a_Side: INTEGER_32; a_Uplo: INTEGER_32; a_TransA: INTEGER_32; a_Diag: INTEGER_32; a_alpha: PD_GSL_COMPLEX; a_A___0: CE_POINTER [PD_GSL_MATRIX_COMPLEX]; a_B: CE_POINTER [PD_GSL_MATRIX_COMPLEX]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_MA: NATURAL_32
			l_NA: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := a_B.item.size1
					l_N := a_B.item.size2
					l_MA := a_A___0.item.size1
					l_NA := a_A___0.item.size2
					if l_MA /= l_NA then
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("matrix A must be square"), ce_string ("blas.c"), 2057, 20)
							Result := 20
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if js.return_called then
						l_pos := -1 + 8 -- skip if block
					end
				when 1 then -- if:
						if a_Side.to_natural_32 /= {NATURAL_32} 141 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_M = l_MA then
							ztrmm_inst.cblas_ztrmm ({PC_CBLAS_ORDER}.CblasRowMajor, a_Side, a_Uplo, a_TransA, a_Diag, l_M.to_integer_32, l_N.to_integer_32, create {CE_POINTER [ANY]}.make_cast ((a_alpha.dat)), create {CE_POINTER [ANY]}.make_cast (a_A___0.item.data), (a_A___0.item.tda).to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_B.item.data), (a_B.item.tda).to_integer_32)
							Result := 0
							js.return
						else
							l_pos := -1 + 4 -- goto _L___0
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 4 then -- else: | _L___0:
						if a_Side.to_natural_32 /= {NATURAL_32} 142 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if l_N = l_MA then
							ztrmm_inst.cblas_ztrmm ({PC_CBLAS_ORDER}.CblasRowMajor, a_Side, a_Uplo, a_TransA, a_Diag, l_M.to_integer_32, l_N.to_integer_32, create {CE_POINTER [ANY]}.make_cast ((a_alpha.dat)), create {CE_POINTER [ANY]}.make_cast (a_A___0.item.data), (a_A___0.item.tda).to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_B.item.data), (a_B.item.tda).to_integer_32)
							Result := 0
							js.return
						else
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 2069, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 8 then -- if done | if done
						if not js.return_called then
							Result := 0
						end
				when 9 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_blas_strsm (a_Side: INTEGER_32; a_Uplo: INTEGER_32; a_TransA: INTEGER_32; a_Diag: INTEGER_32; a_alpha: REAL_32; a_A___0: CE_POINTER [PD_GSL_MATRIX_FLOAT]; a_B: CE_POINTER [PD_GSL_MATRIX_FLOAT]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_MA: NATURAL_32
			l_NA: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := a_B.item.size1
					l_N := a_B.item.size2
					l_MA := a_A___0.item.size1
					l_NA := a_A___0.item.size2
					if l_MA /= l_NA then
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("matrix A must be square"), ce_string ("blas.c"), 2088, 20)
							Result := 20
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if js.return_called then
						l_pos := -1 + 8 -- skip if block
					end
				when 1 then -- if:
						if a_Side.to_natural_32 /= {NATURAL_32} 141 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_M = l_MA then
							strsm_inst.cblas_strsm ({PC_CBLAS_ORDER}.CblasRowMajor, a_Side, a_Uplo, a_TransA, a_Diag, l_M.to_integer_32, l_N.to_integer_32, a_alpha, a_A___0.item.data, (a_A___0.item.tda).to_integer_32, a_B.item.data, (a_B.item.tda).to_integer_32)
							Result := 0
							js.return
						else
							l_pos := -1 + 4 -- goto _L___0
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 4 then -- else: | _L___0:
						if a_Side.to_natural_32 /= {NATURAL_32} 142 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if l_N = l_MA then
							strsm_inst.cblas_strsm ({PC_CBLAS_ORDER}.CblasRowMajor, a_Side, a_Uplo, a_TransA, a_Diag, l_M.to_integer_32, l_N.to_integer_32, a_alpha, a_A___0.item.data, (a_A___0.item.tda).to_integer_32, a_B.item.data, (a_B.item.tda).to_integer_32)
							Result := 0
							js.return
						else
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 2099, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 8 then -- if done | if done
						if not js.return_called then
							Result := 0
						end
				when 9 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_blas_dtrsm (a_Side: INTEGER_32; a_Uplo: INTEGER_32; a_TransA: INTEGER_32; a_Diag: INTEGER_32; a_alpha: REAL_64; a_A___0: CE_POINTER [PD_GSL_MATRIX]; a_B: CE_POINTER [PD_GSL_MATRIX]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_MA: NATURAL_32
			l_NA: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := a_B.item.size1
					l_N := a_B.item.size2
					l_MA := a_A___0.item.size1
					l_NA := a_A___0.item.size2
					if l_MA /= l_NA then
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("matrix A must be square"), ce_string ("blas.c"), 2116, 20)
							Result := 20
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if js.return_called then
						l_pos := -1 + 8 -- skip if block
					end
				when 1 then -- if:
						if a_Side.to_natural_32 /= {NATURAL_32} 141 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_M = l_MA then
							dtrsm_inst.cblas_dtrsm ({PC_CBLAS_ORDER}.CblasRowMajor, a_Side, a_Uplo, a_TransA, a_Diag, l_M.to_integer_32, l_N.to_integer_32, a_alpha, a_A___0.item.data, (a_A___0.item.tda).to_integer_32, a_B.item.data, (a_B.item.tda).to_integer_32)
							Result := 0
							js.return
						else
							l_pos := -1 + 4 -- goto _L___0
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 4 then -- else: | _L___0:
						if a_Side.to_natural_32 /= {NATURAL_32} 142 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if l_N = l_MA then
							dtrsm_inst.cblas_dtrsm ({PC_CBLAS_ORDER}.CblasRowMajor, a_Side, a_Uplo, a_TransA, a_Diag, l_M.to_integer_32, l_N.to_integer_32, a_alpha, a_A___0.item.data, (a_A___0.item.tda).to_integer_32, a_B.item.data, (a_B.item.tda).to_integer_32)
							Result := 0
							js.return
						else
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 2127, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 8 then -- if done | if done
						if not js.return_called then
							Result := 0
						end
				when 9 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_blas_ctrsm (a_Side: INTEGER_32; a_Uplo: INTEGER_32; a_TransA: INTEGER_32; a_Diag: INTEGER_32; a_alpha: PD_GSL_COMPLEX_FLOAT; a_A___0: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]; a_B: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_MA: NATURAL_32
			l_NA: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := a_B.item.size1
					l_N := a_B.item.size2
					l_MA := a_A___0.item.size1
					l_NA := a_A___0.item.size2
					if l_MA /= l_NA then
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("matrix A must be square"), ce_string ("blas.c"), 2146, 20)
							Result := 20
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if js.return_called then
						l_pos := -1 + 8 -- skip if block
					end
				when 1 then -- if:
						if a_Side.to_natural_32 /= {NATURAL_32} 141 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_M = l_MA then
							ctrsm_inst.cblas_ctrsm ({PC_CBLAS_ORDER}.CblasRowMajor, a_Side, a_Uplo, a_TransA, a_Diag, l_M.to_integer_32, l_N.to_integer_32, create {CE_POINTER [ANY]}.make_cast ((a_alpha.dat)), create {CE_POINTER [ANY]}.make_cast (a_A___0.item.data), (a_A___0.item.tda).to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_B.item.data), (a_B.item.tda).to_integer_32)
							Result := 0
							js.return
						else
							l_pos := -1 + 4 -- goto _L___0
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 4 then -- else: | _L___0:
						if a_Side.to_natural_32 /= {NATURAL_32} 142 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if l_N = l_MA then
							ctrsm_inst.cblas_ctrsm ({PC_CBLAS_ORDER}.CblasRowMajor, a_Side, a_Uplo, a_TransA, a_Diag, l_M.to_integer_32, l_N.to_integer_32, create {CE_POINTER [ANY]}.make_cast ((a_alpha.dat)), create {CE_POINTER [ANY]}.make_cast (a_A___0.item.data), (a_A___0.item.tda).to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_B.item.data), (a_B.item.tda).to_integer_32)
							Result := 0
							js.return
						else
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 2158, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 8 then -- if done | if done
						if not js.return_called then
							Result := 0
						end
				when 9 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_blas_ztrsm (a_Side: INTEGER_32; a_Uplo: INTEGER_32; a_TransA: INTEGER_32; a_Diag: INTEGER_32; a_alpha: PD_GSL_COMPLEX; a_A___0: CE_POINTER [PD_GSL_MATRIX_COMPLEX]; a_B: CE_POINTER [PD_GSL_MATRIX_COMPLEX]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_MA: NATURAL_32
			l_NA: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := a_B.item.size1
					l_N := a_B.item.size2
					l_MA := a_A___0.item.size1
					l_NA := a_A___0.item.size2
					if l_MA /= l_NA then
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("matrix A must be square"), ce_string ("blas.c"), 2176, 20)
							Result := 20
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if js.return_called then
						l_pos := -1 + 8 -- skip if block
					end
				when 1 then -- if:
						if a_Side.to_natural_32 /= {NATURAL_32} 141 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_M = l_MA then
							ztrsm_inst.cblas_ztrsm ({PC_CBLAS_ORDER}.CblasRowMajor, a_Side, a_Uplo, a_TransA, a_Diag, l_M.to_integer_32, l_N.to_integer_32, create {CE_POINTER [ANY]}.make_cast ((a_alpha.dat)), create {CE_POINTER [ANY]}.make_cast (a_A___0.item.data), (a_A___0.item.tda).to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_B.item.data), (a_B.item.tda).to_integer_32)
							Result := 0
							js.return
						else
							l_pos := -1 + 4 -- goto _L___0
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 4 then -- else: | _L___0:
						if a_Side.to_natural_32 /= {NATURAL_32} 142 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if l_N = l_MA then
							ztrsm_inst.cblas_ztrsm ({PC_CBLAS_ORDER}.CblasRowMajor, a_Side, a_Uplo, a_TransA, a_Diag, l_M.to_integer_32, l_N.to_integer_32, create {CE_POINTER [ANY]}.make_cast ((a_alpha.dat)), create {CE_POINTER [ANY]}.make_cast (a_A___0.item.data), (a_A___0.item.tda).to_integer_32, create {CE_POINTER [ANY]}.make_cast (a_B.item.data), (a_B.item.tda).to_integer_32)
							Result := 0
							js.return
						else
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 2188, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 8 then -- if done | if done
						if not js.return_called then
							Result := 0
						end
				when 9 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

end
