class
	P_VIEW_SOURCE

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_matrix_complex_long_double_view_array (a_array: CE_POINTER [REAL_96]; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE_VIEW
		local
			l_view: PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE_VIEW
			l_m___4: PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 29, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 34, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_array
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_complex_long_double_view_array_with_tda (a_base: CE_POINTER [REAL_96]; a_n1: NATURAL_32; a_n2: NATURAL_32; a_tda: NATURAL_32): PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE_VIEW
		local
			l_view: PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE_VIEW
			l_m___4: PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 63, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 68, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 > a_tda then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 73, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_base
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_complex_long_double_view_vector (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE]; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE_VIEW
		local
			l_view: PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE_VIEW
			l_m___4: PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 102, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 107, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_v.item.stride /= {NATURAL_32} 1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector must have unit stride"), ce_string ("view_source.c"), 112, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 * a_n2 > a_v.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size exceeds size of original"), ce_string ("view_source.c"), 117, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_v.item.data
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := a_v.item.block
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_complex_long_double_view_vector_with_tda (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE]; a_n1: NATURAL_32; a_n2: NATURAL_32; a_tda: NATURAL_32): PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE_VIEW
		local
			l_view: PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE_VIEW
			l_m___4: PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 147, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 152, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_v.item.stride /= {NATURAL_32} 1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector must have unit stride"), ce_string ("view_source.c"), 157, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 > a_tda then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 162, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 * a_tda > a_v.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size exceeds size of original"), ce_string ("view_source.c"), 167, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_v.item.data
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := a_v.item.block
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_complex_view_array (a_array: CE_POINTER [REAL_64]; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_COMPLEX_VIEW
		local
			l_view: PD_GSL_MATRIX_COMPLEX_VIEW
			l_m___4: PD_GSL_MATRIX_COMPLEX
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 29, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 34, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_array
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_complex_view_array_with_tda (a_base: CE_POINTER [REAL_64]; a_n1: NATURAL_32; a_n2: NATURAL_32; a_tda: NATURAL_32): PD_GSL_MATRIX_COMPLEX_VIEW
		local
			l_view: PD_GSL_MATRIX_COMPLEX_VIEW
			l_m___4: PD_GSL_MATRIX_COMPLEX
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 63, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 68, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 > a_tda then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 73, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_base
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_complex_view_vector (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_COMPLEX_VIEW
		local
			l_view: PD_GSL_MATRIX_COMPLEX_VIEW
			l_m___4: PD_GSL_MATRIX_COMPLEX
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 102, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 107, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_v.item.stride /= {NATURAL_32} 1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector must have unit stride"), ce_string ("view_source.c"), 112, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 * a_n2 > a_v.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size exceeds size of original"), ce_string ("view_source.c"), 117, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_v.item.data
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := a_v.item.block
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_complex_view_vector_with_tda (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_n1: NATURAL_32; a_n2: NATURAL_32; a_tda: NATURAL_32): PD_GSL_MATRIX_COMPLEX_VIEW
		local
			l_view: PD_GSL_MATRIX_COMPLEX_VIEW
			l_m___4: PD_GSL_MATRIX_COMPLEX
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 147, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 152, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_v.item.stride /= {NATURAL_32} 1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector must have unit stride"), ce_string ("view_source.c"), 157, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 > a_tda then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 162, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 * a_tda > a_v.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size exceeds size of original"), ce_string ("view_source.c"), 167, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_v.item.data
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := a_v.item.block
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_complex_float_view_array (a_array: CE_POINTER [REAL_32]; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_COMPLEX_FLOAT_VIEW
		local
			l_view: PD_GSL_MATRIX_COMPLEX_FLOAT_VIEW
			l_m___4: PD_GSL_MATRIX_COMPLEX_FLOAT
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 29, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 34, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_array
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_complex_float_view_array_with_tda (a_base: CE_POINTER [REAL_32]; a_n1: NATURAL_32; a_n2: NATURAL_32; a_tda: NATURAL_32): PD_GSL_MATRIX_COMPLEX_FLOAT_VIEW
		local
			l_view: PD_GSL_MATRIX_COMPLEX_FLOAT_VIEW
			l_m___4: PD_GSL_MATRIX_COMPLEX_FLOAT
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 63, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 68, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 > a_tda then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 73, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_base
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_complex_float_view_vector (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_COMPLEX_FLOAT_VIEW
		local
			l_view: PD_GSL_MATRIX_COMPLEX_FLOAT_VIEW
			l_m___4: PD_GSL_MATRIX_COMPLEX_FLOAT
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 102, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 107, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_v.item.stride /= {NATURAL_32} 1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector must have unit stride"), ce_string ("view_source.c"), 112, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 * a_n2 > a_v.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size exceeds size of original"), ce_string ("view_source.c"), 117, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_v.item.data
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := a_v.item.block
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_complex_float_view_vector_with_tda (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]; a_n1: NATURAL_32; a_n2: NATURAL_32; a_tda: NATURAL_32): PD_GSL_MATRIX_COMPLEX_FLOAT_VIEW
		local
			l_view: PD_GSL_MATRIX_COMPLEX_FLOAT_VIEW
			l_m___4: PD_GSL_MATRIX_COMPLEX_FLOAT
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 147, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 152, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_v.item.stride /= {NATURAL_32} 1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector must have unit stride"), ce_string ("view_source.c"), 157, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 > a_tda then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 162, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 * a_tda > a_v.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size exceeds size of original"), ce_string ("view_source.c"), 167, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_v.item.data
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := a_v.item.block
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_long_double_view_array (a_array: CE_POINTER [REAL_96]; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_LONG_DOUBLE_VIEW
		local
			l_view: PD_GSL_MATRIX_LONG_DOUBLE_VIEW
			l_m___4: PD_GSL_MATRIX_LONG_DOUBLE
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 29, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 34, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_array
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_long_double_view_array_with_tda (a_base: CE_POINTER [REAL_96]; a_n1: NATURAL_32; a_n2: NATURAL_32; a_tda: NATURAL_32): PD_GSL_MATRIX_LONG_DOUBLE_VIEW
		local
			l_view: PD_GSL_MATRIX_LONG_DOUBLE_VIEW
			l_m___4: PD_GSL_MATRIX_LONG_DOUBLE
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 63, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 68, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 > a_tda then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 73, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_base
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_long_double_view_vector (a_v: CE_POINTER [PD_GSL_VECTOR_LONG_DOUBLE]; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_LONG_DOUBLE_VIEW
		local
			l_view: PD_GSL_MATRIX_LONG_DOUBLE_VIEW
			l_m___4: PD_GSL_MATRIX_LONG_DOUBLE
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 102, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 107, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_v.item.stride /= {NATURAL_32} 1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector must have unit stride"), ce_string ("view_source.c"), 112, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 * a_n2 > a_v.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size exceeds size of original"), ce_string ("view_source.c"), 117, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_v.item.data
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := a_v.item.block
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_long_double_view_vector_with_tda (a_v: CE_POINTER [PD_GSL_VECTOR_LONG_DOUBLE]; a_n1: NATURAL_32; a_n2: NATURAL_32; a_tda: NATURAL_32): PD_GSL_MATRIX_LONG_DOUBLE_VIEW
		local
			l_view: PD_GSL_MATRIX_LONG_DOUBLE_VIEW
			l_m___4: PD_GSL_MATRIX_LONG_DOUBLE
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 147, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 152, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_v.item.stride /= {NATURAL_32} 1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector must have unit stride"), ce_string ("view_source.c"), 157, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 > a_tda then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 162, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 * a_tda > a_v.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size exceeds size of original"), ce_string ("view_source.c"), 167, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_v.item.data
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := a_v.item.block
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_view_array (a_array: CE_POINTER [REAL_64]; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_VIEW
		local
			l_view: PD_GSL_MATRIX_VIEW
			l_m___4: PD_GSL_MATRIX
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 29, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 34, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_array
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_view_array_with_tda (a_base: CE_POINTER [REAL_64]; a_n1: NATURAL_32; a_n2: NATURAL_32; a_tda: NATURAL_32): PD_GSL_MATRIX_VIEW
		local
			l_view: PD_GSL_MATRIX_VIEW
			l_m___4: PD_GSL_MATRIX
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 63, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 68, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 > a_tda then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 73, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_base
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_view_vector (a_v: CE_POINTER [PD_GSL_VECTOR]; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_VIEW
		local
			l_view: PD_GSL_MATRIX_VIEW
			l_m___4: PD_GSL_MATRIX
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 102, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 107, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_v.item.stride /= {NATURAL_32} 1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector must have unit stride"), ce_string ("view_source.c"), 112, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 * a_n2 > a_v.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size exceeds size of original"), ce_string ("view_source.c"), 117, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_v.item.data
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := a_v.item.block
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_view_vector_with_tda (a_v: CE_POINTER [PD_GSL_VECTOR]; a_n1: NATURAL_32; a_n2: NATURAL_32; a_tda: NATURAL_32): PD_GSL_MATRIX_VIEW
		local
			l_view: PD_GSL_MATRIX_VIEW
			l_m___4: PD_GSL_MATRIX
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 147, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 152, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_v.item.stride /= {NATURAL_32} 1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector must have unit stride"), ce_string ("view_source.c"), 157, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 > a_tda then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 162, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 * a_tda > a_v.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size exceeds size of original"), ce_string ("view_source.c"), 167, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_v.item.data
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := a_v.item.block
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_float_view_array (a_array: CE_POINTER [REAL_32]; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_FLOAT_VIEW
		local
			l_view: PD_GSL_MATRIX_FLOAT_VIEW
			l_m___4: PD_GSL_MATRIX_FLOAT
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 29, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 34, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_array
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_float_view_array_with_tda (a_base: CE_POINTER [REAL_32]; a_n1: NATURAL_32; a_n2: NATURAL_32; a_tda: NATURAL_32): PD_GSL_MATRIX_FLOAT_VIEW
		local
			l_view: PD_GSL_MATRIX_FLOAT_VIEW
			l_m___4: PD_GSL_MATRIX_FLOAT
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 63, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 68, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 > a_tda then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 73, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_base
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_float_view_vector (a_v: CE_POINTER [PD_GSL_VECTOR_FLOAT]; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_FLOAT_VIEW
		local
			l_view: PD_GSL_MATRIX_FLOAT_VIEW
			l_m___4: PD_GSL_MATRIX_FLOAT
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 102, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 107, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_v.item.stride /= {NATURAL_32} 1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector must have unit stride"), ce_string ("view_source.c"), 112, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 * a_n2 > a_v.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size exceeds size of original"), ce_string ("view_source.c"), 117, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_v.item.data
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := a_v.item.block
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_float_view_vector_with_tda (a_v: CE_POINTER [PD_GSL_VECTOR_FLOAT]; a_n1: NATURAL_32; a_n2: NATURAL_32; a_tda: NATURAL_32): PD_GSL_MATRIX_FLOAT_VIEW
		local
			l_view: PD_GSL_MATRIX_FLOAT_VIEW
			l_m___4: PD_GSL_MATRIX_FLOAT
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 147, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 152, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_v.item.stride /= {NATURAL_32} 1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector must have unit stride"), ce_string ("view_source.c"), 157, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 > a_tda then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 162, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 * a_tda > a_v.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size exceeds size of original"), ce_string ("view_source.c"), 167, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_v.item.data
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := a_v.item.block
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_ulong_view_array (a_array: CE_POINTER [NATURAL_32]; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_ULONG_VIEW
		local
			l_view: PD_GSL_MATRIX_ULONG_VIEW
			l_m___4: PD_GSL_MATRIX_ULONG
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 29, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 34, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_array
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_ulong_view_array_with_tda (a_base: CE_POINTER [NATURAL_32]; a_n1: NATURAL_32; a_n2: NATURAL_32; a_tda: NATURAL_32): PD_GSL_MATRIX_ULONG_VIEW
		local
			l_view: PD_GSL_MATRIX_ULONG_VIEW
			l_m___4: PD_GSL_MATRIX_ULONG
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 63, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 68, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 > a_tda then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 73, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_base
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_ulong_view_vector (a_v: CE_POINTER [PD_GSL_VECTOR_ULONG]; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_ULONG_VIEW
		local
			l_view: PD_GSL_MATRIX_ULONG_VIEW
			l_m___4: PD_GSL_MATRIX_ULONG
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 102, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 107, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_v.item.stride /= {NATURAL_32} 1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector must have unit stride"), ce_string ("view_source.c"), 112, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 * a_n2 > a_v.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size exceeds size of original"), ce_string ("view_source.c"), 117, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_v.item.data
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := a_v.item.block
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_ulong_view_vector_with_tda (a_v: CE_POINTER [PD_GSL_VECTOR_ULONG]; a_n1: NATURAL_32; a_n2: NATURAL_32; a_tda: NATURAL_32): PD_GSL_MATRIX_ULONG_VIEW
		local
			l_view: PD_GSL_MATRIX_ULONG_VIEW
			l_m___4: PD_GSL_MATRIX_ULONG
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 147, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 152, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_v.item.stride /= {NATURAL_32} 1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector must have unit stride"), ce_string ("view_source.c"), 157, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 > a_tda then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 162, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 * a_tda > a_v.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size exceeds size of original"), ce_string ("view_source.c"), 167, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_v.item.data
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := a_v.item.block
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_long_view_array (a_array: CE_POINTER [INTEGER_32]; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_LONG_VIEW
		local
			l_view: PD_GSL_MATRIX_LONG_VIEW
			l_m___4: PD_GSL_MATRIX_LONG
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 29, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 34, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_array
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_long_view_array_with_tda (a_base: CE_POINTER [INTEGER_32]; a_n1: NATURAL_32; a_n2: NATURAL_32; a_tda: NATURAL_32): PD_GSL_MATRIX_LONG_VIEW
		local
			l_view: PD_GSL_MATRIX_LONG_VIEW
			l_m___4: PD_GSL_MATRIX_LONG
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 63, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 68, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 > a_tda then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 73, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_base
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_long_view_vector (a_v: CE_POINTER [PD_GSL_VECTOR_LONG]; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_LONG_VIEW
		local
			l_view: PD_GSL_MATRIX_LONG_VIEW
			l_m___4: PD_GSL_MATRIX_LONG
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 102, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 107, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_v.item.stride /= {NATURAL_32} 1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector must have unit stride"), ce_string ("view_source.c"), 112, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 * a_n2 > a_v.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size exceeds size of original"), ce_string ("view_source.c"), 117, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_v.item.data
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := a_v.item.block
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_long_view_vector_with_tda (a_v: CE_POINTER [PD_GSL_VECTOR_LONG]; a_n1: NATURAL_32; a_n2: NATURAL_32; a_tda: NATURAL_32): PD_GSL_MATRIX_LONG_VIEW
		local
			l_view: PD_GSL_MATRIX_LONG_VIEW
			l_m___4: PD_GSL_MATRIX_LONG
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 147, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 152, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_v.item.stride /= {NATURAL_32} 1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector must have unit stride"), ce_string ("view_source.c"), 157, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 > a_tda then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 162, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 * a_tda > a_v.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size exceeds size of original"), ce_string ("view_source.c"), 167, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_v.item.data
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := a_v.item.block
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_uint_view_array (a_array: CE_POINTER [NATURAL_32]; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_UINT_VIEW
		local
			l_view: PD_GSL_MATRIX_UINT_VIEW
			l_m___4: PD_GSL_MATRIX_UINT
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_UINT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 29, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 34, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_UINT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_array
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_UINT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_uint_view_array_with_tda (a_base: CE_POINTER [NATURAL_32]; a_n1: NATURAL_32; a_n2: NATURAL_32; a_tda: NATURAL_32): PD_GSL_MATRIX_UINT_VIEW
		local
			l_view: PD_GSL_MATRIX_UINT_VIEW
			l_m___4: PD_GSL_MATRIX_UINT
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_UINT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 63, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 68, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 > a_tda then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 73, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_UINT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_base
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_UINT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_uint_view_vector (a_v: CE_POINTER [PD_GSL_VECTOR_UINT]; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_UINT_VIEW
		local
			l_view: PD_GSL_MATRIX_UINT_VIEW
			l_m___4: PD_GSL_MATRIX_UINT
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_UINT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 102, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 107, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_v.item.stride /= {NATURAL_32} 1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector must have unit stride"), ce_string ("view_source.c"), 112, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 * a_n2 > a_v.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size exceeds size of original"), ce_string ("view_source.c"), 117, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_UINT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_v.item.data
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := a_v.item.block
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_uint_view_vector_with_tda (a_v: CE_POINTER [PD_GSL_VECTOR_UINT]; a_n1: NATURAL_32; a_n2: NATURAL_32; a_tda: NATURAL_32): PD_GSL_MATRIX_UINT_VIEW
		local
			l_view: PD_GSL_MATRIX_UINT_VIEW
			l_m___4: PD_GSL_MATRIX_UINT
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_UINT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 147, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 152, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_v.item.stride /= {NATURAL_32} 1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector must have unit stride"), ce_string ("view_source.c"), 157, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 > a_tda then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 162, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 * a_tda > a_v.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size exceeds size of original"), ce_string ("view_source.c"), 167, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_UINT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_v.item.data
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := a_v.item.block
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_int_view_array (a_array: CE_POINTER [INTEGER_32]; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_INT_VIEW
		local
			l_view: PD_GSL_MATRIX_INT_VIEW
			l_m___4: PD_GSL_MATRIX_INT
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_INT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 29, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 34, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_INT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_array
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_INT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_int_view_array_with_tda (a_base: CE_POINTER [INTEGER_32]; a_n1: NATURAL_32; a_n2: NATURAL_32; a_tda: NATURAL_32): PD_GSL_MATRIX_INT_VIEW
		local
			l_view: PD_GSL_MATRIX_INT_VIEW
			l_m___4: PD_GSL_MATRIX_INT
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_INT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 63, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 68, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 > a_tda then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 73, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_INT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_base
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_INT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_int_view_vector (a_v: CE_POINTER [PD_GSL_VECTOR_INT]; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_INT_VIEW
		local
			l_view: PD_GSL_MATRIX_INT_VIEW
			l_m___4: PD_GSL_MATRIX_INT
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_INT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 102, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 107, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_v.item.stride /= {NATURAL_32} 1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector must have unit stride"), ce_string ("view_source.c"), 112, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 * a_n2 > a_v.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size exceeds size of original"), ce_string ("view_source.c"), 117, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_INT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_v.item.data
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := a_v.item.block
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_int_view_vector_with_tda (a_v: CE_POINTER [PD_GSL_VECTOR_INT]; a_n1: NATURAL_32; a_n2: NATURAL_32; a_tda: NATURAL_32): PD_GSL_MATRIX_INT_VIEW
		local
			l_view: PD_GSL_MATRIX_INT_VIEW
			l_m___4: PD_GSL_MATRIX_INT
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_INT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 147, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 152, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_v.item.stride /= {NATURAL_32} 1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector must have unit stride"), ce_string ("view_source.c"), 157, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 > a_tda then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 162, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 * a_tda > a_v.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size exceeds size of original"), ce_string ("view_source.c"), 167, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_INT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_v.item.data
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := a_v.item.block
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_ushort_view_array (a_array: CE_POINTER [NATURAL_16]; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_USHORT_VIEW
		local
			l_view: PD_GSL_MATRIX_USHORT_VIEW
			l_m___4: PD_GSL_MATRIX_USHORT
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [NATURAL_16]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 29, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 34, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [NATURAL_16]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_array
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_ushort_view_array_with_tda (a_base: CE_POINTER [NATURAL_16]; a_n1: NATURAL_32; a_n2: NATURAL_32; a_tda: NATURAL_32): PD_GSL_MATRIX_USHORT_VIEW
		local
			l_view: PD_GSL_MATRIX_USHORT_VIEW
			l_m___4: PD_GSL_MATRIX_USHORT
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [NATURAL_16]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 63, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 68, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 > a_tda then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 73, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [NATURAL_16]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_base
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_ushort_view_vector (a_v: CE_POINTER [PD_GSL_VECTOR_USHORT]; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_USHORT_VIEW
		local
			l_view: PD_GSL_MATRIX_USHORT_VIEW
			l_m___4: PD_GSL_MATRIX_USHORT
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [NATURAL_16]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 102, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 107, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_v.item.stride /= {NATURAL_32} 1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector must have unit stride"), ce_string ("view_source.c"), 112, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 * a_n2 > a_v.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size exceeds size of original"), ce_string ("view_source.c"), 117, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [NATURAL_16]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_v.item.data
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := a_v.item.block
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_ushort_view_vector_with_tda (a_v: CE_POINTER [PD_GSL_VECTOR_USHORT]; a_n1: NATURAL_32; a_n2: NATURAL_32; a_tda: NATURAL_32): PD_GSL_MATRIX_USHORT_VIEW
		local
			l_view: PD_GSL_MATRIX_USHORT_VIEW
			l_m___4: PD_GSL_MATRIX_USHORT
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [NATURAL_16]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 147, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 152, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_v.item.stride /= {NATURAL_32} 1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector must have unit stride"), ce_string ("view_source.c"), 157, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 > a_tda then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 162, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 * a_tda > a_v.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size exceeds size of original"), ce_string ("view_source.c"), 167, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [NATURAL_16]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_v.item.data
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := a_v.item.block
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_short_view_array (a_array: CE_POINTER [INTEGER_16]; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_SHORT_VIEW
		local
			l_view: PD_GSL_MATRIX_SHORT_VIEW
			l_m___4: PD_GSL_MATRIX_SHORT
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [INTEGER_16]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 29, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 34, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [INTEGER_16]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_array
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_short_view_array_with_tda (a_base: CE_POINTER [INTEGER_16]; a_n1: NATURAL_32; a_n2: NATURAL_32; a_tda: NATURAL_32): PD_GSL_MATRIX_SHORT_VIEW
		local
			l_view: PD_GSL_MATRIX_SHORT_VIEW
			l_m___4: PD_GSL_MATRIX_SHORT
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [INTEGER_16]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 63, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 68, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 > a_tda then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 73, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [INTEGER_16]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_base
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_short_view_vector (a_v: CE_POINTER [PD_GSL_VECTOR_SHORT]; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_SHORT_VIEW
		local
			l_view: PD_GSL_MATRIX_SHORT_VIEW
			l_m___4: PD_GSL_MATRIX_SHORT
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [INTEGER_16]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 102, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 107, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_v.item.stride /= {NATURAL_32} 1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector must have unit stride"), ce_string ("view_source.c"), 112, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 * a_n2 > a_v.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size exceeds size of original"), ce_string ("view_source.c"), 117, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [INTEGER_16]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_v.item.data
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := a_v.item.block
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_short_view_vector_with_tda (a_v: CE_POINTER [PD_GSL_VECTOR_SHORT]; a_n1: NATURAL_32; a_n2: NATURAL_32; a_tda: NATURAL_32): PD_GSL_MATRIX_SHORT_VIEW
		local
			l_view: PD_GSL_MATRIX_SHORT_VIEW
			l_m___4: PD_GSL_MATRIX_SHORT
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [INTEGER_16]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 147, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 152, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_v.item.stride /= {NATURAL_32} 1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector must have unit stride"), ce_string ("view_source.c"), 157, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 > a_tda then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 162, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 * a_tda > a_v.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size exceeds size of original"), ce_string ("view_source.c"), 167, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [INTEGER_16]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_v.item.data
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := a_v.item.block
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_uchar_view_array (a_array: CE_POINTER [NATURAL_8]; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_UCHAR_VIEW
		local
			l_view: PD_GSL_MATRIX_UCHAR_VIEW
			l_m___4: PD_GSL_MATRIX_UCHAR
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 29, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 34, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_array
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_uchar_view_array_with_tda (a_base: CE_POINTER [NATURAL_8]; a_n1: NATURAL_32; a_n2: NATURAL_32; a_tda: NATURAL_32): PD_GSL_MATRIX_UCHAR_VIEW
		local
			l_view: PD_GSL_MATRIX_UCHAR_VIEW
			l_m___4: PD_GSL_MATRIX_UCHAR
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 63, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 68, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 > a_tda then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 73, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_base
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_uchar_view_vector (a_v: CE_POINTER [PD_GSL_VECTOR_UCHAR]; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_UCHAR_VIEW
		local
			l_view: PD_GSL_MATRIX_UCHAR_VIEW
			l_m___4: PD_GSL_MATRIX_UCHAR
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 102, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 107, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_v.item.stride /= {NATURAL_32} 1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector must have unit stride"), ce_string ("view_source.c"), 112, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 * a_n2 > a_v.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size exceeds size of original"), ce_string ("view_source.c"), 117, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_v.item.data
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := a_v.item.block
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_uchar_view_vector_with_tda (a_v: CE_POINTER [PD_GSL_VECTOR_UCHAR]; a_n1: NATURAL_32; a_n2: NATURAL_32; a_tda: NATURAL_32): PD_GSL_MATRIX_UCHAR_VIEW
		local
			l_view: PD_GSL_MATRIX_UCHAR_VIEW
			l_m___4: PD_GSL_MATRIX_UCHAR
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 147, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 152, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_v.item.stride /= {NATURAL_32} 1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector must have unit stride"), ce_string ("view_source.c"), 157, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 > a_tda then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 162, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 * a_tda > a_v.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size exceeds size of original"), ce_string ("view_source.c"), 167, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_v.item.data
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := a_v.item.block
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_char_view_array (a_array: CE_POINTER [INTEGER_8]; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_CHAR_VIEW
		local
			l_view: PD_GSL_MATRIX_CHAR_VIEW
			l_m___4: PD_GSL_MATRIX_CHAR
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 29, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 34, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_array
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_char_view_array_with_tda (a_base: CE_POINTER [INTEGER_8]; a_n1: NATURAL_32; a_n2: NATURAL_32; a_tda: NATURAL_32): PD_GSL_MATRIX_CHAR_VIEW
		local
			l_view: PD_GSL_MATRIX_CHAR_VIEW
			l_m___4: PD_GSL_MATRIX_CHAR
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 63, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 68, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 > a_tda then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 73, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_base
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_char_view_vector (a_v: CE_POINTER [PD_GSL_VECTOR_CHAR]; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_CHAR_VIEW
		local
			l_view: PD_GSL_MATRIX_CHAR_VIEW
			l_m___4: PD_GSL_MATRIX_CHAR
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 102, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 107, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_v.item.stride /= {NATURAL_32} 1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector must have unit stride"), ce_string ("view_source.c"), 112, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 * a_n2 > a_v.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size exceeds size of original"), ce_string ("view_source.c"), 117, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_v.item.data
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := a_v.item.block
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_char_view_vector_with_tda (a_v: CE_POINTER [PD_GSL_VECTOR_CHAR]; a_n1: NATURAL_32; a_n2: NATURAL_32; a_tda: NATURAL_32): PD_GSL_MATRIX_CHAR_VIEW
		local
			l_view: PD_GSL_MATRIX_CHAR_VIEW
			l_m___4: PD_GSL_MATRIX_CHAR
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 147, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 152, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_v.item.stride /= {NATURAL_32} 1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector must have unit stride"), ce_string ("view_source.c"), 157, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 > a_tda then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 162, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 * a_tda > a_v.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size exceeds size of original"), ce_string ("view_source.c"), 167, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_v.item.data
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := a_v.item.block
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_complex_long_double_const_view_array (a_array: CE_POINTER [REAL_96]; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 29, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 34, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_array
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_complex_long_double_const_view_array_with_tda (a_base: CE_POINTER [REAL_96]; a_n1: NATURAL_32; a_n2: NATURAL_32; a_tda: NATURAL_32): PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 63, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 68, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 > a_tda then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 73, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_base
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_complex_long_double_const_view_vector (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE]; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 102, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 107, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_v.item.stride /= {NATURAL_32} 1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector must have unit stride"), ce_string ("view_source.c"), 112, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 * a_n2 > a_v.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size exceeds size of original"), ce_string ("view_source.c"), 117, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_v.item.data
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := a_v.item.block
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_complex_long_double_const_view_vector_with_tda (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE]; a_n1: NATURAL_32; a_n2: NATURAL_32; a_tda: NATURAL_32): PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 147, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 152, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_v.item.stride /= {NATURAL_32} 1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector must have unit stride"), ce_string ("view_source.c"), 157, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 > a_tda then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 162, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 * a_tda > a_v.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size exceeds size of original"), ce_string ("view_source.c"), 167, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_v.item.data
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := a_v.item.block
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_complex_const_view_array (a_array: CE_POINTER [REAL_64]; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_COMPLEX_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_COMPLEX_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_COMPLEX
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 29, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 34, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_array
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_complex_const_view_array_with_tda (a_base: CE_POINTER [REAL_64]; a_n1: NATURAL_32; a_n2: NATURAL_32; a_tda: NATURAL_32): PD_GSL_MATRIX_COMPLEX_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_COMPLEX_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_COMPLEX
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 63, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 68, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 > a_tda then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 73, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_base
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_complex_const_view_vector (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_COMPLEX_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_COMPLEX_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_COMPLEX
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 102, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 107, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_v.item.stride /= {NATURAL_32} 1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector must have unit stride"), ce_string ("view_source.c"), 112, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 * a_n2 > a_v.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size exceeds size of original"), ce_string ("view_source.c"), 117, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_v.item.data
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := a_v.item.block
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_complex_const_view_vector_with_tda (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_n1: NATURAL_32; a_n2: NATURAL_32; a_tda: NATURAL_32): PD_GSL_MATRIX_COMPLEX_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_COMPLEX_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_COMPLEX
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 147, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 152, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_v.item.stride /= {NATURAL_32} 1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector must have unit stride"), ce_string ("view_source.c"), 157, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 > a_tda then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 162, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 * a_tda > a_v.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size exceeds size of original"), ce_string ("view_source.c"), 167, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_v.item.data
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := a_v.item.block
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_complex_float_const_view_array (a_array: CE_POINTER [REAL_32]; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_COMPLEX_FLOAT_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_COMPLEX_FLOAT_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_COMPLEX_FLOAT
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 29, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 34, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_array
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_complex_float_const_view_array_with_tda (a_base: CE_POINTER [REAL_32]; a_n1: NATURAL_32; a_n2: NATURAL_32; a_tda: NATURAL_32): PD_GSL_MATRIX_COMPLEX_FLOAT_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_COMPLEX_FLOAT_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_COMPLEX_FLOAT
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 63, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 68, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 > a_tda then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 73, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_base
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_complex_float_const_view_vector (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_COMPLEX_FLOAT_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_COMPLEX_FLOAT_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_COMPLEX_FLOAT
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 102, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 107, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_v.item.stride /= {NATURAL_32} 1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector must have unit stride"), ce_string ("view_source.c"), 112, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 * a_n2 > a_v.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size exceeds size of original"), ce_string ("view_source.c"), 117, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_v.item.data
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := a_v.item.block
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_complex_float_const_view_vector_with_tda (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]; a_n1: NATURAL_32; a_n2: NATURAL_32; a_tda: NATURAL_32): PD_GSL_MATRIX_COMPLEX_FLOAT_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_COMPLEX_FLOAT_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_COMPLEX_FLOAT
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 147, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 152, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_v.item.stride /= {NATURAL_32} 1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector must have unit stride"), ce_string ("view_source.c"), 157, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 > a_tda then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 162, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 * a_tda > a_v.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size exceeds size of original"), ce_string ("view_source.c"), 167, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_v.item.data
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := a_v.item.block
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_long_double_const_view_array (a_array: CE_POINTER [REAL_96]; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_LONG_DOUBLE_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_LONG_DOUBLE_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_LONG_DOUBLE
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 29, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 34, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_array
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_long_double_const_view_array_with_tda (a_base: CE_POINTER [REAL_96]; a_n1: NATURAL_32; a_n2: NATURAL_32; a_tda: NATURAL_32): PD_GSL_MATRIX_LONG_DOUBLE_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_LONG_DOUBLE_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_LONG_DOUBLE
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 63, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 68, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 > a_tda then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 73, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_base
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_long_double_const_view_vector (a_v: CE_POINTER [PD_GSL_VECTOR_LONG_DOUBLE]; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_LONG_DOUBLE_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_LONG_DOUBLE_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_LONG_DOUBLE
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 102, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 107, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_v.item.stride /= {NATURAL_32} 1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector must have unit stride"), ce_string ("view_source.c"), 112, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 * a_n2 > a_v.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size exceeds size of original"), ce_string ("view_source.c"), 117, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_v.item.data
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := a_v.item.block
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_long_double_const_view_vector_with_tda (a_v: CE_POINTER [PD_GSL_VECTOR_LONG_DOUBLE]; a_n1: NATURAL_32; a_n2: NATURAL_32; a_tda: NATURAL_32): PD_GSL_MATRIX_LONG_DOUBLE_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_LONG_DOUBLE_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_LONG_DOUBLE
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 147, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 152, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_v.item.stride /= {NATURAL_32} 1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector must have unit stride"), ce_string ("view_source.c"), 157, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 > a_tda then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 162, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 * a_tda > a_v.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size exceeds size of original"), ce_string ("view_source.c"), 167, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_v.item.data
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := a_v.item.block
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_const_view_array (a_array: CE_POINTER [REAL_64]; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_CONST_VIEW
			l_m___4: PD_GSL_MATRIX
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 29, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 34, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_array
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_const_view_array_with_tda (a_base: CE_POINTER [REAL_64]; a_n1: NATURAL_32; a_n2: NATURAL_32; a_tda: NATURAL_32): PD_GSL_MATRIX_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_CONST_VIEW
			l_m___4: PD_GSL_MATRIX
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 63, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 68, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 > a_tda then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 73, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_base
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_const_view_vector (a_v: CE_POINTER [PD_GSL_VECTOR]; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_CONST_VIEW
			l_m___4: PD_GSL_MATRIX
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 102, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 107, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_v.item.stride /= {NATURAL_32} 1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector must have unit stride"), ce_string ("view_source.c"), 112, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 * a_n2 > a_v.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size exceeds size of original"), ce_string ("view_source.c"), 117, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_v.item.data
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := a_v.item.block
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_const_view_vector_with_tda (a_v: CE_POINTER [PD_GSL_VECTOR]; a_n1: NATURAL_32; a_n2: NATURAL_32; a_tda: NATURAL_32): PD_GSL_MATRIX_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_CONST_VIEW
			l_m___4: PD_GSL_MATRIX
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 147, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 152, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_v.item.stride /= {NATURAL_32} 1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector must have unit stride"), ce_string ("view_source.c"), 157, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 > a_tda then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 162, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 * a_tda > a_v.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size exceeds size of original"), ce_string ("view_source.c"), 167, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_v.item.data
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := a_v.item.block
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_float_const_view_array (a_array: CE_POINTER [REAL_32]; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_FLOAT_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_FLOAT_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_FLOAT
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 29, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 34, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_array
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_float_const_view_array_with_tda (a_base: CE_POINTER [REAL_32]; a_n1: NATURAL_32; a_n2: NATURAL_32; a_tda: NATURAL_32): PD_GSL_MATRIX_FLOAT_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_FLOAT_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_FLOAT
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 63, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 68, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 > a_tda then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 73, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_base
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_float_const_view_vector (a_v: CE_POINTER [PD_GSL_VECTOR_FLOAT]; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_FLOAT_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_FLOAT_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_FLOAT
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 102, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 107, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_v.item.stride /= {NATURAL_32} 1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector must have unit stride"), ce_string ("view_source.c"), 112, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 * a_n2 > a_v.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size exceeds size of original"), ce_string ("view_source.c"), 117, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_v.item.data
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := a_v.item.block
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_float_const_view_vector_with_tda (a_v: CE_POINTER [PD_GSL_VECTOR_FLOAT]; a_n1: NATURAL_32; a_n2: NATURAL_32; a_tda: NATURAL_32): PD_GSL_MATRIX_FLOAT_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_FLOAT_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_FLOAT
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 147, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 152, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_v.item.stride /= {NATURAL_32} 1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector must have unit stride"), ce_string ("view_source.c"), 157, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 > a_tda then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 162, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 * a_tda > a_v.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size exceeds size of original"), ce_string ("view_source.c"), 167, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_v.item.data
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := a_v.item.block
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_ulong_const_view_array (a_array: CE_POINTER [NATURAL_32]; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_ULONG_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_ULONG_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_ULONG
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 29, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 34, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_array
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_ulong_const_view_array_with_tda (a_base: CE_POINTER [NATURAL_32]; a_n1: NATURAL_32; a_n2: NATURAL_32; a_tda: NATURAL_32): PD_GSL_MATRIX_ULONG_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_ULONG_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_ULONG
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 63, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 68, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 > a_tda then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 73, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_base
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_ulong_const_view_vector (a_v: CE_POINTER [PD_GSL_VECTOR_ULONG]; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_ULONG_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_ULONG_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_ULONG
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 102, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 107, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_v.item.stride /= {NATURAL_32} 1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector must have unit stride"), ce_string ("view_source.c"), 112, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 * a_n2 > a_v.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size exceeds size of original"), ce_string ("view_source.c"), 117, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_v.item.data
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := a_v.item.block
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_ulong_const_view_vector_with_tda (a_v: CE_POINTER [PD_GSL_VECTOR_ULONG]; a_n1: NATURAL_32; a_n2: NATURAL_32; a_tda: NATURAL_32): PD_GSL_MATRIX_ULONG_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_ULONG_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_ULONG
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 147, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 152, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_v.item.stride /= {NATURAL_32} 1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector must have unit stride"), ce_string ("view_source.c"), 157, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 > a_tda then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 162, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 * a_tda > a_v.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size exceeds size of original"), ce_string ("view_source.c"), 167, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_v.item.data
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := a_v.item.block
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_long_const_view_array (a_array: CE_POINTER [INTEGER_32]; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_LONG_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_LONG_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_LONG
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 29, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 34, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_array
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_long_const_view_array_with_tda (a_base: CE_POINTER [INTEGER_32]; a_n1: NATURAL_32; a_n2: NATURAL_32; a_tda: NATURAL_32): PD_GSL_MATRIX_LONG_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_LONG_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_LONG
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 63, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 68, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 > a_tda then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 73, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_base
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_long_const_view_vector (a_v: CE_POINTER [PD_GSL_VECTOR_LONG]; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_LONG_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_LONG_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_LONG
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 102, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 107, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_v.item.stride /= {NATURAL_32} 1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector must have unit stride"), ce_string ("view_source.c"), 112, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 * a_n2 > a_v.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size exceeds size of original"), ce_string ("view_source.c"), 117, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_v.item.data
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := a_v.item.block
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_long_const_view_vector_with_tda (a_v: CE_POINTER [PD_GSL_VECTOR_LONG]; a_n1: NATURAL_32; a_n2: NATURAL_32; a_tda: NATURAL_32): PD_GSL_MATRIX_LONG_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_LONG_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_LONG
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 147, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 152, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_v.item.stride /= {NATURAL_32} 1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector must have unit stride"), ce_string ("view_source.c"), 157, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 > a_tda then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 162, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 * a_tda > a_v.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size exceeds size of original"), ce_string ("view_source.c"), 167, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_v.item.data
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := a_v.item.block
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_uint_const_view_array (a_array: CE_POINTER [NATURAL_32]; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_UINT_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_UINT_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_UINT
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_UINT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 29, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 34, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_UINT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_array
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_UINT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_uint_const_view_array_with_tda (a_base: CE_POINTER [NATURAL_32]; a_n1: NATURAL_32; a_n2: NATURAL_32; a_tda: NATURAL_32): PD_GSL_MATRIX_UINT_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_UINT_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_UINT
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_UINT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 63, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 68, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 > a_tda then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 73, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_UINT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_base
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_UINT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_uint_const_view_vector (a_v: CE_POINTER [PD_GSL_VECTOR_UINT]; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_UINT_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_UINT_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_UINT
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_UINT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 102, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 107, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_v.item.stride /= {NATURAL_32} 1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector must have unit stride"), ce_string ("view_source.c"), 112, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 * a_n2 > a_v.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size exceeds size of original"), ce_string ("view_source.c"), 117, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_UINT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_v.item.data
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := a_v.item.block
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_uint_const_view_vector_with_tda (a_v: CE_POINTER [PD_GSL_VECTOR_UINT]; a_n1: NATURAL_32; a_n2: NATURAL_32; a_tda: NATURAL_32): PD_GSL_MATRIX_UINT_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_UINT_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_UINT
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_UINT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 147, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 152, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_v.item.stride /= {NATURAL_32} 1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector must have unit stride"), ce_string ("view_source.c"), 157, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 > a_tda then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 162, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 * a_tda > a_v.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size exceeds size of original"), ce_string ("view_source.c"), 167, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_UINT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_v.item.data
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := a_v.item.block
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_int_const_view_array (a_array: CE_POINTER [INTEGER_32]; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_INT_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_INT_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_INT
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_INT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 29, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 34, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_INT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_array
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_INT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_int_const_view_array_with_tda (a_base: CE_POINTER [INTEGER_32]; a_n1: NATURAL_32; a_n2: NATURAL_32; a_tda: NATURAL_32): PD_GSL_MATRIX_INT_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_INT_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_INT
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_INT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 63, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 68, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 > a_tda then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 73, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_INT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_base
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_INT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_int_const_view_vector (a_v: CE_POINTER [PD_GSL_VECTOR_INT]; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_INT_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_INT_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_INT
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_INT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 102, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 107, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_v.item.stride /= {NATURAL_32} 1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector must have unit stride"), ce_string ("view_source.c"), 112, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 * a_n2 > a_v.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size exceeds size of original"), ce_string ("view_source.c"), 117, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_INT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_v.item.data
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := a_v.item.block
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_int_const_view_vector_with_tda (a_v: CE_POINTER [PD_GSL_VECTOR_INT]; a_n1: NATURAL_32; a_n2: NATURAL_32; a_tda: NATURAL_32): PD_GSL_MATRIX_INT_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_INT_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_INT
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_INT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 147, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 152, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_v.item.stride /= {NATURAL_32} 1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector must have unit stride"), ce_string ("view_source.c"), 157, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 > a_tda then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 162, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 * a_tda > a_v.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size exceeds size of original"), ce_string ("view_source.c"), 167, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_INT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_v.item.data
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := a_v.item.block
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_ushort_const_view_array (a_array: CE_POINTER [NATURAL_16]; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_USHORT_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_USHORT_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_USHORT
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [NATURAL_16]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 29, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 34, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [NATURAL_16]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_array
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_ushort_const_view_array_with_tda (a_base: CE_POINTER [NATURAL_16]; a_n1: NATURAL_32; a_n2: NATURAL_32; a_tda: NATURAL_32): PD_GSL_MATRIX_USHORT_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_USHORT_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_USHORT
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [NATURAL_16]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 63, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 68, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 > a_tda then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 73, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [NATURAL_16]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_base
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_ushort_const_view_vector (a_v: CE_POINTER [PD_GSL_VECTOR_USHORT]; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_USHORT_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_USHORT_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_USHORT
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [NATURAL_16]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 102, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 107, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_v.item.stride /= {NATURAL_32} 1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector must have unit stride"), ce_string ("view_source.c"), 112, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 * a_n2 > a_v.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size exceeds size of original"), ce_string ("view_source.c"), 117, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [NATURAL_16]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_v.item.data
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := a_v.item.block
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_ushort_const_view_vector_with_tda (a_v: CE_POINTER [PD_GSL_VECTOR_USHORT]; a_n1: NATURAL_32; a_n2: NATURAL_32; a_tda: NATURAL_32): PD_GSL_MATRIX_USHORT_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_USHORT_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_USHORT
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [NATURAL_16]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 147, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 152, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_v.item.stride /= {NATURAL_32} 1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector must have unit stride"), ce_string ("view_source.c"), 157, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 > a_tda then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 162, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 * a_tda > a_v.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size exceeds size of original"), ce_string ("view_source.c"), 167, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [NATURAL_16]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_v.item.data
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := a_v.item.block
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_short_const_view_array (a_array: CE_POINTER [INTEGER_16]; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_SHORT_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_SHORT_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_SHORT
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [INTEGER_16]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 29, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 34, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [INTEGER_16]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_array
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_short_const_view_array_with_tda (a_base: CE_POINTER [INTEGER_16]; a_n1: NATURAL_32; a_n2: NATURAL_32; a_tda: NATURAL_32): PD_GSL_MATRIX_SHORT_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_SHORT_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_SHORT
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [INTEGER_16]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 63, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 68, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 > a_tda then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 73, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [INTEGER_16]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_base
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_short_const_view_vector (a_v: CE_POINTER [PD_GSL_VECTOR_SHORT]; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_SHORT_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_SHORT_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_SHORT
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [INTEGER_16]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 102, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 107, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_v.item.stride /= {NATURAL_32} 1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector must have unit stride"), ce_string ("view_source.c"), 112, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 * a_n2 > a_v.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size exceeds size of original"), ce_string ("view_source.c"), 117, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [INTEGER_16]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_v.item.data
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := a_v.item.block
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_short_const_view_vector_with_tda (a_v: CE_POINTER [PD_GSL_VECTOR_SHORT]; a_n1: NATURAL_32; a_n2: NATURAL_32; a_tda: NATURAL_32): PD_GSL_MATRIX_SHORT_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_SHORT_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_SHORT
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [INTEGER_16]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 147, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 152, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_v.item.stride /= {NATURAL_32} 1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector must have unit stride"), ce_string ("view_source.c"), 157, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 > a_tda then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 162, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 * a_tda > a_v.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size exceeds size of original"), ce_string ("view_source.c"), 167, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [INTEGER_16]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_v.item.data
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := a_v.item.block
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_uchar_const_view_array (a_array: CE_POINTER [NATURAL_8]; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_UCHAR_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_UCHAR_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_UCHAR
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 29, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 34, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_array
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_uchar_const_view_array_with_tda (a_base: CE_POINTER [NATURAL_8]; a_n1: NATURAL_32; a_n2: NATURAL_32; a_tda: NATURAL_32): PD_GSL_MATRIX_UCHAR_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_UCHAR_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_UCHAR
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 63, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 68, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 > a_tda then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 73, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_base
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_uchar_const_view_vector (a_v: CE_POINTER [PD_GSL_VECTOR_UCHAR]; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_UCHAR_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_UCHAR_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_UCHAR
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 102, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 107, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_v.item.stride /= {NATURAL_32} 1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector must have unit stride"), ce_string ("view_source.c"), 112, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 * a_n2 > a_v.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size exceeds size of original"), ce_string ("view_source.c"), 117, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_v.item.data
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := a_v.item.block
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_uchar_const_view_vector_with_tda (a_v: CE_POINTER [PD_GSL_VECTOR_UCHAR]; a_n1: NATURAL_32; a_n2: NATURAL_32; a_tda: NATURAL_32): PD_GSL_MATRIX_UCHAR_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_UCHAR_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_UCHAR
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 147, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 152, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_v.item.stride /= {NATURAL_32} 1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector must have unit stride"), ce_string ("view_source.c"), 157, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 > a_tda then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 162, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 * a_tda > a_v.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size exceeds size of original"), ce_string ("view_source.c"), 167, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_v.item.data
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := a_v.item.block
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_char_const_view_array (a_array: CE_POINTER [INTEGER_8]; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_CHAR_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_CHAR_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_CHAR
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 29, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 34, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_array
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_char_const_view_array_with_tda (a_base: CE_POINTER [INTEGER_8]; a_n1: NATURAL_32; a_n2: NATURAL_32; a_tda: NATURAL_32): PD_GSL_MATRIX_CHAR_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_CHAR_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_CHAR
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 63, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 68, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 > a_tda then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 73, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_base
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_char_const_view_vector (a_v: CE_POINTER [PD_GSL_VECTOR_CHAR]; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_CHAR_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_CHAR_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_CHAR
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 102, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 107, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_v.item.stride /= {NATURAL_32} 1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector must have unit stride"), ce_string ("view_source.c"), 112, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 * a_n2 > a_v.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size exceeds size of original"), ce_string ("view_source.c"), 117, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_v.item.data
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := a_v.item.block
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_matrix_char_const_view_vector_with_tda (a_v: CE_POINTER [PD_GSL_VECTOR_CHAR]; a_n1: NATURAL_32; a_n2: NATURAL_32; a_tda: NATURAL_32): PD_GSL_MATRIX_CHAR_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_CHAR_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_CHAR
			js: JUMP_STATE
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 147, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 152, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_v.item.stride /= {NATURAL_32} 1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector must have unit stride"), ce_string ("view_source.c"), 157, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 > a_tda then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 162, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 * a_tda > a_v.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size exceeds size of original"), ce_string ("view_source.c"), 167, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
				l_m___4.block := create {CE_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_v.item.data
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := a_v.item.block
				l_m___4.owner := 0
				l_view.matrix := l_m___4
				Result := l_view
			end
		end

	gsl_vector_complex_long_double_view_array (a_base: CE_POINTER [REAL_96]; a_n: NATURAL_32): PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE_VIEW
		local
			l_view: PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE_VIEW
			l_v: PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE
			js: JUMP_STATE
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 28, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := (1).to_natural_32
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v
				Result := l_view
			end
		end

	gsl_vector_complex_long_double_view_array_with_stride (a_base: CE_POINTER [REAL_96]; a_stride: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE_VIEW
		local
			l_view: PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE_VIEW
			l_v: PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE
			js: JUMP_STATE
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 55, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_stride = {NATURAL_32} 0) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("stride must be positive integer"), ce_string ("view_source.c"), 61, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := a_stride
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v
				Result := l_view
			end
		end

	gsl_vector_complex_view_array (a_base: CE_POINTER [REAL_64]; a_n: NATURAL_32): PD_GSL_VECTOR_COMPLEX_VIEW
		local
			l_view: PD_GSL_VECTOR_COMPLEX_VIEW
			l_v: PD_GSL_VECTOR_COMPLEX
			js: JUMP_STATE
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 28, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := (1).to_natural_32
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v
				Result := l_view
			end
		end

	gsl_vector_complex_view_array_with_stride (a_base: CE_POINTER [REAL_64]; a_stride: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_COMPLEX_VIEW
		local
			l_view: PD_GSL_VECTOR_COMPLEX_VIEW
			l_v: PD_GSL_VECTOR_COMPLEX
			js: JUMP_STATE
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 55, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_stride = {NATURAL_32} 0) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("stride must be positive integer"), ce_string ("view_source.c"), 61, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := a_stride
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v
				Result := l_view
			end
		end

	gsl_vector_complex_float_view_array (a_base: CE_POINTER [REAL_32]; a_n: NATURAL_32): PD_GSL_VECTOR_COMPLEX_FLOAT_VIEW
		local
			l_view: PD_GSL_VECTOR_COMPLEX_FLOAT_VIEW
			l_v: PD_GSL_VECTOR_COMPLEX_FLOAT
			js: JUMP_STATE
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 28, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := (1).to_natural_32
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v
				Result := l_view
			end
		end

	gsl_vector_complex_float_view_array_with_stride (a_base: CE_POINTER [REAL_32]; a_stride: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_COMPLEX_FLOAT_VIEW
		local
			l_view: PD_GSL_VECTOR_COMPLEX_FLOAT_VIEW
			l_v: PD_GSL_VECTOR_COMPLEX_FLOAT
			js: JUMP_STATE
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 55, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_stride = {NATURAL_32} 0) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("stride must be positive integer"), ce_string ("view_source.c"), 61, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := a_stride
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v
				Result := l_view
			end
		end

	gsl_vector_long_double_view_array (a_base: CE_POINTER [REAL_96]; a_n: NATURAL_32): PD_GSL_VECTOR_LONG_DOUBLE_VIEW
		local
			l_view: PD_GSL_VECTOR_LONG_DOUBLE_VIEW
			l_v: PD_GSL_VECTOR_LONG_DOUBLE
			js: JUMP_STATE
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 28, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := (1).to_natural_32
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v
				Result := l_view
			end
		end

	gsl_vector_long_double_view_array_with_stride (a_base: CE_POINTER [REAL_96]; a_stride: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_LONG_DOUBLE_VIEW
		local
			l_view: PD_GSL_VECTOR_LONG_DOUBLE_VIEW
			l_v: PD_GSL_VECTOR_LONG_DOUBLE
			js: JUMP_STATE
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 55, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_stride = {NATURAL_32} 0) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("stride must be positive integer"), ce_string ("view_source.c"), 61, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := a_stride
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v
				Result := l_view
			end
		end

	gsl_vector_view_array (a_base: CE_POINTER [REAL_64]; a_n: NATURAL_32): PD_GSL_VECTOR_VIEW
		local
			l_view: PD_GSL_VECTOR_VIEW
			l_v: PD_GSL_VECTOR
			js: JUMP_STATE
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 28, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := (1).to_natural_32
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v
				Result := l_view
			end
		end

	gsl_vector_view_array_with_stride (a_base: CE_POINTER [REAL_64]; a_stride: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_VIEW
		local
			l_view: PD_GSL_VECTOR_VIEW
			l_v: PD_GSL_VECTOR
			js: JUMP_STATE
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 55, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_stride = {NATURAL_32} 0) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("stride must be positive integer"), ce_string ("view_source.c"), 61, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := a_stride
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v
				Result := l_view
			end
		end

	gsl_vector_float_view_array (a_base: CE_POINTER [REAL_32]; a_n: NATURAL_32): PD_GSL_VECTOR_FLOAT_VIEW
		local
			l_view: PD_GSL_VECTOR_FLOAT_VIEW
			l_v: PD_GSL_VECTOR_FLOAT
			js: JUMP_STATE
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 28, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := (1).to_natural_32
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v
				Result := l_view
			end
		end

	gsl_vector_float_view_array_with_stride (a_base: CE_POINTER [REAL_32]; a_stride: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_FLOAT_VIEW
		local
			l_view: PD_GSL_VECTOR_FLOAT_VIEW
			l_v: PD_GSL_VECTOR_FLOAT
			js: JUMP_STATE
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 55, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_stride = {NATURAL_32} 0) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("stride must be positive integer"), ce_string ("view_source.c"), 61, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := a_stride
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v
				Result := l_view
			end
		end

	gsl_vector_ulong_view_array (a_base: CE_POINTER [NATURAL_32]; a_n: NATURAL_32): PD_GSL_VECTOR_ULONG_VIEW
		local
			l_view: PD_GSL_VECTOR_ULONG_VIEW
			l_v: PD_GSL_VECTOR_ULONG
			js: JUMP_STATE
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 28, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := (1).to_natural_32
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v
				Result := l_view
			end
		end

	gsl_vector_ulong_view_array_with_stride (a_base: CE_POINTER [NATURAL_32]; a_stride: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_ULONG_VIEW
		local
			l_view: PD_GSL_VECTOR_ULONG_VIEW
			l_v: PD_GSL_VECTOR_ULONG
			js: JUMP_STATE
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 55, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_stride = {NATURAL_32} 0) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("stride must be positive integer"), ce_string ("view_source.c"), 61, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := a_stride
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v
				Result := l_view
			end
		end

	gsl_vector_long_view_array (a_base: CE_POINTER [INTEGER_32]; a_n: NATURAL_32): PD_GSL_VECTOR_LONG_VIEW
		local
			l_view: PD_GSL_VECTOR_LONG_VIEW
			l_v: PD_GSL_VECTOR_LONG
			js: JUMP_STATE
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 28, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := (1).to_natural_32
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v
				Result := l_view
			end
		end

	gsl_vector_long_view_array_with_stride (a_base: CE_POINTER [INTEGER_32]; a_stride: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_LONG_VIEW
		local
			l_view: PD_GSL_VECTOR_LONG_VIEW
			l_v: PD_GSL_VECTOR_LONG
			js: JUMP_STATE
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 55, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_stride = {NATURAL_32} 0) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("stride must be positive integer"), ce_string ("view_source.c"), 61, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := a_stride
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v
				Result := l_view
			end
		end

	gsl_vector_uint_view_array (a_base: CE_POINTER [NATURAL_32]; a_n: NATURAL_32): PD_GSL_VECTOR_UINT_VIEW
		local
			l_view: PD_GSL_VECTOR_UINT_VIEW
			l_v: PD_GSL_VECTOR_UINT
			js: JUMP_STATE
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_UINT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 28, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_UINT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := (1).to_natural_32
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_UINT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v
				Result := l_view
			end
		end

	gsl_vector_uint_view_array_with_stride (a_base: CE_POINTER [NATURAL_32]; a_stride: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_UINT_VIEW
		local
			l_view: PD_GSL_VECTOR_UINT_VIEW
			l_v: PD_GSL_VECTOR_UINT
			js: JUMP_STATE
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_UINT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 55, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_stride = {NATURAL_32} 0) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("stride must be positive integer"), ce_string ("view_source.c"), 61, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_UINT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := a_stride
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_UINT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v
				Result := l_view
			end
		end

	gsl_vector_int_view_array (a_base: CE_POINTER [INTEGER_32]; a_n: NATURAL_32): PD_GSL_VECTOR_INT_VIEW
		local
			l_view: PD_GSL_VECTOR_INT_VIEW
			l_v: PD_GSL_VECTOR_INT
			js: JUMP_STATE
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_INT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 28, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_INT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := (1).to_natural_32
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_INT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v
				Result := l_view
			end
		end

	gsl_vector_int_view_array_with_stride (a_base: CE_POINTER [INTEGER_32]; a_stride: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_INT_VIEW
		local
			l_view: PD_GSL_VECTOR_INT_VIEW
			l_v: PD_GSL_VECTOR_INT
			js: JUMP_STATE
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_INT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 55, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_stride = {NATURAL_32} 0) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("stride must be positive integer"), ce_string ("view_source.c"), 61, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_INT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := a_stride
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_INT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v
				Result := l_view
			end
		end

	gsl_vector_ushort_view_array (a_base: CE_POINTER [NATURAL_16]; a_n: NATURAL_32): PD_GSL_VECTOR_USHORT_VIEW
		local
			l_view: PD_GSL_VECTOR_USHORT_VIEW
			l_v: PD_GSL_VECTOR_USHORT
			js: JUMP_STATE
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [NATURAL_16]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 28, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_POINTER [NATURAL_16]}.make_shared (default_pointer)
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := (1).to_natural_32
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v
				Result := l_view
			end
		end

	gsl_vector_ushort_view_array_with_stride (a_base: CE_POINTER [NATURAL_16]; a_stride: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_USHORT_VIEW
		local
			l_view: PD_GSL_VECTOR_USHORT_VIEW
			l_v: PD_GSL_VECTOR_USHORT
			js: JUMP_STATE
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [NATURAL_16]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 55, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_stride = {NATURAL_32} 0) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("stride must be positive integer"), ce_string ("view_source.c"), 61, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_POINTER [NATURAL_16]}.make_shared (default_pointer)
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := a_stride
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v
				Result := l_view
			end
		end

	gsl_vector_short_view_array (a_base: CE_POINTER [INTEGER_16]; a_n: NATURAL_32): PD_GSL_VECTOR_SHORT_VIEW
		local
			l_view: PD_GSL_VECTOR_SHORT_VIEW
			l_v: PD_GSL_VECTOR_SHORT
			js: JUMP_STATE
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [INTEGER_16]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 28, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_POINTER [INTEGER_16]}.make_shared (default_pointer)
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := (1).to_natural_32
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v
				Result := l_view
			end
		end

	gsl_vector_short_view_array_with_stride (a_base: CE_POINTER [INTEGER_16]; a_stride: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_SHORT_VIEW
		local
			l_view: PD_GSL_VECTOR_SHORT_VIEW
			l_v: PD_GSL_VECTOR_SHORT
			js: JUMP_STATE
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [INTEGER_16]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 55, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_stride = {NATURAL_32} 0) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("stride must be positive integer"), ce_string ("view_source.c"), 61, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_POINTER [INTEGER_16]}.make_shared (default_pointer)
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := a_stride
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v
				Result := l_view
			end
		end

	gsl_vector_uchar_view_array (a_base: CE_POINTER [NATURAL_8]; a_n: NATURAL_32): PD_GSL_VECTOR_UCHAR_VIEW
		local
			l_view: PD_GSL_VECTOR_UCHAR_VIEW
			l_v: PD_GSL_VECTOR_UCHAR
			js: JUMP_STATE
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 28, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := (1).to_natural_32
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v
				Result := l_view
			end
		end

	gsl_vector_uchar_view_array_with_stride (a_base: CE_POINTER [NATURAL_8]; a_stride: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_UCHAR_VIEW
		local
			l_view: PD_GSL_VECTOR_UCHAR_VIEW
			l_v: PD_GSL_VECTOR_UCHAR
			js: JUMP_STATE
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 55, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_stride = {NATURAL_32} 0) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("stride must be positive integer"), ce_string ("view_source.c"), 61, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := a_stride
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v
				Result := l_view
			end
		end

	gsl_vector_char_view_array (a_base: CE_POINTER [INTEGER_8]; a_n: NATURAL_32): PD_GSL_VECTOR_CHAR_VIEW
		local
			l_view: PD_GSL_VECTOR_CHAR_VIEW
			l_v: PD_GSL_VECTOR_CHAR
			js: JUMP_STATE
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 28, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := (1).to_natural_32
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v
				Result := l_view
			end
		end

	gsl_vector_char_view_array_with_stride (a_base: CE_POINTER [INTEGER_8]; a_stride: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_CHAR_VIEW
		local
			l_view: PD_GSL_VECTOR_CHAR_VIEW
			l_v: PD_GSL_VECTOR_CHAR
			js: JUMP_STATE
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 55, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_stride = {NATURAL_32} 0) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("stride must be positive integer"), ce_string ("view_source.c"), 61, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := a_stride
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v
				Result := l_view
			end
		end

	gsl_vector_complex_long_double_const_view_array (a_base: CE_POINTER [REAL_96]; a_n: NATURAL_32): PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE_CONST_VIEW
			l_v: PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE
			js: JUMP_STATE
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 28, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := (1).to_natural_32
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v
				Result := l_view
			end
		end

	gsl_vector_complex_long_double_const_view_array_with_stride (a_base: CE_POINTER [REAL_96]; a_stride: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE_CONST_VIEW
			l_v: PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE
			js: JUMP_STATE
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 55, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_stride = {NATURAL_32} 0) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("stride must be positive integer"), ce_string ("view_source.c"), 61, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := a_stride
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v
				Result := l_view
			end
		end

	gsl_vector_complex_const_view_array (a_base: CE_POINTER [REAL_64]; a_n: NATURAL_32): PD_GSL_VECTOR_COMPLEX_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_COMPLEX_CONST_VIEW
			l_v: PD_GSL_VECTOR_COMPLEX
			js: JUMP_STATE
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 28, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := (1).to_natural_32
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v
				Result := l_view
			end
		end

	gsl_vector_complex_const_view_array_with_stride (a_base: CE_POINTER [REAL_64]; a_stride: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_COMPLEX_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_COMPLEX_CONST_VIEW
			l_v: PD_GSL_VECTOR_COMPLEX
			js: JUMP_STATE
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 55, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_stride = {NATURAL_32} 0) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("stride must be positive integer"), ce_string ("view_source.c"), 61, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := a_stride
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v
				Result := l_view
			end
		end

	gsl_vector_complex_float_const_view_array (a_base: CE_POINTER [REAL_32]; a_n: NATURAL_32): PD_GSL_VECTOR_COMPLEX_FLOAT_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_COMPLEX_FLOAT_CONST_VIEW
			l_v: PD_GSL_VECTOR_COMPLEX_FLOAT
			js: JUMP_STATE
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 28, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := (1).to_natural_32
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v
				Result := l_view
			end
		end

	gsl_vector_complex_float_const_view_array_with_stride (a_base: CE_POINTER [REAL_32]; a_stride: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_COMPLEX_FLOAT_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_COMPLEX_FLOAT_CONST_VIEW
			l_v: PD_GSL_VECTOR_COMPLEX_FLOAT
			js: JUMP_STATE
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 55, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_stride = {NATURAL_32} 0) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("stride must be positive integer"), ce_string ("view_source.c"), 61, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := a_stride
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v
				Result := l_view
			end
		end

	gsl_vector_long_double_const_view_array (a_base: CE_POINTER [REAL_96]; a_n: NATURAL_32): PD_GSL_VECTOR_LONG_DOUBLE_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_LONG_DOUBLE_CONST_VIEW
			l_v: PD_GSL_VECTOR_LONG_DOUBLE
			js: JUMP_STATE
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 28, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := (1).to_natural_32
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v
				Result := l_view
			end
		end

	gsl_vector_long_double_const_view_array_with_stride (a_base: CE_POINTER [REAL_96]; a_stride: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_LONG_DOUBLE_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_LONG_DOUBLE_CONST_VIEW
			l_v: PD_GSL_VECTOR_LONG_DOUBLE
			js: JUMP_STATE
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 55, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_stride = {NATURAL_32} 0) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("stride must be positive integer"), ce_string ("view_source.c"), 61, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := a_stride
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v
				Result := l_view
			end
		end

	gsl_vector_const_view_array (a_base: CE_POINTER [REAL_64]; a_n: NATURAL_32): PD_GSL_VECTOR_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_CONST_VIEW
			l_v: PD_GSL_VECTOR
			js: JUMP_STATE
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 28, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := (1).to_natural_32
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v
				Result := l_view
			end
		end

	gsl_vector_const_view_array_with_stride (a_base: CE_POINTER [REAL_64]; a_stride: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_CONST_VIEW
			l_v: PD_GSL_VECTOR
			js: JUMP_STATE
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 55, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_stride = {NATURAL_32} 0) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("stride must be positive integer"), ce_string ("view_source.c"), 61, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := a_stride
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v
				Result := l_view
			end
		end

	gsl_vector_float_const_view_array (a_base: CE_POINTER [REAL_32]; a_n: NATURAL_32): PD_GSL_VECTOR_FLOAT_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_FLOAT_CONST_VIEW
			l_v: PD_GSL_VECTOR_FLOAT
			js: JUMP_STATE
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 28, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := (1).to_natural_32
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v
				Result := l_view
			end
		end

	gsl_vector_float_const_view_array_with_stride (a_base: CE_POINTER [REAL_32]; a_stride: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_FLOAT_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_FLOAT_CONST_VIEW
			l_v: PD_GSL_VECTOR_FLOAT
			js: JUMP_STATE
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 55, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_stride = {NATURAL_32} 0) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("stride must be positive integer"), ce_string ("view_source.c"), 61, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := a_stride
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v
				Result := l_view
			end
		end

	gsl_vector_ulong_const_view_array (a_base: CE_POINTER [NATURAL_32]; a_n: NATURAL_32): PD_GSL_VECTOR_ULONG_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_ULONG_CONST_VIEW
			l_v: PD_GSL_VECTOR_ULONG
			js: JUMP_STATE
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 28, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := (1).to_natural_32
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v
				Result := l_view
			end
		end

	gsl_vector_ulong_const_view_array_with_stride (a_base: CE_POINTER [NATURAL_32]; a_stride: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_ULONG_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_ULONG_CONST_VIEW
			l_v: PD_GSL_VECTOR_ULONG
			js: JUMP_STATE
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 55, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_stride = {NATURAL_32} 0) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("stride must be positive integer"), ce_string ("view_source.c"), 61, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := a_stride
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v
				Result := l_view
			end
		end

	gsl_vector_long_const_view_array (a_base: CE_POINTER [INTEGER_32]; a_n: NATURAL_32): PD_GSL_VECTOR_LONG_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_LONG_CONST_VIEW
			l_v: PD_GSL_VECTOR_LONG
			js: JUMP_STATE
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 28, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := (1).to_natural_32
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v
				Result := l_view
			end
		end

	gsl_vector_long_const_view_array_with_stride (a_base: CE_POINTER [INTEGER_32]; a_stride: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_LONG_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_LONG_CONST_VIEW
			l_v: PD_GSL_VECTOR_LONG
			js: JUMP_STATE
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 55, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_stride = {NATURAL_32} 0) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("stride must be positive integer"), ce_string ("view_source.c"), 61, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := a_stride
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v
				Result := l_view
			end
		end

	gsl_vector_uint_const_view_array (a_base: CE_POINTER [NATURAL_32]; a_n: NATURAL_32): PD_GSL_VECTOR_UINT_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_UINT_CONST_VIEW
			l_v: PD_GSL_VECTOR_UINT
			js: JUMP_STATE
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_UINT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 28, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_UINT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := (1).to_natural_32
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_UINT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v
				Result := l_view
			end
		end

	gsl_vector_uint_const_view_array_with_stride (a_base: CE_POINTER [NATURAL_32]; a_stride: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_UINT_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_UINT_CONST_VIEW
			l_v: PD_GSL_VECTOR_UINT
			js: JUMP_STATE
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_UINT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 55, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_stride = {NATURAL_32} 0) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("stride must be positive integer"), ce_string ("view_source.c"), 61, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_UINT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := a_stride
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_UINT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v
				Result := l_view
			end
		end

	gsl_vector_int_const_view_array (a_base: CE_POINTER [INTEGER_32]; a_n: NATURAL_32): PD_GSL_VECTOR_INT_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_INT_CONST_VIEW
			l_v: PD_GSL_VECTOR_INT
			js: JUMP_STATE
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_INT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 28, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_INT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := (1).to_natural_32
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_INT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v
				Result := l_view
			end
		end

	gsl_vector_int_const_view_array_with_stride (a_base: CE_POINTER [INTEGER_32]; a_stride: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_INT_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_INT_CONST_VIEW
			l_v: PD_GSL_VECTOR_INT
			js: JUMP_STATE
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_INT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 55, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_stride = {NATURAL_32} 0) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("stride must be positive integer"), ce_string ("view_source.c"), 61, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_INT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := a_stride
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_INT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v
				Result := l_view
			end
		end

	gsl_vector_ushort_const_view_array (a_base: CE_POINTER [NATURAL_16]; a_n: NATURAL_32): PD_GSL_VECTOR_USHORT_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_USHORT_CONST_VIEW
			l_v: PD_GSL_VECTOR_USHORT
			js: JUMP_STATE
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [NATURAL_16]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 28, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_POINTER [NATURAL_16]}.make_shared (default_pointer)
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := (1).to_natural_32
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v
				Result := l_view
			end
		end

	gsl_vector_ushort_const_view_array_with_stride (a_base: CE_POINTER [NATURAL_16]; a_stride: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_USHORT_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_USHORT_CONST_VIEW
			l_v: PD_GSL_VECTOR_USHORT
			js: JUMP_STATE
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [NATURAL_16]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 55, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_stride = {NATURAL_32} 0) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("stride must be positive integer"), ce_string ("view_source.c"), 61, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_POINTER [NATURAL_16]}.make_shared (default_pointer)
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := a_stride
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v
				Result := l_view
			end
		end

	gsl_vector_short_const_view_array (a_base: CE_POINTER [INTEGER_16]; a_n: NATURAL_32): PD_GSL_VECTOR_SHORT_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_SHORT_CONST_VIEW
			l_v: PD_GSL_VECTOR_SHORT
			js: JUMP_STATE
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [INTEGER_16]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 28, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_POINTER [INTEGER_16]}.make_shared (default_pointer)
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := (1).to_natural_32
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v
				Result := l_view
			end
		end

	gsl_vector_short_const_view_array_with_stride (a_base: CE_POINTER [INTEGER_16]; a_stride: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_SHORT_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_SHORT_CONST_VIEW
			l_v: PD_GSL_VECTOR_SHORT
			js: JUMP_STATE
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [INTEGER_16]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 55, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_stride = {NATURAL_32} 0) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("stride must be positive integer"), ce_string ("view_source.c"), 61, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_POINTER [INTEGER_16]}.make_shared (default_pointer)
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := a_stride
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v
				Result := l_view
			end
		end

	gsl_vector_uchar_const_view_array (a_base: CE_POINTER [NATURAL_8]; a_n: NATURAL_32): PD_GSL_VECTOR_UCHAR_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_UCHAR_CONST_VIEW
			l_v: PD_GSL_VECTOR_UCHAR
			js: JUMP_STATE
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 28, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := (1).to_natural_32
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v
				Result := l_view
			end
		end

	gsl_vector_uchar_const_view_array_with_stride (a_base: CE_POINTER [NATURAL_8]; a_stride: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_UCHAR_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_UCHAR_CONST_VIEW
			l_v: PD_GSL_VECTOR_UCHAR
			js: JUMP_STATE
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 55, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_stride = {NATURAL_32} 0) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("stride must be positive integer"), ce_string ("view_source.c"), 61, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := a_stride
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v
				Result := l_view
			end
		end

	gsl_vector_char_const_view_array (a_base: CE_POINTER [INTEGER_8]; a_n: NATURAL_32): PD_GSL_VECTOR_CHAR_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_CHAR_CONST_VIEW
			l_v: PD_GSL_VECTOR_CHAR
			js: JUMP_STATE
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 28, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := (1).to_natural_32
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v
				Result := l_view
			end
		end

	gsl_vector_char_const_view_array_with_stride (a_base: CE_POINTER [INTEGER_8]; a_stride: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_CHAR_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_CHAR_CONST_VIEW
			l_v: PD_GSL_VECTOR_CHAR
			js: JUMP_STATE
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 55, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_stride = {NATURAL_32} 0) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("stride must be positive integer"), ce_string ("view_source.c"), 61, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := a_stride
				l_v.block := create {CE_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v
				Result := l_view
			end
		end

end
